//Audio.js - Glauntlet - RIT 2012-2 Preston Johnson
//Handles all da sounds

 //constructor for audio manager
Audio = {};

Audio.init = function()
{
	// Detect if the audio context is supported.
	window.AudioContext = (
	  window.AudioContext ||
	  window.webkitAudioContext ||
	  null
	);

	//if we dont have any audio support, warn and stop setup
	if (!AudioContext) {
	  alert("This broswer does not support HTML5 this. You will not be able to hear any music or sound effects.");
	  return;
	} 
	
	this.ready = false;
	
	//Setup level vars, all will be 2D arrays. 
	//Sounds will be loaded on a per level basis so the arrays reflect that
	// Format is Array[level-1][LevelSoundEnums["SOUND_NAME"]]
	this.LevelSoundEnums = new Array(); //ENUM
	this.levelSoundClips = new Array();
	this.levelSndFilePaths = new Array();
	this.levelSndBuffers = new Array();//Holds the actual sound data
	this.levelSndReady = new Array();
	
	//setup level 1
	this.LevelSoundEnums[0] = {POS_TONE:0,WELCOME:1,HIT1:2,HIT2:3,HIT3:4,ATTACK_WARRIOR:5,ATTACK_ELF:6,ATTACK_WIZARD:7,ATTACK_VALKRIE:8,ALERT:9,COIN:10,DIE:11,HEALTH_LOW:12,MUSIC:13,BRAVE:14,DONT_SHOOT:15,ELF:16,LOW_LIFE:17,NEED_FOOD:18,OW:19,SAVE_KEYS:20,SHOOT_FOOD:21,VALKYRIE:22,WARRIOR:23,WIZARD:24}; //ENUM
	
	this.levelSoundClips[0] = new Array();
	this.levelSoundClips[0][0] = null;
	this.levelSoundClips[0][1] = null;
	this.levelSoundClips[0][2] = null;
	this.levelSoundClips[0][3] = null;
	this.levelSoundClips[0][4] = null;
	this.levelSoundClips[0][5] = null;
	this.levelSoundClips[0][6] = null;
	this.levelSoundClips[0][7] = null;
	this.levelSoundClips[0][8] = null;
	this.levelSoundClips[0][9] = null;
	this.levelSoundClips[0][10] = null;
	this.levelSoundClips[0][11] = null;
	this.levelSoundClips[0][12] = null;
	this.levelSoundClips[0][13] = null;
	this.levelSoundClips[0][14] = null;
	this.levelSoundClips[0][15] = null;
	this.levelSoundClips[0][16] = null;
	this.levelSoundClips[0][17] = null;
	this.levelSoundClips[0][18] = null;
	this.levelSoundClips[0][19] = null;
	this.levelSoundClips[0][20] = null;
	this.levelSoundClips[0][21] = null;
	this.levelSoundClips[0][22] = null;
	this.levelSoundClips[0][23] = null;
	this.levelSoundClips[0][24] = null;
	
	this.levelSndFilePaths[0] = new Array();
	this.levelSndFilePaths[0][0] = "../shared_assets/sound/FX/postone.wav";
	this.levelSndFilePaths[0][1] = "../shared_assets/sound/VOICE/welcome.wav";
	this.levelSndFilePaths[0][2] = "../shared_assets/sound/FX/hit/hit1.wav";
	this.levelSndFilePaths[0][3] = "../shared_assets/sound/FX/hit/hit2.wav";
	this.levelSndFilePaths[0][4] = "../shared_assets/sound/FX/hit/hit3.wav";
	this.levelSndFilePaths[0][5] = "../shared_assets/sound/FX/attack/warriorattack.wav";
	this.levelSndFilePaths[0][6] = "../shared_assets/sound/FX/attack/elfattack.wav";
	this.levelSndFilePaths[0][7] = "../shared_assets/sound/FX/attack/valkyrieattack.wav";
	this.levelSndFilePaths[0][8] = "../shared_assets/sound/FX/attack/wizardattack.wav";
	this.levelSndFilePaths[0][9] = "../shared_assets/sound/FX/alert.wav";
	this.levelSndFilePaths[0][10] = "../shared_assets/sound/FX/coin.wav";
	this.levelSndFilePaths[0][11] = "../shared_assets/sound/FX/die.wav";
	this.levelSndFilePaths[0][12] = "../shared_assets/sound/FX/health_low.wav";
	this.levelSndFilePaths[0][13] = "../shared_assets/sound/FX/intro.wav";
	this.levelSndFilePaths[0][14] = "../shared_assets/sound/VOICE/brave.wav";
	this.levelSndFilePaths[0][15] = "../shared_assets/sound/VOICE/dontshoot.wav";
	this.levelSndFilePaths[0][16] = "../shared_assets/sound/VOICE/elf.wav";
	this.levelSndFilePaths[0][17] = "../shared_assets/sound/VOICE/lowlife.wav";
	this.levelSndFilePaths[0][18] = "../shared_assets/sound/VOICE/needfood.wav";
	this.levelSndFilePaths[0][19] = "../shared_assets/sound/VOICE/ow.wav";
	this.levelSndFilePaths[0][20] = "../shared_assets/sound/VOICE/savekeys.wav";
	this.levelSndFilePaths[0][21] = "../shared_assets/sound/VOICE/shootfood.wav";
	this.levelSndFilePaths[0][22] = "../shared_assets/sound/VOICE/valkyrie.wav";
	this.levelSndFilePaths[0][23] = "../shared_assets/sound/VOICE/warrior.wav";
	this.levelSndFilePaths[0][24] = "../shared_assets/sound/VOICE/wizard.wav";
	
	this.levelSndBuffers[0] = new Array();
	this.levelSndReady[0] = new Array();
	
	this.levelSndReady[0][0] = false;
	this.levelSndReady[0][1] = false;
	this.levelSndReady[0][2] = false;
	this.levelSndReady[0][3] = false;
	this.levelSndReady[0][4] = false;
	this.levelSndReady[0][5] = false;
	this.levelSndReady[0][6] = false;
	this.levelSndReady[0][7] = false;
	this.levelSndReady[0][8] = false;
	this.levelSndReady[0][9] = false;
	this.levelSndReady[0][10] = false;
	this.levelSndReady[0][11] = false;
	this.levelSndReady[0][12] = false;
	this.levelSndReady[0][13] = false;
	this.levelSndReady[0][14] = false;
	this.levelSndReady[0][15] = false;
	this.levelSndReady[0][16] = false;
	this.levelSndReady[0][17] = false;
	this.levelSndReady[0][18] = false;
	this.levelSndReady[0][19] = false;
	this.levelSndReady[0][20] = false;
	this.levelSndReady[0][21] = false;
	this.levelSndReady[0][22] = false;
	this.levelSndReady[0][23] = false;
	this.levelSndReady[0][24] = false;
	
	//Don't allow write modifications on Enums
	Object.freeze(this.LevelSoundEnums);
	
	//Setup needed audio context and effects
	this.context = new AudioContext();
	this.lowpassFilter = this.context.createBiquadFilter();
	this.masterVol = this.context.createGainNode();
	this.compressor = this.context.createDynamicsCompressor();
	this.reverb = this.context.createConvolver();
	
	this.compressor.connect(this.context.destination);
	this.compressor.threshold = 0;
	this.masterVol.connect(this.compressor);
	this.reverb.connect(this.masterVol);
	this.currentLevel = 0;
	this.muted = false;
	
	//Toggle Mute
	this.ToggleMute = function()
	{
		if(this.muted)
		{
			this.masterVol.gain.value = 1;
			this.muted = false;
		}
		else
		{
			this.masterVol.gain.value = 0;
			this.muted = true;
		}
	}
	
	//Loads all the sounds for a level, just input what level to load
	this.LoadLevelSound = function(level){
		switch(level)
		{
			case 1:
				this.currentLevel = 1;
				for(i=0;i<this.levelSndFilePaths[level-1].length;i++)
				{
					this.LoadSound(this.levelSndFilePaths[level-1][i],i,this);
				}
				break;
			default:
			return;	
		}
	};

	//Loads an individual sound
	//INPUT sound path on the server,index that things are stored
	this.LoadSound = function(assetPath,index,audioManager)
	{
		var request = new XMLHttpRequest();
		request.open("GET",assetPath, true);
		request.responseType = "arraybuffer";
		request.onload = function(e){
			 
			if(this.status == 200 || this.status == 304 || this.status == 0)//HTML success and not modified (cached) codes, 0 is for local
			{
				var buffer = audioManager.context.createBuffer(this.response, false);
				audioManager.levelSndBuffers[audioManager.currentLevel-1][index] = buffer;
				audioManager.levelSndReady[audioManager.currentLevel-1][index] = true;
				
				//should prob add a way to play sounds on load but for now just do it for certain clips
				if(audioManager.currentLevel == 1 && index == audioManager.LevelSoundEnums[0].MUSIC)
				{
					audioManager.PlaySound(audioManager.LevelSoundEnums[audioManager.currentLevel-1].MUSIC,null);
				}
				//audioManager.PlaySound(audioManager.LevelSoundEnums[audioManager.currentLevel-1].POS_TONE,null);//DEBUG PLAY EACH SOUND ON LOAD
			}
		};
		request.send();
	};

	//Unloads sound for the inputed level
	this.UnloadLevelSound = function(level)
	{
		for(i=0;i<levelSndBuffers[level-1].length;i++)
		{
			this.levelSndBuffers[level-1][i] = null;
			this.levelSoundClips[level-1][i] = null;
			this.levelSndReady[level-1][i] = false;
		}
	};

	//UNLOAD ALL THE THINGS!
	this.UnloadAll = function(){

		this.levelSndBuffers = null;
		
		this.context = 0;
		this.compressor = 0;
		this.reverb = 0;
		this.source = 0;

		this.lowpassFilter = 0;
		this.masterVol = 0;
		this.reverb = 0;

		this.ready = false;
	};
	
	//Play sound,use enums for input of sound to play, send in refrence to associate game object
	//returns success bool
	this.PlaySound = function(num,gObj)
	{
		if(num>=this.levelSoundClips[this.currentLevel-1].length || num < 0)
		{
			return false;
		}
	
		//make sure sound is ready
		if(!this.levelSndReady[this.currentLevel-1][num])
		{
			return false;
		}

		//if sound clip isnt null make sure its not playing
		if(this.levelSoundClips[this.currentLevel-1][num] != null)
		{	
			if(this.IsPlaying(num))
			{
				return false;
			}
		}
		
		//make the sound clip
		var time = this.context.currentTime;
		var clip = new SoundClip(this.levelSndBuffers[this.currentLevel-1][num],time,this.context,this.masterVol,gObj);
		this.levelSoundClips[this.currentLevel-1][num] = clip;
		clip.src.noteOn(time);
		
		return true;
	};

	//stop a sound,use enums for input of sound to play
	this.StopSound = function(num)
	{
		if(this.IsPlaying(num))
		{
			this.levelSoundClips[this.currentLevel-1][num].src.noteOff(this.context.currentTime);
			return true;
		}
		
		return false;
	};

	//returns if a sound is playing,use enums for input of sound to play
	this.IsPlaying = function(num)
	{
		if(!this.levelSndReady[this.currentLevel-1][num] || this.levelSoundClips[this.currentLevel-1][num]==null)
		{
			return false;
		}
		else
		{
			return this.levelSoundClips[this.currentLevel-1][num].playTime+this.levelSoundClips[this.currentLevel-1][num].src.buffer.duration > this.context.currentTime;
		}
	};

	//Update those sounds
	this.Update = function(cameraMatrix){
		
		if(this.ready)
		{
			if(this.currentLevel<1)
			{
				return;
			}
		
			//Check all sounds in the cue, if they aren't playing anymore, remove them
			//if they are playing update the panner position
			for(i=0;i<this.levelSoundClips[this.currentLevel-1].length;i++)
			{
				if(this.levelSoundClips[this.currentLevel-1][i]!=null)
				{
					if(!this.IsPlaying(i))
					{
						this.levelSoundClips[this.currentLevel-1][i] = null;
					}
					else
					{
						this.levelSoundClips[this.currentLevel-1][i].UpdatePosition();
						this.levelSoundClips[this.currentLevel-1][i].UpdateOrientation();
					}
				}
			}

			// Update listener orientation
			var m = cameraMatrix;

			var mx = m.n14, my = m.n24, mz = m.n34;
			m.n14 = m.n24 = m.n34 = 0;

			// Multiply the orientation vector by the world matrix of the camera.
			var vec = new THREE.Vector3(0,0,1);
			m.multiplyVector3(vec);
			vec.normalize();

			// Multiply the up vector by the world matrix.
			var up = new THREE.Vector3(0,-1,0);
			m.multiplyVector3(up);
			up.normalize();

			// Set the orientation and the up-vector for the listener.
			this.context.listener.setOrientation(vec.x, vec.y, vec.z, up.x, up.y, up.z);

			m.n14 = mx;
			m.n24 = my; 
			m.n34 = mz;
		}
	};

	this.ready = true;
	//this.context.listener.setPosition(50,0,0);//DEBUG ONLY - move audio listener somewhere to test positional audio
	// Setup sound cone
	//this.panner.coneInnerAngle = 22.5;
	//this.panner.coneOuterAngle = 45;
	//this.panner.coneOuterGain = 1;
};

Audio.init();

//Preload level 1 sound
Audio.currentLevel = 1
Audio.LoadLevelSound(Audio.currentLevel);


