//sound_clip.js - Glauntlet - RIT 2012-2 Preston Johnson
//simple data structure to hold sound clips to play
//Should only be used by audio.js

//Makes a sound clip
//Input sound data buffer to play,the play time relative to current time of the audio context, the audio context, and the masterVol,and the game object its associated too
function SoundClip(buffer,playTime,ctx,masterVol,gObj)
{
	this.playTime = playTime;
	this.src = ctx.createBufferSource();
	this.src.buffer = buffer;	
	this.vol = ctx.createGainNode();
	this.panner = ctx.createPanner();
	this.src.connect(this.panner);
	this.panner.connect(this.vol);
	this.vol.connect(masterVol);
	this.gameObject = gObj;
	
	
	//this.vol.gain.value = 0;
	
	if(gObj!=null)
	{
		this.panner.setPosition(gObj.position.x,gObj.position.y,gObj.position.z);
		
		//Sounds via gObjs are too quiet, amplify
		this.vol.gain.maxValue = 3.0;
		this.vol.gain.value = 3.0;
	}
	else
	{
		this.panner.setPosition(0,0,0);
	}
	
	this.UpdatePosition = function(){//Allows us to update the panner position to the associate objects position
	
		if(this.gameObject != null)
		{
			this.panner.setPosition(this.gameObject.position.x,this.gameObject.position.y,this.gameObject.position.z);
		}
	}

	// Update panner orientation based on object orientation
	this.UpdateOrientation = function() {
	
		if(this.gameObject != null)
		{
			var vec = new THREE.Vector3(0, 0, 1);
			var m = this.gameObject.matrixWorld;

			// Save the translation column and zero it.
			var mx = m.n14, my = m.n24, mz = m.n34;
			m.n14 = m.n24 = m.n34 = 0;

			// Multiply the 0,0,1 vector by the world matrix and normalize the result.
			m.multiplyVector3(vec);
			vec.normalize();

			this.panner.setOrientation(vec.x, vec.y, vec.z);

			// Restore the translation column.
			m.n14 = mx;
			m.n24 = my; 
			m.n34 = mz;
		}
	}

}


