//enemy
/*
*This is an enemy. It finds the player and moves towards them. up to within a certain radius
*@author Aleks Litynski
*
*@param {desiredRadius} This is the closest the enemy will try to get to the player
*/
function DefaultEnemy(desiredRadius)
{
	this.radius = desiredRadius;
	this.type = "DefaultEnemy";
	
	this.prevMove = {};

	this.update = function()
	{
	
		if(this.gameObject.getComponent("collider").colliding)
		{
			this.gameObject.position.x -= (this.prevMove.x);
			this.gameObject.position.y -= (this.prevMove.y);
		}
		this.prevMove.x = 0;
		this.prevMove.y = 0;
	
		var currentPos = new THREE.Vector3(this.gameObject.position.x, this.gameObject.position.y, this.gameObject.position.z);
		var diff = currentPos.subSelf(this.getTarget());
		diff.normalize();

		this.prevMove.x = -diff.x * this.gameObject.components.Stats.getSpeed();
		this.prevMove.y = -diff.y * this.gameObject.components.Stats.getSpeed();
		
		
		this.gameObject.position.x += this.prevMove.x;
		this.gameObject.position.y += this.prevMove.y;

	};

	this.getTarget = function()
	{
		var toReturn = ENGINE.currentScene.find("player 0");
		if(toReturn == undefined)
		{
			toReturn = this.gameObject.position;
		}
		else
		{
			toReturn = toReturn.position;
		}
		return toReturn;
	};
};
