/*
* Loads a json file into a map. Currently uses local json data to create the map.
* @author: Aleks Litynksi
*/
function Map(prev, plyrs)
{
	this.prevScene = prev;
	this.players = plyrs;
	
	
	this.loadMap = function(mapLoc)
	{	
		//console.log(this.players);
		var ps = this.players;
		var pu = this.purgatory;
		var mapJson = {};
		if(mapLoc == undefined)
		{
			mapJson = 	{
							"width": 5,
							"height": 5,
							"map": [
								[
									"WALL",
									"WALL",
									"WALL",
									"WALL",
									"WALL"
								],
								[
									"WALL",
									"START",
									"FLOOR",
									"FLOOR",
									"WALL"
								],
								[
									"WALL",
									"GHOST1",
									"GOLD2",
									"FLOOR",
									"WALL"
								],
								[
									"WALL",
									"FLOOR",
									"GOLD2",
									"EXIT",
									"WALL"
								],
								[
									"WALL",
									"WALL",
									"WALL",
									"WALL",
									"WALL"
								]
							]
						}
						loadMap(mapJson);
		}
		else
		{
			$.getJSON(mapLoc, 
				function (data, textStatus)
				{
					loadMap2(data, textStatus, ps, pu);
				}
			);
		}
	};
	
	function loadMap2(mapJson, textStatus, plyrs, pu)
	{
		var playerChars = plyrs;
		
		//var floorMaterial = new THREE.MeshLambertMaterial( { ambient: 0xcccccc, map: ENGINE.currentScene.assets.textures["floor"] });
		
		var cManager = new THREE.Object3D();
		cManager.addComponent(new collisionManager(mapJson.width, mapJson.height));
		cManager.tag = "collisionManager";
		cManager.name = "collisionManager";
		ENGINE.currentScene.add(cManager);
		
		if(!pu){
			var purg = new THREE.Object3D();
			purg.addComponent(new purgatory());
			purg.tag = "purgatory";
			purg.name = "purgatory";
			ENGINE.currentScene.add(purg);
		}
		else{
			var purg = new THREE.Object3D();
			purg.addComponent(pu);
			purg.tag = "purgatory";
			purg.name = "purgatory";
			ENGINE.currentScene.add(purg);
		}
		
		mapJson = mapJson.map;
		var floor = spawnObject(	0,0, 0.05, "FLOOR", "NULL", "floor", 
				new THREE.MorphAnimMesh(new THREE.PlaneGeometry(0,0), 
				new THREE.MeshLambertMaterial({color: 0x808080})),
				[]);
		var matrix = new THREE.Matrix4();
		ENGINE.currentScene.add(floor);
		
		
	/*	for(i = 0; i < cManager.components["collisionManager"].bins.length; i++)
		{
			var c = cManager.components["collisionManager"];
			console.drawOutline(c.bins[i].x,0,c.bins[i].z,c.binSize, 1, c.binSize); //Questions? Check out consoleExentsions.js, in the core/utilities folder.
		}*/
		for(var x = 0; x < mapJson.length; x++)
		{
			for(var z = 0; z < mapJson.length; z++)
			{
				
				var floorTile = spawnObject(x, z, 0, 
								"FLOORELEM", 
								"NULL",  "floor",
								new THREE.MorphAnimMesh(new THREE.PlaneGeometry(1,1), new THREE.MeshLambertMaterial({color: 0x000000, wireframe: true })),
								[]);
					
					floorTile.geometry.applyMatrix( matrix.makeRotationX(  -Math.PI / 2 ) );
					for(var vertex in floorTile.geometry.vertices) 
					{
						floorTile.geometry.vertices[vertex].x += floorTile.position.x;
						floorTile.geometry.vertices[vertex].z += floorTile.position.z;
						floorTile.geometry.vertices[vertex].y += floorTile.position.y;
					}
					floorTile.geometry.__dirtyVertices = true;
					THREE.GeometryUtils.merge(floor.geometry, floorTile.geometry);
					
				switch(mapJson[x][z])
				{
					case "FLOOR":
						//the floor is added on all tiles now
						break;
					case "WALL":
						var model = spawnObject(x, z, 0.5,
									"wall", 
									"NULL", "wall",
									new THREE.MorphAnimMesh(new THREE.CubeGeometry(1,4,1), new THREE.MeshPhongMaterial({ color: 0xffffff, specular: 0xffffff, shininess: 100 })),
									[new collider("rectangle",1,1,1,1), new RigidBody()]);
						model.tag = "wall";
						addWall(model, mapJson);
						break;
					case "BREAKABLEWALL":
						ENGINE.currentScene.add(spawnObject(x, z, 1,
									"BREAKABLEWALL[" + x +"]["+ z +"]", 
									"NULL", "wall",
									new THREE.MorphAnimMesh(new THREE.CubeGeometry(1,2,1), new THREE.MeshLambertMaterial({color: 0x808888})),
									[new collider("rectangle",1,0.5,0.5,0.5), new RigidBody(), new enemyChar(4)]));//w,h,d
						break;
					case "START":
						console.log("purg?");
					    var model = spawnObject(x, z, 0.5,
									"PlayerSpawner",
									"spawn", "spawn", 									
									new THREE.MorphAnimMesh(new THREE.CubeGeometry(3,0.1,3), new THREE.MeshLambertMaterial({color: 0xf6a01a})),
									[new PlayerSpawner({valkyrie:"body", warriorTexture:"warrior", valkyrieTexture:"valkyrie", wizardTexture:"wizard", rangerTexture:"ranger"}, playerChars , pu)], playerChars, pu);
						
						model.scale.multiplyScalar(0.2);
						
						ENGINE.currentScene.add(model);
						break;
					case "FLOORSPIKE":
						ENGINE.currentScene.add(spawnObject(x, z, 1,
									"FLOORSPIKE[" + x +"]["+ z +"]", 
									"spike", "spike",
									new THREE.MorphAnimMesh(new THREE.CubeGeometry(1,2,1), new THREE.MeshLambertMaterial({color: 0xd81417})),
									[new collider("rectangle",1,1,1,1,new Array("floorspike"),new Array("playerChar")), new floorspike(), new RigidBody()]));
						break;
					case "EXIT":
						var model = spawnObject(x, z, 0.25,
									"LevelExit",
									"spawn", "key", 									
									new THREE.Mesh(new THREE.CubeGeometry(1, 1, 1), new THREE.MeshBasicMaterial( { color: 0x666600, wireframe: true })),
									[new collider("rectangle", 1, 1, 1, 1, new Array("enemyChar")), new RigidBody(), new exit()]);
						model.scale.multiplyScalar(0.2);	
						ENGINE.currentScene.add(model);
						break;
					case "KEY":
						var model = spawnObject(x, z, 1,
									"Key["+x+"]["+z+"]",
									"key", "key", 							
									new THREE.Mesh(new THREE.CubeGeometry(0.15, 0.25, 0.6), new THREE.MeshBasicMaterial( { color: 0xffffff, wireframe: false })),
									[new collider("rectangle", 1, 1, 1, 1, new Array("enemy")), new RigidBody(), new key(100)]);
						
						model.scale.multiplyScalar(0.7);	
						
						
						ENGINE.currentScene.add(model);
						break;
					case "DOOR":
						
						model = spawnObject(x, z, 0.25,
									"Door",
									"door", "door", 									
									new THREE.Mesh(new THREE.CubeGeometry(1, 1, 1), new THREE.MeshBasicMaterial( { color: 0xff66ff, wireframe: false })),
									[new collider("rectangle", 1, 1, 1, 1), new RigidBody(), new door()]);
						
						var rotation = function(model) {model.rotation = new THREE.Vector3(0,90 * Math.PI / 180,0);};
						if((mapJson[x-1][z] == "DOOR" || mapJson[x-1][z] == "WALL") && (mapJson[x+1][z] == "DOOR" || mapJson[x+1][z] == "WALL"))
						{							
							rotation = function(model) {model.rotation = new THREE.Vector3(0,0,0);};
						}
						rotation(model);
						ENGINE.currentScene.add(model);
						
						break;
					case "POTION":
						var model = spawnObject(x, z, 0.25,
									"potion [" + x + "][" + z + "]",
									"potion", "bPotion", 									
									new THREE.Mesh(new THREE.CubeGeometry(1, 1, 1), new THREE.MeshBasicMaterial( { color: 0x0000ff, wireframe: true })),
									[new collider("rectangle", 1, 1, 1, 1, new Array("enemyChar")), new RigidBody(), new potion()]);
						
						model.scale.multiplyScalar(0.75);
						
						ENGINE.currentScene.add(model);
						break;
					case "GOLD1":
						ENGINE.currentScene.add(spawnObject(x, z, 0.1,
									"GOLD1[" + x +"]["+ z +"]", 
									"treasure", "treasure1",
									new THREE.MorphAnimMesh(new THREE.SphereGeometry(0.1,0.01,0.1), new THREE.MeshLambertMaterial({color: 0xd4af37})),
									[new treasure(1), new collider("rectangle",1,1,1,1, new Array("enemyChar")), new RigidBody()]));
						break;
					case "GOLD2":
						ENGINE.currentScene.add(spawnObject(x, z, 1,
									"GOLD2[" + x +"]["+ z +"]", 
									"treasure", "treasure2",
									new THREE.MorphAnimMesh(new THREE.SphereGeometry(0.1,0.01,0.1), new THREE.MeshLambertMaterial({color: 0xfdf700})),
									[new treasure(1), new collider("rectangle",1,1,1,1, new Array("enemyChar")), new RigidBody()]));
						break;
					case "GOLD3":
						ENGINE.currentScene.add(spawnObject(x, z, 1,
									"GOLD3[" + x +"]["+ z +"]", 
									"treasure", "treasure3",
									new THREE.MorphAnimMesh(new THREE.SphereGeometry(0.1,0.01,0.1), new THREE.MeshLambertMaterial({color: 0xfdf700})),
									[new treasure(1), new collider("rectangle",1,1,1,1, new Array("enemyChar")), new RigidBody()]));
						break;
					case "FOOD1":
							var model = spawnObject(x, z, 0.5,
										"food1["+x+"]["+z+"]",
										"food1", "food1",									
										new THREE.MorphAnimMesh(new THREE.SphereGeometry(.5,.5,.5), new THREE.MeshBasicMaterial({color: 0x8fff63})),
										[new food(1), new collider("rectangle",1,1,1,1, new Array("enemyChar")), new RigidBody()]);
							model.scale.multiplyScalar(0.1); 
							ENGINE.currentScene.add(model);
						break;
					case "FOOD2":
						var model = spawnObject(x, z, 0.5,
										"food2["+x+"]["+z+"]",
										"food2", "food2",									
										new THREE.MorphAnimMesh(new THREE.SphereGeometry(.5,.5,.5), new THREE.MeshBasicMaterial({color: 0x8fff63})),
										[new food(1), new collider("rectangle",1,1,1,1, new Array("enemyChar")), new RigidBody()]);
							model.scale.multiplyScalar(0.2); 
						ENGINE.currentScene.add(model);
						break;
					case "FOOD3":
						var model = spawnObject(x, z, 0.5,
										"food3["+x+"]["+z+"]",
										"food3", "food3",									
										new THREE.MorphAnimMesh(new THREE.SphereGeometry(.5,.5,.5), new THREE.MeshBasicMaterial({color: 0x8fff63})),
										[new food(1), new collider("rectangle",1,1,1,1, new Array("enemyChar")), new RigidBody()]);
							model.scale.multiplyScalar(0.3); 
							ENGINE.currentScene.add(model);
						break;
					case "GHOST1":
						var model = spawnObject(x, z, 0.2,
									"ghostspawner1["+x+"]["+z+"]",
									"ghostSpawn", "gSpawn1",								
									new THREE.MorphAnimMesh(new THREE.SphereGeometry(.4,.4,.4), new THREE.MeshBasicMaterial({color: 0x856363})),
									[ new EnemySpawner(0, 1, 10, 1, {model:"ghost", texture:"ghost1",     anim:{paused:0, walk:{start:0,stop:1}, fire:{start:0,stop:24}, die:{start:0,stop:1}, speed:10}      }), new collider("rectangle",1,1,1,1), new RigidBody(), new enemyChar(3) ]);
						model.scale.multiplyScalar(4); 
						model.rotation.y += 90*Math.PI/180;
						ENGINE.currentScene.add(model);
						
						break;
					case "GHOST2":
						var model = spawnObject(x, z, 0.2,
									"ghostspawner2["+x+"]["+z+"]",
									"ghostSpawn", "gSpawn2",								
									new THREE.MorphAnimMesh(new THREE.SphereGeometry(.4,.4,.4), new THREE.MeshBasicMaterial({color: 0x856363})),
									[ new EnemySpawner(0, 1, 10, 2, {model:"ghost", texture:"ghost2",   anim:{paused:0, walk:{start:0,stop:1}, fire:{start:0,stop:24}, die:{start:0,stop:1}, speed:10}      }), new collider("rectangle",1,1,1,1), new RigidBody(), new enemyChar(3) ]);
						model.scale.multiplyScalar(4); 
						model.rotation.y += 90*Math.PI/180;
						ENGINE.currentScene.add(model);
						break;
					case "GHOST3":
						var model = spawnObject(x, z, 0.2,
									"ghostspawner1["+x+"]["+z+"]",
									"ghostSpawn", "gSpawn3",								
									new THREE.MorphAnimMesh(new THREE.SphereGeometry(.4,.4,.4), new THREE.MeshBasicMaterial({color: 0x856363})),
									[ new EnemySpawner(0, 1, 10, 3, {model:"ghost", texture:"ghost3",  anim:{paused:0, walk:{start:0,stop:1}, fire:{start:0,stop:24}, die:{start:0,stop:1}, speed:10}   }), new collider("rectangle",1,1,1,1), new RigidBody(), new enemyChar(3) ]);
									
						model.scale.multiplyScalar(4); 
						model.rotation.y += 90*Math.PI/180;
						ENGINE.currentScene.add(model);
						break;
					case "THUG1":
						var model = spawnObject(x, z, 0.2,
									"thugspawner1["+x+"]["+z+"]",
									"banditSpawn", "bSpawn1",								
									new THREE.MorphAnimMesh(new THREE.SphereGeometry(.4,.4,.4), new THREE.MeshBasicMaterial({color: 0x856363})),
									[ new EnemySpawner(1, 1, 10, 1, {model:"bandit", texture:"bandit1", anim:{paused:0, walk:{start:0,stop:38}, fire:{start:39,stop:56}, die:{start:57,stop:77}, speed:10}   }), new collider("rectangle",1,1,1,1), new RigidBody(), new enemyChar(3) ]);
						model.scale.multiplyScalar(1.5); 
						
						ENGINE.currentScene.add(model);
						break;
					case "THUG2":
						var model = spawnObject(x, z, 0.2,
									"thugspawner2["+x+"]["+z+"]",
									"banditSpawn", "bSpawn2",								
									new THREE.MorphAnimMesh(new THREE.SphereGeometry(.4,.4,.4), new THREE.MeshBasicMaterial({color: 0x856363})),
									[ new EnemySpawner(1, 1, 10, 2, {model:"bandit", texture:"bandit2", anim:{paused:0, walk:{start:0,stop:38}, fire:{start:39,stop:56}, die:{start:57,stop:77}, speed:10}  }), new collider("rectangle",1,1,1,1), new RigidBody(), new enemyChar(3) ]);	
						model.scale.multiplyScalar(1.5); 
						
						ENGINE.currentScene.add(model);									
						break;
					case "THUG3":
						var model = spawnObject(x, z, 0.2,
									"thugspawner3["+x+"]["+z+"]",
									"banditSpawn", "bSpawn3",								
									new THREE.MorphAnimMesh(new THREE.SphereGeometry(.4,.4,.4), new THREE.MeshBasicMaterial({color: 0x856363})),
									[ new EnemySpawner(1, 1, 10, 3, {model:"bandit", texture:"bandit3", anim:{paused:0, walk:{start:0,stop:38}, fire:{start:39,stop:56}, die:{start:57,stop:77}, speed:10}  }), new collider("rectangle",1,1,1,1), new RigidBody(), new enemyChar(3) ]);
						model.scale.multiplyScalar(1.5); 
						
						ENGINE.currentScene.add(model);
						break;
					case "DEMON1":
						var model = spawnObject(x, z, 0.2,
									"demonspawner1["+x+"]["+z+"]",
									"demonSpawn", "dSpawn1",								
									new THREE.MorphAnimMesh(new THREE.SphereGeometry(.4,.4,.4), new THREE.MeshBasicMaterial({color: 0x856363})),
									[ new EnemySpawner(2, 1, 10, 1, {model:"demon", texture:"demon1", anim:{paused:0, walk:{start:0,stop:47}, fire:{start:48,stop:70}, die:{start:71,stop:105}, speed:10}  }), new collider("rectangle",1,1,1,1), new RigidBody(), new enemyChar(3) ]);
						model.scale.multiplyScalar(0.2); 
						
						ENGINE.currentScene.add(model);
						break;
					case "DEMON2":
						var model = spawnObject(x, z, 0.2,
									"demonspawner2["+x+"]["+z+"]",
									"demonSpawn", "dSpawn2",								
									new THREE.MorphAnimMesh(new THREE.SphereGeometry(.4,.4,.4), new THREE.MeshBasicMaterial({color: 0x856363})),
									[ new EnemySpawner(2, 1, 10, 2, {model:"demon", texture:"demon2", anim:{paused:0, walk:{start:0,stop:47}, fire:{start:48,stop:70}, die:{start:71,stop:105}, speed:10} }), new collider("rectangle",1,1,1,1), new RigidBody(), new enemyChar(3) ]);
						model.scale.multiplyScalar(0.2); 
						
						ENGINE.currentScene.add(model);
						break;
					case "DEMON3":
						var model = spawnObject(x, z, 0.2,
									"demonspawner3["+x+"]["+z+"]",
									"demonSpawn", "dSpawn3",								
									new THREE.MorphAnimMesh(new THREE.SphereGeometry(.4,.4,.4), new THREE.MeshBasicMaterial({color: 0x856363})),
									[ new EnemySpawner(2, 1, 10, 3, {model:"demon", texture:"demon3", anim:{paused:0, walk:{start:0,stop:47}, fire:{start:48,stop:70}, die:{start:71,stop:105}, speed:10} }), new collider("rectangle",1,1,1,1), new RigidBody(), new enemyChar(3) ]);
						model.scale.multiplyScalar(0.2); 
						
						ENGINE.currentScene.add(model);
						break;
					case "WALLLIGHT":
						var model = spawnObject(x, z, 0.2,
									"torch["+x+"]["+z+"]",
									"torch", "torch",								
									new THREE.MorphAnimMesh(new THREE.SphereGeometry(.4,.4,.4), new THREE.MeshBasicMaterial({color: 0x00ff00})),
									[]);
						//model.scale.multiplyScalar(0.05);
						model.geometry.computeBoundingBox();
						var xx = model.position.x;
						var yy = model.position.y;
						var zz = model.position.z;
						var ww = model.geometry.boundingBox.max.x - model.geometry.boundingBox.min.x;
						var hh = model.geometry.boundingBox.max.y - model.geometry.boundingBox.min.y;
						var dd = model.geometry.boundingBox.max.z - model.geometry.boundingBox.min.z;
						
						ENGINE.currentScene.add(model);
						break;
					case "CEILINGLIGHT":
					
						break;
					case "PROP1":
					
						break;
					case "PROP2":
					
						break;
					case "PROP3":
					
						break;
					case "PROP4":
					
						break;
				}
			}
		}
		
		floor.geometry.computeBoundingSphere();
		var walls = ENGINE.currentScene.findByTag("wall");
		for(var wall in walls)
		{
		
			var color = '#'+Math.floor(Math.random()*16777215).toString(16);
			wall = walls[wall];
			//wall.geometry.computeBoundingBox();
			var bounds = wall.geometry.boundingBox;
			//var len = (bounds.max.x-bounds.min.x);
			//var wid = (bounds.max.y-bounds.min.y);
			//var hei = (bounds.max.z-bounds.min.z);
			
			var matrix = new THREE.Matrix4();
			var wallSpan = wallSpans[wall.name.substr(wall.name.indexOf(" "))-1];
			if(wallSpan)
			{
				var vertOff = 0.5;
				var horOff = 0.5;
				if(wallSpan.type == "horizontal")
				{
					wall.geometry.applyMatrix( matrix.translate( new THREE.Vector3((-wallSpan.walls.length/2)+horOff, 0, 0)));
					wall.position.x += (wallSpan.walls.length/2)-horOff;
					wall.components.collider.boundWidth = wallSpan.walls.length + horOff;

				}
				if(wallSpan.type == "vertical")
				{
					wall.geometry.applyMatrix( matrix.translate( new THREE.Vector3(0, 0, (-wallSpan.walls.length/2)+vertOff)));
					wall.position.z += (wallSpan.walls.length/2)-vertOff;
					wall.components.collider.boundDepth = wallSpan.walls.length + vertOff;
		
				}
				//wall.geometry.computeBoundingSphere();
			}
			
			//wall.components.collider.debugDraw();
			
			var w = wall.components.collider.boundWidth;
			var h = wall.components.collider.boundHeight;
			var d = wall.components.collider.boundDepth;			
		}
		
		
	}
	
	
	function spawnObject(x, z, y, name, modelName, textureName, fallbackModel, components, extraFunction, extraVar, extraVar2)
	{
		var model = fallbackModel;
		if(ENGINE.currentScene.assets.meshes[modelName])
		{
			if(ENGINE.currentScene.assets.textures[textureName])
			{
				model = new THREE.Mesh(ENGINE.currentScene.assets.meshes[modelName].geometry, new THREE.MeshLambertMaterial( {map: ENGINE.currentScene.assets.textures[textureName], morphTargets: true } ) );
				
			}
			else
			{
				model = new THREE.Mesh(ENGINE.currentScene.assets.meshes[modelName].geometry, new THREE.MeshLambertMaterial( { color: 0x606060, morphTargets: true } ) );
				
			}
			model.scale.multiplyScalar(0.2);
		}
		else
		{
			
			if(modelName == "NULL" && ENGINE.currentScene.assets.textures[textureName])
			{
				model.material.map = ENGINE.currentScene.assets.textures[textureName];
		
			}
		}
	
		
		
		model.position.x = x;
		model.position.y = y;
		model.position.z = z; 	//I would love to infer the height of the model, but I can't find any relevent properties.
								//If you can, or if they appear when we load real models, please let me know!

		model.castShadow = true;
		model.receiveShadow = true;
		
		model.name = name;
		
		
		{
			for(var comp in components)
			{	
				var c = components[comp];
				if(c.type == "PlayerSpawner")
				{
					c = new PlayerSpawner({model:"body", warriorTexture:"warrior", valkyrieTexture:"valkyrie", wizardTexture:"wizard", rangerTexture:"ranger"}, extraVar, extraVar2);
					//still same...
					//console.log("extraVar:");
					//console.log(extraVar);
				}
				model.addComponent(c);
			}
		}
		return model;
	}
	 
	 
	 //array of {type:"horizontal", walls:[wall,wall,wall,wall]} //type can be horizontal, vertical, or none
	var wallSpans = [];
	function addWall(wall, map)
	{
	
		//if there is a wall above it
		if(wall.position.z - 1 >= 0)
		{
			if(map[wall.position.x][wall.position.z - 1] == "WALL")
			{
				//if that wall is in a vertical span or no span
				var spanDex = wallSpanOf(wall.position.x,wall.position.z - 1, "vertical");
				if(spanDex != false)
				{
					//add it to that wallspan
					addToSpan(wall, spanDex,"vertical");
					return;
				}
			}
		}
		
		//if there is a wall to the left
		if(wall.position.x - 1 >= 0)
		{
			if(map[wall.position.x - 1][wall.position.z] == "WALL")
			{
				//if that wall is in a horizontal span or no span
				var spanDex = wallSpanOf(wall.position.x - 1,wall.position.z, "horizontal")
				if(spanDex != false)
				{
					//add it to that wallspan
					addToSpan(wall, spanDex, "horizontal");
					return;
				}
			}
		}
		//otherwise add it as a new wallspan
		addNewSpan(wall);
	}
	function wallSpanOf(x,z,type)
	{
		for(var i in wallSpans)
		{
			var wallSpan = wallSpans[i];
			if(wallSpan.type == type || wallSpan.type == "none")
			{
				for(var j in wallSpan.walls)
				{
					var wall = wallSpan.walls[j];
					if(wall.position.x == x && wall.position.z == z)
					{
						return i;
					}
				}
			}
		}
		return false;
	}
	function addToSpan(wall, spanDex, type)
	{
		wallSpans[spanDex].type = type;
		wallSpans[spanDex].walls.push(wall);
		var mergeInto = ENGINE.currentScene.find("wall " + spanDex);
		if(mergeInto != false)
		{
			for(var vertex in wall.geometry.vertices) 
			{
				wall.geometry.vertices[vertex].x += wall.position.x - mergeInto.position.x;
				wall.geometry.vertices[vertex].z += wall.position.z - mergeInto.position.z;
				wall.geometry.vertices[vertex].y += wall.position.y - mergeInto.position.y;
			}
			wall.geometry.verticesNeedUpdate = true;
			THREE.GeometryUtils.merge(mergeInto.geometry, wall.geometry);
			mergeInto.geometry.computeBoundingSphere();
		}
		else
		{
			addNewSpan(wall);
		}
	}
	function addNewSpan(wall)
	{
	//wall.position.y *= 2;
		var newSpan = {type:"none", walls:[wall]};
		wallSpans.push(newSpan);
		wall.name = "wall " + wallSpans.length;
		ENGINE.currentScene.add(wall);
	}
	
	//dom broke everything.
	function center(geometry,dir)
	{
		geometry.computeBoundingBox();
		var bounds = geometry.boundingBox;
		var center = new THREE.Vector3;
		center.x = bounds.min.x + bounds.max.x;
		center.y = bounds.min.y + bounds.max.y;
		center.z = bounds.min.z + bounds.max.z;
		center.multiplyScalar(-0.5);
		var matrix = new THREE.Matrix4();
		if(dir == "x")
		{
			geometry.applyMatrix(matrix.makeTranslation(center.x,0,0));
		}
		else
		{
			geometry.applyMatrix(matrix.makeTranslation(0,0,center.z));
		}
		if(!dir)
		{
			geometry.applyMatrix(matrix.makeTranslation(center.x,center.y,center.z));
		}
		geometry.computeBoundingBox();
		return center;
	}
};

