/*
* Loads a json file into a map. Currently uses local json data to create the map.
* @author: Aleks Litynksi
*/
function Map(prev)
{
	this.prevScene = prev;
	
	this.loadMap = function(mapLoc)
	{
		var mapJson = {};
		if(mapLoc == undefined)
		{
			mapJson = 	{
							"width": 5,
							"height": 5,
							"map": [
								[
									"WALL",
									"WALL",
									"WALL",
									"WALL",
									"WALL"
								],
								[
									"WALL",
									"START",
									"FLOOR",
									"FLOOR",
									"WALL"
								],
								[
									"WALL",
									"GHOST1",
									"GOLD2",
									"FLOOR",
									"WALL"
								],
								[
									"WALL",
									"FLOOR",
									"GOLD2",
									"EXIT",
									"WALL"
								],
								[
									"WALL",
									"WALL",
									"WALL",
									"WALL",
									"WALL"
								]
							]
						}
						loadMap(mapJson);
		}
		else
		{
			$.getJSON(mapLoc, loadMap);
		}
	};
		
		
	function loadMap(mapJson)
	{
	
		mapJson = mapJson.map;
		//var floorMaterial = new THREE.MeshLambertMaterial( { ambient: 0xcccccc, map: ENGINE.currentScene.assets.textures["floor"] });
	
		var cManager = new THREE.Object3D();
		cManager.addComponent(new collisionManager(mapJson.width, mapJson.height));
		cManager.tag = "collisionManager";
		cManager.name = "collisionManager";
		ENGINE.currentScene.add(cManager);
		
		spawnObject(	0,0, -0.05, "FLOOR", "NULL", "floor", 
				new THREE.MorphAnimMesh(new THREE.PlaneGeometry(mapJson.length,mapJson.length), 
				new THREE.MeshLambertMaterial({color: 0x808080})),
				[],
				function(floor){
					floor.rotation.x = Math.toRadians(-90);
					floor.position.x = mapJson.length/2;
					floor.position.z = -mapJson.length/2;
					
					floor.material.map.wrapS  = THREE.RepeatWrapping;
					floor.material.map.wrapT = THREE.RepeatWrapping;
					
					// CORRECT BUT IN THE WRONG POSITION!
					floor.material.map.repeat.y = mapJson.length;//mapJson.length/32;
					floor.material.map.repeat.x = mapJson.length;// mapJson.length/32;
				}
		);
		
		
		for(var x = 0; x < mapJson.length; x++)
		{
			for(var z = 0; z < mapJson.length; z++)
			{
				switch(mapJson[x][z])
				{
					case "FLOOR":
						/*spawnObject(x, z, -0.05, 
									"FLOOR[" + x +"]["+ z +"]", 
									"NULL",  "floor",
									new THREE.Mesh(new THREE.CubeGeometry(1,0.1,1), new THREE.MeshPhongMaterial({color: 0x808080})),
									[],
									function(model) {model.scale.x = 0.9;model.scale.z = 0.9;} );*/
						break;
					case "WALL":
						spawnObject(x, z, 1,
									"WALL[" + x +"]["+ z +"]", 
									"NULL", "wallTexture",
									new THREE.MorphAnimMesh(new THREE.CubeGeometry(1,2,1), new THREE.MeshPhongMaterial({ color: 0xffffff, specular: 0xffffff, shininess: 100 })),/*new THREE.MeshLambertMaterial({color: 0x808080}))*/
									[new collider("rectangle",1,0.6,0.6,0.6)]);//new collider("sphere")
						break;
					case "BREAKABLEWALL":
						spawnObject(x, z, 1,
									"BREAKABLEWALL[" + x +"]["+ z +"]", 
									"bWall", "bWallTex",
									new THREE.MorphAnimMesh(new THREE.CubeGeometry(1,2,1), new THREE.MeshLambertMaterial({color: 0x808888})),
									[new collider("rectangle",0.5,0.5,0.5)]);
						break;
					case "FLOORSPIKE":
					
						break;
					case "WALLDART":
					
						break;
					case "START":
					    spawnObject(x, z, 0.25,
									"PlayerSpawner",
									"spawner", "spawnerTexure", 									
									new THREE.MorphAnimMesh(new THREE.SphereGeometry(0.5,0.5,0.5), new THREE.MeshLambertMaterial({color: 0xf6a01a})),
									[new PlayerSpawner({model:"body", warriorTexture:"warrior", valkyrieTexture:"valkyrie", wizardTexture:"wizard", rangerTexture:"ranger"})],
									function(model) {model.scale.multiplyScalar(0.2)} );
						break;
					case "EXIT":
						spawnObject(x, z, 0.25,
									"LevelExit",
									"exit", "exitTex", 									
									new THREE.Mesh(new THREE.CubeGeometry(1, 1, 1), new THREE.MeshBasicMaterial( { color: 0x666600, wireframe: true })),
									[new collider("rectangle", 1, 1, 1, 1, new Array("enemy")), new exit()]);
						break;
					case "EXITSKIP":
					
						break;
					case "KEY":
						spawnObject(x, z, 1,
									"Key["+x+"]["+z+"]",
									"NULL", "keyTexture", 									
									new THREE.Mesh(new THREE.CubeGeometry(0.15, 0.25, 0.6), new THREE.MeshBasicMaterial( { color: 0xffdd00, wireframe: false })),
									[new collider("rectangle", 1, 1, 1, 1, new Array("enemy")), new key(100)]);
						break;
					case "DOOR":
						var rotation = function(model) {model.rotation = new THREE.Vector3(0,90 * Math.PI / 180,0);console.log(model.rotation);};
						if((mapJson[x-1][z] == "DOOR" || mapJson[x-1][z] == "WALL") && (mapJson[x+1][z] == "DOOR" || mapJson[x+1][z] == "WALL"))
						{							
							rotation = function(model) {model.rotation = new THREE.Vector3(0,0,0);console.log(model.rotation);};
						}
						spawnObject(x, z, 0.25,
									"Door",
									"fence", "fenceTexture", 									
									new THREE.Mesh(new THREE.CubeGeometry(1, 1, 1), new THREE.MeshBasicMaterial( { color: 0xff66ff, wireframe: false })),
									[new collider("rectangle", 1, 1, 1, 1), new door()],
									rotation);	
						break;
					case "POTION":
					  
						break;
					case "GOLD1":
					
						break;
					case "GOLD2":
					
						break;
					case "GOLD3":
					
						break;
					case "FOOD1":
						spawnObject(x, z, 0.5,
									"food1["+x+"]["+z+"]",
									"ham", "hamTexture",									
									new THREE.MorphAnimMesh(new THREE.SphereGeometry(.5,.5,.5), new THREE.MeshBasicMaterial({color: 0x8fff63})),
									[new food(1), new collider("rectangle",1,1,1,1, new Array("enemy"))],
									function(model) {model.scale.multiplyScalar(0.5)} );
						break;
					case "FOOD2":
					
						break;
					case "FOOD3":
					
						break;
					case "GHOST1":
						spawnObject(x, z, 0.2,
									"ghostspawner1["+x+"]["+z+"]",
									"ghostspawner1", "ghostspawner1Tex",								
									new THREE.MorphAnimMesh(new THREE.SphereGeometry(.4,.4,.4), new THREE.MeshBasicMaterial({color: 0x856363})),
									[ new EnemySpawner(1, 10, 1, {model:"ghost", texture:"ghostTexture"}), new collider("rectangle",1,1,1,1) ]
									);
						break;
					case "GHOST2":
					
						break;
					case "GHOST3":
					
						break;
					case "THUG1":
					
						break;
					case "THUG2":
										  
						break;
					case "THUG3":
					
						break;
					case "DEMON1":
					
						break;
					case "DEMON2":
					
						break;
					case "DEMON3":
					
						break;
					case "LOBBER":
					
						break;
					case "DEATH":
					
						break;
					case "FLOORLIGHT":
					
						break;
					case "WALLLIGHT":
					
						break;
					case "CEILINGLIGHT":
					
						break;
					case "PROP1":
					
						break;
					case "PROP2":
					
						break;
					case "PROP3":
					
						break;
					case "PROP4":
					
						break;
				}
			}
		}
	}
	
	
	function spawnObject(x, z, y, name, modelName, textureName, fallbackModel, components, extraFunction)
	{
		var model = fallbackModel;
		if(ENGINE.currentScene.assets.meshes[modelName])
		{
			if(ENGINE.currentScene.assets.textures[textureName])
			{
				//console.log(modelName);
				model = new THREE.MorphAnimMesh(ENGINE.currentScene.assets.meshes[modelName].geometry, new THREE.MeshLambertMaterial( {map: ENGINE.currentScene.assets.textures[textureName], morphTargets: true } ) );
			}
			else
			{
				model = new THREE.MorphAnimMesh(ENGINE.currentScene.assets.meshes[modelName].geometry, new THREE.MeshLambertMaterial( { color: 0x606060, morphTargets: true } ) );
			}
			model.scale.multiplyScalar(0.2);
		}
		else
		{
			if(modelName == "NULL" && ENGINE.currentScene.assets.textures[textureName])
			{
				model.material.map = ENGINE.currentScene.assets.textures[textureName];
			}
		}
	
		model.position.x = x;
		model.position.y = y;
		model.position.z = z; 	//I would love to infer the height of the model, but I can't find any relevent properties.
								//If you can, or if they appear when we load real models, please let me know!

		
		model.castShadow = true;
		model.receiveShadow = true;
		
		model.name = name;
		
		for(var comp in components)
		{
			model.addComponent(components[comp]);
		}
		
		if(extraFunction !== undefined)
		{
			extraFunction(model);
		}
		
		
		ENGINE.currentScene.add(model);
		
		return model;
	}


};




