//this function prints "label" as text above the passed in object. Use it for debugging.
console.logOver = function(label, object)
{
	if(ENGINE.currentScene.findByTag("consoleObj").length == 0)
	{
		var consoleObj = new THREE.Object3D();
		consoleObj.name = "console object";
		consoleObj.tag = "consoleObj";
		ENGINE.currentScene.add(consoleObj);
	}
	var textGeo = new THREE.TextGeometry(label, {size: 0.2, height: 0.01, curveSegments: 0, font: "helvetiker", weight: "bold", style: "normal"});
	var text =  new THREE.Mesh(textGeo, new THREE.MeshLambertMaterial({color: 0xff0000}));
	var matrix = new THREE.Matrix4();
	text.geometry.applyMatrix( matrix.makeRotationX(  -Math.PI / 2 ) );
	var height = 0;
	for(var vertex in object.geometry.vertices){
		if(object.geometry.vertices[vertex].y + object.position.y > height){
			height = object.geometry.vertices[vertex].y + object.position.y;
		}
	}
	for(var vertex in text.geometry.vertices) {
		text.geometry.vertices[vertex].x += object.position.x - (label.length * 0.05);
		text.geometry.vertices[vertex].z += object.position.z;
		text.geometry.vertices[vertex].y += height;
	}
	text.geometry.computeBoundingSphere();
	text.geometry.__dirtyVertices = true;
	text.name = label;
	ENGINE.currentScene.findByTag("consoleObj")[0].add(text);
};

console.drawBoundingBox = function(model)
{
	model.geometry.computeBoundingBox();
	var box = model.geometry.boundingBox;
	console.log((box.max.x - box.min.x) * model.scale.x);
	console.log((box.max.y - box.min.y) * model.scale.y);
	console.log((box.max.z - box.min.z) * model.scale.z);
	console.drawOutline(model.position.x, model.position.y, model.position.z, (box.max.x - box.min.x) * model.scale.x, (box.max.y - box.min.y) * model.scale.y, (box.max.z - box.min.z) * model.scale.z);
}

console.drawOutline = function(x,y,z,w,h,d, color, wireframe)
{
	color = typeof color !== 'undefined' ? color : 0xff0000;
	if(ENGINE.currentScene.findByTag("consoleObj").length == 0)
	{
		var consoleObj = new THREE.Object3D();
		consoleObj.name = "console object";
		consoleObj.tag = "consoleObj";
		ENGINE.currentScene.add(consoleObj);
	}
	var outline = new THREE.Mesh(new THREE.CubeGeometry(w, h, d), new THREE.MeshBasicMaterial( { color: color, wireframe: !wireframe }));
	outline.position.x = x;
	outline.position.z = z;
	outline.position.y = y;
	outline.name = "outline";
	ENGINE.currentScene.findByTag("consoleObj")[0].add(outline);
};

//this function removes all the logOvers. Could help reduce clutter.
console.clearLogOver = function()
{
	var root = ENGINE.currentScene.findByTag("consoleObj");
	if(root[0])
	{
		ENGINE.currentScene.remove(root[0]);
	}
};
