//spawner
/*
*This component will spawn an enemy of a given type every rate seconds. I'm sorry it doesn't take a prefab as a parameter. It should matter for friday, but I thought it did that and now I feel bad that I forgot to impliment it.
*@author Aleks Litynski
*
*@param {rate} The number of seconds to delay before spawning another asset.
*@paren {other} an array of other parameters. I wasn't sure what else I would need. All it takes now is [max:##]
*
* USE NEW COLLIDER 
*/
var EnemySpawner = function(eType, rate, max, tier, other)
{
	this.type = "EnemySpawner";
	this.rate = rate;
	this.maxSpawns = max;
	this.hasSpawned = 0;
	this.enemyType = eType;
	this.Model = other.model;	
	this.Texture = other.texture;	
	this.players;
	this.spawnerTier = tier;
	this.hits;
	this.anim = other.anim;
	
	this.firstUpdate = true;
	
	//Ian Switaj added stuff:  Will need to be changed
	this.spawnPoints = new Array(); //Array that will hold 8 gameobjects surrounding the spawner.  These game objects will have the same x and z dimensions of the enemy that they will spawn.
	this.lastSpawnPoint = 0; //Used in spawning to keep track of which spawn point was last used.  I didn't implement it below but I remember you wanted to change the spawn points used.
	
	//for Ryans brain:
	this.isEverythingExample = false;
	
	var nextSpawnTime = 0;
	
	this.update = function()
	{
	
		if(this.firstUpdate)
		{
			this.firstUpdate = false;
			this.players = ENGINE.currentScene.findByTag("player");
		}
		
		if(this.hasSpawned < this.maxSpawns)		
		{
			var date = new Date();
			if(date.getTime() > nextSpawnTime)
			{
				this.spawn();
				this.updateSpawnTime();
			}
		}
		//console.log("end of enemy spawner");
		
	}
	
	this.init = function()
	{
		this.players = ENGINE.currentScene.findByTag("player");
		var camera = ENGINE.currentScene.find("camera");
		if (camera != null) { this.camera_tracker_component = camera.getComponent("CAMERTRACKER_CP"); }
		
		this.updateSpawnTime();
		
		//sets the number of hits it can take before being destroyed
		this.hits = this.spawnerTier;

		//Create the spawn points.  Right now it uses the hardcoded dimensions of the cube enemy.  The numbers will be replaced by the enemyType mesh's dimensions.		
		var spot = 0;
		
		for(var x = 0; x < 3; x++)
		{				
			for(var z = 0; z < 3; z++)
			{
				if(x != 1 || z != 1){					
					//create each gameobject with the coordinates (x,1,z) and attach a collider to each.
					var spawnArea = new THREE.Mesh(new THREE.CubeGeometry(1,2,1),  new THREE.MeshPhongMaterial({ambient: 0xcccccc, color: 0x000fff, wireframe:true}));
					//spawnArea.addComponent(new collider("rectangle",1,1,2,1,new Array("enemyChar","playerChar","projectile","enemySpawner")));
					
					//Note: That ifd we just set it up as a regular collider we'll have to change the player and enemy movment code so that they will  be able to walk through it instead of resetting its position
					spawnArea.name='spawnPoint';
					spawnArea.position = new THREE.Vector3( ((-1 + x )+ this.gameObject.position.x), 1, ((-1 + z )+ this.gameObject.position.z) );
					
					/*var collider = new collider("rectangle", 1,1,1,1);				
					collider.isEmpty = true;*/
					
					//add the gameobject to spawnPoints
					this.spawnPoints[spot] = spawnArea;
					//ENGINE.currentScene.add(spawnArea);					
					spot++;	
				}				
			}
		}		
				
		
		//Check to see if any of the spawn points intersects a wall or the spawner.  If so, remove it from the array and destroy it
		/*
		for point in spawnPoints
		{
			if collider.colliding == true
				remove it from the array and destroy its collider
		}*/		
	}
	
	this.updateSpawnTime = function()
	{
		var date = new Date();
		nextSpawnTime = date.getTime() + this.rate * 1000;
	}
	
	this.spawn = function() //change the properties of the enemy here. Sorry they aren't taken as parameters. I thought it did that.
	{
		// Check if any player is in range; don't spawn if there's no one around:
		if (this.checkIfPlayersInRange ()) {
			// Spawners gonna spawn:
			// fall through.
		} else {
			// If a tree crashes in the woods, and there is no one to observe it, does it still spawn?
			return;
		}
	
		var enemyMesh = new THREE.Mesh(new THREE.CubeGeometry(1,2,1),  new THREE.MeshPhongMaterial({ambient: 0xcccccc, color: 0x00ffff})); //swap mesh
		if(ENGINE.currentScene.assets.meshes[this.Model])
		{
			if(ENGINE.currentScene.assets.textures[this.Texture])
			{
				enemyMesh = new THREE.MorphAnimMesh(ENGINE.currentScene.assets.meshes[this.Model].geometry, new THREE.MeshLambertMaterial( {map: ENGINE.currentScene.assets.textures[this.Texture], morphTargets: true } ) );
			}
			else
			{
				enemyMesh = new THREE.MorphAnimMesh(ENGINE.currentScene.assets.meshes[this.Model].geometry, new THREE.MeshLambertMaterial( { color: 0x00ffff, morphTargets: true } ) );
			}	
			enemyMesh.scale.multiplyScalar(.02);	
		}

		//check for open spawn point		
		var tempSpot = this.checkSurrounding();		
		//set to the open spawn point
		enemyMesh.position = this.spawnPoints[tempSpot].position;	
		
		enemyMesh.name = "enemy " + this.hasSpawned;
		enemyMesh.tag = "enemy";
		
		enemyMesh.receiveShadow = true;
		enemyMesh.castShadow = true;
		
		
		this.spawn2(enemyMesh.position.x, enemyMesh.position.z, enemyMesh); //swap components
		this.hasSpawned++;
		//console.log(this.hasSpawned);
	}
	
	this.PLAYER_RANGE_SQUARED = 10.0 * 10.0;	// Used only if for some reason the camera was not found. See checkIfPlayersInRange ()

	this.checkIfPlayersInRange = function () {
		if (this.players.length == 0) {
			// Badly init'd; just return true.
			return true;
		}

		for(var i = 0; i < this.players.length; i++) {
			var p = this.players[i];
			var pChar = p.getComponent("playerChar");
			if(pChar!=null){
				if(pChar.alive)
				{	
					if (false && this.camera_tracker_component != null) {	// false forces the retarded range checking; because camera_tracker.IsOnScreen is broken
						if (this.camera_tracker_component.IsOnScreen (p)) {
							return true;
						}
					} else {
						// If for some reason the camera_tracker_component was not initialized, fall back to the retarded (hardcoded) range checking:
						var distX = this.gameObject.position.x - p.position.x;				
						var distZ = this.gameObject.position.z - p.position.z;

						dist = (distX * distX) + (distZ * distZ);

						if(dist < this.PLAYER_RANGE_SQUARED)
						{
							return true;
						}
					}
				}
			}
		}

		return false;
	}
	
	this.checkSurrounding = function(){
		// has 8 default spawn position (up, down, left and right)
		//checks them to see if they are open
		//if they are open spawn counter clockwise to the last position
		var spot = 0;
		
		if(this.lastSpawnPoint < 6){			
			this.lastSpawnPoint++;	
			/*var checkPoint = this.spawnPoints[this.lastSpawnPoint];			
			var collisionM = ENGINE.currentScene.scene.getChildByName("collisionManager").getComponent("collisionManager");
			var playerArray = ENGINE.currentScene.scene.getComponentsInChildren("playerChar");
			var enemyArray = ENGINE.currentScene.scene.getComponentsInChildren("enemyChar");
			
			
			
			for(var i=0; i < playerArray.length; i++){
				var checkPointCollide = checkPoint.getComponent("collider");
				var playerCollider = playerArray[i].gameObject.getComponent("collider");
				
				//collisionM rectangle collision / sphere collision			
			}*/
			
			
			
			spot = this.lastSpawnPoint;
		}
		else{
			this.lastSpawnPoint = 0;
		}
		
		return spot;
	}
	
	
	this.spawn2 = function(x, z, mesh)
	{
	
		mesh.name='enemy';
		mesh.addComponent(new collider("rectangle", 0,1,1,1, new Array("EnemySpawner")));
		mesh.addComponent(new RigidBody());
		mesh.addComponent(new enemyChar(this.enemyType,this));
		mesh.addComponent(new enemyMovement());	
		mesh.addComponent(new melee("enemy"));
		mesh.addComponent(new creatureAnimation(this.anim.paused, this.anim.walk, this.anim.fire, this.anim.die, this.anim.speed));
		
		mesh.components['enemyMovement'].players = this.players;
		
		if(this.isEverythingExample)
		{
			mesh.position = new THREE.Vector3(x + 3,0,z + 2);
		}
		else
			mesh.position = new THREE.Vector3(x,mesh.position.y,z);	
		
		ENGINE.currentScene.add(mesh);
	};
	
	
	this.destroy = function()
	{
		for(var i = 0; i < this.spawnPoints.length; i++)
		{
			ENGINE.currentScene.remove(this.spawnPoints[i]);
		}
	};
	
};
