/*
*This component will spawn a player when its trigger function (named "spawn") is called. 
*@author Aleks Litynski
*
*
*/

PLAYERS = new Array();

function PlayerSpawner(other, plyrs)
{
	
	this.type = "PlayerSpawner";
	this.playerChars = plyrs;
	this.hasSpawned = 0;
	this.playerModel = other.model;
	this.warriorTexture = other.warriorTexture;
	this.wizardTexture = other.wizardTexture;
	this.valkyrieTexture = other.valkyrieTexture;
	this.rangerTexture = other.rangerTexture;
	
	this.spawnButtons = new Array(6);
	this.inputUsed = new Array(6);
	this.spawning = new Array();
	
	this.keyPressed = new Array();
	this.hor = new Array();
	this.vert = new Array();
	
	this.init = function()
	{	
		/*console.log("init:");
		console.log(this.playerChars);
		*/
		this.spawnButtons[0] = 'keyboardRespawn1';
		this.spawnButtons[1] = 'keyboardRespawn2';
		this.spawnButtons[2] = 'gamepadRespawn1';
		this.spawnButtons[3] = 'gamepadRespawn2';
		this.spawnButtons[4] = 'gamepadRespawn3';
		this.spawnButtons[5] = 'gamepadRespawn4';
		
		this.inputUsed[0] = true;
		this.inputUsed[1] = false;
		this.inputUsed[2] = false;
		this.inputUsed[3] = false;
		this.inputUsed[4] = false;
		this.inputUsed[5] = false;
		
		for (var i = 0; i < 4; i++) {
			this.keyPressed[i] = false;
			this.hor[i] = 0;
			this.vert[i] = 0;
		}		
		
		//classes: 0 - Warrior, 1 - valkyrie, 2 - wizard, 3 - ranger
		this.spawn("keyboardLeft1", "keyboardRight1", "keyboardUp1", "keyboardDown1", "keyboardFire1", "keyboardMagic1", 1 , 0); //player 2 spawn
		//this.spawn("keyboardLeft2", "keyboardRight2", "keyboardUp2", "keyboardDown2", "keyboardFire2", "keyboardMagic2", 1 , 1);
		
		//Announce the welcome
		Audio.PlaySound(Audio.LevelSoundEnums[Audio.currentLevel-1].WELCOME,null);
		Audio.PlaySound(Audio.LevelSoundEnums[Audio.currentLevel-1].POS_TONE,null);
		
	};
	
	this.update = function()
	{
		for(var i = 0; i < this.spawnButtons.length; i++){
			
			if( ENGINE.Input.state(this.spawnButtons[i])){
				if(this.hasSpawned + this.spawning < 4 && !this.inputUsed[i]){
					this.inputUsed[i] = true;
					var temp = new Array(3);
					temp[0] = i;//input type
					temp[1] = 0;//class
					temp[2] = 0;//color  red,yellow,green,blue
					this.spawning.push(temp);
					console.log("spawning with input type : "+i);
				}
			}
		}
		for(var i = 0; i < this.spawning.length; i++){
			switch(this.spawning[i][0])
			{
				case 0:
					break;
				case 1:
					if(ENGINE.Input.pressed("keyboardLeft2"))
					{
						this.spawning[i][1] -=1;
						console.log("class : "+ Math.abs(this.spawning[i][1])%4);
					}
					else if(ENGINE.Input.pressed("keyboardRight2"))
					{
						this.spawning[i][1] +=1;
						console.log("class : "+ Math.abs(this.spawning[i][1])%4);
					}
					else if(ENGINE.Input.pressed("keyboardUp2"))
					{
						this.spawning[i][2] +=1;
						console.log("color : "+ Math.abs(this.spawning[i][2])%4);
					}
					else if(ENGINE.Input.pressed("keyboardDown2"))
					{
						this.spawning[i][2] -=1;
						console.log("color : "+ Math.abs(this.spawning[i][2])%4);
					}
					if(ENGINE.Input.pressed("keyboardFire2"))
					{
						this.spawn("keyboardLeft2", "keyboardRight2", "keyboardUp2", "keyboardDown2", "keyboardFire2", "keyboardMagic2", Math.abs(this.spawning[i][1])%4,Math.abs(this.spawning[i][2])%4);
						this.spawning.splice(i,1);
					}
					break;
				case 2:
					this.hor[0] = ENGINE.Input.state("gamepadRight1");
					this.vert[0] = ENGINE.Input.state("gamepadDown1");
					
					if(!this.keyPressed[0] && this.hor[0] != 0 && Math.abs(this.hor[0]) > Math.abs(this.vert[0]))
					{
						this.keyPressed[0] = true;
						this.spawning[i][1] += this.hor[0] > 0 ? 1 : -1;
						console.log("class : "+ Math.abs(this.spawning[i][1])%4);
					}
					else if(!this.keyPressed[0] && this.vert[0] != 0 && Math.abs(this.vert[0]) > Math.abs(this.hor[0]))
					{
						this.keyPressed[0] = true;
						this.spawning[i][2] -= this.vert[0] > 0 ? 1 : -1;
						console.log("color : "+ Math.abs(this.spawning[i][2])%4);
					} else if (this.hor[0] == 0 && this.vert[0] == 0){
						this.keyPressed[0] = false;
					}
					if (ENGINE.Input.state("gamepadFire1")) {
						this.keyPressed[0] = false;
						this.spawn("gamepadLeft1", "gamepadRight1", "gamepadUp1", "gamepadDown1", "gamepadFire1", "gamepadMagic1", this.spawning[i][1],this.spawning[i][2]);
						this.spawning.splice(i,1);
					}
					break;
				case 3:
					this.hor[1] = ENGINE.Input.state("gamepadRight2");
					this.vert[1] = ENGINE.Input.state("gamepadDown2");
					
					if(!this.keyPressed[1] && this.hor[1] != 0 && Math.abs(this.hor[1]) > Math.abs(this.vert[1]))
					{
						this.keyPressed[1] = true;
						this.spawning[i][1] += this.hor[1] > 0 ? 1 : -1;
						console.log("class : "+ Math.abs(this.spawning[i][1])%4);
					}
					else if(!this.keyPressed[1] && this.vert[1] != 0 && Math.abs(this.vert[1]) > Math.abs(this.hor[1]))
					{
						this.keyPressed[1] = true;
						this.spawning[i][2] -= this.vert[1] > 0 ? 1 : -1;
						console.log("color : "+ Math.abs(this.spawning[i][2])%4);
					} else if (this.hor[1] == 0 && this.vert[1] == 0){
						this.keyPressed[1] = false;
					}
					if (ENGINE.Input.state("gamepadFire2")) {
						this.keyPressed[1] = false;
						this.spawn("gamepadLeft2", "gamepadRight2", "gamepadUp2", "gamepadDown2", "gamepadFire2", "gamepadMagic2", this.spawning[i][1],this.spawning[i][2]);
						this.spawning.splice(i,1);
					}
					break;
				case 4:
					this.hor[2] = ENGINE.Input.state("gamepadRight3");
					this.vert[2] = ENGINE.Input.state("gamepadDown3");
					
					if(!this.keyPressed[2] && this.hor[2] != 0 && Math.abs(this.hor[2]) > Math.abs(this.vert[2]))
					{
						this.keyPressed[2] = true;
						this.spawning[i][1] += this.hor[2] > 0 ? 1 : -1;
						console.log("class : "+ Math.abs(this.spawning[i][1])%4);
					}
					else if(!this.keyPressed[2] && this.vert[2] != 0 && Math.abs(this.vert[2]) > Math.abs(this.hor[2]))
					{
						this.keyPressed[2] = true;
						this.spawning[i][2] -= this.vert[2] > 0 ? 1 : -1;
						console.log("color : "+ Math.abs(this.spawning[i][2])%4);
					} else if (this.hor[2] == 0 && this.vert[2] == 0){
						this.keyPressed[2] = false;
					}
					if (ENGINE.Input.state("gamepadFire3")) {
						this.keyPressed[2] = false;
						this.spawn("gamepadLeft1", "gamepadRight3", "gamepadUp3", "gamepadDown3", "gamepadFire3", "gamepadMagic3", this.spawning[i][1],this.spawning[i][2]);
						this.spawning.splice(i,1);
					}
					break;
				case 5:
					this.hor[3] = ENGINE.Input.state("gamepadRight4");
					this.vert[3] = ENGINE.Input.state("gamepadDown4");
					
					if(!this.keyPressed[3] && this.hor[3] != 0 && Math.abs(this.hor[3]) > Math.abs(this.vert[3]))
					{
						this.keyPressed[3] = true;
						this.spawning[i][1] += this.hor[3] > 0 ? 1 : -1;
						console.log("class : "+ Math.abs(this.spawning[i][1])%4);
					}
					else if(!this.keyPressed[3] && this.vert[3] != 0 && Math.abs(this.vert[3]) > Math.abs(this.hor[3]))
					{
						this.keyPressed[3] = true;
						this.spawning[i][2] -= this.vert[3] > 0 ? 1 : -1;
						console.log("color : "+ Math.abs(this.spawning[i][2])%4);
					} else if (this.hor[3] == 0 && this.vert[3] == 0){
						this.keyPressed[3] = false;
					}
					if (ENGINE.Input.state("gamepadFire4")) {
						this.keyPressed[3] = false;
						this.spawn("gamepadLeft4", "gamepadRight4", "gamepadUp4", "gamepadDown4", "gamepadFire4", "gamepadMagic4", this.spawning[i][1],this.spawning[i][2]);
						this.spawning.splice(i,1);
					}
					break;
			}
		}
	};
	
	this.spawn = function(left, right, up, down, fire, magic, spawnClass,color) //0=warrior, 1=valkyrie, 2=wizard, 3=archer   //0=0xff0000, 1=0x00ff00, 2=0x0000ff, 3=0xffff00
	{
		spawnClass = Math.abs(spawnClass);
		color = Math.abs(color);
		console.log(spawnClass + ", " + color);
	
		var playerMesh = new THREE.Mesh(new THREE.CubeGeometry(1,2,1),  new THREE.MeshPhongMaterial({ambient: 0xcccccc, color: 0x606060}));
		switch(color)
		{
			case 0: //red
				switch(spawnClass)
				{
					case 0://warrior
						playerMesh = new THREE.MorphAnimMesh(ENGINE.currentScene.assets.meshes["warrior"].geometry, new THREE.MeshLambertMaterial( {map: ENGINE.currentScene.assets.textures["rWarrior"], morphTargets: true } ) );
						playerMesh.scale.multiplyScalar(0.2); 
						playerMesh.position.y += 1;
					break;
					case 1://valkyrie
						playerMesh = new THREE.MorphAnimMesh(ENGINE.currentScene.assets.meshes["valkyre"].geometry, new THREE.MeshLambertMaterial( {map: ENGINE.currentScene.assets.textures["rValkyrie"], morphTargets: true } ) );
						playerMesh.scale.multiplyScalar(0.02); 
						playerMesh.position.y += 0.1;
					break;
					case 2://wizard
						playerMesh = new THREE.MorphAnimMesh(ENGINE.currentScene.assets.meshes["wizard"].geometry, new THREE.MeshLambertMaterial( {map: ENGINE.currentScene.assets.textures["rWizard"], morphTargets: true } ) );
						playerMesh.scale.multiplyScalar(0.02); 
						playerMesh.position.y += 0.1;
					break;
					case 3://archer
						playerMesh = new THREE.MorphAnimMesh(ENGINE.currentScene.assets.meshes["archer"].geometry, new THREE.MeshLambertMaterial( {map: ENGINE.currentScene.assets.textures["rArcher"], morphTargets: true } ) );
						playerMesh.scale.multiplyScalar(0.2); 
						playerMesh.position.y += 1;
					break;
				}
			break;
			case 1://green
				switch(spawnClass)
				{
					case 0://warrior
						playerMesh = new THREE.MorphAnimMesh(ENGINE.currentScene.assets.meshes["warrior"].geometry, new THREE.MeshLambertMaterial( {map: ENGINE.currentScene.assets.textures["gWarrior"], morphTargets: true } ) );
						playerMesh.scale.multiplyScalar(0.2); 
						playerMesh.position.y += 1;
					break;
					case 1://valkyrie
						playerMesh = new THREE.MorphAnimMesh(ENGINE.currentScene.assets.meshes["valkyre"].geometry, new THREE.MeshLambertMaterial( {map: ENGINE.currentScene.assets.textures["gValkyrie"], morphTargets: true } ) );
						playerMesh.scale.multiplyScalar(0.02); 
						playerMesh.position.y += 0.1;
					break;
					case 2://wizard
						playerMesh = new THREE.MorphAnimMesh(ENGINE.currentScene.assets.meshes["wizard"].geometry, new THREE.MeshLambertMaterial( {map: ENGINE.currentScene.assets.textures["gWizard"], morphTargets: true } ) );
						playerMesh.scale.multiplyScalar(0.02); 
						playerMesh.position.y += 0.1;
					break;
					case 3://archer
						playerMesh = new THREE.MorphAnimMesh(ENGINE.currentScene.assets.meshes["archer"].geometry, new THREE.MeshLambertMaterial( {map: ENGINE.currentScene.assets.textures["gArcher"], morphTargets: true } ) );
						playerMesh.scale.multiplyScalar(0.2); 
						playerMesh.position.y += 1;
					break;
				}
			break;
			case 2://blue
				switch(spawnClass)
				{
					case 0://warrior
						playerMesh = new THREE.MorphAnimMesh(ENGINE.currentScene.assets.meshes["warrior"].geometry, new THREE.MeshLambertMaterial( {map: ENGINE.currentScene.assets.textures["bWarrior"], morphTargets: true } ) );	
						playerMesh.scale.multiplyScalar(0.2); 
						playerMesh.position.y += 1;
					break;
					case 1://valkyrie
						playerMesh = new THREE.MorphAnimMesh(ENGINE.currentScene.assets.meshes["valkyre"].geometry, new THREE.MeshLambertMaterial( {map: ENGINE.currentScene.assets.textures["bValkyrie"], morphTargets: true } ) );
						playerMesh.scale.multiplyScalar(0.02); 
						playerMesh.position.y += 0.1;
					break;
					case 2://wizard
						playerMesh = new THREE.MorphAnimMesh(ENGINE.currentScene.assets.meshes["wizard"].geometry, new THREE.MeshLambertMaterial( {map: ENGINE.currentScene.assets.textures["bWizard"], morphTargets: true } ) );
						playerMesh.scale.multiplyScalar(0.02); 
						playerMesh.position.y += 0.1;
					break;
					case 3://archer
						playerMesh = new THREE.MorphAnimMesh(ENGINE.currentScene.assets.meshes["archer"].geometry, new THREE.MeshLambertMaterial( {map: ENGINE.currentScene.assets.textures["bArcher"], morphTargets: true } ) );
						playerMesh.scale.multiplyScalar(0.2); 
						playerMesh.position.y += 1;
					break;
				}
			break;
			case 3://yellow
				switch(spawnClass)
				{
					case 0://warrior
						playerMesh = new THREE.MorphAnimMesh(ENGINE.currentScene.assets.meshes["warrior"].geometry, new THREE.MeshLambertMaterial( {map: ENGINE.currentScene.assets.textures["yWarrior"], morphTargets: true } ) );	
						playerMesh.scale.multiplyScalar(0.2); 
						playerMesh.position.y += 1;
					break;
					case 1://valkyrie
						playerMesh = new THREE.MorphAnimMesh(ENGINE.currentScene.assets.meshes["valkyre"].geometry, new THREE.MeshLambertMaterial( {map: ENGINE.currentScene.assets.textures["yValkyrie"], morphTargets: true } ) );
						playerMesh.scale.multiplyScalar(0.02); 
						playerMesh.position.y += 0.1;
					break;
					case 2://wizard
						playerMesh = new THREE.MorphAnimMesh(ENGINE.currentScene.assets.meshes["wizard"].geometry, new THREE.MeshLambertMaterial( {map: ENGINE.currentScene.assets.textures["yWizard"], morphTargets: true } ) );
						playerMesh.scale.multiplyScalar(0.02); 
						playerMesh.position.y += 0.1;
					break;
					case 3://archer
						playerMesh = new THREE.MorphAnimMesh(ENGINE.currentScene.assets.meshes["archer"].geometry, new THREE.MeshLambertMaterial( {map: ENGINE.currentScene.assets.textures["yArcher"], morphTargets: true } ) );
						playerMesh.scale.multiplyScalar(0.2); 
						playerMesh.position.y += 1;
					break;
				}
			break;
			
		}
		
		
		if(ENGINE.currentScene.assets.meshes[this.playerModel])
		{
			var textureName;
			switch(spawnClass)
			{
				case 0:
					textureName = this.warriorTexture;
					break;
				case 1:
					textureName = this.valkyrieTexture;
					break;
				case 2:
					textureName = this.wizardTexture;
					break;
				case 3:
					textureName = this.rangerTexture;
					break;
			}
			
			
			if(ENGINE.currentScene.assets.textures[textureName])
			{
				playerMesh = new THREE.MorphAnimMesh(ENGINE.currentScene.assets.meshes[this.playerModel].geometry, new THREE.MeshLambertMaterial( {map: ENGINE.currentScene.assets.textures[textureName], morphTargets: true } ) );
			}
			else
			{
				playerMesh = new THREE.MorphAnimMesh(ENGINE.currentScene.assets.meshes[this.playerModel].geometry, new THREE.MeshLambertMaterial( { color: 0x606060, morphTargets: true } ) );
			}	
			playerMesh.scale.multiplyScalar(.02);	
		}
		
		
		playerMesh.position.y += .2;
		playerMesh.castShadow = true;
		playerMesh.receiveShadow = true;
		
		var animator = new creatureAnimation(0, 0, 0, 0);
		switch(spawnClass)
		{
			case 0://warrior
				animator = new creatureAnimation(0, {start:0,stop:47}, {start:47,stop:66}, {start:76,stop:120}, 35);
			break;
			case 1://valkyrie
				animator = new creatureAnimation(0, {start:0,stop:32}, {start:32,stop:57}, {start:84,stop:113}, 40);
			break;
			case 2://wizard
				animator = new creatureAnimation(0, {start:0,stop:23}, {start:47,stop:70}, {start:71,stop:86}, 40);
			break;
			case 3://archer
				animator = new creatureAnimation(0, {start:0,stop:63}, {start:65,stop:109}, {start:110,stop:128}, 100);
			break;
		}
		animator.init();
		
		//setup audioPlayer and get correct playerChar
		var currPlayerChar
		var attack_enum;
		
		switch(spawnClass)
		{
			case 0:
					attack_enum = Audio.LevelSoundEnums[Audio.currentLevel-1].ATTACK_WARRIOR;
					break;
			case 1:
					attack_enum = Audio.LevelSoundEnums[Audio.currentLevel-1].ATTACK_VALKRIE;
					break;
					
			case 2: 
					attack_enum = Audio.LevelSoundEnums[Audio.currentLevel-1].ATTACK_WIZARD;
					break;
					
			case 3:
					attack_enum = Audio.LevelSoundEnums[Audio.currentLevel-1].ATTACK_ELF;
					break;
			default:
					break;
		}
		
		
		if(this.playerChars)
		{
			for(var i = 0; i < this.playerChars.length; i++)
			{
				if(fire == this.playerChars[i].fireControl)
				{
					currPlayerChar = this.playerChars[i];
					break;
				}
			}
		}

		var audioPlayer = new AudioPlayer([[attack_enum],[Audio.LevelSoundEnums[Audio.currentLevel-1].HIT1,Audio.LevelSoundEnums[Audio.currentLevel-1].HIT2,Audio.LevelSoundEnums[Audio.currentLevel-1].HIT3,Audio.LevelSoundEnums[Audio.currentLevel-1].OW],[],[],[Audio.LevelSoundEnums[Audio.currentLevel-1].DIE]],playerMesh);
		
		//check if just loading new level
		if(this.playerChars)
			var playerComp = [new playerMovement(left, right, up, down, 6), new PlayerMagic(magic), currPlayerChar, new playerShooter(fire), new collider("rectangle",.7,0.7,3, 0.7), new RigidBody(), new melee("player"),animator,audioPlayer, new particles()]; //swap out for the components you need
		else
			var playerComp = [new playerMovement(left, right, up, down, 6), new PlayerMagic(magic), new playerChar(spawnClass,color), new playerShooter(fire), new collider("rectangle",.7,0.7,3, 0.7), new RigidBody(), new melee("player"), animator,audioPlayer, new particles()];
		
		playerMesh.name = "player " + this.hasSpawned;
		
		
		if(this.hasSpawned == 1)
		{
			spawn(this.gameObject.position.x, this.gameObject.position.z + this.hasSpawned * 3, playerMesh, playerComp);
		}
		else
		{
			spawn(this.gameObject.position.x + 3, this.gameObject.position.z, playerMesh, playerComp);
		}
		this.hasSpawned += 1;
		
		
	};
	
	function spawn(x, z, mesh, components)
	{
		mesh.position = new THREE.Vector3(x,mesh.position.y,z);
		
		for(var comp in components)
		{
			mesh.addComponent(components[comp]);
		}

		ENGINE.currentScene.add(mesh);
		mesh.tag = "player";
		
		
		
		ENGINE.currentScene.mainCamera.components["CAMERTRACKER_CP"].addLookAt(mesh);
		
		var purgatory = ENGINE.currentScene.scene.getChildByName("purgatory").getComponent("purgatory");
		purgatory.addSoul(mesh);
		
	};
	
	this.respawn = function(m, c)
	{
		spawn(m.position.x, m.position.z, m, c);
	};
	
};
