// Component for Rigidbody

var RigidBody = function(mass, inertia, collider){

	this.type = 'RigidBody';
	
	// Public
	this.velocity = new THREE.Vector3(0,0,0);
	this.angularVelocity = new THREE.Vector3(0,0,0);
	
	// Default Values
	this.mass = 1;
	this.inertia = new THREE.Vector3(1,1,1);
	this.collider = null;
	
	// Parameterized Values
	if(mass)
		this.mass = mass;
	if(inertia)
		this.inertia = inertia;
	if(collider)
		this.collider = collider;


	// Private
	this._netForce = new THREE.Vector3(0,0,0);
	this._netTorque = new THREE.Vector3(0,0,0);
	
	this._setPosition = null;
	this._setRotation = null;
	
	this.init = function(){
		// If a collider is already attached, set our reference to it
		this.collider = this.gameObject.getComponent('collider');  // Hopefully this is null and not undefined
	};
	
	this.addForce = function(force){
		this._netForce.add(force);
	};
	this.addTorque = function(torque){
		this._netTorque.add(torque);
	};
	this.setPosition = function(position){
		this._setPosition = position;
	};
	this.setRotation = function(rotation){
		this._setRotation =rotation;
	};
}
