// Component for Animator

var Animator2 = function () {

	this.isPlaying = false;
	this.nowPlaying = "";

	this.weight = 0.0;
	this.WEIGHT_INC = 0.01;

	this.currSkin = 0;
	this.nextSkin = 1;

	this.animType = "MORF";		// or "KEYF"


	this.type = "ANIMATOR_CP";			// CHANGE THIS !


	/*
	   Initializes the Animator component to be added to an Object3D
	 */
	this.init = function(){
		this.progress = 0;
	};


	/*
	   Updates the current state of the component - plays any running animations
	   @param {...Number} gameTime - the current game time
	 */
	this.update = function() {
		if (!this.isPlaying) {
			return;
		}

		gameTime = ENGINE.GameTime.timeSinceSceneLoad ();

		this.skin = this.gameObject;


		for ( var i = 0; i < this.skin.morphTargetInfluences.length; i++ ) {
			this.skin.morphTargetInfluences[i] = 0;
		}

		this.weight = this.weight + this.animProperties.animSpeed * this.WEIGHT_INC;
		this.skin.morphTargetInfluences [this.currSkin] = 1 - this.weight;
		this.skin.morphTargetInfluences [this.nextSkin] = this.weight;
		if (this.weight >= 1.0) {
			// advance to next pair of frames (morph targets)
			this.weight = 0.0;
			this.skin.morphTargetInfluences [this.currSkin] = 0.0;
			this.skin.morphTargetInfluences [this.nextSkin] = 1.0;

			this.currSkin = this.currSkin + 1 + this.animProperties.animSpeedCoarse;
			this.nextSkin = this.nextSkin + 1 + this.animProperties.animSpeedCoarse;

			// loop around
			if (this.currSkin >= this.animProperties.END_SKIN) {
				if (!this.animProperties.loop) {
					this.isPlaying = false;
				} else {
					this.currSkin = this.animProperties.BEGIN_SKIN;
				}
			}
			if (this.nextSkin >= this.animProperties.END_SKIN) {
				if (!this.animProperties.loop) {
					this.isPlaying = false;
				} else {
					this.nextSkin = this.animProperties.BEGIN_SKIN;
				}
			}
		}


		return;
	};

	/*
	   Removes this component
	 */
	this.destroy = function() {

	};


	/*
	   Set the current animation
	 */
	this.playAnimation = function (anim) {
		if (this.isPlaying && this.nowPlaying == anim) {
			return;
		}

		if (anim == "swim_cycle") {
			this.animProperties = {
				"BEGIN_SKIN":2,
				"END_SKIN":4,
				"animSpeed":1.0,
				"animSpeedCoarse":5
			};

			this.currSkin = this.animProperties.BEGIN_SKIN;
			this.nextSkin = this.currSkin + 1;

			this.isPlaying = true;
		} else if (anim == "jump_cycle") {
			this.animProperties = {
				"BEGIN_SKIN":5,
				"END_SKIN":10,
				"animSpeed":1.0,
				"animSpeedCoarse":5
			};

			this.currSkin = this.animProperties.BEGIN_SKIN;
			this.nextSkin = this.currSkin + 1;

			this.isPlaying = true;
		} else if (anim == "walk_cycle") {
			this.animProperties = {
				"BEGIN_SKIN":1,
				"END_SKIN":120,
				"loop":true,
				"animSpeed":80.0,
				"animSpeedCoarse":7
			};

			this.currSkin = this.animProperties.BEGIN_SKIN;
			this.nextSkin = this.currSkin + 1;

			this.isPlaying = true;
		} else if (anim == "throw_cycle") {
			this.animProperties = {
				"BEGIN_SKIN":122,
				"END_SKIN":156,
				"loop": false,
				"animSpeed":6.0,
				"animSpeedCoarse":0
			};
			console.log ("came here to throw cycle");

			this.currSkin = this.animProperties.BEGIN_SKIN;
			this.nextSkin = this.currSkin + 1;

			this.isPlaying = true;
		}


		this.nowPlaying = anim;
	}

	/*
	   Resume paused animation
	 */
	this.resumeAnimation = function () {
		this.isPlaying = true;
	}

	/*
	   Pause the current animation
	 */
	this.pauseAnimation = function () {
		this.isPlaying = false;
	}

	/*
	   Stop the current animation
	 */
	this.stopAnimation = function () {
		if (!this.isPlaying) {
			return;
		}

		this.isPlaying = false;

		if (this.animType == "MORF") {
			for ( var i = 0; i < this.skin.morphTargetInfluences.length; i++ ) {
				this.skin.morphTargetInfluences[i] = 0;
			}
		}
	}


};
