// Component for Collision
//ign is an array of strings of th component names to ignore collision for
var collider = function(bType, bRadius, width, height, depth, ign, ignRes)
{
	this.type = "collider";
	this.colliding = false;
	this.contacts = new Array();
	this.inBins = new Array();
	this.ignores = new Array();
	this.ignoreResponse = new Array();
	if(ign)
		this.ignores = ign;
	if(ignRes)
		this.ignoreResponse = ignRes;
	//the index for collisionManager
	this.index = -1;
	this.boundWidth = width;
	this.boundHeight = height;
	this.boundDepth = depth;
	this.boundRadius = bRadius;
	this.boundType;
	if(bType)
	{
		this.boundType = bType;
	}
	else
	{
		this.boundType = "rectangle";
	}
	
	
	this.update = function() {
		
			//console.log(ENGINE.currentScene.findByTag("wall").length);
	};	
	
	/*
	Initiates the collider component to be added to an Object 3D
	*/
	this.init = function(){
	
		var collisionManager = ENGINE.currentScene.scene.getChildByName("collisionManager").getComponent("collisionManager").addCollidable(this);
		// If a rigidbody is already attached, set it's collider to this
		var rigidBody = this.gameObject.getComponent('RigidBody');
		if(rigidBody)
		{
			rigidBody.collider = this;
		}
		/*
		DEBUG DRAW
		*/
		/*var debugMesh = new THREE.Mesh(new THREE.CubeGeometry(this.boundWidth, this.boundHeight, this.boundDepth), //new THREE.MeshPhongMaterial()
										new THREE.MeshBasicMaterial( { color: 0xffffff, wireframe: true}));
		debugMesh.name = "collider " + this.gameObject.name;
		debugMesh.position = this.gameObject.position;
        ENGINE.currentScene.scene.add(debugMesh);*/
		
		//console.log(ENGINE.currentScene.scene.getChildByName("collisionManager").getComponent("collisionManager").collidables[0].length);
	};
	
	this.debugDraw = function()
	{
		var debugMesh = new THREE.Mesh(new THREE.CubeGeometry(this.boundWidth, this.boundHeight, this.boundDepth), //new THREE.MeshPhongMaterial()
										new THREE.MeshBasicMaterial( { color: 0xffffff, wireframe: true}));
		debugMesh.name = "collider " + this.gameObject.name;
		debugMesh.position = this.gameObject.position;
        ENGINE.currentScene.scene.add(debugMesh);
	}
	
	this.clearContacts = function()
	{
		this.contacts = new Array();
		this.colliding = false;
	};

	/*
		Removes this component
	*/
	this.destroy = function() {
		//console.log("collider destroyed: " + this.gameObject.tag);
		var cm = ENGINE.currentScene.scene.getChildByName("collisionManager");
		cm = cm.getComponent("collisionManager")
		cm.removeCollidable(this.index);
		
	};
	
	// Only use these on a box collider. TODO: make work with a sphere collider
	this.min = function() {
		
		return new THREE.Vector3(this.gameObject.position.x - this.boundWidth/2,
								 this.gameObject.position.y - this.boundHeight/2,
								 this.gameObject.position.z - this.boundDepth/2);
	};
	
	this.max = function() {
		
		return new THREE.Vector3(this.gameObject.position.x + this.boundWidth/2,
								 this.gameObject.position.y + this.boundHeight/2,
								 this.gameObject.position.z + this.boundDepth/2);
	};
}
