//enemy
/*
*This is an enemy. It finds the player and moves towards them. up to within a certain radius
*@author Aleks Litynski
*
*@param {desiredRadius} This is the closest the enemy will try to get to the player
*/
var enemyMovement = function()
{
	this.lastTarget = {x:0,y:0,z:0};
	this.type = "enemyMovement";
	this.speed;
	this.players = [];
	this.prevMove = {};
	
	this.init = function()
	{
		this.speed = this.gameObject.getComponent("enemyChar").speed;
	}

	this.update = function()
	{
		//var isOnScreen = ENGINE.currentScene.mainCamera.getComponent("CAMERTRACKER_CP").IsOnScreen(this.gameObject);
		//Check if its on screen or colliding
		
		if(!this.players)
			console.log("no player");
		
		if(this.gameObject.getComponent("collider").colliding)
		{
			this.gameObject.position.x -= (this.prevMove.x);
			this.gameObject.position.z -= (this.prevMove.z);
		}
		
		this.prevMove.x = 0;
		this.prevMove.z = 0;
		
		var currentPos = new THREE.Vector3(this.gameObject.position.x, 0, this.gameObject.position.z);

		var diff = this.getTarget().sub(currentPos);

		//this.prevMove.x = -diff.x * this.speed;
		//this.prevMove.z = -diff.z * this.speed;
		
		
		//this.gameObject.position.x += this.prevMove.x;
		//this.gameObject.position.z += this.prevMove.z;
		this.gameObject.getComponent("RigidBody").velocity = diff.normalize().multiplyScalar(this.speed);
	
		// Check if the player is moving
		moving = !this.gameObject.getComponent('RigidBody').velocity.equals(new THREE.Vector3(0, 0, 0));
		
		if(moving)
		{
			this.gameObject.components.creatureAnimation.playWalk();
				this.gameObject.rotation = /*.getComponent('RigidBody').setRotation(*/
					new THREE.Vector3(
						0,
						Math.atan2(-this.gameObject.getComponent('RigidBody').velocity.z, 
								   this.gameObject.getComponent('RigidBody').velocity.x) - Math.PI/2,
						0
					)
				/*)*/;
		}
		else
		{
			if(this.gameObject.components.creatureAnimation.anim == "walk")
			{
				this.gameObject.components.creatureAnimation.stopAnimation();
			}
		}
		//console.log("end of enemy movement");
		
	};
	
	this.getTarget = function()
	{
		var dist;
		var prevDist = Number.MAX_VALUE;
		var curPlayers = this.players;
		var currPlayer;
		
		for(var i = 0; i < curPlayers.length; i++)
		{
			var p = curPlayers[i];
			var pChar = p.getComponent("playerChar");
			if(pChar!=null){
				if(pChar.alive)
				{	
					var distX = this.gameObject.position.x - p.position.x;				
					var distZ = this.gameObject.position.z - p.position.z;
					
					dist = (distX * distX) + (distZ * distZ);
					
					if(dist < prevDist)
					{
						currPlayer = curPlayers[i];
						prevDist = dist;
					}
				}
			}
		}
		
		var toReturn = this.lastTarget;
		
		if(currPlayer)
		{
			toReturn = currPlayer.position;
			this.lastTarget = toReturn;
		}
		
		return new THREE.Vector3(toReturn.x, 0, toReturn.z);
	};
	
	
	this.destroy = function()
	{
		this.gameObject.removeComponent(this.type);
	};
};
