/**
 * @author mrdoob / http://mrdoob.com/
 * @author Larry Battle / http://bateru.com/news
 */

var THREE = THREE || { REVISION: '55-motherfucking-awesome-version' };

self.console = self.console || {

	info: function () {},
	log: function () {},
	debug: function () {},
	warn: function () {},
	error: function () {}

};

self.Int32Array = self.Int32Array || Array;
self.Float32Array = self.Float32Array || Array;

// Shims for "startsWith", "endsWith", and "trim" for browsers where this is not yet implemented
// not sure we should have this, or at least not have it here

// http://stackoverflow.com/questions/646628/javascript-startswith
// http://stackoverflow.com/questions/498970/how-do-i-trim-a-string-in-javascript
// http://wiki.ecmascript.org/doku.php?id=harmony%3astring_extras

String.prototype.startsWith = String.prototype.startsWith || function ( str ) {

	return this.slice( 0, str.length ) === str;

};

String.prototype.endsWith = String.prototype.endsWith || function ( str ) {

	var t = String( str );
	var index = this.lastIndexOf( t );
	return ( -1 < index && index ) === (this.length - t.length);

};

String.prototype.trim = String.prototype.trim || function () {

	return this.replace( /^\s+|\s+$/g, '' );

};


// http://paulirish.com/2011/requestanimationframe-for-smart-animating/
// http://my.opera.com/emoller/blog/2011/12/20/requestanimationframe-for-smart-er-animating

// requestAnimationFrame polyfill by Erik Mller
// fixes from Paul Irish and Tino Zijdel

( function () {

	var lastTime = 0;
	var vendors = [ 'ms', 'moz', 'webkit', 'o' ];

	for ( var x = 0; x < vendors.length && !window.requestAnimationFrame; ++ x ) {

		window.requestAnimationFrame = window[ vendors[ x ] + 'RequestAnimationFrame' ];
		window.cancelAnimationFrame = window[ vendors[ x ] + 'CancelAnimationFrame' ] || window[ vendors[ x ] + 'CancelRequestAnimationFrame' ];

	}

	if ( window.requestAnimationFrame === undefined ) {

		window.requestAnimationFrame = function ( callback, element ) {

			var currTime = Date.now(), timeToCall = Math.max( 0, 16 - ( currTime - lastTime ) );
			var id = window.setTimeout( function() { callback( currTime + timeToCall ); }, timeToCall );
			lastTime = currTime + timeToCall;
			return id;

		};

	}

	window.cancelAnimationFrame = window.cancelAnimationFrame || function ( id ) { window.clearTimeout( id ) };

}() );

// GL STATE CONSTANTS

THREE.CullFaceNone = 0;
THREE.CullFaceBack = 1;
THREE.CullFaceFront = 2;
THREE.CullFaceFrontBack = 3;

THREE.FrontFaceDirectionCW = 0;
THREE.FrontFaceDirectionCCW = 1;

// SHADOWING TYPES

THREE.BasicShadowMap = 0;
THREE.PCFShadowMap = 1;
THREE.PCFSoftShadowMap = 2;

// MATERIAL CONSTANTS

// side

THREE.FrontSide = 0;
THREE.BackSide = 1;
THREE.DoubleSide = 2;

// shading

THREE.NoShading = 0;
THREE.FlatShading = 1;
THREE.SmoothShading = 2;

// colors

THREE.NoColors = 0;
THREE.FaceColors = 1;
THREE.VertexColors = 2;

// blending modes

THREE.NoBlending = 0;
THREE.NormalBlending = 1;
THREE.AdditiveBlending = 2;
THREE.SubtractiveBlending = 3;
THREE.MultiplyBlending = 4;
THREE.CustomBlending = 5;

// custom blending equations
// (numbers start from 100 not to clash with other
//  mappings to OpenGL constants defined in Texture.js)

THREE.AddEquation = 100;
THREE.SubtractEquation = 101;
THREE.ReverseSubtractEquation = 102;

// custom blending destination factors

THREE.ZeroFactor = 200;
THREE.OneFactor = 201;
THREE.SrcColorFactor = 202;
THREE.OneMinusSrcColorFactor = 203;
THREE.SrcAlphaFactor = 204;
THREE.OneMinusSrcAlphaFactor = 205;
THREE.DstAlphaFactor = 206;
THREE.OneMinusDstAlphaFactor = 207;

// custom blending source factors

//THREE.ZeroFactor = 200;
//THREE.OneFactor = 201;
//THREE.SrcAlphaFactor = 204;
//THREE.OneMinusSrcAlphaFactor = 205;
//THREE.DstAlphaFactor = 206;
//THREE.OneMinusDstAlphaFactor = 207;
THREE.DstColorFactor = 208;
THREE.OneMinusDstColorFactor = 209;
THREE.SrcAlphaSaturateFactor = 210;


// TEXTURE CONSTANTS

THREE.MultiplyOperation = 0;
THREE.MixOperation = 1;
THREE.AddOperation = 2;

// Mapping modes

THREE.UVMapping = function () {};

THREE.CubeReflectionMapping = function () {};
THREE.CubeRefractionMapping = function () {};

THREE.SphericalReflectionMapping = function () {};
THREE.SphericalRefractionMapping = function () {};

// Wrapping modes

THREE.RepeatWrapping = 1000;
THREE.ClampToEdgeWrapping = 1001;
THREE.MirroredRepeatWrapping = 1002;

// Filters

THREE.NearestFilter = 1003;
THREE.NearestMipMapNearestFilter = 1004;
THREE.NearestMipMapLinearFilter = 1005;
THREE.LinearFilter = 1006;
THREE.LinearMipMapNearestFilter = 1007;
THREE.LinearMipMapLinearFilter = 1008;

// Data types

THREE.UnsignedByteType = 1009;
THREE.ByteType = 1010;
THREE.ShortType = 1011;
THREE.UnsignedShortType = 1012;
THREE.IntType = 1013;
THREE.UnsignedIntType = 1014;
THREE.FloatType = 1015;

// Pixel types

//THREE.UnsignedByteType = 1009;
THREE.UnsignedShort4444Type = 1016;
THREE.UnsignedShort5551Type = 1017;
THREE.UnsignedShort565Type = 1018;

// Pixel formats

THREE.AlphaFormat = 1019;
THREE.RGBFormat = 1020;
THREE.RGBAFormat = 1021;
THREE.LuminanceFormat = 1022;
THREE.LuminanceAlphaFormat = 1023;

// Compressed texture formats

THREE.RGB_S3TC_DXT1_Format = 2001;
THREE.RGBA_S3TC_DXT1_Format = 2002;
THREE.RGBA_S3TC_DXT3_Format = 2003;
THREE.RGBA_S3TC_DXT5_Format = 2004;

/*
// Potential future PVRTC compressed texture formats
THREE.RGB_PVRTC_4BPPV1_Format = 2100;
THREE.RGB_PVRTC_2BPPV1_Format = 2101;
THREE.RGBA_PVRTC_4BPPV1_Format = 2102;
THREE.RGBA_PVRTC_2BPPV1_Format = 2103;
*/
/**
 * @author mrdoob / http://mrdoob.com/
 */

THREE.Color = function ( value ) {

	if ( value !== undefined ) this.set( value );

	return this;

};

THREE.Color.prototype = {

	constructor: THREE.Color,

	r: 1, g: 1, b: 1,


	set: function ( value ) {

		switch ( typeof value ) {

			case "number":
				this.setHex( value );
				break;

			case "string":
				this.setStyle( value );
				break;

		}

	},

	setHex: function ( hex ) {

		hex = Math.floor( hex );

		this.r = ( hex >> 16 & 255 ) / 255;
		this.g = ( hex >> 8 & 255 ) / 255;
		this.b = ( hex & 255 ) / 255;

		return this;

	},

	setRGB: function ( r, g, b ) {

		this.r = r;
		this.g = g;
		this.b = b;

		return this;

	},

	setHSV: function ( h, s, v ) {

		// based on MochiKit implementation by Bob Ippolito
		// h,s,v ranges are < 0.0 - 1.0 >

		var i, f, p, q, t;

		if ( v === 0 ) {

			this.r = this.g = this.b = 0;

		} else {

			i = Math.floor( h * 6 );
			f = ( h * 6 ) - i;
			p = v * ( 1 - s );
			q = v * ( 1 - ( s * f ) );
			t = v * ( 1 - ( s * ( 1 - f ) ) );

			if ( i === 0 ) {

				this.r = v;
				this.g = t;
				this.b = p;

			} else if ( i === 1 ) {

				this.r = q;
				this.g = v;
				this.b = p;

			} else if ( i === 2 ) {

				this.r = p;
				this.g = v;
				this.b = t;

			} else if ( i === 3 ) {

				this.r = p;
				this.g = q;
				this.b = v;

			} else if ( i === 4 ) {

				this.r = t;
				this.g = p;
				this.b = v;

			} else if ( i === 5 ) {

				this.r = v;
				this.g = p;
				this.b = q;

			}

		}

		return this;

	},

	setStyle: function ( style ) {

		// rgb(255,0,0)

		if ( /^rgb\((\d+),(\d+),(\d+)\)$/i.test( style ) ) {

			var color = /^rgb\((\d+),(\d+),(\d+)\)$/i.exec( style );

			this.r = Math.min( 255, parseInt( color[ 1 ], 10 ) ) / 255;
			this.g = Math.min( 255, parseInt( color[ 2 ], 10 ) ) / 255;
			this.b = Math.min( 255, parseInt( color[ 3 ], 10 ) ) / 255;

			return this;

		}

		// rgb(100%,0%,0%)

		if ( /^rgb\((\d+)\%,(\d+)\%,(\d+)\%\)$/i.test( style ) ) {

			var color = /^rgb\((\d+)\%,(\d+)\%,(\d+)\%\)$/i.exec( style );

			this.r = Math.min( 100, parseInt( color[ 1 ], 10 ) ) / 100;
			this.g = Math.min( 100, parseInt( color[ 2 ], 10 ) ) / 100;
			this.b = Math.min( 100, parseInt( color[ 3 ], 10 ) ) / 100;

			return this;

		}

		// #ff0000

		if ( /^\#([0-9a-f]{6})$/i.test( style ) ) {

			var color = /^\#([0-9a-f]{6})$/i.exec( style );

			this.setHex( parseInt( color[ 1 ], 16 ) );

			return this;

		}

		// #f00

		if ( /^\#([0-9a-f])([0-9a-f])([0-9a-f])$/i.test( style ) ) {

			var color = /^\#([0-9a-f])([0-9a-f])([0-9a-f])$/i.exec( style );

			this.setHex( parseInt( color[ 1 ] + color[ 1 ] + color[ 2 ] + color[ 2 ] + color[ 3 ] + color[ 3 ], 16 ) );

			return this;

		}

		// red

		if ( /^(\w+)$/i.test( style ) ) {

			this.setHex( THREE.ColorKeywords[ style ] );

			return this;

		}


	},

	copy: function ( color ) {

		this.r = color.r;
		this.g = color.g;
		this.b = color.b;

		return this;

	},

	copyGammaToLinear: function ( color ) {

		this.r = color.r * color.r;
		this.g = color.g * color.g;
		this.b = color.b * color.b;

		return this;

	},

	copyLinearToGamma: function ( color ) {

		this.r = Math.sqrt( color.r );
		this.g = Math.sqrt( color.g );
		this.b = Math.sqrt( color.b );

		return this;

	},

	convertGammaToLinear: function () {

		var r = this.r, g = this.g, b = this.b;

		this.r = r * r;
		this.g = g * g;
		this.b = b * b;

		return this;

	},

	convertLinearToGamma: function () {

		this.r = Math.sqrt( this.r );
		this.g = Math.sqrt( this.g );
		this.b = Math.sqrt( this.b );

		return this;

	},

	getHex: function () {

		return ( this.r * 255 ) << 16 ^ ( this.g * 255 ) << 8 ^ ( this.b * 255 ) << 0;

	},

	getHexString: function () {

		return ( '000000' + this.getHex().toString( 16 ) ).slice( - 6 );

	},

	getStyle: function () {

		return 'rgb(' + ( ( this.r * 255 ) | 0 )  + ',' + ( ( this.g * 255 ) | 0 ) + ',' + ( ( this.b * 255 ) | 0 ) + ')';

	},

	getHSV: function ( hsv ) {

		// based on MochiKit implementation by Bob Ippolito
		// h,s,v ranges are < 0.0 - 1.0 >

		var r = this.r;
		var g = this.g;
		var b = this.b;

		var max = Math.max( Math.max( r, g ), b );
		var min = Math.min( Math.min( r, g ), b );

		var hue;
		var saturation;
		var value = max;

		if ( min === max )	{

			hue = 0;
			saturation = 0;

		} else {

			var delta = ( max - min );
			saturation = delta / max;

			if ( r === max ) {

				hue = ( g - b ) / delta;

			} else if ( g === max ) {

				hue = 2 + ( ( b - r ) / delta );

			} else	{

				hue = 4 + ( ( r - g ) / delta );
			}

			hue /= 6;

			if ( hue < 0 ) {

				hue += 1;

			}

			if ( hue > 1 ) {

				hue -= 1;

			}

		}

		if ( hsv === undefined ) {

			hsv = { h: 0, s: 0, v: 0 };

		}

		hsv.h = hue;
		hsv.s = saturation;
		hsv.v = value;

		return hsv;

	},

	add: function ( color ) {

		this.r += color.r;
		this.g += color.g;
		this.b += color.b;

		return this;

	},

	addColors: function ( color1, color2 ) {

		this.r = color1.r + color2.r;
		this.g = color1.g + color2.g;
		this.b = color1.b + color2.b;

		return this;

	},

	addScalar: function ( s ) {

		this.r += s;
		this.g += s;
		this.b += s;

		return this;

	},

	multiply: function ( color ) {

		this.r *= color.r;
		this.g *= color.g;
		this.b *= color.b;

		return this;

	},

	multiplyScalar: function ( s ) {

		this.r *= s;
		this.g *= s;
		this.b *= s;

		return this;

	},

	lerp: function ( color, alpha ) {

		this.r += ( color.r - this.r ) * alpha;
		this.g += ( color.g - this.g ) * alpha;
		this.b += ( color.b - this.b ) * alpha;

		return this;

	},

	clone: function () {

		return new THREE.Color().setRGB( this.r, this.g, this.b );

	}

};

THREE.ColorKeywords = { "aliceblue": 0xF0F8FF, "antiquewhite": 0xFAEBD7, "aqua": 0x00FFFF, "aquamarine": 0x7FFFD4, "azure": 0xF0FFFF,
"beige": 0xF5F5DC, "bisque": 0xFFE4C4, "black": 0x000000, "blanchedalmond": 0xFFEBCD, "blue": 0x0000FF, "blueviolet": 0x8A2BE2,
"brown": 0xA52A2A, "burlywood": 0xDEB887, "cadetblue": 0x5F9EA0, "chartreuse": 0x7FFF00, "chocolate": 0xD2691E, "coral": 0xFF7F50,
"cornflowerblue": 0x6495ED, "cornsilk": 0xFFF8DC, "crimson": 0xDC143C, "cyan": 0x00FFFF, "darkblue": 0x00008B, "darkcyan": 0x008B8B,
"darkgoldenrod": 0xB8860B, "darkgray": 0xA9A9A9, "darkgreen": 0x006400, "darkgrey": 0xA9A9A9, "darkkhaki": 0xBDB76B, "darkmagenta": 0x8B008B,
"darkolivegreen": 0x556B2F, "darkorange": 0xFF8C00, "darkorchid": 0x9932CC, "darkred": 0x8B0000, "darksalmon": 0xE9967A, "darkseagreen": 0x8FBC8F,
"darkslateblue": 0x483D8B, "darkslategray": 0x2F4F4F, "darkslategrey": 0x2F4F4F, "darkturquoise": 0x00CED1, "darkviolet": 0x9400D3,
"deeppink": 0xFF1493, "deepskyblue": 0x00BFFF, "dimgray": 0x696969, "dimgrey": 0x696969, "dodgerblue": 0x1E90FF, "firebrick": 0xB22222,
"floralwhite": 0xFFFAF0, "forestgreen": 0x228B22, "fuchsia": 0xFF00FF, "gainsboro": 0xDCDCDC, "ghostwhite": 0xF8F8FF, "gold": 0xFFD700,
"goldenrod": 0xDAA520, "gray": 0x808080, "green": 0x008000, "greenyellow": 0xADFF2F, "grey": 0x808080, "honeydew": 0xF0FFF0, "hotpink": 0xFF69B4,
"indianred": 0xCD5C5C, "indigo": 0x4B0082, "ivory": 0xFFFFF0, "khaki": 0xF0E68C, "lavender": 0xE6E6FA, "lavenderblush": 0xFFF0F5, "lawngreen": 0x7CFC00,
"lemonchiffon": 0xFFFACD, "lightblue": 0xADD8E6, "lightcoral": 0xF08080, "lightcyan": 0xE0FFFF, "lightgoldenrodyellow": 0xFAFAD2, "lightgray": 0xD3D3D3,
"lightgreen": 0x90EE90, "lightgrey": 0xD3D3D3, "lightpink": 0xFFB6C1, "lightsalmon": 0xFFA07A, "lightseagreen": 0x20B2AA, "lightskyblue": 0x87CEFA,
"lightslategray": 0x778899, "lightslategrey": 0x778899, "lightsteelblue": 0xB0C4DE, "lightyellow": 0xFFFFE0, "lime": 0x00FF00, "limegreen": 0x32CD32,
"linen": 0xFAF0E6, "magenta": 0xFF00FF, "maroon": 0x800000, "mediumaquamarine": 0x66CDAA, "mediumblue": 0x0000CD, "mediumorchid": 0xBA55D3,
"mediumpurple": 0x9370DB, "mediumseagreen": 0x3CB371, "mediumslateblue": 0x7B68EE, "mediumspringgreen": 0x00FA9A, "mediumturquoise": 0x48D1CC,
"mediumvioletred": 0xC71585, "midnightblue": 0x191970, "mintcream": 0xF5FFFA, "mistyrose": 0xFFE4E1, "moccasin": 0xFFE4B5, "navajowhite": 0xFFDEAD,
"navy": 0x000080, "oldlace": 0xFDF5E6, "olive": 0x808000, "olivedrab": 0x6B8E23, "orange": 0xFFA500, "orangered": 0xFF4500, "orchid": 0xDA70D6,
"palegoldenrod": 0xEEE8AA, "palegreen": 0x98FB98, "paleturquoise": 0xAFEEEE, "palevioletred": 0xDB7093, "papayawhip": 0xFFEFD5, "peachpuff": 0xFFDAB9,
"peru": 0xCD853F, "pink": 0xFFC0CB, "plum": 0xDDA0DD, "powderblue": 0xB0E0E6, "purple": 0x800080, "red": 0xFF0000, "rosybrown": 0xBC8F8F,
"royalblue": 0x4169E1, "saddlebrown": 0x8B4513, "salmon": 0xFA8072, "sandybrown": 0xF4A460, "seagreen": 0x2E8B57, "seashell": 0xFFF5EE,
"sienna": 0xA0522D, "silver": 0xC0C0C0, "skyblue": 0x87CEEB, "slateblue": 0x6A5ACD, "slategray": 0x708090, "slategrey": 0x708090, "snow": 0xFFFAFA,
"springgreen": 0x00FF7F, "steelblue": 0x4682B4, "tan": 0xD2B48C, "teal": 0x008080, "thistle": 0xD8BFD8, "tomato": 0xFF6347, "turquoise": 0x40E0D0,
"violet": 0xEE82EE, "wheat": 0xF5DEB3, "white": 0xFFFFFF, "whitesmoke": 0xF5F5F5, "yellow": 0xFFFF00, "yellowgreen": 0x9ACD32 };
/**
 * @author mikael emtinger / http://gomo.se/
 * @author alteredq / http://alteredqualia.com/
 * @author WestLangley / http://github.com/WestLangley
 * @author bhouston / http://exocortex.com
 */

THREE.Quaternion = function( x, y, z, w ) {

	this.x = x || 0;
	this.y = y || 0;
	this.z = z || 0;
	this.w = ( w !== undefined ) ? w : 1;

};

THREE.Quaternion.prototype = {

	constructor: THREE.Quaternion,

	set: function ( x, y, z, w ) {

		this.x = x;
		this.y = y;
		this.z = z;
		this.w = w;

		return this;

	},

	copy: function ( q ) {

		this.x = q.x;
		this.y = q.y;
		this.z = q.z;
		this.w = q.w;

		return this;

	},

	setFromEuler: function ( v, order ) {

		// http://www.mathworks.com/matlabcentral/fileexchange/
		// 	20696-function-to-convert-between-dcm-euler-angles-quaternions-and-euler-vectors/
		//	content/SpinCalc.m

		var c1 = Math.cos( v.x / 2 );
		var c2 = Math.cos( v.y / 2 );
		var c3 = Math.cos( v.z / 2 );
		var s1 = Math.sin( v.x / 2 );
		var s2 = Math.sin( v.y / 2 );
		var s3 = Math.sin( v.z / 2 );

		if ( order === undefined || order === 'XYZ' ) {

			this.x = s1 * c2 * c3 + c1 * s2 * s3;
			this.y = c1 * s2 * c3 - s1 * c2 * s3;
			this.z = c1 * c2 * s3 + s1 * s2 * c3;
			this.w = c1 * c2 * c3 - s1 * s2 * s3;

		} else if ( order === 'YXZ' ) {

			this.x = s1 * c2 * c3 + c1 * s2 * s3;
			this.y = c1 * s2 * c3 - s1 * c2 * s3;
			this.z = c1 * c2 * s3 - s1 * s2 * c3;
			this.w = c1 * c2 * c3 + s1 * s2 * s3;

		} else if ( order === 'ZXY' ) {

			this.x = s1 * c2 * c3 - c1 * s2 * s3;
			this.y = c1 * s2 * c3 + s1 * c2 * s3;
			this.z = c1 * c2 * s3 + s1 * s2 * c3;
			this.w = c1 * c2 * c3 - s1 * s2 * s3;

		} else if ( order === 'ZYX' ) {

			this.x = s1 * c2 * c3 - c1 * s2 * s3;
			this.y = c1 * s2 * c3 + s1 * c2 * s3;
			this.z = c1 * c2 * s3 - s1 * s2 * c3;
			this.w = c1 * c2 * c3 + s1 * s2 * s3;

		} else if ( order === 'YZX' ) {

			this.x = s1 * c2 * c3 + c1 * s2 * s3;
			this.y = c1 * s2 * c3 + s1 * c2 * s3;
			this.z = c1 * c2 * s3 - s1 * s2 * c3;
			this.w = c1 * c2 * c3 - s1 * s2 * s3;

		} else if ( order === 'XZY' ) {

			this.x = s1 * c2 * c3 - c1 * s2 * s3;
			this.y = c1 * s2 * c3 - s1 * c2 * s3;
			this.z = c1 * c2 * s3 + s1 * s2 * c3;
			this.w = c1 * c2 * c3 + s1 * s2 * s3;

		}

		return this;

	},

	setFromAxisAngle: function ( axis, angle ) {

		// from http://www.euclideanspace.com/maths/geometry/rotations/conversions/angleToQuaternion/index.htm
		// axis have to be normalized

		var halfAngle = angle / 2,
			s = Math.sin( halfAngle );

		this.x = axis.x * s;
		this.y = axis.y * s;
		this.z = axis.z * s;
		this.w = Math.cos( halfAngle );

		return this;

	},

	setFromRotationMatrix: function ( m ) {

		// http://www.euclideanspace.com/maths/geometry/rotations/conversions/matrixToQuaternion/index.htm

		// assumes the upper 3x3 of m is a pure rotation matrix (i.e, unscaled)

		var te = m.elements,

			m11 = te[0], m12 = te[4], m13 = te[8],
			m21 = te[1], m22 = te[5], m23 = te[9],
			m31 = te[2], m32 = te[6], m33 = te[10],

			trace = m11 + m22 + m33,
			s;

		if ( trace > 0 ) {

			s = 0.5 / Math.sqrt( trace + 1.0 );

			this.w = 0.25 / s;
			this.x = ( m32 - m23 ) * s;
			this.y = ( m13 - m31 ) * s;
			this.z = ( m21 - m12 ) * s;

		} else if ( m11 > m22 && m11 > m33 ) {

			s = 2.0 * Math.sqrt( 1.0 + m11 - m22 - m33 );

			this.w = (m32 - m23 ) / s;
			this.x = 0.25 * s;
			this.y = (m12 + m21 ) / s;
			this.z = (m13 + m31 ) / s;

		} else if ( m22 > m33 ) {

			s = 2.0 * Math.sqrt( 1.0 + m22 - m11 - m33 );

			this.w = (m13 - m31 ) / s;
			this.x = (m12 + m21 ) / s;
			this.y = 0.25 * s;
			this.z = (m23 + m32 ) / s;

		} else {

			s = 2.0 * Math.sqrt( 1.0 + m33 - m11 - m22 );

			this.w = ( m21 - m12 ) / s;
			this.x = ( m13 + m31 ) / s;
			this.y = ( m23 + m32 ) / s;
			this.z = 0.25 * s;

		}

		return this;

	},

	inverse: function () {

		this.conjugate().normalize();

		return this;

	},

	conjugate: function () {

		this.x *= -1;
		this.y *= -1;
		this.z *= -1;

		return this;

	},

	lengthSq: function () {

		return this.x * this.x + this.y * this.y + this.z * this.z + this.w * this.w;

	},

	length: function () {

		return Math.sqrt( this.x * this.x + this.y * this.y + this.z * this.z + this.w * this.w );

	},

	normalize: function () {

		var l = this.length();

		if ( l === 0 ) {

			this.x = 0;
			this.y = 0;
			this.z = 0;
			this.w = 1;

		} else {

			l = 1 / l;

			this.x = this.x * l;
			this.y = this.y * l;
			this.z = this.z * l;
			this.w = this.w * l;

		}

		return this;

	},

	multiply: function ( q, p ) {

		if ( p !== undefined ) {

			console.warn( 'DEPRECATED: Quaternion\'s .multiply() now only accepts one argument. Use .multiplyQuaternions( a, b ) instead.' );
			return this.multiplyQuaternions( q, p );

		}

		return this.multiplyQuaternions( this, q );

	},

	multiplyQuaternions: function ( a, b ) {

		// from http://www.euclideanspace.com/maths/algebra/realNormedAlgebra/quaternions/code/index.htm

		var qax = a.x, qay = a.y, qaz = a.z, qaw = a.w;
		var qbx = b.x, qby = b.y, qbz = b.z, qbw = b.w;

		this.x = qax * qbw + qaw * qbx + qay * qbz - qaz * qby;
		this.y = qay * qbw + qaw * qby + qaz * qbx - qax * qbz;
		this.z = qaz * qbw + qaw * qbz + qax * qby - qay * qbx;
		this.w = qaw * qbw - qax * qbx - qay * qby - qaz * qbz;

		return this;

	},

	multiplyVector3: function ( vector ) {

		console.warn( 'DEPRECATED: Quaternion\'s .multiplyVector3() has been removed. Use is now vector.applyQuaternion( quaternion ) instead.' );
		return vector.applyQuaternion( this );

	},

	slerp: function ( qb, t ) {

		var x = this.x, y = this.y, z = this.z, w = this.w;

		// http://www.euclideanspace.com/maths/algebra/realNormedAlgebra/quaternions/slerp/

		var cosHalfTheta = w * qb.w + x * qb.x + y * qb.y + z * qb.z;

		if ( cosHalfTheta < 0 ) {

			this.w = -qb.w;
			this.x = -qb.x;
			this.y = -qb.y;
			this.z = -qb.z;

			cosHalfTheta = -cosHalfTheta;

		} else {

			this.copy( qb );

		}

		if ( cosHalfTheta >= 1.0 ) {

			this.w = w;
			this.x = x;
			this.y = y;
			this.z = z;

			return this;

		}

		var halfTheta = Math.acos( cosHalfTheta );
		var sinHalfTheta = Math.sqrt( 1.0 - cosHalfTheta * cosHalfTheta );

		if ( Math.abs( sinHalfTheta ) < 0.001 ) {

			this.w = 0.5 * ( w + this.w );
			this.x = 0.5 * ( x + this.x );
			this.y = 0.5 * ( y + this.y );
			this.z = 0.5 * ( z + this.z );

			return this;

		}

		var ratioA = Math.sin( ( 1 - t ) * halfTheta ) / sinHalfTheta,
		ratioB = Math.sin( t * halfTheta ) / sinHalfTheta;

		this.w = ( w * ratioA + this.w * ratioB );
		this.x = ( x * ratioA + this.x * ratioB );
		this.y = ( y * ratioA + this.y * ratioB );
		this.z = ( z * ratioA + this.z * ratioB );

		return this;

	},

	equals: function ( v ) {

		return ( ( v.x === this.x ) && ( v.y === this.y ) && ( v.z === this.z ) && ( v.w === this.w ) );

	},

	clone: function () {

		return new THREE.Quaternion( this.x, this.y, this.z, this.w );

	}

}

THREE.Quaternion.slerp = function ( qa, qb, qm, t ) {

	return qm.copy( qa ).slerp( qb, t );

}
/**
 * @author mrdoob / http://mrdoob.com/
 * @author philogb / http://blog.thejit.org/
 * @author egraether / http://egraether.com/
 * @author zz85 / http://www.lab4games.net/zz85/blog
 */

THREE.Vector2 = function ( x, y ) {

	this.x = x || 0;
	this.y = y || 0;

};

THREE.Vector2.prototype = {

	constructor: THREE.Vector2,

	set: function ( x, y ) {

		this.x = x;
		this.y = y;

		return this;

	},

	setX: function ( x ) {

		this.x = x;

		return this;

	},

	setY: function ( y ) {

		this.y = y;

		return this;

	},


	setComponent: function ( index, value ) {

		switch ( index ) {

			case 0: this.x = value; break;
			case 1: this.y = value; break;
			default: throw new Error( "index is out of range: " + index );

		}

	},

	getComponent: function ( index ) {

		switch ( index ) {

			case 0: return this.x;
			case 1: return this.y;
			default: throw new Error( "index is out of range: " + index );

		}

	},

	copy: function ( v ) {

		this.x = v.x;
		this.y = v.y;

		return this;

	},

	add: function ( v, w ) {

		if ( w !== undefined ) {

			console.warn( 'DEPRECATED: Vector2\'s .add() now only accepts one argument. Use .addVectors( a, b ) instead.' );
			return this.addVectors( v, w );

		}

		this.x += v.x;
		this.y += v.y;

		return this;

	},

	addVectors: function ( a, b ) {

		this.x = a.x + b.x;
		this.y = a.y + b.y;

		return this;

	},

	addScalar: function ( s ) {

		this.x += s;
		this.y += s;

		return this;

	},

	sub: function ( v, w ) {

		if ( w !== undefined ) {

			console.warn( 'DEPRECATED: Vector2\'s .sub() now only accepts one argument. Use .subVectors( a, b ) instead.' );
			return this.subVectors( v, w );

		}

		this.x -= v.x;
		this.y -= v.y;

		return this;

	},

	subVectors: function ( a, b ) {

		this.x = a.x - b.x;
		this.y = a.y - b.y;

		return this;

	},

	multiplyScalar: function ( s ) {

		this.x *= s;
		this.y *= s;

		return this;

	},

	divideScalar: function ( s ) {

		if ( s !== 0 ) {

			this.x /= s;
			this.y /= s;

		} else {

			this.set( 0, 0 );

		}

		return this;

	},

	min: function ( v ) {

		if ( this.x > v.x ) {

			this.x = v.x;

		}

		if ( this.y > v.y ) {

			this.y = v.y;

		}

		return this;

	},

	max: function ( v ) {

		if ( this.x < v.x ) {

			this.x = v.x;

		}

		if ( this.y < v.y ) {

			this.y = v.y;

		}

		return this;

	},

	clamp: function ( min, max ) {

		// This function assumes min < max, if this assumption isn't true it will not operate correctly

		if ( this.x < min.x ) {

			this.x = min.x;

		} else if ( this.x > max.x ) {

			this.x = max.x;

		}

		if ( this.y < min.y ) {

			this.y = min.y;

		} else if ( this.y > max.y ) {

			this.y = max.y;

		}

		return this;

	},

	negate: function() {

		return this.multiplyScalar( - 1 );

	},

	dot: function ( v ) {

		return this.x * v.x + this.y * v.y;

	},

	lengthSq: function () {

		return this.x * this.x + this.y * this.y;

	},

	length: function () {

		return Math.sqrt( this.x * this.x + this.y * this.y );

	},

	normalize: function () {

		return this.divideScalar( this.length() );

	},

	distanceTo: function ( v ) {

		return Math.sqrt( this.distanceToSquared( v ) );

	},

	distanceToSquared: function ( v ) {

		var dx = this.x - v.x, dy = this.y - v.y;
		return dx * dx + dy * dy;

	},

	setLength: function ( l ) {

		var oldLength = this.length();

		if ( oldLength !== 0 && l !== oldLength ) {

			this.multiplyScalar( l / oldLength );
		}

		return this;

	},

	lerp: function ( v, alpha ) {

		this.x += ( v.x - this.x ) * alpha;
		this.y += ( v.y - this.y ) * alpha;

		return this;

	},

	equals: function( v ) {

		return ( ( v.x === this.x ) && ( v.y === this.y ) );

	},

	clone: function () {

		return new THREE.Vector2( this.x, this.y );

	}

};
/**
 * @author mrdoob / http://mrdoob.com/
 * @author *kile / http://kile.stravaganza.org/
 * @author philogb / http://blog.thejit.org/
 * @author mikael emtinger / http://gomo.se/
 * @author egraether / http://egraether.com/
 * @author WestLangley / http://github.com/WestLangley
 */

THREE.Vector3 = function ( x, y, z ) {

	this.x = x || 0;
	this.y = y || 0;
	this.z = z || 0;

};


THREE.Vector3.prototype = {

	constructor: THREE.Vector3,

	set: function ( x, y, z ) {

		this.x = x;
		this.y = y;
		this.z = z;

		return this;

	},

	setX: function ( x ) {

		this.x = x;

		return this;

	},

	setY: function ( y ) {

		this.y = y;

		return this;

	},

	setZ: function ( z ) {

		this.z = z;

		return this;

	},

	setComponent: function ( index, value ) {

		switch ( index ) {

			case 0: this.x = value; break;
			case 1: this.y = value; break;
			case 2: this.z = value; break;
			default: throw new Error( "index is out of range: " + index );

		}

	},

	getComponent: function ( index ) {

		switch ( index ) {

			case 0: return this.x;
			case 1: return this.y;
			case 2: return this.z;
			default: throw new Error( "index is out of range: " + index );

		}

	},

	copy: function ( v ) {

		this.x = v.x;
		this.y = v.y;
		this.z = v.z;

		return this;

	},

	add: function ( v, w ) {

		if ( w !== undefined ) {

			console.warn( 'DEPRECATED: Vector3\'s .add() now only accepts one argument. Use .addVectors( a, b ) instead.' );
			return this.addVectors( v, w );

		}

		this.x += v.x;
		this.y += v.y;
		this.z += v.z;

		return this;

	},

	addScalar: function ( s ) {

		this.x += s;
		this.y += s;
		this.z += s;

		return this;

	},

	addVectors: function ( a, b ) {

		this.x = a.x + b.x;
		this.y = a.y + b.y;
		this.z = a.z + b.z;

		return this;

	},

	sub: function ( v, w ) {

		if ( w !== undefined ) {

			console.warn( 'DEPRECATED: Vector3\'s .sub() now only accepts one argument. Use .subVectors( a, b ) instead.' );
			return this.subVectors( v, w );

		}

		this.x -= v.x;
		this.y -= v.y;
		this.z -= v.z;

		return this;

	},

	subVectors: function ( a, b ) {

		this.x = a.x - b.x;
		this.y = a.y - b.y;
		this.z = a.z - b.z;

		return this;

	},

	multiply: function ( v, w ) {

		if ( w !== undefined ) {

			console.warn( 'DEPRECATED: Vector3\'s .multiply() now only accepts one argument. Use .multiplyVectors( a, b ) instead.' );
			return this.multiplyVectors( v, w );

		}

		this.x *= v.x;
		this.y *= v.y;
		this.z *= v.z;

		return this;

	},

	multiplyScalar: function ( s ) {

		this.x *= s;
		this.y *= s;
		this.z *= s;

		return this;

	},

	multiplyVectors: function ( a, b ) {

		this.x = a.x * b.x;
		this.y = a.y * b.y;
		this.z = a.z * b.z;

		return this;

	},

	applyMatrix3: function ( m ) {

		var x = this.x;
		var y = this.y;
		var z = this.z;

		var e = m.elements;

		this.x = e[0] * x + e[3] * y + e[6] * z;
		this.y = e[1] * x + e[4] * y + e[7] * z;
		this.z = e[2] * x + e[5] * y + e[8] * z;

		return this;

	},

	applyMatrix4: function ( m ) {

		// input: THREE.Matrix4 affine matrix

		var x = this.x, y = this.y, z = this.z;

		var e = m.elements;

		this.x = e[0] * x + e[4] * y + e[8]  * z + e[12];
		this.y = e[1] * x + e[5] * y + e[9]  * z + e[13];
		this.z = e[2] * x + e[6] * y + e[10] * z + e[14];

		return this;

	},

	applyProjection: function ( m ) {

		// input: THREE.Matrix4 projection matrix

		var x = this.x, y = this.y, z = this.z;

		var e = m.elements;
		var d = 1 / ( e[3] * x + e[7] * y + e[11] * z + e[15] ); // perspective divide

		this.x = ( e[0] * x + e[4] * y + e[8]  * z + e[12] ) * d;
		this.y = ( e[1] * x + e[5] * y + e[9]  * z + e[13] ) * d;
		this.z = ( e[2] * x + e[6] * y + e[10] * z + e[14] ) * d;

		return this;

	},

	applyQuaternion: function ( q ) {

		var x = this.x;
		var y = this.y;
		var z = this.z;

		var qx = q.x;
		var qy = q.y;
		var qz = q.z;
		var qw = q.w;

		// calculate quat * vector

		var ix =  qw * x + qy * z - qz * y;
		var iy =  qw * y + qz * x - qx * z;
		var iz =  qw * z + qx * y - qy * x;
		var iw = -qx * x - qy * y - qz * z;

		// calculate result * inverse quat

		this.x = ix * qw + iw * -qx + iy * -qz - iz * -qy;
		this.y = iy * qw + iw * -qy + iz * -qx - ix * -qz;
		this.z = iz * qw + iw * -qz + ix * -qy - iy * -qx;

		return this;

	},

	applyEuler: function ( v, eulerOrder ) {

		var quaternion = THREE.Vector3.__q1.setFromEuler( v, eulerOrder );

		this.applyQuaternion( quaternion );

		return this;

	},

	applyAxisAngle: function ( axis, angle ) {

		var quaternion = THREE.Vector3.__q1.setFromAxisAngle( axis, angle );

		this.applyQuaternion( quaternion );

		return this;

	},

	divide: function ( v ) {

		this.x /= v.x;
		this.y /= v.y;
		this.z /= v.z;

		return this;

	},

	divideScalar: function ( s ) {

		if ( s !== 0 ) {

			this.x /= s;
			this.y /= s;
			this.z /= s;

		} else {

			this.x = 0;
			this.y = 0;
			this.z = 0;

		}

		return this;

	},

	min: function ( v ) {

		if ( this.x > v.x ) {

			this.x = v.x;

		}

		if ( this.y > v.y ) {

			this.y = v.y;

		}

		if ( this.z > v.z ) {

			this.z = v.z;

		}

		return this;

	},

	max: function ( v ) {

		if ( this.x < v.x ) {

			this.x = v.x;

		}

		if ( this.y < v.y ) {

			this.y = v.y;

		}

		if ( this.z < v.z ) {

			this.z = v.z;

		}

		return this;

	},

	clamp: function ( min, max ) {

		// This function assumes min < max, if this assumption isn't true it will not operate correctly

		if ( this.x < min.x ) {

			this.x = min.x;

		} else if ( this.x > max.x ) {

			this.x = max.x;

		}

		if ( this.y < min.y ) {

			this.y = min.y;

		} else if ( this.y > max.y ) {

			this.y = max.y;

		}

		if ( this.z < min.z ) {

			this.z = min.z;

		} else if ( this.z > max.z ) {

			this.z = max.z;

		}

		return this;

	},

	negate: function() {

		return this.multiplyScalar( - 1 );

	},

	dot: function ( v ) {

		if(!v)
		{
			var a;
		}
		return this.x * v.x + this.y * v.y + this.z * v.z;

	},

	lengthSq: function () {

		return this.x * this.x + this.y * this.y + this.z * this.z;

	},

	length: function () {

		return Math.sqrt( this.x * this.x + this.y * this.y + this.z * this.z );

	},

	lengthManhattan: function () {

		return Math.abs( this.x ) + Math.abs( this.y ) + Math.abs( this.z );

	},

	normalize: function () {

		return this.divideScalar( this.length() );

	},

	setLength: function ( l ) {

		var oldLength = this.length();

		if ( oldLength !== 0 && l !== oldLength  ) {

			this.multiplyScalar( l / oldLength );
		}

		return this;

	},

	lerp: function ( v, alpha ) {

		this.x += ( v.x - this.x ) * alpha;
		this.y += ( v.y - this.y ) * alpha;
		this.z += ( v.z - this.z ) * alpha;

		return this;

	},

	cross: function ( v, w ) {

		if ( w !== undefined ) {

			console.warn( 'DEPRECATED: Vector3\'s .cross() now only accepts one argument. Use .crossVectors( a, b ) instead.' );
			return this.crossVectors( v, w );

		}

		var x = this.x, y = this.y, z = this.z;

		this.x = y * v.z - z * v.y;
		this.y = z * v.x - x * v.z;
		this.z = x * v.y - y * v.x;

		return this;

	},

	crossVectors: function ( a, b ) {

		this.x = a.y * b.z - a.z * b.y;
		this.y = a.z * b.x - a.x * b.z;
		this.z = a.x * b.y - a.y * b.x;

		return this;

	},

	angleTo: function ( v ) {

		return Math.acos( this.dot( v ) / this.length() / v.length() );

	},

	distanceTo: function ( v ) {

		return Math.sqrt( this.distanceToSquared( v ) );

	},

	distanceToSquared: function ( v ) {

		var dx = this.x - v.x;
		var dy = this.y - v.y;
		var dz = this.z - v.z;

		return dx * dx + dy * dy + dz * dz;

	},

	getPositionFromMatrix: function ( m ) {

		this.x = m.elements[12];
		this.y = m.elements[13];
		this.z = m.elements[14];

		return this;

	},

	setEulerFromRotationMatrix: function ( m, order ) {

		// assumes the upper 3x3 of m is a pure rotation matrix (i.e, unscaled)

		// clamp, to handle numerical problems

		function clamp( x ) {

			return Math.min( Math.max( x, -1 ), 1 );

		}

		var te = m.elements;
		var m11 = te[0], m12 = te[4], m13 = te[8];
		var m21 = te[1], m22 = te[5], m23 = te[9];
		var m31 = te[2], m32 = te[6], m33 = te[10];

		if ( order === undefined || order === 'XYZ' ) {

			this.y = Math.asin( clamp( m13 ) );

			if ( Math.abs( m13 ) < 0.99999 ) {

				this.x = Math.atan2( - m23, m33 );
				this.z = Math.atan2( - m12, m11 );

			} else {

				this.x = Math.atan2( m32, m22 );
				this.z = 0;

			}

		} else if ( order === 'YXZ' ) {

			this.x = Math.asin( - clamp( m23 ) );

			if ( Math.abs( m23 ) < 0.99999 ) {

				this.y = Math.atan2( m13, m33 );
				this.z = Math.atan2( m21, m22 );

			} else {

				this.y = Math.atan2( - m31, m11 );
				this.z = 0;

			}

		} else if ( order === 'ZXY' ) {

			this.x = Math.asin( clamp( m32 ) );

			if ( Math.abs( m32 ) < 0.99999 ) {

				this.y = Math.atan2( - m31, m33 );
				this.z = Math.atan2( - m12, m22 );

			} else {

				this.y = 0;
				this.z = Math.atan2( m21, m11 );

			}

		} else if ( order === 'ZYX' ) {

			this.y = Math.asin( - clamp( m31 ) );

			if ( Math.abs( m31 ) < 0.99999 ) {

				this.x = Math.atan2( m32, m33 );
				this.z = Math.atan2( m21, m11 );

			} else {

				this.x = 0;
				this.z = Math.atan2( - m12, m22 );

			}

		} else if ( order === 'YZX' ) {

			this.z = Math.asin( clamp( m21 ) );

			if ( Math.abs( m21 ) < 0.99999 ) {

				this.x = Math.atan2( - m23, m22 );
				this.y = Math.atan2( - m31, m11 );

			} else {

				this.x = 0;
				this.y = Math.atan2( m13, m33 );

			}

		} else if ( order === 'XZY' ) {

			this.z = Math.asin( - clamp( m12 ) );

			if ( Math.abs( m12 ) < 0.99999 ) {

				this.x = Math.atan2( m32, m22 );
				this.y = Math.atan2( m13, m11 );

			} else {

				this.x = Math.atan2( - m23, m33 );
				this.y = 0;

			}

		}

		return this;

	},

	setEulerFromQuaternion: function ( q, order ) {

		// q is assumed to be normalized

		// clamp, to handle numerical problems

		function clamp( x ) {

			return Math.min( Math.max( x, -1 ), 1 );

		}

		// http://www.mathworks.com/matlabcentral/fileexchange/20696-function-to-convert-between-dcm-euler-angles-quaternions-and-euler-vectors/content/SpinCalc.m

		var sqx = q.x * q.x;
		var sqy = q.y * q.y;
		var sqz = q.z * q.z;
		var sqw = q.w * q.w;

		if ( order === undefined || order === 'XYZ' ) {

			this.x = Math.atan2( 2 * ( q.x * q.w - q.y * q.z ), ( sqw - sqx - sqy + sqz ) );
			this.y = Math.asin(  clamp( 2 * ( q.x * q.z + q.y * q.w ) ) );
			this.z = Math.atan2( 2 * ( q.z * q.w - q.x * q.y ), ( sqw + sqx - sqy - sqz ) );

		} else if ( order ===  'YXZ' ) {

			this.x = Math.asin(  clamp( 2 * ( q.x * q.w - q.y * q.z ) ) );
			this.y = Math.atan2( 2 * ( q.x * q.z + q.y * q.w ), ( sqw - sqx - sqy + sqz ) );
			this.z = Math.atan2( 2 * ( q.x * q.y + q.z * q.w ), ( sqw - sqx + sqy - sqz ) );

		} else if ( order === 'ZXY' ) {

			this.x = Math.asin(  clamp( 2 * ( q.x * q.w + q.y * q.z ) ) );
			this.y = Math.atan2( 2 * ( q.y * q.w - q.z * q.x ), ( sqw - sqx - sqy + sqz ) );
			this.z = Math.atan2( 2 * ( q.z * q.w - q.x * q.y ), ( sqw - sqx + sqy - sqz ) );

		} else if ( order === 'ZYX' ) {

			this.x = Math.atan2( 2 * ( q.x * q.w + q.z * q.y ), ( sqw - sqx - sqy + sqz ) );
			this.y = Math.asin(  clamp( 2 * ( q.y * q.w - q.x * q.z ) ) );
			this.z = Math.atan2( 2 * ( q.x * q.y + q.z * q.w ), ( sqw + sqx - sqy - sqz ) );

		} else if ( order === 'YZX' ) {

			this.x = Math.atan2( 2 * ( q.x * q.w - q.z * q.y ), ( sqw - sqx + sqy - sqz ) );
			this.y = Math.atan2( 2 * ( q.y * q.w - q.x * q.z ), ( sqw + sqx - sqy - sqz ) );
			this.z = Math.asin(  clamp( 2 * ( q.x * q.y + q.z * q.w ) ) );

		} else if ( order === 'XZY' ) {

			this.x = Math.atan2( 2 * ( q.x * q.w + q.y * q.z ), ( sqw - sqx + sqy - sqz ) );
			this.y = Math.atan2( 2 * ( q.x * q.z + q.y * q.w ), ( sqw + sqx - sqy - sqz ) );
			this.z = Math.asin(  clamp( 2 * ( q.z * q.w - q.x * q.y ) ) );

		}

		return this;

	},

	getScaleFromMatrix: function ( m ) {

		var sx = this.set( m.elements[0], m.elements[1], m.elements[2] ).length();
		var sy = this.set( m.elements[4], m.elements[5], m.elements[6] ).length();
		var sz = this.set( m.elements[8], m.elements[9], m.elements[10] ).length();

		this.x = sx;
		this.y = sy;
		this.z = sz;

		return this;
	},

	equals: function ( v ) {

		return ( ( v.x === this.x ) && ( v.y === this.y ) && ( v.z === this.z ) );

	},

	clone: function () {

		return new THREE.Vector3( this.x, this.y, this.z );

	}

};

THREE.Vector3.__q1 = new THREE.Quaternion();
/**
 * @author supereggbert / http://www.paulbrunt.co.uk/
 * @author philogb / http://blog.thejit.org/
 * @author mikael emtinger / http://gomo.se/
 * @author egraether / http://egraether.com/
 * @author WestLangley / http://github.com/WestLangley
 */

THREE.Vector4 = function ( x, y, z, w ) {

	this.x = x || 0;
	this.y = y || 0;
	this.z = z || 0;
	this.w = ( w !== undefined ) ? w : 1;

};

THREE.Vector4.prototype = {

	constructor: THREE.Vector4,

	set: function ( x, y, z, w ) {

		this.x = x;
		this.y = y;
		this.z = z;
		this.w = w;

		return this;

	},

	setX: function ( x ) {

		this.x = x;

		return this;

	},

	setY: function ( y ) {

		this.y = y;

		return this;

	},

	setZ: function ( z ) {

		this.z = z;

		return this;

	},

	setW: function ( w ) {

		this.w = w;

		return this;

	},

	setComponent: function ( index, value ) {

		switch ( index ) {

			case 0: this.x = value; break;
			case 1: this.y = value; break;
			case 2: this.z = value; break;
			case 3: this.w = value; break;
			default: throw new Error( "index is out of range: " + index );

		}

	},

	getComponent: function ( index ) {

		switch ( index ) {

			case 0: return this.x;
			case 1: return this.y;
			case 2: return this.z;
			case 3: return this.w;
			default: throw new Error( "index is out of range: " + index );

		}

	},

	copy: function ( v ) {

		this.x = v.x;
		this.y = v.y;
		this.z = v.z;
		this.w = ( v.w !== undefined ) ? v.w : 1;

		return this;

	},

	add: function ( v, w ) {

		if ( w !== undefined ) {

			console.warn( 'DEPRECATED: Vector4\'s .add() now only accepts one argument. Use .addVectors( a, b ) instead.' );
			return this.addVectors( v, w );

		}

		this.x += v.x;
		this.y += v.y;
		this.z += v.z;
		this.w += v.w;

		return this;

	},

	addScalar: function ( s ) {

		this.x += s;
		this.y += s;
		this.z += s;
		this.w += s;

		return this;

	},

	addVectors: function ( a, b ) {

		this.x = a.x + b.x;
		this.y = a.y + b.y;
		this.z = a.z + b.z;
		this.w = a.w + b.w;

		return this;

	},

	sub: function ( v, w ) {

		if ( w !== undefined ) {

			console.warn( 'DEPRECATED: Vector4\'s .sub() now only accepts one argument. Use .subVectors( a, b ) instead.' );
			return this.subVectors( v, w );

		}

		this.x -= v.x;
		this.y -= v.y;
		this.z -= v.z;
		this.w -= v.w;

		return this;

	},

	subVectors: function ( a, b ) {

		this.x = a.x - b.x;
		this.y = a.y - b.y;
		this.z = a.z - b.z;
		this.w = a.w - b.w;

		return this;

	},

	multiplyScalar: function ( s ) {

		this.x *= s;
		this.y *= s;
		this.z *= s;
		this.w *= s;

		return this;

	},

	applyMatrix4: function ( m ) {

		var x = this.x;
		var y = this.y;
		var z = this.z;
		var w = this.w;

		var e = m.elements;

		this.x = e[0] * x + e[4] * y + e[8] * z + e[12] * w;
		this.y = e[1] * x + e[5] * y + e[9] * z + e[13] * w;
		this.z = e[2] * x + e[6] * y + e[10] * z + e[14] * w;
		this.w = e[3] * x + e[7] * y + e[11] * z + e[15] * w;

		return this;

	},

	divideScalar: function ( s ) {

		if ( s !== 0 ) {

			this.x /= s;
			this.y /= s;
			this.z /= s;
			this.w /= s;

		} else {

			this.x = 0;
			this.y = 0;
			this.z = 0;
			this.w = 1;

		}

		return this;

	},

	min: function ( v ) {

		if ( this.x > v.x ) {

			this.x = v.x;

		}

		if ( this.y > v.y ) {

			this.y = v.y;

		}

		if ( this.z > v.z ) {

			this.z = v.z;

		}

		if ( this.w > v.w ) {

			this.w = v.w;

		}

		return this;

	},

	max: function ( v ) {

		if ( this.x < v.x ) {

			this.x = v.x;

		}

		if ( this.y < v.y ) {

			this.y = v.y;

		}

		if ( this.z < v.z ) {

			this.z = v.z;

		}

		if ( this.w < v.w ) {

			this.w = v.w;

		}

		return this;

	},

	clamp: function ( min, max ) {

		// This function assumes min < max, if this assumption isn't true it will not operate correctly

		if ( this.x < min.x ) {

			this.x = min.x;

		} else if ( this.x > max.x ) {

			this.x = max.x;

		}

		if ( this.y < min.y ) {

			this.y = min.y;

		} else if ( this.y > max.y ) {

			this.y = max.y;

		}

		if ( this.z < min.z ) {

			this.z = min.z;

		} else if ( this.z > max.z ) {

			this.z = max.z;

		}

		if ( this.w < min.w ) {

			this.w = min.w;

		} else if ( this.w > max.w ) {

			this.w = max.w;

		}

		return this;

	},

	negate: function() {

		return this.multiplyScalar( -1 );

	},

	dot: function ( v ) {

		return this.x * v.x + this.y * v.y + this.z * v.z + this.w * v.w;

	},

	lengthSq: function () {

		return this.x * this.x + this.y * this.y + this.z * this.z + this.w * this.w;

	},

	length: function () {

		return Math.sqrt( this.x * this.x + this.y * this.y + this.z * this.z + this.w * this.w );

	},

	lengthManhattan: function () {

		return Math.abs( this.x ) + Math.abs( this.y ) + Math.abs( this.z ) + Math.abs( this.w );

	},

	normalize: function () {

		return this.divideScalar( this.length() );

	},

	setLength: function ( l ) {

		var oldLength = this.length();

		if ( oldLength !== 0 && l !== oldLength ) {

			this.multiplyScalar( l / oldLength );
		}

		return this;

	},

	lerp: function ( v, alpha ) {

		this.x += ( v.x - this.x ) * alpha;
		this.y += ( v.y - this.y ) * alpha;
		this.z += ( v.z - this.z ) * alpha;
		this.w += ( v.w - this.w ) * alpha;

		return this;

	},

	equals: function ( v ) {

		return ( ( v.x === this.x ) && ( v.y === this.y ) && ( v.z === this.z ) && ( v.w === this.w ) );

	},

	clone: function () {

		return new THREE.Vector4( this.x, this.y, this.z, this.w );

	},

	setAxisAngleFromQuaternion: function ( q ) {

		// http://www.euclideanspace.com/maths/geometry/rotations/conversions/quaternionToAngle/index.htm

		// q is assumed to be normalized

		this.w = 2 * Math.acos( q.w );

		var s = Math.sqrt( 1 - q.w * q.w );

		if ( s < 0.0001 ) {

			 this.x = 1;
			 this.y = 0;
			 this.z = 0;

		} else {

			 this.x = q.x / s;
			 this.y = q.y / s;
			 this.z = q.z / s;

		}

		return this;

	},

	setAxisAngleFromRotationMatrix: function ( m ) {

		// http://www.euclideanspace.com/maths/geometry/rotations/conversions/matrixToAngle/index.htm

		// assumes the upper 3x3 of m is a pure rotation matrix (i.e, unscaled)

		var angle, x, y, z,		// variables for result
			epsilon = 0.01,		// margin to allow for rounding errors
			epsilon2 = 0.1,		// margin to distinguish between 0 and 180 degrees

			te = m.elements,

			m11 = te[0], m12 = te[4], m13 = te[8],
			m21 = te[1], m22 = te[5], m23 = te[9],
			m31 = te[2], m32 = te[6], m33 = te[10];

		if ( ( Math.abs( m12 - m21 ) < epsilon )
		  && ( Math.abs( m13 - m31 ) < epsilon )
		  && ( Math.abs( m23 - m32 ) < epsilon ) ) {

			// singularity found
			// first check for identity matrix which must have +1 for all terms
			// in leading diagonal and zero in other terms

			if ( ( Math.abs( m12 + m21 ) < epsilon2 )
			  && ( Math.abs( m13 + m31 ) < epsilon2 )
			  && ( Math.abs( m23 + m32 ) < epsilon2 )
			  && ( Math.abs( m11 + m22 + m33 - 3 ) < epsilon2 ) ) {

				// this singularity is identity matrix so angle = 0

				this.set( 1, 0, 0, 0 );

				return this; // zero angle, arbitrary axis

			}

			// otherwise this singularity is angle = 180

			angle = Math.PI;

			var xx = ( m11 + 1 ) / 2;
			var yy = ( m22 + 1 ) / 2;
			var zz = ( m33 + 1 ) / 2;
			var xy = ( m12 + m21 ) / 4;
			var xz = ( m13 + m31 ) / 4;
			var yz = ( m23 + m32 ) / 4;

			if ( ( xx > yy ) && ( xx > zz ) ) { // m11 is the largest diagonal term

				if ( xx < epsilon ) {

					x = 0;
					y = 0.707106781;
					z = 0.707106781;

				} else {

					x = Math.sqrt( xx );
					y = xy / x;
					z = xz / x;

				}

			} else if ( yy > zz ) { // m22 is the largest diagonal term

				if ( yy < epsilon ) {

					x = 0.707106781;
					y = 0;
					z = 0.707106781;

				} else {

					y = Math.sqrt( yy );
					x = xy / y;
					z = yz / y;

				}

			} else { // m33 is the largest diagonal term so base result on this

				if ( zz < epsilon ) {

					x = 0.707106781;
					y = 0.707106781;
					z = 0;

				} else {

					z = Math.sqrt( zz );
					x = xz / z;
					y = yz / z;

				}

			}

			this.set( x, y, z, angle );

			return this; // return 180 deg rotation

		}

		// as we have reached here there are no singularities so we can handle normally

		var s = Math.sqrt( ( m32 - m23 ) * ( m32 - m23 )
						 + ( m13 - m31 ) * ( m13 - m31 )
						 + ( m21 - m12 ) * ( m21 - m12 ) ); // used to normalize

		if ( Math.abs( s ) < 0.001 ) s = 1;

		// prevent divide by zero, should not happen if matrix is orthogonal and should be
		// caught by singularity test above, but I've left it in just in case

		this.x = ( m32 - m23 ) / s;
		this.y = ( m13 - m31 ) / s;
		this.z = ( m21 - m12 ) / s;
		this.w = Math.acos( ( m11 + m22 + m33 - 1 ) / 2 );

		return this;

	}

};
/**
 * @author bhouston / http://exocortex.com
 */

THREE.Box2 = function ( min, max ) {

	this.min = ( min !== undefined ) ? min : new THREE.Vector2( Infinity, Infinity );
	this.max = ( max !== undefined ) ? max : new THREE.Vector2( -Infinity, -Infinity );

};

THREE.Box2.prototype = {

	constructor: THREE.Box2,

	set: function ( min, max ) {

		this.min.copy( min );
		this.max.copy( max );

		return this;

	},

	setFromPoints: function ( points ) {

		if ( points.length > 0 ) {

			var point = points[ 0 ];

			this.min.copy( point );
			this.max.copy( point );

			for ( var i = 1, il = points.length; i < il; i ++ ) {

				point = points[ i ];

				if ( point.x < this.min.x ) {

					this.min.x = point.x;

				} else if ( point.x > this.max.x ) {

					this.max.x = point.x;

				}

				if ( point.y < this.min.y ) {

					this.min.y = point.y;

				} else if ( point.y > this.max.y ) {

					this.max.y = point.y;

				}

			}

		} else {

			this.makeEmpty();

		}

		return this;

	},

	setFromCenterAndSize: function ( center, size ) {

		var halfSize = THREE.Box2.__v1.copy( size ).multiplyScalar( 0.5 );
		this.min.copy( center ).sub( halfSize );
		this.max.copy( center ).add( halfSize );

		return this;

	},

	copy: function ( box ) {

		this.min.copy( box.min );
		this.max.copy( box.max );

		return this;

	},

	makeEmpty: function () {

		this.min.x = this.min.y = Infinity;
		this.max.x = this.max.y = -Infinity;

		return this;

	},

	empty: function () {

		// this is a more robust check for empty than ( volume <= 0 ) because volume can get positive with two negative axes

		return ( this.max.x < this.min.x ) || ( this.max.y < this.min.y );

	},

	center: function ( optionalTarget ) {

		var result = optionalTarget || new THREE.Vector2();
		return result.addVectors( this.min, this.max ).multiplyScalar( 0.5 );

	},

	size: function ( optionalTarget ) {

		var result = optionalTarget || new THREE.Vector2();
		return result.subVectors( this.max, this.min );

	},

	expandByPoint: function ( point ) {

		this.min.min( point );
		this.max.max( point );

		return this;
	},

	expandByVector: function ( vector ) {

		this.min.sub( vector );
		this.max.add( vector );

		return this;
	},

	expandByScalar: function ( scalar ) {

		this.min.addScalar( -scalar );
		this.max.addScalar( scalar );

		return this;
	},

	containsPoint: function ( point ) {

		if ( point.x < this.min.x || point.x > this.max.x ||
		     point.y < this.min.y || point.y > this.max.y ) {

			return false;

		}

		return true;

	},

	containsBox: function ( box ) {

		if ( ( this.min.x <= box.min.x ) && ( box.max.x <= this.max.x ) &&
		     ( this.min.y <= box.min.y ) && ( box.max.y <= this.max.y ) ) {

			return true;

		}

		return false;

	},

	getParameter: function ( point ) {

		// This can potentially have a divide by zero if the box
		// has a size dimension of 0.

		return new THREE.Vector2(
			( point.x - this.min.x ) / ( this.max.x - this.min.x ),
			( point.y - this.min.y ) / ( this.max.y - this.min.y )
		);

	},

	isIntersectionBox: function ( box ) {

		// using 6 splitting planes to rule out intersections.

		if ( box.max.x < this.min.x || box.min.x > this.max.x ||
		     box.max.y < this.min.y || box.min.y > this.max.y ) {

			return false;

		}

		return true;

	},

	clampPoint: function ( point, optionalTarget ) {

		var result = optionalTarget || new THREE.Vector2();
		return result.copy( point ).clamp( this.min, this.max );

	},

	distanceToPoint: function ( point ) {

		var clampedPoint = THREE.Box2.__v1.copy( point ).clamp( this.min, this.max );
		return clampedPoint.sub( point ).length();

	},

	intersect: function ( box ) {

		this.min.max( box.min );
		this.max.min( box.max );

		return this;

	},

	union: function ( box ) {

		this.min.min( box.min );
		this.max.max( box.max );

		return this;

	},

	translate: function ( offset ) {

		this.min.add( offset );
		this.max.add( offset );

		return this;

	},

	equals: function ( box ) {

		return box.min.equals( this.min ) && box.max.equals( this.max );

	},

	clone: function () {

		return new THREE.Box2().copy( this );

	}

};

THREE.Box2.__v1 = new THREE.Vector2();
/**
 * @author bhouston / http://exocortex.com
 */

THREE.Box3 = function ( min, max ) {

	this.min = ( min !== undefined ) ? min : new THREE.Vector3( Infinity, Infinity, Infinity );
	this.max = ( max !== undefined ) ? max : new THREE.Vector3( -Infinity, -Infinity, -Infinity );

};

THREE.Box3.prototype = {

	constructor: THREE.Box3,

	set: function ( min, max ) {

		this.min.copy( min );
		this.max.copy( max );

		return this;

	},

	setFromPoints: function ( points ) {

		if ( points.length > 0 ) {

			var point = points[ 0 ];

			this.min.copy( point );
			this.max.copy( point );

			for ( var i = 1, il = points.length; i < il; i ++ ) {

				point = points[ i ];

				if ( point.x < this.min.x ) {

					this.min.x = point.x;

				} else if ( point.x > this.max.x ) {

					this.max.x = point.x;

				}

				if ( point.y < this.min.y ) {

					this.min.y = point.y;

				} else if ( point.y > this.max.y ) {

					this.max.y = point.y;

				}

				if ( point.z < this.min.z ) {

					this.min.z = point.z;

				} else if ( point.z > this.max.z ) {

					this.max.z = point.z;

				}

			}

		} else {

			this.makeEmpty();

		}

		return this;

	},

	setFromCenterAndSize: function ( center, size ) {

		var halfSize = THREE.Box3.__v1.copy( size ).multiplyScalar( 0.5 );

		this.min.copy( center ).sub( halfSize );
		this.max.copy( center ).add( halfSize );

		return this;

	},

	copy: function ( box ) {

		this.min.copy( box.min );
		this.max.copy( box.max );

		return this;

	},

	makeEmpty: function () {

		this.min.x = this.min.y = this.min.z = Infinity;
		this.max.x = this.max.y = this.max.z = -Infinity;

		return this;

	},

	empty: function () {

		// this is a more robust check for empty than ( volume <= 0 ) because volume can get positive with two negative axes

		return ( this.max.x < this.min.x ) || ( this.max.y < this.min.y ) || ( this.max.z < this.min.z );

	},

	center: function ( optionalTarget ) {

		var result = optionalTarget || new THREE.Vector3();
		return result.addVectors( this.min, this.max ).multiplyScalar( 0.5 );

	},

	size: function ( optionalTarget ) {

		var result = optionalTarget || new THREE.Vector3();
		return result.subVectors( this.max, this.min );

	},

	expandByPoint: function ( point ) {

		this.min.min( point );
		this.max.max( point );

		return this;

	},

	expandByVector: function ( vector ) {

		this.min.sub( vector );
		this.max.add( vector );

		return this;

	},

	expandByScalar: function ( scalar ) {

		this.min.addScalar( -scalar );
		this.max.addScalar( scalar );

		return this;

	},

	containsPoint: function ( point ) {

		if ( point.x < this.min.x || point.x > this.max.x ||
		     point.y < this.min.y || point.y > this.max.y ||
		     point.z < this.min.z || point.z > this.max.z ) {

			return false;

		}

		return true;

	},

	containsBox: function ( box ) {

		if ( ( this.min.x <= box.min.x ) && ( box.max.x <= this.max.x ) &&
			 ( this.min.y <= box.min.y ) && ( box.max.y <= this.max.y ) &&
			 ( this.min.z <= box.min.z ) && ( box.max.z <= this.max.z ) ) {

			return true;

		}

		return false;

	},

	getParameter: function ( point ) {

		// This can potentially have a divide by zero if the box
		// has a size dimension of 0.

		return new THREE.Vector3(
			( point.x - this.min.x ) / ( this.max.x - this.min.x ),
			( point.y - this.min.y ) / ( this.max.y - this.min.y ),
			( point.z - this.min.z ) / ( this.max.z - this.min.z )
		);

	},

	isIntersectionBox: function ( box ) {

		// using 6 splitting planes to rule out intersections.

		if ( box.max.x < this.min.x || box.min.x > this.max.x ||
		     box.max.y < this.min.y || box.min.y > this.max.y ||
		     box.max.z < this.min.z || box.min.z > this.max.z ) {

			return false;

		}

		return true;

	},

	clampPoint: function ( point, optionalTarget ) {

		var result = optionalTarget || new THREE.Vector3();
		return new THREE.Vector3().copy( point ).clamp( this.min, this.max );

	},

	distanceToPoint: function ( point ) {

		var clampedPoint = THREE.Box3.__v1.copy( point ).clamp( this.min, this.max );
		return clampedPoint.sub( point ).length();

	},

	getBoundingSphere: function ( optionalTarget ) {

		var result = optionalTarget || new THREE.Sphere();

		result.center = this.center();
		result.radius = this.size( THREE.Box3.__v0 ).length() * 0.5;

		return result;

	},

	intersect: function ( box ) {

		this.min.max( box.min );
		this.max.min( box.max );

		return this;

	},

	union: function ( box ) {

		this.min.min( box.min );
		this.max.max( box.max );

		return this;

	},

	transform: function ( matrix ) {

		// NOTE: I am using a binary pattern to specify all 2^3 combinations below
		var newPoints = [
			THREE.Box3.__v0.set( this.min.x, this.min.y, this.min.z ).applyMatrix4( matrix ),
			THREE.Box3.__v0.set( this.min.x, this.min.y, this.min.z ).applyMatrix4( matrix ), // 000
			THREE.Box3.__v1.set( this.min.x, this.min.y, this.max.z ).applyMatrix4( matrix ), // 001
			THREE.Box3.__v2.set( this.min.x, this.max.y, this.min.z ).applyMatrix4( matrix ), // 010
			THREE.Box3.__v3.set( this.min.x, this.max.y, this.max.z ).applyMatrix4( matrix ), // 011
			THREE.Box3.__v4.set( this.max.x, this.min.y, this.min.z ).applyMatrix4( matrix ), // 100
			THREE.Box3.__v5.set( this.max.x, this.min.y, this.max.z ).applyMatrix4( matrix ), // 101
			THREE.Box3.__v6.set( this.max.x, this.max.y, this.min.z ).applyMatrix4( matrix ), // 110
			THREE.Box3.__v7.set( this.max.x, this.max.y, this.max.z ).applyMatrix4( matrix )  // 111
		];

		this.makeEmpty();
		this.setFromPoints( newPoints );

		return this;

	},

	translate: function ( offset ) {

		this.min.add( offset );
		this.max.add( offset );

		return this;

	},

	equals: function ( box ) {

		return box.min.equals( this.min ) && box.max.equals( this.max );

	},

	clone: function () {

		return new THREE.Box3().copy( this );

	}

};

THREE.Box3.__v0 = new THREE.Vector3();
THREE.Box3.__v1 = new THREE.Vector3();
THREE.Box3.__v2 = new THREE.Vector3();
THREE.Box3.__v3 = new THREE.Vector3();
THREE.Box3.__v4 = new THREE.Vector3();
THREE.Box3.__v5 = new THREE.Vector3();
THREE.Box3.__v6 = new THREE.Vector3();
THREE.Box3.__v7 = new THREE.Vector3();
/**
 * @author alteredq / http://alteredqualia.com/
 * @author WestLangley / http://github.com/WestLangley
 * @author bhouston / http://exocortex.com
 */

THREE.Matrix3 = function ( n11, n12, n13, n21, n22, n23, n31, n32, n33 ) {

	this.elements = new Float32Array(9);

	this.set(

		( n11 !== undefined ) ? n11 : 1, n12 || 0, n13 || 0,
		n21 || 0, ( n22 !== undefined ) ? n22 : 1, n23 || 0,
		n31 || 0, n32 || 0, ( n33 !== undefined ) ? n33 : 1

	);
};

THREE.Matrix3.prototype = {

	constructor: THREE.Matrix3,

	set: function ( n11, n12, n13, n21, n22, n23, n31, n32, n33 ) {

		var te = this.elements;

		te[0] = n11; te[3] = n12; te[6] = n13;
		te[1] = n21; te[4] = n22; te[7] = n23;
		te[2] = n31; te[5] = n32; te[8] = n33;

		return this;

	},

	identity: function () {

		this.set(

			1, 0, 0,
			0, 1, 0,
			0, 0, 1

		);

		return this;

	},

	copy: function ( m ) {

		var me = m.elements;

		this.set(

			me[0], me[3], me[6],
			me[1], me[4], me[7],
			me[2], me[5], me[8]

		);

		return this;

	},

	multiplyVector3: function ( vector ) {

		console.warn( 'DEPRECATED: Matrix3\'s .multiplyVector3() has been removed. Use vector.applyMatrix3( matrix ) instead.' );
		return vector.applyMatrix3( this );

	},

	multiplyVector3Array: function ( a ) {

		var tmp = THREE.Matrix3.__v1;

		for ( var i = 0, il = a.length; i < il; i += 3 ) {

			tmp.x = a[ i ];
			tmp.y = a[ i + 1 ];
			tmp.z = a[ i + 2 ];

			tmp.applyMatrix3(this);

			a[ i ]     = tmp.x;
			a[ i + 1 ] = tmp.y;
			a[ i + 2 ] = tmp.z;

		}

		return a;

	},

	multiplyScalar: function ( s ) {

		var te = this.elements;

		te[0] *= s; te[3] *= s; te[6] *= s;
		te[1] *= s; te[4] *= s; te[7] *= s;
		te[2] *= s; te[5] *= s; te[8] *= s;

		return this;

	},

	determinant: function () {

		var te = this.elements;

		var a = te[0], b = te[1], c = te[2],
			d = te[3], e = te[4], f = te[5],
			g = te[6], h = te[7], i = te[8];

		return a*e*i - a*f*h - b*d*i + b*f*g + c*d*h - c*e*g;

	},

	getInverse: function ( matrix, throwOnInvertible ) {

		// input: THREE.Matrix4
		// ( based on http://code.google.com/p/webgl-mjs/ )

		var me = matrix.elements;
		var te = this.elements;

		te[ 0 ] =   me[10] * me[5] - me[6] * me[9];
		te[ 1 ] = - me[10] * me[1] + me[2] * me[9];
		te[ 2 ] =   me[6] * me[1] - me[2] * me[5];
		te[ 3 ] = - me[10] * me[4] + me[6] * me[8];
		te[ 4 ] =   me[10] * me[0] - me[2] * me[8];
		te[ 5 ] = - me[6] * me[0] + me[2] * me[4];
		te[ 6 ] =   me[9] * me[4] - me[5] * me[8];
		te[ 7 ] = - me[9] * me[0] + me[1] * me[8];
		te[ 8 ] =   me[5] * me[0] - me[1] * me[4];

		var det = me[ 0 ] * te[ 0 ] + me[ 1 ] * te[ 3 ] + me[ 2 ] * te[ 6 ];

		// no inverse

		if ( det === 0 ) {

			var msg = "Matrix3.getInverse(): can't invert matrix, determinant is 0";

			if ( throwOnInvertible || false ) {

				throw new Error( msg ); 

			} else {

				console.warn( msg );

			}

			this.identity();

			return this;

		}

		this.multiplyScalar( 1.0 / det );

		return this;

	},


	transpose: function () {

		var tmp, m = this.elements;

		tmp = m[1]; m[1] = m[3]; m[3] = tmp;
		tmp = m[2]; m[2] = m[6]; m[6] = tmp;
		tmp = m[5]; m[5] = m[7]; m[7] = tmp;

		return this;

	},


	transposeIntoArray: function ( r ) {

		var m = this.elements;

		r[ 0 ] = m[ 0 ];
		r[ 1 ] = m[ 3 ];
		r[ 2 ] = m[ 6 ];
		r[ 3 ] = m[ 1 ];
		r[ 4 ] = m[ 4 ];
		r[ 5 ] = m[ 7 ];
		r[ 6 ] = m[ 2 ];
		r[ 7 ] = m[ 5 ];
		r[ 8 ] = m[ 8 ];

		return this;

	},

	clone: function () {

		var te = this.elements;

		return new THREE.Matrix3(

			te[0], te[3], te[6],
			te[1], te[4], te[7],
			te[2], te[5], te[8]

		);

	}

};

THREE.Matrix3.__v1 = new THREE.Vector3();
/**
 * @author mrdoob / http://mrdoob.com/
 * @author supereggbert / http://www.paulbrunt.co.uk/
 * @author philogb / http://blog.thejit.org/
 * @author jordi_ros / http://plattsoft.com
 * @author D1plo1d / http://github.com/D1plo1d
 * @author alteredq / http://alteredqualia.com/
 * @author mikael emtinger / http://gomo.se/
 * @author timknip / http://www.floorplanner.com/
 * @author bhouston / http://exocortex.com
 */


THREE.Matrix4 = function ( n11, n12, n13, n14, n21, n22, n23, n24, n31, n32, n33, n34, n41, n42, n43, n44 ) {

	this.elements = new Float32Array( 16 );

	this.set(

		( n11 !== undefined ) ? n11 : 1, n12 || 0, n13 || 0, n14 || 0,
		n21 || 0, ( n22 !== undefined ) ? n22 : 1, n23 || 0, n24 || 0,
		n31 || 0, n32 || 0, ( n33 !== undefined ) ? n33 : 1, n34 || 0,
		n41 || 0, n42 || 0, n43 || 0, ( n44 !== undefined ) ? n44 : 1

	);

};

THREE.Matrix4.prototype = {

	constructor: THREE.Matrix4,

	set: function ( n11, n12, n13, n14, n21, n22, n23, n24, n31, n32, n33, n34, n41, n42, n43, n44 ) {

		var te = this.elements;

		te[0] = n11; te[4] = n12; te[8] = n13; te[12] = n14;
		te[1] = n21; te[5] = n22; te[9] = n23; te[13] = n24;
		te[2] = n31; te[6] = n32; te[10] = n33; te[14] = n34;
		te[3] = n41; te[7] = n42; te[11] = n43; te[15] = n44;

		return this;

	},

	identity: function () {

		this.set(

			1, 0, 0, 0,
			0, 1, 0, 0,
			0, 0, 1, 0,
			0, 0, 0, 1

		);

		return this;

	},

	copy: function ( m ) {

		var me = m.elements;

		this.set(

			me[0], me[4], me[8], me[12],
			me[1], me[5], me[9], me[13],
			me[2], me[6], me[10], me[14],
			me[3], me[7], me[11], me[15]

		);

		return this;

	},

	setRotationFromEuler: function ( v, order ) {

		var te = this.elements;

		var x = v.x, y = v.y, z = v.z;
		var a = Math.cos( x ), b = Math.sin( x );
		var c = Math.cos( y ), d = Math.sin( y );
		var e = Math.cos( z ), f = Math.sin( z );

		if ( order === undefined || order === 'XYZ' ) {

			var ae = a * e, af = a * f, be = b * e, bf = b * f;

			te[0] = c * e;
			te[4] = - c * f;
			te[8] = d;

			te[1] = af + be * d;
			te[5] = ae - bf * d;
			te[9] = - b * c;

			te[2] = bf - ae * d;
			te[6] = be + af * d;
			te[10] = a * c;

		} else if ( order === 'YXZ' ) {

			var ce = c * e, cf = c * f, de = d * e, df = d * f;

			te[0] = ce + df * b;
			te[4] = de * b - cf;
			te[8] = a * d;

			te[1] = a * f;
			te[5] = a * e;
			te[9] = - b;

			te[2] = cf * b - de;
			te[6] = df + ce * b;
			te[10] = a * c;

		} else if ( order === 'ZXY' ) {

			var ce = c * e, cf = c * f, de = d * e, df = d * f;

			te[0] = ce - df * b;
			te[4] = - a * f;
			te[8] = de + cf * b;

			te[1] = cf + de * b;
			te[5] = a * e;
			te[9] = df - ce * b;

			te[2] = - a * d;
			te[6] = b;
			te[10] = a * c;

		} else if ( order === 'ZYX' ) {

			var ae = a * e, af = a * f, be = b * e, bf = b * f;

			te[0] = c * e;
			te[4] = be * d - af;
			te[8] = ae * d + bf;

			te[1] = c * f;
			te[5] = bf * d + ae;
			te[9] = af * d - be;

			te[2] = - d;
			te[6] = b * c;
			te[10] = a * c;

		} else if ( order === 'YZX' ) {

			var ac = a * c, ad = a * d, bc = b * c, bd = b * d;

			te[0] = c * e;
			te[4] = bd - ac * f;
			te[8] = bc * f + ad;

			te[1] = f;
			te[5] = a * e;
			te[9] = - b * e;

			te[2] = - d * e;
			te[6] = ad * f + bc;
			te[10] = ac - bd * f;

		} else if ( order === 'XZY' ) {

			var ac = a * c, ad = a * d, bc = b * c, bd = b * d;

			te[0] = c * e;
			te[4] = - f;
			te[8] = d * e;

			te[1] = ac * f + bd;
			te[5] = a * e;
			te[9] = ad * f - bc;

			te[2] = bc * f - ad;
			te[6] = b * e;
			te[10] = bd * f + ac;

		}

		return this;

	},

	setRotationFromQuaternion: function ( q ) {

		var te = this.elements;

		var x = q.x, y = q.y, z = q.z, w = q.w;
		var x2 = x + x, y2 = y + y, z2 = z + z;
		var xx = x * x2, xy = x * y2, xz = x * z2;
		var yy = y * y2, yz = y * z2, zz = z * z2;
		var wx = w * x2, wy = w * y2, wz = w * z2;

		te[0] = 1 - ( yy + zz );
		te[4] = xy - wz;
		te[8] = xz + wy;

		te[1] = xy + wz;
		te[5] = 1 - ( xx + zz );
		te[9] = yz - wx;

		te[2] = xz - wy;
		te[6] = yz + wx;
		te[10] = 1 - ( xx + yy );

		return this;

	},

	lookAt: function ( eye, target, up ) {

		var te = this.elements;

		var x = THREE.Matrix4.__v1;
		var y = THREE.Matrix4.__v2;
		var z = THREE.Matrix4.__v3;

		z.subVectors( eye, target ).normalize();

		if ( z.length() === 0 ) {

			z.z = 1;

		}

		x.crossVectors( up, z ).normalize();

		if ( x.length() === 0 ) {

			z.x += 0.0001;
			x.crossVectors( up, z ).normalize();

		}

		y.crossVectors( z, x );


		te[0] = x.x; te[4] = y.x; te[8] = z.x;
		te[1] = x.y; te[5] = y.y; te[9] = z.y;
		te[2] = x.z; te[6] = y.z; te[10] = z.z;

		return this;

	},

	multiply: function ( m, n ) {

		if ( n !== undefined ) {

			console.warn( 'DEPRECATED: Matrix4\'s .multiply() now only accepts one argument. Use .multiplyMatrices( a, b ) instead.' );
			return this.multiplyMatrices( m, n );

		}

		return this.multiplyMatrices( this, m );

	},

	multiplyMatrices: function ( a, b ) {

		var ae = a.elements;
		var be = b.elements;
		var te = this.elements;

		var a11 = ae[0], a12 = ae[4], a13 = ae[8], a14 = ae[12];
		var a21 = ae[1], a22 = ae[5], a23 = ae[9], a24 = ae[13];
		var a31 = ae[2], a32 = ae[6], a33 = ae[10], a34 = ae[14];
		var a41 = ae[3], a42 = ae[7], a43 = ae[11], a44 = ae[15];

		var b11 = be[0], b12 = be[4], b13 = be[8], b14 = be[12];
		var b21 = be[1], b22 = be[5], b23 = be[9], b24 = be[13];
		var b31 = be[2], b32 = be[6], b33 = be[10], b34 = be[14];
		var b41 = be[3], b42 = be[7], b43 = be[11], b44 = be[15];

		te[0] = a11 * b11 + a12 * b21 + a13 * b31 + a14 * b41;
		te[4] = a11 * b12 + a12 * b22 + a13 * b32 + a14 * b42;
		te[8] = a11 * b13 + a12 * b23 + a13 * b33 + a14 * b43;
		te[12] = a11 * b14 + a12 * b24 + a13 * b34 + a14 * b44;

		te[1] = a21 * b11 + a22 * b21 + a23 * b31 + a24 * b41;
		te[5] = a21 * b12 + a22 * b22 + a23 * b32 + a24 * b42;
		te[9] = a21 * b13 + a22 * b23 + a23 * b33 + a24 * b43;
		te[13] = a21 * b14 + a22 * b24 + a23 * b34 + a24 * b44;

		te[2] = a31 * b11 + a32 * b21 + a33 * b31 + a34 * b41;
		te[6] = a31 * b12 + a32 * b22 + a33 * b32 + a34 * b42;
		te[10] = a31 * b13 + a32 * b23 + a33 * b33 + a34 * b43;
		te[14] = a31 * b14 + a32 * b24 + a33 * b34 + a34 * b44;

		te[3] = a41 * b11 + a42 * b21 + a43 * b31 + a44 * b41;
		te[7] = a41 * b12 + a42 * b22 + a43 * b32 + a44 * b42;
		te[11] = a41 * b13 + a42 * b23 + a43 * b33 + a44 * b43;
		te[15] = a41 * b14 + a42 * b24 + a43 * b34 + a44 * b44;

		return this;

	},

	multiplyToArray: function ( a, b, r ) {

		var te = this.elements;

		this.multiplyMatrices( a, b );

		r[ 0 ] = te[0]; r[ 1 ] = te[1]; r[ 2 ] = te[2]; r[ 3 ] = te[3];
		r[ 4 ] = te[4]; r[ 5 ] = te[5]; r[ 6 ] = te[6]; r[ 7 ] = te[7];
		r[ 8 ]  = te[8]; r[ 9 ]  = te[9]; r[ 10 ] = te[10]; r[ 11 ] = te[11];
		r[ 12 ] = te[12]; r[ 13 ] = te[13]; r[ 14 ] = te[14]; r[ 15 ] = te[15];

		return this;

	},

	multiplyScalar: function ( s ) {

		var te = this.elements;

		te[0] *= s; te[4] *= s; te[8] *= s; te[12] *= s;
		te[1] *= s; te[5] *= s; te[9] *= s; te[13] *= s;
		te[2] *= s; te[6] *= s; te[10] *= s; te[14] *= s;
		te[3] *= s; te[7] *= s; te[11] *= s; te[15] *= s;

		return this;

	},

	multiplyVector3: function ( vector ) {

//		console.warn( 'DEPRECATED: Matrix4\'s .multiplyVector3() has been removed. Use vector.applyMatrix4( matrix ) or vector.applyProjection( matrix ) instead.' );
		return vector.applyProjection( this );

	},

	multiplyVector4: function ( vector ) {

		//console.warn( 'DEPRECATED: Matrix4\'s .multiplyVector4() has been removed. Use vector.applyMatrix4( matrix ) instead.' );
		return vector.applyMatrix4( this );

	},

	multiplyVector3Array: function ( a ) {

		var tmp = THREE.Matrix4.__v1;

		for ( var i = 0, il = a.length; i < il; i += 3 ) {

			tmp.x = a[ i ];
			tmp.y = a[ i + 1 ];
			tmp.z = a[ i + 2 ];

			tmp.applyProjection( this );

			a[ i ]     = tmp.x;
			a[ i + 1 ] = tmp.y;
			a[ i + 2 ] = tmp.z;

		}

		return a;

	},

	rotateAxis: function ( v ) {

		var te = this.elements;
		var vx = v.x, vy = v.y, vz = v.z;

		v.x = vx * te[0] + vy * te[4] + vz * te[8];
		v.y = vx * te[1] + vy * te[5] + vz * te[9];
		v.z = vx * te[2] + vy * te[6] + vz * te[10];

		v.normalize();

		return v;

	},

	crossVector: function ( a ) {

		var te = this.elements;
		var v = new THREE.Vector4();

		v.x = te[0] * a.x + te[4] * a.y + te[8] * a.z + te[12] * a.w;
		v.y = te[1] * a.x + te[5] * a.y + te[9] * a.z + te[13] * a.w;
		v.z = te[2] * a.x + te[6] * a.y + te[10] * a.z + te[14] * a.w;

		v.w = ( a.w ) ? te[3] * a.x + te[7] * a.y + te[11] * a.z + te[15] * a.w : 1;

		return v;

	},

	determinant: function () {

		var te = this.elements;

		var n11 = te[0], n12 = te[4], n13 = te[8], n14 = te[12];
		var n21 = te[1], n22 = te[5], n23 = te[9], n24 = te[13];
		var n31 = te[2], n32 = te[6], n33 = te[10], n34 = te[14];
		var n41 = te[3], n42 = te[7], n43 = te[11], n44 = te[15];

		//TODO: make this more efficient
		//( based on http://www.euclideanspace.com/maths/algebra/matrix/functions/inverse/fourD/index.htm )

		return (
			n41 * (
				+n14 * n23 * n32
				-n13 * n24 * n32
				-n14 * n22 * n33
				+n12 * n24 * n33
				+n13 * n22 * n34
				-n12 * n23 * n34
			) +
			n42 * (
				+n11 * n23 * n34
				-n11 * n24 * n33
				+n14 * n21 * n33
				-n13 * n21 * n34
				+n13 * n24 * n31
				-n14 * n23 * n31
			) +
			n43 * (
				+n11 * n24 * n32
				-n11 * n22 * n34
				-n14 * n21 * n32
				+n12 * n21 * n34
				+n14 * n22 * n31
				-n12 * n24 * n31
			) +
			n44 * (
				-n13 * n22 * n31
				-n11 * n23 * n32
				+n11 * n22 * n33
				+n13 * n21 * n32
				-n12 * n21 * n33
				+n12 * n23 * n31
			)

		);

	},

	transpose: function () {

		var te = this.elements;
		var tmp;

		tmp = te[1]; te[1] = te[4]; te[4] = tmp;
		tmp = te[2]; te[2] = te[8]; te[8] = tmp;
		tmp = te[6]; te[6] = te[9]; te[9] = tmp;

		tmp = te[3]; te[3] = te[12]; te[12] = tmp;
		tmp = te[7]; te[7] = te[13]; te[13] = tmp;
		tmp = te[11]; te[11] = te[14]; te[14] = tmp;

		return this;

	},

	flattenToArray: function ( flat ) {

		var te = this.elements;
		flat[ 0 ] = te[0]; flat[ 1 ] = te[1]; flat[ 2 ] = te[2]; flat[ 3 ] = te[3];
		flat[ 4 ] = te[4]; flat[ 5 ] = te[5]; flat[ 6 ] = te[6]; flat[ 7 ] = te[7];
		flat[ 8 ] = te[8]; flat[ 9 ] = te[9]; flat[ 10 ] = te[10]; flat[ 11 ] = te[11];
		flat[ 12 ] = te[12]; flat[ 13 ] = te[13]; flat[ 14 ] = te[14]; flat[ 15 ] = te[15];

		return flat;

	},

	flattenToArrayOffset: function( flat, offset ) {

		var te = this.elements;
		flat[ offset ] = te[0];
		flat[ offset + 1 ] = te[1];
		flat[ offset + 2 ] = te[2];
		flat[ offset + 3 ] = te[3];

		flat[ offset + 4 ] = te[4];
		flat[ offset + 5 ] = te[5];
		flat[ offset + 6 ] = te[6];
		flat[ offset + 7 ] = te[7];

		flat[ offset + 8 ]  = te[8];
		flat[ offset + 9 ]  = te[9];
		flat[ offset + 10 ] = te[10];
		flat[ offset + 11 ] = te[11];

		flat[ offset + 12 ] = te[12];
		flat[ offset + 13 ] = te[13];
		flat[ offset + 14 ] = te[14];
		flat[ offset + 15 ] = te[15];

		return flat;

	},

	getPosition: function () {

		var te = this.elements;
		return THREE.Matrix4.__v1.set( te[12], te[13], te[14] );

	},

	setPosition: function ( v ) {

		var te = this.elements;

		te[12] = v.x;
		te[13] = v.y;
		te[14] = v.z;

		return this;

	},

	getColumnX: function () {

		var te = this.elements;
		return THREE.Matrix4.__v1.set( te[0], te[1], te[2] );

	},

	getColumnY: function () {

		var te = this.elements;
		return THREE.Matrix4.__v1.set( te[4], te[5], te[6] );

	},

	getColumnZ: function() {

		var te = this.elements;
		return THREE.Matrix4.__v1.set( te[8], te[9], te[10] );

	},

	getInverse: function ( m, throwOnInvertible ) {

		// based on http://www.euclideanspace.com/maths/algebra/matrix/functions/inverse/fourD/index.htm
		var te = this.elements;
		var me = m.elements;

		var n11 = me[0], n12 = me[4], n13 = me[8], n14 = me[12];
		var n21 = me[1], n22 = me[5], n23 = me[9], n24 = me[13];
		var n31 = me[2], n32 = me[6], n33 = me[10], n34 = me[14];
		var n41 = me[3], n42 = me[7], n43 = me[11], n44 = me[15];

		te[0] = n23*n34*n42 - n24*n33*n42 + n24*n32*n43 - n22*n34*n43 - n23*n32*n44 + n22*n33*n44;
		te[4] = n14*n33*n42 - n13*n34*n42 - n14*n32*n43 + n12*n34*n43 + n13*n32*n44 - n12*n33*n44;
		te[8] = n13*n24*n42 - n14*n23*n42 + n14*n22*n43 - n12*n24*n43 - n13*n22*n44 + n12*n23*n44;
		te[12] = n14*n23*n32 - n13*n24*n32 - n14*n22*n33 + n12*n24*n33 + n13*n22*n34 - n12*n23*n34;
		te[1] = n24*n33*n41 - n23*n34*n41 - n24*n31*n43 + n21*n34*n43 + n23*n31*n44 - n21*n33*n44;
		te[5] = n13*n34*n41 - n14*n33*n41 + n14*n31*n43 - n11*n34*n43 - n13*n31*n44 + n11*n33*n44;
		te[9] = n14*n23*n41 - n13*n24*n41 - n14*n21*n43 + n11*n24*n43 + n13*n21*n44 - n11*n23*n44;
		te[13] = n13*n24*n31 - n14*n23*n31 + n14*n21*n33 - n11*n24*n33 - n13*n21*n34 + n11*n23*n34;
		te[2] = n22*n34*n41 - n24*n32*n41 + n24*n31*n42 - n21*n34*n42 - n22*n31*n44 + n21*n32*n44;
		te[6] = n14*n32*n41 - n12*n34*n41 - n14*n31*n42 + n11*n34*n42 + n12*n31*n44 - n11*n32*n44;
		te[10] = n12*n24*n41 - n14*n22*n41 + n14*n21*n42 - n11*n24*n42 - n12*n21*n44 + n11*n22*n44;
		te[14] = n14*n22*n31 - n12*n24*n31 - n14*n21*n32 + n11*n24*n32 + n12*n21*n34 - n11*n22*n34;
		te[3] = n23*n32*n41 - n22*n33*n41 - n23*n31*n42 + n21*n33*n42 + n22*n31*n43 - n21*n32*n43;
		te[7] = n12*n33*n41 - n13*n32*n41 + n13*n31*n42 - n11*n33*n42 - n12*n31*n43 + n11*n32*n43;
		te[11] = n13*n22*n41 - n12*n23*n41 - n13*n21*n42 + n11*n23*n42 + n12*n21*n43 - n11*n22*n43;
		te[15] = n12*n23*n31 - n13*n22*n31 + n13*n21*n32 - n11*n23*n32 - n12*n21*n33 + n11*n22*n33;

		var det = me[ 0 ] * te[ 0 ] + me[ 1 ] * te[ 4 ] + me[ 2 ] * te[ 8 ] + me[ 3 ] * te[ 12 ];

		if ( det == 0 ) {

			var msg = "Matrix4.getInverse(): can't invert matrix, determinant is 0";

			if ( throwOnInvertible || false ) {

				throw new Error( msg ); 

			} else {

				console.warn( msg );

			}

			this.identity();

			return this;
		}

		this.multiplyScalar( 1 / det );

		return this;

	},

	compose: function ( translation, rotation, scale ) {

		var te = this.elements;
		var mRotation = THREE.Matrix4.__m1;
		var mScale = THREE.Matrix4.__m2;

		mRotation.identity();
		mRotation.setRotationFromQuaternion( rotation );

		mScale.makeScale( scale.x, scale.y, scale.z );

		this.multiplyMatrices( mRotation, mScale );

		te[12] = translation.x;
		te[13] = translation.y;
		te[14] = translation.z;

		return this;

	},

	decompose: function ( translation, rotation, scale ) {

		var te = this.elements;

		// grab the axis vectors
		var x = THREE.Matrix4.__v1;
		var y = THREE.Matrix4.__v2;
		var z = THREE.Matrix4.__v3;

		x.set( te[0], te[1], te[2] );
		y.set( te[4], te[5], te[6] );
		z.set( te[8], te[9], te[10] );

		translation = ( translation instanceof THREE.Vector3 ) ? translation : new THREE.Vector3();
		rotation = ( rotation instanceof THREE.Quaternion ) ? rotation : new THREE.Quaternion();
		scale = ( scale instanceof THREE.Vector3 ) ? scale : new THREE.Vector3();

		scale.x = x.length();
		scale.y = y.length();
		scale.z = z.length();

		translation.x = te[12];
		translation.y = te[13];
		translation.z = te[14];

		// scale the rotation part

		var matrix = THREE.Matrix4.__m1;

		matrix.copy( this );

		matrix.elements[0] /= scale.x;
		matrix.elements[1] /= scale.x;
		matrix.elements[2] /= scale.x;

		matrix.elements[4] /= scale.y;
		matrix.elements[5] /= scale.y;
		matrix.elements[6] /= scale.y;

		matrix.elements[8] /= scale.z;
		matrix.elements[9] /= scale.z;
		matrix.elements[10] /= scale.z;

		rotation.setFromRotationMatrix( matrix );

		return [ translation, rotation, scale ];

	},

	extractPosition: function ( m ) {

		var te = this.elements;
		var me = m.elements;

		te[12] = me[12];
		te[13] = me[13];
		te[14] = me[14];

		return this;

	},

	extractRotation: function ( m ) {

		var te = this.elements;
		var me = m.elements;

		var vector = THREE.Matrix4.__v1;

		var scaleX = 1 / vector.set( me[0], me[1], me[2] ).length();
		var scaleY = 1 / vector.set( me[4], me[5], me[6] ).length();
		var scaleZ = 1 / vector.set( me[8], me[9], me[10] ).length();

		te[0] = me[0] * scaleX;
		te[1] = me[1] * scaleX;
		te[2] = me[2] * scaleX;

		te[4] = me[4] * scaleY;
		te[5] = me[5] * scaleY;
		te[6] = me[6] * scaleY;

		te[8] = me[8] * scaleZ;
		te[9] = me[9] * scaleZ;
		te[10] = me[10] * scaleZ;

		return this;

	},

	//

	translate: function ( v ) {

		var te = this.elements;
		var x = v.x, y = v.y, z = v.z;

		te[12] = te[0] * x + te[4] * y + te[8] * z + te[12];
		te[13] = te[1] * x + te[5] * y + te[9] * z + te[13];
		te[14] = te[2] * x + te[6] * y + te[10] * z + te[14];
		te[15] = te[3] * x + te[7] * y + te[11] * z + te[15];

		return this;

	},

	rotateX: function ( angle ) {

		var te = this.elements;
		var m12 = te[4];
		var m22 = te[5];
		var m32 = te[6];
		var m42 = te[7];
		var m13 = te[8];
		var m23 = te[9];
		var m33 = te[10];
		var m43 = te[11];
		var c = Math.cos( angle );
		var s = Math.sin( angle );

		te[4] = c * m12 + s * m13;
		te[5] = c * m22 + s * m23;
		te[6] = c * m32 + s * m33;
		te[7] = c * m42 + s * m43;

		te[8] = c * m13 - s * m12;
		te[9] = c * m23 - s * m22;
		te[10] = c * m33 - s * m32;
		te[11] = c * m43 - s * m42;

		return this;

	},

	rotateY: function ( angle ) {

		var te = this.elements;
		var m11 = te[0];
		var m21 = te[1];
		var m31 = te[2];
		var m41 = te[3];
		var m13 = te[8];
		var m23 = te[9];
		var m33 = te[10];
		var m43 = te[11];
		var c = Math.cos( angle );
		var s = Math.sin( angle );

		te[0] = c * m11 - s * m13;
		te[1] = c * m21 - s * m23;
		te[2] = c * m31 - s * m33;
		te[3] = c * m41 - s * m43;

		te[8] = c * m13 + s * m11;
		te[9] = c * m23 + s * m21;
		te[10] = c * m33 + s * m31;
		te[11] = c * m43 + s * m41;

		return this;

	},

	rotateZ: function ( angle ) {

		var te = this.elements;
		var m11 = te[0];
		var m21 = te[1];
		var m31 = te[2];
		var m41 = te[3];
		var m12 = te[4];
		var m22 = te[5];
		var m32 = te[6];
		var m42 = te[7];
		var c = Math.cos( angle );
		var s = Math.sin( angle );

		te[0] = c * m11 + s * m12;
		te[1] = c * m21 + s * m22;
		te[2] = c * m31 + s * m32;
		te[3] = c * m41 + s * m42;

		te[4] = c * m12 - s * m11;
		te[5] = c * m22 - s * m21;
		te[6] = c * m32 - s * m31;
		te[7] = c * m42 - s * m41;

		return this;

	},

	rotateByAxis: function ( axis, angle ) {

		var te = this.elements;

		// optimize by checking axis

		if ( axis.x === 1 && axis.y === 0 && axis.z === 0 ) {

			return this.rotateX( angle );

		} else if ( axis.x === 0 && axis.y === 1 && axis.z === 0 ) {

			return this.rotateY( angle );

		} else if ( axis.x === 0 && axis.y === 0 && axis.z === 1 ) {

			return this.rotateZ( angle );

		}

		var x = axis.x, y = axis.y, z = axis.z;
		var n = Math.sqrt(x * x + y * y + z * z);

		x /= n;
		y /= n;
		z /= n;

		var xx = x * x, yy = y * y, zz = z * z;
		var c = Math.cos( angle );
		var s = Math.sin( angle );
		var oneMinusCosine = 1 - c;
		var xy = x * y * oneMinusCosine;
		var xz = x * z * oneMinusCosine;
		var yz = y * z * oneMinusCosine;
		var xs = x * s;
		var ys = y * s;
		var zs = z * s;

		var r11 = xx + (1 - xx) * c;
		var r21 = xy + zs;
		var r31 = xz - ys;
		var r12 = xy - zs;
		var r22 = yy + (1 - yy) * c;
		var r32 = yz + xs;
		var r13 = xz + ys;
		var r23 = yz - xs;
		var r33 = zz + (1 - zz) * c;

		var m11 = te[0], m21 = te[1], m31 = te[2], m41 = te[3];
		var m12 = te[4], m22 = te[5], m32 = te[6], m42 = te[7];
		var m13 = te[8], m23 = te[9], m33 = te[10], m43 = te[11];
		var m14 = te[12], m24 = te[13], m34 = te[14], m44 = te[15];

		te[0] = r11 * m11 + r21 * m12 + r31 * m13;
		te[1] = r11 * m21 + r21 * m22 + r31 * m23;
		te[2] = r11 * m31 + r21 * m32 + r31 * m33;
		te[3] = r11 * m41 + r21 * m42 + r31 * m43;

		te[4] = r12 * m11 + r22 * m12 + r32 * m13;
		te[5] = r12 * m21 + r22 * m22 + r32 * m23;
		te[6] = r12 * m31 + r22 * m32 + r32 * m33;
		te[7] = r12 * m41 + r22 * m42 + r32 * m43;

		te[8] = r13 * m11 + r23 * m12 + r33 * m13;
		te[9] = r13 * m21 + r23 * m22 + r33 * m23;
		te[10] = r13 * m31 + r23 * m32 + r33 * m33;
		te[11] = r13 * m41 + r23 * m42 + r33 * m43;

		return this;

	},

	scale: function ( v ) {

		var te = this.elements;
		var x = v.x, y = v.y, z = v.z;

		te[0] *= x; te[4] *= y; te[8] *= z;
		te[1] *= x; te[5] *= y; te[9] *= z;
		te[2] *= x; te[6] *= y; te[10] *= z;
		te[3] *= x; te[7] *= y; te[11] *= z;

		return this;

	},

	getMaxScaleOnAxis: function () {

		var te = this.elements;

		var scaleXSq = te[0] * te[0] + te[1] * te[1] + te[2] * te[2];
		var scaleYSq = te[4] * te[4] + te[5] * te[5] + te[6] * te[6];
		var scaleZSq = te[8] * te[8] + te[9] * te[9] + te[10] * te[10];

		return Math.sqrt( Math.max( scaleXSq, Math.max( scaleYSq, scaleZSq ) ) );

	},

	//

	makeTranslation: function ( x, y, z ) {

		this.set(

			1, 0, 0, x,
			0, 1, 0, y,
			0, 0, 1, z,
			0, 0, 0, 1

		);

		return this;

	},

	makeRotationX: function ( theta ) {

		var c = Math.cos( theta ), s = Math.sin( theta );

		this.set(

			1, 0,  0, 0,
			0, c, -s, 0,
			0, s,  c, 0,
			0, 0,  0, 1

		);

		return this;

	},

	makeRotationY: function ( theta ) {

		var c = Math.cos( theta ), s = Math.sin( theta );

		this.set(

			 c, 0, s, 0,
			 0, 1, 0, 0,
			-s, 0, c, 0,
			 0, 0, 0, 1

		);

		return this;

	},

	makeRotationZ: function ( theta ) {

		var c = Math.cos( theta ), s = Math.sin( theta );

		this.set(

			c, -s, 0, 0,
			s,  c, 0, 0,
			0,  0, 1, 0,
			0,  0, 0, 1

		);

		return this;

	},

	makeRotationAxis: function ( axis, angle ) {

		// Based on http://www.gamedev.net/reference/articles/article1199.asp

		var c = Math.cos( angle );
		var s = Math.sin( angle );
		var t = 1 - c;
		var x = axis.x, y = axis.y, z = axis.z;
		var tx = t * x, ty = t * y;

		this.set(

			tx * x + c, tx * y - s * z, tx * z + s * y, 0,
			tx * y + s * z, ty * y + c, ty * z - s * x, 0,
			tx * z - s * y, ty * z + s * x, t * z * z + c, 0,
			0, 0, 0, 1

		);

		 return this;

	},

	makeScale: function ( x, y, z ) {

		this.set(

			x, 0, 0, 0,
			0, y, 0, 0,
			0, 0, z, 0,
			0, 0, 0, 1

		);

		return this;

	},

	makeFrustum: function ( left, right, bottom, top, near, far ) {

		var te = this.elements;
		var x = 2 * near / ( right - left );
		var y = 2 * near / ( top - bottom );

		var a = ( right + left ) / ( right - left );
		var b = ( top + bottom ) / ( top - bottom );
		var c = - ( far + near ) / ( far - near );
		var d = - 2 * far * near / ( far - near );

		te[0] = x;	te[4] = 0;	te[8] = a;	te[12] = 0;
		te[1] = 0;	te[5] = y;	te[9] = b;	te[13] = 0;
		te[2] = 0;	te[6] = 0;	te[10] = c;	te[14] = d;
		te[3] = 0;	te[7] = 0;	te[11] = - 1;	te[15] = 0;

		return this;

	},

	makePerspective: function ( fov, aspect, near, far ) {

		var ymax = near * Math.tan( THREE.Math.degToRad( fov * 0.5 ) );
		var ymin = - ymax;
		var xmin = ymin * aspect;
		var xmax = ymax * aspect;

		return this.makeFrustum( xmin, xmax, ymin, ymax, near, far );

	},

	makeOrthographic: function ( left, right, top, bottom, near, far ) {

		var te = this.elements;
		var w = right - left;
		var h = top - bottom;
		var p = far - near;

		var x = ( right + left ) / w;
		var y = ( top + bottom ) / h;
		var z = ( far + near ) / p;

		te[0] = 2 / w;	te[4] = 0;	te[8] = 0;	te[12] = -x;
		te[1] = 0;	te[5] = 2 / h;	te[9] = 0;	te[13] = -y;
		te[2] = 0;	te[6] = 0;	te[10] = -2/p;	te[14] = -z;
		te[3] = 0;	te[7] = 0;	te[11] = 0;	te[15] = 1;

		return this;

	},

	clone: function () {

		var te = this.elements;

		return new THREE.Matrix4(

			te[0], te[4], te[8], te[12],
			te[1], te[5], te[9], te[13],
			te[2], te[6], te[10], te[14],
			te[3], te[7], te[11], te[15]

		);

	}

};

THREE.Matrix4.__v1 = new THREE.Vector3();
THREE.Matrix4.__v2 = new THREE.Vector3();
THREE.Matrix4.__v3 = new THREE.Vector3();

THREE.Matrix4.__m1 = new THREE.Matrix4();
THREE.Matrix4.__m2 = new THREE.Matrix4();
/**
 * @author bhouston / http://exocortex.com
 */

THREE.Ray = function ( origin, direction ) {

	this.origin = ( origin !== undefined ) ? origin : new THREE.Vector3();
	this.direction = ( direction !== undefined ) ? direction : new THREE.Vector3();

};

THREE.Ray.prototype = {

	constructor: THREE.Ray,

	set: function ( origin, direction ) {

		this.origin.copy( origin );
		this.direction.copy( direction );

		return this;

	},

	copy: function ( ray ) {

		this.origin.copy( ray.origin );
		this.direction.copy( ray.direction );

		return this;

	},

	at: function( t, optionalTarget ) {

		var result = optionalTarget || new THREE.Vector3();

		return result.copy( this.direction ).multiplyScalar( t ).add( this.origin );

	},

	recast: function ( t ) {

		this.origin.copy( this.at( t, THREE.Ray.__v1 ) );

		return this;

	},

	closestPointToPoint: function ( point, optionalTarget ) {

		var result = optionalTarget || new THREE.Vector3();
		result.subVectors( point, this.origin );
		var directionDistance = result.dot( this.direction );

		return result.copy( this.direction ).multiplyScalar( directionDistance ).add( this.origin );

	},

	distanceToPoint: function ( point ) {

		var directionDistance = THREE.Ray.__v1.subVectors( point, this.origin ).dot( this.direction );
		THREE.Ray.__v1.copy( this.direction ).multiplyScalar( directionDistance ).add( this.origin );

		return THREE.Ray.__v1.distanceTo( point );

	},

	isIntersectionSphere: function( sphere ) {

		return ( this.distanceToPoint( sphere.center ) <= sphere.radius );

	},

	isIntersectionPlane: function ( plane ) {

		// check if the line and plane are non-perpendicular, if they
		// eventually they will intersect.
		var denominator = plane.normal.dot( this.direction );
		if ( denominator != 0 ) {

			return true;

		}

		// line is coplanar, return origin
		if( plane.distanceToPoint( this.origin ) == 0 ) {

			return true;

		}

		return false;

	},

	distanceToPlane: function ( plane ) {

		var denominator = plane.normal.dot( this.direction );
		if ( denominator == 0 ) {

			// line is coplanar, return origin
			if( plane.distanceToPoint( this.origin ) == 0 ) {

				return 0;

			}

			// Unsure if this is the correct method to handle this case.
			return undefined;

		}

		var t = - ( this.origin.dot( plane.normal ) + plane.constant ) / denominator;

		return t;

	},

	intersectPlane: function ( plane, optionalTarget ) {

		var t = this.distanceToPlane( plane );

		if( t === undefined ) {

			return undefined;
		}

		return this.at( t, optionalTarget );

	},

	transform: function ( matrix4 ) {

		this.direction.add( this.origin ).applyMatrix4( matrix4 );
		this.origin.applyMatrix4( matrix4 );
		this.direction.sub( this.origin );

		return this;
	},

	equals: function ( ray ) {

		return ray.origin.equals( this.origin ) && ray.direction.equals( this.direction );

	},

	clone: function () {

		return new THREE.Ray().copy( this );

	}

};

THREE.Ray.__v1 = new THREE.Vector3();
THREE.Ray.__v2 = new THREE.Vector3();
/**
 * @author bhouston / http://exocortex.com
 * @author mrdoob / http://mrdoob.com/
 */

THREE.Sphere = function ( center, radius ) {

	this.center = ( center !== undefined ) ? center : new THREE.Vector3();
	this.radius = ( radius !== undefined ) ? radius : 0;

};

THREE.Sphere.prototype = {

	constructor: THREE.Sphere,

	set: function ( center, radius ) {

		this.center.copy( center );
		this.radius = radius;

		return this;
	},

	setFromCenterAndPoints: function ( center, points ) {

		var maxRadiusSq = 0;

		for ( var i = 0, il = points.length; i < il; i ++ ) {

			var radiusSq = center.distanceToSquared( points[ i ] );
			maxRadiusSq = Math.max( maxRadiusSq, radiusSq );

		}

		this.center = center;
		this.radius = Math.sqrt( maxRadiusSq );

		return this;

	},

	copy: function ( sphere ) {

		this.center.copy( sphere.center );
		this.radius = sphere.radius;

		return this;

	},

	empty: function () {

		return ( this.radius <= 0 );

	},

	containsPoint: function ( point ) {

		return ( point.distanceToSquared( this.center ) <= ( this.radius * this.radius ) );

	},

	distanceToPoint: function ( point ) {

		return ( point.distanceTo( this.center ) - this.radius );

	},

	intersectsSphere: function ( sphere ) {

		var radiusSum = this.radius + sphere.radius;

		return sphere.center.distanceToSquared( this.center ) <= ( radiusSum * radiusSum );

	},

	clampPoint: function ( point, optionalTarget ) {

		var deltaLengthSq = this.center.distanceToSquared( point );

		var result = optionalTarget || new THREE.Vector3();
		result.copy( point );

		if ( deltaLengthSq > ( this.radius * this.radius ) ) {

			result.sub( this.center ).normalize();
			result.multiplyScalar( this.radius ).add( this.center );

		}

		return result;

	},

	getBoundingBox: function ( optionalTarget ) {

		var box = optionalTarget || new THREE.Box3();

		box.set( this.center, this.center );
		box.expandByScalar( this.radius );

		return box;

	},

	transform: function ( matrix ) {

		this.center.applyMatrix4( matrix );
		this.radius = this.radius * matrix.getMaxScaleOnAxis();

		return this;

	},

	translate: function ( offset ) {

		this.center.add( offset );

		return this;

	},

	equals: function ( sphere ) {

		return sphere.center.equals( this.center ) && ( sphere.radius === this.radius );

	},

	clone: function () {

		return new THREE.Sphere().copy( this );

	}

};
/**
 * @author mrdoob / http://mrdoob.com/
 * @author alteredq / http://alteredqualia.com/
 * @author bhouston / http://exocortex.com
 */

THREE.Frustum = function ( p0, p1, p2, p3, p4, p5 ) {

	this.planes = [

		( p0 !== undefined ) ? p0 : new THREE.Plane(),
		( p1 !== undefined ) ? p1 : new THREE.Plane(),
		( p2 !== undefined ) ? p2 : new THREE.Plane(),
		( p3 !== undefined ) ? p3 : new THREE.Plane(),
		( p4 !== undefined ) ? p4 : new THREE.Plane(),
		( p5 !== undefined ) ? p5 : new THREE.Plane()

	];

};

THREE.Frustum.prototype = {

	set: function ( p0, p1, p2, p3, p4, p5 ) {

		var planes = this.planes;

		planes[0].copy( p0 );
		planes[1].copy( p1 );
		planes[2].copy( p2 );
		planes[3].copy( p3 );
		planes[4].copy( p4 );
		planes[5].copy( p5 );

		return this;

	},

	copy: function ( frustum ) {

		var planes = this.planes;

		for( var i = 0; i < 6; i ++ ) {

			planes[i].copy( frustum.planes[i] );

		}

		return this;

	},

	setFromMatrix: function ( m ) {

		var planes = this.planes;
		var me = m.elements;
		var me0 = me[0], me1 = me[1], me2 = me[2], me3 = me[3];
		var me4 = me[4], me5 = me[5], me6 = me[6], me7 = me[7];
		var me8 = me[8], me9 = me[9], me10 = me[10], me11 = me[11];
		var me12 = me[12], me13 = me[13], me14 = me[14], me15 = me[15];

		planes[ 0 ].setComponents( me3 - me0, me7 - me4, me11 - me8, me15 - me12 ).normalize();
		planes[ 1 ].setComponents( me3 + me0, me7 + me4, me11 + me8, me15 + me12 ).normalize();
		planes[ 2 ].setComponents( me3 + me1, me7 + me5, me11 + me9, me15 + me13 ).normalize();
		planes[ 3 ].setComponents( me3 - me1, me7 - me5, me11 - me9, me15 - me13 ).normalize();
		planes[ 4 ].setComponents( me3 - me2, me7 - me6, me11 - me10, me15 - me14 ).normalize();
		planes[ 5 ].setComponents( me3 + me2, me7 + me6, me11 + me10, me15 + me14 ).normalize();

		return this;

	},

	intersectsObject: function ( object ) {

		// this method is expanded inlined for performance reasons.
		var matrix = object.matrixWorld;
		var planes = this.planes;
		var center = matrix.getPosition();
		var negRadius = - object.geometry.boundingSphere.radius * matrix.getMaxScaleOnAxis();

		for ( var i = 0; i < 6; i ++ ) {

			var distance = planes[ i ].distanceToPoint( center );

			if( distance < negRadius ) {

				return false;

			}

		}

		return true;

	},

	intersectsSphere: function ( sphere ) {

		var planes = this.planes;
		var center = sphere.center;
		var negRadius = -sphere.radius;

		for ( var i = 0; i < 6; i ++ ) {

			var distance = planes[ i ].distanceToPoint( center );

			if( distance < negRadius ) {

				return false;

			}

		}

		return true;

	},

	containsPoint: function ( point ) {

		var planes = this.planes;

		for ( var i = 0; i < 6; i ++ ) {

			if( planes[ i ].distanceToPoint( point ) < 0 ) {

				return false;

			}

		}

		return true;

	},

	// TODO: Instead of this, change places where these are called instead
	contains: function( object ) {
		return this.intersectsObject(object);
	},
	containsSphere: function( sphere ) {
		return this.intersectsSphere(sphere);
	},
	
	
	clone: function () {

		return new THREE.Frustum().copy( this );

	}

};
/**
 * @author bhouston / http://exocortex.com
 */

THREE.Plane = function ( normal, constant ) {

	this.normal = ( normal !== undefined ) ? normal : new THREE.Vector3( 1, 0, 0 );
	this.constant = ( constant !== undefined ) ? constant : 0;

};

THREE.Plane.prototype = {

	constructor: THREE.Plane,

	set: function ( normal, constant ) {

		this.normal.copy( normal );
		this.constant = constant;

		return this;

	},

	setComponents: function ( x, y, z, w ) {

		this.normal.set( x, y, z );
		this.constant = w;

		return this;

	},

	setFromNormalAndCoplanarPoint: function ( normal, point ) {

		this.normal.copy( normal );
		this.constant = - point.dot( this.normal );	// must be this.normal, not normal, as this.normal is normalized

		return this;

	},

	setFromCoplanarPoints: function ( a, b, c ) {

		var normal = THREE.Plane.__v1.subVectors( c, b ).cross( THREE.Plane.__v2.subVectors( a, b ) ).normalize();

		// Q: should an error be thrown if normal is zero (e.g. degenerate plane)?

		this.setFromNormalAndCoplanarPoint( normal, a );

		return this;

	},

	copy: function ( plane ) {

		this.normal.copy( plane.normal );
		this.constant = plane.constant;

		return this;

	},

	normalize: function () {

		// Note: will lead to a divide by zero if the plane is invalid.

		var inverseNormalLength = 1.0 / this.normal.length();
		this.normal.multiplyScalar( inverseNormalLength );
		this.constant *= inverseNormalLength;

		return this;

	},

	negate: function () {

		this.constant *= -1;
		this.normal.negate();

		return this;

	},

	distanceToPoint: function ( point ) {

		return this.normal.dot( point ) + this.constant;

	},

	distanceToSphere: function ( sphere ) {

		return this.distanceToPoint( sphere.center ) - sphere.radius;

	},

	projectPoint: function ( point, optionalTarget ) {

		return this.orthoPoint( point, optionalTarget ).sub( point ).negate();

	},

	orthoPoint: function ( point, optionalTarget ) {

		var perpendicularMagnitude = this.distanceToPoint( point );

		var result = optionalTarget || new THREE.Vector3();
		return result.copy( this.normal ).multiplyScalar( perpendicularMagnitude );

	},

	isIntersectionLine: function ( startPoint, endPoint ) {

		// Note: this tests if a line intersects the plane, not whether it (or its end-points) are coplanar with it.

		var startSign = this.distanceToPoint( startPoint );
		
		var endSign = this.distanceToPoint( endPoint );

		return ( startSign < 0 && endSign > 0 ) || ( endSign < 0 && startSign > 0 );

	},

	intersectLine: function ( startPoint, endPoint, optionalTarget ) {

		var result = optionalTarget || new THREE.Vector3();

		var direction = THREE.Plane.__v1.subVectors( endPoint, startPoint );

		var denominator = this.normal.dot( direction );

		if ( denominator == 0 ) {

			// line is coplanar, return origin
			if( this.distanceToPoint( startPoint ) == 0 ) {

				return result.copy( startPoint );

			}

			// Unsure if this is the correct method to handle this case.
			return undefined;

		}

		var t = - ( startPoint.dot( this.normal ) + this.constant ) / denominator;

		if( t < 0 || t > 1 ) {

			return undefined;

		}

		return result.copy( direction ).multiplyScalar( t ).add( startPoint );

	},

	coplanarPoint: function ( optionalTarget ) {

		var result = optionalTarget || new THREE.Vector3();
		return result.copy( this.normal ).multiplyScalar( - this.constant );

	},

	transform: function ( matrix, optionalNormalMatrix ) {

		// compute new normal based on theory here:
		// http://www.songho.ca/opengl/gl_normaltransform.html
		optionalNormalMatrix = optionalNormalMatrix || new THREE.Matrix3().getInverse( matrix ).transpose();
		var newNormal = THREE.Plane.__v1.copy( this.normal ).applyMatrix3( optionalNormalMatrix );

		var newCoplanarPoint = this.coplanarPoint( THREE.Plane.__v2 );
		newCoplanarPoint.applyMatrix4( matrix );

		this.setFromNormalAndCoplanarPoint( newNormal, newCoplanarPoint );

		return this;

	},

	translate: function ( offset ) {

		this.constant = this.constant - offset.dot( this.normal );

		return this;

	},

	equals: function ( plane ) {

		return plane.normal.equals( this.normal ) && ( plane.constant == this.constant );

	},

	clone: function () {

		return new THREE.Plane().copy( this );

	}

};

THREE.Plane.__vZero = new THREE.Vector3( 0, 0, 0 );
THREE.Plane.__v1 = new THREE.Vector3();
THREE.Plane.__v2 = new THREE.Vector3();
/**
 * @author alteredq / http://alteredqualia.com/
 */

THREE.Math = {

	// Clamp value to range <a, b>

	clamp: function ( x, a, b ) {

		return ( x < a ) ? a : ( ( x > b ) ? b : x );

	},

	// Clamp value to range <a, inf)

	clampBottom: function ( x, a ) {

		return x < a ? a : x;

	},

	// Linear mapping from range <a1, a2> to range <b1, b2>

	mapLinear: function ( x, a1, a2, b1, b2 ) {

		return b1 + ( x - a1 ) * ( b2 - b1 ) / ( a2 - a1 );

	},

	// Random float from <0, 1> with 16 bits of randomness
	// (standard Math.random() creates repetitive patterns when applied over larger space)

	random16: function () {

		return ( 65280 * Math.random() + 255 * Math.random() ) / 65535;

	},

	// Random integer from <low, high> interval

	randInt: function ( low, high ) {

		return low + Math.floor( Math.random() * ( high - low + 1 ) );

	},

	// Random float from <low, high> interval

	randFloat: function ( low, high ) {

		return low + Math.random() * ( high - low );

	},

	// Random float from <-range/2, range/2> interval

	randFloatSpread: function ( range ) {

		return range * ( 0.5 - Math.random() );

	},

	sign: function ( x ) {

		return ( x < 0 ) ? -1 : ( ( x > 0 ) ? 1 : 0 );

	},

	degToRad: function ( degrees ) {

		return degrees * THREE.Math.__d2r;

	},

	radToDeg: function ( radians ) {

		return radians * THREE.Math.__r2d;

	}

};

THREE.Math.__d2r =  Math.PI / 180;
THREE.Math.__r2d =  180 / Math.PI;
/**
 * Spline from Tween.js, slightly optimized (and trashed)
 * http://sole.github.com/tween.js/examples/05_spline.html
 *
 * @author mrdoob / http://mrdoob.com/
 * @author alteredq / http://alteredqualia.com/
 */

THREE.Spline = function ( points ) {

	this.points = points;

	var c = [], v3 = { x: 0, y: 0, z: 0 },
	point, intPoint, weight, w2, w3,
	pa, pb, pc, pd;

	this.initFromArray = function( a ) {

		this.points = [];

		for ( var i = 0; i < a.length; i++ ) {

			this.points[ i ] = { x: a[ i ][ 0 ], y: a[ i ][ 1 ], z: a[ i ][ 2 ] };

		}

	};

	this.getPoint = function ( k ) {

		point = ( this.points.length - 1 ) * k;
		intPoint = Math.floor( point );
		weight = point - intPoint;

		c[ 0 ] = intPoint === 0 ? intPoint : intPoint - 1;
		c[ 1 ] = intPoint;
		c[ 2 ] = intPoint  > this.points.length - 2 ? this.points.length - 1 : intPoint + 1;
		c[ 3 ] = intPoint  > this.points.length - 3 ? this.points.length - 1 : intPoint + 2;

		pa = this.points[ c[ 0 ] ];
		pb = this.points[ c[ 1 ] ];
		pc = this.points[ c[ 2 ] ];
		pd = this.points[ c[ 3 ] ];

		w2 = weight * weight;
		w3 = weight * w2;

		v3.x = interpolate( pa.x, pb.x, pc.x, pd.x, weight, w2, w3 );
		v3.y = interpolate( pa.y, pb.y, pc.y, pd.y, weight, w2, w3 );
		v3.z = interpolate( pa.z, pb.z, pc.z, pd.z, weight, w2, w3 );

		return v3;

	};

	this.getControlPointsArray = function () {

		var i, p, l = this.points.length,
			coords = [];

		for ( i = 0; i < l; i ++ ) {

			p = this.points[ i ];
			coords[ i ] = [ p.x, p.y, p.z ];

		}

		return coords;

	};

	// approximate length by summing linear segments

	this.getLength = function ( nSubDivisions ) {

		var i, index, nSamples, position,
			point = 0, intPoint = 0, oldIntPoint = 0,
			oldPosition = new THREE.Vector3(),
			tmpVec = new THREE.Vector3(),
			chunkLengths = [],
			totalLength = 0;

		// first point has 0 length

		chunkLengths[ 0 ] = 0;

		if ( !nSubDivisions ) nSubDivisions = 100;

		nSamples = this.points.length * nSubDivisions;

		oldPosition.copy( this.points[ 0 ] );

		for ( i = 1; i < nSamples; i ++ ) {

			index = i / nSamples;

			position = this.getPoint( index );
			tmpVec.copy( position );

			totalLength += tmpVec.distanceTo( oldPosition );

			oldPosition.copy( position );

			point = ( this.points.length - 1 ) * index;
			intPoint = Math.floor( point );

			if ( intPoint != oldIntPoint ) {

				chunkLengths[ intPoint ] = totalLength;
				oldIntPoint = intPoint;

			}

		}

		// last point ends with total length

		chunkLengths[ chunkLengths.length ] = totalLength;

		return { chunks: chunkLengths, total: totalLength };

	};

	this.reparametrizeByArcLength = function ( samplingCoef ) {

		var i, j,
			index, indexCurrent, indexNext,
			linearDistance, realDistance,
			sampling, position,
			newpoints = [],
			tmpVec = new THREE.Vector3(),
			sl = this.getLength();

		newpoints.push( tmpVec.copy( this.points[ 0 ] ).clone() );

		for ( i = 1; i < this.points.length; i++ ) {

			//tmpVec.copy( this.points[ i - 1 ] );
			//linearDistance = tmpVec.distanceTo( this.points[ i ] );

			realDistance = sl.chunks[ i ] - sl.chunks[ i - 1 ];

			sampling = Math.ceil( samplingCoef * realDistance / sl.total );

			indexCurrent = ( i - 1 ) / ( this.points.length - 1 );
			indexNext = i / ( this.points.length - 1 );

			for ( j = 1; j < sampling - 1; j++ ) {

				index = indexCurrent + j * ( 1 / sampling ) * ( indexNext - indexCurrent );

				position = this.getPoint( index );
				newpoints.push( tmpVec.copy( position ).clone() );

			}

			newpoints.push( tmpVec.copy( this.points[ i ] ).clone() );

		}

		this.points = newpoints;

	};

	// Catmull-Rom

	function interpolate( p0, p1, p2, p3, t, t2, t3 ) {

		var v0 = ( p2 - p0 ) * 0.5,
			v1 = ( p3 - p1 ) * 0.5;

		return ( 2 * ( p1 - p2 ) + v0 + v1 ) * t3 + ( - 3 * ( p1 - p2 ) - 2 * v0 - v1 ) * t2 + v0 * t + p1;

	};

};
/**
 * @author bhouston / http://exocortex.com
 * @author mrdoob / http://mrdoob.com/
 */

THREE.Triangle = function ( a, b, c ) {

	this.a = ( a !== undefined ) ? a : new THREE.Vector3();
	this.b = ( b !== undefined ) ? b : new THREE.Vector3();
	this.c = ( c !== undefined ) ? c : new THREE.Vector3();

};

THREE.Triangle.normal = function( a, b, c, optionalTarget ) {

	var result = optionalTarget || new THREE.Vector3();

	result.subVectors( c, b );
	THREE.Triangle.__v0.subVectors( a, b );
	result.cross( THREE.Triangle.__v0 );

	var resultLengthSq = result.lengthSq();
	if( resultLengthSq > 0 ) {

		return result.multiplyScalar( 1 / Math.sqrt( resultLengthSq ) );

	}

	return result.set( 0, 0, 0 );

};

// static/instance method to calculate barycoordinates
// based on: http://www.blackpawn.com/texts/pointinpoly/default.html
THREE.Triangle.barycoordFromPoint = function ( point, a, b, c, optionalTarget ) {

	THREE.Triangle.__v0.subVectors( c, a );
	THREE.Triangle.__v1.subVectors( b, a );
	THREE.Triangle.__v2.subVectors( point, a );

	var dot00 = THREE.Triangle.__v0.dot( THREE.Triangle.__v0 );
	var dot01 = THREE.Triangle.__v0.dot( THREE.Triangle.__v1 );
	var dot02 = THREE.Triangle.__v0.dot( THREE.Triangle.__v2 );
	var dot11 = THREE.Triangle.__v1.dot( THREE.Triangle.__v1 );
	var dot12 = THREE.Triangle.__v1.dot( THREE.Triangle.__v2 );

	var denom = ( dot00 * dot11 - dot01 * dot01 );

	var result = optionalTarget || new THREE.Vector3();

	// colinear or singular triangle
	if( denom == 0 ) {
		// arbitrary location outside of triangle?
		// not sure if this is the best idea, maybe should be returning undefined
		return result.set( -2, -1, -1 );
	}

	var invDenom = 1 / denom;
	var u = ( dot11 * dot02 - dot01 * dot12 ) * invDenom;
	var v = ( dot00 * dot12 - dot01 * dot02 ) * invDenom;

	// barycoordinates must always sum to 1
	return result.set( 1 - u - v, v, u );

};

THREE.Triangle.containsPoint = function ( point, a, b, c ) {

	// NOTE: need to use __v3 here because __v0, __v1 and __v2 are used in barycoordFromPoint.
	var result = THREE.Triangle.barycoordFromPoint( point, a, b, c, THREE.Triangle.__v3 );

	return ( result.x >= 0 ) && ( result.y >= 0 ) && ( ( result.x + result.y ) <= 1 );

};

THREE.Triangle.prototype = {

	constructor: THREE.Triangle,

	set: function ( a, b, c ) {

		this.a.copy( a );
		this.b.copy( b );
		this.c.copy( c );

		return this;

	},

	setFromPointsAndIndices: function ( points, i0, i1, i2 ) {

		this.a.copy( points[i0] );
		this.b.copy( points[i1] );
		this.c.copy( points[i2] );

		return this;

	},

	copy: function ( triangle ) {

		this.a.copy( triangle.a );
		this.b.copy( triangle.b );
		this.c.copy( triangle.c );

		return this;

	},

	area: function () {

		THREE.Triangle.__v0.subVectors( this.c, this.b );
		THREE.Triangle.__v1.subVectors( this.a, this.b );

		return THREE.Triangle.__v0.cross( THREE.Triangle.__v1 ).length() * 0.5;

	},

	midpoint: function ( optionalTarget ) {

		var result = optionalTarget || new THREE.Vector3();
		return result.addVectors( this.a, this.b ).add( this.c ).multiplyScalar( 1 / 3 );

	},

	normal: function ( optionalTarget ) {

		return THREE.Triangle.normal( this.a, this.b, this.c, optionalTarget );

	},

	plane: function ( optionalTarget ) {

		var result = optionalTarget || new THREE.Plane();

		return result.setFromCoplanarPoints( this.a, this.b, this.c );

	},

	barycoordFromPoint: function ( point, optionalTarget ) {

		return THREE.Triangle.barycoordFromPoint( point, this.a, this.b, this.c, optionalTarget );

	},

	containsPoint: function ( point ) {

		return THREE.Triangle.containsPoint( point, this.a, this.b, this.c );

	},

	equals: function ( triangle ) {

		return triangle.a.equals( this.a ) && triangle.b.equals( this.b ) && triangle.c.equals( this.c );

	},

	clone: function () {

		return new THREE.Triangle().copy( this );

	}

};

THREE.Triangle.__v0 = new THREE.Vector3();
THREE.Triangle.__v1 = new THREE.Vector3();
THREE.Triangle.__v2 = new THREE.Vector3();
THREE.Triangle.__v3 = new THREE.Vector3();
/**
 * @author mrdoob / http://mrdoob.com/
 */

THREE.Vertex = function ( v ) {

	console.warn( 'THREE.Vertex has been DEPRECATED. Use THREE.Vector3 instead.')
	return v;

};
/**
 * @author mrdoob / http://mrdoob.com/
 */

THREE.UV = function ( u, v ) {

	console.warn( 'THREE.UV has been DEPRECATED. Use THREE.Vector2 instead.')
	return new THREE.Vector2( u, v );

};
/**
 * @author alteredq / http://alteredqualia.com/
 */

THREE.Clock = function ( autoStart ) {

	this.autoStart = ( autoStart !== undefined ) ? autoStart : true;

	this.startTime = 0;
	this.oldTime = 0;
	this.elapsedTime = 0;

	this.running = false;

};

THREE.Clock.prototype.start = function () {

	this.startTime = Date.now();
	this.oldTime = this.startTime;

	this.running = true;

};

THREE.Clock.prototype.stop = function () {

	this.getElapsedTime();

	this.running = false;

};

THREE.Clock.prototype.getElapsedTime = function () {

	this.getDelta();

	return this.elapsedTime;

};


THREE.Clock.prototype.getDelta = function () {

	var diff = 0;

	if ( this.autoStart && ! this.running ) {

		this.start();

	}

	if ( this.running ) {

		var newTime = Date.now();
		diff = 0.001 * ( newTime - this.oldTime );
		this.oldTime = newTime;

		this.elapsedTime += diff;

	}

	return diff;

};/**
 * https://github.com/mrdoob/eventdispatcher.js/
 */

THREE.EventDispatcher = function () {

	var listeners = {};

	this.addEventListener = function ( type, listener ) {

		if ( listeners[ type ] === undefined ) {

			listeners[ type ] = [];

		}

		if ( listeners[ type ].indexOf( listener ) === - 1 ) {

			listeners[ type ].push( listener );

		}

	};

	this.removeEventListener = function ( type, listener ) {

		var index = listeners[ type ].indexOf( listener );

		if ( index !== - 1 ) {

			listeners[ type ].splice( index, 1 );

		}

	};

	this.dispatchEvent = function ( event ) {

		var listenerArray = listeners[ event.type ];

		if ( listenerArray !== undefined ) {

			event.target = this;

			for ( var i = 0, l = listenerArray.length; i < l; i ++ ) {

				listenerArray[ i ].call( this, event );

			}

		}

	};

};
/**
 * @author mrdoob / http://mrdoob.com/
 * @author bhouston / http://exocortex.com/
 */

( function ( THREE ) {

	THREE.Raycaster = function ( origin, direction, near, far ) {

		this.ray = new THREE.Ray( origin, direction );
		
		// normalized ray.direction required for accurate distance calculations
		if( this.ray.direction.length() > 0 ) {

			this.ray.direction.normalize();

		}

		this.near = near || 0;
		this.far = far || Infinity;

	};

	var sphere = new THREE.Sphere();
	var localRay = new THREE.Ray();
	var facePlane = new THREE.Plane();
	var intersectPoint = new THREE.Vector3();

	var inverseMatrix = new THREE.Matrix4();

	var descSort = function ( a, b ) {

		return a.distance - b.distance;

	};

	var intersectObject = function ( object, raycaster, intersects ) {

		if ( object instanceof THREE.Particle ) {

			var distance = raycaster.ray.distanceToPoint( object.matrixWorld.getPosition() );

			if ( distance > object.scale.x ) {

				return intersects;

			}

			intersects.push( {

				distance: distance,
				point: object.position,
				face: null,
				object: object

			} );

		} else if ( object instanceof THREE.Mesh ) {

			// Checking boundingSphere distance to ray
			sphere.set(
				object.matrixWorld.getPosition(),
				object.geometry.boundingSphere.radius* object.matrixWorld.getMaxScaleOnAxis() );

			if ( ! raycaster.ray.isIntersectionSphere( sphere ) ) {

				return intersects;

			}

			// Checking faces

			var geometry = object.geometry;
			var vertices = geometry.vertices;

			var isFaceMaterial = object.material instanceof THREE.MeshFaceMaterial;
			var objectMaterials = isFaceMaterial === true ? object.material.materials : null;

			var side = object.material.side;

			var a, b, c, d;
			var precision = raycaster.precision;

			object.matrixRotationWorld.extractRotation( object.matrixWorld );

			inverseMatrix.getInverse( object.matrixWorld );

			localRay.copy( raycaster.ray ).transform( inverseMatrix );
	
			for ( var f = 0, fl = geometry.faces.length; f < fl; f ++ ) {

				var face = geometry.faces[ f ];

				var material = isFaceMaterial === true ? objectMaterials[ face.materialIndex ] : object.material;

				if ( material === undefined ) continue;
				
				facePlane.setFromNormalAndCoplanarPoint( face.normal, vertices[face.a] );

				var planeDistance = localRay.distanceToPlane( facePlane );
	
				// bail if raycaster and plane are parallel
				if ( Math.abs( planeDistance ) < precision ) continue;
	
				// if negative distance, then plane is behind raycaster
				if ( planeDistance < 0 ) continue;

				// check if we hit the wrong side of a single sided face
				side = material.side;
				if( side !== THREE.DoubleSide ) {

					var planeSign = localRay.direction.dot( facePlane.normal );

					if( ! ( side === THREE.FrontSide ? planeSign < 0 : planeSign > 0 ) ) continue;

				}

				// this can be done using the planeDistance from localRay because localRay wasn't normalized, but ray was
				if ( planeDistance < raycaster.near || planeDistance > raycaster.far ) continue;
				
				intersectPoint = localRay.at( planeDistance, intersectPoint ); // passing in intersectPoint avoids a copy

				if ( face instanceof THREE.Face3 ) {

					a = vertices[ face.a ];
					b = vertices[ face.b ];
					c = vertices[ face.c ];

					if ( ! THREE.Triangle.containsPoint( intersectPoint, a, b, c ) ) continue;

				} else if ( face instanceof THREE.Face4 ) {

					a = vertices[ face.a ];
					b = vertices[ face.b ];
					c = vertices[ face.c ];
					d = vertices[ face.d ];

					if ( ( ! THREE.Triangle.containsPoint( intersectPoint, a, b, d ) ) &&
						 ( ! THREE.Triangle.containsPoint( intersectPoint, b, c, d ) ) ) continue;

				} else {

					// This is added because if we call out of this if/else group when none of the cases
					//    match it will add a point to the intersection list erroneously.
					throw Error( "face type not supported" );

				}

				intersects.push( {

					distance: planeDistance,	// this works because the original ray was normalized, and the transformed localRay wasn't
					point: raycaster.ray.at( planeDistance ),
					face: face,
					faceIndex: f,
					object: object

				} );

			}

		}

	};

	var intersectDescendants = function ( object, raycaster, intersects ) {

		var descendants = object.getDescendants();

		for ( var i = 0, l = descendants.length; i < l; i ++ ) {

			intersectObject( descendants[ i ], raycaster, intersects );

		}
	};

	//

	THREE.Raycaster.prototype.precision = 0.0001;

	THREE.Raycaster.prototype.set = function ( origin, direction ) {

		this.ray.set( origin, direction );

		// normalized ray.direction required for accurate distance calculations
		if( this.ray.direction.length() > 0 ) {

			this.ray.direction.normalize();

		}

	};

	THREE.Raycaster.prototype.intersectObject = function ( object, recursive ) {

		var intersects = [];

		if ( recursive === true ) {

			intersectDescendants( object, this, intersects );

		}

		intersectObject( object, this, intersects );

		intersects.sort( descSort );

		return intersects;

	};

	THREE.Raycaster.prototype.intersectObjects = function ( objects, recursive ) {

		var intersects = [];

		for ( var i = 0, l = objects.length; i < l; i ++ ) {

			intersectObject( objects[ i ], this, intersects );

			if ( recursive === true ) {

				intersectDescendants( objects[ i ], this, intersects );

			}
		}

		intersects.sort( descSort );

		return intersects;

	};

}( THREE ) );
/**
 * @author mrdoob / http://mrdoob.com/
 * @author mikael emtinger / http://gomo.se/
 * @author alteredq / http://alteredqualia.com/
 */

THREE.Object3D = function () {

	this.id = THREE.Object3DIdCount ++;

	this.name = '';
	this.properties = {};

	this.parent = undefined;
	this.children = [];

	this.up = new THREE.Vector3( 0, 1, 0 );

	this.position = new THREE.Vector3();
	this.rotation = new THREE.Vector3();
	this.eulerOrder = THREE.Object3D.defaultEulerOrder;
	this.scale = new THREE.Vector3( 1, 1, 1 );

	this.renderDepth = null;

	this.rotationAutoUpdate = true;

	this.matrix = new THREE.Matrix4();
	this.matrixWorld = new THREE.Matrix4();
	this.matrixRotationWorld = new THREE.Matrix4();

	this.matrixAutoUpdate = true;
	this.matrixWorldNeedsUpdate = true;

	this.quaternion = new THREE.Quaternion();
	this.useQuaternion = false;

	this.visible = true;

	this.castShadow = false;
	this.receiveShadow = false;

	this.frustumCulled = true;

	this._vector = new THREE.Vector3();

};


THREE.Object3D.prototype = {

	constructor: THREE.Object3D,

	applyMatrix: function ( matrix ) {

		this.matrix.multiplyMatrices( matrix, this.matrix );

		this.scale.getScaleFromMatrix( this.matrix );

		var mat = new THREE.Matrix4().extractRotation( this.matrix );
		this.rotation.setEulerFromRotationMatrix( mat, this.eulerOrder );

		this.position.getPositionFromMatrix( this.matrix );

	},

	translate: function ( distance, axis ) {

		this.matrix.rotateAxis( axis );
		this.position.add( axis.multiplyScalar( distance ) );

	},

	translateX: function ( distance ) {

		this.translate( distance, this._vector.set( 1, 0, 0 ) );

	},

	translateY: function ( distance ) {

		this.translate( distance, this._vector.set( 0, 1, 0 ) );

	},

	translateZ: function ( distance ) {

		this.translate( distance, this._vector.set( 0, 0, 1 ) );

	},

	localToWorld: function ( vector ) {

		return vector.applyMatrix4( this.matrixWorld );

	},

	worldToLocal: function ( vector ) {

		return vector.applyMatrix4( THREE.Object3D.__m1.getInverse( this.matrixWorld ) );

	},

	lookAt: function ( vector ) {

		// TODO: Add hierarchy support.

		this.matrix.lookAt( vector, this.position, this.up );

		if ( this.rotationAutoUpdate ) {

			if ( this.useQuaternion === false )  {

				this.rotation.setEulerFromRotationMatrix( this.matrix, this.eulerOrder );

			} else {

				this.quaternion.copy( this.matrix.decompose()[ 1 ] );

			}

		}

	},

	add: function ( object ) {

		if ( object === this ) {

			console.warn( 'THREE.Object3D.add: An object can\'t be added as a child of itself.' );
			return;

		}

		if ( object instanceof THREE.Object3D ) {

			if ( object.parent !== undefined ) {

				object.parent.remove( object );

			}

			object.parent = this;
			this.children.push( object );

			// add to scene

			var scene = this;

			while ( scene.parent !== undefined ) {

				scene = scene.parent;

			}

			if ( scene !== undefined && scene instanceof THREE.Scene )  {

				scene.__addObject( object );

			}

		}

	},

	remove: function ( object ) {

		var index = this.children.indexOf( object );

		if ( index !== - 1 ) {

			object.parent = undefined;
			this.children.splice( index, 1 );

			// remove from scene

			var scene = this;

			while ( scene.parent !== undefined ) {

				scene = scene.parent;

			}

			if ( scene !== undefined && scene instanceof THREE.Scene ) {

				scene.__removeObject( object );

			}

		}

	},

	traverse: function ( callback ) {

		callback( this );

		for ( var i = 0, l = this.children.length; i < l; i ++ ) {

			this.children[ i ].traverse( callback );

		}

	},

	getChildByName: function ( name, recursive ) {

		for ( var i = 0, l = this.children.length; i < l; i ++ ) {

			var child = this.children[ i ];

			if ( child.name === name ) {

				return child;

			}

			if ( recursive === true ) {

				child = child.getChildByName( name, recursive );

				if ( child !== undefined ) {

					return child;

				}

			}

		}

		return undefined;

	},

	getDescendants: function ( array ) {

		if ( array === undefined ) array = [];

		Array.prototype.push.apply( array, this.children );

		for ( var i = 0, l = this.children.length; i < l; i ++ ) {

			this.children[ i ].getDescendants( array );

		}

		return array;

	},

	updateMatrix: function () {

		this.matrix.setPosition( this.position );

		if ( this.useQuaternion === false )  {

			this.matrix.setRotationFromEuler( this.rotation, this.eulerOrder );

		} else {

			this.matrix.setRotationFromQuaternion( this.quaternion );

		}

		if ( this.scale.x !== 1 || this.scale.y !== 1 || this.scale.z !== 1 ) {

			this.matrix.scale( this.scale );

		}

		this.matrixWorldNeedsUpdate = true;

	},

	updateMatrixWorld: function ( force ) {

		if ( this.matrixAutoUpdate === true ) this.updateMatrix();

		if ( this.matrixWorldNeedsUpdate === true || force === true ) {

			if ( this.parent === undefined ) {

				this.matrixWorld.copy( this.matrix );

			} else {

				this.matrixWorld.multiplyMatrices( this.parent.matrixWorld, this.matrix );

			}

			this.matrixWorldNeedsUpdate = false;

			force = true;

		}

		// update children

		for ( var i = 0, l = this.children.length; i < l; i ++ ) {

			this.children[ i ].updateMatrixWorld( force );

		}

	},

	clone: function ( object ) {

		if ( object === undefined ) object = new THREE.Object3D();

		object.name = this.name;

		object.up.copy( this.up );

		object.position.copy( this.position );
		if ( object.rotation instanceof THREE.Vector3 ) object.rotation.copy( this.rotation ); // because of Sprite madness
		object.eulerOrder = this.eulerOrder;
		object.scale.copy( this.scale );

		object.renderDepth = this.renderDepth;

		object.rotationAutoUpdate = this.rotationAutoUpdate;

		object.matrix.copy( this.matrix );
		object.matrixWorld.copy( this.matrixWorld );
		object.matrixRotationWorld.copy( this.matrixRotationWorld );

		object.matrixAutoUpdate = this.matrixAutoUpdate;
		object.matrixWorldNeedsUpdate = this.matrixWorldNeedsUpdate;

		object.quaternion.copy( this.quaternion );
		object.useQuaternion = this.useQuaternion;

		object.visible = this.visible;

		object.castShadow = this.castShadow;
		object.receiveShadow = this.receiveShadow;

		object.frustumCulled = this.frustumCulled;

		for ( var i = 0; i < this.children.length; i ++ ) {

			var child = this.children[ i ];
			object.add( child.clone() );

		}

		return object;

	}

};

THREE.Object3D.__m1 = new THREE.Matrix4();
THREE.Object3D.defaultEulerOrder = 'XYZ',

THREE.Object3DIdCount = 0;
/**
 * @author mrdoob / http://mrdoob.com/
 * @author supereggbert / http://www.paulbrunt.co.uk/
 * @author julianwa / https://github.com/julianwa
 */

THREE.Projector = function() {

	var _object, _objectCount, _objectPool = [], _objectPoolLength = 0,
	_vertex, _vertexCount, _vertexPool = [], _vertexPoolLength = 0,
	_face, _face3Count, _face3Pool = [], _face3PoolLength = 0,
	_face4Count, _face4Pool = [], _face4PoolLength = 0,
	_line, _lineCount, _linePool = [], _linePoolLength = 0,
	_particle, _particleCount, _particlePool = [], _particlePoolLength = 0,

	_renderData = { objects: [], sprites: [], lights: [], elements: [] },

	_vector3 = new THREE.Vector3(),
	_vector4 = new THREE.Vector4(),

	_clipBox = new THREE.Box3( new THREE.Vector3( -1, -1, -1 ), new THREE.Vector3( 1, 1, 1 ) ),
	_boundingBox = new THREE.Box3(),
	_points3 = new Array( 3 ),
	_points4 = new Array( 4 ),

	_viewMatrix = new THREE.Matrix4(),
	_viewProjectionMatrix = new THREE.Matrix4(),

	_modelMatrix,
	_modelViewProjectionMatrix = new THREE.Matrix4(),

	_normalMatrix = new THREE.Matrix3(),
	_normalViewMatrix = new THREE.Matrix3(),

	_centroid = new THREE.Vector3(),

	_frustum = new THREE.Frustum(),

	_clippedVertex1PositionScreen = new THREE.Vector4(),
	_clippedVertex2PositionScreen = new THREE.Vector4(),

	_face3VertexNormals;

	this.projectVector = function ( vector, camera ) {

		camera.matrixWorldInverse.getInverse( camera.matrixWorld );

		_viewProjectionMatrix.multiplyMatrices( camera.projectionMatrix, camera.matrixWorldInverse );

		return vector.applyProjection( _viewProjectionMatrix );

	};

	this.unprojectVector = function ( vector, camera ) {

		camera.projectionMatrixInverse.getInverse( camera.projectionMatrix );

		_viewProjectionMatrix.multiplyMatrices( camera.matrixWorld, camera.projectionMatrixInverse );

		return vector.applyProjection( _viewProjectionMatrix );

	};

	this.pickingRay = function ( vector, camera ) {

		// set two vectors with opposing z values
		vector.z = -1.0;
		var end = new THREE.Vector3( vector.x, vector.y, 1.0 );

		this.unprojectVector( vector, camera );
		this.unprojectVector( end, camera );

		// find direction from vector to end
		end.sub( vector ).normalize();

		return new THREE.Raycaster( vector, end );

	};

	var projectGraph = function ( root, sortObjects ) {

		_objectCount = 0;

		_renderData.objects.length = 0;
		_renderData.sprites.length = 0;
		_renderData.lights.length = 0;

		var projectObject = function ( parent ) {

			for ( var c = 0, cl = parent.children.length; c < cl; c ++ ) {

				var object = parent.children[ c ];

				if ( object.visible === false ) continue;

				if ( object instanceof THREE.Light ) {

					_renderData.lights.push( object );

				} else if ( object instanceof THREE.Mesh || object instanceof THREE.Line ) {

					if ( object.frustumCulled === false || _frustum.intersectsObject( object ) === true ) {

						_object = getNextObjectInPool();
						_object.object = object;

						if ( object.renderDepth !== null ) {

							_object.z = object.renderDepth;

						} else {

							_vector3.copy( object.matrixWorld.getPosition() );
							_vector3.applyProjection( _viewProjectionMatrix );
							_object.z = _vector3.z;

						}

						_renderData.objects.push( _object );

					}

				} else if ( object instanceof THREE.Sprite || object instanceof THREE.Particle ) {

					_object = getNextObjectInPool();
					_object.object = object;

					// TODO: Find an elegant and performant solution and remove this dupe code.

					if ( object.renderDepth !== null ) {

						_object.z = object.renderDepth;

					} else {

						_vector3.copy( object.matrixWorld.getPosition() );
						_vector3.applyProjection( _viewProjectionMatrix );
						_object.z = _vector3.z;

					}

					_renderData.sprites.push( _object );

				} else {

					_object = getNextObjectInPool();
					_object.object = object;

					if ( object.renderDepth !== null ) {

						_object.z = object.renderDepth;

					} else {

						_vector3.copy( object.matrixWorld.getPosition() );
						_vector3.applyProjection( _viewProjectionMatrix );
						_object.z = _vector3.z;

					}

					_renderData.objects.push( _object );

				}

				projectObject( object );

			}

		};

		projectObject( root );

		if ( sortObjects === true ) _renderData.objects.sort( painterSort );

		return _renderData;

	};

	this.projectScene = function ( scene, camera, sortObjects, sortElements ) {

		var visible = false,
		o, ol, v, vl, f, fl, n, nl, c, cl, u, ul, object,
		geometry, vertices, vertex, vertexPositionScreen,
		faces, face, faceVertexNormals, faceVertexUvs, uvs,
		v1, v2, v3, v4, isFaceMaterial, objectMaterials;

		_face3Count = 0;
		_face4Count = 0;
		_lineCount = 0;
		_particleCount = 0;

		_renderData.elements.length = 0;

		scene.updateMatrixWorld();

		if ( camera.parent === undefined ) camera.updateMatrixWorld();

		_viewMatrix.copy( camera.matrixWorldInverse.getInverse( camera.matrixWorld ) );
		_viewProjectionMatrix.multiplyMatrices( camera.projectionMatrix, _viewMatrix );

		_normalViewMatrix.getInverse( _viewMatrix );
		_normalViewMatrix.transpose();

		_frustum.setFromMatrix( _viewProjectionMatrix );

		_renderData = projectGraph( scene, sortObjects );

		for ( o = 0, ol = _renderData.objects.length; o < ol; o ++ ) {

			object = _renderData.objects[ o ].object;

			_modelMatrix = object.matrixWorld;

			_vertexCount = 0;

			if ( object instanceof THREE.Mesh ) {

				geometry = object.geometry;

				vertices = geometry.vertices;
				faces = geometry.faces;
				faceVertexUvs = geometry.faceVertexUvs;

				_normalMatrix.getInverse( _modelMatrix );
				_normalMatrix.transpose();

				isFaceMaterial = object.material instanceof THREE.MeshFaceMaterial;
				objectMaterials = isFaceMaterial === true ? object.material : null;

				for ( v = 0, vl = vertices.length; v < vl; v ++ ) {

					_vertex = getNextVertexInPool();

					_vertex.positionWorld.copy( vertices[ v ] ).applyMatrix4( _modelMatrix );
					_vertex.positionScreen.copy( _vertex.positionWorld ).applyMatrix4( _viewProjectionMatrix );

					_vertex.positionScreen.x /= _vertex.positionScreen.w;
					_vertex.positionScreen.y /= _vertex.positionScreen.w;
					_vertex.positionScreen.z /= _vertex.positionScreen.w;

					_vertex.visible = ! ( _vertex.positionScreen.x < -1 || _vertex.positionScreen.x > 1 ||
							      _vertex.positionScreen.y < -1 || _vertex.positionScreen.y > 1 ||
							      _vertex.positionScreen.z < -1 || _vertex.positionScreen.z > 1 );

				}

				for ( f = 0, fl = faces.length; f < fl; f ++ ) {

					face = faces[ f ];

					var material = isFaceMaterial === true
						? objectMaterials.materials[ face.materialIndex ]
						: object.material;

					if ( material === undefined ) continue;

					var side = material.side;

					if ( face instanceof THREE.Face3 ) {

						v1 = _vertexPool[ face.a ];
						v2 = _vertexPool[ face.b ];
						v3 = _vertexPool[ face.c ];

						_points3[ 0 ] = v1.positionScreen;
						_points3[ 1 ] = v2.positionScreen;
						_points3[ 2 ] = v3.positionScreen;

						if ( v1.visible === true || v2.visible === true || v3.visible === true ||
							_clipBox.isIntersectionBox( _boundingBox.setFromPoints( _points3 ) ) ) {

							visible = ( ( v3.positionScreen.x - v1.positionScreen.x ) * ( v2.positionScreen.y - v1.positionScreen.y ) -
								( v3.positionScreen.y - v1.positionScreen.y ) * ( v2.positionScreen.x - v1.positionScreen.x ) ) < 0;

							if ( side === THREE.DoubleSide || visible === ( side === THREE.FrontSide ) ) {

								_face = getNextFace3InPool();

								_face.v1.copy( v1 );
								_face.v2.copy( v2 );
								_face.v3.copy( v3 );

							} else {

								continue;

							}

						} else {

							continue;

						}

					} else if ( face instanceof THREE.Face4 ) {

						v1 = _vertexPool[ face.a ];
						v2 = _vertexPool[ face.b ];
						v3 = _vertexPool[ face.c ];
						v4 = _vertexPool[ face.d ];

						_points4[ 0 ] = v1.positionScreen;
						_points4[ 1 ] = v2.positionScreen;
						_points4[ 2 ] = v3.positionScreen;
						_points4[ 3 ] = v4.positionScreen;

						if ( v1.visible === true || v2.visible === true || v3.visible === true || v4.visible === true ||
							_clipBox.isIntersectionBox( _boundingBox.setFromPoints( _points4 ) ) ) {

							visible = ( v4.positionScreen.x - v1.positionScreen.x ) * ( v2.positionScreen.y - v1.positionScreen.y ) -
								( v4.positionScreen.y - v1.positionScreen.y ) * ( v2.positionScreen.x - v1.positionScreen.x ) < 0 ||
								( v2.positionScreen.x - v3.positionScreen.x ) * ( v4.positionScreen.y - v3.positionScreen.y ) -
								( v2.positionScreen.y - v3.positionScreen.y ) * ( v4.positionScreen.x - v3.positionScreen.x ) < 0;


							if ( side === THREE.DoubleSide || visible === ( side === THREE.FrontSide ) ) {

								_face = getNextFace4InPool();

								_face.v1.copy( v1 );
								_face.v2.copy( v2 );
								_face.v3.copy( v3 );
								_face.v4.copy( v4 );

							} else {

								continue;

							}

						} else {

							continue;

						}

					}

					_face.normalModel.copy( face.normal );

					if ( visible === false && ( side === THREE.BackSide || side === THREE.DoubleSide ) ) {

						_face.normalModel.negate();

					}

					_face.normalModel.applyMatrix3( _normalMatrix ).normalize();

					_face.normalModelView.copy( _face.normalModel ).applyMatrix3( _normalViewMatrix );

					_face.centroidModel.copy( face.centroid ).applyMatrix4( _modelMatrix );

					faceVertexNormals = face.vertexNormals;

					for ( n = 0, nl = faceVertexNormals.length; n < nl; n ++ ) {

						var normalModel = _face.vertexNormalsModel[ n ];
						normalModel.copy( faceVertexNormals[ n ] );

						if ( visible === false && ( side === THREE.BackSide || side === THREE.DoubleSide ) ) {

							normalModel.negate();

						}

						normalModel.applyMatrix3( _normalMatrix ).normalize();

						var normalModelView = _face.vertexNormalsModelView[ n ];
						normalModelView.copy( normalModel ).applyMatrix3( _normalViewMatrix );

					}

					_face.vertexNormalsLength = faceVertexNormals.length;

					for ( c = 0, cl = faceVertexUvs.length; c < cl; c ++ ) {

						uvs = faceVertexUvs[ c ][ f ];

						if ( uvs === undefined ) continue;

						for ( u = 0, ul = uvs.length; u < ul; u ++ ) {

							_face.uvs[ c ][ u ] = uvs[ u ];

						}

					}

					_face.color = face.color;
					_face.material = material;

					_centroid.copy( _face.centroidModel ).applyProjection( _viewProjectionMatrix );

					_face.z = _centroid.z;

					_renderData.elements.push( _face );

				}

			} else if ( object instanceof THREE.Line ) {

				_modelViewProjectionMatrix.multiplyMatrices( _viewProjectionMatrix, _modelMatrix );

				vertices = object.geometry.vertices;

				v1 = getNextVertexInPool();
				v1.positionScreen.copy( vertices[ 0 ] ).applyMatrix4( _modelViewProjectionMatrix );

				// Handle LineStrip and LinePieces
				var step = object.type === THREE.LinePieces ? 2 : 1;

				for ( v = 1, vl = vertices.length; v < vl; v ++ ) {

					v1 = getNextVertexInPool();
					v1.positionScreen.copy( vertices[ v ] ).applyMatrix4( _modelViewProjectionMatrix );

					if ( ( v + 1 ) % step > 0 ) continue;

					v2 = _vertexPool[ _vertexCount - 2 ];

					_clippedVertex1PositionScreen.copy( v1.positionScreen );
					_clippedVertex2PositionScreen.copy( v2.positionScreen );

					if ( clipLine( _clippedVertex1PositionScreen, _clippedVertex2PositionScreen ) === true ) {

						// Perform the perspective divide
						_clippedVertex1PositionScreen.multiplyScalar( 1 / _clippedVertex1PositionScreen.w );
						_clippedVertex2PositionScreen.multiplyScalar( 1 / _clippedVertex2PositionScreen.w );

						_line = getNextLineInPool();
						_line.v1.positionScreen.copy( _clippedVertex1PositionScreen );
						_line.v2.positionScreen.copy( _clippedVertex2PositionScreen );

						_line.z = Math.max( _clippedVertex1PositionScreen.z, _clippedVertex2PositionScreen.z );

						_line.material = object.material;

						_renderData.elements.push( _line );

					}

				}

			}

		}

		for ( o = 0, ol = _renderData.sprites.length; o < ol; o++ ) {

			object = _renderData.sprites[ o ].object;

			_modelMatrix = object.matrixWorld;

			if ( object instanceof THREE.Particle ) {

				_vector4.set( _modelMatrix.elements[12], _modelMatrix.elements[13], _modelMatrix.elements[14], 1 );
				_vector4.applyMatrix4( _viewProjectionMatrix );

				_vector4.z /= _vector4.w;

				if ( _vector4.z > 0 && _vector4.z < 1 ) {

					_particle = getNextParticleInPool();
					_particle.object = object;
					_particle.x = _vector4.x / _vector4.w;
					_particle.y = _vector4.y / _vector4.w;
					_particle.z = _vector4.z;

					_particle.rotation = object.rotation.z;

					_particle.scale.x = object.scale.x * Math.abs( _particle.x - ( _vector4.x + camera.projectionMatrix.elements[0] ) / ( _vector4.w + camera.projectionMatrix.elements[12] ) );
					_particle.scale.y = object.scale.y * Math.abs( _particle.y - ( _vector4.y + camera.projectionMatrix.elements[5] ) / ( _vector4.w + camera.projectionMatrix.elements[13] ) );

					_particle.material = object.material;

					_renderData.elements.push( _particle );

				}

			}

		}

		if ( sortElements === true ) _renderData.elements.sort( painterSort );

		return _renderData;

	};

	// Pools

	function getNextObjectInPool() {

		if ( _objectCount === _objectPoolLength ) {

			var object = new THREE.RenderableObject();
			_objectPool.push( object );
			_objectPoolLength ++;
			_objectCount ++;
			return object;

		}

		return _objectPool[ _objectCount ++ ];

	}

	function getNextVertexInPool() {

		if ( _vertexCount === _vertexPoolLength ) {

			var vertex = new THREE.RenderableVertex();
			_vertexPool.push( vertex );
			_vertexPoolLength ++;
			_vertexCount ++;
			return vertex;

		}

		return _vertexPool[ _vertexCount ++ ];

	}

	function getNextFace3InPool() {

		if ( _face3Count === _face3PoolLength ) {

			var face = new THREE.RenderableFace3();
			_face3Pool.push( face );
			_face3PoolLength ++;
			_face3Count ++;
			return face;

		}

		return _face3Pool[ _face3Count ++ ];


	}

	function getNextFace4InPool() {

		if ( _face4Count === _face4PoolLength ) {

			var face = new THREE.RenderableFace4();
			_face4Pool.push( face );
			_face4PoolLength ++;
			_face4Count ++;
			return face;

		}

		return _face4Pool[ _face4Count ++ ];

	}

	function getNextLineInPool() {

		if ( _lineCount === _linePoolLength ) {

			var line = new THREE.RenderableLine();
			_linePool.push( line );
			_linePoolLength ++;
			_lineCount ++
			return line;

		}

		return _linePool[ _lineCount ++ ];

	}

	function getNextParticleInPool() {

		if ( _particleCount === _particlePoolLength ) {

			var particle = new THREE.RenderableParticle();
			_particlePool.push( particle );
			_particlePoolLength ++;
			_particleCount ++
			return particle;

		}

		return _particlePool[ _particleCount ++ ];

	}

	//

	function painterSort( a, b ) {

		return b.z - a.z;

	}

	function clipLine( s1, s2 ) {

		var alpha1 = 0, alpha2 = 1,

		// Calculate the boundary coordinate of each vertex for the near and far clip planes,
		// Z = -1 and Z = +1, respectively.
		bc1near =  s1.z + s1.w,
		bc2near =  s2.z + s2.w,
		bc1far =  - s1.z + s1.w,
		bc2far =  - s2.z + s2.w;

		if ( bc1near >= 0 && bc2near >= 0 && bc1far >= 0 && bc2far >= 0 ) {

			// Both vertices lie entirely within all clip planes.
			return true;

		} else if ( ( bc1near < 0 && bc2near < 0) || (bc1far < 0 && bc2far < 0 ) ) {

			// Both vertices lie entirely outside one of the clip planes.
			return false;

		} else {

			// The line segment spans at least one clip plane.

			if ( bc1near < 0 ) {

				// v1 lies outside the near plane, v2 inside
				alpha1 = Math.max( alpha1, bc1near / ( bc1near - bc2near ) );

			} else if ( bc2near < 0 ) {

				// v2 lies outside the near plane, v1 inside
				alpha2 = Math.min( alpha2, bc1near / ( bc1near - bc2near ) );

			}

			if ( bc1far < 0 ) {

				// v1 lies outside the far plane, v2 inside
				alpha1 = Math.max( alpha1, bc1far / ( bc1far - bc2far ) );

			} else if ( bc2far < 0 ) {

				// v2 lies outside the far plane, v2 inside
				alpha2 = Math.min( alpha2, bc1far / ( bc1far - bc2far ) );

			}

			if ( alpha2 < alpha1 ) {

				// The line segment spans two boundaries, but is outside both of them.
				// (This can't happen when we're only clipping against just near/far but good
				//  to leave the check here for future usage if other clip planes are added.)
				return false;

			} else {

				// Update the s1 and s2 vertices to match the clipped line segment.
				s1.lerp( s2, alpha1 );
				s2.lerp( s1, 1 - alpha2 );

				return true;

			}

		}

	}

};
/**
 * @author mrdoob / http://mrdoob.com/
 * @author alteredq / http://alteredqualia.com/
 */

THREE.Face3 = function ( a, b, c, normal, color, materialIndex ) {

	this.a = a;
	this.b = b;
	this.c = c;

	this.normal = normal instanceof THREE.Vector3 ? normal : new THREE.Vector3();
	this.vertexNormals = normal instanceof Array ? normal : [ ];

	this.color = color instanceof THREE.Color ? color : new THREE.Color();
	this.vertexColors = color instanceof Array ? color : [];

	this.vertexTangents = [];

	this.materialIndex = materialIndex !== undefined ? materialIndex : 0;

	this.centroid = new THREE.Vector3();

};

THREE.Face3.prototype = {

	constructor: THREE.Face3,

	clone: function () {

		var face = new THREE.Face3( this.a, this.b, this.c );

		face.normal.copy( this.normal );
		face.color.copy( this.color );
		face.centroid.copy( this.centroid );

		face.materialIndex = this.materialIndex;

		var i, il;
		for ( i = 0, il = this.vertexNormals.length; i < il; i ++ ) face.vertexNormals[ i ] = this.vertexNormals[ i ].clone();
		for ( i = 0, il = this.vertexColors.length; i < il; i ++ ) face.vertexColors[ i ] = this.vertexColors[ i ].clone();
		for ( i = 0, il = this.vertexTangents.length; i < il; i ++ ) face.vertexTangents[ i ] = this.vertexTangents[ i ].clone();

		return face;

	}

};
/**
 * @author mrdoob / http://mrdoob.com/
 * @author alteredq / http://alteredqualia.com/
 */

THREE.Face4 = function ( a, b, c, d, normal, color, materialIndex ) {

	this.a = a;
	this.b = b;
	this.c = c;
	this.d = d;

	this.normal = normal instanceof THREE.Vector3 ? normal : new THREE.Vector3();
	this.vertexNormals = normal instanceof Array ? normal : [ ];

	this.color = color instanceof THREE.Color ? color : new THREE.Color();
	this.vertexColors = color instanceof Array ? color : [];

	this.vertexTangents = [];

	this.materialIndex = materialIndex !== undefined ? materialIndex : 0;

	this.centroid = new THREE.Vector3();

};

THREE.Face4.prototype = {

	constructor: THREE.Face4,

	clone: function () {

		var face = new THREE.Face4( this.a, this.b, this.c, this.d );

		face.normal.copy( this.normal );
		face.color.copy( this.color );
		face.centroid.copy( this.centroid );

		face.materialIndex = this.materialIndex;

		var i, il;
		for ( i = 0, il = this.vertexNormals.length; i < il; i ++ ) face.vertexNormals[ i ] = this.vertexNormals[ i ].clone();
		for ( i = 0, il = this.vertexColors.length; i < il; i ++ ) face.vertexColors[ i ] = this.vertexColors[ i ].clone();
		for ( i = 0, il = this.vertexTangents.length; i < il; i ++ ) face.vertexTangents[ i ] = this.vertexTangents[ i ].clone();

		return face;

	}

};
/**
 * @author mrdoob / http://mrdoob.com/
 * @author kile / http://kile.stravaganza.org/
 * @author alteredq / http://alteredqualia.com/
 * @author mikael emtinger / http://gomo.se/
 * @author zz85 / http://www.lab4games.net/zz85/blog
 * @author bhouston / http://exocortex.com
 */

THREE.Geometry = function () {

	THREE.EventDispatcher.call( this );

	this.id = THREE.GeometryIdCount ++;

	this.name = '';

	this.vertices = [];
	this.colors = [];  // one-to-one vertex colors, used in ParticleSystem, Line and Ribbon
	this.normals = []; // one-to-one vertex normals, used in Ribbon

	this.faces = [];

	this.faceUvs = [[]];
	this.faceVertexUvs = [[]];

	this.morphTargets = [];
	this.morphColors = [];
	this.morphNormals = [];

	this.skinWeights = [];
	this.skinIndices = [];

	this.lineDistances = [];

	this.boundingBox = null;
	this.boundingSphere = null;

	this.hasTangents = false;

	this.dynamic = true; // the intermediate typed arrays will be deleted when set to false

	// update flags

	this.verticesNeedUpdate = false;
	this.elementsNeedUpdate = false;
	this.uvsNeedUpdate = false;
	this.normalsNeedUpdate = false;
	this.tangentsNeedUpdate = false;
	this.colorsNeedUpdate = false;
	this.lineDistancesNeedUpdate = false;

	this.buffersNeedUpdate = false;

};

THREE.Geometry.prototype = {

	constructor: THREE.Geometry,

	applyMatrix: function ( matrix ) {

		var normalMatrix = new THREE.Matrix3().getInverse( matrix ).transpose();

		for ( var i = 0, il = this.vertices.length; i < il; i ++ ) {

			var vertex = this.vertices[ i ];
			vertex.applyMatrix4( matrix );

		}

		for ( var i = 0, il = this.faces.length; i < il; i ++ ) {

			var face = this.faces[ i ];
			face.normal.applyMatrix3( normalMatrix ).normalize();

			for ( var j = 0, jl = face.vertexNormals.length; j < jl; j ++ ) {

				face.vertexNormals[ j ].applyMatrix3( normalMatrix ).normalize();

			}

			face.centroid.applyMatrix4( matrix );

		}

	},

	computeCentroids: function () {

		var f, fl, face;

		for ( f = 0, fl = this.faces.length; f < fl; f ++ ) {

			face = this.faces[ f ];
			face.centroid.set( 0, 0, 0 );

			if ( face instanceof THREE.Face3 ) {

				face.centroid.add( this.vertices[ face.a ] );
				face.centroid.add( this.vertices[ face.b ] );
				face.centroid.add( this.vertices[ face.c ] );
				face.centroid.divideScalar( 3 );

			} else if ( face instanceof THREE.Face4 ) {

				face.centroid.add( this.vertices[ face.a ] );
				face.centroid.add( this.vertices[ face.b ] );
				face.centroid.add( this.vertices[ face.c ] );
				face.centroid.add( this.vertices[ face.d ] );
				face.centroid.divideScalar( 4 );

			}

		}

	},

	computeFaceNormals: function () {

		var n, nl, v, vl, vertex, f, fl, face, vA, vB, vC,
		cb = new THREE.Vector3(), ab = new THREE.Vector3();

		for ( f = 0, fl = this.faces.length; f < fl; f ++ ) {

			face = this.faces[ f ];

			vA = this.vertices[ face.a ];
			vB = this.vertices[ face.b ];
			vC = this.vertices[ face.c ];

			cb.subVectors( vC, vB );
			ab.subVectors( vA, vB );
			cb.cross( ab );

			cb.normalize();

			face.normal.copy( cb );

		}

	},

	computeVertexNormals: function ( areaWeighted ) {

		var v, vl, f, fl, face, vertices;

		// create internal buffers for reuse when calling this method repeatedly
		// (otherwise memory allocation / deallocation every frame is big resource hog)

		if ( this.__tmpVertices === undefined ) {

			this.__tmpVertices = new Array( this.vertices.length );
			vertices = this.__tmpVertices;

			for ( v = 0, vl = this.vertices.length; v < vl; v ++ ) {

				vertices[ v ] = new THREE.Vector3();

			}

			for ( f = 0, fl = this.faces.length; f < fl; f ++ ) {

				face = this.faces[ f ];

				if ( face instanceof THREE.Face3 ) {

					face.vertexNormals = [ new THREE.Vector3(), new THREE.Vector3(), new THREE.Vector3() ];

				} else if ( face instanceof THREE.Face4 ) {

					face.vertexNormals = [ new THREE.Vector3(), new THREE.Vector3(), new THREE.Vector3(), new THREE.Vector3() ];

				}

			}

		} else {

			vertices = this.__tmpVertices;

			for ( v = 0, vl = this.vertices.length; v < vl; v ++ ) {

				vertices[ v ].set( 0, 0, 0 );

			}

		}

		if ( areaWeighted ) {

			// vertex normals weighted by triangle areas
			// http://www.iquilezles.org/www/articles/normals/normals.htm

			var vA, vB, vC, vD;
			var cb = new THREE.Vector3(), ab = new THREE.Vector3(),
				db = new THREE.Vector3(), dc = new THREE.Vector3(), bc = new THREE.Vector3();

			for ( f = 0, fl = this.faces.length; f < fl; f ++ ) {

				face = this.faces[ f ];

				if ( face instanceof THREE.Face3 ) {

					vA = this.vertices[ face.a ];
					vB = this.vertices[ face.b ];
					vC = this.vertices[ face.c ];

					cb.subVectors( vC, vB );
					ab.subVectors( vA, vB );
					cb.cross( ab );

					vertices[ face.a ].add( cb );
					vertices[ face.b ].add( cb );
					vertices[ face.c ].add( cb );

				} else if ( face instanceof THREE.Face4 ) {

					vA = this.vertices[ face.a ];
					vB = this.vertices[ face.b ];
					vC = this.vertices[ face.c ];
					vD = this.vertices[ face.d ];

					// abd

					db.subVectors( vD, vB );
					ab.subVectors( vA, vB );
					db.cross( ab );

					vertices[ face.a ].add( db );
					vertices[ face.b ].add( db );
					vertices[ face.d ].add( db );

					// bcd

					dc.subVectors( vD, vC );
					bc.subVectors( vB, vC );
					dc.cross( bc );

					vertices[ face.b ].add( dc );
					vertices[ face.c ].add( dc );
					vertices[ face.d ].add( dc );

				}

			}

		} else {

			for ( f = 0, fl = this.faces.length; f < fl; f ++ ) {

				face = this.faces[ f ];

				if ( face instanceof THREE.Face3 ) {

					vertices[ face.a ].add( face.normal );
					vertices[ face.b ].add( face.normal );
					vertices[ face.c ].add( face.normal );

				} else if ( face instanceof THREE.Face4 ) {

					vertices[ face.a ].add( face.normal );
					vertices[ face.b ].add( face.normal );
					vertices[ face.c ].add( face.normal );
					vertices[ face.d ].add( face.normal );

				}

			}

		}

		for ( v = 0, vl = this.vertices.length; v < vl; v ++ ) {

			vertices[ v ].normalize();

		}

		for ( f = 0, fl = this.faces.length; f < fl; f ++ ) {

			face = this.faces[ f ];

			if ( face instanceof THREE.Face3 ) {

				face.vertexNormals[ 0 ].copy( vertices[ face.a ] );
				face.vertexNormals[ 1 ].copy( vertices[ face.b ] );
				face.vertexNormals[ 2 ].copy( vertices[ face.c ] );

			} else if ( face instanceof THREE.Face4 ) {

				face.vertexNormals[ 0 ].copy( vertices[ face.a ] );
				face.vertexNormals[ 1 ].copy( vertices[ face.b ] );
				face.vertexNormals[ 2 ].copy( vertices[ face.c ] );
				face.vertexNormals[ 3 ].copy( vertices[ face.d ] );

			}

		}

	},

	computeMorphNormals: function () {

		var i, il, f, fl, face;

		// save original normals
		// - create temp variables on first access
		//   otherwise just copy (for faster repeated calls)

		for ( f = 0, fl = this.faces.length; f < fl; f ++ ) {

			face = this.faces[ f ];

			if ( ! face.__originalFaceNormal ) {

				face.__originalFaceNormal = face.normal.clone();

			} else {

				face.__originalFaceNormal.copy( face.normal );

			}

			if ( ! face.__originalVertexNormals ) face.__originalVertexNormals = [];

			for ( i = 0, il = face.vertexNormals.length; i < il; i ++ ) {

				if ( ! face.__originalVertexNormals[ i ] ) {

					face.__originalVertexNormals[ i ] = face.vertexNormals[ i ].clone();

				} else {

					face.__originalVertexNormals[ i ].copy( face.vertexNormals[ i ] );

				}

			}

		}

		// use temp geometry to compute face and vertex normals for each morph

		var tmpGeo = new THREE.Geometry();
		tmpGeo.faces = this.faces;

		for ( i = 0, il = this.morphTargets.length; i < il; i ++ ) {

			// create on first access

			if ( ! this.morphNormals[ i ] ) {

				this.morphNormals[ i ] = {};
				this.morphNormals[ i ].faceNormals = [];
				this.morphNormals[ i ].vertexNormals = [];

				var dstNormalsFace = this.morphNormals[ i ].faceNormals;
				var dstNormalsVertex = this.morphNormals[ i ].vertexNormals;

				var faceNormal, vertexNormals;

				for ( f = 0, fl = this.faces.length; f < fl; f ++ ) {

					face = this.faces[ f ];

					faceNormal = new THREE.Vector3();

					if ( face instanceof THREE.Face3 ) {

						vertexNormals = { a: new THREE.Vector3(), b: new THREE.Vector3(), c: new THREE.Vector3() };

					} else {

						vertexNormals = { a: new THREE.Vector3(), b: new THREE.Vector3(), c: new THREE.Vector3(), d: new THREE.Vector3() };

					}

					dstNormalsFace.push( faceNormal );
					dstNormalsVertex.push( vertexNormals );

				}

			}

			var morphNormals = this.morphNormals[ i ];

			// set vertices to morph target

			tmpGeo.vertices = this.morphTargets[ i ].vertices;

			// compute morph normals

			tmpGeo.computeFaceNormals();
			tmpGeo.computeVertexNormals();

			// store morph normals

			var faceNormal, vertexNormals;

			for ( f = 0, fl = this.faces.length; f < fl; f ++ ) {

				face = this.faces[ f ];

				faceNormal = morphNormals.faceNormals[ f ];
				vertexNormals = morphNormals.vertexNormals[ f ];

				faceNormal.copy( face.normal );

				if ( face instanceof THREE.Face3 ) {

					vertexNormals.a.copy( face.vertexNormals[ 0 ] );
					vertexNormals.b.copy( face.vertexNormals[ 1 ] );
					vertexNormals.c.copy( face.vertexNormals[ 2 ] );

				} else {

					vertexNormals.a.copy( face.vertexNormals[ 0 ] );
					vertexNormals.b.copy( face.vertexNormals[ 1 ] );
					vertexNormals.c.copy( face.vertexNormals[ 2 ] );
					vertexNormals.d.copy( face.vertexNormals[ 3 ] );

				}

			}

		}

		// restore original normals

		for ( f = 0, fl = this.faces.length; f < fl; f ++ ) {

			face = this.faces[ f ];

			face.normal = face.__originalFaceNormal;
			face.vertexNormals = face.__originalVertexNormals;

		}

	},

	computeTangents: function () {

		// based on http://www.terathon.com/code/tangent.html
		// tangents go to vertices

		var f, fl, v, vl, i, il, vertexIndex,
			face, uv, vA, vB, vC, uvA, uvB, uvC,
			x1, x2, y1, y2, z1, z2,
			s1, s2, t1, t2, r, t, test,
			tan1 = [], tan2 = [],
			sdir = new THREE.Vector3(), tdir = new THREE.Vector3(),
			tmp = new THREE.Vector3(), tmp2 = new THREE.Vector3(),
			n = new THREE.Vector3(), w;

		for ( v = 0, vl = this.vertices.length; v < vl; v ++ ) {

			tan1[ v ] = new THREE.Vector3();
			tan2[ v ] = new THREE.Vector3();

		}

		function handleTriangle( context, a, b, c, ua, ub, uc ) {

			vA = context.vertices[ a ];
			vB = context.vertices[ b ];
			vC = context.vertices[ c ];

			uvA = uv[ ua ];
			uvB = uv[ ub ];
			uvC = uv[ uc ];

			x1 = vB.x - vA.x;
			x2 = vC.x - vA.x;
			y1 = vB.y - vA.y;
			y2 = vC.y - vA.y;
			z1 = vB.z - vA.z;
			z2 = vC.z - vA.z;

			s1 = uvB.x - uvA.x;
			s2 = uvC.x - uvA.x;
			t1 = uvB.y - uvA.y;
			t2 = uvC.y - uvA.y;

			r = 1.0 / ( s1 * t2 - s2 * t1 );
			sdir.set( ( t2 * x1 - t1 * x2 ) * r,
					  ( t2 * y1 - t1 * y2 ) * r,
					  ( t2 * z1 - t1 * z2 ) * r );
			tdir.set( ( s1 * x2 - s2 * x1 ) * r,
					  ( s1 * y2 - s2 * y1 ) * r,
					  ( s1 * z2 - s2 * z1 ) * r );

			tan1[ a ].add( sdir );
			tan1[ b ].add( sdir );
			tan1[ c ].add( sdir );

			tan2[ a ].add( tdir );
			tan2[ b ].add( tdir );
			tan2[ c ].add( tdir );

		}

		for ( f = 0, fl = this.faces.length; f < fl; f ++ ) {

			face = this.faces[ f ];
			uv = this.faceVertexUvs[ 0 ][ f ]; // use UV layer 0 for tangents

			if ( face instanceof THREE.Face3 ) {

				handleTriangle( this, face.a, face.b, face.c, 0, 1, 2 );

			} else if ( face instanceof THREE.Face4 ) {

				handleTriangle( this, face.a, face.b, face.d, 0, 1, 3 );
				handleTriangle( this, face.b, face.c, face.d, 1, 2, 3 );

			}

		}

		var faceIndex = [ 'a', 'b', 'c', 'd' ];

		for ( f = 0, fl = this.faces.length; f < fl; f ++ ) {

			face = this.faces[ f ];

			for ( i = 0; i < face.vertexNormals.length; i++ ) {

				n.copy( face.vertexNormals[ i ] );

				vertexIndex = face[ faceIndex[ i ] ];

				t = tan1[ vertexIndex ];

				// Gram-Schmidt orthogonalize

				tmp.copy( t );
				tmp.sub( n.multiplyScalar( n.dot( t ) ) ).normalize();

				// Calculate handedness

				tmp2.crossVectors( face.vertexNormals[ i ], t );
				test = tmp2.dot( tan2[ vertexIndex ] );
				w = (test < 0.0) ? -1.0 : 1.0;

				face.vertexTangents[ i ] = new THREE.Vector4( tmp.x, tmp.y, tmp.z, w );

			}

		}

		this.hasTangents = true;

	},

	computeLineDistances: function ( ) {

		var d = 0;
		var vertices = this.vertices;

		for ( var i = 0, il = vertices.length; i < il; i ++ ) {

			if ( i > 0 ) {

				d += vertices[ i ].distanceTo( vertices[ i - 1 ] );

			}

			this.lineDistances[ i ] = d;

		}

	},

	computeBoundingBox: function () {

		if ( this.boundingBox === null ) {

			this.boundingBox = new THREE.Box3();

		}

		this.boundingBox.setFromPoints( this.vertices );

	},

	computeBoundingSphere: function () {

		if ( this.boundingSphere === null ) {

			this.boundingSphere = new THREE.Sphere();

		}

		this.boundingSphere.setFromCenterAndPoints( this.boundingSphere.center, this.vertices );

	},

	/*
	 * Checks for duplicate vertices with hashmap.
	 * Duplicated vertices are removed
	 * and faces' vertices are updated.
	 */

	mergeVertices: function () {

		var verticesMap = {}; // Hashmap for looking up vertice by position coordinates (and making sure they are unique)
		var unique = [], changes = [];

		var v, key;
		var precisionPoints = 4; // number of decimal points, eg. 4 for epsilon of 0.0001
		var precision = Math.pow( 10, precisionPoints );
		var i,il, face;
		var indices, k, j, jl, u;

		// reset cache of vertices as it now will be changing.
		this.__tmpVertices = undefined;

		for ( i = 0, il = this.vertices.length; i < il; i ++ ) {

			v = this.vertices[ i ];
			key = [ Math.round( v.x * precision ), Math.round( v.y * precision ), Math.round( v.z * precision ) ].join( '_' );

			if ( verticesMap[ key ] === undefined ) {

				verticesMap[ key ] = i;
				unique.push( this.vertices[ i ] );
				changes[ i ] = unique.length - 1;

			} else {

				//console.log('Duplicate vertex found. ', i, ' could be using ', verticesMap[key]);
				changes[ i ] = changes[ verticesMap[ key ] ];

			}

		};


		// if faces are completely degenerate after merging vertices, we
		// have to remove them from the geometry.
		var faceIndicesToRemove = [];

		for( i = 0, il = this.faces.length; i < il; i ++ ) {

			face = this.faces[ i ];

			if ( face instanceof THREE.Face3 ) {

				face.a = changes[ face.a ];
				face.b = changes[ face.b ];
				face.c = changes[ face.c ];

				indices = [ face.a, face.b, face.c ];

				var dupIndex = -1;

				// if any duplicate vertices are found in a Face3
				// we have to remove the face as nothing can be saved
				for ( var n = 0; n < 3; n ++ ) {
					if ( indices[ n ] == indices[ ( n + 1 ) % 3 ] ) {

						dupIndex = n;
						faceIndicesToRemove.push( i );
						break;

					}
				}

			} else if ( face instanceof THREE.Face4 ) {

				face.a = changes[ face.a ];
				face.b = changes[ face.b ];
				face.c = changes[ face.c ];
				face.d = changes[ face.d ];

				// check dups in (a, b, c, d) and convert to -> face3

				indices = [ face.a, face.b, face.c, face.d ];

				var dupIndex = -1;

				for ( var n = 0; n < 4; n ++ ) {

					if ( indices[ n ] == indices[ ( n + 1 ) % 4 ] ) {

						// if more than one duplicated vertex is found
						// we can't generate any valid Face3's, thus
						// we need to remove this face complete.
						if ( dupIndex >= 0 ) {

							faceIndicesToRemove.push( i );

						}

						dupIndex = n;

					}
				}

				if ( dupIndex >= 0 ) {

					indices.splice( dupIndex, 1 );

					var newFace = new THREE.Face3( indices[0], indices[1], indices[2], face.normal, face.color, face.materialIndex );

					for ( j = 0, jl = this.faceVertexUvs.length; j < jl; j ++ ) {

						u = this.faceVertexUvs[ j ][ i ];

						if ( u ) {
							u.splice( dupIndex, 1 );
						}

					}

					if( face.vertexNormals && face.vertexNormals.length > 0) {

						newFace.vertexNormals = face.vertexNormals;
						newFace.vertexNormals.splice( dupIndex, 1 );

					}

					if( face.vertexColors && face.vertexColors.length > 0 ) {

						newFace.vertexColors = face.vertexColors;
						newFace.vertexColors.splice( dupIndex, 1 );
					}

					this.faces[ i ] = newFace;
				}

			}

		}

		for ( i = faceIndicesToRemove.length - 1; i >= 0; i -- ) {

			this.faces.splice( i, 1 );

			for ( j = 0, jl = this.faceVertexUvs.length; j < jl; j ++ ) {

				this.faceVertexUvs[ j ].splice( i, 1 );

			}

		}

		// Use unique set of vertices

		var diff = this.vertices.length - unique.length;
		this.vertices = unique;
		return diff;

	},

	clone: function () {

		var geometry = new THREE.Geometry();

		var vertices = this.vertices;

		for ( var i = 0, il = vertices.length; i < il; i ++ ) {

			geometry.vertices.push( vertices[ i ].clone() );

		}

		var faces = this.faces;

		for ( var i = 0, il = faces.length; i < il; i ++ ) {

			geometry.faces.push( faces[ i ].clone() );

		}

		var uvs = this.faceVertexUvs[ 0 ];

		for ( var i = 0, il = uvs.length; i < il; i ++ ) {

			var uv = uvs[ i ], uvCopy = [];

			for ( var j = 0, jl = uv.length; j < jl; j ++ ) {

				uvCopy.push( new THREE.Vector2( uv[ j ].x, uv[ j ].y ) );

			}

			geometry.faceVertexUvs[ 0 ].push( uvCopy );

		}

		return geometry;

	},

	dispose: function () {

		this.dispatchEvent( { type: 'dispose' } );

	}

};

THREE.GeometryIdCount = 0;
/**
 * @author alteredq / http://alteredqualia.com/
 */

THREE.BufferGeometry = function () {

	THREE.EventDispatcher.call( this );

	this.id = THREE.GeometryIdCount ++;

	// attributes

	this.attributes = {};

	// attributes typed arrays are kept only if dynamic flag is set

	this.dynamic = false;

	// offsets for chunks when using indexed elements

	this.offsets = [];

	// boundings

	this.boundingBox = null;
	this.boundingSphere = null;

	this.hasTangents = false;

	// for compatibility

	this.morphTargets = [];

};

THREE.BufferGeometry.prototype = {

	constructor : THREE.BufferGeometry,

	applyMatrix: function ( matrix ) {

		var positionArray;
		var normalArray;

		if ( this.attributes[ "position" ] ) positionArray = this.attributes[ "position" ].array;
		if ( this.attributes[ "normal" ] ) normalArray = this.attributes[ "normal" ].array;

		if ( positionArray !== undefined ) {

			matrix.multiplyVector3Array( positionArray );
			this.verticesNeedUpdate = true;

		}

		if ( normalArray !== undefined ) {

			var normalMatrix = new THREE.Matrix3();
			normalMatrix.getInverse( matrix ).transpose();

			normalMatrix.multiplyVector3Array( normalArray );

			this.normalizeNormals();

			this.normalsNeedUpdate = true;

		}

	},

	computeBoundingBox: function () {

		if ( this.boundingBox === null ) {

			this.boundingBox = new THREE.Box3();

		}

		var positions = this.attributes[ "position" ].array;

		if ( positions ) {

			var bb = this.boundingBox;
			var x, y, z;

			if( positions.length >= 3 ) {
				bb.min.x = bb.max.x = positions[ 0 ];
				bb.min.y = bb.max.y = positions[ 1 ];
				bb.min.z = bb.max.z = positions[ 2 ];
			}

			for ( var i = 3, il = positions.length; i < il; i += 3 ) {

				x = positions[ i ];
				y = positions[ i + 1 ];
				z = positions[ i + 2 ];

				// bounding box

				if ( x < bb.min.x ) {

					bb.min.x = x;

				} else if ( x > bb.max.x ) {

					bb.max.x = x;

				}

				if ( y < bb.min.y ) {

					bb.min.y = y;

				} else if ( y > bb.max.y ) {

					bb.max.y = y;

				}

				if ( z < bb.min.z ) {

					bb.min.z = z;

				} else if ( z > bb.max.z ) {

					bb.max.z = z;

				}

			}

		}

		if ( positions === undefined || positions.length === 0 ) {

			this.boundingBox.min.set( 0, 0, 0 );
			this.boundingBox.max.set( 0, 0, 0 );

		}

	},

	computeBoundingSphere: function () {

		if ( this.boundingSphere === null ) {

			this.boundingSphere = new THREE.Sphere();

		}

		var positions = this.attributes[ "position" ].array;

		if ( positions ) {

			var radiusSq, maxRadiusSq = 0;
			var x, y, z;

			for ( var i = 0, il = positions.length; i < il; i += 3 ) {

				x = positions[ i ];
				y = positions[ i + 1 ];
				z = positions[ i + 2 ];

				radiusSq =  x * x + y * y + z * z;
				if ( radiusSq > maxRadiusSq ) maxRadiusSq = radiusSq;

			}

			this.boundingSphere.radius = Math.sqrt( maxRadiusSq );

		}

	},

	computeVertexNormals: function () {

		if ( this.attributes[ "position" ] ) {

			var i, il;
			var j, jl;

			var nVertexElements = this.attributes[ "position" ].array.length;

			if ( this.attributes[ "normal" ] === undefined ) {

				this.attributes[ "normal" ] = {

					itemSize: 3,
					array: new Float32Array( nVertexElements ),
					numItems: nVertexElements

				};

			} else {

				// reset existing normals to zero

				for ( i = 0, il = this.attributes[ "normal" ].array.length; i < il; i ++ ) {

					this.attributes[ "normal" ].array[ i ] = 0;

				}

			}

			var positions = this.attributes[ "position" ].array;
			var normals = this.attributes[ "normal" ].array;

			var vA, vB, vC, x, y, z,

			pA = new THREE.Vector3(),
			pB = new THREE.Vector3(),
			pC = new THREE.Vector3(),

			cb = new THREE.Vector3(),
			ab = new THREE.Vector3();

			// indexed elements

			if ( this.attributes[ "index" ] ) {

				var indices = this.attributes[ "index" ].array;

				var offsets = this.offsets;

				for ( j = 0, jl = offsets.length; j < jl; ++ j ) {

					var start = offsets[ j ].start;
					var count = offsets[ j ].count;
					var index = offsets[ j ].index;

					for ( i = start, il = start + count; i < il; i += 3 ) {

						vA = index + indices[ i ];
						vB = index + indices[ i + 1 ];
						vC = index + indices[ i + 2 ];

						x = positions[ vA * 3 ];
						y = positions[ vA * 3 + 1 ];
						z = positions[ vA * 3 + 2 ];
						pA.set( x, y, z );

						x = positions[ vB * 3 ];
						y = positions[ vB * 3 + 1 ];
						z = positions[ vB * 3 + 2 ];
						pB.set( x, y, z );

						x = positions[ vC * 3 ];
						y = positions[ vC * 3 + 1 ];
						z = positions[ vC * 3 + 2 ];
						pC.set( x, y, z );

						cb.subVectors( pC, pB );
						ab.subVectors( pA, pB );
						cb.cross( ab );

						normals[ vA * 3 ]     += cb.x;
						normals[ vA * 3 + 1 ] += cb.y;
						normals[ vA * 3 + 2 ] += cb.z;

						normals[ vB * 3 ]     += cb.x;
						normals[ vB * 3 + 1 ] += cb.y;
						normals[ vB * 3 + 2 ] += cb.z;

						normals[ vC * 3 ]     += cb.x;
						normals[ vC * 3 + 1 ] += cb.y;
						normals[ vC * 3 + 2 ] += cb.z;

					}

				}

			// non-indexed elements (unconnected triangle soup)

			} else {

				for ( i = 0, il = positions.length; i < il; i += 9 ) {

					x = positions[ i ];
					y = positions[ i + 1 ];
					z = positions[ i + 2 ];
					pA.set( x, y, z );

					x = positions[ i + 3 ];
					y = positions[ i + 4 ];
					z = positions[ i + 5 ];
					pB.set( x, y, z );

					x = positions[ i + 6 ];
					y = positions[ i + 7 ];
					z = positions[ i + 8 ];
					pC.set( x, y, z );

					cb.subVectors( pC, pB );
					ab.subVectors( pA, pB );
					cb.cross( ab );

					normals[ i ] 	 = cb.x;
					normals[ i + 1 ] = cb.y;
					normals[ i + 2 ] = cb.z;

					normals[ i + 3 ] = cb.x;
					normals[ i + 4 ] = cb.y;
					normals[ i + 5 ] = cb.z;

					normals[ i + 6 ] = cb.x;
					normals[ i + 7 ] = cb.y;
					normals[ i + 8 ] = cb.z;

				}

			}

			this.normalizeNormals();

			this.normalsNeedUpdate = true;

		}

	},

	normalizeNormals: function () {

		var normals = this.attributes[ "normal" ].array;

		var x, y, z, n;

		for ( var i = 0, il = normals.length; i < il; i += 3 ) {

			x = normals[ i ];
			y = normals[ i + 1 ];
			z = normals[ i + 2 ];

			n = 1.0 / Math.sqrt( x * x + y * y + z * z );

			normals[ i ] 	 *= n;
			normals[ i + 1 ] *= n;
			normals[ i + 2 ] *= n;

		}

	},

	computeTangents: function () {

		// based on http://www.terathon.com/code/tangent.html
		// (per vertex tangents)

		if ( this.attributes[ "index" ] === undefined ||
			 this.attributes[ "position" ] === undefined ||
			 this.attributes[ "normal" ] === undefined ||
			 this.attributes[ "uv" ] === undefined ) {

			console.warn( "Missing required attributes (index, position, normal or uv) in BufferGeometry.computeTangents()" );
			return;

		}

		var indices = this.attributes[ "index" ].array;
		var positions = this.attributes[ "position" ].array;
		var normals = this.attributes[ "normal" ].array;
		var uvs = this.attributes[ "uv" ].array;

		var nVertices = positions.length / 3;

		if ( this.attributes[ "tangent" ] === undefined ) {

			var nTangentElements = 4 * nVertices;

			this.attributes[ "tangent" ] = {

				itemSize: 4,
				array: new Float32Array( nTangentElements ),
				numItems: nTangentElements

			};

		}

		var tangents = this.attributes[ "tangent" ].array;

		var tan1 = [], tan2 = [];

		for ( var k = 0; k < nVertices; k ++ ) {

			tan1[ k ] = new THREE.Vector3();
			tan2[ k ] = new THREE.Vector3();

		}

		var xA, yA, zA,
			xB, yB, zB,
			xC, yC, zC,

			uA, vA,
			uB, vB,
			uC, vC,

			x1, x2, y1, y2, z1, z2,
			s1, s2, t1, t2, r;

		var sdir = new THREE.Vector3(), tdir = new THREE.Vector3();

		function handleTriangle( a, b, c ) {

			xA = positions[ a * 3 ];
			yA = positions[ a * 3 + 1 ];
			zA = positions[ a * 3 + 2 ];

			xB = positions[ b * 3 ];
			yB = positions[ b * 3 + 1 ];
			zB = positions[ b * 3 + 2 ];

			xC = positions[ c * 3 ];
			yC = positions[ c * 3 + 1 ];
			zC = positions[ c * 3 + 2 ];

			uA = uvs[ a * 2 ];
			vA = uvs[ a * 2 + 1 ];

			uB = uvs[ b * 2 ];
			vB = uvs[ b * 2 + 1 ];

			uC = uvs[ c * 2 ];
			vC = uvs[ c * 2 + 1 ];

			x1 = xB - xA;
			x2 = xC - xA;

			y1 = yB - yA;
			y2 = yC - yA;

			z1 = zB - zA;
			z2 = zC - zA;

			s1 = uB - uA;
			s2 = uC - uA;

			t1 = vB - vA;
			t2 = vC - vA;

			r = 1.0 / ( s1 * t2 - s2 * t1 );

			sdir.set(
				( t2 * x1 - t1 * x2 ) * r,
				( t2 * y1 - t1 * y2 ) * r,
				( t2 * z1 - t1 * z2 ) * r
			);

			tdir.set(
				( s1 * x2 - s2 * x1 ) * r,
				( s1 * y2 - s2 * y1 ) * r,
				( s1 * z2 - s2 * z1 ) * r
			);

			tan1[ a ].add( sdir );
			tan1[ b ].add( sdir );
			tan1[ c ].add( sdir );

			tan2[ a ].add( tdir );
			tan2[ b ].add( tdir );
			tan2[ c ].add( tdir );

		}

		var i, il;
		var j, jl;
		var iA, iB, iC;

		var offsets = this.offsets;

		for ( j = 0, jl = offsets.length; j < jl; ++ j ) {

			var start = offsets[ j ].start;
			var count = offsets[ j ].count;
			var index = offsets[ j ].index;

			for ( i = start, il = start + count; i < il; i += 3 ) {

				iA = index + indices[ i ];
				iB = index + indices[ i + 1 ];
				iC = index + indices[ i + 2 ];

				handleTriangle( iA, iB, iC );

			}

		}

		var tmp = new THREE.Vector3(), tmp2 = new THREE.Vector3();
		var n = new THREE.Vector3(), n2 = new THREE.Vector3();
		var w, t, test;
		var nx, ny, nz;

		function handleVertex( v ) {

			n.x = normals[ v * 3 ];
			n.y = normals[ v * 3 + 1 ];
			n.z = normals[ v * 3 + 2 ];

			n2.copy( n );

			t = tan1[ v ];

			// Gram-Schmidt orthogonalize

			tmp.copy( t );
			tmp.sub( n.multiplyScalar( n.dot( t ) ) ).normalize();

			// Calculate handedness

			tmp2.crossVectors( n2, t );
			test = tmp2.dot( tan2[ v ] );
			w = ( test < 0.0 ) ? -1.0 : 1.0;

			tangents[ v * 4 ] 	  = tmp.x;
			tangents[ v * 4 + 1 ] = tmp.y;
			tangents[ v * 4 + 2 ] = tmp.z;
			tangents[ v * 4 + 3 ] = w;

		}

		for ( j = 0, jl = offsets.length; j < jl; ++ j ) {

			var start = offsets[ j ].start;
			var count = offsets[ j ].count;
			var index = offsets[ j ].index;

			for ( i = start, il = start + count; i < il; i += 3 ) {

				iA = index + indices[ i ];
				iB = index + indices[ i + 1 ];
				iC = index + indices[ i + 2 ];

				handleVertex( iA );
				handleVertex( iB );
				handleVertex( iC );

			}

		}

		this.hasTangents = true;
		this.tangentsNeedUpdate = true;

	},

	dispose: function () {

		this.dispatchEvent( { type: 'dispose' } );

	}

};

/**
 * @author mrdoob / http://mrdoob.com/
 * @author mikael emtinger / http://gomo.se/
 */

THREE.Camera = function () {

	THREE.Object3D.call( this );

	this.matrixWorldInverse = new THREE.Matrix4();

	this.projectionMatrix = new THREE.Matrix4();
	this.projectionMatrixInverse = new THREE.Matrix4();

};

THREE.Camera.prototype = Object.create( THREE.Object3D.prototype );

THREE.Camera.prototype.lookAt = function ( vector ) {

	// TODO: Add hierarchy support.

	this.matrix.lookAt( this.position, vector, this.up );

	if ( this.rotationAutoUpdate === true ) {

		if ( this.useQuaternion === false )  {

			this.rotation.setEulerFromRotationMatrix( this.matrix, this.eulerOrder );

		} else {

			this.quaternion.copy( this.matrix.decompose()[ 1 ] );

		}

	}

};
/**
 * @author alteredq / http://alteredqualia.com/
 */

THREE.OrthographicCamera = function ( left, right, top, bottom, near, far ) {

	THREE.Camera.call( this );

	this.left = left;
	this.right = right;
	this.top = top;
	this.bottom = bottom;

	this.near = ( near !== undefined ) ? near : 0.1;
	this.far = ( far !== undefined ) ? far : 2000;

	this.updateProjectionMatrix();

};

THREE.OrthographicCamera.prototype = Object.create( THREE.Camera.prototype );

THREE.OrthographicCamera.prototype.updateProjectionMatrix = function () {

	this.projectionMatrix.makeOrthographic( this.left, this.right, this.top, this.bottom, this.near, this.far );

};
/**
 * @author mrdoob / http://mrdoob.com/
 * @author greggman / http://games.greggman.com/
 * @author zz85 / http://www.lab4games.net/zz85/blog
 */

THREE.PerspectiveCamera = function ( fov, aspect, near, far ) {

	THREE.Camera.call( this );

	this.fov = fov !== undefined ? fov : 50;
	this.aspect = aspect !== undefined ? aspect : 1;
	this.near = near !== undefined ? near : 0.1;
	this.far = far !== undefined ? far : 2000;

	this.updateProjectionMatrix();

};

THREE.PerspectiveCamera.prototype = Object.create( THREE.Camera.prototype );


/**
 * Uses Focal Length (in mm) to estimate and set FOV
 * 35mm (fullframe) camera is used if frame size is not specified;
 * Formula based on http://www.bobatkins.com/photography/technical/field_of_view.html
 */

THREE.PerspectiveCamera.prototype.setLens = function ( focalLength, frameHeight ) {

	if ( frameHeight === undefined ) frameHeight = 24;

	this.fov = 2 * THREE.Math.radToDeg( Math.atan( frameHeight / ( focalLength * 2 ) ) );
	this.updateProjectionMatrix();

}


/**
 * Sets an offset in a larger frustum. This is useful for multi-window or
 * multi-monitor/multi-machine setups.
 *
 * For example, if you have 3x2 monitors and each monitor is 1920x1080 and
 * the monitors are in grid like this
 *
 *   +---+---+---+
 *   | A | B | C |
 *   +---+---+---+
 *   | D | E | F |
 *   +---+---+---+
 *
 * then for each monitor you would call it like this
 *
 *   var w = 1920;
 *   var h = 1080;
 *   var fullWidth = w * 3;
 *   var fullHeight = h * 2;
 *
 *   --A--
 *   camera.setOffset( fullWidth, fullHeight, w * 0, h * 0, w, h );
 *   --B--
 *   camera.setOffset( fullWidth, fullHeight, w * 1, h * 0, w, h );
 *   --C--
 *   camera.setOffset( fullWidth, fullHeight, w * 2, h * 0, w, h );
 *   --D--
 *   camera.setOffset( fullWidth, fullHeight, w * 0, h * 1, w, h );
 *   --E--
 *   camera.setOffset( fullWidth, fullHeight, w * 1, h * 1, w, h );
 *   --F--
 *   camera.setOffset( fullWidth, fullHeight, w * 2, h * 1, w, h );
 *
 *   Note there is no reason monitors have to be the same size or in a grid.
 */

THREE.PerspectiveCamera.prototype.setViewOffset = function ( fullWidth, fullHeight, x, y, width, height ) {

	this.fullWidth = fullWidth;
	this.fullHeight = fullHeight;
	this.x = x;
	this.y = y;
	this.width = width;
	this.height = height;

	this.updateProjectionMatrix();

};


THREE.PerspectiveCamera.prototype.updateProjectionMatrix = function () {

	if ( this.fullWidth ) {

		var aspect = this.fullWidth / this.fullHeight;
		var top = Math.tan( THREE.Math.degToRad( this.fov * 0.5 ) ) * this.near;
		var bottom = -top;
		var left = aspect * bottom;
		var right = aspect * top;
		var width = Math.abs( right - left );
		var height = Math.abs( top - bottom );

		this.projectionMatrix.makeFrustum(
			left + this.x * width / this.fullWidth,
			left + ( this.x + this.width ) * width / this.fullWidth,
			top - ( this.y + this.height ) * height / this.fullHeight,
			top - this.y * height / this.fullHeight,
			this.near,
			this.far
		);

	} else {

		this.projectionMatrix.makePerspective( this.fov, this.aspect, this.near, this.far );

	}

};
/**
 * @author mrdoob / http://mrdoob.com/
 * @author alteredq / http://alteredqualia.com/
 */
 
THREE.Light = function ( hex ) {

	THREE.Object3D.call( this );

	this.color = new THREE.Color( hex );

};

THREE.Light.prototype = Object.create( THREE.Object3D.prototype );
/**
 * @author mrdoob / http://mrdoob.com/
 */

THREE.AmbientLight = function ( hex ) {

	THREE.Light.call( this, hex );

};

THREE.AmbientLight.prototype = Object.create( THREE.Light.prototype );
/**
 * @author MPanknin / http://www.redplant.de/
 * @author alteredq / http://alteredqualia.com/
 */

THREE.AreaLight = function ( hex, intensity ) {

	THREE.Light.call( this, hex );

	this.normal = new THREE.Vector3( 0, -1, 0 );
	this.right = new THREE.Vector3( 1, 0, 0 );

	this.intensity = ( intensity !== undefined ) ? intensity : 1;

	this.width = 1.0;
	this.height = 1.0;

	this.constantAttenuation = 1.5;
	this.linearAttenuation = 0.5;
	this.quadraticAttenuation = 0.1;

};

THREE.AreaLight.prototype = Object.create( THREE.Light.prototype );

/**
 * @author mrdoob / http://mrdoob.com/
 * @author alteredq / http://alteredqualia.com/
 */

THREE.DirectionalLight = function ( hex, intensity ) {

	THREE.Light.call( this, hex );

	this.position = new THREE.Vector3( 0, 1, 0 );
	this.target = new THREE.Object3D();

	this.intensity = ( intensity !== undefined ) ? intensity : 1;

	this.castShadow = false;
	this.onlyShadow = false;

	//

	this.shadowCameraNear = 50;
	this.shadowCameraFar = 5000;

	this.shadowCameraLeft = -500;
	this.shadowCameraRight = 500;
	this.shadowCameraTop = 500;
	this.shadowCameraBottom = -500;

	this.shadowCameraVisible = false;

	this.shadowBias = 0;
	this.shadowDarkness = 0.5;

	this.shadowMapWidth = 512;
	this.shadowMapHeight = 512;

	//

	this.shadowCascade = false;

	this.shadowCascadeOffset = new THREE.Vector3( 0, 0, -1000 );
	this.shadowCascadeCount = 2;

	this.shadowCascadeBias = [ 0, 0, 0 ];
	this.shadowCascadeWidth = [ 512, 512, 512 ];
	this.shadowCascadeHeight = [ 512, 512, 512 ];

	this.shadowCascadeNearZ = [ -1.000, 0.990, 0.998 ];
	this.shadowCascadeFarZ  = [  0.990, 0.998, 1.000 ];

	this.shadowCascadeArray = [];

	//

	this.shadowMap = null;
	this.shadowMapSize = null;
	this.shadowCamera = null;
	this.shadowMatrix = null;

};

THREE.DirectionalLight.prototype = Object.create( THREE.Light.prototype );
/**
 * @author alteredq / http://alteredqualia.com/
 */

THREE.HemisphereLight = function ( skyColorHex, groundColorHex, intensity ) {

	THREE.Light.call( this, skyColorHex );

	this.groundColor = new THREE.Color( groundColorHex );

	this.position = new THREE.Vector3( 0, 100, 0 );

	this.intensity = ( intensity !== undefined ) ? intensity : 1;

};

THREE.HemisphereLight.prototype = Object.create( THREE.Light.prototype );
/**
 * @author mrdoob / http://mrdoob.com/
 */

THREE.PointLight = function ( hex, intensity, distance ) {

	THREE.Light.call( this, hex );

	this.position = new THREE.Vector3( 0, 0, 0 );
	this.intensity = ( intensity !== undefined ) ? intensity : 1;
	this.distance = ( distance !== undefined ) ? distance : 0;

};

THREE.PointLight.prototype = Object.create( THREE.Light.prototype );
/**
 * @author alteredq / http://alteredqualia.com/
 */

THREE.SpotLight = function ( hex, intensity, distance, angle, exponent ) {

	THREE.Light.call( this, hex );

	this.position = new THREE.Vector3( 0, 1, 0 );
	this.target = new THREE.Object3D();

	this.intensity = ( intensity !== undefined ) ? intensity : 1;
	this.distance = ( distance !== undefined ) ? distance : 0;
	this.angle = ( angle !== undefined ) ? angle : Math.PI / 2;
	this.exponent = ( exponent !== undefined ) ? exponent : 10;

	this.castShadow = false;
	this.onlyShadow = false;

	//

	this.shadowCameraNear = 50;
	this.shadowCameraFar = 5000;
	this.shadowCameraFov = 50;

	this.shadowCameraVisible = false;

	this.shadowBias = 0;
	this.shadowDarkness = 0.5;

	this.shadowMapWidth = 512;
	this.shadowMapHeight = 512;

	//

	this.shadowMap = null;
	this.shadowMapSize = null;
	this.shadowCamera = null;
	this.shadowMatrix = null;

};

THREE.SpotLight.prototype = Object.create( THREE.Light.prototype );
/**
 * @author alteredq / http://alteredqualia.com/
 */

THREE.Loader = function ( showStatus ) {

	this.showStatus = showStatus;
	this.statusDomElement = showStatus ? THREE.Loader.prototype.addStatusElement() : null;

	this.onLoadStart = function () {};
	this.onLoadProgress = function () {};
	this.onLoadComplete = function () {};

};

THREE.Loader.prototype = {

	constructor: THREE.Loader,

	crossOrigin: 'anonymous',

	addStatusElement: function () {

		var e = document.createElement( "div" );

		e.style.position = "absolute";
		e.style.right = "0px";
		e.style.top = "0px";
		e.style.fontSize = "0.8em";
		e.style.textAlign = "left";
		e.style.background = "rgba(0,0,0,0.25)";
		e.style.color = "#fff";
		e.style.width = "120px";
		e.style.padding = "0.5em 0.5em 0.5em 0.5em";
		e.style.zIndex = 1000;

		e.innerHTML = "Loading ...";

		return e;

	},

	updateProgress: function ( progress ) {

		var message = "Loaded ";

		if ( progress.total ) {

			message += ( 100 * progress.loaded / progress.total ).toFixed(0) + "%";


		} else {

			message += ( progress.loaded / 1000 ).toFixed(2) + " KB";

		}

		this.statusDomElement.innerHTML = message;

	},

	extractUrlBase: function ( url ) {

		var parts = url.split( '/' );
		parts.pop();
		return ( parts.length < 1 ? '.' : parts.join( '/' ) ) + '/';

	},

	initMaterials: function ( materials, texturePath ) {

		var array = [];

		for ( var i = 0; i < materials.length; ++ i ) {

			array[ i ] = THREE.Loader.prototype.createMaterial( materials[ i ], texturePath );

		}

		return array;

	},

	needsTangents: function ( materials ) {

		for( var i = 0, il = materials.length; i < il; i ++ ) {

			var m = materials[ i ];

			if ( m instanceof THREE.ShaderMaterial ) return true;

		}

		return false;

	},

	createMaterial: function ( m, texturePath ) {

		var _this = this;

		function is_pow2( n ) {

			var l = Math.log( n ) / Math.LN2;
			return Math.floor( l ) == l;

		}

		function nearest_pow2( n ) {

			var l = Math.log( n ) / Math.LN2;
			return Math.pow( 2, Math.round(  l ) );

		}

		function load_image( where, url ) {

			var image = new Image();

			image.onload = function () {

				if ( !is_pow2( this.width ) || !is_pow2( this.height ) ) {

					var width = nearest_pow2( this.width );
					var height = nearest_pow2( this.height );

					where.image.width = width;
					where.image.height = height;
					where.image.getContext( '2d' ).drawImage( this, 0, 0, width, height );

				} else {

					where.image = this;

				}

				where.needsUpdate = true;

			};

			image.crossOrigin = _this.crossOrigin;
			image.src = url;

		}

		function create_texture( where, name, sourceFile, repeat, offset, wrap, anisotropy ) {

			var isCompressed = sourceFile.toLowerCase().endsWith( ".dds" );
			var fullPath = texturePath + "/" + sourceFile;

			if ( isCompressed ) {

				var texture = THREE.ImageUtils.loadCompressedTexture( fullPath );

				where[ name ] = texture;

			} else {

				var texture = document.createElement( 'canvas' );

				where[ name ] = new THREE.Texture( texture );

			}

			where[ name ].sourceFile = sourceFile;

			if( repeat ) {

				where[ name ].repeat.set( repeat[ 0 ], repeat[ 1 ] );

				if ( repeat[ 0 ] !== 1 ) where[ name ].wrapS = THREE.RepeatWrapping;
				if ( repeat[ 1 ] !== 1 ) where[ name ].wrapT = THREE.RepeatWrapping;

			}

			if ( offset ) {

				where[ name ].offset.set( offset[ 0 ], offset[ 1 ] );

			}

			if ( wrap ) {

				var wrapMap = {
					"repeat": THREE.RepeatWrapping,
					"mirror": THREE.MirroredRepeatWrapping
				}

				if ( wrapMap[ wrap[ 0 ] ] !== undefined ) where[ name ].wrapS = wrapMap[ wrap[ 0 ] ];
				if ( wrapMap[ wrap[ 1 ] ] !== undefined ) where[ name ].wrapT = wrapMap[ wrap[ 1 ] ];

			}

			if ( anisotropy ) {

				where[ name ].anisotropy = anisotropy;

			}

			if ( ! isCompressed ) {

				load_image( where[ name ], fullPath );

			}

		}

		function rgb2hex( rgb ) {

			return ( rgb[ 0 ] * 255 << 16 ) + ( rgb[ 1 ] * 255 << 8 ) + rgb[ 2 ] * 255;

		}

		// defaults

		var mtype = "MeshLambertMaterial";
		var mpars = { color: 0xeeeeee, opacity: 1.0, map: null, lightMap: null, normalMap: null, bumpMap: null, wireframe: false };

		// parameters from model file

		if ( m.shading ) {

			var shading = m.shading.toLowerCase();

			if ( shading === "phong" ) mtype = "MeshPhongMaterial";
			else if ( shading === "basic" ) mtype = "MeshBasicMaterial";

		}

		if ( m.blending !== undefined && THREE[ m.blending ] !== undefined ) {

			mpars.blending = THREE[ m.blending ];

		}

		if ( m.transparent !== undefined || m.opacity < 1.0 ) {

			mpars.transparent = m.transparent;

		}

		if ( m.depthTest !== undefined ) {

			mpars.depthTest = m.depthTest;

		}

		if ( m.depthWrite !== undefined ) {

			mpars.depthWrite = m.depthWrite;

		}

		if ( m.visible !== undefined ) {

			mpars.visible = m.visible;

		}

		if ( m.flipSided !== undefined ) {

			mpars.side = THREE.BackSide;

		}

		if ( m.doubleSided !== undefined ) {

			mpars.side = THREE.DoubleSide;

		}

		if ( m.wireframe !== undefined ) {

			mpars.wireframe = m.wireframe;

		}

		if ( m.vertexColors !== undefined ) {

			if ( m.vertexColors === "face" ) {

				mpars.vertexColors = THREE.FaceColors;

			} else if ( m.vertexColors ) {

				mpars.vertexColors = THREE.VertexColors;

			}

		}

		// colors

		if ( m.colorDiffuse ) {

			mpars.color = rgb2hex( m.colorDiffuse );

		} else if ( m.DbgColor ) {

			mpars.color = m.DbgColor;

		}

		if ( m.colorSpecular ) {

			mpars.specular = rgb2hex( m.colorSpecular );

		}

		if ( m.colorAmbient ) {

			mpars.ambient = rgb2hex( m.colorAmbient );

		}

		// modifiers

		if ( m.transparency ) {

			mpars.opacity = m.transparency;

		}

		if ( m.specularCoef ) {

			mpars.shininess = m.specularCoef;

		}

		// textures

		if ( m.mapDiffuse && texturePath ) {

			create_texture( mpars, "map", m.mapDiffuse, m.mapDiffuseRepeat, m.mapDiffuseOffset, m.mapDiffuseWrap, m.mapDiffuseAnisotropy );

		}

		if ( m.mapLight && texturePath ) {

			create_texture( mpars, "lightMap", m.mapLight, m.mapLightRepeat, m.mapLightOffset, m.mapLightWrap, m.mapLightAnisotropy );

		}

		if ( m.mapBump && texturePath ) {

			create_texture( mpars, "bumpMap", m.mapBump, m.mapBumpRepeat, m.mapBumpOffset, m.mapBumpWrap, m.mapBumpAnisotropy );

		}

		if ( m.mapNormal && texturePath ) {

			create_texture( mpars, "normalMap", m.mapNormal, m.mapNormalRepeat, m.mapNormalOffset, m.mapNormalWrap, m.mapNormalAnisotropy );

		}

		if ( m.mapSpecular && texturePath ) {

			create_texture( mpars, "specularMap", m.mapSpecular, m.mapSpecularRepeat, m.mapSpecularOffset, m.mapSpecularWrap, m.mapSpecularAnisotropy );

		}

		//

		if ( m.mapBumpScale ) {

			mpars.bumpScale = m.mapBumpScale;

		}

		// special case for normal mapped material

		if ( m.mapNormal ) {

			var shader = THREE.ShaderLib[ "normalmap" ];
			var uniforms = THREE.UniformsUtils.clone( shader.uniforms );

			uniforms[ "tNormal" ].value = mpars.normalMap;

			if ( m.mapNormalFactor ) {

				uniforms[ "uNormalScale" ].value.set( m.mapNormalFactor, m.mapNormalFactor );

			}

			if ( mpars.map ) {

				uniforms[ "tDiffuse" ].value = mpars.map;
				uniforms[ "enableDiffuse" ].value = true;

			}

			if ( mpars.specularMap ) {

				uniforms[ "tSpecular" ].value = mpars.specularMap;
				uniforms[ "enableSpecular" ].value = true;

			}

			if ( mpars.lightMap ) {

				uniforms[ "tAO" ].value = mpars.lightMap;
				uniforms[ "enableAO" ].value = true;

			}

			// for the moment don't handle displacement texture

			uniforms[ "uDiffuseColor" ].value.setHex( mpars.color );
			uniforms[ "uSpecularColor" ].value.setHex( mpars.specular );
			uniforms[ "uAmbientColor" ].value.setHex( mpars.ambient );

			uniforms[ "uShininess" ].value = mpars.shininess;

			if ( mpars.opacity !== undefined ) {

				uniforms[ "uOpacity" ].value = mpars.opacity;

			}

			var parameters = { fragmentShader: shader.fragmentShader, vertexShader: shader.vertexShader, uniforms: uniforms, lights: true, fog: true };
			var material = new THREE.ShaderMaterial( parameters );

			if ( mpars.transparent ) {

				material.transparent = true;

			}

		} else {

			var material = new THREE[ mtype ]( mpars );

		}

		if ( m.DbgName !== undefined ) material.name = m.DbgName;

		return material;

	}

};
/**
 * @author mrdoob / http://mrdoob.com/
 */

THREE.ImageLoader = function () {

	THREE.EventDispatcher.call( this );

	this.crossOrigin = null;

};

THREE.ImageLoader.prototype = {

	constructor: THREE.ImageLoader,

	load: function ( url, image ) {

		var scope = this;

		if ( image === undefined ) image = new Image();

		image.addEventListener( 'load', function () {

			scope.dispatchEvent( { type: 'load', content: image } );

		}, false );

		image.addEventListener( 'error', function () {

			scope.dispatchEvent( { type: 'error', message: 'Couldn\'t load URL [' + url + ']' } );

		}, false );

		if ( scope.crossOrigin ) image.crossOrigin = scope.crossOrigin;

		image.src = url;

	}

}
/**
 * @author mrdoob / http://mrdoob.com/
 * @author alteredq / http://alteredqualia.com/
 */

THREE.JSONLoader = function ( showStatus ) {

	THREE.Loader.call( this, showStatus );

	this.withCredentials = false;

};

THREE.JSONLoader.prototype = Object.create( THREE.Loader.prototype );

THREE.JSONLoader.prototype.load = function ( url, callback, texturePath ) {

	var scope = this;

	// todo: unify load API to for easier SceneLoader use

	texturePath = texturePath && ( typeof texturePath === "string" ) ? texturePath : this.extractUrlBase( url );

	this.onLoadStart();
	this.loadAjaxJSON( this, url, callback, texturePath );

};

THREE.JSONLoader.prototype.loadAjaxJSON = function ( context, url, callback, texturePath, callbackProgress ) {

	var xhr = new XMLHttpRequest();

	var length = 0;

	xhr.onreadystatechange = function () {

		if ( xhr.readyState === xhr.DONE ) {

			if ( xhr.status === 200 || xhr.status === 0 ) {

				if ( xhr.responseText ) {

					var json = JSON.parse( xhr.responseText );
					context.createModel( json, callback, texturePath );

				} else {

					console.warn( "THREE.JSONLoader: [" + url + "] seems to be unreachable or file there is empty" );

				}

				// in context of more complex asset initialization
				// do not block on single failed file
				// maybe should go even one more level up

				context.onLoadComplete();

			} else {

				console.error( "THREE.JSONLoader: Couldn't load [" + url + "] [" + xhr.status + "]" );

			}

		} else if ( xhr.readyState === xhr.LOADING ) {

			if ( callbackProgress ) {

				if ( length === 0 ) {

					length = xhr.getResponseHeader( "Content-Length" );

				}

				callbackProgress( { total: length, loaded: xhr.responseText.length } );

			}

		} else if ( xhr.readyState === xhr.HEADERS_RECEIVED ) {

			length = xhr.getResponseHeader( "Content-Length" );

		}

	};

	xhr.open( "GET", url, true );
	xhr.withCredentials = this.withCredentials;
	xhr.send( null );

};

THREE.JSONLoader.prototype.createModel = function ( json, callback, texturePath ) {

	var scope = this,
	geometry = new THREE.Geometry(),
	scale = ( json.scale !== undefined ) ? 1.0 / json.scale : 1.0;

	parseModel( scale );

	parseSkin();
	parseMorphing( scale );

	geometry.computeCentroids();
	geometry.computeFaceNormals();

	function parseModel( scale ) {

		function isBitSet( value, position ) {

			return value & ( 1 << position );

		}

		var i, j, fi,

		offset, zLength, nVertices,

		colorIndex, normalIndex, uvIndex, materialIndex,

		type,
		isQuad,
		hasMaterial,
		hasFaceUv, hasFaceVertexUv,
		hasFaceNormal, hasFaceVertexNormal,
		hasFaceColor, hasFaceVertexColor,

		vertex, face, color, normal,

		uvLayer, uvs, u, v,

		faces = json.faces,
		vertices = json.vertices,
		normals = json.normals,
		colors = json.colors,

		nUvLayers = 0;

		// disregard empty arrays

		for ( i = 0; i < json.uvs.length; i++ ) {

			if ( json.uvs[ i ].length ) nUvLayers ++;

		}

		for ( i = 0; i < nUvLayers; i++ ) {

			geometry.faceUvs[ i ] = [];
			geometry.faceVertexUvs[ i ] = [];

		}

		offset = 0;
		zLength = vertices.length;

		while ( offset < zLength ) {

			vertex = new THREE.Vector3();

			vertex.x = vertices[ offset ++ ] * scale;
			vertex.y = vertices[ offset ++ ] * scale;
			vertex.z = vertices[ offset ++ ] * scale;

			geometry.vertices.push( vertex );

		}

		offset = 0;
		zLength = faces.length;

		while ( offset < zLength ) {

			type = faces[ offset ++ ];


			isQuad          	= isBitSet( type, 0 );
			hasMaterial         = isBitSet( type, 1 );
			hasFaceUv           = isBitSet( type, 2 );
			hasFaceVertexUv     = isBitSet( type, 3 );
			hasFaceNormal       = isBitSet( type, 4 );
			hasFaceVertexNormal = isBitSet( type, 5 );
			hasFaceColor	    = isBitSet( type, 6 );
			hasFaceVertexColor  = isBitSet( type, 7 );

			//console.log("type", type, "bits", isQuad, hasMaterial, hasFaceUv, hasFaceVertexUv, hasFaceNormal, hasFaceVertexNormal, hasFaceColor, hasFaceVertexColor);

			if ( isQuad ) {

				face = new THREE.Face4();

				face.a = faces[ offset ++ ];
				face.b = faces[ offset ++ ];
				face.c = faces[ offset ++ ];
				face.d = faces[ offset ++ ];

				nVertices = 4;

			} else {

				face = new THREE.Face3();

				face.a = faces[ offset ++ ];
				face.b = faces[ offset ++ ];
				face.c = faces[ offset ++ ];

				nVertices = 3;

			}

			if ( hasMaterial ) {

				materialIndex = faces[ offset ++ ];
				face.materialIndex = materialIndex;

			}

			// to get face <=> uv index correspondence

			fi = geometry.faces.length;

			if ( hasFaceUv ) {

				for ( i = 0; i < nUvLayers; i++ ) {

					uvLayer = json.uvs[ i ];

					uvIndex = faces[ offset ++ ];

					u = uvLayer[ uvIndex * 2 ];
					v = uvLayer[ uvIndex * 2 + 1 ];

					geometry.faceUvs[ i ][ fi ] = new THREE.Vector2( u, v );

				}

			}

			if ( hasFaceVertexUv ) {

				for ( i = 0; i < nUvLayers; i++ ) {

					uvLayer = json.uvs[ i ];

					uvs = [];

					for ( j = 0; j < nVertices; j ++ ) {

						uvIndex = faces[ offset ++ ];

						u = uvLayer[ uvIndex * 2 ];
						v = uvLayer[ uvIndex * 2 + 1 ];

						uvs[ j ] = new THREE.Vector2( u, v );

					}

					geometry.faceVertexUvs[ i ][ fi ] = uvs;

				}

			}

			if ( hasFaceNormal ) {

				normalIndex = faces[ offset ++ ] * 3;

				normal = new THREE.Vector3();

				normal.x = normals[ normalIndex ++ ];
				normal.y = normals[ normalIndex ++ ];
				normal.z = normals[ normalIndex ];

				face.normal = normal;

			}

			if ( hasFaceVertexNormal ) {

				for ( i = 0; i < nVertices; i++ ) {

					normalIndex = faces[ offset ++ ] * 3;

					normal = new THREE.Vector3();

					normal.x = normals[ normalIndex ++ ];
					normal.y = normals[ normalIndex ++ ];
					normal.z = normals[ normalIndex ];

					face.vertexNormals.push( normal );

				}

			}


			if ( hasFaceColor ) {

				colorIndex = faces[ offset ++ ];

				color = new THREE.Color( colors[ colorIndex ] );
				face.color = color;

			}


			if ( hasFaceVertexColor ) {

				for ( i = 0; i < nVertices; i++ ) {

					colorIndex = faces[ offset ++ ];

					color = new THREE.Color( colors[ colorIndex ] );
					face.vertexColors.push( color );

				}

			}

			geometry.faces.push( face );

		}

	};

	function parseSkin() {

		var i, l, x, y, z, w, a, b, c, d;

		if ( json.skinWeights ) {

			for ( i = 0, l = json.skinWeights.length; i < l; i += 2 ) {

				x = json.skinWeights[ i     ];
				y = json.skinWeights[ i + 1 ];
				z = 0;
				w = 0;

				geometry.skinWeights.push( new THREE.Vector4( x, y, z, w ) );

			}

		}

		if ( json.skinIndices ) {

			for ( i = 0, l = json.skinIndices.length; i < l; i += 2 ) {

				a = json.skinIndices[ i     ];
				b = json.skinIndices[ i + 1 ];
				c = 0;
				d = 0;

				geometry.skinIndices.push( new THREE.Vector4( a, b, c, d ) );

			}

		}

		geometry.bones = json.bones;
		geometry.animation = json.animation;

	};

	function parseMorphing( scale ) {

		if ( json.morphTargets !== undefined ) {

			var i, l, v, vl, dstVertices, srcVertices;

			for ( i = 0, l = json.morphTargets.length; i < l; i ++ ) {

				geometry.morphTargets[ i ] = {};
				geometry.morphTargets[ i ].name = json.morphTargets[ i ].name;
				geometry.morphTargets[ i ].vertices = [];

				dstVertices = geometry.morphTargets[ i ].vertices;
				srcVertices = json.morphTargets [ i ].vertices;

				for( v = 0, vl = srcVertices.length; v < vl; v += 3 ) {

					var vertex = new THREE.Vector3();
					vertex.x = srcVertices[ v ] * scale;
					vertex.y = srcVertices[ v + 1 ] * scale;
					vertex.z = srcVertices[ v + 2 ] * scale;

					dstVertices.push( vertex );

				}

			}

		}

		if ( json.morphColors !== undefined ) {

			var i, l, c, cl, dstColors, srcColors, color;

			for ( i = 0, l = json.morphColors.length; i < l; i++ ) {

				geometry.morphColors[ i ] = {};
				geometry.morphColors[ i ].name = json.morphColors[ i ].name;
				geometry.morphColors[ i ].colors = [];

				dstColors = geometry.morphColors[ i ].colors;
				srcColors = json.morphColors [ i ].colors;

				for ( c = 0, cl = srcColors.length; c < cl; c += 3 ) {

					color = new THREE.Color( 0xffaa00 );
					color.setRGB( srcColors[ c ], srcColors[ c + 1 ], srcColors[ c + 2 ] );
					dstColors.push( color );

				}

			}

		}

	};

	var materials = this.initMaterials( json.materials, texturePath );

	if ( this.needsTangents( materials ) ) geometry.computeTangents();

	callback( geometry, materials );

};
/**
 * @author mrdoob / http://mrdoob.com/
 */

THREE.LoadingMonitor = function () {

	THREE.EventDispatcher.call( this );

	var scope = this;

	var loaded = 0;
	var total = 0;

	var onLoad = function ( event ) {

		loaded ++;

		scope.dispatchEvent( { type: 'progress', loaded: loaded, total: total } );

		if ( loaded === total ) {

			scope.dispatchEvent( { type: 'load' } );

		}

	};

	this.add = function ( loader ) {

		total ++;

		loader.addEventListener( 'load', onLoad, false );

	};

};
/**
 * @author alteredq / http://alteredqualia.com/
 */

THREE.SceneLoader = function () {

	this.onLoadStart = function () {};
	this.onLoadProgress = function() {};
	this.onLoadComplete = function () {};

	this.callbackSync = function () {};
	this.callbackProgress = function () {};

	this.geometryHandlerMap = {};
	this.hierarchyHandlerMap = {};

	this.addGeometryHandler( "ascii", THREE.JSONLoader );

};

THREE.SceneLoader.prototype.constructor = THREE.SceneLoader;

THREE.SceneLoader.prototype.load = function ( url, callbackFinished ) {

	var scope = this;

	var xhr = new XMLHttpRequest();

	xhr.onreadystatechange = function () {

		if ( xhr.readyState === 4 ) {

			if ( xhr.status === 200 || xhr.status === 0 ) {

				var json = JSON.parse( xhr.responseText );
				scope.parse( json, callbackFinished, url );

			} else {

				console.error( "THREE.SceneLoader: Couldn't load [" + url + "] [" + xhr.status + "]" );

			}

		}

	};

	xhr.open( "GET", url, true );
	xhr.send( null );

};

THREE.SceneLoader.prototype.addGeometryHandler = function ( typeID, loaderClass ) {

	this.geometryHandlerMap[ typeID ] = { "loaderClass": loaderClass };

};

THREE.SceneLoader.prototype.addHierarchyHandler = function ( typeID, loaderClass ) {

	this.hierarchyHandlerMap[ typeID ] = { "loaderClass": loaderClass };

};

THREE.SceneLoader.prototype.parse = function ( json, callbackFinished, url ) {

	var scope = this;

	var urlBase = THREE.Loader.prototype.extractUrlBase( url );

	var geometry, material, camera, fog,
		texture, images, color,
		light, hex, intensity,
		counter_models, counter_textures,
		total_models, total_textures,
		result;

	var target_array = [];

	var data = json;

	// async geometry loaders

	for ( var typeID in this.geometryHandlerMap ) {

		var loaderClass = this.geometryHandlerMap[ typeID ][ "loaderClass" ];
		this.geometryHandlerMap[ typeID ][ "loaderObject" ] = new loaderClass();

	}

	// async hierachy loaders

	for ( var typeID in this.hierarchyHandlerMap ) {

		var loaderClass = this.hierarchyHandlerMap[ typeID ][ "loaderClass" ];
		this.hierarchyHandlerMap[ typeID ][ "loaderObject" ] = new loaderClass();

	}

	counter_models = 0;
	counter_textures = 0;

	result = {

		scene: new THREE.Scene(),
		geometries: {},
		face_materials: {},
		materials: {},
		textures: {},
		objects: {},
		cameras: {},
		lights: {},
		fogs: {},
		empties: {},
		groups: {}

	};

	if ( data.transform ) {

		var position = data.transform.position,
			rotation = data.transform.rotation,
			scale = data.transform.scale;

		if ( position )
			result.scene.position.set( position[ 0 ], position[ 1 ], position [ 2 ] );

		if ( rotation )
			result.scene.rotation.set( rotation[ 0 ], rotation[ 1 ], rotation [ 2 ] );

		if ( scale )
			result.scene.scale.set( scale[ 0 ], scale[ 1 ], scale [ 2 ] );

		if ( position || rotation || scale ) {

			result.scene.updateMatrix();
			result.scene.updateMatrixWorld();

		}

	}

	function get_url( source_url, url_type ) {

		if ( url_type == "relativeToHTML" ) {

			return source_url;

		} else {

			return urlBase + "/" + source_url;

		}

	};

	// toplevel loader function, delegates to handle_children

	function handle_objects() {

		handle_children( result.scene, data.objects );

	}

	// handle all the children from the loaded json and attach them to given parent

	function handle_children( parent, children ) {

		var mat, dst, pos, rot, scl, quat;

		for ( var objID in children ) {

			// check by id if child has already been handled,
			// if not, create new object

			if ( result.objects[ objID ] === undefined ) {

				var objJSON = children[ objID ];

				var object = null;

				// meshes

				if ( objJSON.type && ( objJSON.type in scope.hierarchyHandlerMap ) ) {

					if ( objJSON.loading === undefined ) {

						var reservedTypes = { "type": 1, "url": 1, "material": 1,
											  "position": 1, "rotation": 1, "scale" : 1,
											  "visible": 1, "children": 1, "properties": 1,
											  "skin": 1, "morph": 1, "mirroredLoop": 1, "duration": 1 };

						var loaderParameters = {};

						for ( var parType in objJSON ) {

							if ( ! ( parType in reservedTypes ) ) {

								loaderParameters[ parType ] = objJSON[ parType ];

							}

						}

						material = result.materials[ objJSON.material ];

						objJSON.loading = true;

						var loader = scope.hierarchyHandlerMap[ objJSON.type ][ "loaderObject" ];

						// ColladaLoader

						if ( loader.options ) {

							loader.load( get_url( objJSON.url, data.urlBaseType ), create_callback_hierachy( objID, parent, material, objJSON ) );

						// UTF8Loader
						// OBJLoader

						} else {

							loader.load( get_url( objJSON.url, data.urlBaseType ), create_callback_hierachy( objID, parent, material, objJSON ), loaderParameters );

						}

					}

				} else if ( objJSON.geometry !== undefined ) {

					geometry = result.geometries[ objJSON.geometry ];

					// geometry already loaded

					if ( geometry ) {

						var needsTangents = false;

						material = result.materials[ objJSON.material ];
						needsTangents = material instanceof THREE.ShaderMaterial;

						pos = objJSON.position;
						rot = objJSON.rotation;
						scl = objJSON.scale;
						mat = objJSON.matrix;
						quat = objJSON.quaternion;

						// use materials from the model file
						// if there is no material specified in the object

						if ( ! objJSON.material ) {

							material = new THREE.MeshFaceMaterial( result.face_materials[ objJSON.geometry ] );

						}

						// use materials from the model file
						// if there is just empty face material
						// (must create new material as each model has its own face material)

						if ( ( material instanceof THREE.MeshFaceMaterial ) && material.materials.length === 0 ) {

							material = new THREE.MeshFaceMaterial( result.face_materials[ objJSON.geometry ] );

						}

						if ( material instanceof THREE.MeshFaceMaterial ) {

							for ( var i = 0; i < material.materials.length; i ++ ) {

								needsTangents = needsTangents || ( material.materials[ i ] instanceof THREE.ShaderMaterial );

							}

						}

						if ( needsTangents ) {

							geometry.computeTangents();

						}

						if ( objJSON.skin ) {

							object = new THREE.SkinnedMesh( geometry, material );

						} else if ( objJSON.morph ) {

							object = new THREE.MorphAnimMesh( geometry, material );

							if ( objJSON.duration !== undefined ) {

								object.duration = objJSON.duration;

							}

							if ( objJSON.time !== undefined ) {

								object.time = objJSON.time;

							}

							if ( objJSON.mirroredLoop !== undefined ) {

								object.mirroredLoop = objJSON.mirroredLoop;

							}

							if ( material.morphNormals ) {

								geometry.computeMorphNormals();

							}

						} else {

							object = new THREE.Mesh( geometry, material );

						}

						object.name = objID;

						if ( mat ) {

							object.matrixAutoUpdate = false;
							object.matrix.set(
								mat[0],  mat[1],  mat[2],  mat[3],
								mat[4],  mat[5],  mat[6],  mat[7],
								mat[8],  mat[9],  mat[10], mat[11],
								mat[12], mat[13], mat[14], mat[15]
							);

						} else {

							object.position.set( pos[0], pos[1], pos[2] );

							if ( quat ) {

								object.quaternion.set( quat[0], quat[1], quat[2], quat[3] );
								object.useQuaternion = true;

							} else {

								object.rotation.set( rot[0], rot[1], rot[2] );

							}

							object.scale.set( scl[0], scl[1], scl[2] );

						}

						object.visible = objJSON.visible;
						object.castShadow = objJSON.castShadow;
						object.receiveShadow = objJSON.receiveShadow;

						parent.add( object );

						result.objects[ objID ] = object;

					}

				// lights

				} else if ( objJSON.type === "DirectionalLight" || objJSON.type === "PointLight" || objJSON.type === "AmbientLight" ) {

					hex = ( objJSON.color !== undefined ) ? objJSON.color : 0xffffff;
					intensity = ( objJSON.intensity !== undefined ) ? objJSON.intensity : 1;

					if ( objJSON.type === "DirectionalLight" ) {

						pos = objJSON.direction;

						light = new THREE.DirectionalLight( hex, intensity );
						light.position.set( pos[0], pos[1], pos[2] );

						if ( objJSON.target ) {

							target_array.push( { "object": light, "targetName" : objJSON.target } );

							// kill existing default target
							// otherwise it gets added to scene when parent gets added

							light.target = null;

						}

					} else if ( objJSON.type === "PointLight" ) {

						pos = objJSON.position;
						dst = objJSON.distance;

						light = new THREE.PointLight( hex, intensity, dst );
						light.position.set( pos[0], pos[1], pos[2] );

					} else if ( objJSON.type === "AmbientLight" ) {

						light = new THREE.AmbientLight( hex );

					}

					parent.add( light );

					light.name = objID;
					result.lights[ objID ] = light;
					result.objects[ objID ] = light;

				// cameras

				} else if ( objJSON.type === "PerspectiveCamera" || objJSON.type === "OrthographicCamera" ) {

					if ( objJSON.type === "PerspectiveCamera" ) {

						camera = new THREE.PerspectiveCamera( objJSON.fov, objJSON.aspect, objJSON.near, objJSON.far );

					} else if ( objJSON.type === "OrthographicCamera" ) {

						camera = new THREE.OrthographicCamera( objJSON.left, objJSON.right, objJSON.top, objJSON.bottom, objJSON.near, objJSON.far );

					}

					pos = objJSON.position;
					camera.position.set( pos[0], pos[1], pos[2] );
					parent.add( camera );

					camera.name = objID;
					result.cameras[ objID ] = camera;
					result.objects[ objID ] = camera;

				// pure Object3D

				} else {

					pos = objJSON.position;
					rot = objJSON.rotation;
					scl = objJSON.scale;
					quat = objJSON.quaternion;

					object = new THREE.Object3D();
					object.name = objID;
					object.position.set( pos[0], pos[1], pos[2] );

					if ( quat ) {

						object.quaternion.set( quat[0], quat[1], quat[2], quat[3] );
						object.useQuaternion = true;

					} else {

						object.rotation.set( rot[0], rot[1], rot[2] );

					}

					object.scale.set( scl[0], scl[1], scl[2] );
					object.visible = ( objJSON.visible !== undefined ) ? objJSON.visible : false;

					parent.add( object );

					result.objects[ objID ] = object;
					result.empties[ objID ] = object;

				}

				if ( object ) {

					if ( objJSON.properties !== undefined )  {

						for ( var key in objJSON.properties ) {

							var value = objJSON.properties[ key ];
							object.properties[ key ] = value;

						}

					}

					if ( objJSON.groups !== undefined ) {

						for ( var i = 0; i < objJSON.groups.length; i ++ ) {

							var groupID = objJSON.groups[ i ];

							if ( result.groups[ groupID ] === undefined ) {

								result.groups[ groupID ] = [];

							}

							result.groups[ groupID ].push( objID );

						}

					}

					if ( objJSON.children !== undefined ) {

						handle_children( object, objJSON.children );

					}

				}

			}

		}

	};

	function handle_mesh( geo, mat, id ) {

		result.geometries[ id ] = geo;
		result.face_materials[ id ] = mat;
		handle_objects();

	};

	function handle_hierarchy( node, id, parent, material, obj ) {

		var p = obj.position;
		var r = obj.rotation;
		var q = obj.quaternion;
		var s = obj.scale;

		node.position.set( p[0], p[1], p[2] );

		if ( q ) {

			node.quaternion.set( q[0], q[1], q[2], q[3] );
			node.useQuaternion = true;

		} else {

			node.rotation.set( r[0], r[1], r[2] );

		}

		node.scale.set( s[0], s[1], s[2] );

		// override children materials
		// if object material was specified in JSON explicitly

		if ( material ) {

			node.traverse( function ( child )  {

				child.material = material;

			} );

		}

		// override children visibility
		// with root node visibility as specified in JSON

		var visible = ( obj.visible !== undefined ) ? obj.visible : true;

		node.traverse( function ( child )  {

			child.visible = visible;

		} );

		parent.add( node );

		node.name = id;

		result.objects[ id ] = node;
		handle_objects();

	};

	function create_callback_geometry( id ) {

		return function( geo, mat ) {

			handle_mesh( geo, mat, id );

			counter_models -= 1;

			scope.onLoadComplete();

			async_callback_gate();

		}

	};

	function create_callback_hierachy( id, parent, material, obj ) {

		return function( event ) {

			var result;

			// loaders which use EventDispatcher

			if ( event.content ) {

				result = event.content;

			// ColladaLoader

			} else if ( event.dae ) {

				result = event.scene;


			// UTF8Loader

			} else {

				result = event;

			}

			handle_hierarchy( result, id, parent, material, obj );

			counter_models -= 1;

			scope.onLoadComplete();

			async_callback_gate();

		}

	};

	function create_callback_embed( id ) {

		return function( geo, mat ) {

			result.geometries[ id ] = geo;
			result.face_materials[ id ] = mat;

		}

	};

	function async_callback_gate() {

		var progress = {

			totalModels : total_models,
			totalTextures : total_textures,
			loadedModels : total_models - counter_models,
			loadedTextures : total_textures - counter_textures

		};

		scope.callbackProgress( progress, result );

		scope.onLoadProgress();

		if ( counter_models === 0 && counter_textures === 0 ) {

			finalize();
			callbackFinished( result );

		}

	};

	function finalize() {

		// take care of targets which could be asynchronously loaded objects

		for ( var i = 0; i < target_array.length; i ++ ) {

			var ta = target_array[ i ];

			var target = result.objects[ ta.targetName ];

			if ( target ) {

				ta.object.target = target;

			} else {

				// if there was error and target of specified name doesn't exist in the scene file
				// create instead dummy target
				// (target must be added to scene explicitly as parent is already added)

				ta.object.target = new THREE.Object3D();
				result.scene.add( ta.object.target );

			}

			ta.object.target.properties.targetInverse = ta.object;

		}

	};

	var callbackTexture = function ( count ) {

		counter_textures -= count;
		async_callback_gate();

		scope.onLoadComplete();

	};

	// must use this instead of just directly calling callbackTexture
	// because of closure in the calling context loop

	var generateTextureCallback = function ( count ) {

		return function() {

			callbackTexture( count );

		};

	};

	// first go synchronous elements

	// fogs

	var fogID, fogJSON;

	for ( fogID in data.fogs ) {

		fogJSON = data.fogs[ fogID ];

		if ( fogJSON.type === "linear" ) {

			fog = new THREE.Fog( 0x000000, fogJSON.near, fogJSON.far );

		} else if ( fogJSON.type === "exp2" ) {

			fog = new THREE.FogExp2( 0x000000, fogJSON.density );

		}

		color = fogJSON.color;
		fog.color.setRGB( color[0], color[1], color[2] );

		result.fogs[ fogID ] = fog;

	}

	// now come potentially asynchronous elements

	// geometries

	// count how many geometries will be loaded asynchronously

	var geoID, geoJSON;

	for ( geoID in data.geometries ) {

		geoJSON = data.geometries[ geoID ];

		if ( geoJSON.type in this.geometryHandlerMap ) {

			counter_models += 1;

			scope.onLoadStart();

		}

	}

	// count how many hierarchies will be loaded asynchronously

	var objID, objJSON;

	for ( objID in data.objects ) {

		objJSON = data.objects[ objID ];

		if ( objJSON.type && ( objJSON.type in this.hierarchyHandlerMap ) ) {

			counter_models += 1;

			scope.onLoadStart();

		}

	}

	total_models = counter_models;

	for ( geoID in data.geometries ) {

		geoJSON = data.geometries[ geoID ];

		if ( geoJSON.type === "cube" ) {

			geometry = new THREE.CubeGeometry( geoJSON.width, geoJSON.height, geoJSON.depth, geoJSON.widthSegments, geoJSON.heightSegments, geoJSON.depthSegments );
			result.geometries[ geoID ] = geometry;

		} else if ( geoJSON.type === "plane" ) {

			geometry = new THREE.PlaneGeometry( geoJSON.width, geoJSON.height, geoJSON.widthSegments, geoJSON.heightSegments );
			result.geometries[ geoID ] = geometry;

		} else if ( geoJSON.type === "sphere" ) {

			geometry = new THREE.SphereGeometry( geoJSON.radius, geoJSON.widthSegments, geoJSON.heightSegments );
			result.geometries[ geoID ] = geometry;

		} else if ( geoJSON.type === "cylinder" ) {

			geometry = new THREE.CylinderGeometry( geoJSON.topRad, geoJSON.botRad, geoJSON.height, geoJSON.radSegs, geoJSON.heightSegs );
			result.geometries[ geoID ] = geometry;

		} else if ( geoJSON.type === "torus" ) {

			geometry = new THREE.TorusGeometry( geoJSON.radius, geoJSON.tube, geoJSON.segmentsR, geoJSON.segmentsT );
			result.geometries[ geoID ] = geometry;

		} else if ( geoJSON.type === "icosahedron" ) {

			geometry = new THREE.IcosahedronGeometry( geoJSON.radius, geoJSON.subdivisions );
			result.geometries[ geoID ] = geometry;

		} else if ( geoJSON.type in this.geometryHandlerMap ) {

			var loaderParameters = {};

			for ( var parType in geoJSON ) {

				if ( parType !== "type" && parType !== "url" ) {

					loaderParameters[ parType ] = geoJSON[ parType ];

				}

			}

			var loader = this.geometryHandlerMap[ geoJSON.type ][ "loaderObject" ];
			loader.load( get_url( geoJSON.url, data.urlBaseType ), create_callback_geometry( geoID ), loaderParameters );

		} else if ( geoJSON.type === "embedded" ) {

			var modelJson = data.embeds[ geoJSON.id ],
				texture_path = "";

			// pass metadata along to jsonLoader so it knows the format version

			modelJson.metadata = data.metadata;

			if ( modelJson ) {

				var jsonLoader = this.geometryHandlerMap[ "ascii" ][ "loaderObject" ];
				jsonLoader.createModel( modelJson, create_callback_embed( geoID ), texture_path );

			}

		}

	}

	// textures

	// count how many textures will be loaded asynchronously

	var textureID, textureJSON;

	for ( textureID in data.textures ) {

		textureJSON = data.textures[ textureID ];

		if ( textureJSON.url instanceof Array ) {

			counter_textures += textureJSON.url.length;

			for( var n = 0; n < textureJSON.url.length; n ++ ) {

				scope.onLoadStart();

			}

		} else {

			counter_textures += 1;

			scope.onLoadStart();

		}

	}

	total_textures = counter_textures;

	for ( textureID in data.textures ) {

		textureJSON = data.textures[ textureID ];

		if ( textureJSON.mapping !== undefined && THREE[ textureJSON.mapping ] !== undefined  ) {

			textureJSON.mapping = new THREE[ textureJSON.mapping ]();

		}

		if ( textureJSON.url instanceof Array ) {

			var count = textureJSON.url.length;
			var url_array = [];

			for( var i = 0; i < count; i ++ ) {

				url_array[ i ] = get_url( textureJSON.url[ i ], data.urlBaseType );

			}

			var isCompressed = url_array[ 0 ].endsWith( ".dds" );

			if ( isCompressed ) {

				texture = THREE.ImageUtils.loadCompressedTextureCube( url_array, textureJSON.mapping, generateTextureCallback( count ) );

			} else {

				texture = THREE.ImageUtils.loadTextureCube( url_array, textureJSON.mapping, generateTextureCallback( count ) );

			}

		} else {

			var isCompressed = textureJSON.url.toLowerCase().endsWith( ".dds" );
			var fullUrl = get_url( textureJSON.url, data.urlBaseType );
			var textureCallback = generateTextureCallback( 1 );

			if ( isCompressed ) {

				texture = THREE.ImageUtils.loadCompressedTexture( fullUrl, textureJSON.mapping, textureCallback );

			} else {

				texture = THREE.ImageUtils.loadTexture( fullUrl, textureJSON.mapping, textureCallback );

			}

			if ( THREE[ textureJSON.minFilter ] !== undefined )
				texture.minFilter = THREE[ textureJSON.minFilter ];

			if ( THREE[ textureJSON.magFilter ] !== undefined )
				texture.magFilter = THREE[ textureJSON.magFilter ];

			if ( textureJSON.anisotropy ) texture.anisotropy = textureJSON.anisotropy;

			if ( textureJSON.repeat ) {

				texture.repeat.set( textureJSON.repeat[ 0 ], textureJSON.repeat[ 1 ] );

				if ( textureJSON.repeat[ 0 ] !== 1 ) texture.wrapS = THREE.RepeatWrapping;
				if ( textureJSON.repeat[ 1 ] !== 1 ) texture.wrapT = THREE.RepeatWrapping;

			}

			if ( textureJSON.offset ) {

				texture.offset.set( textureJSON.offset[ 0 ], textureJSON.offset[ 1 ] );

			}

			// handle wrap after repeat so that default repeat can be overriden

			if ( textureJSON.wrap ) {

				var wrapMap = {
				"repeat" 	: THREE.RepeatWrapping,
				"mirror"	: THREE.MirroredRepeatWrapping
				}

				if ( wrapMap[ textureJSON.wrap[ 0 ] ] !== undefined ) texture.wrapS = wrapMap[ textureJSON.wrap[ 0 ] ];
				if ( wrapMap[ textureJSON.wrap[ 1 ] ] !== undefined ) texture.wrapT = wrapMap[ textureJSON.wrap[ 1 ] ];

			}

		}

		result.textures[ textureID ] = texture;

	}

	// materials

	var matID, matJSON;
	var parID;

	for ( matID in data.materials ) {

		matJSON = data.materials[ matID ];

		for ( parID in matJSON.parameters ) {

			if ( parID === "envMap" || parID === "map" || parID === "lightMap" || parID === "bumpMap" ) {

				matJSON.parameters[ parID ] = result.textures[ matJSON.parameters[ parID ] ];

			} else if ( parID === "shading" ) {

				matJSON.parameters[ parID ] = ( matJSON.parameters[ parID ] === "flat" ) ? THREE.FlatShading : THREE.SmoothShading;

			} else if ( parID === "side" ) {

				if ( matJSON.parameters[ parID ] == "double" ) {

					matJSON.parameters[ parID ] = THREE.DoubleSide;

				} else if ( matJSON.parameters[ parID ] == "back" ) {

					matJSON.parameters[ parID ] = THREE.BackSide;

				} else {

					matJSON.parameters[ parID ] = THREE.FrontSide;

				}

			} else if ( parID === "blending" ) {

				matJSON.parameters[ parID ] = matJSON.parameters[ parID ] in THREE ? THREE[ matJSON.parameters[ parID ] ] : THREE.NormalBlending;

			} else if ( parID === "combine" ) {

				matJSON.parameters[ parID ] = matJSON.parameters[ parID ] in THREE ? THREE[ matJSON.parameters[ parID ] ] : THREE.MultiplyOperation;

			} else if ( parID === "vertexColors" ) {

				if ( matJSON.parameters[ parID ] == "face" ) {

					matJSON.parameters[ parID ] = THREE.FaceColors;

				// default to vertex colors if "vertexColors" is anything else face colors or 0 / null / false

				} else if ( matJSON.parameters[ parID ] )   {

					matJSON.parameters[ parID ] = THREE.VertexColors;

				}

			} else if ( parID === "wrapRGB" ) {

				var v3 = matJSON.parameters[ parID ];
				matJSON.parameters[ parID ] = new THREE.Vector3( v3[ 0 ], v3[ 1 ], v3[ 2 ] );

			}

		}

		if ( matJSON.parameters.opacity !== undefined && matJSON.parameters.opacity < 1.0 ) {

			matJSON.parameters.transparent = true;

		}

		if ( matJSON.parameters.normalMap ) {

			var shader = THREE.ShaderLib[ "normalmap" ];
			var uniforms = THREE.UniformsUtils.clone( shader.uniforms );

			var diffuse = matJSON.parameters.color;
			var specular = matJSON.parameters.specular;
			var ambient = matJSON.parameters.ambient;
			var shininess = matJSON.parameters.shininess;

			uniforms[ "tNormal" ].value = result.textures[ matJSON.parameters.normalMap ];

			if ( matJSON.parameters.normalScale ) {

				uniforms[ "uNormalScale" ].value.set( matJSON.parameters.normalScale[ 0 ], matJSON.parameters.normalScale[ 1 ] );

			}

			if ( matJSON.parameters.map ) {

				uniforms[ "tDiffuse" ].value = matJSON.parameters.map;
				uniforms[ "enableDiffuse" ].value = true;

			}

			if ( matJSON.parameters.envMap ) {

				uniforms[ "tCube" ].value = matJSON.parameters.envMap;
				uniforms[ "enableReflection" ].value = true;
				uniforms[ "uReflectivity" ].value = matJSON.parameters.reflectivity;

			}

			if ( matJSON.parameters.lightMap ) {

				uniforms[ "tAO" ].value = matJSON.parameters.lightMap;
				uniforms[ "enableAO" ].value = true;

			}

			if ( matJSON.parameters.specularMap ) {

				uniforms[ "tSpecular" ].value = result.textures[ matJSON.parameters.specularMap ];
				uniforms[ "enableSpecular" ].value = true;

			}

			if ( matJSON.parameters.displacementMap ) {

				uniforms[ "tDisplacement" ].value = result.textures[ matJSON.parameters.displacementMap ];
				uniforms[ "enableDisplacement" ].value = true;

				uniforms[ "uDisplacementBias" ].value = matJSON.parameters.displacementBias;
				uniforms[ "uDisplacementScale" ].value = matJSON.parameters.displacementScale;

			}

			uniforms[ "uDiffuseColor" ].value.setHex( diffuse );
			uniforms[ "uSpecularColor" ].value.setHex( specular );
			uniforms[ "uAmbientColor" ].value.setHex( ambient );

			uniforms[ "uShininess" ].value = shininess;

			if ( matJSON.parameters.opacity ) {

				uniforms[ "uOpacity" ].value = matJSON.parameters.opacity;

			}

			var parameters = { fragmentShader: shader.fragmentShader, vertexShader: shader.vertexShader, uniforms: uniforms, lights: true, fog: true };

			material = new THREE.ShaderMaterial( parameters );

		} else {

			material = new THREE[ matJSON.type ]( matJSON.parameters );

		}

		result.materials[ matID ] = material;

	}

	// second pass through all materials to initialize MeshFaceMaterials
	// that could be referring to other materials out of order

	for ( matID in data.materials ) {

		matJSON = data.materials[ matID ];

		if ( matJSON.parameters.materials ) {

			var materialArray = [];

			for ( var i = 0; i < matJSON.parameters.materials.length; i ++ ) {

				var label = matJSON.parameters.materials[ i ];
				materialArray.push( result.materials[ label ] );

			}

			result.materials[ matID ].materials = materialArray;

		}

	}

	// objects ( synchronous init of procedural primitives )

	handle_objects();

	// defaults

	if ( result.cameras && data.defaults.camera ) {

		result.currentCamera = result.cameras[ data.defaults.camera ];

	}

	if ( result.fogs && data.defaults.fog ) {

		result.scene.fog = result.fogs[ data.defaults.fog ];

	}

	// synchronous callback

	scope.callbackSync( result );

	// just in case there are no async elements

	async_callback_gate();

};
/**
 * @author mrdoob / http://mrdoob.com/
 */

THREE.TextureLoader = function () {

	THREE.EventDispatcher.call( this );

	this.crossOrigin = null;

};

THREE.TextureLoader.prototype = {

	constructor: THREE.TextureLoader,

	load: function ( url ) {

		var scope = this;

		var image = new Image();

		image.addEventListener( 'load', function () {

			var texture = new THREE.Texture( image );
			texture.needsUpdate = true;

			scope.dispatchEvent( { type: 'load', content: texture } );

		}, false );

		image.addEventListener( 'error', function () {

			scope.dispatchEvent( { type: 'error', message: 'Couldn\'t load URL [' + url + ']' } );

		}, false );

		if ( scope.crossOrigin ) image.crossOrigin = scope.crossOrigin;

		image.src = url;

	}

}
/**
 * @author mrdoob / http://mrdoob.com/
 * @author alteredq / http://alteredqualia.com/
 */

THREE.Material = function () {

	THREE.EventDispatcher.call( this );

	this.id = THREE.MaterialIdCount ++;

	this.name = '';

	this.side = THREE.FrontSide;

	this.opacity = 1;
	this.transparent = false;

	this.blending = THREE.NormalBlending;

	this.blendSrc = THREE.SrcAlphaFactor;
	this.blendDst = THREE.OneMinusSrcAlphaFactor;
	this.blendEquation = THREE.AddEquation;

	this.depthTest = true;
	this.depthWrite = true;

	this.polygonOffset = false;
	this.polygonOffsetFactor = 0;
	this.polygonOffsetUnits = 0;

	this.alphaTest = 0;

	this.overdraw = false; // Boolean for fixing antialiasing gaps in CanvasRenderer

	this.visible = true;

	this.needsUpdate = true;

};

THREE.Material.prototype.setValues = function ( values ) {

	if ( values === undefined ) return;

	for ( var key in values ) {

		var newValue = values[ key ];

		if ( newValue === undefined ) {

			console.warn( 'THREE.Material: \'' + key + '\' parameter is undefined.' );
			continue;

		}

		if ( key in this ) {

			var currentValue = this[ key ];

			if ( currentValue instanceof THREE.Color && newValue instanceof THREE.Color ) {

				currentValue.copy( newValue );

			} else if ( currentValue instanceof THREE.Color ) {

				currentValue.set( newValue );

			} else if ( currentValue instanceof THREE.Vector3 && newValue instanceof THREE.Vector3 ) {

				currentValue.copy( newValue );

			} else {

				this[ key ] = newValue;

			}

		}

	}

};

THREE.Material.prototype.clone = function ( material ) {

	if ( material === undefined ) material = new THREE.Material();

	material.name = this.name;

	material.side = this.side;

	material.opacity = this.opacity;
	material.transparent = this.transparent;

	material.blending = this.blending;

	material.blendSrc = this.blendSrc;
	material.blendDst = this.blendDst;
	material.blendEquation = this.blendEquation;

	material.depthTest = this.depthTest;
	material.depthWrite = this.depthWrite;

	material.polygonOffset = this.polygonOffset;
	material.polygonOffsetFactor = this.polygonOffsetFactor;
	material.polygonOffsetUnits = this.polygonOffsetUnits;

	material.alphaTest = this.alphaTest;

	material.overdraw = this.overdraw;

	material.visible = this.visible;

	return material;

};

THREE.Material.prototype.dispose = function () {

	this.dispatchEvent( { type: 'dispose' } );

};

THREE.MaterialIdCount = 0;
/**
 * @author mrdoob / http://mrdoob.com/
 * @author alteredq / http://alteredqualia.com/
 *
 * parameters = {
 *  color: <hex>,
 *  opacity: <float>,
 *
 *  blending: THREE.NormalBlending,
 *  depthTest: <bool>,
 *  depthWrite: <bool>,
 *
 *  linewidth: <float>,
 *  linecap: "round",
 *  linejoin: "round",
 *
 *  vertexColors: <bool>
 *
 *  fog: <bool>
 * }
 */

THREE.LineBasicMaterial = function ( parameters ) {

	THREE.Material.call( this );

	this.color = new THREE.Color( 0xffffff );

	this.linewidth = 1;
	this.linecap = 'round';
	this.linejoin = 'round';

	this.vertexColors = false;

	this.fog = true;

	this.setValues( parameters );

};

THREE.LineBasicMaterial.prototype = Object.create( THREE.Material.prototype );

THREE.LineBasicMaterial.prototype.clone = function () {

	var material = new THREE.LineBasicMaterial();

	THREE.Material.prototype.clone.call( this, material );

	material.color.copy( this.color );

	material.linewidth = this.linewidth;
	material.linecap = this.linecap;
	material.linejoin = this.linejoin;

	material.vertexColors = this.vertexColors;

	material.fog = this.fog;

	return material;

};
/**
 * @author alteredq / http://alteredqualia.com/
 *
 * parameters = {
 *  color: <hex>,
 *  opacity: <float>,
 *
 *  blending: THREE.NormalBlending,
 *  depthTest: <bool>,
 *  depthWrite: <bool>,
 *
 *  linewidth: <float>,
 *
 *  scale: <float>,
 *  dashSize: <float>,
 *  gapSize: <float>,
 *
 *  vertexColors: <bool>
 *
 *  fog: <bool>
 * }
 */

THREE.LineDashedMaterial = function ( parameters ) {

	THREE.Material.call( this );

	this.color = new THREE.Color( 0xffffff );

	this.linewidth = 1;

	this.scale = 1;
	this.dashSize = 3;
	this.gapSize = 1;

	this.vertexColors = false;

	this.fog = true;

	this.setValues( parameters );

};

THREE.LineDashedMaterial.prototype = Object.create( THREE.Material.prototype );

THREE.LineDashedMaterial.prototype.clone = function () {

	var material = new THREE.LineDashedMaterial();

	THREE.Material.prototype.clone.call( this, material );

	material.color.copy( this.color );

	material.linewidth = this.linewidth;

	material.scale = this.scale;
	material.dashSize = this.dashSize;
	material.gapSize = this.gapSize;

	material.vertexColors = this.vertexColors;

	material.fog = this.fog;

	return material;

};
/**
 * @author mrdoob / http://mrdoob.com/
 * @author alteredq / http://alteredqualia.com/
 *
 * parameters = {
 *  color: <hex>,
 *  opacity: <float>,
 *  map: new THREE.Texture( <Image> ),
 *
 *  lightMap: new THREE.Texture( <Image> ),
 *
 *  specularMap: new THREE.Texture( <Image> ),
 *
 *  envMap: new THREE.TextureCube( [posx, negx, posy, negy, posz, negz] ),
 *  combine: THREE.Multiply,
 *  reflectivity: <float>,
 *  refractionRatio: <float>,
 *
 *  shading: THREE.SmoothShading,
 *  blending: THREE.NormalBlending,
 *  depthTest: <bool>,
 *  depthWrite: <bool>,
 *
 *  wireframe: <boolean>,
 *  wireframeLinewidth: <float>,
 *
 *  vertexColors: THREE.NoColors / THREE.VertexColors / THREE.FaceColors,
 *
 *  skinning: <bool>,
 *  morphTargets: <bool>,
 *
 *  fog: <bool>
 * }
 */

THREE.MeshBasicMaterial = function ( parameters ) {

	THREE.Material.call( this );

	this.color = new THREE.Color( 0xffffff ); // emissive

	this.map = null;

	this.lightMap = null;

	this.specularMap = null;

	this.envMap = null;
	this.combine = THREE.MultiplyOperation;
	this.reflectivity = 1;
	this.refractionRatio = 0.98;

	this.fog = true;

	this.shading = THREE.SmoothShading;

	this.wireframe = false;
	this.wireframeLinewidth = 1;
	this.wireframeLinecap = 'round';
	this.wireframeLinejoin = 'round';

	this.vertexColors = THREE.NoColors;

	this.skinning = false;
	this.morphTargets = false;

	this.setValues( parameters );

};

THREE.MeshBasicMaterial.prototype = Object.create( THREE.Material.prototype );

THREE.MeshBasicMaterial.prototype.clone = function () {

	var material = new THREE.MeshBasicMaterial();

	THREE.Material.prototype.clone.call( this, material );

	material.color.copy( this.color );

	material.map = this.map;

	material.lightMap = this.lightMap;

	material.specularMap = this.specularMap;

	material.envMap = this.envMap;
	material.combine = this.combine;
	material.reflectivity = this.reflectivity;
	material.refractionRatio = this.refractionRatio;

	material.fog = this.fog;

	material.shading = this.shading;

	material.wireframe = this.wireframe;
	material.wireframeLinewidth = this.wireframeLinewidth;
	material.wireframeLinecap = this.wireframeLinecap;
	material.wireframeLinejoin = this.wireframeLinejoin;

	material.vertexColors = this.vertexColors;

	material.skinning = this.skinning;
	material.morphTargets = this.morphTargets;

	return material;

};
/**
 * @author mrdoob / http://mrdoob.com/
 * @author alteredq / http://alteredqualia.com/
 *
 * parameters = {
 *  color: <hex>,
 *  ambient: <hex>,
 *  emissive: <hex>,
 *  opacity: <float>,
 *
 *  map: new THREE.Texture( <Image> ),
 *
 *  lightMap: new THREE.Texture( <Image> ),
 *
 *  specularMap: new THREE.Texture( <Image> ),
 *
 *  envMap: new THREE.TextureCube( [posx, negx, posy, negy, posz, negz] ),
 *  combine: THREE.Multiply,
 *  reflectivity: <float>,
 *  refractionRatio: <float>,
 *
 *  shading: THREE.SmoothShading,
 *  blending: THREE.NormalBlending,
 *  depthTest: <bool>,
 *  depthWrite: <bool>,
 *
 *  wireframe: <boolean>,
 *  wireframeLinewidth: <float>,
 *
 *  vertexColors: THREE.NoColors / THREE.VertexColors / THREE.FaceColors,
 *
 *  skinning: <bool>,
 *  morphTargets: <bool>,
 *  morphNormals: <bool>,
 *
 *	fog: <bool>
 * }
 */

THREE.MeshLambertMaterial = function ( parameters ) {

	THREE.Material.call( this );

	this.color = new THREE.Color( 0xffffff ); // diffuse
	this.ambient = new THREE.Color( 0xffffff );
	this.emissive = new THREE.Color( 0x000000 );

	this.wrapAround = false;
	this.wrapRGB = new THREE.Vector3( 1, 1, 1 );

	this.map = null;

	this.lightMap = null;

	this.specularMap = null;

	this.envMap = null;
	this.combine = THREE.MultiplyOperation;
	this.reflectivity = 1;
	this.refractionRatio = 0.98;

	this.fog = true;

	this.shading = THREE.SmoothShading;

	this.wireframe = false;
	this.wireframeLinewidth = 1;
	this.wireframeLinecap = 'round';
	this.wireframeLinejoin = 'round';

	this.vertexColors = THREE.NoColors;

	this.skinning = false;
	this.morphTargets = false;
	this.morphNormals = false;

	this.setValues( parameters );

};

THREE.MeshLambertMaterial.prototype = Object.create( THREE.Material.prototype );

THREE.MeshLambertMaterial.prototype.clone = function () {

	var material = new THREE.MeshLambertMaterial();

	THREE.Material.prototype.clone.call( this, material );

	material.color.copy( this.color );
	material.ambient.copy( this.ambient );
	material.emissive.copy( this.emissive );

	material.wrapAround = this.wrapAround;
	material.wrapRGB.copy( this.wrapRGB );

	material.map = this.map;

	material.lightMap = this.lightMap;

	material.specularMap = this.specularMap;

	material.envMap = this.envMap;
	material.combine = this.combine;
	material.reflectivity = this.reflectivity;
	material.refractionRatio = this.refractionRatio;

	material.fog = this.fog;

	material.shading = this.shading;

	material.wireframe = this.wireframe;
	material.wireframeLinewidth = this.wireframeLinewidth;
	material.wireframeLinecap = this.wireframeLinecap;
	material.wireframeLinejoin = this.wireframeLinejoin;

	material.vertexColors = this.vertexColors;

	material.skinning = this.skinning;
	material.morphTargets = this.morphTargets;
	material.morphNormals = this.morphNormals;

	return material;

};
/**
 * @author mrdoob / http://mrdoob.com/
 * @author alteredq / http://alteredqualia.com/
 *
 * parameters = {
 *  color: <hex>,
 *  ambient: <hex>,
 *  emissive: <hex>,
 *  specular: <hex>,
 *  shininess: <float>,
 *  opacity: <float>,
 *
 *  map: new THREE.Texture( <Image> ),
 *
 *  lightMap: new THREE.Texture( <Image> ),
 *
 *  bumpMap: new THREE.Texture( <Image> ),
 *  bumpScale: <float>,
 *
 *  normalMap: new THREE.Texture( <Image> ),
 *  normalScale: <Vector2>,
 *
 *  specularMap: new THREE.Texture( <Image> ),
 *
 *  envMap: new THREE.TextureCube( [posx, negx, posy, negy, posz, negz] ),
 *  combine: THREE.Multiply,
 *  reflectivity: <float>,
 *  refractionRatio: <float>,
 *
 *  shading: THREE.SmoothShading,
 *  blending: THREE.NormalBlending,
 *  depthTest: <bool>,
 *  depthWrite: <bool>,
 *
 *  wireframe: <boolean>,
 *  wireframeLinewidth: <float>,
 *
 *  vertexColors: THREE.NoColors / THREE.VertexColors / THREE.FaceColors,
 *
 *  skinning: <bool>,
 *  morphTargets: <bool>,
 *  morphNormals: <bool>,
 *
 *	fog: <bool>
 * }
 */

THREE.MeshPhongMaterial = function ( parameters ) {

	THREE.Material.call( this );

	this.color = new THREE.Color( 0xffffff ); // diffuse
	this.ambient = new THREE.Color( 0xffffff );
	this.emissive = new THREE.Color( 0x000000 );
	this.specular = new THREE.Color( 0x111111 );
	this.shininess = 30;

	this.metal = false;
	this.perPixel = true;

	this.wrapAround = false;
	this.wrapRGB = new THREE.Vector3( 1, 1, 1 );

	this.map = null;

	this.lightMap = null;

	this.bumpMap = null;
	this.bumpScale = 1;

	this.normalMap = null;
	this.normalScale = new THREE.Vector2( 1, 1 );

	this.specularMap = null;

	this.envMap = null;
	this.combine = THREE.MultiplyOperation;
	this.reflectivity = 1;
	this.refractionRatio = 0.98;

	this.fog = true;

	this.shading = THREE.SmoothShading;

	this.wireframe = false;
	this.wireframeLinewidth = 1;
	this.wireframeLinecap = 'round';
	this.wireframeLinejoin = 'round';

	this.vertexColors = THREE.NoColors;

	this.skinning = false;
	this.morphTargets = false;
	this.morphNormals = false;

	this.setValues( parameters );

};

THREE.MeshPhongMaterial.prototype = Object.create( THREE.Material.prototype );

THREE.MeshPhongMaterial.prototype.clone = function () {

	var material = new THREE.MeshPhongMaterial();

	THREE.Material.prototype.clone.call( this, material );

	material.color.copy( this.color );
	material.ambient.copy( this.ambient );
	material.emissive.copy( this.emissive );
	material.specular.copy( this.specular );
	material.shininess = this.shininess;

	material.metal = this.metal;
	material.perPixel = this.perPixel;

	material.wrapAround = this.wrapAround;
	material.wrapRGB.copy( this.wrapRGB );

	material.map = this.map;

	material.lightMap = this.lightMap;

	material.bumpMap = this.bumpMap;
	material.bumpScale = this.bumpScale;

	material.normalMap = this.normalMap;
	material.normalScale.copy( this.normalScale );

	material.specularMap = this.specularMap;

	material.envMap = this.envMap;
	material.combine = this.combine;
	material.reflectivity = this.reflectivity;
	material.refractionRatio = this.refractionRatio;

	material.fog = this.fog;

	material.shading = this.shading;

	material.wireframe = this.wireframe;
	material.wireframeLinewidth = this.wireframeLinewidth;
	material.wireframeLinecap = this.wireframeLinecap;
	material.wireframeLinejoin = this.wireframeLinejoin;

	material.vertexColors = this.vertexColors;

	material.skinning = this.skinning;
	material.morphTargets = this.morphTargets;
	material.morphNormals = this.morphNormals;

	return material;

};
/**
 * @author mrdoob / http://mrdoob.com/
 * @author alteredq / http://alteredqualia.com/
 *
 * parameters = {
 *  opacity: <float>,
 *
 *  blending: THREE.NormalBlending,
 *  depthTest: <bool>,
 *  depthWrite: <bool>,
 *
 *  wireframe: <boolean>,
 *  wireframeLinewidth: <float>
 * }
 */

THREE.MeshDepthMaterial = function ( parameters ) {

	THREE.Material.call( this );

	this.wireframe = false;
	this.wireframeLinewidth = 1;

	this.setValues( parameters );

};

THREE.MeshDepthMaterial.prototype = Object.create( THREE.Material.prototype );

THREE.MeshDepthMaterial.prototype.clone = function () {

	var material = new THREE.LineBasicMaterial();

	THREE.Material.prototype.clone.call( this, material );

	material.wireframe = this.wireframe;
	material.wireframeLinewidth = this.wireframeLinewidth;

	return material;

};
/**
 * @author mrdoob / http://mrdoob.com/
 *
 * parameters = {
 *  opacity: <float>,
 *
 *  shading: THREE.FlatShading,
 *  blending: THREE.NormalBlending,
 *  depthTest: <bool>,
 *  depthWrite: <bool>,
 *
 *  wireframe: <boolean>,
 *  wireframeLinewidth: <float>
 * }
 */

THREE.MeshNormalMaterial = function ( parameters ) {

	THREE.Material.call( this, parameters );

	this.shading = THREE.FlatShading;

	this.wireframe = false;
	this.wireframeLinewidth = 1;

	this.setValues( parameters );

};

THREE.MeshNormalMaterial.prototype = Object.create( THREE.Material.prototype );

THREE.MeshNormalMaterial.prototype.clone = function () {

	var material = new THREE.MeshNormalMaterial();

	THREE.Material.prototype.clone.call( this, material );

	material.shading = this.shading;

	material.wireframe = this.wireframe;
	material.wireframeLinewidth = this.wireframeLinewidth;

	return material;

};
/**
 * @author mrdoob / http://mrdoob.com/
 */

THREE.MeshFaceMaterial = function ( materials ) {

	this.materials = materials instanceof Array ? materials : [];

};

THREE.MeshFaceMaterial.prototype.clone = function () {

	return new THREE.MeshFaceMaterial( this.materials.slice( 0 ) );

};
/**
 * @author mrdoob / http://mrdoob.com/
 * @author alteredq / http://alteredqualia.com/
 *
 * parameters = {
 *  color: <hex>,
 *  opacity: <float>,
 *  map: new THREE.Texture( <Image> ),
 *
 *  size: <float>,
 *
 *  blending: THREE.NormalBlending,
 *  depthTest: <bool>,
 *  depthWrite: <bool>,
 *
 *  vertexColors: <bool>,
 *
 *  fog: <bool>
 * }
 */

THREE.ParticleBasicMaterial = function ( parameters ) {

	THREE.Material.call( this );

	this.color = new THREE.Color( 0xffffff );

	this.map = null;

	this.size = 1;
	this.sizeAttenuation = true;

	this.vertexColors = false;

	this.fog = true;

	this.setValues( parameters );

};

THREE.ParticleBasicMaterial.prototype = Object.create( THREE.Material.prototype );

THREE.ParticleBasicMaterial.prototype.clone = function () {

	var material = new THREE.ParticleBasicMaterial();

	THREE.Material.prototype.clone.call( this, material );

	material.color.copy( this.color );

	material.map = this.map;

	material.size = this.size;
	material.sizeAttenuation = this.sizeAttenuation;

	material.vertexColors = this.vertexColors;

	material.fog = this.fog;

	return material;

};
/**
 * @author mrdoob / http://mrdoob.com/
 *
 * parameters = {
 *  color: <hex>,
 *  program: <function>,
 *  opacity: <float>,
 *  blending: THREE.NormalBlending
 * }
 */

THREE.ParticleCanvasMaterial = function ( parameters ) {

	THREE.Material.call( this );

	this.color = new THREE.Color( 0xffffff );
	this.program = function ( context, color ) {};

	this.setValues( parameters );

};

THREE.ParticleCanvasMaterial.prototype = Object.create( THREE.Material.prototype );

THREE.ParticleCanvasMaterial.prototype.clone = function () {

	var material = new THREE.ParticleCanvasMaterial();

	THREE.Material.prototype.clone.call( this, material );

	material.color.copy( this.color );
	material.program = this.program;

	return material;

};
/**
 * @author alteredq / http://alteredqualia.com/
 *
 * parameters = {
 *  fragmentShader: <string>,
 *  vertexShader: <string>,
 *
 *  uniforms: { "parameter1": { type: "f", value: 1.0 }, "parameter2": { type: "i" value2: 2 } },
 *
 *  defines: { "label" : "value" },
 *
 *  shading: THREE.SmoothShading,
 *  blending: THREE.NormalBlending,
 *  depthTest: <bool>,
 *  depthWrite: <bool>,
 *
 *  wireframe: <boolean>,
 *  wireframeLinewidth: <float>,
 *
 *  lights: <bool>,
 *
 *  vertexColors: THREE.NoColors / THREE.VertexColors / THREE.FaceColors,
 *
 *  skinning: <bool>,
 *  morphTargets: <bool>,
 *  morphNormals: <bool>,
 *
 *	fog: <bool>
 * }
 */

THREE.ShaderMaterial = function ( parameters ) {

	THREE.Material.call( this );

	this.fragmentShader = "void main() {}";
	this.vertexShader = "void main() {}";
	this.uniforms = {};
	this.defines = {};
	this.attributes = null;

	this.shading = THREE.SmoothShading;

	this.wireframe = false;
	this.wireframeLinewidth = 1;

	this.fog = false; // set to use scene fog

	this.lights = false; // set to use scene lights

	this.vertexColors = THREE.NoColors; // set to use "color" attribute stream

	this.skinning = false; // set to use skinning attribute streams

	this.morphTargets = false; // set to use morph targets
	this.morphNormals = false; // set to use morph normals

	this.setValues( parameters );

};

THREE.ShaderMaterial.prototype = Object.create( THREE.Material.prototype );

THREE.ShaderMaterial.prototype.clone = function () {

	var material = new THREE.ShaderMaterial();

	THREE.Material.prototype.clone.call( this, material );

	material.fragmentShader = this.fragmentShader;
	material.vertexShader = this.vertexShader;

	material.uniforms = THREE.UniformsUtils.clone( this.uniforms );

	material.attributes = this.attributes;
	material.defines = this.defines;

	material.shading = this.shading;

	material.wireframe = this.wireframe;
	material.wireframeLinewidth = this.wireframeLinewidth;

	material.fog = this.fog;

	material.lights = this.lights;

	material.vertexColors = this.vertexColors;

	material.skinning = this.skinning;

	material.morphTargets = this.morphTargets;
	material.morphNormals = this.morphNormals;

	return material;

};
/**
 * @author alteredq / http://alteredqualia.com/
 *
 * parameters = {
 *  color: <hex>,
 *  opacity: <float>,
 *  map: new THREE.Texture( <Image> ),
 *
 *  blending: THREE.NormalBlending,
 *  depthTest: <bool>,
 *  depthWrite: <bool>,
 *
 *  useScreenCoordinates: <bool>,
 *  sizeAttenuation: <bool>,
 *  scaleByViewport: <bool>,
 *  alignment: THREE.SpriteAlignment.center,
 *
 *	uvOffset: new THREE.Vector2(),
 *	uvScale: new THREE.Vector2(),
 *
 *  fog: <bool>
 * }
 */

THREE.SpriteMaterial = function ( parameters ) {

	THREE.Material.call( this );

	// defaults

	this.color = new THREE.Color( 0xffffff );
	this.map = new THREE.Texture();

	this.useScreenCoordinates = true;
	this.depthTest = !this.useScreenCoordinates;
	this.sizeAttenuation = !this.useScreenCoordinates;
	this.scaleByViewport = !this.sizeAttenuation;
	this.alignment = THREE.SpriteAlignment.center.clone();

	this.fog = false;

	this.uvOffset = new THREE.Vector2( 0, 0 );
	this.uvScale  = new THREE.Vector2( 1, 1 );

	// set parameters

	this.setValues( parameters );

	// override coupled defaults if not specified explicitly by parameters

	parameters = parameters || {};

	if ( parameters.depthTest === undefined ) this.depthTest = !this.useScreenCoordinates;
	if ( parameters.sizeAttenuation === undefined ) this.sizeAttenuation = !this.useScreenCoordinates;
	if ( parameters.scaleByViewport === undefined ) this.scaleByViewport = !this.sizeAttenuation;

};

THREE.SpriteMaterial.prototype = Object.create( THREE.Material.prototype );

THREE.SpriteMaterial.prototype.clone = function () {

	var material = new THREE.SpriteMaterial();

	THREE.Material.prototype.clone.call( this, material );

	material.color.copy( this.color );
	material.map = this.map;

	material.useScreenCoordinates = this.useScreenCoordinates;
	material.sizeAttenuation = this.sizeAttenuation;
	material.scaleByViewport = this.scaleByViewport;
	material.alignment.copy( this.alignment );

	material.uvOffset.copy( this.uvOffset );
	material.uvScale.copy( this.uvScale );

	material.fog = this.fog;

	return material;

};

// Alignment enums

THREE.SpriteAlignment = {};
THREE.SpriteAlignment.topLeft = new THREE.Vector2( 1, -1 );
THREE.SpriteAlignment.topCenter = new THREE.Vector2( 0, -1 );
THREE.SpriteAlignment.topRight = new THREE.Vector2( -1, -1 );
THREE.SpriteAlignment.centerLeft = new THREE.Vector2( 1, 0 );
THREE.SpriteAlignment.center = new THREE.Vector2( 0, 0 );
THREE.SpriteAlignment.centerRight = new THREE.Vector2( -1, 0 );
THREE.SpriteAlignment.bottomLeft = new THREE.Vector2( 1, 1 );
THREE.SpriteAlignment.bottomCenter = new THREE.Vector2( 0, 1 );
THREE.SpriteAlignment.bottomRight = new THREE.Vector2( -1, 1 );
/**
 * @author mrdoob / http://mrdoob.com/
 * @author alteredq / http://alteredqualia.com/
 * @author szimek / https://github.com/szimek/
 */

THREE.Texture = function ( image, mapping, wrapS, wrapT, magFilter, minFilter, format, type, anisotropy ) {

	THREE.EventDispatcher.call( this );

	this.id = THREE.TextureIdCount ++;

	this.name = '';

	this.image = image;
	this.mipmaps = [];

	this.mapping = mapping !== undefined ? mapping : new THREE.UVMapping();

	this.wrapS = wrapS !== undefined ? wrapS : THREE.ClampToEdgeWrapping;
	this.wrapT = wrapT !== undefined ? wrapT : THREE.ClampToEdgeWrapping;

	this.magFilter = magFilter !== undefined ? magFilter : THREE.LinearFilter;
	this.minFilter = minFilter !== undefined ? minFilter : THREE.LinearMipMapLinearFilter;

	this.anisotropy = anisotropy !== undefined ? anisotropy : 1;

	this.format = format !== undefined ? format : THREE.RGBAFormat;
	this.type = type !== undefined ? type : THREE.UnsignedByteType;

	this.offset = new THREE.Vector2( 0, 0 );
	this.repeat = new THREE.Vector2( 1, 1 );

	this.generateMipmaps = true;
	this.premultiplyAlpha = false;
	this.flipY = true;
	this.unpackAlignment = 4; // valid values: 1, 2, 4, 8 (see http://www.khronos.org/opengles/sdk/docs/man/xhtml/glPixelStorei.xml)

	this.needsUpdate = false;
	this.onUpdate = null;

};

THREE.Texture.prototype = {

	constructor: THREE.Texture,

	clone: function ( texture ) {

		if ( texture === undefined ) texture = new THREE.Texture();

		texture.image = this.image;
		texture.mipmaps = this.mipmaps.slice(0);

		texture.mapping = this.mapping;

		texture.wrapS = this.wrapS;
		texture.wrapT = this.wrapT;

		texture.magFilter = this.magFilter;
		texture.minFilter = this.minFilter;

		texture.anisotropy = this.anisotropy;

		texture.format = this.format;
		texture.type = this.type;

		texture.offset.copy( this.offset );
		texture.repeat.copy( this.repeat );

		texture.generateMipmaps = this.generateMipmaps;
		texture.premultiplyAlpha = this.premultiplyAlpha;
		texture.flipY = this.flipY;
		texture.unpackAlignment = this.unpackAlignment;

		return texture;

	},

	dispose: function () {

		this.dispatchEvent( { type: 'dispose' } );

	}

};

THREE.TextureIdCount = 0;
/**
 * @author alteredq / http://alteredqualia.com/
 */

THREE.CompressedTexture = function ( mipmaps, width, height, format, type, mapping, wrapS, wrapT, magFilter, minFilter, anisotropy ) {

	THREE.Texture.call( this, null, mapping, wrapS, wrapT, magFilter, minFilter, format, type, anisotropy );

	this.image = { width: width, height: height };
	this.mipmaps = mipmaps;

	this.generateMipmaps = false; // WebGL currently can't generate mipmaps for compressed textures, they must be embedded in DDS file

};

THREE.CompressedTexture.prototype = Object.create( THREE.Texture.prototype );

THREE.CompressedTexture.prototype.clone = function () {

	var texture = new THREE.CompressedTexture();

	THREE.Texture.prototype.clone.call( this, texture );

	return texture;

};
/**
 * @author alteredq / http://alteredqualia.com/
 */

THREE.DataTexture = function ( data, width, height, format, type, mapping, wrapS, wrapT, magFilter, minFilter, anisotropy ) {

	THREE.Texture.call( this, null, mapping, wrapS, wrapT, magFilter, minFilter, format, type, anisotropy );

	this.image = { data: data, width: width, height: height };

};

THREE.DataTexture.prototype = Object.create( THREE.Texture.prototype );

THREE.DataTexture.prototype.clone = function () {

	var texture = new THREE.DataTexture();

	THREE.Texture.prototype.clone.call( this, texture );

	return texture;

};
/**
 * @author mrdoob / http://mrdoob.com/
 */

THREE.Particle = function ( material ) {

	THREE.Object3D.call( this );

	this.material = material;

};

THREE.Particle.prototype = Object.create( THREE.Object3D.prototype );

THREE.Particle.prototype.clone = function ( object ) {

	if ( object === undefined ) object = new THREE.Particle( this.material );

	THREE.Object3D.prototype.clone.call( this, object );

	return object;

};
/**
 * @author alteredq / http://alteredqualia.com/
 */

THREE.ParticleSystem = function ( geometry, material ) {

	THREE.Object3D.call( this );

	this.geometry = geometry;
	this.material = ( material !== undefined ) ? material : new THREE.ParticleBasicMaterial( { color: Math.random() * 0xffffff } );

	this.sortParticles = false;

	if ( this.geometry ) {

		// calc bound radius

		if( this.geometry.boundingSphere === null ) {

			this.geometry.computeBoundingSphere();

		}

	}

	this.frustumCulled = false;

};

THREE.ParticleSystem.prototype = Object.create( THREE.Object3D.prototype );

THREE.ParticleSystem.prototype.clone = function ( object ) {

	if ( object === undefined ) object = new THREE.ParticleSystem( this.geometry, this.material );
	object.sortParticles = this.sortParticles;

	THREE.Object3D.prototype.clone.call( this, object );

	return object;

};
/**
 * @author mrdoob / http://mrdoob.com/
 */

THREE.Line = function ( geometry, material, type ) {

	THREE.Object3D.call( this );

	this.geometry = geometry;
	this.material = ( material !== undefined ) ? material : new THREE.LineBasicMaterial( { color: Math.random() * 0xffffff } );
	this.type = ( type !== undefined ) ? type : THREE.LineStrip;

	if ( this.geometry ) {

		if ( ! this.geometry.boundingSphere ) {

			this.geometry.computeBoundingSphere();

		}

	}

};

THREE.LineStrip = 0;
THREE.LinePieces = 1;

THREE.Line.prototype = Object.create( THREE.Object3D.prototype );

THREE.Line.prototype.clone = function ( object ) {

	if ( object === undefined ) object = new THREE.Line( this.geometry, this.material, this.type );

	THREE.Object3D.prototype.clone.call( this, object );

	return object;

};
/**
 * @author mrdoob / http://mrdoob.com/
 * @author alteredq / http://alteredqualia.com/
 * @author mikael emtinger / http://gomo.se/
 * @author jonobr1 / http://jonobr1.com/
 */

THREE.Mesh = function ( geometry, material ) {

	THREE.Object3D.call( this );

	this.geometry = geometry;
	this.material = ( material !== undefined ) ? material : new THREE.MeshBasicMaterial( { color: Math.random() * 0xffffff, wireframe: true } );

	if ( this.geometry !== undefined ) {

		if ( this.geometry.boundingSphere === null ) {

			this.geometry.computeBoundingSphere();

		}

		this.updateMorphTargets();

	}

};

THREE.Mesh.prototype = Object.create( THREE.Object3D.prototype );

THREE.Mesh.prototype.updateMorphTargets = function () {

	if ( this.geometry.morphTargets.length > 0 ) {

		this.morphTargetBase = -1;
		this.morphTargetForcedOrder = [];
		this.morphTargetInfluences = [];
		this.morphTargetDictionary = {};

		for ( var m = 0, ml = this.geometry.morphTargets.length; m < ml; m ++ ) {

			this.morphTargetInfluences.push( 0 );
			this.morphTargetDictionary[ this.geometry.morphTargets[ m ].name ] = m;

		}

	}

};

THREE.Mesh.prototype.getMorphTargetIndexByName = function ( name ) {

	if ( this.morphTargetDictionary[ name ] !== undefined ) {

		return this.morphTargetDictionary[ name ];

	}

	console.log( "THREE.Mesh.getMorphTargetIndexByName: morph target " + name + " does not exist. Returning 0." );

	return 0;

};

THREE.Mesh.prototype.clone = function ( object ) {

	if ( object === undefined ) object = new THREE.Mesh( this.geometry, this.material );

	THREE.Object3D.prototype.clone.call( this, object );

	return object;

};
/**
 * @author mikael emtinger / http://gomo.se/
 * @author alteredq / http://alteredqualia.com/
 */

THREE.Bone = function( belongsToSkin ) {

	THREE.Object3D.call( this );

	this.skin = belongsToSkin;
	this.skinMatrix = new THREE.Matrix4();

};

THREE.Bone.prototype = Object.create( THREE.Object3D.prototype );

THREE.Bone.prototype.update = function ( parentSkinMatrix, forceUpdate ) {

	// update local

	if ( this.matrixAutoUpdate ) {

		forceUpdate |= this.updateMatrix();

	}

	// update skin matrix

	if ( forceUpdate || this.matrixWorldNeedsUpdate ) {

		if( parentSkinMatrix ) {

			this.skinMatrix.multiplyMatrices( parentSkinMatrix, this.matrix );

		} else {

			this.skinMatrix.copy( this.matrix );

		}

		this.matrixWorldNeedsUpdate = false;
		forceUpdate = true;

	}

	// update children

	var child, i, l = this.children.length;

	for ( i = 0; i < l; i ++ ) {

		this.children[ i ].update( this.skinMatrix, forceUpdate );

	}

};

/**
 * @author mikael emtinger / http://gomo.se/
 * @author alteredq / http://alteredqualia.com/
 */

THREE.SkinnedMesh = function ( geometry, material, useVertexTexture ) {

	THREE.Mesh.call( this, geometry, material );

	//

	this.useVertexTexture = useVertexTexture !== undefined ? useVertexTexture : true;

	// init bones

	this.identityMatrix = new THREE.Matrix4();

	this.bones = [];
	this.boneMatrices = [];

	var b, bone, gbone, p, q, s;

	if ( this.geometry && this.geometry.bones !== undefined ) {

		for ( b = 0; b < this.geometry.bones.length; b ++ ) {

			gbone = this.geometry.bones[ b ];

			p = gbone.pos;
			q = gbone.rotq;
			s = gbone.scl;

			bone = this.addBone();

			bone.name = gbone.name;
			bone.position.set( p[0], p[1], p[2] );
			bone.quaternion.set( q[0], q[1], q[2], q[3] );
			bone.useQuaternion = true;

			if ( s !== undefined ) {

				bone.scale.set( s[0], s[1], s[2] );

			} else {

				bone.scale.set( 1, 1, 1 );

			}

		}

		for ( b = 0; b < this.bones.length; b ++ ) {

			gbone = this.geometry.bones[ b ];
			bone = this.bones[ b ];

			if ( gbone.parent === -1 ) {

				this.add( bone );

			} else {

				this.bones[ gbone.parent ].add( bone );

			}

		}

		//

		var nBones = this.bones.length;

		if ( this.useVertexTexture ) {

			// layout (1 matrix = 4 pixels)
			//	RGBA RGBA RGBA RGBA (=> column1, column2, column3, column4)
			//  with  8x8  pixel texture max   16 bones  (8 * 8  / 4)
			//  	 16x16 pixel texture max   64 bones (16 * 16 / 4)
			//  	 32x32 pixel texture max  256 bones (32 * 32 / 4)
			//  	 64x64 pixel texture max 1024 bones (64 * 64 / 4)

			var size;

			if ( nBones > 256 )
				size = 64;
			else if ( nBones > 64 )
				size = 32;
			else if ( nBones > 16 )
				size = 16;
			else
				size = 8;

			this.boneTextureWidth = size;
			this.boneTextureHeight = size;

			this.boneMatrices = new Float32Array( this.boneTextureWidth * this.boneTextureHeight * 4 ); // 4 floats per RGBA pixel
			this.boneTexture = new THREE.DataTexture( this.boneMatrices, this.boneTextureWidth, this.boneTextureHeight, THREE.RGBAFormat, THREE.FloatType );
			this.boneTexture.minFilter = THREE.NearestFilter;
			this.boneTexture.magFilter = THREE.NearestFilter;
			this.boneTexture.generateMipmaps = false;
			this.boneTexture.flipY = false;

		} else {

			this.boneMatrices = new Float32Array( 16 * nBones );

		}

		this.pose();

	}

};

THREE.SkinnedMesh.prototype = Object.create( THREE.Mesh.prototype );

THREE.SkinnedMesh.prototype.addBone = function( bone ) {

	if ( bone === undefined ) {

		bone = new THREE.Bone( this );

	}

	this.bones.push( bone );

	return bone;

};

THREE.SkinnedMesh.prototype.updateMatrixWorld = function ( force ) {

	this.matrixAutoUpdate && this.updateMatrix();

	// update matrixWorld

	if ( this.matrixWorldNeedsUpdate || force ) {

		if ( this.parent ) {

			this.matrixWorld.multiplyMatrices( this.parent.matrixWorld, this.matrix );

		} else {

			this.matrixWorld.copy( this.matrix );

		}

		this.matrixWorldNeedsUpdate = false;

		force = true;

	}

	// update children

	for ( var i = 0, l = this.children.length; i < l; i ++ ) {

		var child = this.children[ i ];

		if ( child instanceof THREE.Bone ) {

			child.update( this.identityMatrix, false );

		} else {

			child.updateMatrixWorld( true );

		}

	}

	// make a snapshot of the bones' rest position

	if ( this.boneInverses == undefined ) {

		this.boneInverses = [];

		for ( var b = 0, bl = this.bones.length; b < bl; b ++ ) {

			var inverse = new THREE.Matrix4();

			inverse.getInverse( this.bones[ b ].skinMatrix );

			this.boneInverses.push( inverse );

		}

	}

	// flatten bone matrices to array

	for ( var b = 0, bl = this.bones.length; b < bl; b ++ ) {

		// compute the offset between the current and the original transform;

		//TODO: we could get rid of this multiplication step if the skinMatrix
		// was already representing the offset; however, this requires some
		// major changes to the animation system

		THREE.SkinnedMesh.offsetMatrix.multiplyMatrices( this.bones[ b ].skinMatrix, this.boneInverses[ b ] );

		THREE.SkinnedMesh.offsetMatrix.flattenToArrayOffset( this.boneMatrices, b * 16 );

	}

	if ( this.useVertexTexture ) {

		this.boneTexture.needsUpdate = true;

	}

};

THREE.SkinnedMesh.prototype.pose = function () {

	this.updateMatrixWorld( true );

	for ( var i = 0; i < this.geometry.skinIndices.length; i ++ ) {

		// normalize weights

		var sw = this.geometry.skinWeights[ i ];

		var scale = 1.0 / sw.lengthManhattan();

		if ( scale !== Infinity ) {

			sw.multiplyScalar( scale );

		} else {

			sw.set( 1 ); // this will be normalized by the shader anyway

		}

	}

};

THREE.SkinnedMesh.prototype.clone = function ( object ) {

	if ( object === undefined ) object = new THREE.SkinnedMesh( this.geometry, this.material, this.useVertexTexture );

	THREE.Mesh.prototype.clone.call( this, object );

	return object;

};

THREE.SkinnedMesh.offsetMatrix = new THREE.Matrix4();
/**
 * @author alteredq / http://alteredqualia.com/
 */

THREE.MorphAnimMesh = function ( geometry, material ) {

	THREE.Mesh.call( this, geometry, material );

	// API

	this.duration = 1000; // milliseconds
	this.mirroredLoop = false;
	this.time = 0;

	// internals

	this.lastKeyframe = 0;
	this.currentKeyframe = 0;

	this.direction = 1;
	this.directionBackwards = false;

	this.setFrameRange( 0, this.geometry.morphTargets.length - 1 );

};

THREE.MorphAnimMesh.prototype = Object.create( THREE.Mesh.prototype );

THREE.MorphAnimMesh.prototype.setFrameRange = function ( start, end ) {

	this.startKeyframe = start;
	this.endKeyframe = end;

	this.length = this.endKeyframe - this.startKeyframe + 1;

};

THREE.MorphAnimMesh.prototype.setDirectionForward = function () {

	this.direction = 1;
	this.directionBackwards = false;

};

THREE.MorphAnimMesh.prototype.setDirectionBackward = function () {

	this.direction = -1;
	this.directionBackwards = true;

};

THREE.MorphAnimMesh.prototype.parseAnimations = function () {

	var geometry = this.geometry;

	if ( ! geometry.animations ) geometry.animations = {};

	var firstAnimation, animations = geometry.animations;

	var pattern = /([a-z]+)(\d+)/;

	for ( var i = 0, il = geometry.morphTargets.length; i < il; i ++ ) {

		var morph = geometry.morphTargets[ i ];
		var parts = morph.name.match( pattern );

		if ( parts && parts.length > 1 ) {

			var label = parts[ 1 ];
			var num = parts[ 2 ];

			if ( ! animations[ label ] ) animations[ label ] = { start: Infinity, end: -Infinity };

			var animation = animations[ label ];

			if ( i < animation.start ) animation.start = i;
			if ( i > animation.end ) animation.end = i;

			if ( ! firstAnimation ) firstAnimation = label;

		}

	}

	geometry.firstAnimation = firstAnimation;

};

THREE.MorphAnimMesh.prototype.setAnimationLabel = function ( label, start, end ) {

	if ( ! this.geometry.animations ) this.geometry.animations = {};

	this.geometry.animations[ label ] = { start: start, end: end };

};

THREE.MorphAnimMesh.prototype.playAnimation = function ( label, fps ) {

	var animation = this.geometry.animations[ label ];

	if ( animation ) {

		this.setFrameRange( animation.start, animation.end );
		this.duration = 1000 * ( ( animation.end - animation.start ) / fps );
		this.time = 0;

	} else {

		console.warn( "animation[" + label + "] undefined" );

	}

};

THREE.MorphAnimMesh.prototype.updateAnimation = function ( delta ) {

	var frameTime = this.duration / this.length;

	this.time += this.direction * delta;

	if ( this.mirroredLoop ) {

		if ( this.time > this.duration || this.time < 0 ) {

			this.direction *= -1;

			if ( this.time > this.duration ) {

				this.time = this.duration;
				this.directionBackwards = true;

			}

			if ( this.time < 0 ) {

				this.time = 0;
				this.directionBackwards = false;

			}

		}

	} else {

		this.time = this.time % this.duration;

		if ( this.time < 0 ) this.time += this.duration;

	}

	var keyframe = this.startKeyframe + THREE.Math.clamp( Math.floor( this.time / frameTime ), 0, this.length - 1 );

	if ( keyframe !== this.currentKeyframe ) {

		this.morphTargetInfluences[ this.lastKeyframe ] = 0;
		this.morphTargetInfluences[ this.currentKeyframe ] = 1;

		this.morphTargetInfluences[ keyframe ] = 0;

		this.lastKeyframe = this.currentKeyframe;
		this.currentKeyframe = keyframe;

	}

	var mix = ( this.time % frameTime ) / frameTime;

	if ( this.directionBackwards ) {

		mix = 1 - mix;

	}

	this.morphTargetInfluences[ this.currentKeyframe ] = mix;
	this.morphTargetInfluences[ this.lastKeyframe ] = 1 - mix;

};

THREE.MorphAnimMesh.prototype.clone = function ( object ) {

	if ( object === undefined ) object = new THREE.MorphAnimMesh( this.geometry, this.material );

	object.duration = this.duration;
	object.mirroredLoop = this.mirroredLoop;
	object.time = this.time;

	object.lastKeyframe = this.lastKeyframe;
	object.currentKeyframe = this.currentKeyframe;

	object.direction = this.direction;
	object.directionBackwards = this.directionBackwards;

	THREE.Mesh.prototype.clone.call( this, object );

	return object;

};

THREE.Ribbon = function (a, b) {
	THREE.Object3D.call(this);
	this.geometry = a;
	this.material = b
};
THREE.Ribbon.prototype = Object.create(THREE.Object3D.prototype);
THREE.Ribbon.prototype.clone = function (a) {
	void 0 === a && (a = new THREE.Ribbon(this.geometry, this.material));
	THREE.Object3D.prototype.clone.call(this, a);
	return a
};
THREE.LOD = function () {
	THREE.Object3D.call(this);
	this.LODs = []
};
THREE.LOD.prototype = Object.create(THREE.Object3D.prototype);
THREE.LOD.prototype.addLevel = function (a, b) {
	void 0 === b && (b = 0);
	for (var b = Math.abs(b), c = 0; c < this.LODs.length && !(b < this.LODs[c].visibleAtDistance); c++);
	this.LODs.splice(c, 0, {
		visibleAtDistance: b,
		object3D: a
	});
	this.add(a)
};
THREE.LOD.prototype.update = function (a) {
	if (1 < this.LODs.length) {
		a.matrixWorldInverse.getInverse(a.matrixWorld);
		a = a.matrixWorldInverse;
		a = -(a.elements[2] * this.matrixWorld.elements[12] + a.elements[6] * this.matrixWorld.elements[13] + a.elements[10] * this.matrixWorld.elements[14] + a.elements[14]);
		this.LODs[0].object3D.visible = !0;
		for (var b = 1; b < this.LODs.length; b++) if (a >= this.LODs[b].visibleAtDistance) this.LODs[b - 1].object3D.visible = !1, this.LODs[b].object3D.visible = !0;
		else break;
		for (; b < this.LODs.length; b++) this.LODs[b].object3D.visible = !1
	}
};
THREE.LOD.prototype.clone = function () {};
THREE.Sprite = function (a) {
	THREE.Object3D.call(this);
	this.material = void 0 !== a ? a : new THREE.SpriteMaterial;
	this.rotation3d = this.rotation;
	this.rotation = 0
};
THREE.Sprite.prototype = Object.create(THREE.Object3D.prototype);
THREE.Sprite.prototype.updateMatrix = function () {
	this.matrix.setPosition(this.position);
	this.rotation3d.set(0, 0, this.rotation);
	this.matrix.setRotationFromEuler(this.rotation3d);
	(1 !== this.scale.x || 1 !== this.scale.y) && this.matrix.scale(this.scale);
	this.matrixWorldNeedsUpdate = !0
};
THREE.Sprite.prototype.clone = function (a) {
	void 0 === a && (a = new THREE.Sprite(this.material));
	THREE.Object3D.prototype.clone.call(this, a);
	return a
};
THREE.Scene = function () {
	THREE.Object3D.call(this);
	this.overrideMaterial = this.fog = null;
	this.matrixAutoUpdate = !1;
	this.__objects = [];
	this.__lights = [];
	this.__objectsAdded = [];
	this.__objectsRemoved = []
};
THREE.Scene.prototype = Object.create(THREE.Object3D.prototype);
THREE.Scene.prototype.__addObject = function (a) {
	if (a instanceof THREE.Light) - 1 === this.__lights.indexOf(a) && this.__lights.push(a), a.target && void 0 === a.target.parent && this.add(a.target);
	else if (!(a instanceof THREE.Camera || a instanceof THREE.Bone) && -1 === this.__objects.indexOf(a)) {
		this.__objects.push(a);
		this.__objectsAdded.push(a);
		var b = this.__objectsRemoved.indexOf(a); - 1 !== b && this.__objectsRemoved.splice(b, 1)
	}
	for (b = 0; b < a.children.length; b++) this.__addObject(a.children[b])
};
THREE.Scene.prototype.__removeObject = function (a) {
	if (a instanceof THREE.Light) {
		// TODO: FUCKING REMOVE ME
		return;
		var b = this.__lights.indexOf(a); - 1 !== b && this.__lights.splice(b, 1)
	} else a instanceof THREE.Camera || (b = this.__objects.indexOf(a), -1 !== b && (this.__objects.splice(b, 1), this.__objectsRemoved.push(a), b = this.__objectsAdded.indexOf(a), -1 !== b && this.__objectsAdded.splice(b, 1)));
	for (b = 0; b < a.children.length; b++) this.__removeObject(a.children[b])
};
THREE.Fog = function (a, b, c) {
	this.name = "";
	this.color = new THREE.Color(a);
	this.near = void 0 !== b ? b : 1;
	this.far = void 0 !== c ? c : 1E3
};
THREE.Fog.prototype.clone = function () {
	return new THREE.Fog(this.color.getHex(), this.near, this.far)
};
THREE.FogExp2 = function (a, b) {
	this.name = "";
	this.color = new THREE.Color(a);
	this.density = void 0 !== b ? b : 2.5E-4
};
THREE.FogExp2.prototype.clone = function () {
	return new THREE.FogExp2(this.color.getHex(), this.density)
};
THREE.CanvasRenderer = function (a) {
	function b(a) {
		x !== a && (x = p.globalAlpha = a)
	}
	function c(a) {
		v !== a && (a === THREE.NormalBlending ? p.globalCompositeOperation = "source-over" : a === THREE.AdditiveBlending ? p.globalCompositeOperation = "lighter" : a === THREE.SubtractiveBlending && (p.globalCompositeOperation = "darker"), v = a)
	}
	function d(a) {
		s !== a && (s = p.strokeStyle = a)
	}
	function e(a) {
		C !== a && (C = p.fillStyle = a)
	}
	console.log("THREE.CanvasRenderer", THREE.REVISION);
	var a = a || {}, f = this,
		g, h, i, k = new THREE.Projector,
		j = void 0 !== a.canvas ? a.canvas : document.createElement("canvas"),
		l, m, r, q, p = j.getContext("2d"),
		t = new THREE.Color(0),
		u = 0,
		x = 1,
		v = 0,
		s = null,
		C = null,
		z = null,
		w = null,
		A = null,
		H, G, I, V, E = new THREE.RenderableVertex,
		O = new THREE.RenderableVertex,
		D, J, P, R, Q, N, M, F, W, oa, ua, va, L = new THREE.Color,
		da = new THREE.Color,
		ca = new THREE.Color,
		ba = new THREE.Color,
		ka = new THREE.Color,
		T = new THREE.Color,
		fa = new THREE.Color,
		U = {}, Fa = {}, wa, qa, na, ta, Ga, ra, Ua, Va, ib, Wa, $a = new THREE.Box2,
		Ba = new THREE.Box2,
		Ha = new THREE.Box2,
		wb = !1,
		Aa = new THREE.Color,
		Xa = new THREE.Color,
		Na = new THREE.Color,
		S = new THREE.Vector3,
		pa, nb, Lb, Ya, Db, tb, ya = 16;
	pa = document.createElement("canvas");
	pa.width = pa.height = 2;
	nb = pa.getContext("2d");
	nb.fillStyle = "rgba(0,0,0,1)";
	nb.fillRect(0, 0, 2, 2);
	Lb = nb.getImageData(0, 0, 2, 2);
	Ya = Lb.data;
	Db = document.createElement("canvas");
	Db.width = Db.height = ya;
	tb = Db.getContext("2d");
	tb.translate(-ya / 2, -ya / 2);
	tb.scale(ya, ya);
	ya--;
	this.domElement = j;
	this.devicePixelRatio = void 0 !== a.devicePixelRatio ? a.devicePixelRatio : void 0 !== window.devicePixelRatio ? window.devicePixelRatio : 1;
	this.sortElements = this.sortObjects = this.autoClear = !0;
	this.info = {
		render: {
			vertices: 0,
			faces: 0
		}
	};
	this.setSize = function (a, b) {
		l = a * this.devicePixelRatio;
		m = b * this.devicePixelRatio;
		r = Math.floor(l / 2);
		q = Math.floor(m / 2);
		j.width = l;
		j.height = m;
		j.style.width = a + "px";
		j.style.height = b + "px";
		$a.min.set(-r, -q);
		$a.max.set(r, q);
		Ba.min.set(-r, -q);
		Ba.max.set(r, q);
		x = 1;
		v = 0;
		A = w = z = C = s = null
	};
	this.setClearColor = function (a, b) {
		t.copy(a);
		u = void 0 !== b ? b : 1;
		Ba.min.set(-r, -q);
		Ba.max.set(r, q)
	};
	this.setClearColorHex = function (a, b) {
		t.setHex(a);
		u = void 0 !== b ? b : 1;
		Ba.min.set(-r, -q);
		Ba.max.set(r, q)
	};
	this.getMaxAnisotropy = function () {
		return 0
	};
	this.clear = function () {
		p.setTransform(1, 0, 0, -1, r, q);
		!1 === Ba.empty() && (Ba.intersect($a), Ba.expandByScalar(2), 1 > u && p.clearRect(Ba.min.x | 0, Ba.min.y | 0, Ba.max.x - Ba.min.x | 0, Ba.max.y - Ba.min.y | 0), 0 < u && (c(THREE.NormalBlending), b(1), e("rgba(" + Math.floor(255 * t.r) + "," + Math.floor(255 * t.g) + "," + Math.floor(255 * t.b) + "," + u + ")"), p.fillRect(Ba.min.x | 0, Ba.min.y | 0, Ba.max.x - Ba.min.x | 0, Ba.max.y - Ba.min.y | 0)), Ba.makeEmpty())
	};
	this.render = function (a,
	j) {
		function n(a, b, c) {
			for (var d = 0, e = i.length; d < e; d++) {
				var f = i[d],
					g = f.color;
				if (f instanceof THREE.DirectionalLight) {
					var h = f.matrixWorld.getPosition().normalize(),
						j = b.dot(h);
					0 >= j || (j *= f.intensity, c.r += g.r * j, c.g += g.g * j, c.b += g.b * j)
				} else f instanceof THREE.PointLight && (h = f.matrixWorld.getPosition(), j = b.dot(S.sub(h, a).normalize()), 0 >= j || (j *= 0 == f.distance ? 1 : 1 - Math.min(a.distanceTo(h) / f.distance, 1), 0 != j && (j *= f.intensity, c.r += g.r * j, c.g += g.g * j, c.b += g.b * j)))
			}
		}
		function m(a, d, e, g, h, i, k, p) {
			f.info.render.vertices += 3;
			f.info.render.faces++;
			b(p.opacity);
			c(p.blending);
			D = a.positionScreen.x;
			J = a.positionScreen.y;
			P = d.positionScreen.x;
			R = d.positionScreen.y;
			Q = e.positionScreen.x;
			N = e.positionScreen.y;
			l(D, J, P, R, Q, N);
			(p instanceof THREE.MeshLambertMaterial || p instanceof THREE.MeshPhongMaterial) && null === p.map && null === p.map ? (T.copy(p.color), fa.copy(p.emissive), p.vertexColors === THREE.FaceColors && (T.r *= k.color.r, T.g *= k.color.g, T.b *= k.color.b), !0 === wb ? !1 === p.wireframe && p.shading == THREE.SmoothShading && 3 == k.vertexNormalsLength ? (da.r = ca.r = ba.r = Aa.r, da.g = ca.g = ba.g = Aa.g, da.b = ca.b = ba.b = Aa.b, n(k.v1.positionWorld, k.vertexNormalsModel[0], da), n(k.v2.positionWorld, k.vertexNormalsModel[1], ca), n(k.v3.positionWorld, k.vertexNormalsModel[2], ba), da.r = da.r * T.r + fa.r, da.g = da.g * T.g + fa.g, da.b = da.b * T.b + fa.b, ca.r = ca.r * T.r + fa.r, ca.g = ca.g * T.g + fa.g, ca.b = ca.b * T.b + fa.b, ba.r = ba.r * T.r + fa.r, ba.g = ba.g * T.g + fa.g, ba.b = ba.b * T.b + fa.b, ka.r = 0.5 * (ca.r + ba.r), ka.g = 0.5 * (ca.g + ba.g), ka.b = 0.5 * (ca.b + ba.b), na = C(da, ca, ba, ka), x(D, J, P, R, Q, N, 0, 0, 1, 0, 0, 1, na)) : (L.r = Aa.r,
			L.g = Aa.g, L.b = Aa.b, n(k.centroidModel, k.normalModel, L), L.r = L.r * T.r + fa.r, L.g = L.g * T.g + fa.g, L.b = L.b * T.b + fa.b, !0 === p.wireframe ? t(L, p.wireframeLinewidth, p.wireframeLinecap, p.wireframeLinejoin) : u(L)) : !0 === p.wireframe ? t(p.color, p.wireframeLinewidth, p.wireframeLinecap, p.wireframeLinejoin) : u(p.color)) : p instanceof THREE.MeshBasicMaterial || p instanceof THREE.MeshLambertMaterial || p instanceof THREE.MeshPhongMaterial ? null !== p.map ? p.map.mapping instanceof THREE.UVMapping && (ta = k.uvs[0], v(D, J, P, R, Q, N, ta[g].x, ta[g].y,
			ta[h].x, ta[h].y, ta[i].x, ta[i].y, p.map)) : null !== p.envMap ? p.envMap.mapping instanceof THREE.SphericalReflectionMapping && (S.copy(k.vertexNormalsModelView[g]), Ga = 0.5 * S.x + 0.5, ra = 0.5 * S.y + 0.5, S.copy(k.vertexNormalsModelView[h]), Ua = 0.5 * S.x + 0.5, Va = 0.5 * S.y + 0.5, S.copy(k.vertexNormalsModelView[i]), ib = 0.5 * S.x + 0.5, Wa = 0.5 * S.y + 0.5, v(D, J, P, R, Q, N, Ga, ra, Ua, Va, ib, Wa, p.envMap)) : (L.copy(p.color), p.vertexColors === THREE.FaceColors && (L.r *= k.color.r, L.g *= k.color.g, L.b *= k.color.b), !0 === p.wireframe ? t(L, p.wireframeLinewidth,
			p.wireframeLinecap, p.wireframeLinejoin) : u(L)) : p instanceof THREE.MeshDepthMaterial ? (wa = j.near, qa = j.far, da.r = da.g = da.b = 1 - ya(a.positionScreen.z, wa, qa), ca.r = ca.g = ca.b = 1 - ya(d.positionScreen.z, wa, qa), ba.r = ba.g = ba.b = 1 - ya(e.positionScreen.z, wa, qa), ka.r = 0.5 * (ca.r + ba.r), ka.g = 0.5 * (ca.g + ba.g), ka.b = 0.5 * (ca.b + ba.b), na = C(da, ca, ba, ka), x(D, J, P, R, Q, N, 0, 0, 1, 0, 0, 1, na)) : p instanceof THREE.MeshNormalMaterial && (L.r = 0.5 * k.normalModelView.x + 0.5, L.g = 0.5 * k.normalModelView.y + 0.5, L.b = 0.5 * k.normalModelView.z + 0.5, !0 === p.wireframe ? t(L, p.wireframeLinewidth, p.wireframeLinecap, p.wireframeLinejoin) : u(L))
		}
		function l(a, b, c, d, e, f) {
			p.beginPath();
			p.moveTo(a, b);
			p.lineTo(c, d);
			p.lineTo(e, f);
			p.closePath()
		}
		function s(a, b, c, d, e, f, g, h) {
			p.beginPath();
			p.moveTo(a, b);
			p.lineTo(c, d);
			p.lineTo(e, f);
			p.lineTo(g, h);
			p.closePath()
		}
		function t(a, b, c, e) {
			z !== b && (z = p.lineWidth = b);
			w !== c && (w = p.lineCap = c);
			A !== e && (A = p.lineJoin = e);
			d(a.getStyle());
			p.stroke();
			Ha.expandByScalar(2 * b)
		}
		function u(a) {
			e(a.getStyle());
			p.fill()
		}
		function v(a, b, c, d, f, g, h, i, j, k, n, m, l) {
			if (!(l instanceof
			THREE.DataTexture || void 0 === l.image || 0 == l.image.width)) {
				if (!0 === l.needsUpdate) {
					var r = l.wrapS == THREE.RepeatWrapping,
						q = l.wrapT == THREE.RepeatWrapping;
					U[l.id] = p.createPattern(l.image, !0 === r && !0 === q ? "repeat" : !0 === r && !1 === q ? "repeat-x" : !1 === r && !0 === q ? "repeat-y" : "no-repeat");
					l.needsUpdate = !1
				}
				void 0 === U[l.id] ? e("rgba(0,0,0,1)") : e(U[l.id]);
				var r = l.offset.x / l.repeat.x,
					q = l.offset.y / l.repeat.y,
					S = l.image.width * l.repeat.x,
					s = l.image.height * l.repeat.y,
					h = (h + r) * S,
					i = (1 - i + q) * s,
					c = c - a,
					d = d - b,
					f = f - a,
					g = g - b,
					j = (j + r) * S - h,
					k = (1 - k + q) * s - i,
					n = (n + r) * S - h,
					m = (1 - m + q) * s - i,
					r = j * m - n * k;
				0 === r ? (void 0 === Fa[l.id] && (b = document.createElement("canvas"), b.width = l.image.width, b.height = l.image.height, b = b.getContext("2d"), b.drawImage(l.image, 0, 0), Fa[l.id] = b.getImageData(0, 0, l.image.width, l.image.height).data), b = Fa[l.id], h = 4 * (Math.floor(h) + Math.floor(i) * l.image.width), L.setRGB(b[h] / 255, b[h + 1] / 255, b[h + 2] / 255), u(L)) : (r = 1 / r, l = (m * c - k * f) * r, k = (m * d - k * g) * r, c = (j * f - n * c) * r, d = (j * g - n * d) * r, a = a - l * h - c * i, h = b - k * h - d * i, p.save(), p.transform(l, k, c, d, a, h), p.fill(), p.restore())
			}
		}

		function x(a, b, c, d, e, f, g, h, i, j, k, n, m) {
			var l, r;
			l = m.width - 1;
			r = m.height - 1;
			g *= l;
			h *= r;
			c -= a;
			d -= b;
			e -= a;
			f -= b;
			i = i * l - g;
			j = j * r - h;
			k = k * l - g;
			n = n * r - h;
			r = 1 / (i * n - k * j);
			l = (n * c - j * e) * r;
			j = (n * d - j * f) * r;
			c = (i * e - k * c) * r;
			d = (i * f - k * d) * r;
			a = a - l * g - c * h;
			b = b - j * g - d * h;
			p.save();
			p.transform(l, j, c, d, a, b);
			p.clip();
			p.drawImage(m, 0, 0);
			p.restore()
		}
		function C(a, b, c, d) {
			Ya[0] = 255 * a.r | 0;
			Ya[1] = 255 * a.g | 0;
			Ya[2] = 255 * a.b | 0;
			Ya[4] = 255 * b.r | 0;
			Ya[5] = 255 * b.g | 0;
			Ya[6] = 255 * b.b | 0;
			Ya[8] = 255 * c.r | 0;
			Ya[9] = 255 * c.g | 0;
			Ya[10] = 255 * c.b | 0;
			Ya[12] = 255 * d.r | 0;
			Ya[13] = 255 * d.g | 0;
			Ya[14] = 255 * d.b | 0;
			nb.putImageData(Lb, 0, 0);
			tb.drawImage(pa, 0, 0);
			return Db
		}
		function ya(a, b, c) {
			a = (a - b) / (c - b);
			return a * a * (3 - 2 * a)
		}
		function fb(a, b) {
			var c = b.x - a.x,
				d = b.y - a.y,
				e = c * c + d * d;
			0 !== e && (e = 1 / Math.sqrt(e), c *= e, d *= e, b.x += c, b.y += d, a.x -= c, a.y -= d)
		}
		if (!1 === j instanceof THREE.Camera) console.error("THREE.CanvasRenderer.render: camera is not an instance of THREE.Camera.");
		else {
			!0 === this.autoClear && this.clear();
			p.setTransform(1, 0, 0, -1, r, q);
			f.info.render.vertices = 0;
			f.info.render.faces = 0;
			g = k.projectScene(a, j, this.sortObjects,
			this.sortElements);
			h = g.elements;
			i = g.lights;
			wb = 0 < i.length;
			if (!0 === wb) {
				Aa.setRGB(0, 0, 0);
				Xa.setRGB(0, 0, 0);
				Na.setRGB(0, 0, 0);
				for (var jb = 0, ec = i.length; jb < ec; jb++) {
					var ea = i[jb],
						ma = ea.color;
					ea instanceof THREE.AmbientLight ? (Aa.r += ma.r, Aa.g += ma.g, Aa.b += ma.b) : ea instanceof THREE.DirectionalLight ? (Xa.r += ma.r, Xa.g += ma.g, Xa.b += ma.b) : ea instanceof THREE.PointLight && (Na.r += ma.r, Na.g += ma.g, Na.b += ma.b)
				}
			}
			jb = 0;
			for (ec = h.length; jb < ec; jb++) {
				var la = h[jb],
					ea = la.material;
				if (!(void 0 === ea || !1 === ea.visible)) {
					Ha.makeEmpty();
					if (la instanceof THREE.RenderableParticle) {
						H = la;
						H.x *= r;
						H.y *= q;
						var ma = H,
							Ka = la;
						b(ea.opacity);
						c(ea.blending);
						var cb = void 0,
							db = void 0,
							ob = void 0,
							ab = void 0,
							Eb = la = void 0,
							Gb = void 0;
						ea instanceof THREE.ParticleBasicMaterial ? null === ea.map ? (ob = Ka.object.scale.x, ab = Ka.object.scale.y, ob *= Ka.scale.x * r, ab *= Ka.scale.y * q, Ha.min.set(ma.x - ob, ma.y - ab), Ha.max.set(ma.x + ob, ma.y + ab), !1 !== $a.isIntersectionBox(Ha) && (e(ea.color.getStyle()), p.save(), p.translate(ma.x, ma.y), p.rotate(-Ka.rotation), p.scale(ob, ab), p.fillRect(-1, -1, 2, 2), p.restore())) : (la = ea.map.image, Eb = la.width >> 1, Gb = la.height >> 1, ob = Ka.scale.x * r, ab = Ka.scale.y * q, cb = ob * Eb, db = ab * Gb, Ha.min.set(ma.x - cb, ma.y - db), Ha.max.set(ma.x + cb, ma.y + db), !1 !== $a.isIntersectionBox(Ha) && (p.save(), p.translate(ma.x, ma.y), p.rotate(-Ka.rotation), p.scale(ob, -ab), p.translate(-Eb, -Gb), p.drawImage(la, 0, 0), p.restore())) : ea instanceof THREE.ParticleCanvasMaterial && (cb = Ka.scale.x * r, db = Ka.scale.y * q, Ha.min.set(ma.x - cb, ma.y - db), Ha.max.set(ma.x + cb, ma.y + db), !1 !== $a.isIntersectionBox(Ha) && (d(ea.color.getStyle()),
						e(ea.color.getStyle()), p.save(), p.translate(ma.x, ma.y), p.rotate(-Ka.rotation), p.scale(cb, db), ea.program(p), p.restore()))
					} else la instanceof THREE.RenderableLine ? (H = la.v1, G = la.v2, H.positionScreen.x *= r, H.positionScreen.y *= q, G.positionScreen.x *= r, G.positionScreen.y *= q, Ha.setFromPoints([H.positionScreen, G.positionScreen]), !0 === $a.isIntersectionBox(Ha) && (ma = H, Ka = G, b(ea.opacity), c(ea.blending), p.beginPath(), p.moveTo(ma.positionScreen.x, ma.positionScreen.y), p.lineTo(Ka.positionScreen.x, Ka.positionScreen.y),
					ea instanceof THREE.LineBasicMaterial && (ma = ea.linewidth, z !== ma && (z = p.lineWidth = ma), ma = ea.linecap, w !== ma && (w = p.lineCap = ma), ma = ea.linejoin, A !== ma && (A = p.lineJoin = ma), d(ea.color.getStyle()), p.stroke(), Ha.expandByScalar(2 * ea.linewidth)))) : la instanceof THREE.RenderableFace3 ? (H = la.v1, G = la.v2, I = la.v3, H.positionScreen.x *= r, H.positionScreen.y *= q, G.positionScreen.x *= r, G.positionScreen.y *= q, I.positionScreen.x *= r, I.positionScreen.y *= q, !0 === ea.overdraw && (fb(H.positionScreen, G.positionScreen), fb(G.positionScreen,
					I.positionScreen), fb(I.positionScreen, H.positionScreen)), Ha.setFromPoints([H.positionScreen, G.positionScreen, I.positionScreen]), !0 === $a.isIntersectionBox(Ha) && m(H, G, I, 0, 1, 2, la, ea, a)) : la instanceof THREE.RenderableFace4 && (H = la.v1, G = la.v2, I = la.v3, V = la.v4, H.positionScreen.x *= r, H.positionScreen.y *= q, G.positionScreen.x *= r, G.positionScreen.y *= q, I.positionScreen.x *= r, I.positionScreen.y *= q, V.positionScreen.x *= r, V.positionScreen.y *= q, E.positionScreen.copy(G.positionScreen), O.positionScreen.copy(V.positionScreen), !0 === ea.overdraw && (fb(H.positionScreen, G.positionScreen), fb(G.positionScreen, V.positionScreen), fb(V.positionScreen, H.positionScreen), fb(I.positionScreen, E.positionScreen), fb(I.positionScreen, O.positionScreen)), Ha.setFromPoints([H.positionScreen, G.positionScreen, I.positionScreen, V.positionScreen]), !0 === $a.isIntersectionBox(Ha) && (ma = H, Ka = G, cb = I, db = V, ob = E, ab = O, Eb = a, f.info.render.vertices += 4, f.info.render.faces++, b(ea.opacity), c(ea.blending), void 0 !== ea.map && null !== ea.map || void 0 !== ea.envMap && null !== ea.envMap ? (m(ma, Ka, db, 0, 1, 3, la, ea, Eb), m(ob, cb, ab, 1, 2, 3, la, ea, Eb)) : (D = ma.positionScreen.x, J = ma.positionScreen.y, P = Ka.positionScreen.x, R = Ka.positionScreen.y, Q = cb.positionScreen.x, N = cb.positionScreen.y, M = db.positionScreen.x, F = db.positionScreen.y, W = ob.positionScreen.x, oa = ob.positionScreen.y, ua = ab.positionScreen.x, va = ab.positionScreen.y, ea instanceof THREE.MeshLambertMaterial || ea instanceof THREE.MeshPhongMaterial ? (T.copy(ea.color), fa.copy(ea.emissive), ea.vertexColors === THREE.FaceColors && (T.r *= la.color.r,
					T.g *= la.color.g, T.b *= la.color.b), !0 === wb ? !1 === ea.wireframe && ea.shading == THREE.SmoothShading && 4 == la.vertexNormalsLength ? (da.r = ca.r = ba.r = ka.r = Aa.r, da.g = ca.g = ba.g = ka.g = Aa.g, da.b = ca.b = ba.b = ka.b = Aa.b, n(la.v1.positionWorld, la.vertexNormalsModel[0], da), n(la.v2.positionWorld, la.vertexNormalsModel[1], ca), n(la.v4.positionWorld, la.vertexNormalsModel[3], ba), n(la.v3.positionWorld, la.vertexNormalsModel[2], ka), da.r = da.r * T.r + fa.r, da.g = da.g * T.g + fa.g, da.b = da.b * T.b + fa.b, ca.r = ca.r * T.r + fa.r, ca.g = ca.g * T.g + fa.g, ca.b = ca.b * T.b + fa.b, ba.r = ba.r * T.r + fa.r, ba.g = ba.g * T.g + fa.g, ba.b = ba.b * T.b + fa.b, ka.r = ka.r * T.r + fa.r, ka.g = ka.g * T.g + fa.g, ka.b = ka.b * T.b + fa.b, na = C(da, ca, ba, ka), l(D, J, P, R, M, F), x(D, J, P, R, M, F, 0, 0, 1, 0, 0, 1, na), l(W, oa, Q, N, ua, va), x(W, oa, Q, N, ua, va, 1, 0, 1, 1, 0, 1, na)) : (L.r = Aa.r, L.g = Aa.g, L.b = Aa.b, n(la.centroidModel, la.normalModel, L), L.r = L.r * T.r + fa.r, L.g = L.g * T.g + fa.g, L.b = L.b * T.b + fa.b, s(D, J, P, R, Q, N, M, F), !0 === ea.wireframe ? t(L, ea.wireframeLinewidth, ea.wireframeLinecap, ea.wireframeLinejoin) : u(L)) : (L.r = T.r + fa.r, L.g = T.g + fa.g, L.b = T.b + fa.b,
					s(D, J, P, R, Q, N, M, F), !0 === ea.wireframe ? t(L, ea.wireframeLinewidth, ea.wireframeLinecap, ea.wireframeLinejoin) : u(L))) : ea instanceof THREE.MeshBasicMaterial ? (L.copy(ea.color), ea.vertexColors === THREE.FaceColors && (L.r *= la.color.r, L.g *= la.color.g, L.b *= la.color.b), s(D, J, P, R, Q, N, M, F), !0 === ea.wireframe ? t(L, ea.wireframeLinewidth, ea.wireframeLinecap, ea.wireframeLinejoin) : u(L)) : ea instanceof THREE.MeshNormalMaterial ? (L.r = 0.5 * la.normalModelView.x + 0.5, L.g = 0.5 * la.normalModelView.y + 0.5, L.b = 0.5 * la.normalModelView.z + 0.5,
					s(D, J, P, R, Q, N, M, F), !0 === ea.wireframe ? t(L, ea.wireframeLinewidth, ea.wireframeLinecap, ea.wireframeLinejoin) : u(L)) : ea instanceof THREE.MeshDepthMaterial && (wa = j.near, qa = j.far, da.r = da.g = da.b = 1 - ya(ma.positionScreen.z, wa, qa), ca.r = ca.g = ca.b = 1 - ya(Ka.positionScreen.z, wa, qa), ba.r = ba.g = ba.b = 1 - ya(db.positionScreen.z, wa, qa), ka.r = ka.g = ka.b = 1 - ya(cb.positionScreen.z, wa, qa), na = C(da, ca, ba, ka), l(D, J, P, R, M, F), x(D, J, P, R, M, F, 0, 0, 1, 0, 0, 1, na), l(W, oa, Q, N, ua, va), x(W, oa, Q, N, ua, va, 1, 0, 1, 1, 0, 1, na)))));
					Ba.union(Ha)
				}
			}
			p.setTransform(1,
			0, 0, 1, 0, 0)
		}
	}
};
THREE.ShaderChunk = {
	fog_pars_fragment: "#ifdef USE_FOG\nuniform vec3 fogColor;\n#ifdef FOG_EXP2\nuniform float fogDensity;\n#else\nuniform float fogNear;\nuniform float fogFar;\n#endif\n#endif",
	fog_fragment: "#ifdef USE_FOG\nfloat depth = gl_FragCoord.z / gl_FragCoord.w;\n#ifdef FOG_EXP2\nconst float LOG2 = 1.442695;\nfloat fogFactor = exp2( - fogDensity * fogDensity * depth * depth * LOG2 );\nfogFactor = 1.0 - clamp( fogFactor, 0.0, 1.0 );\n#else\nfloat fogFactor = smoothstep( fogNear, fogFar, depth );\n#endif\ngl_FragColor = mix( gl_FragColor, vec4( fogColor, gl_FragColor.w ), fogFactor );\n#endif",
	envmap_pars_fragment: "#ifdef USE_ENVMAP\nuniform float reflectivity;\nuniform samplerCube envMap;\nuniform float flipEnvMap;\nuniform int combine;\n#if defined( USE_BUMPMAP ) || defined( USE_NORMALMAP )\nuniform bool useRefract;\nuniform float refractionRatio;\n#else\nvarying vec3 vReflect;\n#endif\n#endif",
	envmap_fragment: "#ifdef USE_ENVMAP\nvec3 reflectVec;\n#if defined( USE_BUMPMAP ) || defined( USE_NORMALMAP )\nvec3 cameraToVertex = normalize( vWorldPosition - cameraPosition );\nif ( useRefract ) {\nreflectVec = refract( cameraToVertex, normal, refractionRatio );\n} else { \nreflectVec = reflect( cameraToVertex, normal );\n}\n#else\nreflectVec = vReflect;\n#endif\n#ifdef DOUBLE_SIDED\nfloat flipNormal = ( -1.0 + 2.0 * float( gl_FrontFacing ) );\nvec4 cubeColor = textureCube( envMap, flipNormal * vec3( flipEnvMap * reflectVec.x, reflectVec.yz ) );\n#else\nvec4 cubeColor = textureCube( envMap, vec3( flipEnvMap * reflectVec.x, reflectVec.yz ) );\n#endif\n#ifdef GAMMA_INPUT\ncubeColor.xyz *= cubeColor.xyz;\n#endif\nif ( combine == 1 ) {\ngl_FragColor.xyz = mix( gl_FragColor.xyz, cubeColor.xyz, specularStrength * reflectivity );\n} else if ( combine == 2 ) {\ngl_FragColor.xyz += cubeColor.xyz * specularStrength * reflectivity;\n} else {\ngl_FragColor.xyz = mix( gl_FragColor.xyz, gl_FragColor.xyz * cubeColor.xyz, specularStrength * reflectivity );\n}\n#endif",
	envmap_pars_vertex: "#if defined( USE_ENVMAP ) && ! defined( USE_BUMPMAP ) && ! defined( USE_NORMALMAP )\nvarying vec3 vReflect;\nuniform float refractionRatio;\nuniform bool useRefract;\n#endif",
	worldpos_vertex: "#if defined( USE_ENVMAP ) || defined( PHONG ) || defined( LAMBERT ) || defined ( USE_SHADOWMAP )\n#ifdef USE_SKINNING\nvec4 worldPosition = modelMatrix * skinned;\n#endif\n#if defined( USE_MORPHTARGETS ) && ! defined( USE_SKINNING )\nvec4 worldPosition = modelMatrix * vec4( morphed, 1.0 );\n#endif\n#if ! defined( USE_MORPHTARGETS ) && ! defined( USE_SKINNING )\nvec4 worldPosition = modelMatrix * vec4( position, 1.0 );\n#endif\n#endif",
	envmap_vertex: "#if defined( USE_ENVMAP ) && ! defined( USE_BUMPMAP ) && ! defined( USE_NORMALMAP )\nvec3 worldNormal = mat3( modelMatrix[ 0 ].xyz, modelMatrix[ 1 ].xyz, modelMatrix[ 2 ].xyz ) * objectNormal;\nworldNormal = normalize( worldNormal );\nvec3 cameraToVertex = normalize( worldPosition.xyz - cameraPosition );\nif ( useRefract ) {\nvReflect = refract( cameraToVertex, worldNormal, refractionRatio );\n} else {\nvReflect = reflect( cameraToVertex, worldNormal );\n}\n#endif",
	map_particle_pars_fragment: "#ifdef USE_MAP\nuniform sampler2D map;\n#endif",
	map_particle_fragment: "#ifdef USE_MAP\ngl_FragColor = gl_FragColor * texture2D( map, vec2( gl_PointCoord.x, 1.0 - gl_PointCoord.y ) );\n#endif",
	map_pars_vertex: "#if defined( USE_MAP ) || defined( USE_BUMPMAP ) || defined( USE_NORMALMAP ) || defined( USE_SPECULARMAP )\nvarying vec2 vUv;\nuniform vec4 offsetRepeat;\n#endif",
	map_pars_fragment: "#if defined( USE_MAP ) || defined( USE_BUMPMAP ) || defined( USE_NORMALMAP ) || defined( USE_SPECULARMAP )\nvarying vec2 vUv;\n#endif\n#ifdef USE_MAP\nuniform sampler2D map;\n#endif",
	map_vertex: "#if defined( USE_MAP ) || defined( USE_BUMPMAP ) || defined( USE_NORMALMAP ) || defined( USE_SPECULARMAP )\nvUv = uv * offsetRepeat.zw + offsetRepeat.xy;\n#endif",
	map_fragment: "#ifdef USE_MAP\nvec4 texelColor = texture2D( map, vUv );\n#ifdef GAMMA_INPUT\ntexelColor.xyz *= texelColor.xyz;\n#endif\ngl_FragColor = gl_FragColor * texelColor;\n#endif",
	lightmap_pars_fragment: "#ifdef USE_LIGHTMAP\nvarying vec2 vUv2;\nuniform sampler2D lightMap;\n#endif",
	lightmap_pars_vertex: "#ifdef USE_LIGHTMAP\nvarying vec2 vUv2;\n#endif",
	lightmap_fragment: "#ifdef USE_LIGHTMAP\ngl_FragColor = gl_FragColor * texture2D( lightMap, vUv2 );\n#endif",
	lightmap_vertex: "#ifdef USE_LIGHTMAP\nvUv2 = uv2;\n#endif",
	bumpmap_pars_fragment: "#ifdef USE_BUMPMAP\nuniform sampler2D bumpMap;\nuniform float bumpScale;\nvec2 dHdxy_fwd() {\nvec2 dSTdx = dFdx( vUv );\nvec2 dSTdy = dFdy( vUv );\nfloat Hll = bumpScale * texture2D( bumpMap, vUv ).x;\nfloat dBx = bumpScale * texture2D( bumpMap, vUv + dSTdx ).x - Hll;\nfloat dBy = bumpScale * texture2D( bumpMap, vUv + dSTdy ).x - Hll;\nreturn vec2( dBx, dBy );\n}\nvec3 perturbNormalArb( vec3 surf_pos, vec3 surf_norm, vec2 dHdxy ) {\nvec3 vSigmaX = dFdx( surf_pos );\nvec3 vSigmaY = dFdy( surf_pos );\nvec3 vN = surf_norm;\nvec3 R1 = cross( vSigmaY, vN );\nvec3 R2 = cross( vN, vSigmaX );\nfloat fDet = dot( vSigmaX, R1 );\nvec3 vGrad = sign( fDet ) * ( dHdxy.x * R1 + dHdxy.y * R2 );\nreturn normalize( abs( fDet ) * surf_norm - vGrad );\n}\n#endif",
	normalmap_pars_fragment: "#ifdef USE_NORMALMAP\nuniform sampler2D normalMap;\nuniform vec2 normalScale;\nvec3 perturbNormal2Arb( vec3 eye_pos, vec3 surf_norm ) {\nvec3 q0 = dFdx( eye_pos.xyz );\nvec3 q1 = dFdy( eye_pos.xyz );\nvec2 st0 = dFdx( vUv.st );\nvec2 st1 = dFdy( vUv.st );\nvec3 S = normalize(  q0 * st1.t - q1 * st0.t );\nvec3 T = normalize( -q0 * st1.s + q1 * st0.s );\nvec3 N = normalize( surf_norm );\nvec3 mapN = texture2D( normalMap, vUv ).xyz * 2.0 - 1.0;\nmapN.xy = normalScale * mapN.xy;\nmat3 tsn = mat3( S, T, N );\nreturn normalize( tsn * mapN );\n}\n#endif",
	specularmap_pars_fragment: "#ifdef USE_SPECULARMAP\nuniform sampler2D specularMap;\n#endif",
	specularmap_fragment: "float specularStrength;\n#ifdef USE_SPECULARMAP\nvec4 texelSpecular = texture2D( specularMap, vUv );\nspecularStrength = texelSpecular.r;\n#else\nspecularStrength = 1.0;\n#endif",
	lights_lambert_pars_vertex: "uniform vec3 ambient;\nuniform vec3 diffuse;\nuniform vec3 emissive;\nuniform vec3 ambientLightColor;\n#if MAX_DIR_LIGHTS > 0\nuniform vec3 directionalLightColor[ MAX_DIR_LIGHTS ];\nuniform vec3 directionalLightDirection[ MAX_DIR_LIGHTS ];\n#endif\n#if MAX_HEMI_LIGHTS > 0\nuniform vec3 hemisphereLightSkyColor[ MAX_HEMI_LIGHTS ];\nuniform vec3 hemisphereLightGroundColor[ MAX_HEMI_LIGHTS ];\nuniform vec3 hemisphereLightDirection[ MAX_HEMI_LIGHTS ];\n#endif\n#if MAX_POINT_LIGHTS > 0\nuniform vec3 pointLightColor[ MAX_POINT_LIGHTS ];\nuniform vec3 pointLightPosition[ MAX_POINT_LIGHTS ];\nuniform float pointLightDistance[ MAX_POINT_LIGHTS ];\n#endif\n#if MAX_SPOT_LIGHTS > 0\nuniform vec3 spotLightColor[ MAX_SPOT_LIGHTS ];\nuniform vec3 spotLightPosition[ MAX_SPOT_LIGHTS ];\nuniform vec3 spotLightDirection[ MAX_SPOT_LIGHTS ];\nuniform float spotLightDistance[ MAX_SPOT_LIGHTS ];\nuniform float spotLightAngleCos[ MAX_SPOT_LIGHTS ];\nuniform float spotLightExponent[ MAX_SPOT_LIGHTS ];\n#endif\n#ifdef WRAP_AROUND\nuniform vec3 wrapRGB;\n#endif",
	lights_lambert_vertex: "vLightFront = vec3( 0.0 );\n#ifdef DOUBLE_SIDED\nvLightBack = vec3( 0.0 );\n#endif\ntransformedNormal = normalize( transformedNormal );\n#if MAX_DIR_LIGHTS > 0\nfor( int i = 0; i < MAX_DIR_LIGHTS; i ++ ) {\nvec4 lDirection = viewMatrix * vec4( directionalLightDirection[ i ], 0.0 );\nvec3 dirVector = normalize( lDirection.xyz );\nfloat dotProduct = dot( transformedNormal, dirVector );\nvec3 directionalLightWeighting = vec3( max( dotProduct, 0.0 ) );\n#ifdef DOUBLE_SIDED\nvec3 directionalLightWeightingBack = vec3( max( -dotProduct, 0.0 ) );\n#ifdef WRAP_AROUND\nvec3 directionalLightWeightingHalfBack = vec3( max( -0.5 * dotProduct + 0.5, 0.0 ) );\n#endif\n#endif\n#ifdef WRAP_AROUND\nvec3 directionalLightWeightingHalf = vec3( max( 0.5 * dotProduct + 0.5, 0.0 ) );\ndirectionalLightWeighting = mix( directionalLightWeighting, directionalLightWeightingHalf, wrapRGB );\n#ifdef DOUBLE_SIDED\ndirectionalLightWeightingBack = mix( directionalLightWeightingBack, directionalLightWeightingHalfBack, wrapRGB );\n#endif\n#endif\nvLightFront += directionalLightColor[ i ] * directionalLightWeighting;\n#ifdef DOUBLE_SIDED\nvLightBack += directionalLightColor[ i ] * directionalLightWeightingBack;\n#endif\n}\n#endif\n#if MAX_POINT_LIGHTS > 0\nfor( int i = 0; i < MAX_POINT_LIGHTS; i ++ ) {\nvec4 lPosition = viewMatrix * vec4( pointLightPosition[ i ], 1.0 );\nvec3 lVector = lPosition.xyz - mvPosition.xyz;\nfloat lDistance = 1.0;\nif ( pointLightDistance[ i ] > 0.0 )\nlDistance = 1.0 - min( ( length( lVector ) / pointLightDistance[ i ] ), 1.0 );\nlVector = normalize( lVector );\nfloat dotProduct = dot( transformedNormal, lVector );\nvec3 pointLightWeighting = vec3( max( dotProduct, 0.0 ) );\n#ifdef DOUBLE_SIDED\nvec3 pointLightWeightingBack = vec3( max( -dotProduct, 0.0 ) );\n#ifdef WRAP_AROUND\nvec3 pointLightWeightingHalfBack = vec3( max( -0.5 * dotProduct + 0.5, 0.0 ) );\n#endif\n#endif\n#ifdef WRAP_AROUND\nvec3 pointLightWeightingHalf = vec3( max( 0.5 * dotProduct + 0.5, 0.0 ) );\npointLightWeighting = mix( pointLightWeighting, pointLightWeightingHalf, wrapRGB );\n#ifdef DOUBLE_SIDED\npointLightWeightingBack = mix( pointLightWeightingBack, pointLightWeightingHalfBack, wrapRGB );\n#endif\n#endif\nvLightFront += pointLightColor[ i ] * pointLightWeighting * lDistance;\n#ifdef DOUBLE_SIDED\nvLightBack += pointLightColor[ i ] * pointLightWeightingBack * lDistance;\n#endif\n}\n#endif\n#if MAX_SPOT_LIGHTS > 0\nfor( int i = 0; i < MAX_SPOT_LIGHTS; i ++ ) {\nvec4 lPosition = viewMatrix * vec4( spotLightPosition[ i ], 1.0 );\nvec3 lVector = lPosition.xyz - mvPosition.xyz;\nfloat spotEffect = dot( spotLightDirection[ i ], normalize( spotLightPosition[ i ] - worldPosition.xyz ) );\nif ( spotEffect > spotLightAngleCos[ i ] ) {\nspotEffect = max( pow( spotEffect, spotLightExponent[ i ] ), 0.0 );\nfloat lDistance = 1.0;\nif ( spotLightDistance[ i ] > 0.0 )\nlDistance = 1.0 - min( ( length( lVector ) / spotLightDistance[ i ] ), 1.0 );\nlVector = normalize( lVector );\nfloat dotProduct = dot( transformedNormal, lVector );\nvec3 spotLightWeighting = vec3( max( dotProduct, 0.0 ) );\n#ifdef DOUBLE_SIDED\nvec3 spotLightWeightingBack = vec3( max( -dotProduct, 0.0 ) );\n#ifdef WRAP_AROUND\nvec3 spotLightWeightingHalfBack = vec3( max( -0.5 * dotProduct + 0.5, 0.0 ) );\n#endif\n#endif\n#ifdef WRAP_AROUND\nvec3 spotLightWeightingHalf = vec3( max( 0.5 * dotProduct + 0.5, 0.0 ) );\nspotLightWeighting = mix( spotLightWeighting, spotLightWeightingHalf, wrapRGB );\n#ifdef DOUBLE_SIDED\nspotLightWeightingBack = mix( spotLightWeightingBack, spotLightWeightingHalfBack, wrapRGB );\n#endif\n#endif\nvLightFront += spotLightColor[ i ] * spotLightWeighting * lDistance * spotEffect;\n#ifdef DOUBLE_SIDED\nvLightBack += spotLightColor[ i ] * spotLightWeightingBack * lDistance * spotEffect;\n#endif\n}\n}\n#endif\n#if MAX_HEMI_LIGHTS > 0\nfor( int i = 0; i < MAX_HEMI_LIGHTS; i ++ ) {\nvec4 lDirection = viewMatrix * vec4( hemisphereLightDirection[ i ], 0.0 );\nvec3 lVector = normalize( lDirection.xyz );\nfloat dotProduct = dot( transformedNormal, lVector );\nfloat hemiDiffuseWeight = 0.5 * dotProduct + 0.5;\nfloat hemiDiffuseWeightBack = -0.5 * dotProduct + 0.5;\nvLightFront += mix( hemisphereLightGroundColor[ i ], hemisphereLightSkyColor[ i ], hemiDiffuseWeight );\n#ifdef DOUBLE_SIDED\nvLightBack += mix( hemisphereLightGroundColor[ i ], hemisphereLightSkyColor[ i ], hemiDiffuseWeightBack );\n#endif\n}\n#endif\nvLightFront = vLightFront * diffuse + ambient * ambientLightColor + emissive;\n#ifdef DOUBLE_SIDED\nvLightBack = vLightBack * diffuse + ambient * ambientLightColor + emissive;\n#endif",
	lights_phong_pars_vertex: "#ifndef PHONG_PER_PIXEL\n#if MAX_POINT_LIGHTS > 0\nuniform vec3 pointLightPosition[ MAX_POINT_LIGHTS ];\nuniform float pointLightDistance[ MAX_POINT_LIGHTS ];\nvarying vec4 vPointLight[ MAX_POINT_LIGHTS ];\n#endif\n#if MAX_SPOT_LIGHTS > 0\nuniform vec3 spotLightPosition[ MAX_SPOT_LIGHTS ];\nuniform float spotLightDistance[ MAX_SPOT_LIGHTS ];\nvarying vec4 vSpotLight[ MAX_SPOT_LIGHTS ];\n#endif\n#endif\n#if MAX_SPOT_LIGHTS > 0 || defined( USE_BUMPMAP )\nvarying vec3 vWorldPosition;\n#endif",
	lights_phong_vertex: "#ifndef PHONG_PER_PIXEL\n#if MAX_POINT_LIGHTS > 0\nfor( int i = 0; i < MAX_POINT_LIGHTS; i ++ ) {\nvec4 lPosition = viewMatrix * vec4( pointLightPosition[ i ], 1.0 );\nvec3 lVector = lPosition.xyz - mvPosition.xyz;\nfloat lDistance = 1.0;\nif ( pointLightDistance[ i ] > 0.0 )\nlDistance = 1.0 - min( ( length( lVector ) / pointLightDistance[ i ] ), 1.0 );\nvPointLight[ i ] = vec4( lVector, lDistance );\n}\n#endif\n#if MAX_SPOT_LIGHTS > 0\nfor( int i = 0; i < MAX_SPOT_LIGHTS; i ++ ) {\nvec4 lPosition = viewMatrix * vec4( spotLightPosition[ i ], 1.0 );\nvec3 lVector = lPosition.xyz - mvPosition.xyz;\nfloat lDistance = 1.0;\nif ( spotLightDistance[ i ] > 0.0 )\nlDistance = 1.0 - min( ( length( lVector ) / spotLightDistance[ i ] ), 1.0 );\nvSpotLight[ i ] = vec4( lVector, lDistance );\n}\n#endif\n#endif\n#if MAX_SPOT_LIGHTS > 0 || defined( USE_BUMPMAP )\nvWorldPosition = worldPosition.xyz;\n#endif",
	lights_phong_pars_fragment: "uniform vec3 ambientLightColor;\n#if MAX_DIR_LIGHTS > 0\nuniform vec3 directionalLightColor[ MAX_DIR_LIGHTS ];\nuniform vec3 directionalLightDirection[ MAX_DIR_LIGHTS ];\n#endif\n#if MAX_HEMI_LIGHTS > 0\nuniform vec3 hemisphereLightSkyColor[ MAX_HEMI_LIGHTS ];\nuniform vec3 hemisphereLightGroundColor[ MAX_HEMI_LIGHTS ];\nuniform vec3 hemisphereLightDirection[ MAX_HEMI_LIGHTS ];\n#endif\n#if MAX_POINT_LIGHTS > 0\nuniform vec3 pointLightColor[ MAX_POINT_LIGHTS ];\n#ifdef PHONG_PER_PIXEL\nuniform vec3 pointLightPosition[ MAX_POINT_LIGHTS ];\nuniform float pointLightDistance[ MAX_POINT_LIGHTS ];\n#else\nvarying vec4 vPointLight[ MAX_POINT_LIGHTS ];\n#endif\n#endif\n#if MAX_SPOT_LIGHTS > 0\nuniform vec3 spotLightColor[ MAX_SPOT_LIGHTS ];\nuniform vec3 spotLightPosition[ MAX_SPOT_LIGHTS ];\nuniform vec3 spotLightDirection[ MAX_SPOT_LIGHTS ];\nuniform float spotLightAngleCos[ MAX_SPOT_LIGHTS ];\nuniform float spotLightExponent[ MAX_SPOT_LIGHTS ];\n#ifdef PHONG_PER_PIXEL\nuniform float spotLightDistance[ MAX_SPOT_LIGHTS ];\n#else\nvarying vec4 vSpotLight[ MAX_SPOT_LIGHTS ];\n#endif\n#endif\n#if MAX_SPOT_LIGHTS > 0 || defined( USE_BUMPMAP )\nvarying vec3 vWorldPosition;\n#endif\n#ifdef WRAP_AROUND\nuniform vec3 wrapRGB;\n#endif\nvarying vec3 vViewPosition;\nvarying vec3 vNormal;",
	lights_phong_fragment: "vec3 normal = normalize( vNormal );\nvec3 viewPosition = normalize( vViewPosition );\n#ifdef DOUBLE_SIDED\nnormal = normal * ( -1.0 + 2.0 * float( gl_FrontFacing ) );\n#endif\n#ifdef USE_NORMALMAP\nnormal = perturbNormal2Arb( -viewPosition, normal );\n#elif defined( USE_BUMPMAP )\nnormal = perturbNormalArb( -vViewPosition, normal, dHdxy_fwd() );\n#endif\n#if MAX_POINT_LIGHTS > 0\nvec3 pointDiffuse  = vec3( 0.0 );\nvec3 pointSpecular = vec3( 0.0 );\nfor ( int i = 0; i < MAX_POINT_LIGHTS; i ++ ) {\n#ifdef PHONG_PER_PIXEL\nvec4 lPosition = viewMatrix * vec4( pointLightPosition[ i ], 1.0 );\nvec3 lVector = lPosition.xyz + vViewPosition.xyz;\nfloat lDistance = 1.0;\nif ( pointLightDistance[ i ] > 0.0 )\nlDistance = 1.0 - min( ( length( lVector ) / pointLightDistance[ i ] ), 1.0 );\nlVector = normalize( lVector );\n#else\nvec3 lVector = normalize( vPointLight[ i ].xyz );\nfloat lDistance = vPointLight[ i ].w;\n#endif\nfloat dotProduct = dot( normal, lVector );\n#ifdef WRAP_AROUND\nfloat pointDiffuseWeightFull = max( dotProduct, 0.0 );\nfloat pointDiffuseWeightHalf = max( 0.5 * dotProduct + 0.5, 0.0 );\nvec3 pointDiffuseWeight = mix( vec3 ( pointDiffuseWeightFull ), vec3( pointDiffuseWeightHalf ), wrapRGB );\n#else\nfloat pointDiffuseWeight = max( dotProduct, 0.0 );\n#endif\npointDiffuse  += diffuse * pointLightColor[ i ] * pointDiffuseWeight * lDistance;\nvec3 pointHalfVector = normalize( lVector + viewPosition );\nfloat pointDotNormalHalf = max( dot( normal, pointHalfVector ), 0.0 );\nfloat pointSpecularWeight = specularStrength * max( pow( pointDotNormalHalf, shininess ), 0.0 );\n#ifdef PHYSICALLY_BASED_SHADING\nfloat specularNormalization = ( shininess + 2.0001 ) / 8.0;\nvec3 schlick = specular + vec3( 1.0 - specular ) * pow( 1.0 - dot( lVector, pointHalfVector ), 5.0 );\npointSpecular += schlick * pointLightColor[ i ] * pointSpecularWeight * pointDiffuseWeight * lDistance * specularNormalization;\n#else\npointSpecular += specular * pointLightColor[ i ] * pointSpecularWeight * pointDiffuseWeight * lDistance;\n#endif\n}\n#endif\n#if MAX_SPOT_LIGHTS > 0\nvec3 spotDiffuse  = vec3( 0.0 );\nvec3 spotSpecular = vec3( 0.0 );\nfor ( int i = 0; i < MAX_SPOT_LIGHTS; i ++ ) {\n#ifdef PHONG_PER_PIXEL\nvec4 lPosition = viewMatrix * vec4( spotLightPosition[ i ], 1.0 );\nvec3 lVector = lPosition.xyz + vViewPosition.xyz;\nfloat lDistance = 1.0;\nif ( spotLightDistance[ i ] > 0.0 )\nlDistance = 1.0 - min( ( length( lVector ) / spotLightDistance[ i ] ), 1.0 );\nlVector = normalize( lVector );\n#else\nvec3 lVector = normalize( vSpotLight[ i ].xyz );\nfloat lDistance = vSpotLight[ i ].w;\n#endif\nfloat spotEffect = dot( spotLightDirection[ i ], normalize( spotLightPosition[ i ] - vWorldPosition ) );\nif ( spotEffect > spotLightAngleCos[ i ] ) {\nspotEffect = max( pow( spotEffect, spotLightExponent[ i ] ), 0.0 );\nfloat dotProduct = dot( normal, lVector );\n#ifdef WRAP_AROUND\nfloat spotDiffuseWeightFull = max( dotProduct, 0.0 );\nfloat spotDiffuseWeightHalf = max( 0.5 * dotProduct + 0.5, 0.0 );\nvec3 spotDiffuseWeight = mix( vec3 ( spotDiffuseWeightFull ), vec3( spotDiffuseWeightHalf ), wrapRGB );\n#else\nfloat spotDiffuseWeight = max( dotProduct, 0.0 );\n#endif\nspotDiffuse += diffuse * spotLightColor[ i ] * spotDiffuseWeight * lDistance * spotEffect;\nvec3 spotHalfVector = normalize( lVector + viewPosition );\nfloat spotDotNormalHalf = max( dot( normal, spotHalfVector ), 0.0 );\nfloat spotSpecularWeight = specularStrength * max( pow( spotDotNormalHalf, shininess ), 0.0 );\n#ifdef PHYSICALLY_BASED_SHADING\nfloat specularNormalization = ( shininess + 2.0001 ) / 8.0;\nvec3 schlick = specular + vec3( 1.0 - specular ) * pow( 1.0 - dot( lVector, spotHalfVector ), 5.0 );\nspotSpecular += schlick * spotLightColor[ i ] * spotSpecularWeight * spotDiffuseWeight * lDistance * specularNormalization * spotEffect;\n#else\nspotSpecular += specular * spotLightColor[ i ] * spotSpecularWeight * spotDiffuseWeight * lDistance * spotEffect;\n#endif\n}\n}\n#endif\n#if MAX_DIR_LIGHTS > 0\nvec3 dirDiffuse  = vec3( 0.0 );\nvec3 dirSpecular = vec3( 0.0 );\nfor( int i = 0; i < MAX_DIR_LIGHTS; i ++ ) {\nvec4 lDirection = viewMatrix * vec4( directionalLightDirection[ i ], 0.0 );\nvec3 dirVector = normalize( lDirection.xyz );\nfloat dotProduct = dot( normal, dirVector );\n#ifdef WRAP_AROUND\nfloat dirDiffuseWeightFull = max( dotProduct, 0.0 );\nfloat dirDiffuseWeightHalf = max( 0.5 * dotProduct + 0.5, 0.0 );\nvec3 dirDiffuseWeight = mix( vec3( dirDiffuseWeightFull ), vec3( dirDiffuseWeightHalf ), wrapRGB );\n#else\nfloat dirDiffuseWeight = max( dotProduct, 0.0 );\n#endif\ndirDiffuse  += diffuse * directionalLightColor[ i ] * dirDiffuseWeight;\nvec3 dirHalfVector = normalize( dirVector + viewPosition );\nfloat dirDotNormalHalf = max( dot( normal, dirHalfVector ), 0.0 );\nfloat dirSpecularWeight = specularStrength * max( pow( dirDotNormalHalf, shininess ), 0.0 );\n#ifdef PHYSICALLY_BASED_SHADING\nfloat specularNormalization = ( shininess + 2.0001 ) / 8.0;\nvec3 schlick = specular + vec3( 1.0 - specular ) * pow( 1.0 - dot( dirVector, dirHalfVector ), 5.0 );\ndirSpecular += schlick * directionalLightColor[ i ] * dirSpecularWeight * dirDiffuseWeight * specularNormalization;\n#else\ndirSpecular += specular * directionalLightColor[ i ] * dirSpecularWeight * dirDiffuseWeight;\n#endif\n}\n#endif\n#if MAX_HEMI_LIGHTS > 0\nvec3 hemiDiffuse  = vec3( 0.0 );\nvec3 hemiSpecular = vec3( 0.0 );\nfor( int i = 0; i < MAX_HEMI_LIGHTS; i ++ ) {\nvec4 lDirection = viewMatrix * vec4( hemisphereLightDirection[ i ], 0.0 );\nvec3 lVector = normalize( lDirection.xyz );\nfloat dotProduct = dot( normal, lVector );\nfloat hemiDiffuseWeight = 0.5 * dotProduct + 0.5;\nvec3 hemiColor = mix( hemisphereLightGroundColor[ i ], hemisphereLightSkyColor[ i ], hemiDiffuseWeight );\nhemiDiffuse += diffuse * hemiColor;\nvec3 hemiHalfVectorSky = normalize( lVector + viewPosition );\nfloat hemiDotNormalHalfSky = 0.5 * dot( normal, hemiHalfVectorSky ) + 0.5;\nfloat hemiSpecularWeightSky = specularStrength * max( pow( hemiDotNormalHalfSky, shininess ), 0.0 );\nvec3 lVectorGround = -lVector;\nvec3 hemiHalfVectorGround = normalize( lVectorGround + viewPosition );\nfloat hemiDotNormalHalfGround = 0.5 * dot( normal, hemiHalfVectorGround ) + 0.5;\nfloat hemiSpecularWeightGround = specularStrength * max( pow( hemiDotNormalHalfGround, shininess ), 0.0 );\n#ifdef PHYSICALLY_BASED_SHADING\nfloat dotProductGround = dot( normal, lVectorGround );\nfloat specularNormalization = ( shininess + 2.0001 ) / 8.0;\nvec3 schlickSky = specular + vec3( 1.0 - specular ) * pow( 1.0 - dot( lVector, hemiHalfVectorSky ), 5.0 );\nvec3 schlickGround = specular + vec3( 1.0 - specular ) * pow( 1.0 - dot( lVectorGround, hemiHalfVectorGround ), 5.0 );\nhemiSpecular += hemiColor * specularNormalization * ( schlickSky * hemiSpecularWeightSky * max( dotProduct, 0.0 ) + schlickGround * hemiSpecularWeightGround * max( dotProductGround, 0.0 ) );\n#else\nhemiSpecular += specular * hemiColor * ( hemiSpecularWeightSky + hemiSpecularWeightGround ) * hemiDiffuseWeight;\n#endif\n}\n#endif\nvec3 totalDiffuse = vec3( 0.0 );\nvec3 totalSpecular = vec3( 0.0 );\n#if MAX_DIR_LIGHTS > 0\ntotalDiffuse += dirDiffuse;\ntotalSpecular += dirSpecular;\n#endif\n#if MAX_HEMI_LIGHTS > 0\ntotalDiffuse += hemiDiffuse;\ntotalSpecular += hemiSpecular;\n#endif\n#if MAX_POINT_LIGHTS > 0\ntotalDiffuse += pointDiffuse;\ntotalSpecular += pointSpecular;\n#endif\n#if MAX_SPOT_LIGHTS > 0\ntotalDiffuse += spotDiffuse;\ntotalSpecular += spotSpecular;\n#endif\n#ifdef METAL\ngl_FragColor.xyz = gl_FragColor.xyz * ( emissive + totalDiffuse + ambientLightColor * ambient + totalSpecular );\n#else\ngl_FragColor.xyz = gl_FragColor.xyz * ( emissive + totalDiffuse + ambientLightColor * ambient ) + totalSpecular;\n#endif",
	color_pars_fragment: "#ifdef USE_COLOR\nvarying vec3 vColor;\n#endif",
	color_fragment: "#ifdef USE_COLOR\ngl_FragColor = gl_FragColor * vec4( vColor, opacity );\n#endif",
	color_pars_vertex: "#ifdef USE_COLOR\nvarying vec3 vColor;\n#endif",
	color_vertex: "#ifdef USE_COLOR\n#ifdef GAMMA_INPUT\nvColor = color * color;\n#else\nvColor = color;\n#endif\n#endif",
	skinning_pars_vertex: "#ifdef USE_SKINNING\n#ifdef BONE_TEXTURE\nuniform sampler2D boneTexture;\nmat4 getBoneMatrix( const in float i ) {\nfloat j = i * 4.0;\nfloat x = mod( j, N_BONE_PIXEL_X );\nfloat y = floor( j / N_BONE_PIXEL_X );\nconst float dx = 1.0 / N_BONE_PIXEL_X;\nconst float dy = 1.0 / N_BONE_PIXEL_Y;\ny = dy * ( y + 0.5 );\nvec4 v1 = texture2D( boneTexture, vec2( dx * ( x + 0.5 ), y ) );\nvec4 v2 = texture2D( boneTexture, vec2( dx * ( x + 1.5 ), y ) );\nvec4 v3 = texture2D( boneTexture, vec2( dx * ( x + 2.5 ), y ) );\nvec4 v4 = texture2D( boneTexture, vec2( dx * ( x + 3.5 ), y ) );\nmat4 bone = mat4( v1, v2, v3, v4 );\nreturn bone;\n}\n#else\nuniform mat4 boneGlobalMatrices[ MAX_BONES ];\nmat4 getBoneMatrix( const in float i ) {\nmat4 bone = boneGlobalMatrices[ int(i) ];\nreturn bone;\n}\n#endif\n#endif",
	skinbase_vertex: "#ifdef USE_SKINNING\nmat4 boneMatX = getBoneMatrix( skinIndex.x );\nmat4 boneMatY = getBoneMatrix( skinIndex.y );\n#endif",
	skinning_vertex: "#ifdef USE_SKINNING\n#ifdef USE_MORPHTARGETS\nvec4 skinVertex = vec4( morphed, 1.0 );\n#else\nvec4 skinVertex = vec4( position, 1.0 );\n#endif\nvec4 skinned  = boneMatX * skinVertex * skinWeight.x;\nskinned \t  += boneMatY * skinVertex * skinWeight.y;\n#endif",
	morphtarget_pars_vertex: "#ifdef USE_MORPHTARGETS\n#ifndef USE_MORPHNORMALS\nuniform float morphTargetInfluences[ 8 ];\n#else\nuniform float morphTargetInfluences[ 4 ];\n#endif\n#endif",
	morphtarget_vertex: "#ifdef USE_MORPHTARGETS\nvec3 morphed = vec3( 0.0 );\nmorphed += ( morphTarget0 - position ) * morphTargetInfluences[ 0 ];\nmorphed += ( morphTarget1 - position ) * morphTargetInfluences[ 1 ];\nmorphed += ( morphTarget2 - position ) * morphTargetInfluences[ 2 ];\nmorphed += ( morphTarget3 - position ) * morphTargetInfluences[ 3 ];\n#ifndef USE_MORPHNORMALS\nmorphed += ( morphTarget4 - position ) * morphTargetInfluences[ 4 ];\nmorphed += ( morphTarget5 - position ) * morphTargetInfluences[ 5 ];\nmorphed += ( morphTarget6 - position ) * morphTargetInfluences[ 6 ];\nmorphed += ( morphTarget7 - position ) * morphTargetInfluences[ 7 ];\n#endif\nmorphed += position;\n#endif",
	default_vertex: "vec4 mvPosition;\n#ifdef USE_SKINNING\nmvPosition = modelViewMatrix * skinned;\n#endif\n#if !defined( USE_SKINNING ) && defined( USE_MORPHTARGETS )\nmvPosition = modelViewMatrix * vec4( morphed, 1.0 );\n#endif\n#if !defined( USE_SKINNING ) && ! defined( USE_MORPHTARGETS )\nmvPosition = modelViewMatrix * vec4( position, 1.0 );\n#endif\ngl_Position = projectionMatrix * mvPosition;",
	morphnormal_vertex: "#ifdef USE_MORPHNORMALS\nvec3 morphedNormal = vec3( 0.0 );\nmorphedNormal +=  ( morphNormal0 - normal ) * morphTargetInfluences[ 0 ];\nmorphedNormal +=  ( morphNormal1 - normal ) * morphTargetInfluences[ 1 ];\nmorphedNormal +=  ( morphNormal2 - normal ) * morphTargetInfluences[ 2 ];\nmorphedNormal +=  ( morphNormal3 - normal ) * morphTargetInfluences[ 3 ];\nmorphedNormal += normal;\n#endif",
	skinnormal_vertex: "#ifdef USE_SKINNING\nmat4 skinMatrix = skinWeight.x * boneMatX;\nskinMatrix \t+= skinWeight.y * boneMatY;\n#ifdef USE_MORPHNORMALS\nvec4 skinnedNormal = skinMatrix * vec4( morphedNormal, 0.0 );\n#else\nvec4 skinnedNormal = skinMatrix * vec4( normal, 0.0 );\n#endif\n#endif",
	defaultnormal_vertex: "vec3 objectNormal;\n#ifdef USE_SKINNING\nobjectNormal = skinnedNormal.xyz;\n#endif\n#if !defined( USE_SKINNING ) && defined( USE_MORPHNORMALS )\nobjectNormal = morphedNormal;\n#endif\n#if !defined( USE_SKINNING ) && ! defined( USE_MORPHNORMALS )\nobjectNormal = normal;\n#endif\n#ifdef FLIP_SIDED\nobjectNormal = -objectNormal;\n#endif\nvec3 transformedNormal = normalMatrix * objectNormal;",
	shadowmap_pars_fragment: "#ifdef USE_SHADOWMAP\nuniform sampler2D shadowMap[ MAX_SHADOWS ];\nuniform vec2 shadowMapSize[ MAX_SHADOWS ];\nuniform float shadowDarkness[ MAX_SHADOWS ];\nuniform float shadowBias[ MAX_SHADOWS ];\nvarying vec4 vShadowCoord[ MAX_SHADOWS ];\nfloat unpackDepth( const in vec4 rgba_depth ) {\nconst vec4 bit_shift = vec4( 1.0 / ( 256.0 * 256.0 * 256.0 ), 1.0 / ( 256.0 * 256.0 ), 1.0 / 256.0, 1.0 );\nfloat depth = dot( rgba_depth, bit_shift );\nreturn depth;\n}\n#endif",
	shadowmap_fragment: "#ifdef USE_SHADOWMAP\n#ifdef SHADOWMAP_DEBUG\nvec3 frustumColors[3];\nfrustumColors[0] = vec3( 1.0, 0.5, 0.0 );\nfrustumColors[1] = vec3( 0.0, 1.0, 0.8 );\nfrustumColors[2] = vec3( 0.0, 0.5, 1.0 );\n#endif\n#ifdef SHADOWMAP_CASCADE\nint inFrustumCount = 0;\n#endif\nfloat fDepth;\nvec3 shadowColor = vec3( 1.0 );\nfor( int i = 0; i < MAX_SHADOWS; i ++ ) {\nvec3 shadowCoord = vShadowCoord[ i ].xyz / vShadowCoord[ i ].w;\nbvec4 inFrustumVec = bvec4 ( shadowCoord.x >= 0.0, shadowCoord.x <= 1.0, shadowCoord.y >= 0.0, shadowCoord.y <= 1.0 );\nbool inFrustum = all( inFrustumVec );\n#ifdef SHADOWMAP_CASCADE\ninFrustumCount += int( inFrustum );\nbvec3 frustumTestVec = bvec3( inFrustum, inFrustumCount == 1, shadowCoord.z <= 1.0 );\n#else\nbvec2 frustumTestVec = bvec2( inFrustum, shadowCoord.z <= 1.0 );\n#endif\nbool frustumTest = all( frustumTestVec );\nif ( frustumTest ) {\nshadowCoord.z += shadowBias[ i ];\n#if defined( SHADOWMAP_TYPE_PCF )\nfloat shadow = 0.0;\nconst float shadowDelta = 1.0 / 9.0;\nfloat xPixelOffset = 1.0 / shadowMapSize[ i ].x;\nfloat yPixelOffset = 1.0 / shadowMapSize[ i ].y;\nfloat dx0 = -1.25 * xPixelOffset;\nfloat dy0 = -1.25 * yPixelOffset;\nfloat dx1 = 1.25 * xPixelOffset;\nfloat dy1 = 1.25 * yPixelOffset;\nfDepth = unpackDepth( texture2D( shadowMap[ i ], shadowCoord.xy + vec2( dx0, dy0 ) ) );\nif ( fDepth < shadowCoord.z ) shadow += shadowDelta;\nfDepth = unpackDepth( texture2D( shadowMap[ i ], shadowCoord.xy + vec2( 0.0, dy0 ) ) );\nif ( fDepth < shadowCoord.z ) shadow += shadowDelta;\nfDepth = unpackDepth( texture2D( shadowMap[ i ], shadowCoord.xy + vec2( dx1, dy0 ) ) );\nif ( fDepth < shadowCoord.z ) shadow += shadowDelta;\nfDepth = unpackDepth( texture2D( shadowMap[ i ], shadowCoord.xy + vec2( dx0, 0.0 ) ) );\nif ( fDepth < shadowCoord.z ) shadow += shadowDelta;\nfDepth = unpackDepth( texture2D( shadowMap[ i ], shadowCoord.xy ) );\nif ( fDepth < shadowCoord.z ) shadow += shadowDelta;\nfDepth = unpackDepth( texture2D( shadowMap[ i ], shadowCoord.xy + vec2( dx1, 0.0 ) ) );\nif ( fDepth < shadowCoord.z ) shadow += shadowDelta;\nfDepth = unpackDepth( texture2D( shadowMap[ i ], shadowCoord.xy + vec2( dx0, dy1 ) ) );\nif ( fDepth < shadowCoord.z ) shadow += shadowDelta;\nfDepth = unpackDepth( texture2D( shadowMap[ i ], shadowCoord.xy + vec2( 0.0, dy1 ) ) );\nif ( fDepth < shadowCoord.z ) shadow += shadowDelta;\nfDepth = unpackDepth( texture2D( shadowMap[ i ], shadowCoord.xy + vec2( dx1, dy1 ) ) );\nif ( fDepth < shadowCoord.z ) shadow += shadowDelta;\nshadowColor = shadowColor * vec3( ( 1.0 - shadowDarkness[ i ] * shadow ) );\n#elif defined( SHADOWMAP_TYPE_PCF_SOFT )\nfloat shadow = 0.0;\nfloat xPixelOffset = 1.0 / shadowMapSize[ i ].x;\nfloat yPixelOffset = 1.0 / shadowMapSize[ i ].y;\nfloat dx0 = -1.0 * xPixelOffset;\nfloat dy0 = -1.0 * yPixelOffset;\nfloat dx1 = 1.0 * xPixelOffset;\nfloat dy1 = 1.0 * yPixelOffset;\nmat3 shadowKernel;\nmat3 depthKernel;\ndepthKernel[0][0] = unpackDepth( texture2D( shadowMap[ i ], shadowCoord.xy + vec2( dx0, dy0 ) ) );\nif ( depthKernel[0][0] < shadowCoord.z ) shadowKernel[0][0] = 0.25;\nelse shadowKernel[0][0] = 0.0;\ndepthKernel[0][1] = unpackDepth( texture2D( shadowMap[ i ], shadowCoord.xy + vec2( dx0, 0.0 ) ) );\nif ( depthKernel[0][1] < shadowCoord.z ) shadowKernel[0][1] = 0.25;\nelse shadowKernel[0][1] = 0.0;\ndepthKernel[0][2] = unpackDepth( texture2D( shadowMap[ i ], shadowCoord.xy + vec2( dx0, dy1 ) ) );\nif ( depthKernel[0][2] < shadowCoord.z ) shadowKernel[0][2] = 0.25;\nelse shadowKernel[0][2] = 0.0;\ndepthKernel[1][0] = unpackDepth( texture2D( shadowMap[ i ], shadowCoord.xy + vec2( 0.0, dy0 ) ) );\nif ( depthKernel[1][0] < shadowCoord.z ) shadowKernel[1][0] = 0.25;\nelse shadowKernel[1][0] = 0.0;\ndepthKernel[1][1] = unpackDepth( texture2D( shadowMap[ i ], shadowCoord.xy ) );\nif ( depthKernel[1][1] < shadowCoord.z ) shadowKernel[1][1] = 0.25;\nelse shadowKernel[1][1] = 0.0;\ndepthKernel[1][2] = unpackDepth( texture2D( shadowMap[ i ], shadowCoord.xy + vec2( 0.0, dy1 ) ) );\nif ( depthKernel[1][2] < shadowCoord.z ) shadowKernel[1][2] = 0.25;\nelse shadowKernel[1][2] = 0.0;\ndepthKernel[2][0] = unpackDepth( texture2D( shadowMap[ i ], shadowCoord.xy + vec2( dx1, dy0 ) ) );\nif ( depthKernel[2][0] < shadowCoord.z ) shadowKernel[2][0] = 0.25;\nelse shadowKernel[2][0] = 0.0;\ndepthKernel[2][1] = unpackDepth( texture2D( shadowMap[ i ], shadowCoord.xy + vec2( dx1, 0.0 ) ) );\nif ( depthKernel[2][1] < shadowCoord.z ) shadowKernel[2][1] = 0.25;\nelse shadowKernel[2][1] = 0.0;\ndepthKernel[2][2] = unpackDepth( texture2D( shadowMap[ i ], shadowCoord.xy + vec2( dx1, dy1 ) ) );\nif ( depthKernel[2][2] < shadowCoord.z ) shadowKernel[2][2] = 0.25;\nelse shadowKernel[2][2] = 0.0;\nvec2 fractionalCoord = 1.0 - fract( shadowCoord.xy * shadowMapSize[i].xy );\nshadowKernel[0] = mix( shadowKernel[1], shadowKernel[0], fractionalCoord.x );\nshadowKernel[1] = mix( shadowKernel[2], shadowKernel[1], fractionalCoord.x );\nvec4 shadowValues;\nshadowValues.x = mix( shadowKernel[0][1], shadowKernel[0][0], fractionalCoord.y );\nshadowValues.y = mix( shadowKernel[0][2], shadowKernel[0][1], fractionalCoord.y );\nshadowValues.z = mix( shadowKernel[1][1], shadowKernel[1][0], fractionalCoord.y );\nshadowValues.w = mix( shadowKernel[1][2], shadowKernel[1][1], fractionalCoord.y );\nshadow = dot( shadowValues, vec4( 1.0 ) );\nshadowColor = shadowColor * vec3( ( 1.0 - shadowDarkness[ i ] * shadow ) );\n#else\nvec4 rgbaDepth = texture2D( shadowMap[ i ], shadowCoord.xy );\nfloat fDepth = unpackDepth( rgbaDepth );\nif ( fDepth < shadowCoord.z )\nshadowColor = shadowColor * vec3( 1.0 - shadowDarkness[ i ] );\n#endif\n}\n#ifdef SHADOWMAP_DEBUG\n#ifdef SHADOWMAP_CASCADE\nif ( inFrustum && inFrustumCount == 1 ) gl_FragColor.xyz *= frustumColors[ i ];\n#else\nif ( inFrustum ) gl_FragColor.xyz *= frustumColors[ i ];\n#endif\n#endif\n}\n#ifdef GAMMA_OUTPUT\nshadowColor *= shadowColor;\n#endif\ngl_FragColor.xyz = gl_FragColor.xyz * shadowColor;\n#endif",
	shadowmap_pars_vertex: "#ifdef USE_SHADOWMAP\nvarying vec4 vShadowCoord[ MAX_SHADOWS ];\nuniform mat4 shadowMatrix[ MAX_SHADOWS ];\n#endif",
	shadowmap_vertex: "#ifdef USE_SHADOWMAP\nfor( int i = 0; i < MAX_SHADOWS; i ++ ) {\nvShadowCoord[ i ] = shadowMatrix[ i ] * worldPosition;\n}\n#endif",
	alphatest_fragment: "#ifdef ALPHATEST\nif ( gl_FragColor.a < ALPHATEST ) discard;\n#endif",
	linear_to_gamma_fragment: "#ifdef GAMMA_OUTPUT\ngl_FragColor.xyz = sqrt( gl_FragColor.xyz );\n#endif"
};
THREE.UniformsUtils = {
	merge: function (a) {
		var b, c, d, e = {};
		for (b = 0; b < a.length; b++) for (c in d = this.clone(a[b]), d) e[c] = d[c];
		return e
	},
	clone: function (a) {
		var b, c, d, e = {};
		for (b in a) for (c in e[b] = {}, a[b]) d = a[b][c], e[b][c] = d instanceof THREE.Color || d instanceof THREE.Vector2 || d instanceof THREE.Vector3 || d instanceof THREE.Vector4 || d instanceof THREE.Matrix4 || d instanceof THREE.Texture ? d.clone() : d instanceof Array ? d.slice() : d;
		return e
	}
};
THREE.UniformsLib = {
	common: {
		diffuse: {
			type: "c",
			value: new THREE.Color(15658734)
		},
		opacity: {
			type: "f",
			value: 1
		},
		map: {
			type: "t",
			value: null
		},
		offsetRepeat: {
			type: "v4",
			value: new THREE.Vector4(0, 0, 1, 1)
		},
		lightMap: {
			type: "t",
			value: null
		},
		specularMap: {
			type: "t",
			value: null
		},
		envMap: {
			type: "t",
			value: null
		},
		flipEnvMap: {
			type: "f",
			value: -1
		},
		useRefract: {
			type: "i",
			value: 0
		},
		reflectivity: {
			type: "f",
			value: 1
		},
		refractionRatio: {
			type: "f",
			value: 0.98
		},
		combine: {
			type: "i",
			value: 0
		},
		morphTargetInfluences: {
			type: "f",
			value: 0
		}
	},
	bump: {
		bumpMap: {
			type: "t",
			value: null
		},
		bumpScale: {
			type: "f",
			value: 1
		}
	},
	normalmap: {
		normalMap: {
			type: "t",
			value: null
		},
		normalScale: {
			type: "v2",
			value: new THREE.Vector2(1, 1)
		}
	},
	fog: {
		fogDensity: {
			type: "f",
			value: 2.5E-4
		},
		fogNear: {
			type: "f",
			value: 1
		},
		fogFar: {
			type: "f",
			value: 2E3
		},
		fogColor: {
			type: "c",
			value: new THREE.Color(16777215)
		}
	},
	lights: {
		ambientLightColor: {
			type: "fv",
			value: []
		},
		directionalLightDirection: {
			type: "fv",
			value: []
		},
		directionalLightColor: {
			type: "fv",
			value: []
		},
		hemisphereLightDirection: {
			type: "fv",
			value: []
		},
		hemisphereLightSkyColor: {
			type: "fv",
			value: []
		},
		hemisphereLightGroundColor: {
			type: "fv",
			value: []
		},
		pointLightColor: {
			type: "fv",
			value: []
		},
		pointLightPosition: {
			type: "fv",
			value: []
		},
		pointLightDistance: {
			type: "fv1",
			value: []
		},
		spotLightColor: {
			type: "fv",
			value: []
		},
		spotLightPosition: {
			type: "fv",
			value: []
		},
		spotLightDirection: {
			type: "fv",
			value: []
		},
		spotLightDistance: {
			type: "fv1",
			value: []
		},
		spotLightAngleCos: {
			type: "fv1",
			value: []
		},
		spotLightExponent: {
			type: "fv1",
			value: []
		}
	},
	particle: {
		psColor: {
			type: "c",
			value: new THREE.Color(15658734)
		},
		opacity: {
			type: "f",
			value: 1
		},
		size: {
			type: "f",
			value: 1
		},
		scale: {
			type: "f",
			value: 1
		},
		map: {
			type: "t",
			value: null
		},
		fogDensity: {
			type: "f",
			value: 2.5E-4
		},
		fogNear: {
			type: "f",
			value: 1
		},
		fogFar: {
			type: "f",
			value: 2E3
		},
		fogColor: {
			type: "c",
			value: new THREE.Color(16777215)
		}
	},
	shadowmap: {
		shadowMap: {
			type: "tv",
			value: []
		},
		shadowMapSize: {
			type: "v2v",
			value: []
		},
		shadowBias: {
			type: "fv1",
			value: []
		},
		shadowDarkness: {
			type: "fv1",
			value: []
		},
		shadowMatrix: {
			type: "m4v",
			value: []
		}
	}
};
THREE.ShaderLib = {
	depth: {
		uniforms: {
			mNear: {
				type: "f",
				value: 1
			},
			mFar: {
				type: "f",
				value: 2E3
			},
			opacity: {
				type: "f",
				value: 1
			}
		},
		vertexShader: "void main() {\ngl_Position = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );\n}",
		fragmentShader: "uniform float mNear;\nuniform float mFar;\nuniform float opacity;\nvoid main() {\nfloat depth = gl_FragCoord.z / gl_FragCoord.w;\nfloat color = 1.0 - smoothstep( mNear, mFar, depth );\ngl_FragColor = vec4( vec3( color ), opacity );\n}"
	},
	normal: {
		uniforms: {
			opacity: {
				type: "f",
				value: 1
			}
		},
		vertexShader: "varying vec3 vNormal;\nvoid main() {\nvec4 mvPosition = modelViewMatrix * vec4( position, 1.0 );\nvNormal = normalize( normalMatrix * normal );\ngl_Position = projectionMatrix * mvPosition;\n}",
		fragmentShader: "uniform float opacity;\nvarying vec3 vNormal;\nvoid main() {\ngl_FragColor = vec4( 0.5 * normalize( vNormal ) + 0.5, opacity );\n}"
	},
	basic: {
		uniforms: THREE.UniformsUtils.merge([THREE.UniformsLib.common, THREE.UniformsLib.fog, THREE.UniformsLib.shadowmap]),
		vertexShader: [THREE.ShaderChunk.map_pars_vertex,
		THREE.ShaderChunk.lightmap_pars_vertex, THREE.ShaderChunk.envmap_pars_vertex, THREE.ShaderChunk.color_pars_vertex, THREE.ShaderChunk.morphtarget_pars_vertex, THREE.ShaderChunk.skinning_pars_vertex, THREE.ShaderChunk.shadowmap_pars_vertex, "void main() {", THREE.ShaderChunk.map_vertex, THREE.ShaderChunk.lightmap_vertex, THREE.ShaderChunk.color_vertex, THREE.ShaderChunk.skinbase_vertex, "#ifdef USE_ENVMAP", THREE.ShaderChunk.morphnormal_vertex, THREE.ShaderChunk.skinnormal_vertex, THREE.ShaderChunk.defaultnormal_vertex,
			"#endif", THREE.ShaderChunk.morphtarget_vertex, THREE.ShaderChunk.skinning_vertex, THREE.ShaderChunk.default_vertex, THREE.ShaderChunk.worldpos_vertex, THREE.ShaderChunk.envmap_vertex, THREE.ShaderChunk.shadowmap_vertex, "}"].join("\n"),
		fragmentShader: ["uniform vec3 diffuse;\nuniform float opacity;", THREE.ShaderChunk.color_pars_fragment, THREE.ShaderChunk.map_pars_fragment, THREE.ShaderChunk.lightmap_pars_fragment, THREE.ShaderChunk.envmap_pars_fragment, THREE.ShaderChunk.fog_pars_fragment, THREE.ShaderChunk.shadowmap_pars_fragment,
		THREE.ShaderChunk.specularmap_pars_fragment, "void main() {\ngl_FragColor = vec4( diffuse, opacity );", THREE.ShaderChunk.map_fragment, THREE.ShaderChunk.alphatest_fragment, THREE.ShaderChunk.specularmap_fragment, THREE.ShaderChunk.lightmap_fragment, THREE.ShaderChunk.color_fragment, THREE.ShaderChunk.envmap_fragment, THREE.ShaderChunk.shadowmap_fragment, THREE.ShaderChunk.linear_to_gamma_fragment, THREE.ShaderChunk.fog_fragment, "}"].join("\n")
	},
	lambert: {
		uniforms: THREE.UniformsUtils.merge([THREE.UniformsLib.common,
		THREE.UniformsLib.fog, THREE.UniformsLib.lights, THREE.UniformsLib.shadowmap, {
			ambient: {
				type: "c",
				value: new THREE.Color(16777215)
			},
			emissive: {
				type: "c",
				value: new THREE.Color(0)
			},
			wrapRGB: {
				type: "v3",
				value: new THREE.Vector3(1, 1, 1)
			}
		}]),
		vertexShader: ["#define LAMBERT\nvarying vec3 vLightFront;\n#ifdef DOUBLE_SIDED\nvarying vec3 vLightBack;\n#endif", THREE.ShaderChunk.map_pars_vertex, THREE.ShaderChunk.lightmap_pars_vertex, THREE.ShaderChunk.envmap_pars_vertex, THREE.ShaderChunk.lights_lambert_pars_vertex, THREE.ShaderChunk.color_pars_vertex,
		THREE.ShaderChunk.morphtarget_pars_vertex, THREE.ShaderChunk.skinning_pars_vertex, THREE.ShaderChunk.shadowmap_pars_vertex, "void main() {", THREE.ShaderChunk.map_vertex, THREE.ShaderChunk.lightmap_vertex, THREE.ShaderChunk.color_vertex, THREE.ShaderChunk.morphnormal_vertex, THREE.ShaderChunk.skinbase_vertex, THREE.ShaderChunk.skinnormal_vertex, THREE.ShaderChunk.defaultnormal_vertex, THREE.ShaderChunk.morphtarget_vertex, THREE.ShaderChunk.skinning_vertex, THREE.ShaderChunk.default_vertex, THREE.ShaderChunk.worldpos_vertex,
		THREE.ShaderChunk.envmap_vertex, THREE.ShaderChunk.lights_lambert_vertex, THREE.ShaderChunk.shadowmap_vertex, "}"].join("\n"),
		fragmentShader: ["uniform float opacity;\nvarying vec3 vLightFront;\n#ifdef DOUBLE_SIDED\nvarying vec3 vLightBack;\n#endif", THREE.ShaderChunk.color_pars_fragment, THREE.ShaderChunk.map_pars_fragment, THREE.ShaderChunk.lightmap_pars_fragment, THREE.ShaderChunk.envmap_pars_fragment, THREE.ShaderChunk.fog_pars_fragment, THREE.ShaderChunk.shadowmap_pars_fragment, THREE.ShaderChunk.specularmap_pars_fragment,
			"void main() {\ngl_FragColor = vec4( vec3 ( 1.0 ), opacity );", THREE.ShaderChunk.map_fragment, THREE.ShaderChunk.alphatest_fragment, THREE.ShaderChunk.specularmap_fragment, "#ifdef DOUBLE_SIDED\nif ( gl_FrontFacing )\ngl_FragColor.xyz *= vLightFront;\nelse\ngl_FragColor.xyz *= vLightBack;\n#else\ngl_FragColor.xyz *= vLightFront;\n#endif", THREE.ShaderChunk.lightmap_fragment, THREE.ShaderChunk.color_fragment, THREE.ShaderChunk.envmap_fragment, THREE.ShaderChunk.shadowmap_fragment, THREE.ShaderChunk.linear_to_gamma_fragment,
		THREE.ShaderChunk.fog_fragment, "}"].join("\n")
	},
	phong: {
		uniforms: THREE.UniformsUtils.merge([THREE.UniformsLib.common, THREE.UniformsLib.bump, THREE.UniformsLib.normalmap, THREE.UniformsLib.fog, THREE.UniformsLib.lights, THREE.UniformsLib.shadowmap, {
			ambient: {
				type: "c",
				value: new THREE.Color(16777215)
			},
			emissive: {
				type: "c",
				value: new THREE.Color(0)
			},
			specular: {
				type: "c",
				value: new THREE.Color(1118481)
			},
			shininess: {
				type: "f",
				value: 30
			},
			wrapRGB: {
				type: "v3",
				value: new THREE.Vector3(1, 1, 1)
			}
		}]),
		vertexShader: ["#define PHONG\nvarying vec3 vViewPosition;\nvarying vec3 vNormal;",
		THREE.ShaderChunk.map_pars_vertex, THREE.ShaderChunk.lightmap_pars_vertex, THREE.ShaderChunk.envmap_pars_vertex, THREE.ShaderChunk.lights_phong_pars_vertex, THREE.ShaderChunk.color_pars_vertex, THREE.ShaderChunk.morphtarget_pars_vertex, THREE.ShaderChunk.skinning_pars_vertex, THREE.ShaderChunk.shadowmap_pars_vertex, "void main() {", THREE.ShaderChunk.map_vertex, THREE.ShaderChunk.lightmap_vertex, THREE.ShaderChunk.color_vertex, THREE.ShaderChunk.morphnormal_vertex, THREE.ShaderChunk.skinbase_vertex, THREE.ShaderChunk.skinnormal_vertex,
		THREE.ShaderChunk.defaultnormal_vertex, "vNormal = normalize( transformedNormal );", THREE.ShaderChunk.morphtarget_vertex, THREE.ShaderChunk.skinning_vertex, THREE.ShaderChunk.default_vertex, "vViewPosition = -mvPosition.xyz;", THREE.ShaderChunk.worldpos_vertex, THREE.ShaderChunk.envmap_vertex, THREE.ShaderChunk.lights_phong_vertex, THREE.ShaderChunk.shadowmap_vertex, "}"].join("\n"),
		fragmentShader: ["uniform vec3 diffuse;\nuniform float opacity;\nuniform vec3 ambient;\nuniform vec3 emissive;\nuniform vec3 specular;\nuniform float shininess;",
		THREE.ShaderChunk.color_pars_fragment, THREE.ShaderChunk.map_pars_fragment, THREE.ShaderChunk.lightmap_pars_fragment, THREE.ShaderChunk.envmap_pars_fragment, THREE.ShaderChunk.fog_pars_fragment, THREE.ShaderChunk.lights_phong_pars_fragment, THREE.ShaderChunk.shadowmap_pars_fragment, THREE.ShaderChunk.bumpmap_pars_fragment, THREE.ShaderChunk.normalmap_pars_fragment, THREE.ShaderChunk.specularmap_pars_fragment, "void main() {\ngl_FragColor = vec4( vec3 ( 1.0 ), opacity );", THREE.ShaderChunk.map_fragment, THREE.ShaderChunk.alphatest_fragment,
		THREE.ShaderChunk.specularmap_fragment, THREE.ShaderChunk.lights_phong_fragment, THREE.ShaderChunk.lightmap_fragment, THREE.ShaderChunk.color_fragment, THREE.ShaderChunk.envmap_fragment, THREE.ShaderChunk.shadowmap_fragment, THREE.ShaderChunk.linear_to_gamma_fragment, THREE.ShaderChunk.fog_fragment, "}"].join("\n")
	},
	particle_basic: {
		uniforms: THREE.UniformsUtils.merge([THREE.UniformsLib.particle, THREE.UniformsLib.shadowmap]),
		vertexShader: ["uniform float size;\nuniform float scale;", THREE.ShaderChunk.color_pars_vertex,
		THREE.ShaderChunk.shadowmap_pars_vertex, "void main() {", THREE.ShaderChunk.color_vertex, "vec4 mvPosition = modelViewMatrix * vec4( position, 1.0 );\n#ifdef USE_SIZEATTENUATION\ngl_PointSize = size * ( scale / length( mvPosition.xyz ) );\n#else\ngl_PointSize = size;\n#endif\ngl_Position = projectionMatrix * mvPosition;", THREE.ShaderChunk.worldpos_vertex, THREE.ShaderChunk.shadowmap_vertex, "}"].join("\n"),
		fragmentShader: ["uniform vec3 psColor;\nuniform float opacity;", THREE.ShaderChunk.color_pars_fragment,
		THREE.ShaderChunk.map_particle_pars_fragment, THREE.ShaderChunk.fog_pars_fragment, THREE.ShaderChunk.shadowmap_pars_fragment, "void main() {\ngl_FragColor = vec4( psColor, opacity );", THREE.ShaderChunk.map_particle_fragment, THREE.ShaderChunk.alphatest_fragment, THREE.ShaderChunk.color_fragment, THREE.ShaderChunk.shadowmap_fragment, THREE.ShaderChunk.fog_fragment, "}"].join("\n")
	},
	dashed: {
		uniforms: THREE.UniformsUtils.merge([THREE.UniformsLib.common, THREE.UniformsLib.fog, {
			scale: {
				type: "f",
				value: 1
			},
			dashSize: {
				type: "f",
				value: 1
			},
			totalSize: {
				type: "f",
				value: 2
			}
		}]),
		vertexShader: ["uniform float scale;\nattribute float lineDistance;\nvarying float vLineDistance;", THREE.ShaderChunk.color_pars_vertex, "void main() {", THREE.ShaderChunk.color_vertex, "vLineDistance = scale * lineDistance;\nvec4 mvPosition = modelViewMatrix * vec4( position, 1.0 );\ngl_Position = projectionMatrix * mvPosition;\n}"].join("\n"),
		fragmentShader: ["uniform vec3 diffuse;\nuniform float opacity;\nuniform float dashSize;\nuniform float totalSize;\nvarying float vLineDistance;",
		THREE.ShaderChunk.color_pars_fragment, THREE.ShaderChunk.fog_pars_fragment, "void main() {\nif ( mod( vLineDistance, totalSize ) > dashSize ) {\ndiscard;\n}\ngl_FragColor = vec4( diffuse, opacity );", THREE.ShaderChunk.color_fragment, THREE.ShaderChunk.fog_fragment, "}"].join("\n")
	},
	depthRGBA: {
		uniforms: {},
		vertexShader: [THREE.ShaderChunk.morphtarget_pars_vertex, THREE.ShaderChunk.skinning_pars_vertex, "void main() {", THREE.ShaderChunk.skinbase_vertex, THREE.ShaderChunk.morphtarget_vertex, THREE.ShaderChunk.skinning_vertex,
		THREE.ShaderChunk.default_vertex, "}"].join("\n"),
		fragmentShader: "vec4 pack_depth( const in float depth ) {\nconst vec4 bit_shift = vec4( 256.0 * 256.0 * 256.0, 256.0 * 256.0, 256.0, 1.0 );\nconst vec4 bit_mask  = vec4( 0.0, 1.0 / 256.0, 1.0 / 256.0, 1.0 / 256.0 );\nvec4 res = fract( depth * bit_shift );\nres -= res.xxyz * bit_mask;\nreturn res;\n}\nvoid main() {\ngl_FragData[ 0 ] = pack_depth( gl_FragCoord.z );\n}"
	}
};

THREE.WebGLRenderer = function (a) {
	function b(a) {
		if (a.__webglCustomAttributesList) for (var b in a.__webglCustomAttributesList) n.deleteBuffer(a.__webglCustomAttributesList[b].buffer)
	}
	function c(a, b) {
		var c = a.vertices.length,
			d = b.material;
		if (d.attributes) {
			void 0 === a.__webglCustomAttributesList && (a.__webglCustomAttributesList = []);
			for (var e in d.attributes) {
				var f = d.attributes[e];
				if (!f.__webglInitialized || f.createUniqueBuffers) {
					f.__webglInitialized = !0;
					var g = 1;
					"v2" === f.type ? g = 2 : "v3" === f.type ? g = 3 : "v4" === f.type ? g = 4 : "c" === f.type && (g = 3);
					f.size = g;
					f.array = new Float32Array(c * g);
					f.buffer = n.createBuffer();
					f.buffer.belongsToAttribute = e;
					f.needsUpdate = !0
				}
				a.__webglCustomAttributesList.push(f)
			}
		}
	}
	function d(a, b) {
		var c = b.geometry,
			d = a.faces3,
			h = a.faces4,
			i = 3 * d.length + 4 * h.length,
			j = 1 * d.length + 2 * h.length,
			h = 3 * d.length + 4 * h.length,
			d = e(b, a),
			k = g(d),
			m = f(d),
			l = d.vertexColors ? d.vertexColors : !1;
		a.__vertexArray = new Float32Array(3 * i);
		m && (a.__normalArray = new Float32Array(3 * i));
		c.hasTangents && (a.__tangentArray = new Float32Array(4 * i));
		l && (a.__colorArray = new Float32Array(3 * i));
		if (k) {
			if (0 < c.faceUvs.length || 0 < c.faceVertexUvs.length) a.__uvArray = new Float32Array(2 * i);
			if (1 < c.faceUvs.length || 1 < c.faceVertexUvs.length) a.__uv2Array = new Float32Array(2 * i)
		}
		b.geometry.skinWeights.length && b.geometry.skinIndices.length && (a.__skinIndexArray = new Float32Array(4 * i), a.__skinWeightArray = new Float32Array(4 * i));
		a.__faceArray = new Uint16Array(3 * j);
		a.__lineArray = new Uint16Array(2 * h);
		if (a.numMorphTargets) {
			a.__morphTargetsArrays = [];
			c = 0;
			for (k = a.numMorphTargets; c < k; c++) a.__morphTargetsArrays.push(new Float32Array(3 * i))
		}
		if (a.numMorphNormals) {
			a.__morphNormalsArrays = [];
			c = 0;
			for (k = a.numMorphNormals; c < k; c++) a.__morphNormalsArrays.push(new Float32Array(3 * i))
		}
		a.__webglFaceCount = 3 * j;
		a.__webglLineCount = 2 * h;
		if (d.attributes) {
			void 0 === a.__webglCustomAttributesList && (a.__webglCustomAttributesList = []);
			for (var p in d.attributes) {
				var j = d.attributes[p],
					c = {}, r;
				for (r in j) c[r] = j[r];
				if (!c.__webglInitialized || c.createUniqueBuffers) c.__webglInitialized = !0, h = 1, "v2" === c.type ? h = 2 :
					"v3" === c.type ? h = 3 : "v4" === c.type ? h = 4 : "c" === c.type && (h = 3), c.size = h, c.array = new Float32Array(i * h), c.buffer = n.createBuffer(), c.buffer.belongsToAttribute = p, j.needsUpdate = !0, c.__original = j;
				a.__webglCustomAttributesList.push(c)
			}
		}
		a.__inittedArrays = !0
	}
	function e(a, b) {
		return a.material instanceof THREE.MeshFaceMaterial ? a.material.materials[b.materialIndex] : a.material
	}
	function f(a) {
		return a instanceof THREE.MeshBasicMaterial && !a.envMap || a instanceof THREE.MeshDepthMaterial ? !1 : a && void 0 !== a.shading && a.shading === THREE.SmoothShading ? THREE.SmoothShading : THREE.FlatShading
	}
	function g(a) {
		return a.map || a.lightMap || a.bumpMap || a.normalMap || a.specularMap || a instanceof THREE.ShaderMaterial ? !0 : !1
	}
	function h(a) {
		var b, c, d;
		for (b in a.attributes) d = "index" === b ? n.ELEMENT_ARRAY_BUFFER : n.ARRAY_BUFFER, c = a.attributes[b], c.buffer = n.createBuffer(), n.bindBuffer(d, c.buffer), n.bufferData(d, c.array, n.STATIC_DRAW)
	}
	function i(a, b, c) {
		var d = a.attributes,
			e = d.index,
			f = d.position,
			g = d.normal,
			h = d.uv,
			i = d.color,
			d = d.tangent;
		a.elementsNeedUpdate && void 0 !== e && (n.bindBuffer(n.ELEMENT_ARRAY_BUFFER, e.buffer), n.bufferData(n.ELEMENT_ARRAY_BUFFER, e.array, b));
		a.verticesNeedUpdate && void 0 !== f && (n.bindBuffer(n.ARRAY_BUFFER, f.buffer), n.bufferData(n.ARRAY_BUFFER, f.array, b));
		a.normalsNeedUpdate && void 0 !== g && (n.bindBuffer(n.ARRAY_BUFFER, g.buffer), n.bufferData(n.ARRAY_BUFFER, g.array, b));
		a.uvsNeedUpdate && void 0 !== h && (n.bindBuffer(n.ARRAY_BUFFER, h.buffer), n.bufferData(n.ARRAY_BUFFER, h.array, b));
		a.colorsNeedUpdate && void 0 !== i && (n.bindBuffer(n.ARRAY_BUFFER,
		i.buffer), n.bufferData(n.ARRAY_BUFFER, i.array, b));
		a.tangentsNeedUpdate && void 0 !== d && (n.bindBuffer(n.ARRAY_BUFFER, d.buffer), n.bufferData(n.ARRAY_BUFFER, d.array, b));
		if (c) for (var j in a.attributes) delete a.attributes[j].array
	}
	function k(a) {
		nb[a] || (n.enableVertexAttribArray(a), nb[a] = !0)
	}
	function j() {
		for (var a in nb) nb[a] && (n.disableVertexAttribArray(a), nb[a] = !1)
	}
	function l(a, b) {
		return a.z !== b.z ? b.z - a.z : b.id - a.id
	}
	function m(a, b) {
		return b[0] - a[0]
	}
	function r(a, b, c) {
		if (a.length) for (var d = 0, e = a.length; d < e; d++) U = ba = null, T = fa = na = qa = ib = Va = ta = -1, Qb = !0, a[d].render(b, c, S, pa), U = ba = null, T = fa = na = qa = ib = Va = ta = -1, Qb = !0
	}
	function q(a, b, c, d, e, f, g, h) {
		var i, j, k, n;
		b ? (j = a.length - 1, n = b = -1) : (j = 0, b = a.length, n = 1);
		for (var m = j; m !== b; m += n) if (i = a[m], i.render) {
			j = i.object;
			k = i.buffer;
			if (h) i = h;
			else {
				i = i[c];
				if (!i) continue;
				g && L.setBlending(i.blending, i.blendEquation, i.blendSrc, i.blendDst);
				L.setDepthTest(i.depthTest);
				L.setDepthWrite(i.depthWrite);
				G(i.polygonOffset, i.polygonOffsetFactor, i.polygonOffsetUnits)
			}
			L.setMaterialFaces(i);
			k instanceof
			THREE.BufferGeometry ? L.renderBufferDirect(d, e, f, i, k, j) : L.renderBuffer(d, e, f, i, k, j)
		}
	}
	function p(a, b, c, d, e, f, g) {
		for (var h, i, j = 0, k = a.length; j < k; j++) if (h = a[j], i = h.object, i.visible) {
			if (g) h = g;
			else {
				h = h[b];
				if (!h) continue;
				f && L.setBlending(h.blending, h.blendEquation, h.blendSrc, h.blendDst);
				L.setDepthTest(h.depthTest);
				L.setDepthWrite(h.depthWrite);
				G(h.polygonOffset, h.polygonOffsetFactor, h.polygonOffsetUnits)
			}
			L.renderImmediateObject(c, d, e, h, i)
		}
	}
	function t(a, b, c) {
		a.push({
			buffer: b,
			object: c,
			opaque: null,
			transparent: null
		})
	}

	function u(a) {
		for (var b in a.attributes) if (a.attributes[b].needsUpdate) return !0;
		return !1
	}
	function x(a) {
		for (var b in a.attributes) a.attributes[b].needsUpdate = !1
	}
	function v(a, b) {
		for (var c = a.length - 1; 0 <= c; c--) a[c].object === b && a.splice(c, 1)
	}
	function s(a, b) {
		for (var c = a.length - 1; 0 <= c; c--) a[c] === b && a.splice(c, 1)
	}
	function C(a, b, c, d, e) {
		wa = 0;
		d.needsUpdate && (d.program && Gc(d), L.initMaterial(d, b, c, e), d.needsUpdate = !1);
		d.morphTargets && !e.__webglMorphTargetInfluences && (e.__webglMorphTargetInfluences = new Float32Array(L.maxMorphTargets));
		var f = !1,
			g = d.program,
			h = g.uniforms,
			i = d.uniforms;
		g !== ba && (n.useProgram(g), ba = g, f = !0);
		d.id !== T && (T = d.id, f = !0);
		if (f || a !== U) n.uniformMatrix4fv(h.projectionMatrix, !1, a.projectionMatrix.elements), a !== U && (U = a);
		if (d.skinning) if (jb && e.useVertexTexture) {
			if (null !== h.boneTexture) {
				var j = z();
				n.uniform1i(h.boneTexture, j);
				L.setTexture(e.boneTexture, j)
			}
		} else null !== h.boneGlobalMatrices && n.uniformMatrix4fv(h.boneGlobalMatrices, !1, e.boneMatrices);
		if (f) {
			c && d.fog && (i.fogColor.value = c.color, c instanceof THREE.Fog ? (i.fogNear.value = c.near, i.fogFar.value = c.far) : c instanceof THREE.FogExp2 && (i.fogDensity.value = c.density));
			if (d instanceof THREE.MeshPhongMaterial || d instanceof THREE.MeshLambertMaterial || d.lights) {
				if (Qb) {
					for (var k, m = j = 0, l = 0, p, r, q, S = kc, s = S.directional.colors, t = S.directional.positions, u = S.point.colors, pa = S.point.positions, v = S.point.distances, nb = S.spot.colors, x = S.spot.positions, w = S.spot.distances, C = S.spot.directions, Lb = S.spot.anglesCos, $a = S.spot.exponents, ib = S.hemi.skyColors, D = S.hemi.groundColors, G = S.hemi.positions,
					I = 0, F = 0, Ya = 0, tb = 0, P = 0, Ba = 0, Q = 0, Db = 0, O = k = 0, c = q = O = 0, f = b.length; c < f; c++) k = b[c], k.onlyShadow || (p = k.color, r = k.intensity, q = k.distance, k instanceof THREE.AmbientLight ? k.visible && (L.gammaInput ? (j += p.r * p.r, m += p.g * p.g, l += p.b * p.b) : (j += p.r, m += p.g, l += p.b)) : k instanceof THREE.DirectionalLight ? (P += 1, k.visible && (ya.copy(k.matrixWorld.getPosition()), ya.sub(k.target.matrixWorld.getPosition()), ya.normalize(), 0 === ya.x && 0 === ya.y && 0 === ya.z || (k = 3 * I, t[k] = ya.x, t[k + 1] = ya.y, t[k + 2] = ya.z, L.gammaInput ? A(s, k, p, r * r) : H(s, k, p,
					r), I += 1))) : k instanceof THREE.PointLight ? (Ba += 1, k.visible && (O = 3 * F, L.gammaInput ? A(u, O, p, r * r) : H(u, O, p, r), r = k.matrixWorld.getPosition(), pa[O] = r.x, pa[O + 1] = r.y, pa[O + 2] = r.z, v[F] = q, F += 1)) : k instanceof THREE.SpotLight ? (Q += 1, k.visible && (O = 3 * Ya, L.gammaInput ? A(nb, O, p, r * r) : H(nb, O, p, r), r = k.matrixWorld.getPosition(), x[O] = r.x, x[O + 1] = r.y, x[O + 2] = r.z, w[Ya] = q, ya.copy(r), ya.sub(k.target.matrixWorld.getPosition()), ya.normalize(), C[O] = ya.x, C[O + 1] = ya.y, C[O + 2] = ya.z, Lb[Ya] = Math.cos(k.angle), $a[Ya] = k.exponent, Ya += 1)) : k instanceof THREE.HemisphereLight && (Db += 1, k.visible && (ya.copy(k.matrixWorld.getPosition()), ya.normalize(), 0 === ya.x && 0 === ya.y && 0 === ya.z || (q = 3 * tb, G[q] = ya.x, G[q + 1] = ya.y, G[q + 2] = ya.z, p = k.color, k = k.groundColor, L.gammaInput ? (r *= r, A(ib, q, p, r), A(D, q, k, r)) : (H(ib, q, p, r), H(D, q, k, r)), tb += 1))));
					c = 3 * I;
					for (f = Math.max(s.length, 3 * P); c < f; c++) s[c] = 0;
					c = 3 * F;
					for (f = Math.max(u.length, 3 * Ba); c < f; c++) u[c] = 0;
					c = 3 * Ya;
					for (f = Math.max(nb.length, 3 * Q); c < f; c++) nb[c] = 0;
					c = 3 * tb;
					for (f = Math.max(ib.length, 3 * Db); c < f; c++) ib[c] = 0;
					c = 3 * tb;
					for (f = Math.max(D.length, 3 * Db); c < f; c++) D[c] = 0;
					S.directional.length = I;
					S.point.length = F;
					S.spot.length = Ya;
					S.hemi.length = tb;
					S.ambient[0] = j;
					S.ambient[1] = m;
					S.ambient[2] = l;
					Qb = !1
				}
				c = kc;
				i.ambientLightColor.value = c.ambient;
				i.directionalLightColor.value = c.directional.colors;
				i.directionalLightDirection.value = c.directional.positions;
				i.pointLightColor.value = c.point.colors;
				i.pointLightPosition.value = c.point.positions;
				i.pointLightDistance.value = c.point.distances;
				i.spotLightColor.value = c.spot.colors;
				i.spotLightPosition.value = c.spot.positions;
				i.spotLightDistance.value = c.spot.distances;
				i.spotLightDirection.value = c.spot.directions;
				i.spotLightAngleCos.value = c.spot.anglesCos;
				i.spotLightExponent.value = c.spot.exponents;
				i.hemisphereLightSkyColor.value = c.hemi.skyColors;
				i.hemisphereLightGroundColor.value = c.hemi.groundColors;
				i.hemisphereLightDirection.value = c.hemi.positions
			}
			if (d instanceof THREE.MeshBasicMaterial || d instanceof THREE.MeshLambertMaterial || d instanceof THREE.MeshPhongMaterial) {
				i.opacity.value = d.opacity;
				L.gammaInput ? i.diffuse.value.copyGammaToLinear(d.color) : i.diffuse.value = d.color;
				i.map.value = d.map;
				i.lightMap.value = d.lightMap;
				i.specularMap.value = d.specularMap;
				d.bumpMap && (i.bumpMap.value = d.bumpMap, i.bumpScale.value = d.bumpScale);
				d.normalMap && (i.normalMap.value = d.normalMap, i.normalScale.value.copy(d.normalScale));
				var M;
				d.map ? M = d.map : d.specularMap ? M = d.specularMap : d.normalMap ? M = d.normalMap : d.bumpMap && (M = d.bumpMap);
				void 0 !== M && (c = M.offset, M = M.repeat, i.offsetRepeat.value.set(c.x, c.y, M.x, M.y));
				i.envMap.value = d.envMap;
				i.flipEnvMap.value = d.envMap instanceof THREE.WebGLRenderTargetCube ? 1 : -1;
				i.reflectivity.value = d.reflectivity;
				i.refractionRatio.value = d.refractionRatio;
				i.combine.value = d.combine;
				i.useRefract.value = d.envMap && d.envMap.mapping instanceof THREE.CubeRefractionMapping
			}
			d instanceof THREE.LineBasicMaterial ? (i.diffuse.value = d.color, i.opacity.value = d.opacity) : d instanceof THREE.LineDashedMaterial ? (i.diffuse.value = d.color, i.opacity.value = d.opacity, i.dashSize.value = d.dashSize, i.totalSize.value = d.dashSize + d.gapSize,
			i.scale.value = d.scale) : d instanceof THREE.ParticleBasicMaterial ? (i.psColor.value = d.color, i.opacity.value = d.opacity, i.size.value = d.size, i.scale.value = R.height / 2, i.map.value = d.map) : d instanceof THREE.MeshPhongMaterial ? (i.shininess.value = d.shininess, L.gammaInput ? (i.ambient.value.copyGammaToLinear(d.ambient), i.emissive.value.copyGammaToLinear(d.emissive), i.specular.value.copyGammaToLinear(d.specular)) : (i.ambient.value = d.ambient, i.emissive.value = d.emissive, i.specular.value = d.specular), d.wrapAround && i.wrapRGB.value.copy(d.wrapRGB)) : d instanceof THREE.MeshLambertMaterial ? (L.gammaInput ? (i.ambient.value.copyGammaToLinear(d.ambient), i.emissive.value.copyGammaToLinear(d.emissive)) : (i.ambient.value = d.ambient, i.emissive.value = d.emissive), d.wrapAround && i.wrapRGB.value.copy(d.wrapRGB)) : d instanceof THREE.MeshDepthMaterial ? (i.mNear.value = a.near, i.mFar.value = a.far, i.opacity.value = d.opacity) : d instanceof THREE.MeshNormalMaterial && (i.opacity.value = d.opacity);
			if (e.receiveShadow && !d._shadowPass && i.shadowMatrix) {
				c = M = 0;
				for (f = b.length; c < f; c++) if (j = b[c], j.castShadow && (j instanceof THREE.SpotLight || j instanceof THREE.DirectionalLight && !j.shadowCascade)) i.shadowMap.value[M] = j.shadowMap, i.shadowMapSize.value[M] = j.shadowMapSize, i.shadowMatrix.value[M] = j.shadowMatrix, i.shadowDarkness.value[M] = j.shadowDarkness, i.shadowBias.value[M] = j.shadowBias, M++
			}
			b = d.uniformsList;
			i = 0;
			for (M = b.length; i < M; i++) if (f = g.uniforms[b[i][1]]) if (c = b[i][0], m = c.type, j = c.value, "i" === m) n.uniform1i(f, j);
			else if ("f" === m) n.uniform1f(f, j);
			else if ("v2" === m) n.uniform2f(f, j.x, j.y);
			else if ("v3" === m) n.uniform3f(f, j.x, j.y, j.z);
			else if ("v4" === m) n.uniform4f(f, j.x, j.y, j.z, j.w);
			else if ("c" === m) n.uniform3f(f, j.r, j.g, j.b);
			else if ("iv1" === m) n.uniform1iv(f, j);
			else if ("iv" === m) n.uniform3iv(f, j);
			else if ("fv1" === m) n.uniform1fv(f, j);
			else if ("fv" === m) n.uniform3fv(f, j);
			else if ("v2v" === m) {
				void 0 === c._array && (c._array = new Float32Array(2 * j.length));
				m = 0;
				for (l = j.length; m < l; m++) S = 2 * m, c._array[S] = j[m].x, c._array[S + 1] = j[m].y;
				n.uniform2fv(f, c._array)
			} else if ("v3v" === m) {
				void 0 === c._array && (c._array = new Float32Array(3 * j.length));
				m = 0;
				for (l = j.length; m < l; m++) S = 3 * m, c._array[S] = j[m].x, c._array[S + 1] = j[m].y, c._array[S + 2] = j[m].z;
				n.uniform3fv(f, c._array)
			} else if ("v4v" === m) {
				void 0 === c._array && (c._array = new Float32Array(4 * j.length));
				m = 0;
				for (l = j.length; m < l; m++) S = 4 * m, c._array[S] = j[m].x, c._array[S + 1] = j[m].y, c._array[S + 2] = j[m].z, c._array[S + 3] = j[m].w;
				n.uniform4fv(f, c._array)
			} else if ("m4" === m) void 0 === c._array && (c._array = new Float32Array(16)), j.flattenToArray(c._array), n.uniformMatrix4fv(f, !1, c._array);
			else if ("m4v" === m) {
				void 0 === c._array && (c._array = new Float32Array(16 * j.length));
				m = 0;
				for (l = j.length; m < l; m++) j[m].flattenToArrayOffset(c._array, 16 * m);
				n.uniformMatrix4fv(f, !1, c._array)
			} else if ("t" === m) {
				if (S = j, j = z(), n.uniform1i(f, j), S) if (S.image instanceof Array && 6 === S.image.length) {
					if (c = S, f = j, 6 === c.image.length) if (c.needsUpdate) {
						c.image.__webglTextureCube || (c.image.__webglTextureCube = n.createTexture(), L.info.memory.textures++);
						n.activeTexture(n.TEXTURE0 + f);
						n.bindTexture(n.TEXTURE_CUBE_MAP, c.image.__webglTextureCube);
						n.pixelStorei(n.UNPACK_FLIP_Y_WEBGL,
						c.flipY);
						f = c instanceof THREE.CompressedTexture;
						j = [];
						for (m = 0; 6 > m; m++) l = j, S = m, L.autoScaleCubemaps && !f ? (s = c.image[m], u = Mb, s.width <= u && s.height <= u || (pa = Math.max(s.width, s.height), t = Math.floor(s.width * u / pa), u = Math.floor(s.height * u / pa), pa = document.createElement("canvas"), pa.width = t, pa.height = u, pa.getContext("2d").drawImage(s, 0, 0, s.width, s.height, 0, 0, t, u), s = pa)) : s = c.image[m], l[S] = s;
						m = j[0];
						l = 0 === (m.width & m.width - 1) && 0 === (m.height & m.height - 1);
						S = J(c.format);
						s = J(c.type);
						E(n.TEXTURE_CUBE_MAP, c, l);
						for (m = 0; 6 > m; m++) if (f) {
							u = j[m].mipmaps;
							pa = 0;
							for (v = u.length; pa < v; pa++) t = u[pa], n.compressedTexImage2D(n.TEXTURE_CUBE_MAP_POSITIVE_X + m, pa, S, t.width, t.height, 0, t.data)
						} else n.texImage2D(n.TEXTURE_CUBE_MAP_POSITIVE_X + m, 0, S, S, s, j[m]);
						c.generateMipmaps && l && n.generateMipmap(n.TEXTURE_CUBE_MAP);
						c.needsUpdate = !1;
						if (c.onUpdate) c.onUpdate()
					} else n.activeTexture(n.TEXTURE0 + f), n.bindTexture(n.TEXTURE_CUBE_MAP, c.image.__webglTextureCube)
				} else S instanceof THREE.WebGLRenderTargetCube ? (c = S, n.activeTexture(n.TEXTURE0 + j), n.bindTexture(n.TEXTURE_CUBE_MAP,
				c.__webglTexture)) : L.setTexture(S, j)
			} else if ("tv" === m) {
				void 0 === c._array && (c._array = []);
				m = 0;
				for (l = c.value.length; m < l; m++) c._array[m] = z();
				n.uniform1iv(f, c._array);
				m = 0;
				for (l = c.value.length; m < l; m++) S = c.value[m], j = c._array[m], S && L.setTexture(S, j)
			}
			if ((d instanceof THREE.ShaderMaterial || d instanceof THREE.MeshPhongMaterial || d.envMap) && null !== h.cameraPosition) b = a.matrixWorld.getPosition(), n.uniform3f(h.cameraPosition, b.x, b.y, b.z);
			(d instanceof THREE.MeshPhongMaterial || d instanceof THREE.MeshLambertMaterial || d instanceof THREE.ShaderMaterial || d.skinning) && null !== h.viewMatrix && n.uniformMatrix4fv(h.viewMatrix, !1, a.matrixWorldInverse.elements)
		}
		n.uniformMatrix4fv(h.modelViewMatrix, !1, e._modelViewMatrix.elements);
		h.normalMatrix && n.uniformMatrix3fv(h.normalMatrix, !1, e._normalMatrix.elements);
		null !== h.modelMatrix && n.uniformMatrix4fv(h.modelMatrix, !1, e.matrixWorld.elements);
		return g
	}
	function z() {
		var a = wa;
		a >= dc && console.warn("WebGLRenderer: trying to use " + a + " texture units while this GPU supports only " + dc);
		wa += 1;
		return a
	}
	function w(a, b) {
		a._modelViewMatrix.multiplyMatrices(b.matrixWorldInverse, a.matrixWorld); // Changed
		a._normalMatrix.getInverse(a._modelViewMatrix);
		a._normalMatrix.transpose()
	}
	function A(a, b, c, d) {
		a[b] = c.r * c.r * d;
		a[b + 1] = c.g * c.g * d;
		a[b + 2] = c.b * c.b * d
	}
	function H(a, b, c, d) {
		a[b] = c.r * d;
		a[b + 1] = c.g * d;
		a[b + 2] = c.b * d
	}
	function G(a, b, c) {
		Wa !== a && (a ? n.enable(n.POLYGON_OFFSET_FILL) : n.disable(n.POLYGON_OFFSET_FILL), Wa = a);
		if (a && ($a !== b || Ba !== c)) n.polygonOffset(b, c), $a = b, Ba = c
	}
	function I(a) {
		for (var a = a.split("\n"), b = 0, c = a.length; b < c; b++) a[b] = b + 1 + ": " + a[b];
		return a.join("\n")
	}
	function V(a, b) {
		var c;
		"fragment" === a ? c = n.createShader(n.FRAGMENT_SHADER) : "vertex" === a && (c = n.createShader(n.VERTEX_SHADER));
		n.shaderSource(c, b);
		n.compileShader(c);
		return !n.getShaderParameter(c, n.COMPILE_STATUS) ? (console.error(n.getShaderInfoLog(c)), console.error(I(b)), null) : c
	}
	function E(a, b, c) {
		c ? (n.texParameteri(a, n.TEXTURE_WRAP_S, J(b.wrapS)), n.texParameteri(a, n.TEXTURE_WRAP_T, J(b.wrapT)), n.texParameteri(a, n.TEXTURE_MAG_FILTER, J(b.magFilter)), n.texParameteri(a,
		n.TEXTURE_MIN_FILTER, J(b.minFilter))) : (n.texParameteri(a, n.TEXTURE_WRAP_S, n.CLAMP_TO_EDGE), n.texParameteri(a, n.TEXTURE_WRAP_T, n.CLAMP_TO_EDGE), n.texParameteri(a, n.TEXTURE_MAG_FILTER, D(b.magFilter)), n.texParameteri(a, n.TEXTURE_MIN_FILTER, D(b.minFilter)));
		if (Bb && b.type !== THREE.FloatType && (1 < b.anisotropy || b.__oldAnisotropy)) n.texParameterf(a, Bb.TEXTURE_MAX_ANISOTROPY_EXT, Math.min(b.anisotropy, Fb)), b.__oldAnisotropy = b.anisotropy
	}
	function O(a, b) {
		n.bindRenderbuffer(n.RENDERBUFFER, a);
		b.depthBuffer && !b.stencilBuffer ? (n.renderbufferStorage(n.RENDERBUFFER, n.DEPTH_COMPONENT16, b.width, b.height), n.framebufferRenderbuffer(n.FRAMEBUFFER, n.DEPTH_ATTACHMENT, n.RENDERBUFFER, a)) : b.depthBuffer && b.stencilBuffer ? (n.renderbufferStorage(n.RENDERBUFFER, n.DEPTH_STENCIL, b.width, b.height), n.framebufferRenderbuffer(n.FRAMEBUFFER, n.DEPTH_STENCIL_ATTACHMENT, n.RENDERBUFFER, a)) : n.renderbufferStorage(n.RENDERBUFFER, n.RGBA4, b.width, b.height)
	}
	function D(a) {
		return a === THREE.NearestFilter || a === THREE.NearestMipMapNearestFilter || a === THREE.NearestMipMapLinearFilter ? n.NEAREST : n.LINEAR
	}
	function J(a) {
		if (a === THREE.RepeatWrapping) return n.REPEAT;
		if (a === THREE.ClampToEdgeWrapping) return n.CLAMP_TO_EDGE;
		if (a === THREE.MirroredRepeatWrapping) return n.MIRRORED_REPEAT;
		if (a === THREE.NearestFilter) return n.NEAREST;
		if (a === THREE.NearestMipMapNearestFilter) return n.NEAREST_MIPMAP_NEAREST;
		if (a === THREE.NearestMipMapLinearFilter) return n.NEAREST_MIPMAP_LINEAR;
		if (a === THREE.LinearFilter) return n.LINEAR;
		if (a === THREE.LinearMipMapNearestFilter) return n.LINEAR_MIPMAP_NEAREST;
		if (a === THREE.LinearMipMapLinearFilter) return n.LINEAR_MIPMAP_LINEAR;
		if (a === THREE.UnsignedByteType) return n.UNSIGNED_BYTE;
		if (a === THREE.UnsignedShort4444Type) return n.UNSIGNED_SHORT_4_4_4_4;
		if (a === THREE.UnsignedShort5551Type) return n.UNSIGNED_SHORT_5_5_5_1;
		if (a === THREE.UnsignedShort565Type) return n.UNSIGNED_SHORT_5_6_5;
		if (a === THREE.ByteType) return n.BYTE;
		if (a === THREE.ShortType) return n.SHORT;
		if (a === THREE.UnsignedShortType) return n.UNSIGNED_SHORT;
		if (a === THREE.IntType) return n.INT;
		if (a === THREE.UnsignedIntType) return n.UNSIGNED_INT;
		if (a === THREE.FloatType) return n.FLOAT;
		if (a === THREE.AlphaFormat) return n.ALPHA;
		if (a === THREE.RGBFormat) return n.RGB;
		if (a === THREE.RGBAFormat) return n.RGBA;
		if (a === THREE.LuminanceFormat) return n.LUMINANCE;
		if (a === THREE.LuminanceAlphaFormat) return n.LUMINANCE_ALPHA;
		if (a === THREE.AddEquation) return n.FUNC_ADD;
		if (a === THREE.SubtractEquation) return n.FUNC_SUBTRACT;
		if (a === THREE.ReverseSubtractEquation) return n.FUNC_REVERSE_SUBTRACT;
		if (a === THREE.ZeroFactor) return n.ZERO;
		if (a === THREE.OneFactor) return n.ONE;
		if (a === THREE.SrcColorFactor) return n.SRC_COLOR;
		if (a === THREE.OneMinusSrcColorFactor) return n.ONE_MINUS_SRC_COLOR;
		if (a === THREE.SrcAlphaFactor) return n.SRC_ALPHA;
		if (a === THREE.OneMinusSrcAlphaFactor) return n.ONE_MINUS_SRC_ALPHA;
		if (a === THREE.DstAlphaFactor) return n.DST_ALPHA;
		if (a === THREE.OneMinusDstAlphaFactor) return n.ONE_MINUS_DST_ALPHA;
		if (a === THREE.DstColorFactor) return n.DST_COLOR;
		if (a === THREE.OneMinusDstColorFactor) return n.ONE_MINUS_DST_COLOR;
		if (a === THREE.SrcAlphaSaturateFactor) return n.SRC_ALPHA_SATURATE;
		if (void 0 !== ub) {
			if (a === THREE.RGB_S3TC_DXT1_Format) return ub.COMPRESSED_RGB_S3TC_DXT1_EXT;
			if (a === THREE.RGBA_S3TC_DXT1_Format) return ub.COMPRESSED_RGBA_S3TC_DXT1_EXT;
			if (a === THREE.RGBA_S3TC_DXT3_Format) return ub.COMPRESSED_RGBA_S3TC_DXT3_EXT;
			if (a === THREE.RGBA_S3TC_DXT5_Format) return ub.COMPRESSED_RGBA_S3TC_DXT5_EXT
		}
		return 0
	}
	function P(a, b) {
		var c = n.createFramebuffer(),
			d = n.createTexture();
		n.bindTexture(n.TEXTURE_2D, d);
		n.texImage2D(n.TEXTURE_2D, 0, a, 2, 2, 0, a, b, null);
		n.bindFramebuffer(n.FRAMEBUFFER, c);
		n.framebufferTexture2D(n.FRAMEBUFFER, n.COLOR_ATTACHMENT0, n.TEXTURE_2D, d, 0);
		c = n.checkFramebufferStatus(n.FRAMEBUFFER);
		n.bindFramebuffer(n.FRAMEBUFFER, null);
		n.bindTexture(n.TEXTURE_2D, null);
		return c === n.FRAMEBUFFER_COMPLETE
	}
	console.log("THREE.WebGLRenderer", THREE.REVISION);
	var a = a || {}, R = void 0 !== a.canvas ? a.canvas : document.createElement("canvas"),
		Q = void 0 !== a.precision ? a.precision : "highp",
		N = void 0 !== a.alpha ? a.alpha : !0,
		M = void 0 !== a.premultipliedAlpha ? a.premultipliedAlpha : !0,
		F = void 0 !== a.antialias ? a.antialias : !1,
		W = void 0 !== a.stencil ? a.stencil : !0,
		oa = void 0 !== a.preserveDrawingBuffer ? a.preserveDrawingBuffer : !1,
		ua = void 0 !== a.clearColor ? new THREE.Color(a.clearColor) : new THREE.Color(0),
		va = void 0 !== a.clearAlpha ? a.clearAlpha : 0;
	this.domElement = R;
	this.context = null;
	this.devicePixelRatio = void 0 !== a.devicePixelRatio ? a.devicePixelRatio : void 0 !== window.devicePixelRatio ? window.devicePixelRatio : 1;
	this.autoUpdateScene = this.autoUpdateObjects = this.sortObjects = this.autoClearStencil = this.autoClearDepth = this.autoClearColor = this.autoClear = !0;
	this.shadowMapEnabled = this.physicallyBasedShading = this.gammaOutput = this.gammaInput = !1;
	this.shadowMapAutoUpdate = !0;
	this.shadowMapType = THREE.PCFShadowMap;
	this.shadowMapCullFace = THREE.CullFaceFront;
	this.shadowMapCascade = this.shadowMapDebug = !1;
	this.maxMorphTargets = 8;
	this.maxMorphNormals = 4;
	this.autoScaleCubemaps = !0;
	this.renderPluginsPre = [];
	this.renderPluginsPost = [];
	this.info = {
		memory: {
			programs: 0,
			geometries: 0,
			textures: 0
		},
		render: {
			calls: 0,
			vertices: 0,
			faces: 0,
			points: 0
		}
	};
	var L = this,
		da = [],
		ca = 0,
		ba = null,
		ka = null,
		T = -1,
		fa = null,
		U = null,
		Fa = 0,
		wa = 0,
		qa = -1,
		na = -1,
		ta = -1,
		Ga = -1,
		ra = -1,
		Ua = -1,
		Va = -1,
		ib = -1,
		Wa = null,
		$a = null,
		Ba = null,
		Ha = null,
		wb = 0,
		Aa = 0,
		Xa = 0,
		Na = 0,
		S = 0,
		pa = 0,
		nb = {}, Lb = new THREE.Frustum,
		Ya = new THREE.Matrix4,
		Db = new THREE.Matrix4,
		tb = new THREE.Vector3,
		ya = new THREE.Vector3,
		Qb = !0,
		kc = {
			ambient: [0, 0, 0],
			directional: {
				length: 0,
				colors: [],
				positions: []
			},
			point: {
				length: 0,
				colors: [],
				positions: [],
				distances: []
			},
			spot: {
				length: 0,
				colors: [],
				positions: [],
				distances: [],
				directions: [],
				anglesCos: [],
				exponents: []
			},
			hemi: {
				length: 0,
				skyColors: [],
				groundColors: [],
				positions: []
			}
		}, n, Rb, uc, Bb, ub;
	try {
		if (!(n = R.getContext("experimental-webgl", {
			alpha: N,
			premultipliedAlpha: M,
			antialias: F,
			stencil: W,
			preserveDrawingBuffer: oa
		}))) throw "Error creating WebGL context.";
	} catch (Nb) {
		console.error(Nb)
	}
	Rb = n.getExtension("OES_texture_float");
	uc = n.getExtension("OES_standard_derivatives");
	Bb = n.getExtension("EXT_texture_filter_anisotropic") || n.getExtension("MOZ_EXT_texture_filter_anisotropic") || n.getExtension("WEBKIT_EXT_texture_filter_anisotropic");
	ub = n.getExtension("WEBGL_compressed_texture_s3tc") || n.getExtension("MOZ_WEBGL_compressed_texture_s3tc") || n.getExtension("WEBKIT_WEBGL_compressed_texture_s3tc");
	Rb || console.log("THREE.WebGLRenderer: Float textures not supported.");
	uc || console.log("THREE.WebGLRenderer: Standard derivatives not supported.");
	Bb || console.log("THREE.WebGLRenderer: Anisotropic texture filtering not supported.");
	ub || console.log("THREE.WebGLRenderer: S3TC compressed textures not supported.");
	n.clearColor(0, 0, 0, 1);
	n.clearDepth(1);
	n.clearStencil(0);
	n.enable(n.DEPTH_TEST);
	n.depthFunc(n.LEQUAL);
	n.frontFace(n.CCW);
	n.cullFace(n.BACK);
	n.enable(n.CULL_FACE);
	n.enable(n.BLEND);
	n.blendEquation(n.FUNC_ADD);
	n.blendFunc(n.SRC_ALPHA, n.ONE_MINUS_SRC_ALPHA);
	n.clearColor(ua.r, ua.g, ua.b, va);
	this.context = n;
	var dc = n.getParameter(n.MAX_TEXTURE_IMAGE_UNITS),
		Hc = n.getParameter(n.MAX_VERTEX_TEXTURE_IMAGE_UNITS);
	n.getParameter(n.MAX_TEXTURE_SIZE);
	var Mb = n.getParameter(n.MAX_CUBE_MAP_TEXTURE_SIZE),
		Fb = Bb ? n.getParameter(Bb.MAX_TEXTURE_MAX_ANISOTROPY_EXT) : 0,
		fb = 0 < Hc,
		jb = fb && Rb;
	ub && n.getParameter(n.COMPRESSED_TEXTURE_FORMATS);
	var ec = n.getShaderPrecisionFormat(n.VERTEX_SHADER, n.HIGH_FLOAT),
		ea = n.getShaderPrecisionFormat(n.VERTEX_SHADER,
		n.MEDIUM_FLOAT);
	n.getShaderPrecisionFormat(n.VERTEX_SHADER, n.LOW_FLOAT);
	var ma = n.getShaderPrecisionFormat(n.FRAGMENT_SHADER, n.HIGH_FLOAT),
		la = n.getShaderPrecisionFormat(n.FRAGMENT_SHADER, n.MEDIUM_FLOAT);
	n.getShaderPrecisionFormat(n.FRAGMENT_SHADER, n.LOW_FLOAT);
	n.getShaderPrecisionFormat(n.VERTEX_SHADER, n.HIGH_INT);
	n.getShaderPrecisionFormat(n.VERTEX_SHADER, n.MEDIUM_INT);
	n.getShaderPrecisionFormat(n.VERTEX_SHADER, n.LOW_INT);
	n.getShaderPrecisionFormat(n.FRAGMENT_SHADER, n.HIGH_INT);
	n.getShaderPrecisionFormat(n.FRAGMENT_SHADER,
	n.MEDIUM_INT);
	n.getShaderPrecisionFormat(n.FRAGMENT_SHADER, n.LOW_INT);
	var Ka = Rb && P(n.RGB, n.FLOAT),
		cb = Rb && P(n.RGBA, n.FLOAT),
		db = Rb && P(n.LUMINANCE, n.FLOAT),
		ob = Rb && P(n.ALPHA, n.FLOAT),
		ab = Rb && P(n.LUMINANCE_ALPHA, n.FLOAT),
		Eb = 0 < ec.precision && 0 < ma.precision,
		Gb = 0 < ea.precision && 0 < la.precision;
	"highp" === Q && !Eb && (Gb ? (Q = "mediump", console.warn("WebGLRenderer: highp not supported, using mediump")) : (Q = "lowp", console.warn("WebGLRenderer: highp and mediump not supported, using lowp")));
	"mediump" === Q && !Gb && (Q = "lowp",
	console.warn("WebGLRenderer: mediump not supported, using lowp"));
	this.getContext = function () {
		return n
	};
	this.supportsVertexTextures = function () {
		return fb
	};
	this.supportsLuminanceFloatRenderTarget = function () {
		return db
	};
	this.supportsAlphaFloatRenderTarget = function () {
		return ob
	};
	this.supportsLuminanceAlphaFloatRenderTarget = function () {
		return ab
	};
	this.supportsRGBFloatRenderTarget = function () {
		return Ka
	};
	this.supportsRGBAFloatRenderTarget = function () {
		return cb
	};
	this.getMaxAnisotropy = function () {
		return Fb
	};
	this.getPrecision = function () {
		return Q
	};
	this.setSize = function (a, b) {
		R.width = a * this.devicePixelRatio;
		R.height = b * this.devicePixelRatio;
		R.style.width = a + "px";
		R.style.height = b + "px";
		this.setViewport(0, 0, R.width, R.height)
	};
	this.setViewport = function (a, b, c, d) {
		wb = void 0 !== a ? a : 0;
		Aa = void 0 !== b ? b : 0;
		Xa = void 0 !== c ? c : R.width;
		Na = void 0 !== d ? d : R.height;
		n.viewport(wb, Aa, Xa, Na)
	};
	this.setScissor = function (a, b, c, d) {
		n.scissor(a, b, c, d)
	};
	this.enableScissorTest = function (a) {
		a ? n.enable(n.SCISSOR_TEST) : n.disable(n.SCISSOR_TEST)
	};
	this.setClearColorHex = function (a, b) {
		ua.setHex(a);
		va = b;
		n.clearColor(ua.r, ua.g, ua.b, va)
	};
	this.setClearColor = function (a, b) {
		ua.copy(a);
		va = b;
		n.clearColor(ua.r, ua.g, ua.b, va)
	};
	this.getClearColor = function () {
		return ua
	};
	this.getClearAlpha = function () {
		return va
	};
	this.clear = function (a, b, c) {
		var d = 0;
		if (void 0 === a || a) d |= n.COLOR_BUFFER_BIT;
		if (void 0 === b || b) d |= n.DEPTH_BUFFER_BIT;
		if (void 0 === c || c) d |= n.STENCIL_BUFFER_BIT;
		n.clear(d)
	};
	this.clearTarget = function (a, b, c, d) {
		this.setRenderTarget(a);
		this.clear(b, c, d)
	};
	this.addPostPlugin = function (a) {
		a.init(this);
		this.renderPluginsPost.push(a)
	};
	this.addPrePlugin = function (a) {
		a.init(this);
		this.renderPluginsPre.push(a)
	};
	this.updateShadowMap = function (a, b) {
		ba = null;
		T = fa = ib = Va = ta = -1;
		Qb = !0;
		na = qa = -1;
		this.shadowMapPlugin.update(a, b)
	};
	var hd = function (a) {
		a = a.target;
		a.removeEventListener("dispose", hd);
		a.__webglInit = void 0;
		void 0 !== a.__webglVertexBuffer && n.deleteBuffer(a.__webglVertexBuffer);
		void 0 !== a.__webglNormalBuffer && n.deleteBuffer(a.__webglNormalBuffer);
		void 0 !== a.__webglTangentBuffer && n.deleteBuffer(a.__webglTangentBuffer);
		void 0 !== a.__webglColorBuffer && n.deleteBuffer(a.__webglColorBuffer);
		void 0 !== a.__webglUVBuffer && n.deleteBuffer(a.__webglUVBuffer);
		void 0 !== a.__webglUV2Buffer && n.deleteBuffer(a.__webglUV2Buffer);
		void 0 !== a.__webglSkinIndicesBuffer && n.deleteBuffer(a.__webglSkinIndicesBuffer);
		void 0 !== a.__webglSkinWeightsBuffer && n.deleteBuffer(a.__webglSkinWeightsBuffer);
		void 0 !== a.__webglFaceBuffer && n.deleteBuffer(a.__webglFaceBuffer);
		void 0 !== a.__webglLineBuffer && n.deleteBuffer(a.__webglLineBuffer);
		void 0 !== a.__webglLineDistanceBuffer && n.deleteBuffer(a.__webglLineDistanceBuffer);
		if (void 0 !== a.geometryGroups) for (var c in a.geometryGroups) {
			var d = a.geometryGroups[c];
			if (void 0 !== d.numMorphTargets) for (var e = 0, f = d.numMorphTargets; e < f; e++) n.deleteBuffer(d.__webglMorphTargetsBuffers[e]);
			if (void 0 !== d.numMorphNormals) {
				e = 0;
				for (f = d.numMorphNormals; e < f; e++) n.deleteBuffer(d.__webglMorphNormalsBuffers[e])
			}
			b(d)
		}
		b(a);
		L.info.memory.geometries--
	}, Ec = function (a) {
		a = a.target;
		a.removeEventListener("dispose", Ec);
		a.image && a.image.__webglTextureCube ? n.deleteTexture(a.image.__webglTextureCube) : a.__webglInit && (a.__webglInit = !1, n.deleteTexture(a.__webglTexture));
		L.info.memory.textures--
	}, tc = function (a) {
		a = a.target;
		a.removeEventListener("dispose", tc);
		if (a && a.__webglTexture) if (n.deleteTexture(a.__webglTexture), a instanceof THREE.WebGLRenderTargetCube) for (var b = 0; 6 > b; b++) n.deleteFramebuffer(a.__webglFramebuffer[b]), n.deleteRenderbuffer(a.__webglRenderbuffer[b]);
		else n.deleteFramebuffer(a.__webglFramebuffer), n.deleteRenderbuffer(a.__webglRenderbuffer);
		L.info.memory.textures--
	}, Fc = function (a) {
		a = a.target;
		a.removeEventListener("dispose", Fc);
		Gc(a)
	}, Gc = function (a) {
		var b = a.program;
		if (void 0 !== b) {
			a.program = void 0;
			var c, d, e = !1,
				a = 0;
			for (c = da.length; a < c; a++) if (d = da[a], d.program === b) {
				d.usedTimes--;
				0 === d.usedTimes && (e = !0);
				break
			}
			if (!0 === e) {
				e = [];
				a = 0;
				for (c = da.length; a < c; a++) d = da[a], d.program !== b && e.push(d);
				da = e;
				n.deleteProgram(b);
				L.info.memory.programs--
			}
		}
	};
	this.renderBufferImmediate = function (a, b, c) {
		a.hasPositions && !a.__webglVertexBuffer && (a.__webglVertexBuffer = n.createBuffer());
		a.hasNormals && !a.__webglNormalBuffer && (a.__webglNormalBuffer = n.createBuffer());
		a.hasUvs && !a.__webglUvBuffer && (a.__webglUvBuffer = n.createBuffer());
		a.hasColors && !a.__webglColorBuffer && (a.__webglColorBuffer = n.createBuffer());
		a.hasPositions && (n.bindBuffer(n.ARRAY_BUFFER, a.__webglVertexBuffer), n.bufferData(n.ARRAY_BUFFER, a.positionArray, n.DYNAMIC_DRAW), n.enableVertexAttribArray(b.attributes.position), n.vertexAttribPointer(b.attributes.position, 3, n.FLOAT, !1, 0, 0));
		if (a.hasNormals) {
			n.bindBuffer(n.ARRAY_BUFFER, a.__webglNormalBuffer);
			if (c.shading === THREE.FlatShading) {
				var d, e, f, g, h, i, j, k, m, l, p, r = 3 * a.count;
				for (p = 0; p < r; p += 9) l = a.normalArray, d = l[p], e = l[p + 1], f = l[p + 2], g = l[p + 3], i = l[p + 4], k = l[p + 5], h = l[p + 6], j = l[p + 7], m = l[p + 8], d = (d + g + h) / 3, e = (e + i + j) / 3, f = (f + k + m) / 3, l[p] = d, l[p + 1] = e, l[p + 2] = f, l[p + 3] = d, l[p + 4] = e, l[p + 5] = f, l[p + 6] = d, l[p + 7] = e, l[p + 8] = f
			}
			n.bufferData(n.ARRAY_BUFFER, a.normalArray, n.DYNAMIC_DRAW);
			n.enableVertexAttribArray(b.attributes.normal);
			n.vertexAttribPointer(b.attributes.normal, 3, n.FLOAT, !1, 0, 0)
		}
		a.hasUvs && c.map && (n.bindBuffer(n.ARRAY_BUFFER, a.__webglUvBuffer),
		n.bufferData(n.ARRAY_BUFFER, a.uvArray, n.DYNAMIC_DRAW), n.enableVertexAttribArray(b.attributes.uv), n.vertexAttribPointer(b.attributes.uv, 2, n.FLOAT, !1, 0, 0));
		a.hasColors && c.vertexColors !== THREE.NoColors && (n.bindBuffer(n.ARRAY_BUFFER, a.__webglColorBuffer), n.bufferData(n.ARRAY_BUFFER, a.colorArray, n.DYNAMIC_DRAW), n.enableVertexAttribArray(b.attributes.color), n.vertexAttribPointer(b.attributes.color, 3, n.FLOAT, !1, 0, 0));
		n.drawArrays(n.TRIANGLES, 0, a.count);
		a.count = 0
	};
	this.renderBufferDirect = function (a, b, c, d,
	e, f) {
		if (!1 !== d.visible) if (c = C(a, b, c, d, f), a = c.attributes, b = !1, d = 16777215 * e.id + 2 * c.id + (d.wireframe ? 1 : 0), d !== fa && (fa = d, b = !0), b && j(), f instanceof THREE.Mesh) if (f = e.attributes.index) {
			d = e.offsets;
			1 < d.length && (b = !0);
			for (var c = 0, g = d.length; c < g; c++) {
				var h = d[c].index;
				if (b) {
					var i = e.attributes.position,
						m = i.itemSize;
					n.bindBuffer(n.ARRAY_BUFFER, i.buffer);
					k(a.position);
					n.vertexAttribPointer(a.position, m, n.FLOAT, !1, 0, 4 * h * m);
					m = e.attributes.normal;
					if (0 <= a.normal && m) {
						var l = m.itemSize;
						n.bindBuffer(n.ARRAY_BUFFER, m.buffer);
						k(a.normal);
						n.vertexAttribPointer(a.normal, l, n.FLOAT, !1, 0, 4 * h * l)
					}
					m = e.attributes.uv;
					0 <= a.uv && m && (l = m.itemSize, n.bindBuffer(n.ARRAY_BUFFER, m.buffer), k(a.uv), n.vertexAttribPointer(a.uv, l, n.FLOAT, !1, 0, 4 * h * l));
					m = e.attributes.color;
					0 <= a.color && m && (l = m.itemSize, n.bindBuffer(n.ARRAY_BUFFER, m.buffer), k(a.color), n.vertexAttribPointer(a.color, l, n.FLOAT, !1, 0, 4 * h * l));
					m = e.attributes.tangent;
					0 <= a.tangent && m && (l = m.itemSize, n.bindBuffer(n.ARRAY_BUFFER, m.buffer), k(a.tangent), n.vertexAttribPointer(a.tangent, l, n.FLOAT, !1, 0, 4 * h * l));
					n.bindBuffer(n.ELEMENT_ARRAY_BUFFER, f.buffer)
				}
				n.drawElements(n.TRIANGLES, d[c].count, n.UNSIGNED_SHORT, 2 * d[c].start);
				L.info.render.calls++;
				L.info.render.vertices += d[c].count;
				L.info.render.faces += d[c].count / 3
			}
		} else b && (i = e.attributes.position, m = i.itemSize, n.bindBuffer(n.ARRAY_BUFFER, i.buffer), k(a.position), n.vertexAttribPointer(a.position, m, n.FLOAT, !1, 0, 0), m = e.attributes.normal, 0 <= a.normal && m && (l = m.itemSize, n.bindBuffer(n.ARRAY_BUFFER, m.buffer), k(a.normal), n.vertexAttribPointer(a.normal,
		l, n.FLOAT, !1, 0, 0)), m = e.attributes.uv, 0 <= a.uv && m && (l = m.itemSize, n.bindBuffer(n.ARRAY_BUFFER, m.buffer), k(a.uv), n.vertexAttribPointer(a.uv, l, n.FLOAT, !1, 0, 0)), m = e.attributes.color, 0 <= a.color && m && (l = m.itemSize, n.bindBuffer(n.ARRAY_BUFFER, m.buffer), k(a.color), n.vertexAttribPointer(a.color, l, n.FLOAT, !1, 0, 0)), m = e.attributes.tangent, 0 <= a.tangent && m && (l = m.itemSize, n.bindBuffer(n.ARRAY_BUFFER, m.buffer), k(a.tangent), n.vertexAttribPointer(a.tangent, l, n.FLOAT, !1, 0, 0))), n.drawArrays(n.TRIANGLES, 0, i.numItems / 3),
		L.info.render.calls++, L.info.render.vertices += i.numItems / 3, L.info.render.faces += i.numItems / 3 / 3;
		else f instanceof THREE.ParticleSystem && b && (i = e.attributes.position, m = i.itemSize, n.bindBuffer(n.ARRAY_BUFFER, i.buffer), k(a.position), n.vertexAttribPointer(a.position, m, n.FLOAT, !1, 0, 0), m = e.attributes.color, 0 <= a.color && m && (l = m.itemSize, n.bindBuffer(n.ARRAY_BUFFER, m.buffer), k(a.color), n.vertexAttribPointer(a.color, l, n.FLOAT, !1, 0, 0)), n.drawArrays(n.POINTS, 0, i.numItems / 3), L.info.render.calls++, L.info.render.points += i.numItems / 3)
	};
	this.renderBuffer = function (a, b, c, d, e, f) {
		if (!1 !== d.visible) {
			var g, h, c = C(a, b, c, d, f),
				b = c.attributes,
				a = !1,
				c = 16777215 * e.id + 2 * c.id + (d.wireframe ? 1 : 0);
			c !== fa && (fa = c, a = !0);
			a && j();
			if (!d.morphTargets && 0 <= b.position) a && (n.bindBuffer(n.ARRAY_BUFFER, e.__webglVertexBuffer), k(b.position), n.vertexAttribPointer(b.position, 3, n.FLOAT, !1, 0, 0));
			else if (f.morphTargetBase) {
				c = d.program.attributes; - 1 !== f.morphTargetBase && 0 <= c.position ? (n.bindBuffer(n.ARRAY_BUFFER, e.__webglMorphTargetsBuffers[f.morphTargetBase]),
				k(c.position), n.vertexAttribPointer(c.position, 3, n.FLOAT, !1, 0, 0)) : 0 <= c.position && (n.bindBuffer(n.ARRAY_BUFFER, e.__webglVertexBuffer), k(c.position), n.vertexAttribPointer(c.position, 3, n.FLOAT, !1, 0, 0));
				if (f.morphTargetForcedOrder.length) {
					var i = 0;
					h = f.morphTargetForcedOrder;
					for (g = f.morphTargetInfluences; i < d.numSupportedMorphTargets && i < h.length;) 0 <= c["morphTarget" + i] && (n.bindBuffer(n.ARRAY_BUFFER, e.__webglMorphTargetsBuffers[h[i]]), k(c["morphTarget" + i]), n.vertexAttribPointer(c["morphTarget" + i], 3, n.FLOAT, !1, 0, 0)), 0 <= c["morphNormal" + i] && d.morphNormals && (n.bindBuffer(n.ARRAY_BUFFER, e.__webglMorphNormalsBuffers[h[i]]), k(c["morphNormal" + i]), n.vertexAttribPointer(c["morphNormal" + i], 3, n.FLOAT, !1, 0, 0)), f.__webglMorphTargetInfluences[i] = g[h[i]], i++
				} else {
					h = [];
					g = f.morphTargetInfluences;
					var l, p = g.length;
					for (l = 0; l < p; l++) i = g[l], 0 < i && h.push([i, l]);
					h.length > d.numSupportedMorphTargets ? (h.sort(m), h.length = d.numSupportedMorphTargets) : h.length > d.numSupportedMorphNormals ? h.sort(m) : 0 === h.length && h.push([0, 0]);
					for (i = 0; i < d.numSupportedMorphTargets;) h[i] ? (l = h[i][1], 0 <= c["morphTarget" + i] && (n.bindBuffer(n.ARRAY_BUFFER, e.__webglMorphTargetsBuffers[l]), k(c["morphTarget" + i]), n.vertexAttribPointer(c["morphTarget" + i], 3, n.FLOAT, !1, 0, 0)), 0 <= c["morphNormal" + i] && d.morphNormals && (n.bindBuffer(n.ARRAY_BUFFER, e.__webglMorphNormalsBuffers[l]), k(c["morphNormal" + i]), n.vertexAttribPointer(c["morphNormal" + i], 3, n.FLOAT, !1, 0, 0)), f.__webglMorphTargetInfluences[i] = g[l]) : f.__webglMorphTargetInfluences[i] = 0, i++
				}
				null !== d.program.uniforms.morphTargetInfluences && n.uniform1fv(d.program.uniforms.morphTargetInfluences, f.__webglMorphTargetInfluences)
			}
			if (a) {
				if (e.__webglCustomAttributesList) {
					g = 0;
					for (h = e.__webglCustomAttributesList.length; g < h; g++) c = e.__webglCustomAttributesList[g], 0 <= b[c.buffer.belongsToAttribute] && (n.bindBuffer(n.ARRAY_BUFFER, c.buffer), k(b[c.buffer.belongsToAttribute]), n.vertexAttribPointer(b[c.buffer.belongsToAttribute], c.size, n.FLOAT, !1, 0, 0))
				}
				0 <= b.color && (n.bindBuffer(n.ARRAY_BUFFER, e.__webglColorBuffer), k(b.color), n.vertexAttribPointer(b.color,
				3, n.FLOAT, !1, 0, 0));
				0 <= b.normal && (n.bindBuffer(n.ARRAY_BUFFER, e.__webglNormalBuffer), k(b.normal), n.vertexAttribPointer(b.normal, 3, n.FLOAT, !1, 0, 0));
				0 <= b.tangent && (n.bindBuffer(n.ARRAY_BUFFER, e.__webglTangentBuffer), k(b.tangent), n.vertexAttribPointer(b.tangent, 4, n.FLOAT, !1, 0, 0));
				0 <= b.uv && (n.bindBuffer(n.ARRAY_BUFFER, e.__webglUVBuffer), k(b.uv), n.vertexAttribPointer(b.uv, 2, n.FLOAT, !1, 0, 0));
				0 <= b.uv2 && (n.bindBuffer(n.ARRAY_BUFFER, e.__webglUV2Buffer), k(b.uv2), n.vertexAttribPointer(b.uv2, 2, n.FLOAT, !1, 0, 0));
				d.skinning && (0 <= b.skinIndex && 0 <= b.skinWeight) && (n.bindBuffer(n.ARRAY_BUFFER, e.__webglSkinIndicesBuffer), k(b.skinIndex), n.vertexAttribPointer(b.skinIndex, 4, n.FLOAT, !1, 0, 0), n.bindBuffer(n.ARRAY_BUFFER, e.__webglSkinWeightsBuffer), k(b.skinWeight), n.vertexAttribPointer(b.skinWeight, 4, n.FLOAT, !1, 0, 0));
				0 <= b.lineDistance && (n.bindBuffer(n.ARRAY_BUFFER, e.__webglLineDistanceBuffer), k(b.lineDistance), n.vertexAttribPointer(b.lineDistance, 1, n.FLOAT, !1, 0, 0))
			}
			f instanceof THREE.Mesh ? (d.wireframe ? (d = d.wireframeLinewidth,
			d !== Ha && (n.lineWidth(d), Ha = d), a && n.bindBuffer(n.ELEMENT_ARRAY_BUFFER, e.__webglLineBuffer), n.drawElements(n.LINES, e.__webglLineCount, n.UNSIGNED_SHORT, 0)) : (a && n.bindBuffer(n.ELEMENT_ARRAY_BUFFER, e.__webglFaceBuffer), n.drawElements(n.TRIANGLES, e.__webglFaceCount, n.UNSIGNED_SHORT, 0)), L.info.render.calls++, L.info.render.vertices += e.__webglFaceCount, L.info.render.faces += e.__webglFaceCount / 3) : f instanceof THREE.Line ? (f = f.type === THREE.LineStrip ? n.LINE_STRIP : n.LINES, d = d.linewidth, d !== Ha && (n.lineWidth(d), Ha = d), n.drawArrays(f, 0, e.__webglLineCount), L.info.render.calls++) : f instanceof THREE.ParticleSystem ? (n.drawArrays(n.POINTS, 0, e.__webglParticleCount), L.info.render.calls++, L.info.render.points += e.__webglParticleCount) : f instanceof THREE.Ribbon && (n.drawArrays(n.TRIANGLE_STRIP, 0, e.__webglVertexCount), L.info.render.calls++)
		}
	};
	this.render = function (a, b, c, d) {
		if (!1 === b instanceof THREE.Camera) console.error("THREE.WebGLRenderer.render: camera is not an instance of THREE.Camera.");
		else {
			var e, f, g, h, i = a.__lights,
				j = a.fog;
			T = -1;
			Qb = !0;
			this.autoUpdateScene && a.updateMatrixWorld();
			void 0 === b.parent && b.updateMatrixWorld();
			b.matrixWorldInverse.getInverse(b.matrixWorld);
			Ya.multiplyMatrices(b.projectionMatrix, b.matrixWorldInverse);
			Lb.setFromMatrix(Ya);
			this.autoUpdateObjects && this.initWebGLObjects(a);
			r(this.renderPluginsPre, a, b);
			L.info.render.calls = 0;
			L.info.render.vertices = 0;
			L.info.render.faces = 0;
			L.info.render.points = 0;
			this.setRenderTarget(c);
			(this.autoClear || d) && this.clear(this.autoClearColor, this.autoClearDepth, this.autoClearStencil);
			h = a.__webglObjects;
			d = 0;
			for (e = h.length; d < e; d++) if (f = h[d], g = f.object, f.render = !1, g.visible && (!(g instanceof THREE.Mesh || g instanceof THREE.ParticleSystem) || !g.frustumCulled || Lb.contains(g))) {
				w(g, b);
				var k = f,
					m = k.buffer,
					S = void 0,
					s = S = void 0,
					s = k.object.material;
				if (s instanceof THREE.MeshFaceMaterial) S = m.materialIndex, S = s.materials[S], S.transparent ? (k.transparent = S, k.opaque = null) : (k.opaque = S, k.transparent = null);
				else if (S = s) S.transparent ? (k.transparent = S, k.opaque = null) : (k.opaque = S, k.transparent = null);
				f.render = !0;
				!0 === this.sortObjects && (null !== g.renderDepth ? f.z = g.renderDepth : (tb.copy(g.matrixWorld.getPosition()), tb.applyProjection(Ya)/*CHANGED Ya.multiplyVector3(tb)*/, f.z = tb.z), f.id = g.id)
			}
			this.sortObjects && h.sort(l);
			h = a.__webglObjectsImmediate;
			d = 0;
			for (e = h.length; d < e; d++) f = h[d], g = f.object, g.visible && (w(g, b), g = f.object.material, g.transparent ? (f.transparent = g, f.opaque = null) : (f.opaque = g, f.transparent = null));
			a.overrideMaterial ? (d = a.overrideMaterial, this.setBlending(d.blending, d.blendEquation, d.blendSrc, d.blendDst), this.setDepthTest(d.depthTest),
			this.setDepthWrite(d.depthWrite), G(d.polygonOffset, d.polygonOffsetFactor, d.polygonOffsetUnits), q(a.__webglObjects, !1, "", b, i, j, !0, d), p(a.__webglObjectsImmediate, "", b, i, j, !1, d)) : (d = null, this.setBlending(THREE.NoBlending), q(a.__webglObjects, !0, "opaque", b, i, j, !1, d), p(a.__webglObjectsImmediate, "opaque", b, i, j, !1, d), q(a.__webglObjects, !1, "transparent", b, i, j, !0, d), p(a.__webglObjectsImmediate, "transparent", b, i, j, !0, d));
			r(this.renderPluginsPost, a, b);
			c && (c.generateMipmaps && c.minFilter !== THREE.NearestFilter && c.minFilter !== THREE.LinearFilter) && (c instanceof THREE.WebGLRenderTargetCube ? (n.bindTexture(n.TEXTURE_CUBE_MAP, c.__webglTexture), n.generateMipmap(n.TEXTURE_CUBE_MAP), n.bindTexture(n.TEXTURE_CUBE_MAP, null)) : (n.bindTexture(n.TEXTURE_2D, c.__webglTexture), n.generateMipmap(n.TEXTURE_2D), n.bindTexture(n.TEXTURE_2D, null)));
			this.setDepthTest(!0);
			this.setDepthWrite(!0)
		}
	};
	this.renderImmediateObject = function (a, b, c, d, e) {
		var f = C(a, b, c, d, e);
		fa = -1;
		L.setMaterialFaces(d);
		e.immediateRenderCallback ? e.immediateRenderCallback(f,
		n, Lb) : e.render(function (a) {
			L.renderBufferImmediate(a, f, d)
		})
	};
	this.initWebGLObjects = function (a) {
		a.__webglObjects || (a.__webglObjects = [], a.__webglObjectsImmediate = [], a.__webglSprites = [], a.__webglFlares = []);
		for (; a.__objectsAdded.length;) {
			var b = a.__objectsAdded[0],
				j = a,
				k = void 0,
				l = void 0,
				p = void 0,
				r = void 0;
			if (!b.__webglInit) if (b.__webglInit = !0, b._modelViewMatrix = new THREE.Matrix4, b._normalMatrix = new THREE.Matrix3, void 0 !== b.geometry && void 0 === b.geometry.__webglInit && (b.geometry.__webglInit = !0, b.geometry.addEventListener("dispose",
			hd)), b instanceof THREE.Mesh) if (l = b.geometry, p = b.material, l instanceof THREE.Geometry) {
				if (void 0 === l.geometryGroups) {
					var q = l,
						S = void 0,
						pa = void 0,
						nb = void 0,
						w = void 0,
						z = void 0,
						A = void 0,
						C = {}, Lb = q.morphTargets.length,
						$a = q.morphNormals.length,
						ib = p instanceof THREE.MeshFaceMaterial;
					q.geometryGroups = {};
					S = 0;
					for (pa = q.faces.length; S < pa; S++) nb = q.faces[S], w = ib ? nb.materialIndex : 0, void 0 === C[w] && (C[w] = {
						hash: w,
						counter: 0
					}), A = C[w].hash + "_" + C[w].counter, void 0 === q.geometryGroups[A] && (q.geometryGroups[A] = {
						faces3: [],
						faces4: [],
						materialIndex: w,
						vertices: 0,
						numMorphTargets: Lb,
						numMorphNormals: $a
					}), z = nb instanceof THREE.Face3 ? 3 : 4, 65535 < q.geometryGroups[A].vertices + z && (C[w].counter += 1, A = C[w].hash + "_" + C[w].counter, void 0 === q.geometryGroups[A] && (q.geometryGroups[A] = {
						faces3: [],
						faces4: [],
						materialIndex: w,
						vertices: 0,
						numMorphTargets: Lb,
						numMorphNormals: $a
					})), nb instanceof THREE.Face3 ? q.geometryGroups[A].faces3.push(S) : q.geometryGroups[A].faces4.push(S), q.geometryGroups[A].vertices += z;
					q.geometryGroupsList = [];
					var D = void 0;
					for (D in q.geometryGroups) q.geometryGroups[D].id = Fa++, q.geometryGroupsList.push(q.geometryGroups[D])
				}
				for (k in l.geometryGroups) if (r = l.geometryGroups[k], !r.__webglVertexBuffer) {
					var E = r;
					E.__webglVertexBuffer = n.createBuffer();
					E.__webglNormalBuffer = n.createBuffer();
					E.__webglTangentBuffer = n.createBuffer();
					E.__webglColorBuffer = n.createBuffer();
					E.__webglUVBuffer = n.createBuffer();
					E.__webglUV2Buffer = n.createBuffer();
					E.__webglSkinIndicesBuffer = n.createBuffer();
					E.__webglSkinWeightsBuffer = n.createBuffer();
					E.__webglFaceBuffer = n.createBuffer();
					E.__webglLineBuffer = n.createBuffer();
					var H = void 0,
						G = void 0;
					if (E.numMorphTargets) {
						E.__webglMorphTargetsBuffers = [];
						H = 0;
						for (G = E.numMorphTargets; H < G; H++) E.__webglMorphTargetsBuffers.push(n.createBuffer())
					}
					if (E.numMorphNormals) {
						E.__webglMorphNormalsBuffers = [];
						H = 0;
						for (G = E.numMorphNormals; H < G; H++) E.__webglMorphNormalsBuffers.push(n.createBuffer())
					}
					L.info.memory.geometries++;
					d(r, b);
					l.verticesNeedUpdate = !0;
					l.morphTargetsNeedUpdate = !0;
					l.elementsNeedUpdate = !0;
					l.uvsNeedUpdate = !0;
					l.normalsNeedUpdate = !0;
					l.tangentsNeedUpdate = !0;
					l.colorsNeedUpdate = !0
				}
			} else l instanceof THREE.BufferGeometry && h(l);
			else if (b instanceof THREE.Ribbon) {
				if (l = b.geometry, !l.__webglVertexBuffer) {
					var I = l;
					I.__webglVertexBuffer = n.createBuffer();
					I.__webglColorBuffer = n.createBuffer();
					I.__webglNormalBuffer = n.createBuffer();
					L.info.memory.geometries++;
					var F = l,
						J = b,
						P = F.vertices.length;
					F.__vertexArray = new Float32Array(3 * P);
					F.__colorArray = new Float32Array(3 * P);
					F.__normalArray = new Float32Array(3 * P);
					F.__webglVertexCount = P;
					c(F, J);
					l.verticesNeedUpdate = !0;
					l.colorsNeedUpdate = !0;
					l.normalsNeedUpdate = !0
				}
			} else if (b instanceof THREE.Line) {
				if (l = b.geometry, !l.__webglVertexBuffer) {
					var Ba = l;
					Ba.__webglVertexBuffer = n.createBuffer();
					Ba.__webglColorBuffer = n.createBuffer();
					Ba.__webglLineDistanceBuffer = n.createBuffer();
					L.info.memory.geometries++;
					var M = l,
						O = b,
						Q = M.vertices.length;
					M.__vertexArray = new Float32Array(3 * Q);
					M.__colorArray = new Float32Array(3 * Q);
					M.__lineDistanceArray = new Float32Array(1 * Q);
					M.__webglLineCount = Q;
					c(M, O);
					l.verticesNeedUpdate = !0;
					l.colorsNeedUpdate = !0;
					l.lineDistancesNeedUpdate = !0
				}
			} else if (b instanceof
			THREE.ParticleSystem && (l = b.geometry, !l.__webglVertexBuffer)) if (l instanceof THREE.Geometry) {
				var ya = l;
				ya.__webglVertexBuffer = n.createBuffer();
				ya.__webglColorBuffer = n.createBuffer();
				L.info.memory.geometries++;
				var R = l,
					V = b,
					T = R.vertices.length;
				R.__vertexArray = new Float32Array(3 * T);
				R.__colorArray = new Float32Array(3 * T);
				R.__sortArray = [];
				R.__webglParticleCount = T;
				c(R, V);
				l.verticesNeedUpdate = !0;
				l.colorsNeedUpdate = !0
			} else l instanceof THREE.BufferGeometry && h(l);
			if (!b.__webglActive) {
				if (b instanceof THREE.Mesh) if (l = b.geometry, l instanceof THREE.BufferGeometry) t(j.__webglObjects, l, b);
				else for (k in l.geometryGroups) r = l.geometryGroups[k], t(j.__webglObjects, r, b);
				else b instanceof THREE.Ribbon || b instanceof THREE.Line || b instanceof THREE.ParticleSystem ? (l = b.geometry, t(j.__webglObjects, l, b)) : b instanceof THREE.ImmediateRenderObject || b.immediateRenderCallback ? j.__webglObjectsImmediate.push({
					object: b,
					opaque: null,
					transparent: null
				}) : b instanceof THREE.Sprite ? j.__webglSprites.push(b) : b instanceof THREE.LensFlare && j.__webglFlares.push(b);
				b.__webglActive = !0
			}
			a.__objectsAdded.splice(0, 1)
		}
		for (; a.__objectsRemoved.length;) {
			var Wa = a.__objectsRemoved[0],
				da = a;
			Wa instanceof THREE.Mesh || Wa instanceof THREE.ParticleSystem || Wa instanceof THREE.Ribbon || Wa instanceof THREE.Line ? v(da.__webglObjects, Wa) : Wa instanceof THREE.Sprite ? s(da.__webglSprites, Wa) : Wa instanceof THREE.LensFlare ? s(da.__webglFlares, Wa) : (Wa instanceof THREE.ImmediateRenderObject || Wa.immediateRenderCallback) && v(da.__webglObjectsImmediate, Wa);
			Wa.__webglActive = !1;
			a.__objectsRemoved.splice(0,
			1)
		}
		for (var Qb = 0, fa = a.__webglObjects.length; Qb < fa; Qb++) {
			var ca = a.__webglObjects[Qb].object,
				N = ca.geometry,
				kc = void 0,
				ba = void 0,
				W = void 0;
			if (ca instanceof THREE.Mesh) if (N instanceof THREE.BufferGeometry)(N.verticesNeedUpdate || N.elementsNeedUpdate || N.uvsNeedUpdate || N.normalsNeedUpdate || N.colorsNeedUpdate || N.tangentsNeedUpdate) && i(N, n.DYNAMIC_DRAW, !N.dynamic), N.verticesNeedUpdate = !1, N.elementsNeedUpdate = !1, N.uvsNeedUpdate = !1, N.normalsNeedUpdate = !1, N.colorsNeedUpdate = !1, N.tangentsNeedUpdate = !1;
			else {
				for (var Ha = 0, ea = N.geometryGroupsList.length; Ha < ea; Ha++) if (kc = N.geometryGroupsList[Ha], W = e(ca, kc), N.buffersNeedUpdate && d(kc, ca), ba = W.attributes && u(W), N.verticesNeedUpdate || N.morphTargetsNeedUpdate || N.elementsNeedUpdate || N.uvsNeedUpdate || N.normalsNeedUpdate || N.colorsNeedUpdate || N.tangentsNeedUpdate || ba) {
					var U = kc,
						Rb = ca,
						ka = n.DYNAMIC_DRAW,
						Aa = !N.dynamic,
						va = W;
					if (U.__inittedArrays) {
						var uc = f(va),
							na = va.vertexColors ? va.vertexColors : !1,
							ua = g(va),
							wb = uc === THREE.SmoothShading,
							K = void 0,
							aa = void 0,
							Bb = void 0,
							X = void 0,
							ma = void 0,
							la = void 0,
							oa = void 0,
							wa = void 0,
							ub = void 0,
							qa = void 0,
							ta = void 0,
							Y = void 0,
							Z = void 0,
							$ = void 0,
							za = void 0,
							ra = void 0,
							Xa = void 0,
							Mb = void 0,
							Ga = void 0,
							Na = void 0,
							fb = void 0,
							jb = void 0,
							Va = void 0,
							Ka = void 0,
							Nb = void 0,
							Ua = void 0,
							ob = void 0,
							ab = void 0,
							cb = void 0,
							db = void 0,
							dc = void 0,
							Fb = void 0,
							Sb = void 0,
							Tb = void 0,
							Eb = void 0,
							Ea = void 0,
							Hc = void 0,
							fc = void 0,
							Gb = void 0,
							pc = void 0,
							kb = void 0,
							ec = void 0,
							gb = void 0,
							hb = void 0,
							gc = void 0,
							Zb = void 0,
							Za = 0,
							eb = 0,
							$b = 0,
							ac = 0,
							Hb = 0,
							rb = 0,
							La = 0,
							vb = 0,
							bb = 0,
							ha = 0,
							sa = 0,
							B = 0,
							Ia = void 0,
							lb = U.__vertexArray,
							vc = U.__uvArray,
							wc = U.__uv2Array,
							Ib = U.__normalArray,
							Qa = U.__tangentArray,
							mb = U.__colorArray,
							Ra = U.__skinIndexArray,
							Sa = U.__skinWeightArray,
							Yc = U.__morphTargetsArrays,
							Zc = U.__morphNormalsArrays,
							$c = U.__webglCustomAttributesList,
							y = void 0,
							Ub = U.__faceArray,
							Cb = U.__lineArray,
							xb = Rb.geometry,
							Ec = xb.elementsNeedUpdate,
							tc = xb.uvsNeedUpdate,
							Fc = xb.normalsNeedUpdate,
							Gc = xb.tangentsNeedUpdate,
							ud = xb.colorsNeedUpdate,
							vd = xb.morphTargetsNeedUpdate,
							lc = xb.vertices,
							Ca = U.faces3,
							Da = U.faces4,
							sb = xb.faces,
							ad = xb.faceVertexUvs[0],
							bd = xb.faceVertexUvs[1],
							mc = xb.skinIndices,
							hc = xb.skinWeights,
							ic = xb.morphTargets,
							Ic = xb.morphNormals;
						if (xb.verticesNeedUpdate) {
							K = 0;
							for (aa = Ca.length; K < aa; K++) X = sb[Ca[K]], Y = lc[X.a], Z = lc[X.b], $ = lc[X.c], lb[eb] = Y.x, lb[eb + 1] = Y.y, lb[eb + 2] = Y.z, lb[eb + 3] = Z.x, lb[eb + 4] = Z.y, lb[eb + 5] = Z.z, lb[eb + 6] = $.x, lb[eb + 7] = $.y, lb[eb + 8] = $.z, eb += 9;
							K = 0;
							for (aa = Da.length; K < aa; K++) X = sb[Da[K]], Y = lc[X.a], Z = lc[X.b], $ = lc[X.c], za = lc[X.d], lb[eb] = Y.x, lb[eb + 1] = Y.y, lb[eb + 2] = Y.z, lb[eb + 3] = Z.x, lb[eb + 4] = Z.y, lb[eb + 5] = Z.z, lb[eb + 6] = $.x, lb[eb + 7] = $.y, lb[eb + 8] = $.z, lb[eb + 9] = za.x,
							lb[eb + 10] = za.y, lb[eb + 11] = za.z, eb += 12;
							n.bindBuffer(n.ARRAY_BUFFER, U.__webglVertexBuffer);
							n.bufferData(n.ARRAY_BUFFER, lb, ka)
						}
						if (vd) {
							kb = 0;
							for (ec = ic.length; kb < ec; kb++) {
								K = sa = 0;
								for (aa = Ca.length; K < aa; K++) gc = Ca[K], X = sb[gc], Y = ic[kb].vertices[X.a], Z = ic[kb].vertices[X.b], $ = ic[kb].vertices[X.c], gb = Yc[kb], gb[sa] = Y.x, gb[sa + 1] = Y.y, gb[sa + 2] = Y.z, gb[sa + 3] = Z.x, gb[sa + 4] = Z.y, gb[sa + 5] = Z.z, gb[sa + 6] = $.x, gb[sa + 7] = $.y, gb[sa + 8] = $.z, va.morphNormals && (wb ? (Zb = Ic[kb].vertexNormals[gc], Na = Zb.a, fb = Zb.b, jb = Zb.c) : jb = fb = Na = Ic[kb].faceNormals[gc],
								hb = Zc[kb], hb[sa] = Na.x, hb[sa + 1] = Na.y, hb[sa + 2] = Na.z, hb[sa + 3] = fb.x, hb[sa + 4] = fb.y, hb[sa + 5] = fb.z, hb[sa + 6] = jb.x, hb[sa + 7] = jb.y, hb[sa + 8] = jb.z), sa += 9;
								K = 0;
								for (aa = Da.length; K < aa; K++) gc = Da[K], X = sb[gc], Y = ic[kb].vertices[X.a], Z = ic[kb].vertices[X.b], $ = ic[kb].vertices[X.c], za = ic[kb].vertices[X.d], gb = Yc[kb], gb[sa] = Y.x, gb[sa + 1] = Y.y, gb[sa + 2] = Y.z, gb[sa + 3] = Z.x, gb[sa + 4] = Z.y, gb[sa + 5] = Z.z, gb[sa + 6] = $.x, gb[sa + 7] = $.y, gb[sa + 8] = $.z, gb[sa + 9] = za.x, gb[sa + 10] = za.y, gb[sa + 11] = za.z, va.morphNormals && (wb ? (Zb = Ic[kb].vertexNormals[gc],
								Na = Zb.a, fb = Zb.b, jb = Zb.c, Va = Zb.d) : Va = jb = fb = Na = Ic[kb].faceNormals[gc], hb = Zc[kb], hb[sa] = Na.x, hb[sa + 1] = Na.y, hb[sa + 2] = Na.z, hb[sa + 3] = fb.x, hb[sa + 4] = fb.y, hb[sa + 5] = fb.z, hb[sa + 6] = jb.x, hb[sa + 7] = jb.y, hb[sa + 8] = jb.z, hb[sa + 9] = Va.x, hb[sa + 10] = Va.y, hb[sa + 11] = Va.z), sa += 12;
								n.bindBuffer(n.ARRAY_BUFFER, U.__webglMorphTargetsBuffers[kb]);
								n.bufferData(n.ARRAY_BUFFER, Yc[kb], ka);
								va.morphNormals && (n.bindBuffer(n.ARRAY_BUFFER, U.__webglMorphNormalsBuffers[kb]), n.bufferData(n.ARRAY_BUFFER, Zc[kb], ka))
							}
						}
						if (hc.length) {
							K = 0;
							for (aa = Ca.length; K < aa; K++) X = sb[Ca[K]], ab = hc[X.a], cb = hc[X.b], db = hc[X.c], Sa[ha] = ab.x, Sa[ha + 1] = ab.y, Sa[ha + 2] = ab.z, Sa[ha + 3] = ab.w, Sa[ha + 4] = cb.x, Sa[ha + 5] = cb.y, Sa[ha + 6] = cb.z, Sa[ha + 7] = cb.w, Sa[ha + 8] = db.x, Sa[ha + 9] = db.y, Sa[ha + 10] = db.z, Sa[ha + 11] = db.w, Fb = mc[X.a], Sb = mc[X.b], Tb = mc[X.c], Ra[ha] = Fb.x, Ra[ha + 1] = Fb.y, Ra[ha + 2] = Fb.z, Ra[ha + 3] = Fb.w, Ra[ha + 4] = Sb.x, Ra[ha + 5] = Sb.y, Ra[ha + 6] = Sb.z, Ra[ha + 7] = Sb.w, Ra[ha + 8] = Tb.x, Ra[ha + 9] = Tb.y, Ra[ha + 10] = Tb.z, Ra[ha + 11] = Tb.w, ha += 12;
							K = 0;
							for (aa = Da.length; K < aa; K++) X = sb[Da[K]], ab = hc[X.a], cb = hc[X.b],
							db = hc[X.c], dc = hc[X.d], Sa[ha] = ab.x, Sa[ha + 1] = ab.y, Sa[ha + 2] = ab.z, Sa[ha + 3] = ab.w, Sa[ha + 4] = cb.x, Sa[ha + 5] = cb.y, Sa[ha + 6] = cb.z, Sa[ha + 7] = cb.w, Sa[ha + 8] = db.x, Sa[ha + 9] = db.y, Sa[ha + 10] = db.z, Sa[ha + 11] = db.w, Sa[ha + 12] = dc.x, Sa[ha + 13] = dc.y, Sa[ha + 14] = dc.z, Sa[ha + 15] = dc.w, Fb = mc[X.a], Sb = mc[X.b], Tb = mc[X.c], Eb = mc[X.d], Ra[ha] = Fb.x, Ra[ha + 1] = Fb.y, Ra[ha + 2] = Fb.z, Ra[ha + 3] = Fb.w, Ra[ha + 4] = Sb.x, Ra[ha + 5] = Sb.y, Ra[ha + 6] = Sb.z, Ra[ha + 7] = Sb.w, Ra[ha + 8] = Tb.x, Ra[ha + 9] = Tb.y, Ra[ha + 10] = Tb.z, Ra[ha + 11] = Tb.w, Ra[ha + 12] = Eb.x, Ra[ha + 13] = Eb.y, Ra[ha + 14] = Eb.z, Ra[ha + 15] = Eb.w, ha += 16;
							0 < ha && (n.bindBuffer(n.ARRAY_BUFFER, U.__webglSkinIndicesBuffer), n.bufferData(n.ARRAY_BUFFER, Ra, ka), n.bindBuffer(n.ARRAY_BUFFER, U.__webglSkinWeightsBuffer), n.bufferData(n.ARRAY_BUFFER, Sa, ka))
						}
						if (ud && na) {
							K = 0;
							for (aa = Ca.length; K < aa; K++) X = sb[Ca[K]], oa = X.vertexColors, wa = X.color, 3 === oa.length && na === THREE.VertexColors ? (Ka = oa[0], Nb = oa[1], Ua = oa[2]) : Ua = Nb = Ka = wa, mb[bb] = Ka.r, mb[bb + 1] = Ka.g, mb[bb + 2] = Ka.b, mb[bb + 3] = Nb.r, mb[bb + 4] = Nb.g, mb[bb + 5] = Nb.b, mb[bb + 6] = Ua.r, mb[bb + 7] = Ua.g, mb[bb + 8] = Ua.b,
							bb += 9;
							K = 0;
							for (aa = Da.length; K < aa; K++) X = sb[Da[K]], oa = X.vertexColors, wa = X.color, 4 === oa.length && na === THREE.VertexColors ? (Ka = oa[0], Nb = oa[1], Ua = oa[2], ob = oa[3]) : ob = Ua = Nb = Ka = wa, mb[bb] = Ka.r, mb[bb + 1] = Ka.g, mb[bb + 2] = Ka.b, mb[bb + 3] = Nb.r, mb[bb + 4] = Nb.g, mb[bb + 5] = Nb.b, mb[bb + 6] = Ua.r, mb[bb + 7] = Ua.g, mb[bb + 8] = Ua.b, mb[bb + 9] = ob.r, mb[bb + 10] = ob.g, mb[bb + 11] = ob.b, bb += 12;
							0 < bb && (n.bindBuffer(n.ARRAY_BUFFER, U.__webglColorBuffer), n.bufferData(n.ARRAY_BUFFER, mb, ka))
						}
						if (Gc && xb.hasTangents) {
							K = 0;
							for (aa = Ca.length; K < aa; K++) X = sb[Ca[K]],
							ub = X.vertexTangents, ra = ub[0], Xa = ub[1], Mb = ub[2], Qa[La] = ra.x, Qa[La + 1] = ra.y, Qa[La + 2] = ra.z, Qa[La + 3] = ra.w, Qa[La + 4] = Xa.x, Qa[La + 5] = Xa.y, Qa[La + 6] = Xa.z, Qa[La + 7] = Xa.w, Qa[La + 8] = Mb.x, Qa[La + 9] = Mb.y, Qa[La + 10] = Mb.z, Qa[La + 11] = Mb.w, La += 12;
							K = 0;
							for (aa = Da.length; K < aa; K++) X = sb[Da[K]], ub = X.vertexTangents, ra = ub[0], Xa = ub[1], Mb = ub[2], Ga = ub[3], Qa[La] = ra.x, Qa[La + 1] = ra.y, Qa[La + 2] = ra.z, Qa[La + 3] = ra.w, Qa[La + 4] = Xa.x, Qa[La + 5] = Xa.y, Qa[La + 6] = Xa.z, Qa[La + 7] = Xa.w, Qa[La + 8] = Mb.x, Qa[La + 9] = Mb.y, Qa[La + 10] = Mb.z, Qa[La + 11] = Mb.w, Qa[La + 12] = Ga.x,
							Qa[La + 13] = Ga.y, Qa[La + 14] = Ga.z, Qa[La + 15] = Ga.w, La += 16;
							n.bindBuffer(n.ARRAY_BUFFER, U.__webglTangentBuffer);
							n.bufferData(n.ARRAY_BUFFER, Qa, ka)
						}
						if (Fc && uc) {
							K = 0;
							for (aa = Ca.length; K < aa; K++) if (X = sb[Ca[K]], ma = X.vertexNormals, la = X.normal, 3 === ma.length && wb) for (Ea = 0; 3 > Ea; Ea++) fc = ma[Ea], Ib[rb] = fc.x, Ib[rb + 1] = fc.y, Ib[rb + 2] = fc.z, rb += 3;
							else for (Ea = 0; 3 > Ea; Ea++) Ib[rb] = la.x, Ib[rb + 1] = la.y, Ib[rb + 2] = la.z, rb += 3;
							K = 0;
							for (aa = Da.length; K < aa; K++) if (X = sb[Da[K]], ma = X.vertexNormals, la = X.normal, 4 === ma.length && wb) for (Ea = 0; 4 > Ea; Ea++) fc = ma[Ea], Ib[rb] = fc.x, Ib[rb + 1] = fc.y, Ib[rb + 2] = fc.z, rb += 3;
							else for (Ea = 0; 4 > Ea; Ea++) Ib[rb] = la.x, Ib[rb + 1] = la.y, Ib[rb + 2] = la.z, rb += 3;
							n.bindBuffer(n.ARRAY_BUFFER, U.__webglNormalBuffer);
							n.bufferData(n.ARRAY_BUFFER, Ib, ka)
						}
						if (tc && ad && ua) {
							K = 0;
							for (aa = Ca.length; K < aa; K++) if (Bb = Ca[K], qa = ad[Bb], void 0 !== qa) for (Ea = 0; 3 > Ea; Ea++) Gb = qa[Ea], vc[$b] = Gb.x, vc[$b + 1] = Gb.y, $b += 2;
							K = 0;
							for (aa = Da.length; K < aa; K++) if (Bb = Da[K], qa = ad[Bb], void 0 !== qa) for (Ea = 0; 4 > Ea; Ea++) Gb = qa[Ea], vc[$b] = Gb.x, vc[$b + 1] = Gb.y, $b += 2;
							0 < $b && (n.bindBuffer(n.ARRAY_BUFFER,
							U.__webglUVBuffer), n.bufferData(n.ARRAY_BUFFER, vc, ka))
						}
						if (tc && bd && ua) {
							K = 0;
							for (aa = Ca.length; K < aa; K++) if (Bb = Ca[K], ta = bd[Bb], void 0 !== ta) for (Ea = 0; 3 > Ea; Ea++) pc = ta[Ea], wc[ac] = pc.x, wc[ac + 1] = pc.y, ac += 2;
							K = 0;
							for (aa = Da.length; K < aa; K++) if (Bb = Da[K], ta = bd[Bb], void 0 !== ta) for (Ea = 0; 4 > Ea; Ea++) pc = ta[Ea], wc[ac] = pc.x, wc[ac + 1] = pc.y, ac += 2;
							0 < ac && (n.bindBuffer(n.ARRAY_BUFFER, U.__webglUV2Buffer), n.bufferData(n.ARRAY_BUFFER, wc, ka))
						}
						if (Ec) {
							K = 0;
							for (aa = Ca.length; K < aa; K++) Ub[Hb] = Za, Ub[Hb + 1] = Za + 1, Ub[Hb + 2] = Za + 2, Hb += 3, Cb[vb] = Za,
							Cb[vb + 1] = Za + 1, Cb[vb + 2] = Za, Cb[vb + 3] = Za + 2, Cb[vb + 4] = Za + 1, Cb[vb + 5] = Za + 2, vb += 6, Za += 3;
							K = 0;
							for (aa = Da.length; K < aa; K++) Ub[Hb] = Za, Ub[Hb + 1] = Za + 1, Ub[Hb + 2] = Za + 3, Ub[Hb + 3] = Za + 1, Ub[Hb + 4] = Za + 2, Ub[Hb + 5] = Za + 3, Hb += 6, Cb[vb] = Za, Cb[vb + 1] = Za + 1, Cb[vb + 2] = Za, Cb[vb + 3] = Za + 3, Cb[vb + 4] = Za + 1, Cb[vb + 5] = Za + 2, Cb[vb + 6] = Za + 2, Cb[vb + 7] = Za + 3, vb += 8, Za += 4;
							n.bindBuffer(n.ELEMENT_ARRAY_BUFFER, U.__webglFaceBuffer);
							n.bufferData(n.ELEMENT_ARRAY_BUFFER, Ub, ka);
							n.bindBuffer(n.ELEMENT_ARRAY_BUFFER, U.__webglLineBuffer);
							n.bufferData(n.ELEMENT_ARRAY_BUFFER,
							Cb, ka)
						}
						if ($c) {
							Ea = 0;
							for (Hc = $c.length; Ea < Hc; Ea++) if (y = $c[Ea], y.__original.needsUpdate) {
								B = 0;
								if (1 === y.size) if (void 0 === y.boundTo || "vertices" === y.boundTo) {
									K = 0;
									for (aa = Ca.length; K < aa; K++) X = sb[Ca[K]], y.array[B] = y.value[X.a], y.array[B + 1] = y.value[X.b], y.array[B + 2] = y.value[X.c], B += 3;
									K = 0;
									for (aa = Da.length; K < aa; K++) X = sb[Da[K]], y.array[B] = y.value[X.a], y.array[B + 1] = y.value[X.b], y.array[B + 2] = y.value[X.c], y.array[B + 3] = y.value[X.d], B += 4
								} else {
									if ("faces" === y.boundTo) {
										K = 0;
										for (aa = Ca.length; K < aa; K++) Ia = y.value[Ca[K]], y.array[B] = Ia, y.array[B + 1] = Ia, y.array[B + 2] = Ia, B += 3;
										K = 0;
										for (aa = Da.length; K < aa; K++) Ia = y.value[Da[K]], y.array[B] = Ia, y.array[B + 1] = Ia, y.array[B + 2] = Ia, y.array[B + 3] = Ia, B += 4
									}
								} else if (2 === y.size) if (void 0 === y.boundTo || "vertices" === y.boundTo) {
									K = 0;
									for (aa = Ca.length; K < aa; K++) X = sb[Ca[K]], Y = y.value[X.a], Z = y.value[X.b], $ = y.value[X.c], y.array[B] = Y.x, y.array[B + 1] = Y.y, y.array[B + 2] = Z.x, y.array[B + 3] = Z.y, y.array[B + 4] = $.x, y.array[B + 5] = $.y, B += 6;
									K = 0;
									for (aa = Da.length; K < aa; K++) X = sb[Da[K]], Y = y.value[X.a], Z = y.value[X.b], $ = y.value[X.c],
									za = y.value[X.d], y.array[B] = Y.x, y.array[B + 1] = Y.y, y.array[B + 2] = Z.x, y.array[B + 3] = Z.y, y.array[B + 4] = $.x, y.array[B + 5] = $.y, y.array[B + 6] = za.x, y.array[B + 7] = za.y, B += 8
								} else {
									if ("faces" === y.boundTo) {
										K = 0;
										for (aa = Ca.length; K < aa; K++) $ = Z = Y = Ia = y.value[Ca[K]], y.array[B] = Y.x, y.array[B + 1] = Y.y, y.array[B + 2] = Z.x, y.array[B + 3] = Z.y, y.array[B + 4] = $.x, y.array[B + 5] = $.y, B += 6;
										K = 0;
										for (aa = Da.length; K < aa; K++) za = $ = Z = Y = Ia = y.value[Da[K]], y.array[B] = Y.x, y.array[B + 1] = Y.y, y.array[B + 2] = Z.x, y.array[B + 3] = Z.y, y.array[B + 4] = $.x, y.array[B + 5] = $.y,
										y.array[B + 6] = za.x, y.array[B + 7] = za.y, B += 8
									}
								} else if (3 === y.size) {
									var ga;
									ga = "c" === y.type ? ["r", "g", "b"] : ["x", "y", "z"];
									if (void 0 === y.boundTo || "vertices" === y.boundTo) {
										K = 0;
										for (aa = Ca.length; K < aa; K++) X = sb[Ca[K]], Y = y.value[X.a], Z = y.value[X.b], $ = y.value[X.c], y.array[B] = Y[ga[0]], y.array[B + 1] = Y[ga[1]], y.array[B + 2] = Y[ga[2]], y.array[B + 3] = Z[ga[0]], y.array[B + 4] = Z[ga[1]], y.array[B + 5] = Z[ga[2]], y.array[B + 6] = $[ga[0]], y.array[B + 7] = $[ga[1]], y.array[B + 8] = $[ga[2]], B += 9;
										K = 0;
										for (aa = Da.length; K < aa; K++) X = sb[Da[K]], Y = y.value[X.a],
										Z = y.value[X.b], $ = y.value[X.c], za = y.value[X.d], y.array[B] = Y[ga[0]], y.array[B + 1] = Y[ga[1]], y.array[B + 2] = Y[ga[2]], y.array[B + 3] = Z[ga[0]], y.array[B + 4] = Z[ga[1]], y.array[B + 5] = Z[ga[2]], y.array[B + 6] = $[ga[0]], y.array[B + 7] = $[ga[1]], y.array[B + 8] = $[ga[2]], y.array[B + 9] = za[ga[0]], y.array[B + 10] = za[ga[1]], y.array[B + 11] = za[ga[2]], B += 12
									} else if ("faces" === y.boundTo) {
										K = 0;
										for (aa = Ca.length; K < aa; K++) $ = Z = Y = Ia = y.value[Ca[K]], y.array[B] = Y[ga[0]], y.array[B + 1] = Y[ga[1]], y.array[B + 2] = Y[ga[2]], y.array[B + 3] = Z[ga[0]], y.array[B + 4] = Z[ga[1]], y.array[B + 5] = Z[ga[2]], y.array[B + 6] = $[ga[0]], y.array[B + 7] = $[ga[1]], y.array[B + 8] = $[ga[2]], B += 9;
										K = 0;
										for (aa = Da.length; K < aa; K++) za = $ = Z = Y = Ia = y.value[Da[K]], y.array[B] = Y[ga[0]], y.array[B + 1] = Y[ga[1]], y.array[B + 2] = Y[ga[2]], y.array[B + 3] = Z[ga[0]], y.array[B + 4] = Z[ga[1]], y.array[B + 5] = Z[ga[2]], y.array[B + 6] = $[ga[0]], y.array[B + 7] = $[ga[1]], y.array[B + 8] = $[ga[2]], y.array[B + 9] = za[ga[0]], y.array[B + 10] = za[ga[1]], y.array[B + 11] = za[ga[2]], B += 12
									} else if ("faceVertices" === y.boundTo) {
										K = 0;
										for (aa = Ca.length; K < aa; K++) Ia = y.value[Ca[K]], Y = Ia[0], Z = Ia[1], $ = Ia[2], y.array[B] = Y[ga[0]], y.array[B + 1] = Y[ga[1]], y.array[B + 2] = Y[ga[2]], y.array[B + 3] = Z[ga[0]], y.array[B + 4] = Z[ga[1]], y.array[B + 5] = Z[ga[2]], y.array[B + 6] = $[ga[0]], y.array[B + 7] = $[ga[1]], y.array[B + 8] = $[ga[2]], B += 9;
										K = 0;
										for (aa = Da.length; K < aa; K++) Ia = y.value[Da[K]], Y = Ia[0], Z = Ia[1], $ = Ia[2], za = Ia[3], y.array[B] = Y[ga[0]], y.array[B + 1] = Y[ga[1]], y.array[B + 2] = Y[ga[2]], y.array[B + 3] = Z[ga[0]], y.array[B + 4] = Z[ga[1]], y.array[B + 5] = Z[ga[2]], y.array[B + 6] = $[ga[0]], y.array[B + 7] = $[ga[1]], y.array[B + 8] = $[ga[2]], y.array[B + 9] = za[ga[0]], y.array[B + 10] = za[ga[1]], y.array[B + 11] = za[ga[2]], B += 12
									}
								} else if (4 === y.size) if (void 0 === y.boundTo || "vertices" === y.boundTo) {
									K = 0;
									for (aa = Ca.length; K < aa; K++) X = sb[Ca[K]], Y = y.value[X.a], Z = y.value[X.b], $ = y.value[X.c], y.array[B] = Y.x, y.array[B + 1] = Y.y, y.array[B + 2] = Y.z, y.array[B + 3] = Y.w, y.array[B + 4] = Z.x, y.array[B + 5] = Z.y, y.array[B + 6] = Z.z, y.array[B + 7] = Z.w, y.array[B + 8] = $.x, y.array[B + 9] = $.y, y.array[B + 10] = $.z, y.array[B + 11] = $.w, B += 12;
									K = 0;
									for (aa = Da.length; K < aa; K++) X = sb[Da[K]], Y = y.value[X.a],
									Z = y.value[X.b], $ = y.value[X.c], za = y.value[X.d], y.array[B] = Y.x, y.array[B + 1] = Y.y, y.array[B + 2] = Y.z, y.array[B + 3] = Y.w, y.array[B + 4] = Z.x, y.array[B + 5] = Z.y, y.array[B + 6] = Z.z, y.array[B + 7] = Z.w, y.array[B + 8] = $.x, y.array[B + 9] = $.y, y.array[B + 10] = $.z, y.array[B + 11] = $.w, y.array[B + 12] = za.x, y.array[B + 13] = za.y, y.array[B + 14] = za.z, y.array[B + 15] = za.w, B += 16
								} else if ("faces" === y.boundTo) {
									K = 0;
									for (aa = Ca.length; K < aa; K++) $ = Z = Y = Ia = y.value[Ca[K]], y.array[B] = Y.x, y.array[B + 1] = Y.y, y.array[B + 2] = Y.z, y.array[B + 3] = Y.w, y.array[B + 4] = Z.x, y.array[B + 5] = Z.y, y.array[B + 6] = Z.z, y.array[B + 7] = Z.w, y.array[B + 8] = $.x, y.array[B + 9] = $.y, y.array[B + 10] = $.z, y.array[B + 11] = $.w, B += 12;
									K = 0;
									for (aa = Da.length; K < aa; K++) za = $ = Z = Y = Ia = y.value[Da[K]], y.array[B] = Y.x, y.array[B + 1] = Y.y, y.array[B + 2] = Y.z, y.array[B + 3] = Y.w, y.array[B + 4] = Z.x, y.array[B + 5] = Z.y, y.array[B + 6] = Z.z, y.array[B + 7] = Z.w, y.array[B + 8] = $.x, y.array[B + 9] = $.y, y.array[B + 10] = $.z, y.array[B + 11] = $.w, y.array[B + 12] = za.x, y.array[B + 13] = za.y, y.array[B + 14] = za.z, y.array[B + 15] = za.w, B += 16
								} else if ("faceVertices" === y.boundTo) {
									K = 0;
									for (aa = Ca.length; K < aa; K++) Ia = y.value[Ca[K]], Y = Ia[0], Z = Ia[1], $ = Ia[2], y.array[B] = Y.x, y.array[B + 1] = Y.y, y.array[B + 2] = Y.z, y.array[B + 3] = Y.w, y.array[B + 4] = Z.x, y.array[B + 5] = Z.y, y.array[B + 6] = Z.z, y.array[B + 7] = Z.w, y.array[B + 8] = $.x, y.array[B + 9] = $.y, y.array[B + 10] = $.z, y.array[B + 11] = $.w, B += 12;
									K = 0;
									for (aa = Da.length; K < aa; K++) Ia = y.value[Da[K]], Y = Ia[0], Z = Ia[1], $ = Ia[2], za = Ia[3], y.array[B] = Y.x, y.array[B + 1] = Y.y, y.array[B + 2] = Y.z, y.array[B + 3] = Y.w, y.array[B + 4] = Z.x, y.array[B + 5] = Z.y, y.array[B + 6] = Z.z, y.array[B + 7] = Z.w, y.array[B + 8] = $.x,
									y.array[B + 9] = $.y, y.array[B + 10] = $.z, y.array[B + 11] = $.w, y.array[B + 12] = za.x, y.array[B + 13] = za.y, y.array[B + 14] = za.z, y.array[B + 15] = za.w, B += 16
								}
								n.bindBuffer(n.ARRAY_BUFFER, y.buffer);
								n.bufferData(n.ARRAY_BUFFER, y.array, ka)
							}
						}
						Aa && (delete U.__inittedArrays, delete U.__colorArray, delete U.__normalArray, delete U.__tangentArray, delete U.__uvArray, delete U.__uv2Array, delete U.__faceArray, delete U.__vertexArray, delete U.__lineArray, delete U.__skinIndexArray, delete U.__skinWeightArray)
					}
				}
				N.verticesNeedUpdate = !1;
				N.morphTargetsNeedUpdate = !1;
				N.elementsNeedUpdate = !1;
				N.uvsNeedUpdate = !1;
				N.normalsNeedUpdate = !1;
				N.colorsNeedUpdate = !1;
				N.tangentsNeedUpdate = !1;
				N.buffersNeedUpdate = !1;
				W.attributes && x(W)
			} else if (ca instanceof THREE.Ribbon) {
				W = e(ca, N);
				ba = W.attributes && u(W);
				if (N.verticesNeedUpdate || N.colorsNeedUpdate || N.normalsNeedUpdate || ba) {
					var Jb = N,
						Jc = n.DYNAMIC_DRAW,
						xc = void 0,
						yc = void 0,
						zc = void 0,
						Kc = void 0,
						Ja = void 0,
						Lc = void 0,
						Mc = void 0,
						Nc = void 0,
						id = void 0,
						pb = void 0,
						qc = void 0,
						Oa = void 0,
						yb = void 0,
						jd = Jb.vertices,
						kd = Jb.colors,
						ld = Jb.normals,
						wd = jd.length,
						xd = kd.length,
						yd = ld.length,
						Oc = Jb.__vertexArray,
						Pc = Jb.__colorArray,
						Qc = Jb.__normalArray,
						zd = Jb.colorsNeedUpdate,
						Ad = Jb.normalsNeedUpdate,
						cd = Jb.__webglCustomAttributesList;
					if (Jb.verticesNeedUpdate) {
						for (xc = 0; xc < wd; xc++) Kc = jd[xc], Ja = 3 * xc, Oc[Ja] = Kc.x, Oc[Ja + 1] = Kc.y, Oc[Ja + 2] = Kc.z;
						n.bindBuffer(n.ARRAY_BUFFER, Jb.__webglVertexBuffer);
						n.bufferData(n.ARRAY_BUFFER, Oc, Jc)
					}
					if (zd) {
						for (yc = 0; yc < xd; yc++) Lc = kd[yc], Ja = 3 * yc, Pc[Ja] = Lc.r, Pc[Ja + 1] = Lc.g, Pc[Ja + 2] = Lc.b;
						n.bindBuffer(n.ARRAY_BUFFER, Jb.__webglColorBuffer);
						n.bufferData(n.ARRAY_BUFFER,
						Pc, Jc)
					}
					if (Ad) {
						for (zc = 0; zc < yd; zc++) Mc = ld[zc], Ja = 3 * zc, Qc[Ja] = Mc.x, Qc[Ja + 1] = Mc.y, Qc[Ja + 2] = Mc.z;
						n.bindBuffer(n.ARRAY_BUFFER, Jb.__webglNormalBuffer);
						n.bufferData(n.ARRAY_BUFFER, Qc, Jc)
					}
					if (cd) {
						Nc = 0;
						for (id = cd.length; Nc < id; Nc++) if (Oa = cd[Nc], Oa.needsUpdate && (void 0 === Oa.boundTo || "vertices" === Oa.boundTo)) {
							Ja = 0;
							qc = Oa.value.length;
							if (1 === Oa.size) for (pb = 0; pb < qc; pb++) Oa.array[pb] = Oa.value[pb];
							else if (2 === Oa.size) for (pb = 0; pb < qc; pb++) yb = Oa.value[pb], Oa.array[Ja] = yb.x, Oa.array[Ja + 1] = yb.y, Ja += 2;
							else if (3 === Oa.size) if ("c" === Oa.type) for (pb = 0; pb < qc; pb++) yb = Oa.value[pb], Oa.array[Ja] = yb.r, Oa.array[Ja + 1] = yb.g, Oa.array[Ja + 2] = yb.b, Ja += 3;
							else for (pb = 0; pb < qc; pb++) yb = Oa.value[pb], Oa.array[Ja] = yb.x, Oa.array[Ja + 1] = yb.y, Oa.array[Ja + 2] = yb.z, Ja += 3;
							else if (4 === Oa.size) for (pb = 0; pb < qc; pb++) yb = Oa.value[pb], Oa.array[Ja] = yb.x, Oa.array[Ja + 1] = yb.y, Oa.array[Ja + 2] = yb.z, Oa.array[Ja + 3] = yb.w, Ja += 4;
							n.bindBuffer(n.ARRAY_BUFFER, Oa.buffer);
							n.bufferData(n.ARRAY_BUFFER, Oa.array, Jc)
						}
					}
				}
				N.verticesNeedUpdate = !1;
				N.colorsNeedUpdate = !1;
				N.normalsNeedUpdate = !1;
				W.attributes && x(W)
			} else if (ca instanceof THREE.Line) {
				W = e(ca, N);
				ba = W.attributes && u(W);
				if (N.verticesNeedUpdate || N.colorsNeedUpdate || N.lineDistancesNeedUpdate || ba) {
					var Kb = N,
						Rc = n.DYNAMIC_DRAW,
						Ac = void 0,
						Bc = void 0,
						Cc = void 0,
						Sc = void 0,
						Ta = void 0,
						Tc = void 0,
						md = Kb.vertices,
						nd = Kb.colors,
						od = Kb.lineDistances,
						Bd = md.length,
						Cd = nd.length,
						Dd = od.length,
						Uc = Kb.__vertexArray,
						Vc = Kb.__colorArray,
						pd = Kb.__lineDistanceArray,
						Ed = Kb.colorsNeedUpdate,
						Fd = Kb.lineDistancesNeedUpdate,
						dd = Kb.__webglCustomAttributesList,
						Wc = void 0,
						qd = void 0,
						qb = void 0,
						rc = void 0,
						zb = void 0,
						Pa = void 0;
					if (Kb.verticesNeedUpdate) {
						for (Ac = 0; Ac < Bd; Ac++) Sc = md[Ac], Ta = 3 * Ac, Uc[Ta] = Sc.x, Uc[Ta + 1] = Sc.y, Uc[Ta + 2] = Sc.z;
						n.bindBuffer(n.ARRAY_BUFFER, Kb.__webglVertexBuffer);
						n.bufferData(n.ARRAY_BUFFER, Uc, Rc)
					}
					if (Ed) {
						for (Bc = 0; Bc < Cd; Bc++) Tc = nd[Bc], Ta = 3 * Bc, Vc[Ta] = Tc.r, Vc[Ta + 1] = Tc.g, Vc[Ta + 2] = Tc.b;
						n.bindBuffer(n.ARRAY_BUFFER, Kb.__webglColorBuffer);
						n.bufferData(n.ARRAY_BUFFER, Vc, Rc)
					}
					if (Fd) {
						for (Cc = 0; Cc < Dd; Cc++) pd[Cc] = od[Cc];
						n.bindBuffer(n.ARRAY_BUFFER, Kb.__webglLineDistanceBuffer);
						n.bufferData(n.ARRAY_BUFFER, pd, Rc)
					}
					if (dd) {
						Wc = 0;
						for (qd = dd.length; Wc < qd; Wc++) if (Pa = dd[Wc], Pa.needsUpdate && (void 0 === Pa.boundTo || "vertices" === Pa.boundTo)) {
							Ta = 0;
							rc = Pa.value.length;
							if (1 === Pa.size) for (qb = 0; qb < rc; qb++) Pa.array[qb] = Pa.value[qb];
							else if (2 === Pa.size) for (qb = 0; qb < rc; qb++) zb = Pa.value[qb], Pa.array[Ta] = zb.x, Pa.array[Ta + 1] = zb.y, Ta += 2;
							else if (3 === Pa.size) if ("c" === Pa.type) for (qb = 0; qb < rc; qb++) zb = Pa.value[qb], Pa.array[Ta] = zb.r, Pa.array[Ta + 1] = zb.g, Pa.array[Ta + 2] = zb.b, Ta += 3;
							else for (qb = 0; qb < rc; qb++) zb = Pa.value[qb], Pa.array[Ta] = zb.x, Pa.array[Ta + 1] = zb.y, Pa.array[Ta + 2] = zb.z, Ta += 3;
							else if (4 === Pa.size) for (qb = 0; qb < rc; qb++) zb = Pa.value[qb], Pa.array[Ta] = zb.x, Pa.array[Ta + 1] = zb.y, Pa.array[Ta + 2] = zb.z, Pa.array[Ta + 3] = zb.w, Ta += 4;
							n.bindBuffer(n.ARRAY_BUFFER, Pa.buffer);
							n.bufferData(n.ARRAY_BUFFER, Pa.array, Rc)
						}
					}
				}
				N.verticesNeedUpdate = !1;
				N.colorsNeedUpdate = !1;
				N.lineDistancesNeedUpdate = !1;
				W.attributes && x(W)
			} else if (ca instanceof THREE.ParticleSystem) if (N instanceof THREE.BufferGeometry)(N.verticesNeedUpdate || N.colorsNeedUpdate) && i(N, n.DYNAMIC_DRAW, !N.dynamic), N.verticesNeedUpdate = !1, N.colorsNeedUpdate = !1;
			else {
				W = e(ca, N);
				ba = W.attributes && u(W);
				if (N.verticesNeedUpdate || N.colorsNeedUpdate || ca.sortParticles || ba) {
					var Vb = N,
						ed = n.DYNAMIC_DRAW,
						Dc = ca,
						Ab = void 0,
						Wb = void 0,
						Xb = void 0,
						ja = void 0,
						Yb = void 0,
						jc = void 0,
						Xc = Vb.vertices,
						fd = Xc.length,
						gd = Vb.colors,
						rd = gd.length,
						nc = Vb.__vertexArray,
						oc = Vb.__colorArray,
						bc = Vb.__sortArray,
						sd = Vb.verticesNeedUpdate,
						td = Vb.colorsNeedUpdate,
						cc = Vb.__webglCustomAttributesList,
						Ob = void 0,
						sc = void 0,
						xa = void 0,
						Pb = void 0,
						Ma = void 0,
						ia = void 0;
					if (Dc.sortParticles) {
						Db.copy(Ya);
						Db.multiplySelf(Dc.matrixWorld);
						for (Ab = 0; Ab < fd; Ab++) Xb = Xc[Ab], tb.copy(Xb), tb.applyProjection(DB)/*CHANGEDDb.multiplyVector3(tb)*/, bc[Ab] = [tb.z, Ab];
						bc.sort(m);
						for (Ab = 0; Ab < fd; Ab++) Xb = Xc[bc[Ab][1]], ja = 3 * Ab, nc[ja] = Xb.x, nc[ja + 1] = Xb.y, nc[ja + 2] = Xb.z;
						for (Wb = 0; Wb < rd; Wb++) ja = 3 * Wb, jc = gd[bc[Wb][1]], oc[ja] = jc.r, oc[ja + 1] = jc.g, oc[ja + 2] = jc.b;
						if (cc) {
							Ob = 0;
							for (sc = cc.length; Ob < sc; Ob++) if (ia = cc[Ob], void 0 === ia.boundTo || "vertices" === ia.boundTo) if (ja = 0, Pb = ia.value.length, 1 === ia.size) for (xa = 0; xa < Pb; xa++) Yb = bc[xa][1], ia.array[xa] = ia.value[Yb];
							else if (2 === ia.size) for (xa = 0; xa < Pb; xa++) Yb = bc[xa][1], Ma = ia.value[Yb], ia.array[ja] = Ma.x, ia.array[ja + 1] = Ma.y, ja += 2;
							else if (3 === ia.size) if ("c" === ia.type) for (xa = 0; xa < Pb; xa++) Yb = bc[xa][1], Ma = ia.value[Yb], ia.array[ja] = Ma.r, ia.array[ja + 1] = Ma.g, ia.array[ja + 2] = Ma.b, ja += 3;
							else for (xa = 0; xa < Pb; xa++) Yb = bc[xa][1], Ma = ia.value[Yb], ia.array[ja] = Ma.x, ia.array[ja + 1] = Ma.y, ia.array[ja + 2] = Ma.z, ja += 3;
							else if (4 === ia.size) for (xa = 0; xa < Pb; xa++) Yb = bc[xa][1], Ma = ia.value[Yb], ia.array[ja] = Ma.x,
							ia.array[ja + 1] = Ma.y, ia.array[ja + 2] = Ma.z, ia.array[ja + 3] = Ma.w, ja += 4
						}
					} else {
						if (sd) for (Ab = 0; Ab < fd; Ab++) Xb = Xc[Ab], ja = 3 * Ab, nc[ja] = Xb.x, nc[ja + 1] = Xb.y, nc[ja + 2] = Xb.z;
						if (td) for (Wb = 0; Wb < rd; Wb++) jc = gd[Wb], ja = 3 * Wb, oc[ja] = jc.r, oc[ja + 1] = jc.g, oc[ja + 2] = jc.b;
						if (cc) {
							Ob = 0;
							for (sc = cc.length; Ob < sc; Ob++) if (ia = cc[Ob], ia.needsUpdate && (void 0 === ia.boundTo || "vertices" === ia.boundTo)) if (Pb = ia.value.length, ja = 0, 1 === ia.size) for (xa = 0; xa < Pb; xa++) ia.array[xa] = ia.value[xa];
							else if (2 === ia.size) for (xa = 0; xa < Pb; xa++) Ma = ia.value[xa], ia.array[ja] = Ma.x, ia.array[ja + 1] = Ma.y, ja += 2;
							else if (3 === ia.size) if ("c" === ia.type) for (xa = 0; xa < Pb; xa++) Ma = ia.value[xa], ia.array[ja] = Ma.r, ia.array[ja + 1] = Ma.g, ia.array[ja + 2] = Ma.b, ja += 3;
							else for (xa = 0; xa < Pb; xa++) Ma = ia.value[xa], ia.array[ja] = Ma.x, ia.array[ja + 1] = Ma.y, ia.array[ja + 2] = Ma.z, ja += 3;
							else if (4 === ia.size) for (xa = 0; xa < Pb; xa++) Ma = ia.value[xa], ia.array[ja] = Ma.x, ia.array[ja + 1] = Ma.y, ia.array[ja + 2] = Ma.z, ia.array[ja + 3] = Ma.w, ja += 4
						}
					}
					if (sd || Dc.sortParticles) n.bindBuffer(n.ARRAY_BUFFER, Vb.__webglVertexBuffer), n.bufferData(n.ARRAY_BUFFER,
					nc, ed);
					if (td || Dc.sortParticles) n.bindBuffer(n.ARRAY_BUFFER, Vb.__webglColorBuffer), n.bufferData(n.ARRAY_BUFFER, oc, ed);
					if (cc) {
						Ob = 0;
						for (sc = cc.length; Ob < sc; Ob++) if (ia = cc[Ob], ia.needsUpdate || Dc.sortParticles) n.bindBuffer(n.ARRAY_BUFFER, ia.buffer), n.bufferData(n.ARRAY_BUFFER, ia.array, ed)
					}
				}
				N.verticesNeedUpdate = !1;
				N.colorsNeedUpdate = !1;
				W.attributes && x(W)
			}
		}
	};
	this.initMaterial = function (a, b, c, d) {
		var e, f, g, h;
		a.addEventListener("dispose", Fc);
		var i, j, k, m, l;
		a instanceof THREE.MeshDepthMaterial ? l = "depth" : a instanceof
		THREE.MeshNormalMaterial ? l = "normal" : a instanceof THREE.MeshBasicMaterial ? l = "basic" : a instanceof THREE.MeshLambertMaterial ? l = "lambert" : a instanceof THREE.MeshPhongMaterial ? l = "phong" : a instanceof THREE.LineBasicMaterial ? l = "basic" : a instanceof THREE.LineDashedMaterial ? l = "dashed" : a instanceof THREE.ParticleBasicMaterial && (l = "particle_basic");
		if (l) {
			var p = THREE.ShaderLib[l];
			a.uniforms = THREE.UniformsUtils.clone(p.uniforms);
			a.vertexShader = p.vertexShader;
			a.fragmentShader = p.fragmentShader
		}
		var r, q, S;
		e = g = q = S = p = 0;
		for (f = b.length; e < f; e++) r = b[e], r.onlyShadow || (r instanceof THREE.DirectionalLight && g++, r instanceof THREE.PointLight && q++, r instanceof THREE.SpotLight && S++, r instanceof THREE.HemisphereLight && p++);
		e = g;
		f = q;
		g = S;
		h = p;
		p = r = 0;
		for (S = b.length; p < S; p++) q = b[p], q.castShadow && (q instanceof THREE.SpotLight && r++, q instanceof THREE.DirectionalLight && !q.shadowCascade && r++);
		m = r;
		jb && d && d.useVertexTexture ? k = 1024 : (b = n.getParameter(n.MAX_VERTEX_UNIFORM_VECTORS), b = Math.floor((b - 20) / 4), void 0 !== d && d instanceof THREE.SkinnedMesh && (b = Math.min(d.bones.length, b), b < d.bones.length && console.warn("WebGLRenderer: too many bones - " + d.bones.length + ", this GPU supports just " + b + " (try OpenGL instead of ANGLE)")), k = b);
		a: {
			q = a.fragmentShader;
			S = a.vertexShader;
			p = a.uniforms;
			b = a.attributes;
			r = a.defines;
			var c = {
				map: !! a.map,
				envMap: !! a.envMap,
				lightMap: !! a.lightMap,
				bumpMap: !! a.bumpMap,
				normalMap: !! a.normalMap,
				specularMap: !! a.specularMap,
				vertexColors: a.vertexColors,
				fog: c,
				useFog: a.fog,
				fogExp: c instanceof THREE.FogExp2,
				sizeAttenuation: a.sizeAttenuation,
				skinning: a.skinning,
				maxBones: k,
				useVertexTexture: jb && d && d.useVertexTexture,
				boneTextureWidth: d && d.boneTextureWidth,
				boneTextureHeight: d && d.boneTextureHeight,
				morphTargets: a.morphTargets,
				morphNormals: a.morphNormals,
				maxMorphTargets: this.maxMorphTargets,
				maxMorphNormals: this.maxMorphNormals,
				maxDirLights: e,
				maxPointLights: f,
				maxSpotLights: g,
				maxHemiLights: h,
				maxShadows: m,
				shadowMapEnabled: this.shadowMapEnabled && d.receiveShadow,
				shadowMapType: this.shadowMapType,
				shadowMapDebug: this.shadowMapDebug,
				shadowMapCascade: this.shadowMapCascade,
				alphaTest: a.alphaTest,
				metal: a.metal,
				perPixel: a.perPixel,
				wrapAround: a.wrapAround,
				doubleSided: a.side === THREE.DoubleSide,
				flipSided: a.side === THREE.BackSide
			}, s, t, u, d = [];
			l ? d.push(l) : (d.push(q), d.push(S));
			for (t in r) d.push(t), d.push(r[t]);
			for (s in c) d.push(s), d.push(c[s]);
			l = d.join();
			s = 0;
			for (t = da.length; s < t; s++) if (d = da[s], d.code === l) {
				d.usedTimes++;
				j = d.program;
				break a
			}
			s = "SHADOWMAP_TYPE_BASIC";
			c.shadowMapType === THREE.PCFShadowMap ? s = "SHADOWMAP_TYPE_PCF" : c.shadowMapType === THREE.PCFSoftShadowMap && (s = "SHADOWMAP_TYPE_PCF_SOFT");
			t = [];
			for (u in r) d = r[u], !1 !== d && (d = "#define " + u + " " + d, t.push(d));
			d = t.join("\n");
			u = n.createProgram();
			t = ["precision " + Q + " float;", d, fb ? "#define VERTEX_TEXTURES" : "", L.gammaInput ? "#define GAMMA_INPUT" : "", L.gammaOutput ? "#define GAMMA_OUTPUT" : "", L.physicallyBasedShading ? "#define PHYSICALLY_BASED_SHADING" : "", "#define MAX_DIR_LIGHTS " + c.maxDirLights, "#define MAX_POINT_LIGHTS " + c.maxPointLights, "#define MAX_SPOT_LIGHTS " + c.maxSpotLights, "#define MAX_HEMI_LIGHTS " + c.maxHemiLights, "#define MAX_SHADOWS " + c.maxShadows,
				"#define MAX_BONES " + c.maxBones, c.map ? "#define USE_MAP" : "", c.envMap ? "#define USE_ENVMAP" : "", c.lightMap ? "#define USE_LIGHTMAP" : "", c.bumpMap ? "#define USE_BUMPMAP" : "", c.normalMap ? "#define USE_NORMALMAP" : "", c.specularMap ? "#define USE_SPECULARMAP" : "", c.vertexColors ? "#define USE_COLOR" : "", c.skinning ? "#define USE_SKINNING" : "", c.useVertexTexture ? "#define BONE_TEXTURE" : "", c.boneTextureWidth ? "#define N_BONE_PIXEL_X " + c.boneTextureWidth.toFixed(1) : "", c.boneTextureHeight ? "#define N_BONE_PIXEL_Y " + c.boneTextureHeight.toFixed(1) :
				"", c.morphTargets ? "#define USE_MORPHTARGETS" : "", c.morphNormals ? "#define USE_MORPHNORMALS" : "", c.perPixel ? "#define PHONG_PER_PIXEL" : "", c.wrapAround ? "#define WRAP_AROUND" : "", c.doubleSided ? "#define DOUBLE_SIDED" : "", c.flipSided ? "#define FLIP_SIDED" : "", c.shadowMapEnabled ? "#define USE_SHADOWMAP" : "", c.shadowMapEnabled ? "#define " + s : "", c.shadowMapDebug ? "#define SHADOWMAP_DEBUG" : "", c.shadowMapCascade ? "#define SHADOWMAP_CASCADE" : "", c.sizeAttenuation ? "#define USE_SIZEATTENUATION" : "", "uniform mat4 modelMatrix;\nuniform mat4 modelViewMatrix;\nuniform mat4 projectionMatrix;\nuniform mat4 viewMatrix;\nuniform mat3 normalMatrix;\nuniform vec3 cameraPosition;\nattribute vec3 position;\nattribute vec3 normal;\nattribute vec2 uv;\nattribute vec2 uv2;\n#ifdef USE_COLOR\nattribute vec3 color;\n#endif\n#ifdef USE_MORPHTARGETS\nattribute vec3 morphTarget0;\nattribute vec3 morphTarget1;\nattribute vec3 morphTarget2;\nattribute vec3 morphTarget3;\n#ifdef USE_MORPHNORMALS\nattribute vec3 morphNormal0;\nattribute vec3 morphNormal1;\nattribute vec3 morphNormal2;\nattribute vec3 morphNormal3;\n#else\nattribute vec3 morphTarget4;\nattribute vec3 morphTarget5;\nattribute vec3 morphTarget6;\nattribute vec3 morphTarget7;\n#endif\n#endif\n#ifdef USE_SKINNING\nattribute vec4 skinIndex;\nattribute vec4 skinWeight;\n#endif\n"].join("\n");
			s = ["precision " + Q + " float;", c.bumpMap || c.normalMap ? "#extension GL_OES_standard_derivatives : enable" : "", d, "#define MAX_DIR_LIGHTS " + c.maxDirLights, "#define MAX_POINT_LIGHTS " + c.maxPointLights, "#define MAX_SPOT_LIGHTS " + c.maxSpotLights, "#define MAX_HEMI_LIGHTS " + c.maxHemiLights, "#define MAX_SHADOWS " + c.maxShadows, c.alphaTest ? "#define ALPHATEST " + c.alphaTest : "", L.gammaInput ? "#define GAMMA_INPUT" : "", L.gammaOutput ? "#define GAMMA_OUTPUT" : "", L.physicallyBasedShading ? "#define PHYSICALLY_BASED_SHADING" : "",
			c.useFog && c.fog ? "#define USE_FOG" : "", c.useFog && c.fogExp ? "#define FOG_EXP2" : "", c.map ? "#define USE_MAP" : "", c.envMap ? "#define USE_ENVMAP" : "", c.lightMap ? "#define USE_LIGHTMAP" : "", c.bumpMap ? "#define USE_BUMPMAP" : "", c.normalMap ? "#define USE_NORMALMAP" : "", c.specularMap ? "#define USE_SPECULARMAP" : "", c.vertexColors ? "#define USE_COLOR" : "", c.metal ? "#define METAL" : "", c.perPixel ? "#define PHONG_PER_PIXEL" : "", c.wrapAround ? "#define WRAP_AROUND" : "", c.doubleSided ? "#define DOUBLE_SIDED" : "", c.flipSided ? "#define FLIP_SIDED" :
				"", c.shadowMapEnabled ? "#define USE_SHADOWMAP" : "", c.shadowMapEnabled ? "#define " + s : "", c.shadowMapDebug ? "#define SHADOWMAP_DEBUG" : "", c.shadowMapCascade ? "#define SHADOWMAP_CASCADE" : "", "uniform mat4 viewMatrix;\nuniform vec3 cameraPosition;\n"].join("\n");
			s = V("fragment", s + q);
			t = V("vertex", t + S);
			n.attachShader(u, t);
			n.attachShader(u, s);
			n.linkProgram(u);
			n.getProgramParameter(u, n.LINK_STATUS) || console.error("Could not initialise shader\nVALIDATE_STATUS: " + n.getProgramParameter(u, n.VALIDATE_STATUS) + ", gl error [" + n.getError() + "]");
			n.deleteShader(s);
			n.deleteShader(t);
			u.uniforms = {};
			u.attributes = {};
			var pa;
			s = "viewMatrix modelViewMatrix projectionMatrix normalMatrix modelMatrix cameraPosition morphTargetInfluences".split(" ");
			c.useVertexTexture ? s.push("boneTexture") : s.push("boneGlobalMatrices");
			for (pa in p) s.push(pa);
			pa = s;
			s = 0;
			for (t = pa.length; s < t; s++) p = pa[s], u.uniforms[p] = n.getUniformLocation(u, p);
			s = "position normal uv uv2 tangent color skinIndex skinWeight lineDistance".split(" ");
			for (pa = 0; pa < c.maxMorphTargets; pa++) s.push("morphTarget" + pa);
			for (pa = 0; pa < c.maxMorphNormals; pa++) s.push("morphNormal" + pa);
			for (j in b) s.push(j);
			j = s;
			pa = 0;
			for (b = j.length; pa < b; pa++) s = j[pa], u.attributes[s] = n.getAttribLocation(u, s);
			u.id = ca++;
			da.push({
				program: u,
				code: l,
				usedTimes: 1
			});
			L.info.memory.programs = da.length;
			j = u
		}
		a.program = j;
		pa = a.program.attributes;
		if (a.morphTargets) {
			a.numSupportedMorphTargets = 0;
			b = "morphTarget";
			for (j = 0; j < this.maxMorphTargets; j++) u = b + j, 0 <= pa[u] && a.numSupportedMorphTargets++
		}
		if (a.morphNormals) {
			a.numSupportedMorphNormals = 0;
			b = "morphNormal";
			for (j = 0; j < this.maxMorphNormals; j++) u = b + j, 0 <= pa[u] && a.numSupportedMorphNormals++
		}
		a.uniformsList = [];
		for (i in a.uniforms) a.uniformsList.push([a.uniforms[i], i])
	};
	this.setFaceCulling = function (a, b) {
		a === THREE.CullFaceNone ? n.disable(n.CULL_FACE) : (b === THREE.FrontFaceDirectionCW ? n.frontFace(n.CW) : n.frontFace(n.CCW), a === THREE.CullFaceBack ? n.cullFace(n.BACK) : a === THREE.CullFaceFront ? n.cullFace(n.FRONT) : n.cullFace(n.FRONT_AND_BACK), n.enable(n.CULL_FACE))
	};
	this.setMaterialFaces = function (a) {
		var b = a.side === THREE.DoubleSide,
			a = a.side === THREE.BackSide;
		qa !== b && (b ? n.disable(n.CULL_FACE) : n.enable(n.CULL_FACE), qa = b);
		na !== a && (a ? n.frontFace(n.CW) : n.frontFace(n.CCW), na = a)
	};
	this.setDepthTest = function (a) {
		Va !== a && (a ? n.enable(n.DEPTH_TEST) : n.disable(n.DEPTH_TEST), Va = a)
	};
	this.setDepthWrite = function (a) {
		ib !== a && (n.depthMask(a), ib = a)
	};
	this.setBlending = function (a, b, c, d) {
		a !== ta && (a === THREE.NoBlending ? n.disable(n.BLEND) : a === THREE.AdditiveBlending ? (n.enable(n.BLEND), n.blendEquation(n.FUNC_ADD), n.blendFunc(n.SRC_ALPHA, n.ONE)) : a === THREE.SubtractiveBlending ? (n.enable(n.BLEND), n.blendEquation(n.FUNC_ADD), n.blendFunc(n.ZERO, n.ONE_MINUS_SRC_COLOR)) : a === THREE.MultiplyBlending ? (n.enable(n.BLEND), n.blendEquation(n.FUNC_ADD), n.blendFunc(n.ZERO, n.SRC_COLOR)) : a === THREE.CustomBlending ? n.enable(n.BLEND) : (n.enable(n.BLEND), n.blendEquationSeparate(n.FUNC_ADD, n.FUNC_ADD), n.blendFuncSeparate(n.SRC_ALPHA, n.ONE_MINUS_SRC_ALPHA, n.ONE, n.ONE_MINUS_SRC_ALPHA)), ta = a);
		if (a === THREE.CustomBlending) {
			if (b !== Ga && (n.blendEquation(J(b)), Ga = b), c !== ra || d !== Ua) n.blendFunc(J(c), J(d)),
			ra = c, Ua = d
		} else Ua = ra = Ga = null
	};
	this.setTexture = function (a, b) {
		if (a.needsUpdate) {
			a.__webglInit || (a.__webglInit = !0, a.addEventListener("dispose", Ec), a.__webglTexture = n.createTexture(), L.info.memory.textures++);
			n.activeTexture(n.TEXTURE0 + b);
			n.bindTexture(n.TEXTURE_2D, a.__webglTexture);
			n.pixelStorei(n.UNPACK_FLIP_Y_WEBGL, a.flipY);
			n.pixelStorei(n.UNPACK_PREMULTIPLY_ALPHA_WEBGL, a.premultiplyAlpha);
			n.pixelStorei(n.UNPACK_ALIGNMENT, a.unpackAlignment);
			var c = a.image,
				d = 0 === (c.width & c.width - 1) && 0 === (c.height & c.height - 1),
				e = J(a.format),
				f = J(a.type);
			E(n.TEXTURE_2D, a, d);
			var g = a.mipmaps;
			if (a instanceof THREE.DataTexture) if (0 < g.length && d) {
				for (var h = 0, i = g.length; h < i; h++) c = g[h], n.texImage2D(n.TEXTURE_2D, h, e, c.width, c.height, 0, e, f, c.data);
				a.generateMipmaps = !1
			} else n.texImage2D(n.TEXTURE_2D, 0, e, c.width, c.height, 0, e, f, c.data);
			else if (a instanceof THREE.CompressedTexture) {
				h = 0;
				for (i = g.length; h < i; h++) c = g[h], n.compressedTexImage2D(n.TEXTURE_2D, h, e, c.width, c.height, 0, c.data)
			} else if (0 < g.length && d) {
				h = 0;
				for (i = g.length; h < i; h++) c = g[h], n.texImage2D(n.TEXTURE_2D, h, e, e, f, c);
				a.generateMipmaps = !1
			} else n.texImage2D(n.TEXTURE_2D, 0, e, e, f, a.image);
			a.generateMipmaps && d && n.generateMipmap(n.TEXTURE_2D);
			a.needsUpdate = !1;
			if (a.onUpdate) a.onUpdate()
		} else n.activeTexture(n.TEXTURE0 + b), n.bindTexture(n.TEXTURE_2D, a.__webglTexture)
	};
	this.setRenderTarget = function (a) {
		var b = a instanceof THREE.WebGLRenderTargetCube;
		if (a && !a.__webglFramebuffer) {
			void 0 === a.depthBuffer && (a.depthBuffer = !0);
			void 0 === a.stencilBuffer && (a.stencilBuffer = !0);
			a.addEventListener("dispose",
			tc);
			a.__webglTexture = n.createTexture();
			L.info.memory.textures++;
			var c = 0 === (a.width & a.width - 1) && 0 === (a.height & a.height - 1),
				d = J(a.format),
				e = J(a.type);
			if (b) {
				a.__webglFramebuffer = [];
				a.__webglRenderbuffer = [];
				n.bindTexture(n.TEXTURE_CUBE_MAP, a.__webglTexture);
				E(n.TEXTURE_CUBE_MAP, a, c);
				for (var f = 0; 6 > f; f++) {
					a.__webglFramebuffer[f] = n.createFramebuffer();
					a.__webglRenderbuffer[f] = n.createRenderbuffer();
					n.texImage2D(n.TEXTURE_CUBE_MAP_POSITIVE_X + f, 0, d, a.width, a.height, 0, d, e, null);
					var g = a,
						h = n.TEXTURE_CUBE_MAP_POSITIVE_X + f;
					n.bindFramebuffer(n.FRAMEBUFFER, a.__webglFramebuffer[f]);
					n.framebufferTexture2D(n.FRAMEBUFFER, n.COLOR_ATTACHMENT0, h, g.__webglTexture, 0);
					O(a.__webglRenderbuffer[f], a)
				}
				c && n.generateMipmap(n.TEXTURE_CUBE_MAP)
			} else a.__webglFramebuffer = n.createFramebuffer(), a.__webglRenderbuffer = a.shareDepthFrom ? a.shareDepthFrom.__webglRenderbuffer : n.createRenderbuffer(), n.bindTexture(n.TEXTURE_2D, a.__webglTexture), E(n.TEXTURE_2D, a, c), n.texImage2D(n.TEXTURE_2D, 0, d, a.width, a.height, 0, d, e, null), d = n.TEXTURE_2D, n.bindFramebuffer(n.FRAMEBUFFER,
			a.__webglFramebuffer), n.framebufferTexture2D(n.FRAMEBUFFER, n.COLOR_ATTACHMENT0, d, a.__webglTexture, 0), a.shareDepthFrom ? a.depthBuffer && !a.stencilBuffer ? n.framebufferRenderbuffer(n.FRAMEBUFFER, n.DEPTH_ATTACHMENT, n.RENDERBUFFER, a.__webglRenderbuffer) : a.depthBuffer && a.stencilBuffer && n.framebufferRenderbuffer(n.FRAMEBUFFER, n.DEPTH_STENCIL_ATTACHMENT, n.RENDERBUFFER, a.__webglRenderbuffer) : O(a.__webglRenderbuffer, a), c && n.generateMipmap(n.TEXTURE_2D);
			b ? n.bindTexture(n.TEXTURE_CUBE_MAP, null) : n.bindTexture(n.TEXTURE_2D,
			null);
			n.bindRenderbuffer(n.RENDERBUFFER, null);
			n.bindFramebuffer(n.FRAMEBUFFER, null)
		}
		a ? (b = b ? a.__webglFramebuffer[a.activeCubeFace] : a.__webglFramebuffer, c = a.width, a = a.height, e = d = 0) : (b = null, c = Xa, a = Na, d = wb, e = Aa);
		b !== ka && (n.bindFramebuffer(n.FRAMEBUFFER, b), n.viewport(d, e, c, a), ka = b);
		S = c;
		pa = a
	};
	this.shadowMapPlugin = new THREE.ShadowMapPlugin;
	this.addPrePlugin(this.shadowMapPlugin);
	this.addPostPlugin(new THREE.SpritePlugin);
	this.addPostPlugin(new THREE.LensFlarePlugin)
};


THREE.WebGLRenderTarget = function (a, b, c) {
	THREE.EventDispatcher.call(this);
	this.width = a;
	this.height = b;
	c = c || {};
	this.wrapS = void 0 !== c.wrapS ? c.wrapS : THREE.ClampToEdgeWrapping;
	this.wrapT = void 0 !== c.wrapT ? c.wrapT : THREE.ClampToEdgeWrapping;
	this.magFilter = void 0 !== c.magFilter ? c.magFilter : THREE.LinearFilter;
	this.minFilter = void 0 !== c.minFilter ? c.minFilter : THREE.LinearMipMapLinearFilter;
	this.anisotropy = void 0 !== c.anisotropy ? c.anisotropy : 1;
	this.offset = new THREE.Vector2(0, 0);
	this.repeat = new THREE.Vector2(1, 1);
	this.format = void 0 !== c.format ? c.format : THREE.RGBAFormat;
	this.type = void 0 !== c.type ? c.type : THREE.UnsignedByteType;
	this.depthBuffer = void 0 !== c.depthBuffer ? c.depthBuffer : !0;
	this.stencilBuffer = void 0 !== c.stencilBuffer ? c.stencilBuffer : !0;
	this.generateMipmaps = !0;
	this.shareDepthFrom = null
};
THREE.WebGLRenderTarget.prototype.clone = function () {
	var a = new THREE.WebGLRenderTarget(this.width, this.height);
	a.wrapS = this.wrapS;
	a.wrapT = this.wrapT;
	a.magFilter = this.magFilter;
	a.minFilter = this.minFilter;
	a.anisotropy = this.anisotropy;
	a.offset.copy(this.offset);
	a.repeat.copy(this.repeat);
	a.format = this.format;
	a.type = this.type;
	a.depthBuffer = this.depthBuffer;
	a.stencilBuffer = this.stencilBuffer;
	a.generateMipmaps = this.generateMipmaps;
	a.shareDepthFrom = this.shareDepthFrom;
	return a
};
THREE.WebGLRenderTarget.prototype.dispose = function () {
	this.dispatchEvent({
		type: "dispose"
	})
};
THREE.WebGLRenderTargetCube = function (a, b, c) {
	THREE.WebGLRenderTarget.call(this, a, b, c);
	this.activeCubeFace = 0
};
THREE.WebGLRenderTargetCube.prototype = Object.create(THREE.WebGLRenderTarget.prototype);
THREE.RenderableVertex = function () {
	this.positionWorld = new THREE.Vector3;
	this.positionScreen = new THREE.Vector4;
	this.visible = !0
};
THREE.RenderableVertex.prototype.copy = function (a) {
	this.positionWorld.copy(a.positionWorld);
	this.positionScreen.copy(a.positionScreen)
};
THREE.RenderableFace3 = function () {
	this.v1 = new THREE.RenderableVertex;
	this.v2 = new THREE.RenderableVertex;
	this.v3 = new THREE.RenderableVertex;
	this.centroidModel = new THREE.Vector3;
	this.normalModel = new THREE.Vector3;
	this.normalModelView = new THREE.Vector3;
	this.vertexNormalsLength = 0;
	this.vertexNormalsModel = [new THREE.Vector3, new THREE.Vector3, new THREE.Vector3];
	this.vertexNormalsModelView = [new THREE.Vector3, new THREE.Vector3, new THREE.Vector3];
	this.material = this.color = null;
	this.uvs = [
		[]
	];
	this.z = null
};
THREE.RenderableFace4 = function () {
	this.v1 = new THREE.RenderableVertex;
	this.v2 = new THREE.RenderableVertex;
	this.v3 = new THREE.RenderableVertex;
	this.v4 = new THREE.RenderableVertex;
	this.centroidModel = new THREE.Vector3;
	this.normalModel = new THREE.Vector3;
	this.normalModelView = new THREE.Vector3;
	this.vertexNormalsLength = 0;
	this.vertexNormalsModel = [new THREE.Vector3, new THREE.Vector3, new THREE.Vector3, new THREE.Vector3];
	this.vertexNormalsModelView = [new THREE.Vector3, new THREE.Vector3, new THREE.Vector3, new THREE.Vector3];
	this.material = this.color = null;
	this.uvs = [
		[]
	];
	this.z = null
};
THREE.RenderableObject = function () {
	this.z = this.object = null
};
THREE.RenderableParticle = function () {
	this.rotation = this.z = this.y = this.x = this.object = null;
	this.scale = new THREE.Vector2;
	this.material = null
};
THREE.RenderableLine = function () {
	this.z = null;
	this.v1 = new THREE.RenderableVertex;
	this.v2 = new THREE.RenderableVertex;
	this.material = null
};
THREE.ColorUtils = {
	adjustHSV: function (a, b, c, d) {
		var e = THREE.ColorUtils.__hsv;
		a.getHSV(e);
		e.h = THREE.Math.clamp(e.h + b, 0, 1);
		e.s = THREE.Math.clamp(e.s + c, 0, 1);
		e.v = THREE.Math.clamp(e.v + d, 0, 1);
		a.setHSV(e.h, e.s, e.v)
	}
};
THREE.ColorUtils.__hsv = {
	h: 0,
	s: 0,
	v: 0
};
THREE.GeometryUtils = {
	merge: function (a, b) {
		var c, d, e = a.vertices.length,
			f = b instanceof THREE.Mesh ? b.geometry : b,
			g = a.vertices,
			h = f.vertices,
			i = a.faces,
			k = f.faces,
			j = a.faceVertexUvs[0],
			f = f.faceVertexUvs[0];
		b instanceof THREE.Mesh && (b.matrixAutoUpdate && b.updateMatrix(), c = b.matrix, d = new THREE.Matrix4, d.extractRotation(c, b.scale));
		for (var l = 0, m = h.length; l < m; l++) {
			var r = h[l].clone();
			c && c.multiplyVector3(r);
			g.push(r)
		}
		l = 0;
		for (m = k.length; l < m; l++) {
			var r = k[l],
				q, p, t = r.vertexNormals,
				u = r.vertexColors;
			r instanceof THREE.Face3 ? q = new THREE.Face3(r.a + e, r.b + e, r.c + e) : r instanceof THREE.Face4 && (q = new THREE.Face4(r.a + e, r.b + e, r.c + e, r.d + e));
			q.normal.copy(r.normal);
			d && d.multiplyVector3(q.normal);
			g = 0;
			for (h = t.length; g < h; g++) p = t[g].clone(), d && d.multiplyVector3(p), q.vertexNormals.push(p);
			q.color.copy(r.color);
			g = 0;
			for (h = u.length; g < h; g++) p = u[g], q.vertexColors.push(p.clone());
			q.materialIndex = r.materialIndex;
			q.centroid.copy(r.centroid);
			c && c.multiplyVector3(q.centroid);
			i.push(q)
		}
		l = 0;
		for (m = f.length; l < m; l++) {
			c = f[l];
			d = [];
			g = 0;
			for (h = c.length; g < h; g++) d.push(new THREE.Vector2(c[g].x, c[g].y));
			j.push(d)
		}
	},
	removeMaterials: function (a, b) {
		for (var c = {}, d = 0, e = b.length; d < e; d++) c[b[d]] = !0;
		for (var f, g = [], d = 0, e = a.faces.length; d < e; d++) f = a.faces[d], f.materialIndex in c || g.push(f);
		a.faces = g
	},
	randomPointInTriangle: function (a, b, c) {
		var d, e, f, g = new THREE.Vector3,
			h = THREE.GeometryUtils.__v1;
		d = THREE.GeometryUtils.random();
		e = THREE.GeometryUtils.random();
		1 < d + e && (d = 1 - d, e = 1 - e);
		f = 1 - d - e;
		g.copy(a);
		g.multiplyScalar(d);
		h.copy(b);
		h.multiplyScalar(e);
		g.add(h);
		h.copy(c);
		h.multiplyScalar(f);
		g.add(h);
		return g
	},
	randomPointInFace: function (a, b, c) {
		var d, e, f;
		if (a instanceof THREE.Face3) return d = b.vertices[a.a], e = b.vertices[a.b], f = b.vertices[a.c], THREE.GeometryUtils.randomPointInTriangle(d, e, f);
		if (a instanceof THREE.Face4) {
			d = b.vertices[a.a];
			e = b.vertices[a.b];
			f = b.vertices[a.c];
			var b = b.vertices[a.d],
				g;
			c ? a._area1 && a._area2 ? (c = a._area1, g = a._area2) : (c = THREE.GeometryUtils.triangleArea(d, e, b), g = THREE.GeometryUtils.triangleArea(e, f, b), a._area1 = c, a._area2 = g) : (c = THREE.GeometryUtils.triangleArea(d,
			e, b), g = THREE.GeometryUtils.triangleArea(e, f, b));
			return THREE.GeometryUtils.random() * (c + g) < c ? THREE.GeometryUtils.randomPointInTriangle(d, e, b) : THREE.GeometryUtils.randomPointInTriangle(e, f, b)
		}
	},
	randomPointsInGeometry: function (a, b) {
		function c(a) {
			function b(c, d) {
				if (d < c) return c;
				var e = c + Math.floor((d - c) / 2);
				return k[e] > a ? b(c, e - 1) : k[e] < a ? b(e + 1, d) : e
			}
			return b(0, k.length - 1)
		}
		var d, e, f = a.faces,
			g = a.vertices,
			h = f.length,
			i = 0,
			k = [],
			j, l, m, r;
		for (e = 0; e < h; e++) d = f[e], d instanceof THREE.Face3 ? (j = g[d.a], l = g[d.b], m = g[d.c],
		d._area = THREE.GeometryUtils.triangleArea(j, l, m)) : d instanceof THREE.Face4 && (j = g[d.a], l = g[d.b], m = g[d.c], r = g[d.d], d._area1 = THREE.GeometryUtils.triangleArea(j, l, r), d._area2 = THREE.GeometryUtils.triangleArea(l, m, r), d._area = d._area1 + d._area2), i += d._area, k[e] = i;
		d = [];
		for (e = 0; e < b; e++) g = THREE.GeometryUtils.random() * i, g = c(g), d[e] = THREE.GeometryUtils.randomPointInFace(f[g], a, !0);
		return d
	},
	triangleArea: function (a, b, c) {
		var d = THREE.GeometryUtils.__v1,
			e = THREE.GeometryUtils.__v2;
		d.sub(b, a);
		e.sub(c, a);
		d.crossSelf(e);
		return 0.5 * d.length()
	},
	center: function (a) {
		a.computeBoundingBox();
		var b = a.boundingBox,
			c = new THREE.Vector3;
		c.add(b.min, b.max);
		c.multiplyScalar(-0.5);
		a.applyMatrix((new THREE.Matrix4).makeTranslation(c));
		a.computeBoundingBox();
		return c
	},
	normalizeUVs: function (a) {
		for (var a = a.faceVertexUvs[0], b = 0, c = a.length; b < c; b++) for (var d = a[b], e = 0, f = d.length; e < f; e++) 1 !== d[e].x && (d[e].x -= Math.floor(d[e].x)), 1 !== d[e].y && (d[e].y -= Math.floor(d[e].y))
	},
	triangulateQuads: function (a) {
		var b, c, d, e, f = [],
			g = [],
			h = [];
		b = 0;
		for (c = a.faceUvs.length; b < c; b++) g[b] = [];
		b = 0;
		for (c = a.faceVertexUvs.length; b < c; b++) h[b] = [];
		b = 0;
		for (c = a.faces.length; b < c; b++) if (d = a.faces[b], d instanceof THREE.Face4) {
			e = d.a;
			var i = d.b,
				k = d.c,
				j = d.d,
				l = new THREE.Face3,
				m = new THREE.Face3;
			l.color.copy(d.color);
			m.color.copy(d.color);
			l.materialIndex = d.materialIndex;
			m.materialIndex = d.materialIndex;
			l.a = e;
			l.b = i;
			l.c = j;
			m.a = i;
			m.b = k;
			m.c = j;
			4 === d.vertexColors.length && (l.vertexColors[0] = d.vertexColors[0].clone(), l.vertexColors[1] = d.vertexColors[1].clone(), l.vertexColors[2] = d.vertexColors[3].clone(),
			m.vertexColors[0] = d.vertexColors[1].clone(), m.vertexColors[1] = d.vertexColors[2].clone(), m.vertexColors[2] = d.vertexColors[3].clone());
			f.push(l, m);
			d = 0;
			for (e = a.faceVertexUvs.length; d < e; d++) a.faceVertexUvs[d].length && (l = a.faceVertexUvs[d][b], i = l[1], k = l[2], j = l[3], l = [l[0].clone(), i.clone(), j.clone()], i = [i.clone(), k.clone(), j.clone()], h[d].push(l, i));
			d = 0;
			for (e = a.faceUvs.length; d < e; d++) a.faceUvs[d].length && (i = a.faceUvs[d][b], g[d].push(i, i))
		} else {
			f.push(d);
			d = 0;
			for (e = a.faceUvs.length; d < e; d++) g[d].push(a.faceUvs[d][b]);
			d = 0;
			for (e = a.faceVertexUvs.length; d < e; d++) h[d].push(a.faceVertexUvs[d][b])
		}
		a.faces = f;
		a.faceUvs = g;
		a.faceVertexUvs = h;
		a.computeCentroids();
		a.computeFaceNormals();
		a.computeVertexNormals();
		a.hasTangents && a.computeTangents()
	},
	explode: function (a) {
		for (var b = [], c = 0, d = a.faces.length; c < d; c++) {
			var e = b.length,
				f = a.faces[c];
			if (f instanceof THREE.Face4) {
				var g = f.a,
					h = f.b,
					i = f.c,
					g = a.vertices[g],
					h = a.vertices[h],
					i = a.vertices[i],
					k = a.vertices[f.d];
				b.push(g.clone());
				b.push(h.clone());
				b.push(i.clone());
				b.push(k.clone());
				f.a = e;
				f.b = e + 1;
				f.c = e + 2;
				f.d = e + 3
			} else g = f.a, h = f.b, i = f.c, g = a.vertices[g], h = a.vertices[h], i = a.vertices[i], b.push(g.clone()), b.push(h.clone()), b.push(i.clone()), f.a = e, f.b = e + 1, f.c = e + 2
		}
		a.vertices = b;
		delete a.__tmpVertices
	},
	tessellate: function (a, b) {
		var c, d, e, f, g, h, i, k, j, l, m, r, q, p, t, u, x, v, s, C = [],
			z = [];
		c = 0;
		for (d = a.faceVertexUvs.length; c < d; c++) z[c] = [];
		c = 0;
		for (d = a.faces.length; c < d; c++) if (e = a.faces[c], e instanceof THREE.Face3) if (f = e.a, g = e.b, h = e.c, k = a.vertices[f], j = a.vertices[g], l = a.vertices[h], r = k.distanceTo(j), q = j.distanceTo(l),
		m = k.distanceTo(l), r > b || q > b || m > b) {
			i = a.vertices.length;
			v = e.clone();
			s = e.clone();
			r >= q && r >= m ? (k = k.clone(), k.lerpSelf(j, 0.5), v.a = f, v.b = i, v.c = h, s.a = i, s.b = g, s.c = h, 3 === e.vertexNormals.length && (f = e.vertexNormals[0].clone(), f.lerpSelf(e.vertexNormals[1], 0.5), v.vertexNormals[1].copy(f), s.vertexNormals[0].copy(f)), 3 === e.vertexColors.length && (f = e.vertexColors[0].clone(), f.lerpSelf(e.vertexColors[1], 0.5), v.vertexColors[1].copy(f), s.vertexColors[0].copy(f)), e = 0) : q >= r && q >= m ? (k = j.clone(), k.lerpSelf(l, 0.5), v.a = f, v.b = g, v.c = i, s.a = i, s.b = h, s.c = f, 3 === e.vertexNormals.length && (f = e.vertexNormals[1].clone(), f.lerpSelf(e.vertexNormals[2], 0.5), v.vertexNormals[2].copy(f), s.vertexNormals[0].copy(f), s.vertexNormals[1].copy(e.vertexNormals[2]), s.vertexNormals[2].copy(e.vertexNormals[0])), 3 === e.vertexColors.length && (f = e.vertexColors[1].clone(), f.lerpSelf(e.vertexColors[2], 0.5), v.vertexColors[2].copy(f), s.vertexColors[0].copy(f), s.vertexColors[1].copy(e.vertexColors[2]), s.vertexColors[2].copy(e.vertexColors[0])), e = 1) : (k = k.clone(),
			k.lerpSelf(l, 0.5), v.a = f, v.b = g, v.c = i, s.a = i, s.b = g, s.c = h, 3 === e.vertexNormals.length && (f = e.vertexNormals[0].clone(), f.lerpSelf(e.vertexNormals[2], 0.5), v.vertexNormals[2].copy(f), s.vertexNormals[0].copy(f)), 3 === e.vertexColors.length && (f = e.vertexColors[0].clone(), f.lerpSelf(e.vertexColors[2], 0.5), v.vertexColors[2].copy(f), s.vertexColors[0].copy(f)), e = 2);
			C.push(v, s);
			a.vertices.push(k);
			f = 0;
			for (g = a.faceVertexUvs.length; f < g; f++) a.faceVertexUvs[f].length && (k = a.faceVertexUvs[f][c], s = k[0], h = k[1], v = k[2], 0 === e ? (j = s.clone(), j.lerpSelf(h, 0.5), k = [s.clone(), j.clone(), v.clone()], h = [j.clone(), h.clone(), v.clone()]) : 1 === e ? (j = h.clone(), j.lerpSelf(v, 0.5), k = [s.clone(), h.clone(), j.clone()], h = [j.clone(), v.clone(), s.clone()]) : (j = s.clone(), j.lerpSelf(v, 0.5), k = [s.clone(), h.clone(), j.clone()], h = [j.clone(), h.clone(), v.clone()]), z[f].push(k, h))
		} else {
			C.push(e);
			f = 0;
			for (g = a.faceVertexUvs.length; f < g; f++) z[f].push(a.faceVertexUvs[f][c])
		} else if (f = e.a, g = e.b, h = e.c, i = e.d, k = a.vertices[f], j = a.vertices[g], l = a.vertices[h], m = a.vertices[i],
		r = k.distanceTo(j), q = j.distanceTo(l), p = l.distanceTo(m), t = k.distanceTo(m), r > b || q > b || p > b || t > b) {
			u = a.vertices.length;
			x = a.vertices.length + 1;
			v = e.clone();
			s = e.clone();
			r >= q && r >= p && r >= t || p >= q && p >= r && p >= t ? (r = k.clone(), r.lerpSelf(j, 0.5), j = l.clone(), j.lerpSelf(m, 0.5), v.a = f, v.b = u, v.c = x, v.d = i, s.a = u, s.b = g, s.c = h, s.d = x, 4 === e.vertexNormals.length && (f = e.vertexNormals[0].clone(), f.lerpSelf(e.vertexNormals[1], 0.5), g = e.vertexNormals[2].clone(), g.lerpSelf(e.vertexNormals[3], 0.5), v.vertexNormals[1].copy(f), v.vertexNormals[2].copy(g),
			s.vertexNormals[0].copy(f), s.vertexNormals[3].copy(g)), 4 === e.vertexColors.length && (f = e.vertexColors[0].clone(), f.lerpSelf(e.vertexColors[1], 0.5), g = e.vertexColors[2].clone(), g.lerpSelf(e.vertexColors[3], 0.5), v.vertexColors[1].copy(f), v.vertexColors[2].copy(g), s.vertexColors[0].copy(f), s.vertexColors[3].copy(g)), e = 0) : (r = j.clone(), r.lerpSelf(l, 0.5), j = m.clone(), j.lerpSelf(k, 0.5), v.a = f, v.b = g, v.c = u, v.d = x, s.a = x, s.b = u, s.c = h, s.d = i, 4 === e.vertexNormals.length && (f = e.vertexNormals[1].clone(), f.lerpSelf(e.vertexNormals[2],
			0.5), g = e.vertexNormals[3].clone(), g.lerpSelf(e.vertexNormals[0], 0.5), v.vertexNormals[2].copy(f), v.vertexNormals[3].copy(g), s.vertexNormals[0].copy(g), s.vertexNormals[1].copy(f)), 4 === e.vertexColors.length && (f = e.vertexColors[1].clone(), f.lerpSelf(e.vertexColors[2], 0.5), g = e.vertexColors[3].clone(), g.lerpSelf(e.vertexColors[0], 0.5), v.vertexColors[2].copy(f), v.vertexColors[3].copy(g), s.vertexColors[0].copy(g), s.vertexColors[1].copy(f)), e = 1);
			C.push(v, s);
			a.vertices.push(r, j);
			f = 0;
			for (g = a.faceVertexUvs.length; f < g; f++) a.faceVertexUvs[f].length && (k = a.faceVertexUvs[f][c], s = k[0], h = k[1], v = k[2], k = k[3], 0 === e ? (j = s.clone(), j.lerpSelf(h, 0.5), l = v.clone(), l.lerpSelf(k, 0.5), s = [s.clone(), j.clone(), l.clone(), k.clone()], h = [j.clone(), h.clone(), v.clone(), l.clone()]) : (j = h.clone(), j.lerpSelf(v, 0.5), l = k.clone(), l.lerpSelf(s, 0.5), s = [s.clone(), h.clone(), j.clone(), l.clone()], h = [l.clone(), j.clone(), v.clone(), k.clone()]), z[f].push(s, h))
		} else {
			C.push(e);
			f = 0;
			for (g = a.faceVertexUvs.length; f < g; f++) z[f].push(a.faceVertexUvs[f][c])
		}
		a.faces = C;
		a.faceVertexUvs = z
	},
	setMaterialIndex: function (a, b, c, d) {
		a = a.faces;
		d = d || a.length - 1;
		for (c = c || 0; c <= d; c++) a[c].materialIndex = b
	}
};
THREE.GeometryUtils.random = THREE.Math.random16;
THREE.GeometryUtils.__v1 = new THREE.Vector3;
THREE.GeometryUtils.__v2 = new THREE.Vector3;
THREE.ImageUtils = {
	crossOrigin: "anonymous",
	loadTexture: function (a, b, c, d) {
		var e = new Image,
			f = new THREE.Texture(e, b),
			b = new THREE.ImageLoader;
		b.addEventListener("load", function (a) {
			f.image = a.content;
			f.needsUpdate = !0;
			c && c(f)
		});
		b.addEventListener("error", function (a) {
			d && d(a.message)
		});
		b.crossOrigin = this.crossOrigin;
		b.load(a, e);
		f.sourceFile = a;
		return f
	},
	loadCompressedTexture: function (a, b, c, d) {
		var e = new THREE.CompressedTexture;
		e.mapping = b;
		var f = new XMLHttpRequest;
		f.onload = function () {
			var a = THREE.ImageUtils.parseDDS(f.response, !0);
			e.format = a.format;
			e.mipmaps = a.mipmaps;
			e.image.width = a.width;
			e.image.height = a.height;
			e.generateMipmaps = !1;
			e.needsUpdate = !0;
			c && c(e)
		};
		f.onerror = d;
		f.open("GET", a, !0);
		f.responseType = "arraybuffer";
		f.send(null);
		return e
	},
	loadTextureCube: function (a, b, c, d) {
		var e = [];
		e.loadCount = 0;
		var f = new THREE.Texture;
		f.image = e;
		void 0 !== b && (f.mapping = b);
		f.flipY = !1;
		for (var b = 0, g = a.length; b < g; ++b) {
			var h = new Image;
			e[b] = h;
			h.onload = function () {
				e.loadCount += 1;
				6 === e.loadCount && (f.needsUpdate = !0, c && c(f))
			};
			h.onerror = d;
			h.crossOrigin = this.crossOrigin;
			h.src = a[b]
		}
		return f
	},
	loadCompressedTextureCube: function (a, b, c, d) {
		var e = [];
		e.loadCount = 0;
		var f = new THREE.CompressedTexture;
		f.image = e;
		void 0 !== b && (f.mapping = b);
		f.flipY = !1;
		f.generateMipmaps = !1;
		b = function (a, b) {
			return function () {
				var d = THREE.ImageUtils.parseDDS(a.response, !0);
				b.format = d.format;
				b.mipmaps = d.mipmaps;
				b.width = d.width;
				b.height = d.height;
				e.loadCount += 1;
				6 === e.loadCount && (f.format = d.format, f.needsUpdate = !0, c && c(f))
			}
		};
		if (a instanceof Array) for (var g = 0, h = a.length; g < h; ++g) {
			var i = {};
			e[g] = i;
			var k = new XMLHttpRequest;
			k.onload = b(k, i);
			k.onerror = d;
			i = a[g];
			k.open("GET", i, !0);
			k.responseType = "arraybuffer";
			k.send(null)
		} else k = new XMLHttpRequest, k.onload = function () {
			var a = THREE.ImageUtils.parseDDS(k.response, !0);
			if (a.isCubemap) {
				for (var b = a.mipmaps.length / a.mipmapCount, d = 0; d < b; d++) {
					e[d] = {
						mipmaps: []
					};
					for (var g = 0; g < a.mipmapCount; g++) e[d].mipmaps.push(a.mipmaps[d * a.mipmapCount + g]), e[d].format = a.format, e[d].width = a.width, e[d].height = a.height
				}
				f.format = a.format;
				f.needsUpdate = !0;
				c && c(f)
			}
		}, k.onerror = d, k.open("GET", a, !0), k.responseType = "arraybuffer", k.send(null);
		return f
	},
	parseDDS: function (a, b) {
		function c(a) {
			return a.charCodeAt(0) + (a.charCodeAt(1) << 8) + (a.charCodeAt(2) << 16) + (a.charCodeAt(3) << 24)
		}
		var d = {
			mipmaps: [],
			width: 0,
			height: 0,
			format: null,
			mipmapCount: 1
		}, e = c("DXT1"),
			f = c("DXT3"),
			g = c("DXT5"),
			h = new Int32Array(a, 0, 31);
		if (542327876 !== h[0]) return console.error("ImageUtils.parseDDS(): Invalid magic number in DDS header"), d;
		if (!h[20] & 4) return console.error("ImageUtils.parseDDS(): Unsupported format, must contain a FourCC code"),
		d;
		var i = h[21];
		switch (i) {
			case e:
				e = 8;
				d.format = THREE.RGB_S3TC_DXT1_Format;
				break;
			case f:
				e = 16;
				d.format = THREE.RGBA_S3TC_DXT3_Format;
				break;
			case g:
				e = 16;
				d.format = THREE.RGBA_S3TC_DXT5_Format;
				break;
			default:
				return console.error("ImageUtils.parseDDS(): Unsupported FourCC code: ", String.fromCharCode(i & 255, i >> 8 & 255, i >> 16 & 255, i >> 24 & 255)), d
		}
		d.mipmapCount = 1;
		h[2] & 131072 && !1 !== b && (d.mipmapCount = Math.max(1, h[7]));
		d.isCubemap = h[28] & 512 ? !0 : !1;
		d.width = h[4];
		d.height = h[3];
		for (var h = h[1] + 4, f = d.width, g = d.height, i = d.isCubemap ? 6 : 1, k = 0; k < i; k++) {
			for (var j = 0; j < d.mipmapCount; j++) {
				var l = Math.max(4, f) / 4 * Math.max(4, g) / 4 * e,
					m = {
						data: new Uint8Array(a, h, l),
						width: f,
						height: g
					};
				d.mipmaps.push(m);
				h += l;
				f = Math.max(0.5 * f, 1);
				g = Math.max(0.5 * g, 1)
			}
			f = d.width;
			g = d.height
		}
		return d
	},
	getNormalMap: function (a, b) {
		var c = function (a) {
			var b = Math.sqrt(a[0] * a[0] + a[1] * a[1] + a[2] * a[2]);
			return [a[0] / b, a[1] / b, a[2] / b]
		}, b = b | 1,
			d = a.width,
			e = a.height,
			f = document.createElement("canvas");
		f.width = d;
		f.height = e;
		var g = f.getContext("2d");
		g.drawImage(a, 0, 0);
		for (var h = g.getImageData(0,
		0, d, e).data, i = g.createImageData(d, e), k = i.data, j = 0; j < d; j++) for (var l = 0; l < e; l++) {
			var m = 0 > l - 1 ? 0 : l - 1,
				r = l + 1 > e - 1 ? e - 1 : l + 1,
				q = 0 > j - 1 ? 0 : j - 1,
				p = j + 1 > d - 1 ? d - 1 : j + 1,
				t = [],
				u = [0, 0, h[4 * (l * d + j)] / 255 * b];
			t.push([-1, 0, h[4 * (l * d + q)] / 255 * b]);
			t.push([-1, -1, h[4 * (m * d + q)] / 255 * b]);
			t.push([0, -1, h[4 * (m * d + j)] / 255 * b]);
			t.push([1, -1, h[4 * (m * d + p)] / 255 * b]);
			t.push([1, 0, h[4 * (l * d + p)] / 255 * b]);
			t.push([1, 1, h[4 * (r * d + p)] / 255 * b]);
			t.push([0, 1, h[4 * (r * d + j)] / 255 * b]);
			t.push([-1, 1, h[4 * (r * d + q)] / 255 * b]);
			m = [];
			q = t.length;
			for (r = 0; r < q; r++) {
				var p = t[r],
					x = t[(r + 1) % q],
					p = [p[0] - u[0], p[1] - u[1], p[2] - u[2]],
					x = [x[0] - u[0], x[1] - u[1], x[2] - u[2]];
				m.push(c([p[1] * x[2] - p[2] * x[1], p[2] * x[0] - p[0] * x[2], p[0] * x[1] - p[1] * x[0]]))
			}
			t = [0, 0, 0];
			for (r = 0; r < m.length; r++) t[0] += m[r][0], t[1] += m[r][1], t[2] += m[r][2];
			t[0] /= m.length;
			t[1] /= m.length;
			t[2] /= m.length;
			u = 4 * (l * d + j);
			k[u] = 255 * ((t[0] + 1) / 2) | 0;
			k[u + 1] = 255 * ((t[1] + 1) / 2) | 0;
			k[u + 2] = 255 * t[2] | 0;
			k[u + 3] = 255
		}
		g.putImageData(i, 0, 0);
		return f
	},
	generateDataTexture: function (a, b, c) {
		for (var d = a * b, e = new Uint8Array(3 * d), f = Math.floor(255 * c.r), g = Math.floor(255 * c.g),
		c = Math.floor(255 * c.b), h = 0; h < d; h++) e[3 * h] = f, e[3 * h + 1] = g, e[3 * h + 2] = c;
		a = new THREE.DataTexture(e, a, b, THREE.RGBFormat);
		a.needsUpdate = !0;
		return a
	}
};
THREE.SceneUtils = {
	createMultiMaterialObject: function (a, b) {
		for (var c = new THREE.Object3D, d = 0, e = b.length; d < e; d++) c.add(new THREE.Mesh(a, b[d]));
		return c
	},
	detach: function (a, b, c) {
		a.applyMatrix(b.matrixWorld);
		b.remove(a);
		c.add(a)
	},
	attach: function (a, b, c) {
		var d = new THREE.Matrix4;
		d.getInverse(c.matrixWorld);
		a.applyMatrix(d);
		b.remove(a);
		c.add(a)
	}
};
THREE.ShaderUtils = {
	lib: {
		fresnel: {
			uniforms: {
				mRefractionRatio: {
					type: "f",
					value: 1.02
				},
				mFresnelBias: {
					type: "f",
					value: 0.1
				},
				mFresnelPower: {
					type: "f",
					value: 2
				},
				mFresnelScale: {
					type: "f",
					value: 1
				},
				tCube: {
					type: "t",
					value: null
				}
			},
			fragmentShader: "uniform samplerCube tCube;\nvarying vec3 vReflect;\nvarying vec3 vRefract[3];\nvarying float vReflectionFactor;\nvoid main() {\nvec4 reflectedColor = textureCube( tCube, vec3( -vReflect.x, vReflect.yz ) );\nvec4 refractedColor = vec4( 1.0 );\nrefractedColor.r = textureCube( tCube, vec3( -vRefract[0].x, vRefract[0].yz ) ).r;\nrefractedColor.g = textureCube( tCube, vec3( -vRefract[1].x, vRefract[1].yz ) ).g;\nrefractedColor.b = textureCube( tCube, vec3( -vRefract[2].x, vRefract[2].yz ) ).b;\ngl_FragColor = mix( refractedColor, reflectedColor, clamp( vReflectionFactor, 0.0, 1.0 ) );\n}",
			vertexShader: "uniform float mRefractionRatio;\nuniform float mFresnelBias;\nuniform float mFresnelScale;\nuniform float mFresnelPower;\nvarying vec3 vReflect;\nvarying vec3 vRefract[3];\nvarying float vReflectionFactor;\nvoid main() {\nvec4 mvPosition = modelViewMatrix * vec4( position, 1.0 );\nvec4 worldPosition = modelMatrix * vec4( position, 1.0 );\nvec3 worldNormal = normalize( mat3( modelMatrix[0].xyz, modelMatrix[1].xyz, modelMatrix[2].xyz ) * normal );\nvec3 I = worldPosition.xyz - cameraPosition;\nvReflect = reflect( I, worldNormal );\nvRefract[0] = refract( normalize( I ), worldNormal, mRefractionRatio );\nvRefract[1] = refract( normalize( I ), worldNormal, mRefractionRatio * 0.99 );\nvRefract[2] = refract( normalize( I ), worldNormal, mRefractionRatio * 0.98 );\nvReflectionFactor = mFresnelBias + mFresnelScale * pow( 1.0 + dot( normalize( I ), worldNormal ), mFresnelPower );\ngl_Position = projectionMatrix * mvPosition;\n}"
		},
		normal: {
			uniforms: THREE.UniformsUtils.merge([THREE.UniformsLib.fog, THREE.UniformsLib.lights, THREE.UniformsLib.shadowmap, {
				enableAO: {
					type: "i",
					value: 0
				},
				enableDiffuse: {
					type: "i",
					value: 0
				},
				enableSpecular: {
					type: "i",
					value: 0
				},
				enableReflection: {
					type: "i",
					value: 0
				},
				enableDisplacement: {
					type: "i",
					value: 0
				},
				tDisplacement: {
					type: "t",
					value: null
				},
				tDiffuse: {
					type: "t",
					value: null
				},
				tCube: {
					type: "t",
					value: null
				},
				tNormal: {
					type: "t",
					value: null
				},
				tSpecular: {
					type: "t",
					value: null
				},
				tAO: {
					type: "t",
					value: null
				},
				uNormalScale: {
					type: "v2",
					value: new THREE.Vector2(1,
					1)
				},
				uDisplacementBias: {
					type: "f",
					value: 0
				},
				uDisplacementScale: {
					type: "f",
					value: 1
				},
				uDiffuseColor: {
					type: "c",
					value: new THREE.Color(16777215)
				},
				uSpecularColor: {
					type: "c",
					value: new THREE.Color(1118481)
				},
				uAmbientColor: {
					type: "c",
					value: new THREE.Color(16777215)
				},
				uShininess: {
					type: "f",
					value: 30
				},
				uOpacity: {
					type: "f",
					value: 1
				},
				useRefract: {
					type: "i",
					value: 0
				},
				uRefractionRatio: {
					type: "f",
					value: 0.98
				},
				uReflectivity: {
					type: "f",
					value: 0.5
				},
				uOffset: {
					type: "v2",
					value: new THREE.Vector2(0, 0)
				},
				uRepeat: {
					type: "v2",
					value: new THREE.Vector2(1,
					1)
				},
				wrapRGB: {
					type: "v3",
					value: new THREE.Vector3(1, 1, 1)
				}
			}]),
			fragmentShader: ["uniform vec3 uAmbientColor;\nuniform vec3 uDiffuseColor;\nuniform vec3 uSpecularColor;\nuniform float uShininess;\nuniform float uOpacity;\nuniform bool enableDiffuse;\nuniform bool enableSpecular;\nuniform bool enableAO;\nuniform bool enableReflection;\nuniform sampler2D tDiffuse;\nuniform sampler2D tNormal;\nuniform sampler2D tSpecular;\nuniform sampler2D tAO;\nuniform samplerCube tCube;\nuniform vec2 uNormalScale;\nuniform bool useRefract;\nuniform float uRefractionRatio;\nuniform float uReflectivity;\nvarying vec3 vTangent;\nvarying vec3 vBinormal;\nvarying vec3 vNormal;\nvarying vec2 vUv;\nuniform vec3 ambientLightColor;\n#if MAX_DIR_LIGHTS > 0\nuniform vec3 directionalLightColor[ MAX_DIR_LIGHTS ];\nuniform vec3 directionalLightDirection[ MAX_DIR_LIGHTS ];\n#endif\n#if MAX_HEMI_LIGHTS > 0\nuniform vec3 hemisphereLightSkyColor[ MAX_HEMI_LIGHTS ];\nuniform vec3 hemisphereLightGroundColor[ MAX_HEMI_LIGHTS ];\nuniform vec3 hemisphereLightDirection[ MAX_HEMI_LIGHTS ];\n#endif\n#if MAX_POINT_LIGHTS > 0\nuniform vec3 pointLightColor[ MAX_POINT_LIGHTS ];\nuniform vec3 pointLightPosition[ MAX_POINT_LIGHTS ];\nuniform float pointLightDistance[ MAX_POINT_LIGHTS ];\n#endif\n#if MAX_SPOT_LIGHTS > 0\nuniform vec3 spotLightColor[ MAX_SPOT_LIGHTS ];\nuniform vec3 spotLightPosition[ MAX_SPOT_LIGHTS ];\nuniform vec3 spotLightDirection[ MAX_SPOT_LIGHTS ];\nuniform float spotLightAngleCos[ MAX_SPOT_LIGHTS ];\nuniform float spotLightExponent[ MAX_SPOT_LIGHTS ];\nuniform float spotLightDistance[ MAX_SPOT_LIGHTS ];\n#endif\n#ifdef WRAP_AROUND\nuniform vec3 wrapRGB;\n#endif\nvarying vec3 vWorldPosition;\nvarying vec3 vViewPosition;",
			THREE.ShaderChunk.shadowmap_pars_fragment, THREE.ShaderChunk.fog_pars_fragment, "void main() {\ngl_FragColor = vec4( vec3( 1.0 ), uOpacity );\nvec3 specularTex = vec3( 1.0 );\nvec3 normalTex = texture2D( tNormal, vUv ).xyz * 2.0 - 1.0;\nnormalTex.xy *= uNormalScale;\nnormalTex = normalize( normalTex );\nif( enableDiffuse ) {\n#ifdef GAMMA_INPUT\nvec4 texelColor = texture2D( tDiffuse, vUv );\ntexelColor.xyz *= texelColor.xyz;\ngl_FragColor = gl_FragColor * texelColor;\n#else\ngl_FragColor = gl_FragColor * texture2D( tDiffuse, vUv );\n#endif\n}\nif( enableAO ) {\n#ifdef GAMMA_INPUT\nvec4 aoColor = texture2D( tAO, vUv );\naoColor.xyz *= aoColor.xyz;\ngl_FragColor.xyz = gl_FragColor.xyz * aoColor.xyz;\n#else\ngl_FragColor.xyz = gl_FragColor.xyz * texture2D( tAO, vUv ).xyz;\n#endif\n}\nif( enableSpecular )\nspecularTex = texture2D( tSpecular, vUv ).xyz;\nmat3 tsb = mat3( normalize( vTangent ), normalize( vBinormal ), normalize( vNormal ) );\nvec3 finalNormal = tsb * normalTex;\n#ifdef FLIP_SIDED\nfinalNormal = -finalNormal;\n#endif\nvec3 normal = normalize( finalNormal );\nvec3 viewPosition = normalize( vViewPosition );\n#if MAX_POINT_LIGHTS > 0\nvec3 pointDiffuse = vec3( 0.0 );\nvec3 pointSpecular = vec3( 0.0 );\nfor ( int i = 0; i < MAX_POINT_LIGHTS; i ++ ) {\nvec4 lPosition = viewMatrix * vec4( pointLightPosition[ i ], 1.0 );\nvec3 pointVector = lPosition.xyz + vViewPosition.xyz;\nfloat pointDistance = 1.0;\nif ( pointLightDistance[ i ] > 0.0 )\npointDistance = 1.0 - min( ( length( pointVector ) / pointLightDistance[ i ] ), 1.0 );\npointVector = normalize( pointVector );\n#ifdef WRAP_AROUND\nfloat pointDiffuseWeightFull = max( dot( normal, pointVector ), 0.0 );\nfloat pointDiffuseWeightHalf = max( 0.5 * dot( normal, pointVector ) + 0.5, 0.0 );\nvec3 pointDiffuseWeight = mix( vec3 ( pointDiffuseWeightFull ), vec3( pointDiffuseWeightHalf ), wrapRGB );\n#else\nfloat pointDiffuseWeight = max( dot( normal, pointVector ), 0.0 );\n#endif\npointDiffuse += pointDistance * pointLightColor[ i ] * uDiffuseColor * pointDiffuseWeight;\nvec3 pointHalfVector = normalize( pointVector + viewPosition );\nfloat pointDotNormalHalf = max( dot( normal, pointHalfVector ), 0.0 );\nfloat pointSpecularWeight = specularTex.r * max( pow( pointDotNormalHalf, uShininess ), 0.0 );\n#ifdef PHYSICALLY_BASED_SHADING\nfloat specularNormalization = ( uShininess + 2.0001 ) / 8.0;\nvec3 schlick = uSpecularColor + vec3( 1.0 - uSpecularColor ) * pow( 1.0 - dot( pointVector, pointHalfVector ), 5.0 );\npointSpecular += schlick * pointLightColor[ i ] * pointSpecularWeight * pointDiffuseWeight * pointDistance * specularNormalization;\n#else\npointSpecular += pointDistance * pointLightColor[ i ] * uSpecularColor * pointSpecularWeight * pointDiffuseWeight;\n#endif\n}\n#endif\n#if MAX_SPOT_LIGHTS > 0\nvec3 spotDiffuse = vec3( 0.0 );\nvec3 spotSpecular = vec3( 0.0 );\nfor ( int i = 0; i < MAX_SPOT_LIGHTS; i ++ ) {\nvec4 lPosition = viewMatrix * vec4( spotLightPosition[ i ], 1.0 );\nvec3 spotVector = lPosition.xyz + vViewPosition.xyz;\nfloat spotDistance = 1.0;\nif ( spotLightDistance[ i ] > 0.0 )\nspotDistance = 1.0 - min( ( length( spotVector ) / spotLightDistance[ i ] ), 1.0 );\nspotVector = normalize( spotVector );\nfloat spotEffect = dot( spotLightDirection[ i ], normalize( spotLightPosition[ i ] - vWorldPosition ) );\nif ( spotEffect > spotLightAngleCos[ i ] ) {\nspotEffect = max( pow( spotEffect, spotLightExponent[ i ] ), 0.0 );\n#ifdef WRAP_AROUND\nfloat spotDiffuseWeightFull = max( dot( normal, spotVector ), 0.0 );\nfloat spotDiffuseWeightHalf = max( 0.5 * dot( normal, spotVector ) + 0.5, 0.0 );\nvec3 spotDiffuseWeight = mix( vec3 ( spotDiffuseWeightFull ), vec3( spotDiffuseWeightHalf ), wrapRGB );\n#else\nfloat spotDiffuseWeight = max( dot( normal, spotVector ), 0.0 );\n#endif\nspotDiffuse += spotDistance * spotLightColor[ i ] * uDiffuseColor * spotDiffuseWeight * spotEffect;\nvec3 spotHalfVector = normalize( spotVector + viewPosition );\nfloat spotDotNormalHalf = max( dot( normal, spotHalfVector ), 0.0 );\nfloat spotSpecularWeight = specularTex.r * max( pow( spotDotNormalHalf, uShininess ), 0.0 );\n#ifdef PHYSICALLY_BASED_SHADING\nfloat specularNormalization = ( uShininess + 2.0001 ) / 8.0;\nvec3 schlick = uSpecularColor + vec3( 1.0 - uSpecularColor ) * pow( 1.0 - dot( spotVector, spotHalfVector ), 5.0 );\nspotSpecular += schlick * spotLightColor[ i ] * spotSpecularWeight * spotDiffuseWeight * spotDistance * specularNormalization * spotEffect;\n#else\nspotSpecular += spotDistance * spotLightColor[ i ] * uSpecularColor * spotSpecularWeight * spotDiffuseWeight * spotEffect;\n#endif\n}\n}\n#endif\n#if MAX_DIR_LIGHTS > 0\nvec3 dirDiffuse = vec3( 0.0 );\nvec3 dirSpecular = vec3( 0.0 );\nfor( int i = 0; i < MAX_DIR_LIGHTS; i++ ) {\nvec4 lDirection = viewMatrix * vec4( directionalLightDirection[ i ], 0.0 );\nvec3 dirVector = normalize( lDirection.xyz );\n#ifdef WRAP_AROUND\nfloat directionalLightWeightingFull = max( dot( normal, dirVector ), 0.0 );\nfloat directionalLightWeightingHalf = max( 0.5 * dot( normal, dirVector ) + 0.5, 0.0 );\nvec3 dirDiffuseWeight = mix( vec3( directionalLightWeightingFull ), vec3( directionalLightWeightingHalf ), wrapRGB );\n#else\nfloat dirDiffuseWeight = max( dot( normal, dirVector ), 0.0 );\n#endif\ndirDiffuse += directionalLightColor[ i ] * uDiffuseColor * dirDiffuseWeight;\nvec3 dirHalfVector = normalize( dirVector + viewPosition );\nfloat dirDotNormalHalf = max( dot( normal, dirHalfVector ), 0.0 );\nfloat dirSpecularWeight = specularTex.r * max( pow( dirDotNormalHalf, uShininess ), 0.0 );\n#ifdef PHYSICALLY_BASED_SHADING\nfloat specularNormalization = ( uShininess + 2.0001 ) / 8.0;\nvec3 schlick = uSpecularColor + vec3( 1.0 - uSpecularColor ) * pow( 1.0 - dot( dirVector, dirHalfVector ), 5.0 );\ndirSpecular += schlick * directionalLightColor[ i ] * dirSpecularWeight * dirDiffuseWeight * specularNormalization;\n#else\ndirSpecular += directionalLightColor[ i ] * uSpecularColor * dirSpecularWeight * dirDiffuseWeight;\n#endif\n}\n#endif\n#if MAX_HEMI_LIGHTS > 0\nvec3 hemiDiffuse  = vec3( 0.0 );\nvec3 hemiSpecular = vec3( 0.0 );\nfor( int i = 0; i < MAX_HEMI_LIGHTS; i ++ ) {\nvec4 lDirection = viewMatrix * vec4( hemisphereLightDirection[ i ], 0.0 );\nvec3 lVector = normalize( lDirection.xyz );\nfloat dotProduct = dot( normal, lVector );\nfloat hemiDiffuseWeight = 0.5 * dotProduct + 0.5;\nvec3 hemiColor = mix( hemisphereLightGroundColor[ i ], hemisphereLightSkyColor[ i ], hemiDiffuseWeight );\nhemiDiffuse += uDiffuseColor * hemiColor;\nvec3 hemiHalfVectorSky = normalize( lVector + viewPosition );\nfloat hemiDotNormalHalfSky = 0.5 * dot( normal, hemiHalfVectorSky ) + 0.5;\nfloat hemiSpecularWeightSky = specularTex.r * max( pow( hemiDotNormalHalfSky, uShininess ), 0.0 );\nvec3 lVectorGround = -lVector;\nvec3 hemiHalfVectorGround = normalize( lVectorGround + viewPosition );\nfloat hemiDotNormalHalfGround = 0.5 * dot( normal, hemiHalfVectorGround ) + 0.5;\nfloat hemiSpecularWeightGround = specularTex.r * max( pow( hemiDotNormalHalfGround, uShininess ), 0.0 );\n#ifdef PHYSICALLY_BASED_SHADING\nfloat dotProductGround = dot( normal, lVectorGround );\nfloat specularNormalization = ( uShininess + 2.0001 ) / 8.0;\nvec3 schlickSky = uSpecularColor + vec3( 1.0 - uSpecularColor ) * pow( 1.0 - dot( lVector, hemiHalfVectorSky ), 5.0 );\nvec3 schlickGround = uSpecularColor + vec3( 1.0 - uSpecularColor ) * pow( 1.0 - dot( lVectorGround, hemiHalfVectorGround ), 5.0 );\nhemiSpecular += hemiColor * specularNormalization * ( schlickSky * hemiSpecularWeightSky * max( dotProduct, 0.0 ) + schlickGround * hemiSpecularWeightGround * max( dotProductGround, 0.0 ) );\n#else\nhemiSpecular += uSpecularColor * hemiColor * ( hemiSpecularWeightSky + hemiSpecularWeightGround ) * hemiDiffuseWeight;\n#endif\n}\n#endif\nvec3 totalDiffuse = vec3( 0.0 );\nvec3 totalSpecular = vec3( 0.0 );\n#if MAX_DIR_LIGHTS > 0\ntotalDiffuse += dirDiffuse;\ntotalSpecular += dirSpecular;\n#endif\n#if MAX_HEMI_LIGHTS > 0\ntotalDiffuse += hemiDiffuse;\ntotalSpecular += hemiSpecular;\n#endif\n#if MAX_POINT_LIGHTS > 0\ntotalDiffuse += pointDiffuse;\ntotalSpecular += pointSpecular;\n#endif\n#if MAX_SPOT_LIGHTS > 0\ntotalDiffuse += spotDiffuse;\ntotalSpecular += spotSpecular;\n#endif\n#ifdef METAL\ngl_FragColor.xyz = gl_FragColor.xyz * ( totalDiffuse + ambientLightColor * uAmbientColor + totalSpecular );\n#else\ngl_FragColor.xyz = gl_FragColor.xyz * ( totalDiffuse + ambientLightColor * uAmbientColor ) + totalSpecular;\n#endif\nif ( enableReflection ) {\nvec3 vReflect;\nvec3 cameraToVertex = normalize( vWorldPosition - cameraPosition );\nif ( useRefract ) {\nvReflect = refract( cameraToVertex, normal, uRefractionRatio );\n} else {\nvReflect = reflect( cameraToVertex, normal );\n}\nvec4 cubeColor = textureCube( tCube, vec3( -vReflect.x, vReflect.yz ) );\n#ifdef GAMMA_INPUT\ncubeColor.xyz *= cubeColor.xyz;\n#endif\ngl_FragColor.xyz = mix( gl_FragColor.xyz, cubeColor.xyz, specularTex.r * uReflectivity );\n}",
			THREE.ShaderChunk.shadowmap_fragment, THREE.ShaderChunk.linear_to_gamma_fragment, THREE.ShaderChunk.fog_fragment, "}"].join("\n"),
			vertexShader: ["attribute vec4 tangent;\nuniform vec2 uOffset;\nuniform vec2 uRepeat;\nuniform bool enableDisplacement;\n#ifdef VERTEX_TEXTURES\nuniform sampler2D tDisplacement;\nuniform float uDisplacementScale;\nuniform float uDisplacementBias;\n#endif\nvarying vec3 vTangent;\nvarying vec3 vBinormal;\nvarying vec3 vNormal;\nvarying vec2 vUv;\nvarying vec3 vWorldPosition;\nvarying vec3 vViewPosition;",
			THREE.ShaderChunk.skinning_pars_vertex, THREE.ShaderChunk.shadowmap_pars_vertex, "void main() {", THREE.ShaderChunk.skinbase_vertex, THREE.ShaderChunk.skinnormal_vertex, "#ifdef USE_SKINNING\nvNormal = normalize( normalMatrix * skinnedNormal.xyz );\nvec4 skinnedTangent = skinMatrix * vec4( tangent.xyz, 0.0 );\nvTangent = normalize( normalMatrix * skinnedTangent.xyz );\n#else\nvNormal = normalize( normalMatrix * normal );\nvTangent = normalize( normalMatrix * tangent.xyz );\n#endif\nvBinormal = normalize( cross( vNormal, vTangent ) * tangent.w );\nvUv = uv * uRepeat + uOffset;\nvec3 displacedPosition;\n#ifdef VERTEX_TEXTURES\nif ( enableDisplacement ) {\nvec3 dv = texture2D( tDisplacement, uv ).xyz;\nfloat df = uDisplacementScale * dv.x + uDisplacementBias;\ndisplacedPosition = position + normalize( normal ) * df;\n} else {\n#ifdef USE_SKINNING\nvec4 skinVertex = vec4( position, 1.0 );\nvec4 skinned  = boneMatX * skinVertex * skinWeight.x;\nskinned \t  += boneMatY * skinVertex * skinWeight.y;\ndisplacedPosition  = skinned.xyz;\n#else\ndisplacedPosition = position;\n#endif\n}\n#else\n#ifdef USE_SKINNING\nvec4 skinVertex = vec4( position, 1.0 );\nvec4 skinned  = boneMatX * skinVertex * skinWeight.x;\nskinned \t  += boneMatY * skinVertex * skinWeight.y;\ndisplacedPosition  = skinned.xyz;\n#else\ndisplacedPosition = position;\n#endif\n#endif\nvec4 mvPosition = modelViewMatrix * vec4( displacedPosition, 1.0 );\nvec4 worldPosition = modelMatrix * vec4( displacedPosition, 1.0 );\ngl_Position = projectionMatrix * mvPosition;\nvWorldPosition = worldPosition.xyz;\nvViewPosition = -mvPosition.xyz;\n#ifdef USE_SHADOWMAP\nfor( int i = 0; i < MAX_SHADOWS; i ++ ) {\nvShadowCoord[ i ] = shadowMatrix[ i ] * worldPosition;\n}\n#endif\n}"].join("\n")
		},
		cube: {
			uniforms: {
				tCube: {
					type: "t",
					value: null
				},
				tFlip: {
					type: "f",
					value: -1
				}
			},
			vertexShader: "varying vec3 vWorldPosition;\nvoid main() {\nvec4 worldPosition = modelMatrix * vec4( position, 1.0 );\nvWorldPosition = worldPosition.xyz;\ngl_Position = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );\n}",
			fragmentShader: "uniform samplerCube tCube;\nuniform float tFlip;\nvarying vec3 vWorldPosition;\nvoid main() {\ngl_FragColor = textureCube( tCube, vec3( tFlip * vWorldPosition.x, vWorldPosition.yz ) );\n}"
		}
	}
};
THREE.FontUtils = {
	faces: {},
	face: "helvetiker",
	weight: "normal",
	style: "normal",
	size: 150,
	divisions: 10,
	getFace: function () {
		return this.faces[this.face][this.weight][this.style]
	},
	loadFace: function (a) {
		var b = a.familyName.toLowerCase();
		this.faces[b] = this.faces[b] || {};
		this.faces[b][a.cssFontWeight] = this.faces[b][a.cssFontWeight] || {};
		this.faces[b][a.cssFontWeight][a.cssFontStyle] = a;
		return this.faces[b][a.cssFontWeight][a.cssFontStyle] = a
	},
	drawText: function (a) {
		for (var b = this.getFace(), c = this.size / b.resolution, d = 0, e = String(a).split(""), f = e.length, g = [], a = 0; a < f; a++) {
			var h = new THREE.Path,
				h = this.extractGlyphPoints(e[a], b, c, d, h),
				d = d + h.offset;
			g.push(h.path)
		}
		return {
			paths: g,
			offset: d / 2
		}
	},
	extractGlyphPoints: function (a, b, c, d, e) {
		var f = [],
			g, h, i, k, j, l, m, r, q, p, t, u = b.glyphs[a] || b.glyphs["?"];
		if (u) {
			if (u.o) {
				b = u._cachedOutline || (u._cachedOutline = u.o.split(" "));
				k = b.length;
				for (a = 0; a < k;) switch (i = b[a++], i) {
					case "m":
						i = b[a++] * c + d;
						j = b[a++] * c;
						e.moveTo(i, j);
						break;
					case "l":
						i = b[a++] * c + d;
						j = b[a++] * c;
						e.lineTo(i, j);
						break;
					case "q":
						i = b[a++] * c + d;
						j = b[a++] * c;
						r = b[a++] * c + d;
						q = b[a++] * c;
						e.quadraticCurveTo(r, q, i, j);
						if (g = f[f.length - 1]) {
							l = g.x;
							m = g.y;
							g = 1;
							for (h = this.divisions; g <= h; g++) {
								var x = g / h;
								THREE.Shape.Utils.b2(x, l, r, i);
								THREE.Shape.Utils.b2(x, m, q, j)
							}
						}
						break;
					case "b":
						if (i = b[a++] * c + d, j = b[a++] * c, r = b[a++] * c + d, q = b[a++] * -c, p = b[a++] * c + d, t = b[a++] * -c, e.bezierCurveTo(i, j, r, q, p, t), g = f[f.length - 1]) {
							l = g.x;
							m = g.y;
							g = 1;
							for (h = this.divisions; g <= h; g++) x = g / h, THREE.Shape.Utils.b3(x, l, r, p, i), THREE.Shape.Utils.b3(x, m, q, t, j)
						}
				}
			}
			return {
				offset: u.ha * c,
				path: e
			}
		}
	}
};
THREE.FontUtils.generateShapes = function (a, b) {
	var b = b || {}, c = void 0 !== b.curveSegments ? b.curveSegments : 4,
		d = void 0 !== b.font ? b.font : "helvetiker",
		e = void 0 !== b.weight ? b.weight : "normal",
		f = void 0 !== b.style ? b.style : "normal";
	THREE.FontUtils.size = void 0 !== b.size ? b.size : 100;
	THREE.FontUtils.divisions = c;
	THREE.FontUtils.face = d;
	THREE.FontUtils.weight = e;
	THREE.FontUtils.style = f;
	c = THREE.FontUtils.drawText(a).paths;
	d = [];
	e = 0;
	for (f = c.length; e < f; e++) Array.prototype.push.apply(d, c[e].toShapes());
	return d
};
(function (a) {
	var b = function (a) {
		for (var b = a.length, e = 0, f = b - 1, g = 0; g < b; f = g++) e += a[f].x * a[g].y - a[g].x * a[f].y;
		return 0.5 * e
	};
	a.Triangulate = function (a, d) {
		var e = a.length;
		if (3 > e) return null;
		var f = [],
			g = [],
			h = [],
			i, k, j;
		if (0 < b(a)) for (k = 0; k < e; k++) g[k] = k;
		else for (k = 0; k < e; k++) g[k] = e - 1 - k;
		var l = 2 * e;
		for (k = e - 1; 2 < e;) {
			if (0 >= l--) {
				console.log("Warning, unable to triangulate polygon!");
				break
			}
			i = k;
			e <= i && (i = 0);
			k = i + 1;
			e <= k && (k = 0);
			j = k + 1;
			e <= j && (j = 0);
			var m;
			a: {
				var r = m = void 0,
					q = void 0,
					p = void 0,
					t = void 0,
					u = void 0,
					x = void 0,
					v = void 0,
					s = void 0,
					r = a[g[i]].x,
					q = a[g[i]].y,
					p = a[g[k]].x,
					t = a[g[k]].y,
					u = a[g[j]].x,
					x = a[g[j]].y;
				if (1E-10 > (p - r) * (x - q) - (t - q) * (u - r)) m = !1;
				else {
					var C = void 0,
						z = void 0,
						w = void 0,
						A = void 0,
						H = void 0,
						G = void 0,
						I = void 0,
						V = void 0,
						E = void 0,
						O = void 0,
						E = V = I = s = v = void 0,
						C = u - p,
						z = x - t,
						w = r - u,
						A = q - x,
						H = p - r,
						G = t - q;
					for (m = 0; m < e; m++) if (!(m === i || m === k || m === j)) if (v = a[g[m]].x, s = a[g[m]].y, I = v - r, V = s - q, E = v - p, O = s - t, v -= u, s -= x, E = C * O - z * E, I = H * V - G * I, V = w * s - A * v, 0 <= E && 0 <= V && 0 <= I) {
						m = !1;
						break a
					}
					m = !0
				}
			}
			if (m) {
				f.push([a[g[i]], a[g[k]], a[g[j]]]);
				h.push([g[i], g[k], g[j]]);
				i = k;
				for (j = k + 1; j < e; i++, j++) g[i] = g[j];
				e--;
				l = 2 * e
			}
		}
		return d ? h : f
	};
	a.Triangulate.area = b;
	return a
})(THREE.FontUtils);
self._typeface_js = {
	faces: THREE.FontUtils.faces,
	loadFace: THREE.FontUtils.loadFace
};
THREE.Curve = function () {};
THREE.Curve.prototype.getPoint = function () {
	console.log("Warning, getPoint() not implemented!");
	return null
};
THREE.Curve.prototype.getPointAt = function (a) {
	a = this.getUtoTmapping(a);
	return this.getPoint(a)
};
THREE.Curve.prototype.getPoints = function (a) {
	a || (a = 5);
	var b, c = [];
	for (b = 0; b <= a; b++) c.push(this.getPoint(b / a));
	return c
};
THREE.Curve.prototype.getSpacedPoints = function (a) {
	a || (a = 5);
	var b, c = [];
	for (b = 0; b <= a; b++) c.push(this.getPointAt(b / a));
	return c
};
THREE.Curve.prototype.getLength = function () {
	var a = this.getLengths();
	return a[a.length - 1]
};
THREE.Curve.prototype.getLengths = function (a) {
	a || (a = this.__arcLengthDivisions ? this.__arcLengthDivisions : 200);
	if (this.cacheArcLengths && this.cacheArcLengths.length == a + 1 && !this.needsUpdate) return this.cacheArcLengths;
	this.needsUpdate = !1;
	var b = [],
		c, d = this.getPoint(0),
		e, f = 0;
	b.push(0);
	for (e = 1; e <= a; e++) c = this.getPoint(e / a), f += c.distanceTo(d), b.push(f), d = c;
	return this.cacheArcLengths = b
};
THREE.Curve.prototype.updateArcLengths = function () {
	this.needsUpdate = !0;
	this.getLengths()
};
THREE.Curve.prototype.getUtoTmapping = function (a, b) {
	var c = this.getLengths(),
		d = 0,
		e = c.length,
		f;
	f = b ? b : a * c[e - 1];
	for (var g = 0, h = e - 1, i; g <= h;) if (d = Math.floor(g + (h - g) / 2), i = c[d] - f, 0 > i) g = d + 1;
	else if (0 < i) h = d - 1;
	else {
		h = d;
		break
	}
	d = h;
	if (c[d] == f) return d / (e - 1);
	g = c[d];
	return c = (d + (f - g) / (c[d + 1] - g)) / (e - 1)
};
THREE.Curve.prototype.getTangent = function (a) {
	var b = a - 1E-4,
		a = a + 1E-4;
	0 > b && (b = 0);
	1 < a && (a = 1);
	b = this.getPoint(b);
	return this.getPoint(a).clone().sub(b).normalize()
};
THREE.Curve.prototype.getTangentAt = function (a) {
	a = this.getUtoTmapping(a);
	return this.getTangent(a)
};
THREE.LineCurve = function (a, b) {
	this.v1 = a;
	this.v2 = b
};
THREE.LineCurve.prototype = Object.create(THREE.Curve.prototype);
THREE.LineCurve.prototype.getPoint = function (a) {
	var b = this.v2.clone().sub(this.v1);
	b.multiplyScalar(a).add(this.v1);
	return b
};
THREE.LineCurve.prototype.getPointAt = function (a) {
	return this.getPoint(a)
};
THREE.LineCurve.prototype.getTangent = function () {
	return this.v2.clone().sub(this.v1).normalize()
};
THREE.QuadraticBezierCurve = function (a, b, c) {
	this.v0 = a;
	this.v1 = b;
	this.v2 = c
};
THREE.QuadraticBezierCurve.prototype = Object.create(THREE.Curve.prototype);
THREE.QuadraticBezierCurve.prototype.getPoint = function (a) {
	var b;
	b = THREE.Shape.Utils.b2(a, this.v0.x, this.v1.x, this.v2.x);
	a = THREE.Shape.Utils.b2(a, this.v0.y, this.v1.y, this.v2.y);
	return new THREE.Vector2(b, a)
};
THREE.QuadraticBezierCurve.prototype.getTangent = function (a) {
	var b;
	b = THREE.Curve.Utils.tangentQuadraticBezier(a, this.v0.x, this.v1.x, this.v2.x);
	a = THREE.Curve.Utils.tangentQuadraticBezier(a, this.v0.y, this.v1.y, this.v2.y);
	b = new THREE.Vector2(b, a);
	b.normalize();
	return b
};
THREE.CubicBezierCurve = function (a, b, c, d) {
	this.v0 = a;
	this.v1 = b;
	this.v2 = c;
	this.v3 = d
};
THREE.CubicBezierCurve.prototype = Object.create(THREE.Curve.prototype);
THREE.CubicBezierCurve.prototype.getPoint = function (a) {
	var b;
	b = THREE.Shape.Utils.b3(a, this.v0.x, this.v1.x, this.v2.x, this.v3.x);
	a = THREE.Shape.Utils.b3(a, this.v0.y, this.v1.y, this.v2.y, this.v3.y);
	return new THREE.Vector2(b, a)
};
THREE.CubicBezierCurve.prototype.getTangent = function (a) {
	var b;
	b = THREE.Curve.Utils.tangentCubicBezier(a, this.v0.x, this.v1.x, this.v2.x, this.v3.x);
	a = THREE.Curve.Utils.tangentCubicBezier(a, this.v0.y, this.v1.y, this.v2.y, this.v3.y);
	b = new THREE.Vector2(b, a);
	b.normalize();
	return b
};
THREE.SplineCurve = function (a) {
	this.points = void 0 == a ? [] : a
};
THREE.SplineCurve.prototype = Object.create(THREE.Curve.prototype);
THREE.SplineCurve.prototype.getPoint = function (a) {
	var b = new THREE.Vector2,
		c = [],
		d = this.points,
		e;
	e = (d.length - 1) * a;
	a = Math.floor(e);
	e -= a;
	c[0] = 0 == a ? a : a - 1;
	c[1] = a;
	c[2] = a > d.length - 2 ? d.length - 1 : a + 1;
	c[3] = a > d.length - 3 ? d.length - 1 : a + 2;
	b.x = THREE.Curve.Utils.interpolate(d[c[0]].x, d[c[1]].x, d[c[2]].x, d[c[3]].x, e);
	b.y = THREE.Curve.Utils.interpolate(d[c[0]].y, d[c[1]].y, d[c[2]].y, d[c[3]].y, e);
	return b
};
THREE.EllipseCurve = function (a, b, c, d, e, f, g) {
	this.aX = a;
	this.aY = b;
	this.xRadius = c;
	this.yRadius = d;
	this.aStartAngle = e;
	this.aEndAngle = f;
	this.aClockwise = g
};
THREE.EllipseCurve.prototype = Object.create(THREE.Curve.prototype);
THREE.EllipseCurve.prototype.getPoint = function (a) {
	var b = this.aEndAngle - this.aStartAngle;
	this.aClockwise || (a = 1 - a);
	b = this.aStartAngle + a * b;
	a = this.aX + this.xRadius * Math.cos(b);
	b = this.aY + this.yRadius * Math.sin(b);
	return new THREE.Vector2(a, b)
};
THREE.ArcCurve = function (a, b, c, d, e, f) {
	THREE.EllipseCurve.call(this, a, b, c, c, d, e, f)
};
THREE.ArcCurve.prototype = Object.create(THREE.EllipseCurve.prototype);
THREE.Curve.Utils = {
	tangentQuadraticBezier: function (a, b, c, d) {
		return 2 * (1 - a) * (c - b) + 2 * a * (d - c)
	},
	tangentCubicBezier: function (a, b, c, d, e) {
		return -3 * b * (1 - a) * (1 - a) + 3 * c * (1 - a) * (1 - a) - 6 * a * c * (1 - a) + 6 * a * d * (1 - a) - 3 * a * a * d + 3 * a * a * e
	},
	tangentSpline: function (a) {
		return 6 * a * a - 6 * a + (3 * a * a - 4 * a + 1) + (-6 * a * a + 6 * a) + (3 * a * a - 2 * a)
	},
	interpolate: function (a, b, c, d, e) {
		var a = 0.5 * (c - a),
			d = 0.5 * (d - b),
			f = e * e;
		return (2 * b - 2 * c + a + d) * e * f + (-3 * b + 3 * c - 2 * a - d) * f + a * e + b
	}
};
THREE.Curve.create = function (a, b) {
	a.prototype = Object.create(THREE.Curve.prototype);
	a.prototype.getPoint = b;
	return a
};
THREE.LineCurve3 = THREE.Curve.create(function (a, b) {
	this.v1 = a;
	this.v2 = b
}, function (a) {
	var b = new THREE.Vector3;
	b.sub(this.v2, this.v1);
	b.multiplyScalar(a);
	b.add(this.v1);
	return b
});
THREE.QuadraticBezierCurve3 = THREE.Curve.create(function (a, b, c) {
	this.v0 = a;
	this.v1 = b;
	this.v2 = c
}, function (a) {
	var b, c;
	b = THREE.Shape.Utils.b2(a, this.v0.x, this.v1.x, this.v2.x);
	c = THREE.Shape.Utils.b2(a, this.v0.y, this.v1.y, this.v2.y);
	a = THREE.Shape.Utils.b2(a, this.v0.z, this.v1.z, this.v2.z);
	return new THREE.Vector3(b, c, a)
});
THREE.CubicBezierCurve3 = THREE.Curve.create(function (a, b, c, d) {
	this.v0 = a;
	this.v1 = b;
	this.v2 = c;
	this.v3 = d
}, function (a) {
	var b, c;
	b = THREE.Shape.Utils.b3(a, this.v0.x, this.v1.x, this.v2.x, this.v3.x);
	c = THREE.Shape.Utils.b3(a, this.v0.y, this.v1.y, this.v2.y, this.v3.y);
	a = THREE.Shape.Utils.b3(a, this.v0.z, this.v1.z, this.v2.z, this.v3.z);
	return new THREE.Vector3(b, c, a)
});
THREE.SplineCurve3 = THREE.Curve.create(function (a) {
	this.points = void 0 == a ? [] : a
}, function (a) {
	var b = new THREE.Vector3,
		c = [],
		d = this.points,
		e, a = (d.length - 1) * a;
	e = Math.floor(a);
	a -= e;
	c[0] = 0 == e ? e : e - 1;
	c[1] = e;
	c[2] = e > d.length - 2 ? d.length - 1 : e + 1;
	c[3] = e > d.length - 3 ? d.length - 1 : e + 2;
	e = d[c[0]];
	var f = d[c[1]],
		g = d[c[2]],
		c = d[c[3]];
	b.x = THREE.Curve.Utils.interpolate(e.x, f.x, g.x, c.x, a);
	b.y = THREE.Curve.Utils.interpolate(e.y, f.y, g.y, c.y, a);
	b.z = THREE.Curve.Utils.interpolate(e.z, f.z, g.z, c.z, a);
	return b
});
THREE.ClosedSplineCurve3 = THREE.Curve.create(function (a) {
	this.points = void 0 == a ? [] : a
}, function (a) {
	var b = new THREE.Vector3,
		c = [],
		d = this.points,
		e;
	e = (d.length - 0) * a;
	a = Math.floor(e);
	e -= a;
	a += 0 < a ? 0 : (Math.floor(Math.abs(a) / d.length) + 1) * d.length;
	c[0] = (a - 1) % d.length;
	c[1] = a % d.length;
	c[2] = (a + 1) % d.length;
	c[3] = (a + 2) % d.length;
	b.x = THREE.Curve.Utils.interpolate(d[c[0]].x, d[c[1]].x, d[c[2]].x, d[c[3]].x, e);
	b.y = THREE.Curve.Utils.interpolate(d[c[0]].y, d[c[1]].y, d[c[2]].y, d[c[3]].y, e);
	b.z = THREE.Curve.Utils.interpolate(d[c[0]].z,
	d[c[1]].z, d[c[2]].z, d[c[3]].z, e);
	return b
});
THREE.CurvePath = function () {
	this.curves = [];
	this.bends = [];
	this.autoClose = !1
};
THREE.CurvePath.prototype = Object.create(THREE.Curve.prototype);
THREE.CurvePath.prototype.add = function (a) {
	this.curves.push(a)
};
THREE.CurvePath.prototype.checkConnection = function () {};
THREE.CurvePath.prototype.closePath = function () {
	var a = this.curves[0].getPoint(0),
		b = this.curves[this.curves.length - 1].getPoint(1);
	a.equals(b) || this.curves.push(new THREE.LineCurve(b, a))
};
THREE.CurvePath.prototype.getPoint = function (a) {
	for (var b = a * this.getLength(), c = this.getCurveLengths(), a = 0; a < c.length;) {
		if (c[a] >= b) return b = c[a] - b, a = this.curves[a], b = 1 - b / a.getLength(), a.getPointAt(b);
		a++
	}
	return null
};
THREE.CurvePath.prototype.getLength = function () {
	var a = this.getCurveLengths();
	return a[a.length - 1]
};
THREE.CurvePath.prototype.getCurveLengths = function () {
	if (this.cacheLengths && this.cacheLengths.length == this.curves.length) return this.cacheLengths;
	var a = [],
		b = 0,
		c, d = this.curves.length;
	for (c = 0; c < d; c++) b += this.curves[c].getLength(), a.push(b);
	return this.cacheLengths = a
};
THREE.CurvePath.prototype.getBoundingBox = function () {
	var a = this.getPoints(),
		b, c, d, e, f, g;
	b = c = Number.NEGATIVE_INFINITY;
	e = f = Number.POSITIVE_INFINITY;
	var h, i, k, j, l = a[0] instanceof THREE.Vector3;
	j = l ? new THREE.Vector3 : new THREE.Vector2;
	i = 0;
	for (k = a.length; i < k; i++) h = a[i], h.x > b ? b = h.x : h.x < e && (e = h.x), h.y > c ? c = h.y : h.y < f && (f = h.y), l && (h.z > d ? d = h.z : h.z < g && (g = h.z)), j.add(h);
	a = {
		minX: e,
		minY: f,
		maxX: b,
		maxY: c,
		centroid: j.divideScalar(k)
	};
	l && (a.maxZ = d, a.minZ = g);
	return a
};
THREE.CurvePath.prototype.createPointsGeometry = function (a) {
	a = this.getPoints(a, !0);
	return this.createGeometry(a)
};
THREE.CurvePath.prototype.createSpacedPointsGeometry = function (a) {
	a = this.getSpacedPoints(a, !0);
	return this.createGeometry(a)
};
THREE.CurvePath.prototype.createGeometry = function (a) {
	for (var b = new THREE.Geometry, c = 0; c < a.length; c++) b.vertices.push(new THREE.Vector3(a[c].x, a[c].y, a[c].z || 0));
	return b
};
THREE.CurvePath.prototype.addWrapPath = function (a) {
	this.bends.push(a)
};
THREE.CurvePath.prototype.getTransformedPoints = function (a, b) {
	var c = this.getPoints(a),
		d, e;
	b || (b = this.bends);
	d = 0;
	for (e = b.length; d < e; d++) c = this.getWrapPoints(c, b[d]);
	return c
};
THREE.CurvePath.prototype.getTransformedSpacedPoints = function (a, b) {
	var c = this.getSpacedPoints(a),
		d, e;
	b || (b = this.bends);
	d = 0;
	for (e = b.length; d < e; d++) c = this.getWrapPoints(c, b[d]);
	return c
};
THREE.CurvePath.prototype.getWrapPoints = function (a, b) {
	var c = this.getBoundingBox(),
		d, e, f, g, h, i;
	d = 0;
	for (e = a.length; d < e; d++) f = a[d], g = f.x, h = f.y, i = g / c.maxX, i = b.getUtoTmapping(i, g), g = b.getPoint(i), h = b.getNormalVector(i).multiplyScalar(h), f.x = g.x + h.x, f.y = g.y + h.y;
	return a
};
THREE.Gyroscope = function () {
	THREE.Object3D.call(this)
};
THREE.Gyroscope.prototype = Object.create(THREE.Object3D.prototype);
THREE.Gyroscope.prototype.updateMatrixWorld = function (a) {
	this.matrixAutoUpdate && this.updateMatrix();// TODO CHANGED
	if (this.matrixWorldNeedsUpdate || a) this.parent ? (this.matrixWorld.multiplyMatrices(this.parent.matrixWorld, this.matrix), this.matrixWorld.decompose(this.translationWorld, this.rotationWorld, this.scaleWorld), this.matrix.decompose(this.translationObject, this.rotationObject, this.scaleObject), this.matrixWorld.compose(this.translationWorld, this.rotationObject, this.scaleWorld)) : this.matrixWorld.copy(this.matrix), this.matrixWorldNeedsUpdate = !1, a = !0;
	for (var b = 0, c = this.children.length; b < c; b++) this.children[b].updateMatrixWorld(a)
};
THREE.Gyroscope.prototype.translationWorld = new THREE.Vector3;
THREE.Gyroscope.prototype.translationObject = new THREE.Vector3;
THREE.Gyroscope.prototype.rotationWorld = new THREE.Quaternion;
THREE.Gyroscope.prototype.rotationObject = new THREE.Quaternion;
THREE.Gyroscope.prototype.scaleWorld = new THREE.Vector3;
THREE.Gyroscope.prototype.scaleObject = new THREE.Vector3;
THREE.Path = function (a) {
	THREE.CurvePath.call(this);
	this.actions = [];
	a && this.fromPoints(a)
};
THREE.Path.prototype = Object.create(THREE.CurvePath.prototype);
THREE.PathActions = {
	MOVE_TO: "moveTo",
	LINE_TO: "lineTo",
	QUADRATIC_CURVE_TO: "quadraticCurveTo",
	BEZIER_CURVE_TO: "bezierCurveTo",
	CSPLINE_THRU: "splineThru",
	ARC: "arc",
	ELLIPSE: "ellipse"
};
THREE.Path.prototype.fromPoints = function (a) {
	this.moveTo(a[0].x, a[0].y);
	for (var b = 1, c = a.length; b < c; b++) this.lineTo(a[b].x, a[b].y)
};
THREE.Path.prototype.moveTo = function (a, b) {
	var c = Array.prototype.slice.call(arguments);
	this.actions.push({
		action: THREE.PathActions.MOVE_TO,
		args: c
	})
};
THREE.Path.prototype.lineTo = function (a, b) {
	var c = Array.prototype.slice.call(arguments),
		d = this.actions[this.actions.length - 1].args,
		d = new THREE.LineCurve(new THREE.Vector2(d[d.length - 2], d[d.length - 1]), new THREE.Vector2(a, b));
	this.curves.push(d);
	this.actions.push({
		action: THREE.PathActions.LINE_TO,
		args: c
	})
};
THREE.Path.prototype.quadraticCurveTo = function (a, b, c, d) {
	var e = Array.prototype.slice.call(arguments),
		f = this.actions[this.actions.length - 1].args,
		f = new THREE.QuadraticBezierCurve(new THREE.Vector2(f[f.length - 2], f[f.length - 1]), new THREE.Vector2(a, b), new THREE.Vector2(c, d));
	this.curves.push(f);
	this.actions.push({
		action: THREE.PathActions.QUADRATIC_CURVE_TO,
		args: e
	})
};
THREE.Path.prototype.bezierCurveTo = function (a, b, c, d, e, f) {
	var g = Array.prototype.slice.call(arguments),
		h = this.actions[this.actions.length - 1].args,
		h = new THREE.CubicBezierCurve(new THREE.Vector2(h[h.length - 2], h[h.length - 1]), new THREE.Vector2(a, b), new THREE.Vector2(c, d), new THREE.Vector2(e, f));
	this.curves.push(h);
	this.actions.push({
		action: THREE.PathActions.BEZIER_CURVE_TO,
		args: g
	})
};
THREE.Path.prototype.splineThru = function (a) {
	var b = Array.prototype.slice.call(arguments),
		c = this.actions[this.actions.length - 1].args,
		c = [new THREE.Vector2(c[c.length - 2], c[c.length - 1])];
	Array.prototype.push.apply(c, a);
	c = new THREE.SplineCurve(c);
	this.curves.push(c);
	this.actions.push({
		action: THREE.PathActions.CSPLINE_THRU,
		args: b
	})
};
THREE.Path.prototype.arc = function (a, b, c, d, e, f) {
	var g = this.actions[this.actions.length - 1].args;
	this.absarc(a + g[g.length - 2], b + g[g.length - 1], c, d, e, f)
};
THREE.Path.prototype.absarc = function (a, b, c, d, e, f) {
	this.absellipse(a, b, c, c, d, e, f)
};
THREE.Path.prototype.ellipse = function (a, b, c, d, e, f, g) {
	var h = this.actions[this.actions.length - 1].args;
	this.absellipse(a + h[h.length - 2], b + h[h.length - 1], c, d, e, f, g)
};
THREE.Path.prototype.absellipse = function (a, b, c, d, e, f, g) {
	var h = Array.prototype.slice.call(arguments),
		i = new THREE.EllipseCurve(a, b, c, d, e, f, g);
	this.curves.push(i);
	i = i.getPoint(g ? 1 : 0);
	h.push(i.x);
	h.push(i.y);
	this.actions.push({
		action: THREE.PathActions.ELLIPSE,
		args: h
	})
};
THREE.Path.prototype.getSpacedPoints = function (a) {
	a || (a = 40);
	for (var b = [], c = 0; c < a; c++) b.push(this.getPoint(c / a));
	return b
};
THREE.Path.prototype.getPoints = function (a, b) {
	if (this.useSpacedPoints) return console.log("tata"), this.getSpacedPoints(a, b);
	var a = a || 12,
		c = [],
		d, e, f, g, h, i, k, j, l, m, r, q, p;
	d = 0;
	for (e = this.actions.length; d < e; d++) switch (f = this.actions[d], g = f.action, f = f.args, g) {
		case THREE.PathActions.MOVE_TO:
			c.push(new THREE.Vector2(f[0], f[1]));
			break;
		case THREE.PathActions.LINE_TO:
			c.push(new THREE.Vector2(f[0], f[1]));
			break;
		case THREE.PathActions.QUADRATIC_CURVE_TO:
			h = f[2];
			i = f[3];
			l = f[0];
			m = f[1];
			0 < c.length ? (g = c[c.length - 1], r = g.x,
			q = g.y) : (g = this.actions[d - 1].args, r = g[g.length - 2], q = g[g.length - 1]);
			for (f = 1; f <= a; f++) p = f / a, g = THREE.Shape.Utils.b2(p, r, l, h), p = THREE.Shape.Utils.b2(p, q, m, i), c.push(new THREE.Vector2(g, p));
			break;
		case THREE.PathActions.BEZIER_CURVE_TO:
			h = f[4];
			i = f[5];
			l = f[0];
			m = f[1];
			k = f[2];
			j = f[3];
			0 < c.length ? (g = c[c.length - 1], r = g.x, q = g.y) : (g = this.actions[d - 1].args, r = g[g.length - 2], q = g[g.length - 1]);
			for (f = 1; f <= a; f++) p = f / a, g = THREE.Shape.Utils.b3(p, r, l, k, h), p = THREE.Shape.Utils.b3(p, q, m, j, i), c.push(new THREE.Vector2(g, p));
			break;
		case THREE.PathActions.CSPLINE_THRU:
			g = this.actions[d - 1].args;
			p = [new THREE.Vector2(g[g.length - 2], g[g.length - 1])];
			g = a * f[0].length;
			p = p.concat(f[0]);
			p = new THREE.SplineCurve(p);
			for (f = 1; f <= g; f++) c.push(p.getPointAt(f / g));
			break;
		case THREE.PathActions.ARC:
			h = f[0];
			i = f[1];
			m = f[2];
			k = f[3];
			g = f[4];
			l = !! f[5];
			r = g - k;
			q = 2 * a;
			for (f = 1; f <= q; f++) p = f / q, l || (p = 1 - p), p = k + p * r, g = h + m * Math.cos(p), p = i + m * Math.sin(p), c.push(new THREE.Vector2(g, p));
			break;
		case THREE.PathActions.ELLIPSE:
			h = f[0];
			i = f[1];
			m = f[2];
			j = f[3];
			k = f[4];
			g = f[5];
			l = !! f[6];
			r = g - k;
			q = 2 * a;
			for (f = 1; f <= q; f++) p = f / q, l || (p = 1 - p), p = k + p * r, g = h + m * Math.cos(p), p = i + j * Math.sin(p), c.push(new THREE.Vector2(g, p))
	}
	d = c[c.length - 1];
	1E-10 > Math.abs(d.x - c[0].x) && 1E-10 > Math.abs(d.y - c[0].y) && c.splice(c.length - 1, 1);
	b && c.push(c[0]);
	return c
};
THREE.Path.prototype.toShapes = function () {
	var a, b, c, d, e = [],
		f = new THREE.Path;
	a = 0;
	for (b = this.actions.length; a < b; a++) c = this.actions[a], d = c.args, c = c.action, c == THREE.PathActions.MOVE_TO && 0 != f.actions.length && (e.push(f), f = new THREE.Path), f[c].apply(f, d);
	0 != f.actions.length && e.push(f);
	if (0 == e.length) return [];
	var g;
	d = [];
	a = !THREE.Shape.Utils.isClockWise(e[0].getPoints());
	if (1 == e.length) return f = e[0], g = new THREE.Shape, g.actions = f.actions, g.curves = f.curves, d.push(g), d;
	if (a) {
		g = new THREE.Shape;
		a = 0;
		for (b = e.length; a < b; a++) f = e[a], THREE.Shape.Utils.isClockWise(f.getPoints()) ? (g.actions = f.actions, g.curves = f.curves, d.push(g), g = new THREE.Shape) : g.holes.push(f)
	} else {
		a = 0;
		for (b = e.length; a < b; a++) f = e[a], THREE.Shape.Utils.isClockWise(f.getPoints()) ? (g && d.push(g), g = new THREE.Shape, g.actions = f.actions, g.curves = f.curves) : g.holes.push(f);
		d.push(g)
	}
	return d
};
THREE.Shape = function () {
	THREE.Path.apply(this, arguments);
	this.holes = []
};
THREE.Shape.prototype = Object.create(THREE.Path.prototype);
THREE.Shape.prototype.extrude = function (a) {
	return new THREE.ExtrudeGeometry(this, a)
};
THREE.Shape.prototype.makeGeometry = function (a) {
	return new THREE.ShapeGeometry(this, a)
};
THREE.Shape.prototype.getPointsHoles = function (a) {
	var b, c = this.holes.length,
		d = [];
	for (b = 0; b < c; b++) d[b] = this.holes[b].getTransformedPoints(a, this.bends);
	return d
};
THREE.Shape.prototype.getSpacedPointsHoles = function (a) {
	var b, c = this.holes.length,
		d = [];
	for (b = 0; b < c; b++) d[b] = this.holes[b].getTransformedSpacedPoints(a, this.bends);
	return d
};
THREE.Shape.prototype.extractAllPoints = function (a) {
	return {
		shape: this.getTransformedPoints(a),
		holes: this.getPointsHoles(a)
	}
};
THREE.Shape.prototype.extractPoints = function (a) {
	return this.useSpacedPoints ? this.extractAllSpacedPoints(a) : this.extractAllPoints(a)
};
THREE.Shape.prototype.extractAllSpacedPoints = function (a) {
	return {
		shape: this.getTransformedSpacedPoints(a),
		holes: this.getSpacedPointsHoles(a)
	}
};
THREE.Shape.Utils = {
	removeHoles: function (a, b) {
		var c = a.concat(),
			d = c.concat(),
			e, f, g, h, i, k, j, l, m, r, q = [];
		for (i = 0; i < b.length; i++) {
			k = b[i];
			Array.prototype.push.apply(d, k);
			f = Number.POSITIVE_INFINITY;
			for (e = 0; e < k.length; e++) {
				m = k[e];
				r = [];
				for (l = 0; l < c.length; l++) j = c[l], j = m.distanceToSquared(j), r.push(j), j < f && (f = j, g = e, h = l)
			}
			e = 0 <= h - 1 ? h - 1 : c.length - 1;
			f = 0 <= g - 1 ? g - 1 : k.length - 1;
			var p = [k[g], c[h], c[e]];
			l = THREE.FontUtils.Triangulate.area(p);
			var t = [k[g], k[f], c[h]];
			m = THREE.FontUtils.Triangulate.area(t);
			r = h;
			j = g;
			h += 1;
			g += -1;
			0 > h && (h += c.length);
			h %= c.length;
			0 > g && (g += k.length);
			g %= k.length;
			e = 0 <= h - 1 ? h - 1 : c.length - 1;
			f = 0 <= g - 1 ? g - 1 : k.length - 1;
			p = [k[g], c[h], c[e]];
			p = THREE.FontUtils.Triangulate.area(p);
			t = [k[g], k[f], c[h]];
			t = THREE.FontUtils.Triangulate.area(t);
			l + m > p + t && (h = r, g = j, 0 > h && (h += c.length), h %= c.length, 0 > g && (g += k.length), g %= k.length, e = 0 <= h - 1 ? h - 1 : c.length - 1, f = 0 <= g - 1 ? g - 1 : k.length - 1);
			l = c.slice(0, h);
			m = c.slice(h);
			r = k.slice(g);
			j = k.slice(0, g);
			f = [k[g], k[f], c[h]];
			q.push([k[g], c[h], c[e]]);
			q.push(f);
			c = l.concat(r).concat(j).concat(m)
		}
		return {
			shape: c,
			isolatedPts: q,
			allpoints: d
		}
	},
	triangulateShape: function (a, b) {
		var c = THREE.Shape.Utils.removeHoles(a, b),
			d = c.allpoints,
			e = c.isolatedPts,
			c = THREE.FontUtils.Triangulate(c.shape, !1),
			f, g, h, i, k = {};
		f = 0;
		for (g = d.length; f < g; f++) i = d[f].x + ":" + d[f].y, void 0 !== k[i] && console.log("Duplicate point", i), k[i] = f;
		f = 0;
		for (g = c.length; f < g; f++) {
			h = c[f];
			for (d = 0; 3 > d; d++) i = h[d].x + ":" + h[d].y, i = k[i], void 0 !== i && (h[d] = i)
		}
		f = 0;
		for (g = e.length; f < g; f++) {
			h = e[f];
			for (d = 0; 3 > d; d++) i = h[d].x + ":" + h[d].y, i = k[i], void 0 !== i && (h[d] = i)
		}
		return c.concat(e)
	},
	isClockWise: function (a) {
		return 0 > THREE.FontUtils.Triangulate.area(a)
	},
	b2p0: function (a, b) {
		var c = 1 - a;
		return c * c * b
	},
	b2p1: function (a, b) {
		return 2 * (1 - a) * a * b
	},
	b2p2: function (a, b) {
		return a * a * b
	},
	b2: function (a, b, c, d) {
		return this.b2p0(a, b) + this.b2p1(a, c) + this.b2p2(a, d)
	},
	b3p0: function (a, b) {
		var c = 1 - a;
		return c * c * c * b
	},
	b3p1: function (a, b) {
		var c = 1 - a;
		return 3 * c * c * a * b
	},
	b3p2: function (a, b) {
		return 3 * (1 - a) * a * a * b
	},
	b3p3: function (a, b) {
		return a * a * a * b
	},
	b3: function (a, b, c, d, e) {
		return this.b3p0(a, b) + this.b3p1(a, c) + this.b3p2(a, d) + this.b3p3(a, e)
	}
};
THREE.AnimationHandler = function () {
	var a = [],
		b = {}, c = {
			update: function (b) {
				for (var c = 0; c < a.length; c++) a[c].update(b)
			},
			addToUpdate: function (b) {
				-1 === a.indexOf(b) && a.push(b)
			},
			removeFromUpdate: function (b) {
				b = a.indexOf(b); - 1 !== b && a.splice(b, 1)
			},
			add: function (a) {
				void 0 !== b[a.name] && console.log("THREE.AnimationHandler.add: Warning! " + a.name + " already exists in library. Overwriting.");
				b[a.name] = a;
				if (!0 !== a.initialized) {
					for (var c = 0; c < a.hierarchy.length; c++) {
						for (var d = 0; d < a.hierarchy[c].keys.length; d++) if (0 > a.hierarchy[c].keys[d].time && (a.hierarchy[c].keys[d].time = 0), void 0 !== a.hierarchy[c].keys[d].rot && !(a.hierarchy[c].keys[d].rot instanceof THREE.Quaternion)) {
							var h = a.hierarchy[c].keys[d].rot;
							a.hierarchy[c].keys[d].rot = new THREE.Quaternion(h[0], h[1], h[2], h[3])
						}
						if (a.hierarchy[c].keys.length && void 0 !== a.hierarchy[c].keys[0].morphTargets) {
							h = {};
							for (d = 0; d < a.hierarchy[c].keys.length; d++) for (var i = 0; i < a.hierarchy[c].keys[d].morphTargets.length; i++) {
								var k = a.hierarchy[c].keys[d].morphTargets[i];
								h[k] = -1
							}
							a.hierarchy[c].usedMorphTargets = h;
							for (d = 0; d < a.hierarchy[c].keys.length; d++) {
								var j = {};
								for (k in h) {
									for (i = 0; i < a.hierarchy[c].keys[d].morphTargets.length; i++) if (a.hierarchy[c].keys[d].morphTargets[i] === k) {
										j[k] = a.hierarchy[c].keys[d].morphTargetsInfluences[i];
										break
									}
									i === a.hierarchy[c].keys[d].morphTargets.length && (j[k] = 0)
								}
								a.hierarchy[c].keys[d].morphTargetsInfluences = j
							}
						}
						for (d = 1; d < a.hierarchy[c].keys.length; d++) a.hierarchy[c].keys[d].time === a.hierarchy[c].keys[d - 1].time && (a.hierarchy[c].keys.splice(d, 1), d--);
						for (d = 0; d < a.hierarchy[c].keys.length; d++) a.hierarchy[c].keys[d].index = d
					}
					d = parseInt(a.length * a.fps, 10);
					a.JIT = {};
					a.JIT.hierarchy = [];
					for (c = 0; c < a.hierarchy.length; c++) a.JIT.hierarchy.push(Array(d));
					a.initialized = !0
				}
			},
			get: function (a) {
				if ("string" === typeof a) {
					if (b[a]) return b[a];
					console.log("THREE.AnimationHandler.get: Couldn't find animation " + a);
					return null
				}
			},
			parse: function (a) {
				var b = [];
				if (a instanceof THREE.SkinnedMesh) for (var c = 0; c < a.bones.length; c++) b.push(a.bones[c]);
				else d(a, b);
				return b
			}
		}, d = function (a, b) {
			b.push(a);
			for (var c = 0; c < a.children.length; c++) d(a.children[c],
			b)
		};
	c.LINEAR = 0;
	c.CATMULLROM = 1;
	c.CATMULLROM_FORWARD = 2;
	return c
}();
THREE.Animation = function (a, b, c) {
	this.root = a;
	this.data = THREE.AnimationHandler.get(b);
	this.hierarchy = THREE.AnimationHandler.parse(a);
	this.currentTime = 0;
	this.timeScale = 1;
	this.isPlaying = !1;
	this.loop = this.isPaused = !0;
	this.interpolationType = void 0 !== c ? c : THREE.AnimationHandler.LINEAR;
	this.points = [];
	this.target = new THREE.Vector3
};
THREE.Animation.prototype.play = function (a, b) {
	if (!1 === this.isPlaying) {
		this.isPlaying = !0;
		this.loop = void 0 !== a ? a : !0;
		this.currentTime = void 0 !== b ? b : 0;
		var c, d = this.hierarchy.length,
			e;
		for (c = 0; c < d; c++) {
			e = this.hierarchy[c];
			this.interpolationType !== THREE.AnimationHandler.CATMULLROM_FORWARD && (e.useQuaternion = !0);
			e.matrixAutoUpdate = !0;
			void 0 === e.animationCache && (e.animationCache = {}, e.animationCache.prevKey = {
				pos: 0,
				rot: 0,
				scl: 0
			}, e.animationCache.nextKey = {
				pos: 0,
				rot: 0,
				scl: 0
			}, e.animationCache.originalMatrix = e instanceof
			THREE.Bone ? e.skinMatrix : e.matrix);
			var f = e.animationCache.prevKey;
			e = e.animationCache.nextKey;
			f.pos = this.data.hierarchy[c].keys[0];
			f.rot = this.data.hierarchy[c].keys[0];
			f.scl = this.data.hierarchy[c].keys[0];
			e.pos = this.getNextKeyWith("pos", c, 1);
			e.rot = this.getNextKeyWith("rot", c, 1);
			e.scl = this.getNextKeyWith("scl", c, 1)
		}
		this.update(0)
	}
	this.isPaused = !1;
	THREE.AnimationHandler.addToUpdate(this)
};
THREE.Animation.prototype.pause = function () {
	!0 === this.isPaused ? THREE.AnimationHandler.addToUpdate(this) : THREE.AnimationHandler.removeFromUpdate(this);
	this.isPaused = !this.isPaused
};
THREE.Animation.prototype.stop = function () {
	this.isPaused = this.isPlaying = !1;
	THREE.AnimationHandler.removeFromUpdate(this)
};
THREE.Animation.prototype.update = function (a) {
	if (!1 !== this.isPlaying) {
		var b = ["pos", "rot", "scl"],
			c, d, e, f, g, h, i, k, j;
		j = this.currentTime += a * this.timeScale;
		k = this.currentTime %= this.data.length;
		parseInt(Math.min(k * this.data.fps, this.data.length * this.data.fps), 10);
		for (var l = 0, m = this.hierarchy.length; l < m; l++) {
			a = this.hierarchy[l];
			i = a.animationCache;
			for (var r = 0; 3 > r; r++) {
				c = b[r];
				g = i.prevKey[c];
				h = i.nextKey[c];
				if (h.time <= j) {
					if (k < j) if (this.loop) {
						g = this.data.hierarchy[l].keys[0];
						for (h = this.getNextKeyWith(c, l, 1); h.time < k;) g = h, h = this.getNextKeyWith(c, l, h.index + 1)
					} else {
						this.stop();
						return
					} else {
						do g = h, h = this.getNextKeyWith(c, l, h.index + 1);
						while (h.time < k)
					}
					i.prevKey[c] = g;
					i.nextKey[c] = h
				}
				a.matrixAutoUpdate = !0;
				a.matrixWorldNeedsUpdate = !0;
				d = (k - g.time) / (h.time - g.time);
				e = g[c];
				f = h[c];
				if (0 > d || 1 < d) console.log("THREE.Animation.update: Warning! Scale out of bounds:" + d + " on bone " + l), d = 0 > d ? 0 : 1;
				if ("pos" === c) if (c = a.position, this.interpolationType === THREE.AnimationHandler.LINEAR) c.x = e[0] + (f[0] - e[0]) * d, c.y = e[1] + (f[1] - e[1]) * d, c.z = e[2] + (f[2] - e[2]) * d;
				else {
					if (this.interpolationType === THREE.AnimationHandler.CATMULLROM || this.interpolationType === THREE.AnimationHandler.CATMULLROM_FORWARD) this.points[0] = this.getPrevKeyWith("pos", l, g.index - 1).pos, this.points[1] = e, this.points[2] = f, this.points[3] = this.getNextKeyWith("pos", l, h.index + 1).pos, d = 0.33 * d + 0.33, e = this.interpolateCatmullRom(this.points, d), c.x = e[0], c.y = e[1], c.z = e[2], this.interpolationType === THREE.AnimationHandler.CATMULLROM_FORWARD && (d = this.interpolateCatmullRom(this.points, 1.01 * d),
					this.target.set(d[0], d[1], d[2]), this.target.sub(c), this.target.y = 0, this.target.normalize(), d = Math.atan2(this.target.x, this.target.z), a.rotation.set(0, d, 0))
				} else "rot" === c ? THREE.Quaternion.slerp(e, f, a.quaternion, d) : "scl" === c && (c = a.scale, c.x = e[0] + (f[0] - e[0]) * d, c.y = e[1] + (f[1] - e[1]) * d, c.z = e[2] + (f[2] - e[2]) * d)
			}
		}
	}
};
THREE.Animation.prototype.interpolateCatmullRom = function (a, b) {
	var c = [],
		d = [],
		e, f, g, h, i, k;
	e = (a.length - 1) * b;
	f = Math.floor(e);
	e -= f;
	c[0] = 0 === f ? f : f - 1;
	c[1] = f;
	c[2] = f > a.length - 2 ? f : f + 1;
	c[3] = f > a.length - 3 ? f : f + 2;
	f = a[c[0]];
	h = a[c[1]];
	i = a[c[2]];
	k = a[c[3]];
	c = e * e;
	g = e * c;
	d[0] = this.interpolate(f[0], h[0], i[0], k[0], e, c, g);
	d[1] = this.interpolate(f[1], h[1], i[1], k[1], e, c, g);
	d[2] = this.interpolate(f[2], h[2], i[2], k[2], e, c, g);
	return d
};
THREE.Animation.prototype.interpolate = function (a, b, c, d, e, f, g) {
	a = 0.5 * (c - a);
	d = 0.5 * (d - b);
	return (2 * (b - c) + a + d) * g + (-3 * (b - c) - 2 * a - d) * f + a * e + b
};
THREE.Animation.prototype.getNextKeyWith = function (a, b, c) {
	for (var d = this.data.hierarchy[b].keys, c = this.interpolationType === THREE.AnimationHandler.CATMULLROM || this.interpolationType === THREE.AnimationHandler.CATMULLROM_FORWARD ? c < d.length - 1 ? c : d.length - 1 : c % d.length; c < d.length; c++) if (void 0 !== d[c][a]) return d[c];
	return this.data.hierarchy[b].keys[0]
};
THREE.Animation.prototype.getPrevKeyWith = function (a, b, c) {
	for (var d = this.data.hierarchy[b].keys, c = this.interpolationType === THREE.AnimationHandler.CATMULLROM || this.interpolationType === THREE.AnimationHandler.CATMULLROM_FORWARD ? 0 < c ? c : 0 : 0 <= c ? c : c + d.length; 0 <= c; c--) if (void 0 !== d[c][a]) return d[c];
	return this.data.hierarchy[b].keys[d.length - 1]
};
THREE.KeyFrameAnimation = function (a, b, c) {
	this.root = a;
	this.data = THREE.AnimationHandler.get(b);
	this.hierarchy = THREE.AnimationHandler.parse(a);
	this.currentTime = 0;
	this.timeScale = 0.001;
	this.isPlaying = !1;
	this.loop = this.isPaused = !0;
	this.JITCompile = void 0 !== c ? c : !0;
	a = 0;
	for (b = this.hierarchy.length; a < b; a++) {
		var c = this.data.hierarchy[a].sids,
			d = this.hierarchy[a];
		if (this.data.hierarchy[a].keys.length && c) {
			for (var e = 0; e < c.length; e++) {
				var f = c[e],
					g = this.getNextKeyWith(f, a, 0);
				g && g.apply(f)
			}
			d.matrixAutoUpdate = !1;
			this.data.hierarchy[a].node.updateMatrix();
			d.matrixWorldNeedsUpdate = !0
		}
	}
};
THREE.KeyFrameAnimation.prototype.play = function (a, b) {
	if (!this.isPlaying) {
		this.isPlaying = !0;
		this.loop = void 0 !== a ? a : !0;
		this.currentTime = void 0 !== b ? b : 0;
		this.startTimeMs = b;
		this.startTime = 1E7;
		this.endTime = -this.startTime;
		var c, d = this.hierarchy.length,
			e, f;
		for (c = 0; c < d; c++) e = this.hierarchy[c], f = this.data.hierarchy[c], e.useQuaternion = !0, void 0 === f.animationCache && (f.animationCache = {}, f.animationCache.prevKey = null, f.animationCache.nextKey = null, f.animationCache.originalMatrix = e instanceof THREE.Bone ? e.skinMatrix : e.matrix), e = this.data.hierarchy[c].keys, e.length && (f.animationCache.prevKey = e[0], f.animationCache.nextKey = e[1], this.startTime = Math.min(e[0].time, this.startTime), this.endTime = Math.max(e[e.length - 1].time, this.endTime));
		this.update(0)
	}
	this.isPaused = !1;
	THREE.AnimationHandler.addToUpdate(this)
};
THREE.KeyFrameAnimation.prototype.pause = function () {
	this.isPaused ? THREE.AnimationHandler.addToUpdate(this) : THREE.AnimationHandler.removeFromUpdate(this);
	this.isPaused = !this.isPaused
};
THREE.KeyFrameAnimation.prototype.stop = function () {
	this.isPaused = this.isPlaying = !1;
	THREE.AnimationHandler.removeFromUpdate(this);
	for (var a = 0; a < this.data.hierarchy.length; a++) {
		var b = this.hierarchy[a],
			c = this.data.hierarchy[a];
		if (void 0 !== c.animationCache) {
			var d = c.animationCache.originalMatrix;
			b instanceof THREE.Bone ? (d.copy(b.skinMatrix), b.skinMatrix = d) : (d.copy(b.matrix), b.matrix = d);
			delete c.animationCache
		}
	}
};
THREE.KeyFrameAnimation.prototype.update = function (a) {
	if (this.isPlaying) {
		var b, c, d, e, f = this.data.JIT.hierarchy,
			g, h, i;
		h = this.currentTime += a * this.timeScale;
		g = this.currentTime %= this.data.length;
		g < this.startTimeMs && (g = this.currentTime = this.startTimeMs + g);
		e = parseInt(Math.min(g * this.data.fps, this.data.length * this.data.fps), 10);
		if ((i = g < h) && !this.loop) {
			for (var a = 0, k = this.hierarchy.length; a < k; a++) {
				var j = this.data.hierarchy[a].keys,
					f = this.data.hierarchy[a].sids;
				d = j.length - 1;
				e = this.hierarchy[a];
				if (j.length) {
					for (j = 0; j < f.length; j++) g = f[j], (h = this.getPrevKeyWith(g, a, d)) && h.apply(g);
					this.data.hierarchy[a].node.updateMatrix();
					e.matrixWorldNeedsUpdate = !0
				}
			}
			this.stop()
		} else if (!(g < this.startTime)) {
			a = 0;
			for (k = this.hierarchy.length; a < k; a++) {
				d = this.hierarchy[a];
				b = this.data.hierarchy[a];
				var j = b.keys,
					l = b.animationCache;
				if (this.JITCompile && void 0 !== f[a][e]) d instanceof THREE.Bone ? (d.skinMatrix = f[a][e], d.matrixWorldNeedsUpdate = !1) : (d.matrix = f[a][e], d.matrixWorldNeedsUpdate = !0);
				else if (j.length) {
					this.JITCompile && l && (d instanceof
					THREE.Bone ? d.skinMatrix = l.originalMatrix : d.matrix = l.originalMatrix);
					b = l.prevKey;
					c = l.nextKey;
					if (b && c) {
						if (c.time <= h) {
							if (i && this.loop) {
								b = j[0];
								for (c = j[1]; c.time < g;) b = c, c = j[b.index + 1]
							} else if (!i) for (var m = j.length - 1; c.time < g && c.index !== m;) b = c, c = j[b.index + 1];
							l.prevKey = b;
							l.nextKey = c
						}
						c.time >= g ? b.interpolate(c, g) : b.interpolate(c, c.time)
					}
					this.data.hierarchy[a].node.updateMatrix();
					d.matrixWorldNeedsUpdate = !0
				}
			}
			if (this.JITCompile && void 0 === f[0][e]) {
				this.hierarchy[0].updateMatrixWorld(!0);
				for (a = 0; a < this.hierarchy.length; a++) f[a][e] = this.hierarchy[a] instanceof THREE.Bone ? this.hierarchy[a].skinMatrix.clone() : this.hierarchy[a].matrix.clone()
			}
		}
	}
};
THREE.KeyFrameAnimation.prototype.getNextKeyWith = function (a, b, c) {
	b = this.data.hierarchy[b].keys;
	for (c %= b.length; c < b.length; c++) if (b[c].hasTarget(a)) return b[c];
	return b[0]
};
THREE.KeyFrameAnimation.prototype.getPrevKeyWith = function (a, b, c) {
	b = this.data.hierarchy[b].keys;
	for (c = 0 <= c ? c : c + b.length; 0 <= c; c--) if (b[c].hasTarget(a)) return b[c];
	return b[b.length - 1]
};
THREE.CubeCamera = function (a, b, c) {
	THREE.Object3D.call(this);
	var d = new THREE.PerspectiveCamera(90, 1, a, b);
	d.up.set(0, -1, 0);
	d.lookAt(new THREE.Vector3(1, 0, 0));
	this.add(d);
	var e = new THREE.PerspectiveCamera(90, 1, a, b);
	e.up.set(0, -1, 0);
	e.lookAt(new THREE.Vector3(-1, 0, 0));
	this.add(e);
	var f = new THREE.PerspectiveCamera(90, 1, a, b);
	f.up.set(0, 0, 1);
	f.lookAt(new THREE.Vector3(0, 1, 0));
	this.add(f);
	var g = new THREE.PerspectiveCamera(90, 1, a, b);
	g.up.set(0, 0, -1);
	g.lookAt(new THREE.Vector3(0, -1, 0));
	this.add(g);
	var h = new THREE.PerspectiveCamera(90,
	1, a, b);
	h.up.set(0, -1, 0);
	h.lookAt(new THREE.Vector3(0, 0, 1));
	this.add(h);
	var i = new THREE.PerspectiveCamera(90, 1, a, b);
	i.up.set(0, -1, 0);
	i.lookAt(new THREE.Vector3(0, 0, -1));
	this.add(i);
	this.renderTarget = new THREE.WebGLRenderTargetCube(c, c, {
		format: THREE.RGBFormat,
		magFilter: THREE.LinearFilter,
		minFilter: THREE.LinearFilter
	});
	this.updateCubeMap = function (a, b) {
		var c = this.renderTarget,
			m = c.generateMipmaps;
		c.generateMipmaps = !1;
		c.activeCubeFace = 0;
		a.render(b, d, c);
		c.activeCubeFace = 1;
		a.render(b, e, c);
		c.activeCubeFace = 2;
		a.render(b, f, c);
		c.activeCubeFace = 3;
		a.render(b, g, c);
		c.activeCubeFace = 4;
		a.render(b, h, c);
		c.generateMipmaps = m;
		c.activeCubeFace = 5;
		a.render(b, i, c)
	}
};
THREE.CubeCamera.prototype = Object.create(THREE.Object3D.prototype);
THREE.CombinedCamera = function (a, b, c, d, e, f, g) {
	THREE.Camera.call(this);
	this.fov = c;
	this.left = -a / 2;
	this.right = a / 2;
	this.top = b / 2;
	this.bottom = -b / 2;
	this.cameraO = new THREE.OrthographicCamera(a / -2, a / 2, b / 2, b / -2, f, g);
	this.cameraP = new THREE.PerspectiveCamera(c, a / b, d, e);
	this.zoom = 1;
	this.toPerspective()
};
THREE.CombinedCamera.prototype = Object.create(THREE.Camera.prototype);
THREE.CombinedCamera.prototype.toPerspective = function () {
	this.near = this.cameraP.near;
	this.far = this.cameraP.far;
	this.cameraP.fov = this.fov / this.zoom;
	this.cameraP.updateProjectionMatrix();
	this.projectionMatrix = this.cameraP.projectionMatrix;
	this.inPerspectiveMode = !0;
	this.inOrthographicMode = !1
};
THREE.CombinedCamera.prototype.toOrthographic = function () {
	var a = this.cameraP.aspect,
		b = (this.cameraP.near + this.cameraP.far) / 2,
		b = Math.tan(this.fov / 2) * b,
		a = 2 * b * a / 2,
		b = b / this.zoom,
		a = a / this.zoom;
	this.cameraO.left = -a;
	this.cameraO.right = a;
	this.cameraO.top = b;
	this.cameraO.bottom = -b;
	this.cameraO.updateProjectionMatrix();
	this.near = this.cameraO.near;
	this.far = this.cameraO.far;
	this.projectionMatrix = this.cameraO.projectionMatrix;
	this.inPerspectiveMode = !1;
	this.inOrthographicMode = !0
};
THREE.CombinedCamera.prototype.setSize = function (a, b) {
	this.cameraP.aspect = a / b;
	this.left = -a / 2;
	this.right = a / 2;
	this.top = b / 2;
	this.bottom = -b / 2
};
THREE.CombinedCamera.prototype.setFov = function (a) {
	this.fov = a;
	this.inPerspectiveMode ? this.toPerspective() : this.toOrthographic()
};
THREE.CombinedCamera.prototype.updateProjectionMatrix = function () {
	this.inPerspectiveMode ? this.toPerspective() : (this.toPerspective(), this.toOrthographic())
};
THREE.CombinedCamera.prototype.setLens = function (a, b) {
	void 0 === b && (b = 24);
	var c = 2 * THREE.Math.radToDeg(Math.atan(b / (2 * a)));
	this.setFov(c);
	return c
};
THREE.CombinedCamera.prototype.setZoom = function (a) {
	this.zoom = a;
	this.inPerspectiveMode ? this.toPerspective() : this.toOrthographic()
};
THREE.CombinedCamera.prototype.toFrontView = function () {
	this.rotation.x = 0;
	this.rotation.y = 0;
	this.rotation.z = 0;
	this.rotationAutoUpdate = !1
};
THREE.CombinedCamera.prototype.toBackView = function () {
	this.rotation.x = 0;
	this.rotation.y = Math.PI;
	this.rotation.z = 0;
	this.rotationAutoUpdate = !1
};
THREE.CombinedCamera.prototype.toLeftView = function () {
	this.rotation.x = 0;
	this.rotation.y = -Math.PI / 2;
	this.rotation.z = 0;
	this.rotationAutoUpdate = !1
};
THREE.CombinedCamera.prototype.toRightView = function () {
	this.rotation.x = 0;
	this.rotation.y = Math.PI / 2;
	this.rotation.z = 0;
	this.rotationAutoUpdate = !1
};
THREE.CombinedCamera.prototype.toTopView = function () {
	this.rotation.x = -Math.PI / 2;
	this.rotation.y = 0;
	this.rotation.z = 0;
	this.rotationAutoUpdate = !1
};
THREE.CombinedCamera.prototype.toBottomView = function () {
	this.rotation.x = Math.PI / 2;
	this.rotation.y = 0;
	this.rotation.z = 0;
	this.rotationAutoUpdate = !1
};
THREE.AsteriskGeometry = function (a, b) {
	THREE.Geometry.call(this);
	for (var c = 0.707 * a, d = 0.707 * b, c = [
		[a, 0, 0],
		[b, 0, 0],
		[-a, 0, 0],
		[-b, 0, 0],
		[0, a, 0],
		[0, b, 0],
		[0, -a, 0],
		[0, -b, 0],
		[0, 0, a],
		[0, 0, b],
		[0, 0, -a],
		[0, 0, -b],
		[c, c, 0],
		[d, d, 0],
		[-c, -c, 0],
		[-d, -d, 0],
		[c, -c, 0],
		[d, -d, 0],
		[-c, c, 0],
		[-d, d, 0],
		[c, 0, c],
		[d, 0, d],
		[-c, 0, -c],
		[-d, 0, -d],
		[c, 0, -c],
		[d, 0, -d],
		[-c, 0, c],
		[-d, 0, d],
		[0, c, c],
		[0, d, d],
		[0, -c, -c],
		[0, -d, -d],
		[0, c, -c],
		[0, d, -d],
		[0, -c, c],
		[0, -d, d]
	], d = 0, e = c.length; d < e; d++) this.vertices.push(new THREE.Vector3(c[d][0], c[d][1], c[d][2]))
};
THREE.AsteriskGeometry.prototype = Object.create(THREE.Geometry.prototype);
THREE.CircleGeometry = function (a, b, c, d) {
	THREE.Geometry.call(this);
	var a = a || 50,
		c = void 0 !== c ? c : 0,
		d = void 0 !== d ? d : 2 * Math.PI,
		b = void 0 !== b ? Math.max(3, b) : 8,
		e, f = [];
	e = new THREE.Vector3;
	var g = new THREE.Vector2(0.5, 0.5);
	this.vertices.push(e);
	f.push(g);
	for (e = 0; e <= b; e++) {
		var h = new THREE.Vector3;
		h.x = a * Math.cos(c + e / b * d);
		h.y = a * Math.sin(c + e / b * d);
		this.vertices.push(h);
		f.push(new THREE.Vector2((h.x / a + 1) / 2, -(h.y / a + 1) / 2 + 1))
	}
	c = new THREE.Vector3(0, 0, -1);
	for (e = 1; e <= b; e++) this.faces.push(new THREE.Face3(e, e + 1, 0, [c, c, c])),
	this.faceVertexUvs[0].push([f[e], f[e + 1], g]);
	this.computeCentroids();
	this.computeFaceNormals();
	this.boundingSphere = new THREE.Sphere(new THREE.Vector3, a)
};
THREE.CircleGeometry.prototype = Object.create(THREE.Geometry.prototype);
THREE.CubeGeometry = function (a, b, c, d, e, f) {
	function g(a, b, c, d, e, f, g, p) {
		var t, u = h.widthSegments,
			x = h.heightSegments,
			v = e / 2,
			s = f / 2,
			C = h.vertices.length;
		if ("x" === a && "y" === b || "y" === a && "x" === b) t = "z";
		else if ("x" === a && "z" === b || "z" === a && "x" === b) t = "y", x = h.depthSegments;
		else if ("z" === a && "y" === b || "y" === a && "z" === b) t = "x", u = h.depthSegments;
		var z = u + 1,
			w = x + 1,
			A = e / u,
			H = f / x,
			G = new THREE.Vector3;
		G[t] = 0 < g ? 1 : -1;
		for (e = 0; e < w; e++) for (f = 0; f < z; f++) {
			var I = new THREE.Vector3;
			I[a] = (f * A - v) * c;
			I[b] = (e * H - s) * d;
			I[t] = g;
			h.vertices.push(I)
		}
		for (e = 0; e < x; e++) for (f = 0; f < u; f++) a = new THREE.Face4(f + z * e + C, f + z * (e + 1) + C, f + 1 + z * (e + 1) + C, f + 1 + z * e + C), a.normal.copy(G), a.vertexNormals.push(G.clone(), G.clone(), G.clone(), G.clone()), a.materialIndex = p, h.faces.push(a), h.faceVertexUvs[0].push([new THREE.Vector2(f / u, 1 - e / x), new THREE.Vector2(f / u, 1 - (e + 1) / x), new THREE.Vector2((f + 1) / u, 1 - (e + 1) / x), new THREE.Vector2((f + 1) / u, 1 - e / x)])
	}
	THREE.Geometry.call(this);
	var h = this;
	this.width = a;
	this.height = b;
	this.depth = c;
	this.widthSegments = d || 1;
	this.heightSegments = e || 1;
	this.depthSegments = f || 1;
	a = this.width / 2;
	b = this.height / 2;
	c = this.depth / 2;
	g("z", "y", -1, -1, this.depth, this.height, a, 0);
	g("z", "y", 1, -1, this.depth, this.height, -a, 1);
	g("x", "z", 1, 1, this.width, this.depth, b, 2);
	g("x", "z", 1, -1, this.width, this.depth, -b, 3);
	g("x", "y", 1, -1, this.width, this.height, c, 4);
	g("x", "y", -1, -1, this.width, this.height, -c, 5);
	this.computeCentroids();
	this.mergeVertices()
};
THREE.CubeGeometry.prototype = Object.create(THREE.Geometry.prototype);
THREE.CylinderGeometry = function (a, b, c, d, e, f) {
	THREE.Geometry.call(this);
	var a = void 0 !== a ? a : 20,
		b = void 0 !== b ? b : 20,
		c = void 0 !== c ? c : 100,
		g = c / 2,
		d = d || 8,
		e = e || 1,
		h, i, k = [],
		j = [];
	for (i = 0; i <= e; i++) {
		var l = [],
			m = [],
			r = i / e,
			q = r * (b - a) + a;
		for (h = 0; h <= d; h++) {
			var p = h / d,
				t = new THREE.Vector3;
			t.x = q * Math.sin(2 * p * Math.PI);
			t.y = -r * c + g;
			t.z = q * Math.cos(2 * p * Math.PI);
			this.vertices.push(t);
			l.push(this.vertices.length - 1);
			m.push(new THREE.Vector2(p, 1 - r))
		}
		k.push(l);
		j.push(m)
	}
	c = (b - a) / c;
	for (h = 0; h < d; h++) {
		0 !== a ? (l = this.vertices[k[0][h]].clone(),
		m = this.vertices[k[0][h + 1]].clone()) : (l = this.vertices[k[1][h]].clone(), m = this.vertices[k[1][h + 1]].clone());
		l.setY(Math.sqrt(l.x * l.x + l.z * l.z) * c).normalize();
		m.setY(Math.sqrt(m.x * m.x + m.z * m.z) * c).normalize();
		for (i = 0; i < e; i++) {
			var r = k[i][h],
				q = k[i + 1][h],
				p = k[i + 1][h + 1],
				t = k[i][h + 1],
				u = l.clone(),
				x = l.clone(),
				v = m.clone(),
				s = m.clone(),
				C = j[i][h].clone(),
				z = j[i + 1][h].clone(),
				w = j[i + 1][h + 1].clone(),
				A = j[i][h + 1].clone();
			this.faces.push(new THREE.Face4(r, q, p, t, [u, x, v, s]));
			this.faceVertexUvs[0].push([C, z, w, A])
		}
	}
	if (!f && 0 < a) {
		this.vertices.push(new THREE.Vector3(0, g, 0));
		for (h = 0; h < d; h++) r = k[0][h], q = k[0][h + 1], p = this.vertices.length - 1, u = new THREE.Vector3(0, 1, 0), x = new THREE.Vector3(0, 1, 0), v = new THREE.Vector3(0, 1, 0), C = j[0][h].clone(), z = j[0][h + 1].clone(), w = new THREE.Vector2(z.u, 0), this.faces.push(new THREE.Face3(r, q, p, [u, x, v])), this.faceVertexUvs[0].push([C, z, w])
	}
	if (!f && 0 < b) {
		this.vertices.push(new THREE.Vector3(0, -g, 0));
		for (h = 0; h < d; h++) r = k[i][h + 1], q = k[i][h], p = this.vertices.length - 1, u = new THREE.Vector3(0, -1, 0), x = new THREE.Vector3(0, -1, 0), v = new THREE.Vector3(0, -1, 0), C = j[i][h + 1].clone(), z = j[i][h].clone(), w = new THREE.Vector2(z.u, 1), this.faces.push(new THREE.Face3(r, q, p, [u, x, v])), this.faceVertexUvs[0].push([C, z, w])
	}
	this.computeCentroids();
	this.computeFaceNormals()
};
THREE.CylinderGeometry.prototype = Object.create(THREE.Geometry.prototype);
THREE.ExtrudeGeometry = function (a, b) {
	"undefined" !== typeof a && (THREE.Geometry.call(this), a = a instanceof Array ? a : [a], this.shapebb = a[a.length - 1].getBoundingBox(), this.addShapeList(a, b), this.computeCentroids(), this.computeFaceNormals())
};
THREE.ExtrudeGeometry.prototype = Object.create(THREE.Geometry.prototype);
THREE.ExtrudeGeometry.prototype.addShapeList = function (a, b) {
	for (var c = a.length, d = 0; d < c; d++) this.addShape(a[d], b)
};
THREE.ExtrudeGeometry.prototype.addShape = function (a, b) {
	function c(a, b, c) {
		b || console.log("die");
		return b.clone().multiplyScalar(c).add(a)
	}
	function d(a, b, c) {
		var d = THREE.ExtrudeGeometry.__v1,
			e = THREE.ExtrudeGeometry.__v2,
			f = THREE.ExtrudeGeometry.__v3,
			g = THREE.ExtrudeGeometry.__v4,
			h = THREE.ExtrudeGeometry.__v5,
			i = THREE.ExtrudeGeometry.__v6;
		d.set(a.x - b.x, a.y - b.y);
		e.set(a.x - c.x, a.y - c.y);
		d = d.normalize();
		e = e.normalize();
		f.set(-d.y, d.x);
		g.set(e.y, -e.x);
		h.copy(a).add(f);
		i.copy(a).add(g);
		if (h.equals(i)) return g.clone();
		h.copy(b).add(f);
		i.copy(c).add(g);
		f = d.dot(g);
		g = i.sub(h).dot(g);
		0 === f && (console.log("Either infinite or no solutions!"), 0 === g ? console.log("Its finite solutions.") : console.log("Too bad, no solutions."));
		g /= f;
		0 > g ? (b = Math.atan2(b.y - a.y, b.x - a.x), a = Math.atan2(c.y - a.y, c.x - a.x), b > a && (a += 2 * Math.PI), c = (b + a) / 2, a = -Math.cos(c), c = -Math.sin(c), a = new THREE.Vector2(a, c)) : a = d.multiplyScalar(g).add(h).sub(a).clone();
		return a
	}
	function e(c, d) {
		var e, f;
		for (F = c.length; 0 <= --F;) {
			e = F;
			f = F - 1;
			0 > f && (f = c.length - 1);
			for (var g = 0, h = r + 2 * j, g = 0; g < h; g++) {
				var i = Q * g,
					k = Q * (g + 1),
					m = d + e + i,
					i = d + f + i,
					l = d + f + k,
					k = d + e + k,
					p = c,
					q = g,
					s = h,
					t = e,
					u = f,
					m = m + V,
					i = i + V,
					l = l + V,
					k = k + V;
				I.faces.push(new THREE.Face4(m, i, l, k, null, null, x));
				m = v.generateSideWallUV(I, a, p, b, m, i, l, k, q, s, t, u);
				I.faceVertexUvs[0].push(m)
			}
		}
	}
	function f(a, b, c) {
		I.vertices.push(new THREE.Vector3(a, b, c))
	}
	function g(c, d, e, f) {
		c += V;
		d += V;
		e += V;
		I.faces.push(new THREE.Face3(c, d, e, null, null, u));
		c = f ? v.generateBottomUV(I, a, b, c, d, e) : v.generateTopUV(I, a, b, c, d, e);
		I.faceVertexUvs[0].push(c)
	}
	var h = void 0 !== b.amount ? b.amount : 100,
		i = void 0 !== b.bevelThickness ? b.bevelThickness : 6,
		k = void 0 !== b.bevelSize ? b.bevelSize : i - 2,
		j = void 0 !== b.bevelSegments ? b.bevelSegments : 3,
		l = void 0 !== b.bevelEnabled ? b.bevelEnabled : !0,
		m = void 0 !== b.curveSegments ? b.curveSegments : 12,
		r = void 0 !== b.steps ? b.steps : 1,
		q = b.extrudePath,
		p, t = !1,
		u = b.material,
		x = b.extrudeMaterial,
		v = void 0 !== b.UVGenerator ? b.UVGenerator : THREE.ExtrudeGeometry.WorldUVGenerator,
		s, C, z, w;
	q && (p = q.getSpacedPoints(r), t = !0, l = !1, s = void 0 !== b.frames ? b.frames : new THREE.TubeGeometry.FrenetFrames(q,
	r, !1), C = new THREE.Vector3, z = new THREE.Vector3, w = new THREE.Vector3);
	l || (k = i = j = 0);
	var A, H, G, I = this,
		V = this.vertices.length,
		m = a.extractPoints(m),
		E = m.shape,
		m = m.holes;
	if (q = !THREE.Shape.Utils.isClockWise(E)) {
		E = E.reverse();
		H = 0;
		for (G = m.length; H < G; H++) A = m[H], THREE.Shape.Utils.isClockWise(A) && (m[H] = A.reverse());
		q = !1
	}
	var O = THREE.Shape.Utils.triangulateShape(E, m),
		q = E;
	H = 0;
	for (G = m.length; H < G; H++) A = m[H], E = E.concat(A);
	var D, J, P, R, Q = E.length,
		N = O.length,
		M = [],
		F = 0,
		W = q.length;
	D = W - 1;
	for (J = F + 1; F < W; F++, D++, J++) D === W && (D = 0), J === W && (J = 0), M[F] = d(q[F], q[D], q[J]);
	var oa = [],
		ua, va = M.concat();
	H = 0;
	for (G = m.length; H < G; H++) {
		A = m[H];
		ua = [];
		F = 0;
		W = A.length;
		D = W - 1;
		for (J = F + 1; F < W; F++, D++, J++) D === W && (D = 0), J === W && (J = 0), ua[F] = d(A[F], A[D], A[J]);
		oa.push(ua);
		va = va.concat(ua)
	}
	for (D = 0; D < j; D++) {
		A = D / j;
		P = i * (1 - A);
		J = k * Math.sin(A * Math.PI / 2);
		F = 0;
		for (W = q.length; F < W; F++) R = c(q[F], M[F], J), f(R.x, R.y, -P);
		H = 0;
		for (G = m.length; H < G; H++) {
			A = m[H];
			ua = oa[H];
			F = 0;
			for (W = A.length; F < W; F++) R = c(A[F], ua[F], J), f(R.x, R.y, -P)
		}
	}
	J = k;
	for (F = 0; F < Q; F++) R = l ? c(E[F], va[F], J) : E[F], t ? (z.copy(s.normals[0]).multiplyScalar(R.x), C.copy(s.binormals[0]).multiplyScalar(R.y), w.copy(p[0]).add(z).add(C), f(w.x, w.y, w.z)) : f(R.x, R.y, 0);
	for (A = 1; A <= r; A++) for (F = 0; F < Q; F++) R = l ? c(E[F], va[F], J) : E[F], t ? (z.copy(s.normals[A]).multiplyScalar(R.x), C.copy(s.binormals[A]).multiplyScalar(R.y), w.copy(p[A]).add(z).add(C), f(w.x, w.y, w.z)) : f(R.x, R.y, h / r * A);
	for (D = j - 1; 0 <= D; D--) {
		A = D / j;
		P = i * (1 - A);
		J = k * Math.sin(A * Math.PI / 2);
		F = 0;
		for (W = q.length; F < W; F++) R = c(q[F], M[F], J), f(R.x, R.y, h + P);
		H = 0;
		for (G = m.length; H < G; H++) {
			A = m[H];
			ua = oa[H];
			F = 0;
			for (W = A.length; F < W; F++) R = c(A[F], ua[F], J), t ? f(R.x, R.y + p[r - 1].y, p[r - 1].x + P) : f(R.x, R.y, h + P)
		}
	}
	if (l) {
		i = 0 * Q;
		for (F = 0; F < N; F++) h = O[F], g(h[2] + i, h[1] + i, h[0] + i, !0);
		i = Q * (r + 2 * j);
		for (F = 0; F < N; F++) h = O[F], g(h[0] + i, h[1] + i, h[2] + i, !1)
	} else {
		for (F = 0; F < N; F++) h = O[F], g(h[2], h[1], h[0], !0);
		for (F = 0; F < N; F++) h = O[F], g(h[0] + Q * r, h[1] + Q * r, h[2] + Q * r, !1)
	}
	h = 0;
	e(q, h);
	h += q.length;
	H = 0;
	for (G = m.length; H < G; H++) A = m[H], e(A, h), h += A.length
};
THREE.ExtrudeGeometry.WorldUVGenerator = {
	generateTopUV: function (a, b, c, d, e, f) {
		b = a.vertices[e].x;
		e = a.vertices[e].y;
		c = a.vertices[f].x;
		f = a.vertices[f].y;
		return [new THREE.Vector2(a.vertices[d].x, a.vertices[d].y), new THREE.Vector2(b, e), new THREE.Vector2(c, f)]
	},
	generateBottomUV: function (a, b, c, d, e, f) {
		return this.generateTopUV(a, b, c, d, e, f)
	},
	generateSideWallUV: function (a, b, c, d, e, f, g, h) {
		var b = a.vertices[e].x,
			c = a.vertices[e].y,
			e = a.vertices[e].z,
			d = a.vertices[f].x,
			i = a.vertices[f].y,
			f = a.vertices[f].z,
			k = a.vertices[g].x,
			j = a.vertices[g].y,
			g = a.vertices[g].z,
			l = a.vertices[h].x,
			m = a.vertices[h].y,
			a = a.vertices[h].z;
		return 0.01 > Math.abs(c - i) ? [new THREE.Vector2(b, 1 - e), new THREE.Vector2(d, 1 - f), new THREE.Vector2(k, 1 - g), new THREE.Vector2(l, 1 - a)] : [new THREE.Vector2(c, 1 - e), new THREE.Vector2(i, 1 - f), new THREE.Vector2(j, 1 - g), new THREE.Vector2(m, 1 - a)]
	}
};
THREE.ExtrudeGeometry.__v1 = new THREE.Vector2;
THREE.ExtrudeGeometry.__v2 = new THREE.Vector2;
THREE.ExtrudeGeometry.__v3 = new THREE.Vector2;
THREE.ExtrudeGeometry.__v4 = new THREE.Vector2;
THREE.ExtrudeGeometry.__v5 = new THREE.Vector2;
THREE.ExtrudeGeometry.__v6 = new THREE.Vector2;
THREE.ShapeGeometry = function (a, b) {
	THREE.Geometry.call(this);
	!1 === a instanceof Array && (a = [a]);
	this.shapebb = a[a.length - 1].getBoundingBox();
	this.addShapeList(a, b);
	this.computeCentroids();
	this.computeFaceNormals()
};
THREE.ShapeGeometry.prototype = Object.create(THREE.Geometry.prototype);
THREE.ShapeGeometry.prototype.addShapeList = function (a, b) {
	for (var c = 0, d = a.length; c < d; c++) this.addShape(a[c], b);
	return this
};
THREE.ShapeGeometry.prototype.addShape = function (a, b) {
	void 0 === b && (b = {});
	var c = b.material,
		d = void 0 === b.UVGenerator ? THREE.ExtrudeGeometry.WorldUVGenerator : b.UVGenerator,
		e, f, g, h = this.vertices.length;
	e = a.extractPoints(void 0 !== b.curveSegments ? b.curveSegments : 12);
	var i = e.shape,
		k = e.holes;
	if (!THREE.Shape.Utils.isClockWise(i)) {
		i = i.reverse();
		e = 0;
		for (f = k.length; e < f; e++) g = k[e], THREE.Shape.Utils.isClockWise(g) && (k[e] = g.reverse())
	}
	var j = THREE.Shape.Utils.triangulateShape(i, k);
	e = 0;
	for (f = k.length; e < f; e++) g = k[e],
	i = i.concat(g);
	k = i.length;
	f = j.length;
	for (e = 0; e < k; e++) g = i[e], this.vertices.push(new THREE.Vector3(g.x, g.y, 0));
	for (e = 0; e < f; e++) k = j[e], i = k[0] + h, g = k[1] + h, k = k[2] + h, this.faces.push(new THREE.Face3(i, g, k, null, null, c)), this.faceVertexUvs[0].push(d.generateBottomUV(this, a, b, i, g, k))
};
THREE.LatheGeometry = function (a, b, c) {
	THREE.Geometry.call(this);
	for (var b = b || 12, c = c || 2 * Math.PI, d = [], e = (new THREE.Matrix4).makeRotationZ(c / b), f = 0; f < a.length; f++) d[f] = a[f].clone(), this.vertices.push(d[f]);
	for (var g = b + 1, c = 0; c < g; c++) for (f = 0; f < d.length; f++) d[f] = e.multiplyVector3(d[f].clone()), this.vertices.push(d[f]);
	for (c = 0; c < b; c++) {
		d = 0;
		for (e = a.length; d < e - 1; d++) this.faces.push(new THREE.Face4(c * e + d, (c + 1) % g * e + d, (c + 1) % g * e + (d + 1) % e, c * e + (d + 1) % e)), this.faceVertexUvs[0].push([new THREE.Vector2(1 - c / b, d / e), new THREE.Vector2(1 - (c + 1) / b, d / e), new THREE.Vector2(1 - (c + 1) / b, (d + 1) / e), new THREE.Vector2(1 - c / b, (d + 1) / e)])
	}
	this.computeCentroids();
	this.computeFaceNormals();
	this.computeVertexNormals()
};
THREE.LatheGeometry.prototype = Object.create(THREE.Geometry.prototype);
THREE.PlaneGeometry = function (a, b, c, d) {
	THREE.Geometry.call(this);
	this.width = a;
	this.height = b;
	this.widthSegments = c || 1;
	this.heightSegments = d || 1;
	for (var c = a / 2, e = b / 2, d = this.widthSegments, f = this.heightSegments, g = d + 1, h = f + 1, i = this.width / d, k = this.height / f, j = new THREE.Vector3(0, 0, 1), a = 0; a < h; a++) for (b = 0; b < g; b++) this.vertices.push(new THREE.Vector3(b * i - c, -(a * k - e), 0));
	for (a = 0; a < f; a++) for (b = 0; b < d; b++) c = new THREE.Face4(b + g * a, b + g * (a + 1), b + 1 + g * (a + 1), b + 1 + g * a), c.normal.copy(j), c.vertexNormals.push(j.clone(), j.clone(),
	j.clone(), j.clone()), this.faces.push(c), this.faceVertexUvs[0].push([new THREE.Vector2(b / d, 1 - a / f), new THREE.Vector2(b / d, 1 - (a + 1) / f), new THREE.Vector2((b + 1) / d, 1 - (a + 1) / f), new THREE.Vector2((b + 1) / d, 1 - a / f)]);
	this.computeCentroids()
};
THREE.PlaneGeometry.prototype = Object.create(THREE.Geometry.prototype);
THREE.SphereGeometry = function (a, b, c, d, e, f, g) {
	THREE.Geometry.call(this);
	this.radius = a || 50;
	this.widthSegments = Math.max(3, Math.floor(b) || 8);
	this.heightSegments = Math.max(2, Math.floor(c) || 6);
	for (var d = void 0 !== d ? d : 0, e = void 0 !== e ? e : 2 * Math.PI, f = void 0 !== f ? f : 0, g = void 0 !== g ? g : Math.PI, h = [], i = [], c = 0; c <= this.heightSegments; c++) {
		for (var k = [], j = [], b = 0; b <= this.widthSegments; b++) {
			var l = b / this.widthSegments,
				m = c / this.heightSegments,
				r = new THREE.Vector3;
			r.x = -this.radius * Math.cos(d + l * e) * Math.sin(f + m * g);
			r.y = this.radius * Math.cos(f + m * g);
			r.z = this.radius * Math.sin(d + l * e) * Math.sin(f + m * g);
			this.vertices.push(r);
			k.push(this.vertices.length - 1);
			j.push(new THREE.Vector2(l, 1 - m))
		}
		h.push(k);
		i.push(j)
	}
	for (c = 0; c < this.heightSegments; c++) for (b = 0; b < this.widthSegments; b++) {
		var d = h[c][b + 1],
			e = h[c][b],
			f = h[c + 1][b],
			g = h[c + 1][b + 1],
			k = this.vertices[d].clone().normalize(),
			j = this.vertices[e].clone().normalize(),
			l = this.vertices[f].clone().normalize(),
			m = this.vertices[g].clone().normalize(),
			r = i[c][b + 1].clone(),
			q = i[c][b].clone(),
			p = i[c + 1][b].clone(),
			t = i[c + 1][b + 1].clone();
		Math.abs(this.vertices[d].y) === this.radius ? (this.faces.push(new THREE.Face3(d, f, g, [k, l, m])), this.faceVertexUvs[0].push([r, p, t])) : Math.abs(this.vertices[f].y) === this.radius ? (this.faces.push(new THREE.Face3(d, e, f, [k, j, l])), this.faceVertexUvs[0].push([r, q, p])) : (this.faces.push(new THREE.Face4(d, e, f, g, [k, j, l, m])), this.faceVertexUvs[0].push([r, q, p, t]))
	}
	this.computeCentroids();
	this.computeFaceNormals();
	this.boundingSphere = new THREE.Sphere(new THREE.Vector3, a)
};
THREE.SphereGeometry.prototype = Object.create(THREE.Geometry.prototype);
THREE.TextGeometry = function (a, b) {
	var c = THREE.FontUtils.generateShapes(a, b);
	b.amount = void 0 !== b.height ? b.height : 50;
	void 0 === b.bevelThickness && (b.bevelThickness = 10);
	void 0 === b.bevelSize && (b.bevelSize = 8);
	void 0 === b.bevelEnabled && (b.bevelEnabled = !1);
	THREE.ExtrudeGeometry.call(this, c, b)
};
THREE.TextGeometry.prototype = Object.create(THREE.ExtrudeGeometry.prototype);
THREE.TorusGeometry = function (a, b, c, d, e) {
	THREE.Geometry.call(this);
	this.radius = a || 100;
	this.tube = b || 40;
	this.radialSegments = c || 8;
	this.tubularSegments = d || 6;
	this.arc = e || 2 * Math.PI;
	e = new THREE.Vector3;
	a = [];
	b = [];
	for (c = 0; c <= this.radialSegments; c++) for (d = 0; d <= this.tubularSegments; d++) {
		var f = d / this.tubularSegments * this.arc,
			g = 2 * c / this.radialSegments * Math.PI;
		e.x = this.radius * Math.cos(f);
		e.y = this.radius * Math.sin(f);
		var h = new THREE.Vector3;
		h.x = (this.radius + this.tube * Math.cos(g)) * Math.cos(f);
		h.y = (this.radius + this.tube * Math.cos(g)) * Math.sin(f);
		h.z = this.tube * Math.sin(g);
		this.vertices.push(h);
		a.push(new THREE.Vector2(d / this.tubularSegments, c / this.radialSegments));
		b.push(h.clone().sub(e).normalize())
	}
	for (c = 1; c <= this.radialSegments; c++) for (d = 1; d <= this.tubularSegments; d++) {
		var e = (this.tubularSegments + 1) * c + d - 1,
			f = (this.tubularSegments + 1) * (c - 1) + d - 1,
			g = (this.tubularSegments + 1) * (c - 1) + d,
			h = (this.tubularSegments + 1) * c + d,
			i = new THREE.Face4(e, f, g, h, [b[e], b[f], b[g], b[h]]);
		i.normal.add(b[e]);
		i.normal.add(b[f]);
		i.normal.add(b[g]);
		i.normal.add(b[h]);
		i.normal.normalize();
		this.faces.push(i);
		this.faceVertexUvs[0].push([a[e].clone(), a[f].clone(), a[g].clone(), a[h].clone()])
	}
	this.computeCentroids()
};
THREE.TorusGeometry.prototype = Object.create(THREE.Geometry.prototype);
THREE.TorusKnotGeometry = function (a, b, c, d, e, f, g) {
	function h(a, b, c, d, e, f) {
		var g = Math.cos(a);
		Math.cos(b);
		b = Math.sin(a);
		a *= c / d;
		c = Math.cos(a);
		g *= 0.5 * e * (2 + c);
		b = 0.5 * e * (2 + c) * b;
		e = 0.5 * f * e * Math.sin(a);
		return new THREE.Vector3(g, b, e)
	}
	THREE.Geometry.call(this);
	this.radius = a || 100;
	this.tube = b || 40;
	this.radialSegments = c || 64;
	this.tubularSegments = d || 8;
	this.p = e || 2;
	this.q = f || 3;
	this.heightScale = g || 1;
	this.grid = Array(this.radialSegments);
	c = new THREE.Vector3;
	d = new THREE.Vector3;
	e = new THREE.Vector3;
	for (a = 0; a < this.radialSegments; ++a) {
		this.grid[a] = Array(this.tubularSegments);
		for (b = 0; b < this.tubularSegments; ++b) {
			var i = 2 * (a / this.radialSegments) * this.p * Math.PI,
				g = 2 * (b / this.tubularSegments) * Math.PI,
				f = h(i, g, this.q, this.p, this.radius, this.heightScale),
				i = h(i + 0.01, g, this.q, this.p, this.radius, this.heightScale);
			c.sub(i, f);
			d.add(i, f);
			e.cross(c, d);
			d.cross(e, c);
			e.normalize();
			d.normalize();
			i = -this.tube * Math.cos(g);
			g = this.tube * Math.sin(g);
			f.x += i * d.x + g * e.x;
			f.y += i * d.y + g * e.y;
			f.z += i * d.z + g * e.z;
			this.grid[a][b] = this.vertices.push(new THREE.Vector3(f.x, f.y, f.z)) - 1
		}
	}
	for (a = 0; a < this.radialSegments; ++a) for (b = 0; b < this.tubularSegments; ++b) {
		var e = (a + 1) % this.radialSegments,
			f = (b + 1) % this.tubularSegments,
			c = this.grid[a][b],
			d = this.grid[e][b],
			e = this.grid[e][f],
			f = this.grid[a][f],
			g = new THREE.Vector2(a / this.radialSegments, b / this.tubularSegments),
			i = new THREE.Vector2((a + 1) / this.radialSegments, b / this.tubularSegments),
			k = new THREE.Vector2((a + 1) / this.radialSegments, (b + 1) / this.tubularSegments),
			j = new THREE.Vector2(a / this.radialSegments, (b + 1) / this.tubularSegments);
		this.faces.push(new THREE.Face4(c,
		d, e, f));
		this.faceVertexUvs[0].push([g, i, k, j])
	}
	this.computeCentroids();
	this.computeFaceNormals();
	this.computeVertexNormals()
};
THREE.TorusKnotGeometry.prototype = Object.create(THREE.Geometry.prototype);
THREE.TubeGeometry = function (a, b, c, d, e, f) {
	THREE.Geometry.call(this);
	this.path = a;
	this.segments = b || 64;
	this.radius = c || 1;
	this.radiusSegments = d || 8;
	this.closed = e || !1;
	f && (this.debug = new THREE.Object3D);
	this.grid = [];
	var g, h, e = this.segments + 1,
		i, k, j, f = new THREE.Vector3,
		l, m, r, b = new THREE.TubeGeometry.FrenetFrames(this.path, this.segments, this.closed);
	l = b.tangents;
	m = b.normals;
	r = b.binormals;
	this.tangents = l;
	this.normals = m;
	this.binormals = r;
	for (b = 0; b < e; b++) {
		this.grid[b] = [];
		d = b / (e - 1);
		j = a.getPointAt(d);
		d = l[b];
		g = m[b];
		h = r[b];
		this.debug && (this.debug.add(new THREE.ArrowHelper(d, j, c, 255)), this.debug.add(new THREE.ArrowHelper(g, j, c, 16711680)), this.debug.add(new THREE.ArrowHelper(h, j, c, 65280)));
		for (d = 0; d < this.radiusSegments; d++) i = 2 * (d / this.radiusSegments) * Math.PI, k = -this.radius * Math.cos(i), i = this.radius * Math.sin(i), f.copy(j), f.x += k * g.x + i * h.x, f.y += k * g.y + i * h.y, f.z += k * g.z + i * h.z, this.grid[b][d] = this.vertices.push(new THREE.Vector3(f.x, f.y, f.z)) - 1
	}
	for (b = 0; b < this.segments; b++) for (d = 0; d < this.radiusSegments; d++) e = this.closed ? (b + 1) % this.segments : b + 1, f = (d + 1) % this.radiusSegments, a = this.grid[b][d], c = this.grid[e][d], e = this.grid[e][f], f = this.grid[b][f], l = new THREE.Vector2(b / this.segments, d / this.radiusSegments), m = new THREE.Vector2((b + 1) / this.segments, d / this.radiusSegments), r = new THREE.Vector2((b + 1) / this.segments, (d + 1) / this.radiusSegments), g = new THREE.Vector2(b / this.segments, (d + 1) / this.radiusSegments), this.faces.push(new THREE.Face4(a, c, e, f)), this.faceVertexUvs[0].push([l, m, r, g]);
	this.computeCentroids();
	this.computeFaceNormals();
	this.computeVertexNormals()
};
THREE.TubeGeometry.prototype = Object.create(THREE.Geometry.prototype);
THREE.TubeGeometry.FrenetFrames = function (a, b, c) {
	new THREE.Vector3;
	var d = new THREE.Vector3;
	new THREE.Vector3;
	var e = [],
		f = [],
		g = [],
		h = new THREE.Vector3,
		i = new THREE.Matrix4,
		b = b + 1,
		k, j, l;
	this.tangents = e;
	this.normals = f;
	this.binormals = g;
	for (k = 0; k < b; k++) j = k / (b - 1), e[k] = a.getTangentAt(j), e[k].normalize();
	f[0] = new THREE.Vector3;
	g[0] = new THREE.Vector3;
	a = Number.MAX_VALUE;
	k = Math.abs(e[0].x);
	j = Math.abs(e[0].y);
	l = Math.abs(e[0].z);
	k <= a && (a = k, d.set(1, 0, 0));
	j <= a && (a = j, d.set(0, 1, 0));
	l <= a && d.set(0, 0, 1);
	h.cross(e[0], d).normalize();
	f[0].cross(e[0], h);
	g[0].cross(e[0], f[0]);
	for (k = 1; k < b; k++) f[k] = f[k - 1].clone(), g[k] = g[k - 1].clone(), h.cross(e[k - 1], e[k]), 1E-4 < h.length() && (h.normalize(), d = Math.acos(e[k - 1].dot(e[k])), i.makeRotationAxis(h, d).multiplyVector3(f[k])), g[k].cross(e[k], f[k]);
	if (c) {
		d = Math.acos(f[0].dot(f[b - 1]));
		d /= b - 1;
		0 < e[0].dot(h.cross(f[0], f[b - 1])) && (d = -d);
		for (k = 1; k < b; k++) i.makeRotationAxis(e[k], d * k).multiplyVector3(f[k]), g[k].cross(e[k], f[k])
	}
};
THREE.PolyhedronGeometry = function (a, b, c, d) {
	function e(a) {
		var b = a.normalize().clone();
		b.index = i.vertices.push(b) - 1;
		var c = Math.atan2(a.z, -a.x) / 2 / Math.PI + 0.5,
			a = Math.atan2(-a.y, Math.sqrt(a.x * a.x + a.z * a.z)) / Math.PI + 0.5;
		b.uv = new THREE.Vector2(c, 1 - a);
		return b
	}
	function f(a, b, c, d) {
		1 > d ? (d = new THREE.Face3(a.index, b.index, c.index, [a.clone(), b.clone(), c.clone()]), d.centroid.add(a).add(b).add(c).divideScalar(3), d.normal = d.centroid.clone().normalize(), i.faces.push(d), d = Math.atan2(d.centroid.z, -d.centroid.x),
		i.faceVertexUvs[0].push([h(a.uv, a, d), h(b.uv, b, d), h(c.uv, c, d)])) : (d -= 1, f(a, g(a, b), g(a, c), d), f(g(a, b), b, g(b, c), d), f(g(a, c), g(b, c), c, d), f(g(a, b), g(b, c), g(a, c), d))
	}
	function g(a, b) {
		l[a.index] || (l[a.index] = []);
		l[b.index] || (l[b.index] = []);
		var c = l[a.index][b.index];
		void 0 === c && (l[a.index][b.index] = l[b.index][a.index] = c = e((new THREE.Vector3).add(a, b).divideScalar(2)));
		return c
	}
	function h(a, b, c) {
		0 > c && 1 === a.x && (a = new THREE.Vector2(a.x - 1, a.y));
		0 === b.x && 0 === b.z && (a = new THREE.Vector2(c / 2 / Math.PI + 0.5, a.y));
		return a
	}
	THREE.Geometry.call(this);
	for (var c = c || 1, d = d || 0, i = this, k = 0, j = a.length; k < j; k++) e(new THREE.Vector3(a[k][0], a[k][1], a[k][2]));
	for (var l = [], a = this.vertices, k = 0, j = b.length; k < j; k++) f(a[b[k][0]], a[b[k][1]], a[b[k][2]], d);
	this.mergeVertices();
	k = 0;
	for (j = this.vertices.length; k < j; k++) this.vertices[k].multiplyScalar(c);
	this.computeCentroids();
	this.boundingSphere = new THREE.Sphere(new THREE.Vector3, c)
};
THREE.PolyhedronGeometry.prototype = Object.create(THREE.Geometry.prototype);
THREE.IcosahedronGeometry = function (a, b) {
	var c = (1 + Math.sqrt(5)) / 2;
	THREE.PolyhedronGeometry.call(this, [
		[-1, c, 0],
		[1, c, 0],
		[-1, -c, 0],
		[1, -c, 0],
		[0, -1, c],
		[0, 1, c],
		[0, -1, -c],
		[0, 1, -c],
		[c, 0, -1],
		[c, 0, 1],
		[-c, 0, -1],
		[-c, 0, 1]
	], [
		[0, 11, 5],
		[0, 5, 1],
		[0, 1, 7],
		[0, 7, 10],
		[0, 10, 11],
		[1, 5, 9],
		[5, 11, 4],
		[11, 10, 2],
		[10, 7, 6],
		[7, 1, 8],
		[3, 9, 4],
		[3, 4, 2],
		[3, 2, 6],
		[3, 6, 8],
		[3, 8, 9],
		[4, 9, 5],
		[2, 4, 11],
		[6, 2, 10],
		[8, 6, 7],
		[9, 8, 1]
	], a, b)
};
THREE.IcosahedronGeometry.prototype = Object.create(THREE.Geometry.prototype);
THREE.OctahedronGeometry = function (a, b) {
	THREE.PolyhedronGeometry.call(this, [
		[1, 0, 0],
		[-1, 0, 0],
		[0, 1, 0],
		[0, -1, 0],
		[0, 0, 1],
		[0, 0, -1]
	], [
		[0, 2, 4],
		[0, 4, 3],
		[0, 3, 5],
		[0, 5, 2],
		[1, 2, 5],
		[1, 5, 3],
		[1, 3, 4],
		[1, 4, 2]
	], a, b)
};
THREE.OctahedronGeometry.prototype = Object.create(THREE.Geometry.prototype);
THREE.TetrahedronGeometry = function (a, b) {
	THREE.PolyhedronGeometry.call(this, [
		[1, 1, 1],
		[-1, -1, 1],
		[-1, 1, -1],
		[1, -1, -1]
	], [
		[2, 1, 0],
		[0, 3, 2],
		[1, 3, 0],
		[2, 3, 1]
	], a, b)
};
THREE.TetrahedronGeometry.prototype = Object.create(THREE.Geometry.prototype);
THREE.ParametricGeometry = function (a, b, c, d) {
	THREE.Geometry.call(this);
	var e = this.vertices,
		f = this.faces,
		g = this.faceVertexUvs[0],
		d = void 0 === d ? !1 : d,
		h, i, k, j, l = b + 1;
	for (h = 0; h <= c; h++) {
		j = h / c;
		for (i = 0; i <= b; i++) k = i / b, k = a(k, j), e.push(k)
	}
	var m, r, q, p;
	for (h = 0; h < c; h++) for (i = 0; i < b; i++) a = h * l + i, e = h * l + i + 1, j = (h + 1) * l + i, k = (h + 1) * l + i + 1, m = new THREE.Vector2(i / b, h / c), r = new THREE.Vector2((i + 1) / b, h / c), q = new THREE.Vector2(i / b, (h + 1) / c), p = new THREE.Vector2((i + 1) / b, (h + 1) / c), d ? (f.push(new THREE.Face3(a, e, j)), f.push(new THREE.Face3(e,
	k, j)), g.push([m, r, q]), g.push([r, p, q])) : (f.push(new THREE.Face4(a, e, k, j)), g.push([m, r, p, q]));
	this.computeCentroids();
	this.computeFaceNormals();
	this.computeVertexNormals()
};
THREE.ParametricGeometry.prototype = Object.create(THREE.Geometry.prototype);
THREE.ConvexGeometry = function (a) {
	function b(a) {
		var b = a.length();
		return new THREE.Vector2(a.x / b, a.y / b)
	}
	THREE.Geometry.call(this);
	for (var c = [
		[0, 1, 2],
		[0, 2, 1]
	], d = 3; d < a.length; d++) {
		var e = d,
			f = a[e].clone(),
			g = f.length();
		f.x += g * 2E-6 * (Math.random() - 0.5);
		f.y += g * 2E-6 * (Math.random() - 0.5);
		f.z += g * 2E-6 * (Math.random() - 0.5);
		for (var g = [], h = 0; h < c.length;) {
			var i = c[h],
				k = f,
				j = a[i[0]],
				l = a[i[1]],
				m = a[i[2]],
				r = new THREE.Vector3,
				q = new THREE.Vector3;
			r.sub(m, l);
			q.sub(j, l);
			r.crossSelf(q);
			r.normalize();
			j = r.dot(j);
			if (r.dot(k) >= j) {
				for (k = 0; 3 > k; k++) {
					r = [i[k], i[(k + 1) % 3]];
					j = !0;
					for (l = 0; l < g.length; l++) if (g[l][0] === r[1] && g[l][1] === r[0]) {
						g[l] = g[g.length - 1];
						g.pop();
						j = !1;
						break
					}
					j && g.push(r)
				}
				c[h] = c[c.length - 1];
				c.pop()
			} else h++
		}
		for (l = 0; l < g.length; l++) c.push([g[l][0], g[l][1], e])
	}
	e = 0;
	f = Array(a.length);
	for (d = 0; d < c.length; d++) {
		g = c[d];
		for (h = 0; 3 > h; h++) void 0 === f[g[h]] && (f[g[h]] = e++, this.vertices.push(a[g[h]])), g[h] = f[g[h]]
	}
	for (d = 0; d < c.length; d++) this.faces.push(new THREE.Face3(c[d][0], c[d][1], c[d][2]));
	for (d = 0; d < this.faces.length; d++) g = this.faces[d],
	this.faceVertexUvs[0].push([b(this.vertices[g.a]), b(this.vertices[g.b]), b(this.vertices[g.c])]);
	this.computeCentroids();
	this.computeFaceNormals();
	this.computeVertexNormals()
};
THREE.ConvexGeometry.prototype = Object.create(THREE.Geometry.prototype);
THREE.AxisHelper = function (a) {
	var b = new THREE.Geometry;
	b.vertices.push(new THREE.Vector3, new THREE.Vector3(a || 1, 0, 0), new THREE.Vector3, new THREE.Vector3(0, a || 1, 0), new THREE.Vector3, new THREE.Vector3(0, 0, a || 1));
	b.colors.push(new THREE.Color(16711680), new THREE.Color(16755200), new THREE.Color(65280), new THREE.Color(11206400), new THREE.Color(255), new THREE.Color(43775));
	a = new THREE.LineBasicMaterial({
		vertexColors: THREE.VertexColors
	});
	THREE.Line.call(this, b, a, THREE.LinePieces)
};
THREE.AxisHelper.prototype = Object.create(THREE.Line.prototype);
THREE.ArrowHelper = function (a, b, c, d) {
	THREE.Object3D.call(this);
	void 0 === d && (d = 16776960);
	void 0 === c && (c = 20);
	var e = new THREE.Geometry;
	e.vertices.push(new THREE.Vector3(0, 0, 0));
	e.vertices.push(new THREE.Vector3(0, 1, 0));
	this.line = new THREE.Line(e, new THREE.LineBasicMaterial({
		color: d
	}));
	this.add(this.line);
	e = new THREE.CylinderGeometry(0, 0.05, 0.25, 5, 1);
	this.cone = new THREE.Mesh(e, new THREE.MeshBasicMaterial({
		color: d
	}));
	this.cone.position.set(0, 1, 0);
	this.add(this.cone);
	b instanceof THREE.Vector3 && (this.position = b);
	this.setDirection(a);
	this.setLength(c)
};
THREE.ArrowHelper.prototype = Object.create(THREE.Object3D.prototype);
THREE.ArrowHelper.prototype.setDirection = function (a) {
	var b = (new THREE.Vector3(0, 1, 0)).crossSelf(a),
		a = Math.acos((new THREE.Vector3(0, 1, 0)).dot(a.clone().normalize()));
	this.matrix = (new THREE.Matrix4).makeRotationAxis(b.normalize(), a);
	this.rotation.setEulerFromRotationMatrix(this.matrix, this.eulerOrder)
};
THREE.ArrowHelper.prototype.setLength = function (a) {
	this.scale.set(a, a, a)
};
THREE.ArrowHelper.prototype.setColor = function (a) {
	this.line.material.color.setHex(a);
	this.cone.material.color.setHex(a)
};
THREE.CameraHelper = function (a) {
	function b(a, b, d) {
		c(a, d);
		c(b, d)
	}
	function c(a, b) {
		d.geometry.vertices.push(new THREE.Vector3);
		d.geometry.colors.push(new THREE.Color(b));
		void 0 === d.pointMap[a] && (d.pointMap[a] = []);
		d.pointMap[a].push(d.geometry.vertices.length - 1)
	}
	THREE.Line.call(this);
	var d = this;
	this.geometry = new THREE.Geometry;
	this.material = new THREE.LineBasicMaterial({
		color: 16777215,
		vertexColors: THREE.FaceColors
	});
	this.type = THREE.LinePieces;
	this.matrixWorld = a.matrixWorld;
	this.matrixAutoUpdate = !1;
	this.pointMap = {};
	b("n1", "n2", 16755200);
	b("n2", "n4", 16755200);
	b("n4", "n3", 16755200);
	b("n3", "n1", 16755200);
	b("f1", "f2", 16755200);
	b("f2", "f4", 16755200);
	b("f4", "f3", 16755200);
	b("f3", "f1", 16755200);
	b("n1", "f1", 16755200);
	b("n2", "f2", 16755200);
	b("n3", "f3", 16755200);
	b("n4", "f4", 16755200);
	b("p", "n1", 16711680);
	b("p", "n2", 16711680);
	b("p", "n3", 16711680);
	b("p", "n4", 16711680);
	b("u1", "u2", 43775);
	b("u2", "u3", 43775);
	b("u3", "u1", 43775);
	b("c", "t", 16777215);
	b("p", "c", 3355443);
	b("cn1", "cn2", 3355443);
	b("cn3", "cn4", 3355443);
	b("cf1",
		"cf2", 3355443);
	b("cf3", "cf4", 3355443);
	this.camera = a;
	this.update(a)
};
THREE.CameraHelper.prototype = Object.create(THREE.Line.prototype);
THREE.CameraHelper.prototype.update = function () {
	function a(a, d, e, f) {
		THREE.CameraHelper.__v.set(d, e, f);
		THREE.CameraHelper.__projector.unprojectVector(THREE.CameraHelper.__v, THREE.CameraHelper.__c);
		a = b.pointMap[a];
		if (void 0 !== a) {
			d = 0;
			for (e = a.length; d < e; d++) b.geometry.vertices[a[d]].copy(THREE.CameraHelper.__v)
		}
	}
	var b = this;
	THREE.CameraHelper.__c.projectionMatrix.copy(this.camera.projectionMatrix);
	a("c", 0, 0, -1);
	a("t", 0, 0, 1);
	a("n1", -1, -1, -1);
	a("n2", 1, -1, -1);
	a("n3", -1, 1, -1);
	a("n4", 1, 1, -1);
	a("f1", -1, -1, 1);
	a("f2", 1, -1, 1);
	a("f3", -1, 1, 1);
	a("f4", 1, 1, 1);
	a("u1", 0.7, 1.1, -1);
	a("u2", -0.7, 1.1, -1);
	a("u3", 0, 2, -1);
	a("cf1", -1, 0, 1);
	a("cf2", 1, 0, 1);
	a("cf3", 0, -1, 1);
	a("cf4", 0, 1, 1);
	a("cn1", -1, 0, -1);
	a("cn2", 1, 0, -1);
	a("cn3", 0, -1, -1);
	a("cn4", 0, 1, -1);
	this.geometry.verticesNeedUpdate = !0
};
THREE.CameraHelper.__projector = new THREE.Projector;
THREE.CameraHelper.__v = new THREE.Vector3;
THREE.CameraHelper.__c = new THREE.Camera;
THREE.DirectionalLightHelper = function (a, b, c) {
	THREE.Object3D.call(this);
	this.light = a;
	this.position = a.position;
	this.direction = new THREE.Vector3;
	this.direction.sub(a.target.position, a.position);
	this.color = a.color.clone();
	var d = THREE.Math.clamp(a.intensity, 0, 1);
	this.color.r *= d;
	this.color.g *= d;
	this.color.b *= d;
	var d = this.color.getHex(),
		e = new THREE.SphereGeometry(b, 16, 8),
		f = new THREE.AsteriskGeometry(1.25 * b, 2.25 * b),
		g = new THREE.MeshBasicMaterial({
			color: d,
			fog: !1
		}),
		h = new THREE.LineBasicMaterial({
			color: d,
			fog: !1
		});
	this.lightArrow = new THREE.ArrowHelper(this.direction, null, c, d);
	this.lightSphere = new THREE.Mesh(e, g);
	this.lightArrow.cone.material.fog = !1;
	this.lightArrow.line.material.fog = !1;
	this.lightRays = new THREE.Line(f, h, THREE.LinePieces);
	this.add(this.lightArrow);
	this.add(this.lightSphere);
	this.add(this.lightRays);
	this.lightSphere.properties.isGizmo = !0;
	this.lightSphere.properties.gizmoSubject = a;
	this.lightSphere.properties.gizmoRoot = this;
	this.targetSphere = null;
	a.target.properties.targetInverse && (b = new THREE.SphereGeometry(b,
	8, 4), c = new THREE.MeshBasicMaterial({
		color: d,
		wireframe: !0,
		fog: !1
	}), this.targetSphere = new THREE.Mesh(b, c), this.targetSphere.position = a.target.position, this.targetSphere.properties.isGizmo = !0, this.targetSphere.properties.gizmoSubject = a.target, this.targetSphere.properties.gizmoRoot = this.targetSphere, a = new THREE.LineDashedMaterial({
		color: d,
		dashSize: 4,
		gapSize: 4,
		opacity: 0.75,
		transparent: !0,
		fog: !1
	}), d = new THREE.Geometry, d.vertices.push(this.position.clone()), d.vertices.push(this.targetSphere.position.clone()),
	d.computeLineDistances(), this.targetLine = new THREE.Line(d, a), this.targetLine.properties.isGizmo = !0);
	this.properties.isGizmo = !0
};
THREE.DirectionalLightHelper.prototype = Object.create(THREE.Object3D.prototype);
THREE.DirectionalLightHelper.prototype.update = function () {
	this.direction.sub(this.light.target.position, this.light.position);
	this.lightArrow.setDirection(this.direction);
	this.color.copy(this.light.color);
	var a = THREE.Math.clamp(this.light.intensity, 0, 1);
	this.color.r *= a;
	this.color.g *= a;
	this.color.b *= a;
	this.lightArrow.setColor(this.color.getHex());
	this.lightSphere.material.color.copy(this.color);
	this.lightRays.material.color.copy(this.color);
	this.targetSphere.material.color.copy(this.color);
	this.targetLine.material.color.copy(this.color);
	this.targetLine.geometry.vertices[0].copy(this.light.position);
	this.targetLine.geometry.vertices[1].copy(this.light.target.position);
	this.targetLine.geometry.computeLineDistances();
	this.targetLine.geometry.verticesNeedUpdate = !0
};
THREE.HemisphereLightHelper = function (a, b, c) {
	THREE.Object3D.call(this);
	this.light = a;
	this.position = a.position;
	var d = THREE.Math.clamp(a.intensity, 0, 1);
	this.color = a.color.clone();
	this.color.r *= d;
	this.color.g *= d;
	this.color.b *= d;
	var e = this.color.getHex();
	this.groundColor = a.groundColor.clone();
	this.groundColor.r *= d;
	this.groundColor.g *= d;
	this.groundColor.b *= d;
	for (var d = this.groundColor.getHex(), f = new THREE.SphereGeometry(b, 16, 8, 0, 2 * Math.PI, 0, 0.5 * Math.PI), g = new THREE.SphereGeometry(b, 16, 8, 0, 2 * Math.PI, 0.5 * Math.PI, Math.PI), h = new THREE.MeshBasicMaterial({
		color: e,
		fog: !1
	}), i = new THREE.MeshBasicMaterial({
		color: d,
		fog: !1
	}), k = 0, j = f.faces.length; k < j; k++) f.faces[k].materialIndex = 0;
	k = 0;
	for (j = g.faces.length; k < j; k++) g.faces[k].materialIndex = 1;
	THREE.GeometryUtils.merge(f, g);
	this.lightSphere = new THREE.Mesh(f, new THREE.MeshFaceMaterial([h, i]));
	this.lightArrow = new THREE.ArrowHelper(new THREE.Vector3(0, 1, 0), new THREE.Vector3(0, 1.1 * (b + c), 0), c, e);
	this.lightArrow.rotation.x = Math.PI;
	this.lightArrowGround = new THREE.ArrowHelper(new THREE.Vector3(0,
	1, 0), new THREE.Vector3(0, -1.1 * (b + c), 0), c, d);
	b = new THREE.Object3D;
	b.rotation.x = 0.5 * -Math.PI;
	b.add(this.lightSphere);
	b.add(this.lightArrow);
	b.add(this.lightArrowGround);
	this.add(b);
	this.lightSphere.properties.isGizmo = !0;
	this.lightSphere.properties.gizmoSubject = a;
	this.lightSphere.properties.gizmoRoot = this;
	this.properties.isGizmo = !0;
	this.target = new THREE.Vector3;
	this.lookAt(this.target)
};
THREE.HemisphereLightHelper.prototype = Object.create(THREE.Object3D.prototype);
THREE.HemisphereLightHelper.prototype.update = function () {
	var a = THREE.Math.clamp(this.light.intensity, 0, 1);
	this.color.copy(this.light.color);
	this.groundColor.copy(this.light.groundColor);
	this.color.r *= a;
	this.color.g *= a;
	this.color.b *= a;
	this.groundColor.r *= a;
	this.groundColor.g *= a;
	this.groundColor.b *= a;
	this.lightSphere.material.materials[0].color.copy(this.color);
	this.lightSphere.material.materials[1].color.copy(this.groundColor);
	this.lightArrow.setColor(this.color.getHex());
	this.lightArrowGround.setColor(this.groundColor.getHex());
	this.lookAt(this.target)
};
THREE.PointLightHelper = function (a, b) {
	THREE.Object3D.call(this);
	this.light = a;
	this.position = a.position;
	this.color = a.color.clone();
	var c = THREE.Math.clamp(a.intensity, 0, 1);
	this.color.r *= c;
	this.color.g *= c;
	this.color.b *= c;
	var d = this.color.getHex(),
		c = new THREE.SphereGeometry(b, 16, 8),
		e = new THREE.AsteriskGeometry(1.25 * b, 2.25 * b),
		f = new THREE.IcosahedronGeometry(1, 2),
		g = new THREE.MeshBasicMaterial({
			color: d,
			fog: !1
		}),
		h = new THREE.LineBasicMaterial({
			color: d,
			fog: !1
		}),
		d = new THREE.MeshBasicMaterial({
			color: d,
			fog: !1,
			wireframe: !0,
			opacity: 0.1,
			transparent: !0
		});
	this.lightSphere = new THREE.Mesh(c, g);
	this.lightRays = new THREE.Line(e, h, THREE.LinePieces);
	this.lightDistance = new THREE.Mesh(f, d);
	c = a.distance;
	0 === c ? this.lightDistance.visible = !1 : this.lightDistance.scale.set(c, c, c);
	this.add(this.lightSphere);
	this.add(this.lightRays);
	this.add(this.lightDistance);
	this.lightSphere.properties.isGizmo = !0;
	this.lightSphere.properties.gizmoSubject = a;
	this.lightSphere.properties.gizmoRoot = this;
	this.properties.isGizmo = !0
};
THREE.PointLightHelper.prototype = Object.create(THREE.Object3D.prototype);
THREE.PointLightHelper.prototype.update = function () {
	this.color.copy(this.light.color);
	var a = THREE.Math.clamp(this.light.intensity, 0, 1);
	this.color.r *= a;
	this.color.g *= a;
	this.color.b *= a;
	this.lightSphere.material.color.copy(this.color);
	this.lightRays.material.color.copy(this.color);
	this.lightDistance.material.color.copy(this.color);
	a = this.light.distance;
	0 === a ? this.lightDistance.visible = !1 : (this.lightDistance.visible = !0, this.lightDistance.scale.set(a, a, a))
};
THREE.SpotLightHelper = function (a, b, c) {
	THREE.Object3D.call(this);
	this.light = a;
	this.position = a.position;
	this.direction = new THREE.Vector3;
	this.direction.sub(a.target.position, a.position);
	this.color = a.color.clone();
	var d = THREE.Math.clamp(a.intensity, 0, 1);
	this.color.r *= d;
	this.color.g *= d;
	this.color.b *= d;
	var d = this.color.getHex(),
		e = new THREE.SphereGeometry(b, 16, 8),
		f = new THREE.AsteriskGeometry(1.25 * b, 2.25 * b),
		g = new THREE.CylinderGeometry(1E-4, 1, 1, 8, 1, !0),
		h = new THREE.Matrix4;
	h.rotateX(-Math.PI / 2);
	h.translate(new THREE.Vector3(0, -0.5, 0));
	g.applyMatrix(h);
	var i = new THREE.MeshBasicMaterial({
		color: d,
		fog: !1
	}),
		h = new THREE.LineBasicMaterial({
			color: d,
			fog: !1
		}),
		k = new THREE.MeshBasicMaterial({
			color: d,
			fog: !1,
			wireframe: !0,
			opacity: 0.3,
			transparent: !0
		});
	this.lightArrow = new THREE.ArrowHelper(this.direction, null, c, d);
	this.lightSphere = new THREE.Mesh(e, i);
	this.lightCone = new THREE.Mesh(g, k);
	c = a.distance ? a.distance : 1E4;
	e = 2 * c * Math.tan(0.5 * a.angle);
	this.lightCone.scale.set(e, e, c);
	this.lightArrow.cone.material.fog = !1;
	this.lightArrow.line.material.fog = !1;
	this.lightRays = new THREE.Line(f, h, THREE.LinePieces);
	this.gyroscope = new THREE.Gyroscope;
	this.gyroscope.add(this.lightArrow);
	this.gyroscope.add(this.lightSphere);
	this.gyroscope.add(this.lightRays);
	this.add(this.gyroscope);
	this.add(this.lightCone);
	this.lookAt(a.target.position);
	this.lightSphere.properties.isGizmo = !0;
	this.lightSphere.properties.gizmoSubject = a;
	this.lightSphere.properties.gizmoRoot = this;
	this.targetSphere = null;
	a.target.properties.targetInverse && (b = new THREE.SphereGeometry(b, 8, 4), f = new THREE.MeshBasicMaterial({
		color: d,
		wireframe: !0,
		fog: !1
	}), this.targetSphere = new THREE.Mesh(b, f), this.targetSphere.position = a.target.position, this.targetSphere.properties.isGizmo = !0, this.targetSphere.properties.gizmoSubject = a.target, this.targetSphere.properties.gizmoRoot = this.targetSphere, a = new THREE.LineDashedMaterial({
		color: d,
		dashSize: 4,
		gapSize: 4,
		opacity: 0.75,
		transparent: !0,
		fog: !1
	}), d = new THREE.Geometry, d.vertices.push(this.position.clone()), d.vertices.push(this.targetSphere.position.clone()), d.computeLineDistances(), this.targetLine = new THREE.Line(d, a), this.targetLine.properties.isGizmo = !0);
	this.properties.isGizmo = !0
};
THREE.SpotLightHelper.prototype = Object.create(THREE.Object3D.prototype);
THREE.SpotLightHelper.prototype.update = function () {
	this.direction.sub(this.light.target.position, this.light.position);
	this.lightArrow.setDirection(this.direction);
	this.lookAt(this.light.target.position);
	var a = this.light.distance ? this.light.distance : 1E4,
		b = 2 * a * Math.tan(0.5 * this.light.angle);
	this.lightCone.scale.set(b, b, a);
	this.color.copy(this.light.color);
	a = THREE.Math.clamp(this.light.intensity, 0, 1);
	this.color.r *= a;
	this.color.g *= a;
	this.color.b *= a;
	this.lightArrow.setColor(this.color.getHex());
	this.lightSphere.material.color.copy(this.color);
	this.lightRays.material.color.copy(this.color);
	this.lightCone.material.color.copy(this.color);
	this.targetSphere.material.color.copy(this.color);
	this.targetLine.material.color.copy(this.color);
	this.targetLine.geometry.vertices[0].copy(this.light.position);
	this.targetLine.geometry.vertices[1].copy(this.light.target.position);
	this.targetLine.geometry.computeLineDistances();
	this.targetLine.geometry.verticesNeedUpdate = !0
};
THREE.ImmediateRenderObject = function () {
	THREE.Object3D.call(this);
	this.render = function () {}
};
THREE.ImmediateRenderObject.prototype = Object.create(THREE.Object3D.prototype);
THREE.LensFlare = function (a, b, c, d, e) {
	THREE.Object3D.call(this);
	this.lensFlares = [];
	this.positionScreen = new THREE.Vector3;
	this.customUpdateCallback = void 0;
	void 0 !== a && this.add(a, b, c, d, e)
};
THREE.LensFlare.prototype = Object.create(THREE.Object3D.prototype);
THREE.LensFlare.prototype.add = function (a, b, c, d, e, f) {
	void 0 === b && (b = -1);
	void 0 === c && (c = 0);
	void 0 === f && (f = 1);
	void 0 === e && (e = new THREE.Color(16777215));
	void 0 === d && (d = THREE.NormalBlending);
	c = Math.min(c, Math.max(0, c));
	this.lensFlares.push({
		texture: a,
		size: b,
		distance: c,
		x: 0,
		y: 0,
		z: 0,
		scale: 1,
		rotation: 1,
		opacity: f,
		color: e,
		blending: d
	})
};
THREE.LensFlare.prototype.updateLensFlares = function () {
	var a, b = this.lensFlares.length,
		c, d = 2 * -this.positionScreen.x,
		e = 2 * -this.positionScreen.y;
	for (a = 0; a < b; a++) c = this.lensFlares[a], c.x = this.positionScreen.x + d * c.distance, c.y = this.positionScreen.y + e * c.distance, c.wantedRotation = 0.25 * c.x * Math.PI, c.rotation += 0.25 * (c.wantedRotation - c.rotation)
};
THREE.MorphBlendMesh = function (a, b) {
	THREE.Mesh.call(this, a, b);
	this.animationsMap = {};
	this.animationsList = [];
	var c = this.geometry.morphTargets.length;
	this.createAnimation("__default", 0, c - 1, c / 1);
	this.setAnimationWeight("__default", 1)
};
THREE.MorphBlendMesh.prototype = Object.create(THREE.Mesh.prototype);
THREE.MorphBlendMesh.prototype.createAnimation = function (a, b, c, d) {
	b = {
		startFrame: b,
		endFrame: c,
		length: c - b + 1,
		fps: d,
		duration: (c - b) / d,
		lastFrame: 0,
		currentFrame: 0,
		active: !1,
		time: 0,
		direction: 1,
		weight: 1,
		directionBackwards: !1,
		mirroredLoop: !1
	};
	this.animationsMap[a] = b;
	this.animationsList.push(b)
};
THREE.MorphBlendMesh.prototype.autoCreateAnimations = function (a) {
	for (var b = /([a-z]+)(\d+)/, c, d = {}, e = this.geometry, f = 0, g = e.morphTargets.length; f < g; f++) {
		var h = e.morphTargets[f].name.match(b);
		if (h && 1 < h.length) {
			var i = h[1];
			d[i] || (d[i] = {
				start: Infinity,
				end: -Infinity
			});
			h = d[i];
			f < h.start && (h.start = f);
			f > h.end && (h.end = f);
			c || (c = i)
		}
	}
	for (i in d) h = d[i], this.createAnimation(i, h.start, h.end, a);
	this.firstAnimation = c
};
THREE.MorphBlendMesh.prototype.setAnimationDirectionForward = function (a) {
	if (a = this.animationsMap[a]) a.direction = 1, a.directionBackwards = !1
};
THREE.MorphBlendMesh.prototype.setAnimationDirectionBackward = function (a) {
	if (a = this.animationsMap[a]) a.direction = -1, a.directionBackwards = !0
};
THREE.MorphBlendMesh.prototype.setAnimationFPS = function (a, b) {
	var c = this.animationsMap[a];
	c && (c.fps = b, c.duration = (c.end - c.start) / c.fps)
};
THREE.MorphBlendMesh.prototype.setAnimationDuration = function (a, b) {
	var c = this.animationsMap[a];
	c && (c.duration = b, c.fps = (c.end - c.start) / c.duration)
};
THREE.MorphBlendMesh.prototype.setAnimationWeight = function (a, b) {
	var c = this.animationsMap[a];
	c && (c.weight = b)
};
THREE.MorphBlendMesh.prototype.setAnimationTime = function (a, b) {
	var c = this.animationsMap[a];
	c && (c.time = b)
};
THREE.MorphBlendMesh.prototype.getAnimationTime = function (a) {
	var b = 0;
	if (a = this.animationsMap[a]) b = a.time;
	return b
};
THREE.MorphBlendMesh.prototype.getAnimationDuration = function (a) {
	var b = -1;
	if (a = this.animationsMap[a]) b = a.duration;
	return b
};
THREE.MorphBlendMesh.prototype.playAnimation = function (a) {
	var b = this.animationsMap[a];
	b ? (b.time = 0, b.active = !0) : console.warn("animation[" + a + "] undefined")
};
THREE.MorphBlendMesh.prototype.stopAnimation = function (a) {
	if (a = this.animationsMap[a]) a.active = !1
};
THREE.MorphBlendMesh.prototype.update = function (a) {
	for (var b = 0, c = this.animationsList.length; b < c; b++) {
		var d = this.animationsList[b];
		if (d.active) {
			var e = d.duration / d.length;
			d.time += d.direction * a;
			if (d.mirroredLoop) {
				if (d.time > d.duration || 0 > d.time) d.direction *= -1, d.time > d.duration && (d.time = d.duration, d.directionBackwards = !0), 0 > d.time && (d.time = 0, d.directionBackwards = !1)
			} else d.time %= d.duration, 0 > d.time && (d.time += d.duration);
			var f = d.startFrame + THREE.Math.clamp(Math.floor(d.time / e), 0, d.length - 1),
				g = d.weight;
			f !== d.currentFrame && (this.morphTargetInfluences[d.lastFrame] = 0, this.morphTargetInfluences[d.currentFrame] = 1 * g, this.morphTargetInfluences[f] = 0, d.lastFrame = d.currentFrame, d.currentFrame = f);
			e = d.time % e / e;
			d.directionBackwards && (e = 1 - e);
			this.morphTargetInfluences[d.currentFrame] = e * g;
			this.morphTargetInfluences[d.lastFrame] = (1 - e) * g
		}
	}
};
THREE.LensFlarePlugin = function () {
	function a(a, c) {
		var d = b.createProgram(),
			e = b.createShader(b.FRAGMENT_SHADER),
			f = b.createShader(b.VERTEX_SHADER),
			g = "precision " + c + " float;\n";
		b.shaderSource(e, g + a.fragmentShader);
		b.shaderSource(f, g + a.vertexShader);
		b.compileShader(e);
		b.compileShader(f);
		b.attachShader(d, e);
		b.attachShader(d, f);
		b.linkProgram(d);
		return d
	}
	var b, c, d, e, f, g, h, i, k, j, l, m, r;
	this.init = function (q) {
		b = q.context;
		c = q;
		d = q.getPrecision();
		e = new Float32Array(16);
		f = new Uint16Array(6);
		q = 0;
		e[q++] = -1;
		e[q++] = -1;
		e[q++] = 0;
		e[q++] = 0;
		e[q++] = 1;
		e[q++] = -1;
		e[q++] = 1;
		e[q++] = 0;
		e[q++] = 1;
		e[q++] = 1;
		e[q++] = 1;
		e[q++] = 1;
		e[q++] = -1;
		e[q++] = 1;
		e[q++] = 0;
		e[q++] = 1;
		q = 0;
		f[q++] = 0;
		f[q++] = 1;
		f[q++] = 2;
		f[q++] = 0;
		f[q++] = 2;
		f[q++] = 3;
		g = b.createBuffer();
		h = b.createBuffer();
		b.bindBuffer(b.ARRAY_BUFFER, g);
		b.bufferData(b.ARRAY_BUFFER, e, b.STATIC_DRAW);
		b.bindBuffer(b.ELEMENT_ARRAY_BUFFER, h);
		b.bufferData(b.ELEMENT_ARRAY_BUFFER, f, b.STATIC_DRAW);
		i = b.createTexture();
		k = b.createTexture();
		b.bindTexture(b.TEXTURE_2D, i);
		b.texImage2D(b.TEXTURE_2D, 0, b.RGB, 16, 16,
		0, b.RGB, b.UNSIGNED_BYTE, null);
		b.texParameteri(b.TEXTURE_2D, b.TEXTURE_WRAP_S, b.CLAMP_TO_EDGE);
		b.texParameteri(b.TEXTURE_2D, b.TEXTURE_WRAP_T, b.CLAMP_TO_EDGE);
		b.texParameteri(b.TEXTURE_2D, b.TEXTURE_MAG_FILTER, b.NEAREST);
		b.texParameteri(b.TEXTURE_2D, b.TEXTURE_MIN_FILTER, b.NEAREST);
		b.bindTexture(b.TEXTURE_2D, k);
		b.texImage2D(b.TEXTURE_2D, 0, b.RGBA, 16, 16, 0, b.RGBA, b.UNSIGNED_BYTE, null);
		b.texParameteri(b.TEXTURE_2D, b.TEXTURE_WRAP_S, b.CLAMP_TO_EDGE);
		b.texParameteri(b.TEXTURE_2D, b.TEXTURE_WRAP_T, b.CLAMP_TO_EDGE);
		b.texParameteri(b.TEXTURE_2D, b.TEXTURE_MAG_FILTER, b.NEAREST);
		b.texParameteri(b.TEXTURE_2D, b.TEXTURE_MIN_FILTER, b.NEAREST);
		0 >= b.getParameter(b.MAX_VERTEX_TEXTURE_IMAGE_UNITS) ? (j = !1, l = a(THREE.ShaderFlares.lensFlare, d)) : (j = !0, l = a(THREE.ShaderFlares.lensFlareVertexTexture, d));
		m = {};
		r = {};
		m.vertex = b.getAttribLocation(l, "position");
		m.uv = b.getAttribLocation(l, "uv");
		r.renderType = b.getUniformLocation(l, "renderType");
		r.map = b.getUniformLocation(l, "map");
		r.occlusionMap = b.getUniformLocation(l, "occlusionMap");
		r.opacity = b.getUniformLocation(l, "opacity");
		r.color = b.getUniformLocation(l, "color");
		r.scale = b.getUniformLocation(l, "scale");
		r.rotation = b.getUniformLocation(l, "rotation");
		r.screenPosition = b.getUniformLocation(l, "screenPosition")
	};
	this.render = function (a, d, e, f) {
		var a = a.__webglFlares,
			x = a.length;
		if (x) {
			var v = new THREE.Vector3,
				s = f / e,
				C = 0.5 * e,
				z = 0.5 * f,
				w = 16 / f,
				A = new THREE.Vector2(w * s, w),
				H = new THREE.Vector3(1, 1, 0),
				G = new THREE.Vector2(1, 1),
				I = r,
				w = m;
			b.useProgram(l);
			b.enableVertexAttribArray(m.vertex);
			b.enableVertexAttribArray(m.uv);
			b.uniform1i(I.occlusionMap, 0);
			b.uniform1i(I.map, 1);
			b.bindBuffer(b.ARRAY_BUFFER, g);
			b.vertexAttribPointer(w.vertex, 2, b.FLOAT, !1, 16, 0);
			b.vertexAttribPointer(w.uv, 2, b.FLOAT, !1, 16, 8);
			b.bindBuffer(b.ELEMENT_ARRAY_BUFFER, h);
			b.disable(b.CULL_FACE);
			b.depthMask(!1);
			var V, E, O, D, J;
			for (V = 0; V < x; V++) if (w = 16 / f, A.set(w * s, w), D = a[V], v.set(D.matrixWorld.elements[12], D.matrixWorld.elements[13], D.matrixWorld.elements[14]), d.matrixWorldInverse.multiplyVector3(v), d.projectionMatrix.multiplyVector3(v), H.copy(v), G.x = H.x * C + C, G.y = H.y * z + z, j || 0 < G.x && G.x < e && 0 < G.y && G.y < f) {
				b.activeTexture(b.TEXTURE1);
				b.bindTexture(b.TEXTURE_2D, i);
				b.copyTexImage2D(b.TEXTURE_2D, 0, b.RGB, G.x - 8, G.y - 8, 16, 16, 0);
				b.uniform1i(I.renderType, 0);
				b.uniform2f(I.scale, A.x, A.y);
				b.uniform3f(I.screenPosition, H.x, H.y, H.z);
				b.disable(b.BLEND);
				b.enable(b.DEPTH_TEST);
				b.drawElements(b.TRIANGLES, 6, b.UNSIGNED_SHORT, 0);
				b.activeTexture(b.TEXTURE0);
				b.bindTexture(b.TEXTURE_2D, k);
				b.copyTexImage2D(b.TEXTURE_2D, 0, b.RGBA, G.x - 8, G.y - 8, 16, 16, 0);
				b.uniform1i(I.renderType, 1);
				b.disable(b.DEPTH_TEST);
				b.activeTexture(b.TEXTURE1);
				b.bindTexture(b.TEXTURE_2D, i);
				b.drawElements(b.TRIANGLES, 6, b.UNSIGNED_SHORT, 0);
				D.positionScreen.copy(H);
				D.customUpdateCallback ? D.customUpdateCallback(D) : D.updateLensFlares();
				b.uniform1i(I.renderType, 2);
				b.enable(b.BLEND);
				E = 0;
				for (O = D.lensFlares.length; E < O; E++) J = D.lensFlares[E], 0.001 < J.opacity && 0.001 < J.scale && (H.x = J.x, H.y = J.y, H.z = J.z, w = J.size * J.scale / f, A.x = w * s, A.y = w, b.uniform3f(I.screenPosition, H.x, H.y, H.z), b.uniform2f(I.scale, A.x, A.y), b.uniform1f(I.rotation, J.rotation), b.uniform1f(I.opacity,
				J.opacity), b.uniform3f(I.color, J.color.r, J.color.g, J.color.b), c.setBlending(J.blending, J.blendEquation, J.blendSrc, J.blendDst), c.setTexture(J.texture, 1), b.drawElements(b.TRIANGLES, 6, b.UNSIGNED_SHORT, 0))
			}
			b.enable(b.CULL_FACE);
			b.enable(b.DEPTH_TEST);
			b.depthMask(!0)
		}
	}
};
THREE.ShadowMapPlugin = function () {
	var a, b, c, d, e, f, g = new THREE.Frustum,
		h = new THREE.Matrix4,
		i = new THREE.Vector3,
		k = new THREE.Vector3;
	this.init = function (g) {
		a = g.context;
		b = g;
		var g = THREE.ShaderLib.depthRGBA,
			h = THREE.UniformsUtils.clone(g.uniforms);
		c = new THREE.ShaderMaterial({
			fragmentShader: g.fragmentShader,
			vertexShader: g.vertexShader,
			uniforms: h
		});
		d = new THREE.ShaderMaterial({
			fragmentShader: g.fragmentShader,
			vertexShader: g.vertexShader,
			uniforms: h,
			morphTargets: !0
		});
		e = new THREE.ShaderMaterial({
			fragmentShader: g.fragmentShader,
			vertexShader: g.vertexShader,
			uniforms: h,
			skinning: !0
		});
		f = new THREE.ShaderMaterial({
			fragmentShader: g.fragmentShader,
			vertexShader: g.vertexShader,
			uniforms: h,
			morphTargets: !0,
			skinning: !0
		});
		c._shadowPass = !0;
		d._shadowPass = !0;
		e._shadowPass = !0;
		f._shadowPass = !0
	};
	this.render = function (a, c) {
		b.shadowMapEnabled && b.shadowMapAutoUpdate && this.update(a, c)
	};
	this.update = function (j, l) {
		var m, r, q, p, t, u, x, v, s, C = [];
		p = 0;
		a.clearColor(1, 1, 1, 1);
		a.disable(a.BLEND);
		a.enable(a.CULL_FACE);
		a.frontFace(a.CCW);
		b.shadowMapCullFace === THREE.CullFaceFront ? a.cullFace(a.FRONT) : a.cullFace(a.BACK);
		b.setDepthTest(!0);
		m = 0;
		for (r = j.__lights.length; m < r; m++) if (q = j.__lights[m], q.castShadow) if (q instanceof THREE.DirectionalLight && q.shadowCascade) for (t = 0; t < q.shadowCascadeCount; t++) {
			var z;
			if (q.shadowCascadeArray[t]) z = q.shadowCascadeArray[t];
			else {
				s = q;
				x = t;
				z = new THREE.DirectionalLight;
				z.isVirtual = !0;
				z.onlyShadow = !0;
				z.castShadow = !0;
				z.shadowCameraNear = s.shadowCameraNear;
				z.shadowCameraFar = s.shadowCameraFar;
				z.shadowCameraLeft = s.shadowCameraLeft;
				z.shadowCameraRight = s.shadowCameraRight;
				z.shadowCameraBottom = s.shadowCameraBottom;
				z.shadowCameraTop = s.shadowCameraTop;
				z.shadowCameraVisible = s.shadowCameraVisible;
				z.shadowDarkness = s.shadowDarkness;
				z.shadowBias = s.shadowCascadeBias[x];
				z.shadowMapWidth = s.shadowCascadeWidth[x];
				z.shadowMapHeight = s.shadowCascadeHeight[x];
				z.pointsWorld = [];
				z.pointsFrustum = [];
				v = z.pointsWorld;
				u = z.pointsFrustum;
				for (var w = 0; 8 > w; w++) v[w] = new THREE.Vector3, u[w] = new THREE.Vector3;
				v = s.shadowCascadeNearZ[x];
				s = s.shadowCascadeFarZ[x];
				u[0].set(-1, -1, v);
				u[1].set(1, -1, v);
				u[2].set(-1,
				1, v);
				u[3].set(1, 1, v);
				u[4].set(-1, -1, s);
				u[5].set(1, -1, s);
				u[6].set(-1, 1, s);
				u[7].set(1, 1, s);
				z.originalCamera = l;
				u = new THREE.Gyroscope;
				u.position = q.shadowCascadeOffset;
				u.add(z);
				u.add(z.target);
				l.add(u);
				q.shadowCascadeArray[t] = z;
				console.log("Created virtualLight", z)
			}
			x = q;
			v = t;
			s = x.shadowCascadeArray[v];
			s.position.copy(x.position);
			s.target.position.copy(x.target.position);
			s.lookAt(s.target);
			s.shadowCameraVisible = x.shadowCameraVisible;
			s.shadowDarkness = x.shadowDarkness;
			s.shadowBias = x.shadowCascadeBias[v];
			u = x.shadowCascadeNearZ[v];
			x = x.shadowCascadeFarZ[v];
			s = s.pointsFrustum;
			s[0].z = u;
			s[1].z = u;
			s[2].z = u;
			s[3].z = u;
			s[4].z = x;
			s[5].z = x;
			s[6].z = x;
			s[7].z = x;
			C[p] = z;
			p++
		} else C[p] = q, p++;
		m = 0;
		for (r = C.length; m < r; m++) {
			q = C[m];
			q.shadowMap || (t = THREE.LinearFilter, b.shadowMapType === THREE.PCFSoftShadowMap && (t = THREE.NearestFilter), q.shadowMap = new THREE.WebGLRenderTarget(q.shadowMapWidth, q.shadowMapHeight, {
				minFilter: t,
				magFilter: t,
				format: THREE.RGBAFormat
			}), q.shadowMapSize = new THREE.Vector2(q.shadowMapWidth, q.shadowMapHeight), q.shadowMatrix = new THREE.Matrix4);
			if (!q.shadowCamera) {
				if (q instanceof THREE.SpotLight) q.shadowCamera = new THREE.PerspectiveCamera(q.shadowCameraFov, q.shadowMapWidth / q.shadowMapHeight, q.shadowCameraNear, q.shadowCameraFar);
				else if (q instanceof THREE.DirectionalLight) q.shadowCamera = new THREE.OrthographicCamera(q.shadowCameraLeft, q.shadowCameraRight, q.shadowCameraTop, q.shadowCameraBottom, q.shadowCameraNear, q.shadowCameraFar);
				else {
					console.error("Unsupported light type for shadow");
					continue
				}
				j.add(q.shadowCamera);
				b.autoUpdateScene && j.updateMatrixWorld()
			}
			q.shadowCameraVisible && !q.cameraHelper && (q.cameraHelper = new THREE.CameraHelper(q.shadowCamera), q.shadowCamera.add(q.cameraHelper));
			if (q.isVirtual && z.originalCamera == l) {
				t = l;
				p = q.shadowCamera;
				u = q.pointsFrustum;
				s = q.pointsWorld;
				i.set(Infinity, Infinity, Infinity);
				k.set(-Infinity, -Infinity, -Infinity);
				for (x = 0; 8 > x; x++) v = s[x], v.copy(u[x]), THREE.ShadowMapPlugin.__projector.unprojectVector(v, t), p.matrixWorldInverse.multiplyVector3(v), v.x < i.x && (i.x = v.x), v.x > k.x && (k.x = v.x), v.y < i.y && (i.y = v.y), v.y > k.y && (k.y = v.y), v.z < i.z && (i.z = v.z), v.z > k.z && (k.z = v.z);
				p.left = i.x;
				p.right = k.x;
				p.top = k.y;
				p.bottom = i.y;
				p.updateProjectionMatrix()
			}
			p = q.shadowMap;
			u = q.shadowMatrix;
			t = q.shadowCamera;
			t.position.copy(q.matrixWorld.getPosition());
			t.lookAt(q.target.matrixWorld.getPosition());
			t.updateMatrixWorld();
			t.matrixWorldInverse.getInverse(t.matrixWorld);
			q.cameraHelper && (q.cameraHelper.visible = q.shadowCameraVisible);
			q.shadowCameraVisible && q.cameraHelper.update();
			u.set(0.5, 0, 0, 0.5, 0, 0.5, 0, 0.5, 0, 0, 0.5, 0.5, 0, 0, 0, 1);
			u.multiplySelf(t.projectionMatrix);
			u.multiplySelf(t.matrixWorldInverse);
			h.multiplyMatrices(t.projectionMatrix, t.matrixWorldInverse);
			g.setFromMatrix(h);
			b.setRenderTarget(p);
			b.clear();
			s = j.__webglObjects;
			q = 0;
			for (p = s.length; q < p; q++) if (x = s[q], u = x.object, x.render = !1, u.visible && u.castShadow && (!(u instanceof THREE.Mesh || u instanceof THREE.ParticleSystem) || !u.frustumCulled || g.contains(u))) u._modelViewMatrix.multiplyMatrices(t.matrixWorldInverse, u.matrixWorld), x.render = !0;
			q = 0;
			for (p = s.length; q < p; q++) x = s[q], x.render && (u = x.object, x = x.buffer, w = u.material instanceof THREE.MeshFaceMaterial ? u.material.materials[0] : u.material, v = 0 < u.geometry.morphTargets.length && w.morphTargets, w = u instanceof THREE.SkinnedMesh && w.skinning, v = u.customDepthMaterial ? u.customDepthMaterial : w ? v ? f : e : v ? d : c, x instanceof THREE.BufferGeometry ? b.renderBufferDirect(t, j.__lights, null, v, x, u) : b.renderBuffer(t, j.__lights, null, v, x, u));
			s = j.__webglObjectsImmediate;
			q = 0;
			for (p = s.length; q < p; q++) x = s[q], u = x.object, u.visible && u.castShadow && (u._modelViewMatrix.multiplyMatrices(t.matrixWorldInverse, u.matrixWorld), b.renderImmediateObject(t, j.__lights, null, c, u))
		}
		m = b.getClearColor();
		r = b.getClearAlpha();
		a.clearColor(m.r, m.g, m.b, r);
		a.enable(a.BLEND);
		b.shadowMapCullFace === THREE.CullFaceFront && a.cullFace(a.BACK)
	}
};
THREE.ShadowMapPlugin.__projector = new THREE.Projector;
THREE.SpritePlugin = function () {
	function a(a, b) {
		return a.z !== b.z ? b.z - a.z : b.id - a.id
	}
	var b, c, d, e, f, g, h, i, k, j;
	this.init = function (a) {
		b = a.context;
		c = a;
		d = a.getPrecision();
		e = new Float32Array(16);
		f = new Uint16Array(6);
		a = 0;
		e[a++] = -1;
		e[a++] = -1;
		e[a++] = 0;
		e[a++] = 0;
		e[a++] = 1;
		e[a++] = -1;
		e[a++] = 1;
		e[a++] = 0;
		e[a++] = 1;
		e[a++] = 1;
		e[a++] = 1;
		e[a++] = 1;
		e[a++] = -1;
		e[a++] = 1;
		e[a++] = 0;
		e[a++] = 1;
		a = 0;
		f[a++] = 0;
		f[a++] = 1;
		f[a++] = 2;
		f[a++] = 0;
		f[a++] = 2;
		f[a++] = 3;
		g = b.createBuffer();
		h = b.createBuffer();
		b.bindBuffer(b.ARRAY_BUFFER, g);
		b.bufferData(b.ARRAY_BUFFER,
		e, b.STATIC_DRAW);
		b.bindBuffer(b.ELEMENT_ARRAY_BUFFER, h);
		b.bufferData(b.ELEMENT_ARRAY_BUFFER, f, b.STATIC_DRAW);
		var a = THREE.ShaderSprite.sprite,
			m = b.createProgram(),
			r = b.createShader(b.FRAGMENT_SHADER),
			q = b.createShader(b.VERTEX_SHADER),
			p = "precision " + d + " float;\n";
		b.shaderSource(r, p + a.fragmentShader);
		b.shaderSource(q, p + a.vertexShader);
		b.compileShader(r);
		b.compileShader(q);
		b.attachShader(m, r);
		b.attachShader(m, q);
		b.linkProgram(m);
		i = m;
		k = {};
		j = {};
		k.position = b.getAttribLocation(i, "position");
		k.uv = b.getAttribLocation(i,
			"uv");
		j.uvOffset = b.getUniformLocation(i, "uvOffset");
		j.uvScale = b.getUniformLocation(i, "uvScale");
		j.rotation = b.getUniformLocation(i, "rotation");
		j.scale = b.getUniformLocation(i, "scale");
		j.alignment = b.getUniformLocation(i, "alignment");
		j.color = b.getUniformLocation(i, "color");
		j.map = b.getUniformLocation(i, "map");
		j.opacity = b.getUniformLocation(i, "opacity");
		j.useScreenCoordinates = b.getUniformLocation(i, "useScreenCoordinates");
		j.sizeAttenuation = b.getUniformLocation(i, "sizeAttenuation");
		j.screenPosition = b.getUniformLocation(i,
			"screenPosition");
		j.modelViewMatrix = b.getUniformLocation(i, "modelViewMatrix");
		j.projectionMatrix = b.getUniformLocation(i, "projectionMatrix");
		j.fogType = b.getUniformLocation(i, "fogType");
		j.fogDensity = b.getUniformLocation(i, "fogDensity");
		j.fogNear = b.getUniformLocation(i, "fogNear");
		j.fogFar = b.getUniformLocation(i, "fogFar");
		j.fogColor = b.getUniformLocation(i, "fogColor");
		j.alphaTest = b.getUniformLocation(i, "alphaTest")
	};
	this.render = function (d, e, f, q) {
		var p = d.__webglSprites,
			t = p.length;
		if (t) {
			var u = k,
				x = j,
				v = q / f,
				f = 0.5 * f,
				s = 0.5 * q;
			b.useProgram(i);
			b.enableVertexAttribArray(u.position);
			b.enableVertexAttribArray(u.uv);
			b.disable(b.CULL_FACE);
			b.enable(b.BLEND);
			b.bindBuffer(b.ARRAY_BUFFER, g);
			b.vertexAttribPointer(u.position, 2, b.FLOAT, !1, 16, 0);
			b.vertexAttribPointer(u.uv, 2, b.FLOAT, !1, 16, 8);
			b.bindBuffer(b.ELEMENT_ARRAY_BUFFER, h);
			b.uniformMatrix4fv(x.projectionMatrix, !1, e.projectionMatrix.elements);
			b.activeTexture(b.TEXTURE0);
			b.uniform1i(x.map, 0);
			var C = u = 0,
				z = d.fog;
			z ? (b.uniform3f(x.fogColor, z.color.r, z.color.g, z.color.b),
			z instanceof THREE.Fog ? (b.uniform1f(x.fogNear, z.near), b.uniform1f(x.fogFar, z.far), b.uniform1i(x.fogType, 1), C = u = 1) : z instanceof THREE.FogExp2 && (b.uniform1f(x.fogDensity, z.density), b.uniform1i(x.fogType, 2), C = u = 2)) : (b.uniform1i(x.fogType, 0), C = u = 0);
			for (var w, A, H = [], z = 0; z < t; z++) w = p[z], A = w.material, w.visible && 0 !== A.opacity && (A.useScreenCoordinates ? w.z = -w.position.z : (w._modelViewMatrix.multiplyMatrices(e.matrixWorldInverse, w.matrixWorld), w.z = -w._modelViewMatrix.elements[14]));
			p.sort(a);
			for (z = 0; z < t; z++) w = p[z], A = w.material, w.visible && 0 !== A.opacity && (A.map && A.map.image && A.map.image.width) && (b.uniform1f(x.alphaTest, A.alphaTest), !0 === A.useScreenCoordinates ? (b.uniform1i(x.useScreenCoordinates, 1), b.uniform3f(x.screenPosition, (w.position.x * c.devicePixelRatio - f) / f, (s - w.position.y * c.devicePixelRatio) / s, Math.max(0, Math.min(1, w.position.z))), H[0] = c.devicePixelRatio, H[1] = c.devicePixelRatio) : (b.uniform1i(x.useScreenCoordinates, 0), b.uniform1i(x.sizeAttenuation, A.sizeAttenuation ? 1 : 0), b.uniformMatrix4fv(x.modelViewMatrix, !1, w._modelViewMatrix.elements), H[0] = 1, H[1] = 1), e = d.fog && A.fog ? C : 0, u !== e && (b.uniform1i(x.fogType, e), u = e), e = 1 / (A.scaleByViewport ? q : 1), H[0] *= e * v * w.scale.x, H[1] *= e * w.scale.y, b.uniform2f(x.uvScale, A.uvScale.x, A.uvScale.y), b.uniform2f(x.uvOffset, A.uvOffset.x, A.uvOffset.y), b.uniform2f(x.alignment, A.alignment.x, A.alignment.y), b.uniform1f(x.opacity, A.opacity), b.uniform3f(x.color, A.color.r, A.color.g, A.color.b), b.uniform1f(x.rotation, w.rotation), b.uniform2fv(x.scale, H), c.setBlending(A.blending, A.blendEquation,
			A.blendSrc, A.blendDst), c.setDepthTest(A.depthTest), c.setDepthWrite(A.depthWrite), c.setTexture(A.map, 0), b.drawElements(b.TRIANGLES, 6, b.UNSIGNED_SHORT, 0));
			b.enable(b.CULL_FACE)
		}
	}
};
THREE.DepthPassPlugin = function () {
	this.enabled = !1;
	this.renderTarget = null;
	var a, b, c, d, e, f, g = new THREE.Frustum,
		h = new THREE.Matrix4;
	this.init = function (g) {
		a = g.context;
		b = g;
		var g = THREE.ShaderLib.depthRGBA,
			h = THREE.UniformsUtils.clone(g.uniforms);
		c = new THREE.ShaderMaterial({
			fragmentShader: g.fragmentShader,
			vertexShader: g.vertexShader,
			uniforms: h
		});
		d = new THREE.ShaderMaterial({
			fragmentShader: g.fragmentShader,
			vertexShader: g.vertexShader,
			uniforms: h,
			morphTargets: !0
		});
		e = new THREE.ShaderMaterial({
			fragmentShader: g.fragmentShader,
			vertexShader: g.vertexShader,
			uniforms: h,
			skinning: !0
		});
		f = new THREE.ShaderMaterial({
			fragmentShader: g.fragmentShader,
			vertexShader: g.vertexShader,
			uniforms: h,
			morphTargets: !0,
			skinning: !0
		});
		c._shadowPass = !0;
		d._shadowPass = !0;
		e._shadowPass = !0;
		f._shadowPass = !0
	};
	this.render = function (a, b) {
		this.enabled && this.update(a, b)
	};
	this.update = function (i, k) {
		var j, l, m, r, q, p;
		a.clearColor(1, 1, 1, 1);
		a.disable(a.BLEND);
		b.setDepthTest(!0);
		b.autoUpdateScene && i.updateMatrixWorld();
		k.matrixWorldInverse.getInverse(k.matrixWorld);
		h.multiplyMatrices(k.projectionMatrix,
		k.matrixWorldInverse);
		g.setFromMatrix(h);
		b.setRenderTarget(this.renderTarget);
		b.clear();
		p = i.__webglObjects;
		j = 0;
		for (l = p.length; j < l; j++) if (m = p[j], q = m.object, m.render = !1, q.visible && (!(q instanceof THREE.Mesh || q instanceof THREE.ParticleSystem) || !q.frustumCulled || g.contains(q))) q._modelViewMatrix.multiplyMatrices(k.matrixWorldInverse, q.matrixWorld), m.render = !0;
		var t;
		j = 0;
		for (l = p.length; j < l; j++) if (m = p[j], m.render && (q = m.object, m = m.buffer, !(q instanceof THREE.ParticleSystem) || q.customDepthMaterial))(t = q.material instanceof
		THREE.MeshFaceMaterial ? q.material.materials[0] : q.material) && b.setMaterialFaces(q.material), r = 0 < q.geometry.morphTargets.length && t.morphTargets, t = q instanceof THREE.SkinnedMesh && t.skinning, r = q.customDepthMaterial ? q.customDepthMaterial : t ? r ? f : e : r ? d : c, m instanceof THREE.BufferGeometry ? b.renderBufferDirect(k, i.__lights, null, r, m, q) : b.renderBuffer(k, i.__lights, null, r, m, q);
		p = i.__webglObjectsImmediate;
		j = 0;
		for (l = p.length; j < l; j++) m = p[j], q = m.object, q.visible && (q._modelViewMatrix.multiplyMatrices(k.matrixWorldInverse,
		q.matrixWorld), b.renderImmediateObject(k, i.__lights, null, c, q));
		j = b.getClearColor();
		l = b.getClearAlpha();
		a.clearColor(j.r, j.g, j.b, l);
		a.enable(a.BLEND)
	}
};
THREE.ShaderFlares = {
	lensFlareVertexTexture: {
		vertexShader: "uniform lowp int renderType;\nuniform vec3 screenPosition;\nuniform vec2 scale;\nuniform float rotation;\nuniform sampler2D occlusionMap;\nattribute vec2 position;\nattribute vec2 uv;\nvarying vec2 vUV;\nvarying float vVisibility;\nvoid main() {\nvUV = uv;\nvec2 pos = position;\nif( renderType == 2 ) {\nvec4 visibility = texture2D( occlusionMap, vec2( 0.1, 0.1 ) ) +\ntexture2D( occlusionMap, vec2( 0.5, 0.1 ) ) +\ntexture2D( occlusionMap, vec2( 0.9, 0.1 ) ) +\ntexture2D( occlusionMap, vec2( 0.9, 0.5 ) ) +\ntexture2D( occlusionMap, vec2( 0.9, 0.9 ) ) +\ntexture2D( occlusionMap, vec2( 0.5, 0.9 ) ) +\ntexture2D( occlusionMap, vec2( 0.1, 0.9 ) ) +\ntexture2D( occlusionMap, vec2( 0.1, 0.5 ) ) +\ntexture2D( occlusionMap, vec2( 0.5, 0.5 ) );\nvVisibility = (       visibility.r / 9.0 ) *\n( 1.0 - visibility.g / 9.0 ) *\n(       visibility.b / 9.0 ) *\n( 1.0 - visibility.a / 9.0 );\npos.x = cos( rotation ) * position.x - sin( rotation ) * position.y;\npos.y = sin( rotation ) * position.x + cos( rotation ) * position.y;\n}\ngl_Position = vec4( ( pos * scale + screenPosition.xy ).xy, screenPosition.z, 1.0 );\n}",
		fragmentShader: "uniform lowp int renderType;\nuniform sampler2D map;\nuniform float opacity;\nuniform vec3 color;\nvarying vec2 vUV;\nvarying float vVisibility;\nvoid main() {\nif( renderType == 0 ) {\ngl_FragColor = vec4( 1.0, 0.0, 1.0, 0.0 );\n} else if( renderType == 1 ) {\ngl_FragColor = texture2D( map, vUV );\n} else {\nvec4 texture = texture2D( map, vUV );\ntexture.a *= opacity * vVisibility;\ngl_FragColor = texture;\ngl_FragColor.rgb *= color;\n}\n}"
	},
	lensFlare: {
		vertexShader: "uniform lowp int renderType;\nuniform vec3 screenPosition;\nuniform vec2 scale;\nuniform float rotation;\nattribute vec2 position;\nattribute vec2 uv;\nvarying vec2 vUV;\nvoid main() {\nvUV = uv;\nvec2 pos = position;\nif( renderType == 2 ) {\npos.x = cos( rotation ) * position.x - sin( rotation ) * position.y;\npos.y = sin( rotation ) * position.x + cos( rotation ) * position.y;\n}\ngl_Position = vec4( ( pos * scale + screenPosition.xy ).xy, screenPosition.z, 1.0 );\n}",
		fragmentShader: "precision mediump float;\nuniform lowp int renderType;\nuniform sampler2D map;\nuniform sampler2D occlusionMap;\nuniform float opacity;\nuniform vec3 color;\nvarying vec2 vUV;\nvoid main() {\nif( renderType == 0 ) {\ngl_FragColor = vec4( texture2D( map, vUV ).rgb, 0.0 );\n} else if( renderType == 1 ) {\ngl_FragColor = texture2D( map, vUV );\n} else {\nfloat visibility = texture2D( occlusionMap, vec2( 0.5, 0.1 ) ).a +\ntexture2D( occlusionMap, vec2( 0.9, 0.5 ) ).a +\ntexture2D( occlusionMap, vec2( 0.5, 0.9 ) ).a +\ntexture2D( occlusionMap, vec2( 0.1, 0.5 ) ).a;\nvisibility = ( 1.0 - visibility / 4.0 );\nvec4 texture = texture2D( map, vUV );\ntexture.a *= opacity * visibility;\ngl_FragColor = texture;\ngl_FragColor.rgb *= color;\n}\n}"
	}
};
THREE.ShaderSprite = {
	sprite: {
		vertexShader: "uniform int useScreenCoordinates;\nuniform int sizeAttenuation;\nuniform vec3 screenPosition;\nuniform mat4 modelViewMatrix;\nuniform mat4 projectionMatrix;\nuniform float rotation;\nuniform vec2 scale;\nuniform vec2 alignment;\nuniform vec2 uvOffset;\nuniform vec2 uvScale;\nattribute vec2 position;\nattribute vec2 uv;\nvarying vec2 vUV;\nvoid main() {\nvUV = uvOffset + uv * uvScale;\nvec2 alignedPosition = position + alignment;\nvec2 rotatedPosition;\nrotatedPosition.x = ( cos( rotation ) * alignedPosition.x - sin( rotation ) * alignedPosition.y ) * scale.x;\nrotatedPosition.y = ( sin( rotation ) * alignedPosition.x + cos( rotation ) * alignedPosition.y ) * scale.y;\nvec4 finalPosition;\nif( useScreenCoordinates != 0 ) {\nfinalPosition = vec4( screenPosition.xy + rotatedPosition, screenPosition.z, 1.0 );\n} else {\nfinalPosition = projectionMatrix * modelViewMatrix * vec4( 0.0, 0.0, 0.0, 1.0 );\nfinalPosition.xy += rotatedPosition * ( sizeAttenuation == 1 ? 1.0 : finalPosition.z );\n}\ngl_Position = finalPosition;\n}",
		fragmentShader: "uniform vec3 color;\nuniform sampler2D map;\nuniform float opacity;\nuniform int fogType;\nuniform vec3 fogColor;\nuniform float fogDensity;\nuniform float fogNear;\nuniform float fogFar;\nuniform float alphaTest;\nvarying vec2 vUV;\nvoid main() {\nvec4 texture = texture2D( map, vUV );\nif ( texture.a < alphaTest ) discard;\ngl_FragColor = vec4( color * texture.xyz, texture.a * opacity );\nif ( fogType > 0 ) {\nfloat depth = gl_FragCoord.z / gl_FragCoord.w;\nfloat fogFactor = 0.0;\nif ( fogType == 1 ) {\nfogFactor = smoothstep( fogNear, fogFar, depth );\n} else {\nconst float LOG2 = 1.442695;\nfloat fogFactor = exp2( - fogDensity * fogDensity * depth * depth * LOG2 );\nfogFactor = 1.0 - clamp( fogFactor, 0.0, 1.0 );\n}\ngl_FragColor = mix( gl_FragColor, vec4( fogColor, gl_FragColor.w ), fogFactor );\n}\n}"
	}
};
THREE.FirstPersonControls = function (a, b) {
	function c(a, b) {
		return function () {
			b.apply(a, arguments)
		}
	}
	this.object = a;
	this.target = new THREE.Vector3(0, 0, 0);
	this.domElement = void 0 !== b ? b : document;
	this.movementSpeed = 1;
	this.lookSpeed = 0.005;
	this.lookVertical = !0;
	this.autoForward = !1;
	this.activeLook = !0;
	this.heightSpeed = !1;
	this.heightCoef = 1;
	this.heightMin = 0;
	this.heightMax = 1;
	this.constrainVertical = !1;
	this.verticalMin = 0;
	this.verticalMax = Math.PI;
	this.theta = this.phi = this.lon = this.lat = this.mouseY = this.mouseX = this.autoSpeedFactor = 0;
	this.mouseDragOn = this.freeze = this.moveRight = this.moveLeft = this.moveBackward = this.moveForward = !1;
	this.viewHalfY = this.viewHalfX = 0;
	this.domElement !== document && this.domElement.setAttribute("tabindex", -1);
	this.handleResize = function () {
		this.domElement === document ? (this.viewHalfX = window.innerWidth / 2, this.viewHalfY = window.innerHeight / 2) : (this.viewHalfX = this.domElement.offsetWidth / 2, this.viewHalfY = this.domElement.offsetHeight / 2)
	};
	this.onMouseDown = function (a) {
		this.domElement !== document && this.domElement.focus();
		a.preventDefault();
		a.stopPropagation();
		if (this.activeLook) switch (a.button) {
			case 0:
				this.moveForward = !0;
				break;
			case 2:
				this.moveBackward = !0
		}
		this.mouseDragOn = !0
	};
	this.onMouseUp = function (a) {
		a.preventDefault();
		a.stopPropagation();
		if (this.activeLook) switch (a.button) {
			case 0:
				this.moveForward = !1;
				break;
			case 2:
				this.moveBackward = !1
		}
		this.mouseDragOn = !1
	};
	this.onMouseMove = function (a) {
		this.domElement === document ? (this.mouseX = a.pageX - this.viewHalfX, this.mouseY = a.pageY - this.viewHalfY) : (this.mouseX = a.pageX - this.domElement.offsetLeft - this.viewHalfX, this.mouseY = a.pageY - this.domElement.offsetTop - this.viewHalfY)
	};
	this.onKeyDown = function (a) {
		switch (a.keyCode) {
			case 38:
			case 87:
				this.moveForward = !0;
				break;
			case 37:
			case 65:
				this.moveLeft = !0;
				break;
			case 40:
			case 83:
				this.moveBackward = !0;
				break;
			case 39:
			case 68:
				this.moveRight = !0;
				break;
			case 82:
				this.moveUp = !0;
				break;
			case 70:
				this.moveDown = !0;
				break;
			case 81:
				this.freeze = !this.freeze
		}
	};
	this.onKeyUp = function (a) {
		switch (a.keyCode) {
			case 38:
			case 87:
				this.moveForward = !1;
				break;
			case 37:
			case 65:
				this.moveLeft = !1;
				break;
			case 40:
			case 83:
				this.moveBackward = !1;
				break;
			case 39:
			case 68:
				this.moveRight = !1;
				break;
			case 82:
				this.moveUp = !1;
				break;
			case 70:
				this.moveDown = !1
		}
	};
	this.update = function (a) {
		var b = 0;
		if (!this.freeze) {
			this.heightSpeed ? (b = THREE.Math.clamp(this.object.position.y, this.heightMin, this.heightMax) - this.heightMin, this.autoSpeedFactor = a * b * this.heightCoef) : this.autoSpeedFactor = 0;
			b = a * this.movementSpeed;
			(this.moveForward || this.autoForward && !this.moveBackward) && this.object.translateZ(-(b + this.autoSpeedFactor));
			this.moveBackward && this.object.translateZ(b);
			this.moveLeft && this.object.translateX(-b);
			this.moveRight && this.object.translateX(b);
			this.moveUp && this.object.translateY(b);
			this.moveDown && this.object.translateY(-b);
			a *= this.lookSpeed;
			this.activeLook || (a = 0);
			this.lon += this.mouseX * a;
			this.lookVertical && (this.lat -= this.mouseY * a);
			this.lat = Math.max(-85, Math.min(85, this.lat));
			this.phi = THREE.Math.degToRad(90 - this.lat);
			this.theta = THREE.Math.degToRad(this.lon);
			var b = this.target,
				c = this.object.position;
			b.x = c.x + 100 * Math.sin(this.phi) * Math.cos(this.theta);
			b.y = c.y + 100 * Math.cos(this.phi);
			b.z = c.z + 100 * Math.sin(this.phi) * Math.sin(this.theta);
			b = 1;
			this.constrainVertical && (b = Math.PI / (this.verticalMax - this.verticalMin));
			this.lon += this.mouseX * a;
			this.lookVertical && (this.lat -= this.mouseY * a * b);
			this.lat = Math.max(-85, Math.min(85, this.lat));
			this.phi = THREE.Math.degToRad(90 - this.lat);
			this.theta = THREE.Math.degToRad(this.lon);
			this.constrainVertical && (this.phi = THREE.Math.mapLinear(this.phi, 0, Math.PI, this.verticalMin, this.verticalMax));
			b = this.target;
			c = this.object.position;
			b.x = c.x + 100 * Math.sin(this.phi) * Math.cos(this.theta);
			b.y = c.y + 100 * Math.cos(this.phi);
			b.z = c.z + 100 * Math.sin(this.phi) * Math.sin(this.theta);
			this.object.lookAt(b)
		}
	};
	this.domElement.addEventListener("contextmenu", function (a) {
		a.preventDefault()
	}, !1);
	this.domElement.addEventListener("mousemove", c(this, this.onMouseMove), !1);
	this.domElement.addEventListener("mousedown", c(this, this.onMouseDown), !1);
	this.domElement.addEventListener("mouseup", c(this, this.onMouseUp), !1);
	this.domElement.addEventListener("keydown",
	c(this, this.onKeyDown), !1);
	this.domElement.addEventListener("keyup", c(this, this.onKeyUp), !1);
	this.handleResize()
};
THREE.FlyControls = function (a, b) {
	function c(a, b) {
		return function () {
			b.apply(a, arguments)
		}
	}
	this.object = a;
	this.domElement = void 0 !== b ? b : document;
	b && this.domElement.setAttribute("tabindex", -1);
	this.movementSpeed = 1;
	this.rollSpeed = 0.005;
	this.autoForward = this.dragToLook = !1;
	this.object.useQuaternion = !0;
	this.tmpQuaternion = new THREE.Quaternion;
	this.mouseStatus = 0;
	this.moveState = {
		up: 0,
		down: 0,
		left: 0,
		right: 0,
		forward: 0,
		back: 0,
		pitchUp: 0,
		pitchDown: 0,
		yawLeft: 0,
		yawRight: 0,
		rollLeft: 0,
		rollRight: 0
	};
	this.moveVector = new THREE.Vector3(0,
	0, 0);
	this.rotationVector = new THREE.Vector3(0, 0, 0);
	this.handleEvent = function (a) {
		if ("function" == typeof this[a.type]) this[a.type](a)
	};
	this.keydown = function (a) {
		if (!a.altKey) {
			switch (a.keyCode) {
				case 16:
					this.movementSpeedMultiplier = 0.1;
					break;
				case 87:
					this.moveState.forward = 1;
					break;
				case 83:
					this.moveState.back = 1;
					break;
				case 65:
					this.moveState.left = 1;
					break;
				case 68:
					this.moveState.right = 1;
					break;
				case 82:
					this.moveState.up = 1;
					break;
				case 70:
					this.moveState.down = 1;
					break;
				case 38:
					this.moveState.pitchUp = 1;
					break;
				case 40:
					this.moveState.pitchDown = 1;
					break;
				case 37:
					this.moveState.yawLeft = 1;
					break;
				case 39:
					this.moveState.yawRight = 1;
					break;
				case 81:
					this.moveState.rollLeft = 1;
					break;
				case 69:
					this.moveState.rollRight = 1
			}
			this.updateMovementVector();
			this.updateRotationVector()
		}
	};
	this.keyup = function (a) {
		switch (a.keyCode) {
			case 16:
				this.movementSpeedMultiplier = 1;
				break;
			case 87:
				this.moveState.forward = 0;
				break;
			case 83:
				this.moveState.back = 0;
				break;
			case 65:
				this.moveState.left = 0;
				break;
			case 68:
				this.moveState.right = 0;
				break;
			case 82:
				this.moveState.up = 0;
				break;
			case 70:
				this.moveState.down = 0;
				break;
			case 38:
				this.moveState.pitchUp = 0;
				break;
			case 40:
				this.moveState.pitchDown = 0;
				break;
			case 37:
				this.moveState.yawLeft = 0;
				break;
			case 39:
				this.moveState.yawRight = 0;
				break;
			case 81:
				this.moveState.rollLeft = 0;
				break;
			case 69:
				this.moveState.rollRight = 0
		}
		this.updateMovementVector();
		this.updateRotationVector()
	};
	this.mousedown = function (a) {
		this.domElement !== document && this.domElement.focus();
		a.preventDefault();
		a.stopPropagation();
		if (this.dragToLook) this.mouseStatus++;
		else switch (a.button) {
			case 0:
				this.object.moveForward = !0;
				break;
			case 2:
				this.object.moveBackward = !0
		}
	};
	this.mousemove = function (a) {
		if (!this.dragToLook || 0 < this.mouseStatus) {
			var b = this.getContainerDimensions(),
				c = b.size[0] / 2,
				g = b.size[1] / 2;
			this.moveState.yawLeft = -(a.pageX - b.offset[0] - c) / c;
			this.moveState.pitchDown = (a.pageY - b.offset[1] - g) / g;
			this.updateRotationVector()
		}
	};
	this.mouseup = function (a) {
		a.preventDefault();
		a.stopPropagation();
		if (this.dragToLook) this.mouseStatus--, this.moveState.yawLeft = this.moveState.pitchDown = 0;
		else switch (a.button) {
			case 0:
				this.moveForward = !1;
				break;
			case 2:
				this.moveBackward = !1
		}
		this.updateRotationVector()
	};
	this.update = function (a) {
		var b = a * this.movementSpeed,
			a = a * this.rollSpeed;
		this.object.translateX(this.moveVector.x * b);
		this.object.translateY(this.moveVector.y * b);
		this.object.translateZ(this.moveVector.z * b);
		this.tmpQuaternion.set(this.rotationVector.x * a, this.rotationVector.y * a, this.rotationVector.z * a, 1).normalize();
		this.object.quaternion.multiplySelf(this.tmpQuaternion);
		this.object.matrix.setPosition(this.object.position);
		this.object.matrix.setRotationFromQuaternion(this.object.quaternion);
		this.object.matrixWorldNeedsUpdate = !0
	};
	this.updateMovementVector = function () {
		var a = this.moveState.forward || this.autoForward && !this.moveState.back ? 1 : 0;
		this.moveVector.x = -this.moveState.left + this.moveState.right;
		this.moveVector.y = -this.moveState.down + this.moveState.up;
		this.moveVector.z = -a + this.moveState.back
	};
	this.updateRotationVector = function () {
		this.rotationVector.x = -this.moveState.pitchDown + this.moveState.pitchUp;
		this.rotationVector.y = -this.moveState.yawRight + this.moveState.yawLeft;
		this.rotationVector.z = -this.moveState.rollRight + this.moveState.rollLeft
	};
	this.getContainerDimensions = function () {
		return this.domElement != document ? {
			size: [this.domElement.offsetWidth, this.domElement.offsetHeight],
			offset: [this.domElement.offsetLeft, this.domElement.offsetTop]
		} : {
			size: [window.innerWidth, window.innerHeight],
			offset: [0, 0]
		}
	};
	this.domElement.addEventListener("mousemove", c(this, this.mousemove), !1);
	this.domElement.addEventListener("mousedown", c(this, this.mousedown), !1);
	this.domElement.addEventListener("mouseup", c(this,
	this.mouseup), !1);
	this.domElement.addEventListener("keydown", c(this, this.keydown), !1);
	this.domElement.addEventListener("keyup", c(this, this.keyup), !1);
	this.updateMovementVector();
	this.updateRotationVector()
};
THREE.OrbitControls = function (a, b) {
	function c() {
		return 2 * Math.PI / 60 / 60 * f.autoRotateSpeed
	}
	function d(a) {
		a.preventDefault();
		x === u.ROTATE ? (i.set(a.clientX, a.clientY), k.sub(i, h), f.rotateLeft(2 * Math.PI * k.x / g * f.userRotateSpeed), f.rotateUp(2 * Math.PI * k.y / g * f.userRotateSpeed), h.copy(i)) : x === u.ZOOM && (l.set(a.clientX, a.clientY), m.sub(l, j), 0 < m.y ? f.zoomIn() : f.zoomOut(), j.copy(l))
	}
	function e() {
		f.userRotate && (document.removeEventListener("mousemove", d, !1), document.removeEventListener("mouseup", e, !1), x = u.NONE)
	}
	THREE.EventDispatcher.call(this);
	this.object = a;
	this.domElement = void 0 !== b ? b : document;
	this.center = new THREE.Vector3;
	this.userZoom = !0;
	this.userZoomSpeed = 1;
	this.userRotate = !0;
	this.userRotateSpeed = 1;
	this.autoRotate = !1;
	this.autoRotateSpeed = 2;
	this.minPolarAngle = 0;
	this.maxPolarAngle = Math.PI;
	this.minDistance = 0;
	this.maxDistance = Infinity;
	var f = this,
		g = 1800,
		h = new THREE.Vector2,
		i = new THREE.Vector2,
		k = new THREE.Vector2,
		j = new THREE.Vector2,
		l = new THREE.Vector2,
		m = new THREE.Vector2,
		r = 0,
		q = 0,
		p = 1,
		t = new THREE.Vector3,
		u = {
			NONE: -1,
			ROTATE: 0,
			ZOOM: 1
		}, x = u.NONE,
		v = {
			type: "change"
		};
	this.rotateLeft = function (a) {
		void 0 === a && (a = c());
		q -= a
	};
	this.rotateRight = function (a) {
		void 0 === a && (a = c());
		q += a
	};
	this.rotateUp = function (a) {
		void 0 === a && (a = c());
		r -= a
	};
	this.rotateDown = function (a) {
		void 0 === a && (a = c());
		r += a
	};
	this.zoomIn = function (a) {
		void 0 === a && (a = Math.pow(0.95, f.userZoomSpeed));
		p /= a
	};
	this.zoomOut = function (a) {
		void 0 === a && (a = Math.pow(0.95, f.userZoomSpeed));
		p *= a
	};
	this.update = function () {
		var a = this.object.position,
			b = a.clone().sub(this.center),
			d = Math.atan2(b.x, b.z),
			e = Math.atan2(Math.sqrt(b.x * b.x + b.z * b.z), b.y);
		this.autoRotate && this.rotateLeft(c());
		var d = d + q,
			e = e + r,
			e = Math.max(this.minPolarAngle, Math.min(this.maxPolarAngle, e)),
			e = Math.max(1E-6, Math.min(Math.PI - 1E-6, e)),
			f = b.length() * p,
			f = Math.max(this.minDistance, Math.min(this.maxDistance, f));
		b.x = f * Math.sin(e) * Math.sin(d);
		b.y = f * Math.cos(e);
		b.z = f * Math.sin(e) * Math.cos(d);
		a.copy(this.center).add(b);
		this.object.lookAt(this.center);
		r = q = 0;
		p = 1;
		0 < t.distanceTo(this.object.position) && (this.dispatchEvent(v), t.copy(this.object.position))
	};
	this.domElement.addEventListener("contextmenu",

	function (a) {
		a.preventDefault()
	}, !1);
	this.domElement.addEventListener("mousedown", function (a) {
		f.userRotate && (a.preventDefault(), 0 === a.button || 2 === a.button ? (x = u.ROTATE, h.set(a.clientX, a.clientY)) : 1 === a.button && (x = u.ZOOM, j.set(a.clientX, a.clientY)), document.addEventListener("mousemove", d, !1), document.addEventListener("mouseup", e, !1))
	}, !1);
	this.domElement.addEventListener("mousewheel", function (a) {
		f.userZoom && (0 < a.wheelDelta ? f.zoomOut() : f.zoomIn())
	}, !1)
};
THREE.PathControls = function (a, b) {
	function c(a) {
		return 1 > (a *= 2) ? 0.5 * a * a : -0.5 * (--a * (a - 2) - 1)
	}
	function d(a, b) {
		return function () {
			b.apply(a, arguments)
		}
	}
	function e(a, b, c, d) {
		var e = {
			name: c,
			fps: 0.6,
			length: d,
			hierarchy: []
		}, f, g = b.getControlPointsArray(),
			q = b.getLength(),
			p = g.length,
			t = 0;
		f = p - 1;
		b = {
			parent: -1,
			keys: []
		};
		b.keys[0] = {
			time: 0,
			pos: g[0],
			rot: [0, 0, 0, 1],
			scl: [1, 1, 1]
		};
		b.keys[f] = {
			time: d,
			pos: g[f],
			rot: [0, 0, 0, 1],
			scl: [1, 1, 1]
		};
		for (f = 1; f < p - 1; f++) t = d * q.chunks[f] / q.total, b.keys[f] = {
			time: t,
			pos: g[f]
		};
		e.hierarchy[0] = b;
		THREE.AnimationHandler.add(e);
		return new THREE.Animation(a, c, THREE.AnimationHandler.CATMULLROM_FORWARD, !1)
	}
	function f(a, b) {
		var c, d, e = new THREE.Geometry;
		for (c = 0; c < a.points.length * b; c++) d = c / (a.points.length * b), d = a.getPoint(d), e.vertices[c] = new THREE.Vector3(d.x, d.y, d.z);
		return e
	}
	this.object = a;
	this.domElement = void 0 !== b ? b : document;
	this.id = "PathControls" + THREE.PathControlsIdCounter++;
	this.duration = 1E4;
	this.waypoints = [];
	this.useConstantSpeed = !0;
	this.resamplingCoef = 50;
	this.debugPath = new THREE.Object3D;
	this.debugDummy = new THREE.Object3D;
	this.animationParent = new THREE.Object3D;
	this.lookSpeed = 0.005;
	this.lookHorizontal = this.lookVertical = !0;
	this.verticalAngleMap = {
		srcRange: [0, 2 * Math.PI],
		dstRange: [0, 2 * Math.PI]
	};
	this.horizontalAngleMap = {
		srcRange: [0, 2 * Math.PI],
		dstRange: [0, 2 * Math.PI]
	};
	this.target = new THREE.Object3D;
	this.theta = this.phi = this.lon = this.lat = this.mouseY = this.mouseX = 0;
	var g = 2 * Math.PI;
	this.viewHalfY = this.viewHalfX = 0;
	this.domElement !== document && this.domElement.setAttribute("tabindex", -1);
	this.handleResize = function () {
		this.domElement === document ? (this.viewHalfX = window.innerWidth / 2, this.viewHalfY = window.innerHeight / 2) : (this.viewHalfX = this.domElement.offsetWidth / 2, this.viewHalfY = this.domElement.offsetHeight / 2)
	};
	this.update = function (a) {
		var b;
		this.lookHorizontal && (this.lon += this.mouseX * this.lookSpeed * a);
		this.lookVertical && (this.lat -= this.mouseY * this.lookSpeed * a);
		this.lon = Math.max(0, Math.min(360, this.lon));
		this.lat = Math.max(-85, Math.min(85, this.lat));
		this.phi = THREE.Math.degToRad(90 - this.lat);
		this.theta = THREE.Math.degToRad(this.lon);
		a = this.phi % g;
		this.phi = 0 <= a ? a : a + g;
		b = this.verticalAngleMap.srcRange;
		a = this.verticalAngleMap.dstRange;
		b = THREE.Math.mapLinear(this.phi, b[0], b[1], a[0], a[1]);
		var d = a[1] - a[0];
		this.phi = c((b - a[0]) / d) * d + a[0];
		b = this.horizontalAngleMap.srcRange;
		a = this.horizontalAngleMap.dstRange;
		b = THREE.Math.mapLinear(this.theta, b[0], b[1], a[0], a[1]);
		d = a[1] - a[0];
		this.theta = c((b - a[0]) / d) * d + a[0];
		a = this.target.position;
		a.x = 100 * Math.sin(this.phi) * Math.cos(this.theta);
		a.y = 100 * Math.cos(this.phi);
		a.z = 100 * Math.sin(this.phi) * Math.sin(this.theta);
		this.object.lookAt(this.target.position)
	};
	this.onMouseMove = function (a) {
		this.domElement === document ? (this.mouseX = a.pageX - this.viewHalfX, this.mouseY = a.pageY - this.viewHalfY) : (this.mouseX = a.pageX - this.domElement.offsetLeft - this.viewHalfX, this.mouseY = a.pageY - this.domElement.offsetTop - this.viewHalfY)
	};
	this.init = function () {
		this.spline = new THREE.Spline;
		this.spline.initFromArray(this.waypoints);
		this.useConstantSpeed && this.spline.reparametrizeByArcLength(this.resamplingCoef);
		if (this.createDebugDummy) {
			var a = new THREE.MeshLambertMaterial({
				color: 30719
			}),
				b = new THREE.MeshLambertMaterial({
					color: 65280
				}),
				c = new THREE.CubeGeometry(10, 10, 20),
				g = new THREE.CubeGeometry(2, 2, 10);
			this.animationParent = new THREE.Mesh(c, a);
			a = new THREE.Mesh(g, b);
			a.position.set(0, 10, 0);
			this.animation = e(this.animationParent, this.spline, this.id, this.duration);
			this.animationParent.add(this.object);
			this.animationParent.add(this.target);
			this.animationParent.add(a)
		} else this.animation = e(this.animationParent, this.spline, this.id, this.duration),
		this.animationParent.add(this.target), this.animationParent.add(this.object);
		if (this.createDebugPath) {
			var a = this.debugPath,
				b = this.spline,
				g = f(b, 10),
				c = f(b, 10),
				l = new THREE.LineBasicMaterial({
					color: 16711680,
					linewidth: 3
				}),
				g = new THREE.Line(g, l),
				c = new THREE.ParticleSystem(c, new THREE.ParticleBasicMaterial({
					color: 16755200,
					size: 3
				}));
			g.scale.set(1, 1, 1);
			a.add(g);
			c.scale.set(1, 1, 1);
			a.add(c);
			for (var g = new THREE.SphereGeometry(1, 16, 8), l = new THREE.MeshBasicMaterial({
				color: 65280
			}), m = 0; m < b.points.length; m++) c = new THREE.Mesh(g,
			l), c.position.copy(b.points[m]), a.add(c)
		}
		this.domElement.addEventListener("mousemove", d(this, this.onMouseMove), !1)
	};
	this.handleResize()
};
THREE.PathControlsIdCounter = 0;
THREE.PointerLockControls = function (a) {
	var b = this,
		c = new THREE.Object3D;
	c.add(a);
	var d = new THREE.Object3D;
	d.position.y = 10;
	d.add(c);
	var e = !1,
		f = !1,
		g = !1,
		h = !1,
		i = !1,
		k = !1,
		j = new THREE.Vector3,
		l = Math.PI / 2;
	document.addEventListener("mousemove", function (a) {
		if (!1 !== b.enabled) {
			var e = a.movementY || a.mozMovementY || a.webkitMovementY || 0;
			d.rotation.y -= 0.002 * (a.movementX || a.mozMovementX || a.webkitMovementX || 0);
			c.rotation.x -= 0.002 * e;
			c.rotation.x = Math.max(-l, Math.min(l, c.rotation.x))
		}
	}, !1);
	document.addEventListener("keydown",

	function (a) {
		switch (a.keyCode) {
			case 38:
			case 87:
				e = !0;
				break;
			case 37:
			case 65:
				g = !0;
				break;
			case 40:
			case 83:
				f = !0;
				break;
			case 39:
			case 68:
				h = !0;
				break;
			case 32:
				!0 === k && (j.y += 10), k = !1
		}
	}, !1);
	document.addEventListener("keyup", function (a) {
		switch (a.keyCode) {
			case 38:
			case 87:
				e = !1;
				break;
			case 37:
			case 65:
				g = !1;
				break;
			case 40:
			case 83:
				f = !1;
				break;
			case 39:
			case 68:
				h = !1
		}
	}, !1);
	this.enabled = !1;
	this.getObject = function () {
		return d
	};
	this.isOnObject = function (a) {
		k = i = a
	};
	this.update = function (a) {
		!1 !== b.enabled && (a *= 0.1, j.x += 0.08 * -j.x * a, j.z += 0.08 * -j.z * a, j.y -= 0.25 * a, e && (j.z -= 0.12 * a), f && (j.z += 0.12 * a), g && (j.x -= 0.12 * a), h && (j.x += 0.12 * a), !0 === i && (j.y = Math.max(0, j.y)), d.translateX(j.x), d.translateY(j.y), d.translateZ(j.z), 10 > d.position.y && (j.y = 0, d.position.y = 10, k = !0))
	}
};
THREE.RollControls = function (a, b) {
	this.object = a;
	this.domElement = void 0 !== b ? b : document;
	this.mouseLook = !0;
	this.autoForward = !1;
	this.rollSpeed = this.movementSpeed = this.lookSpeed = 1;
	this.constrainVertical = [-0.9, 0.9];
	this.object.matrixAutoUpdate = !1;
	this.forward = new THREE.Vector3(0, 0, 1);
	this.roll = 0;
	var c = new THREE.Vector3,
		d = new THREE.Vector3,
		e = new THREE.Vector3,
		f = new THREE.Matrix4,
		g = !1,
		h = 1,
		i = 0,
		k = 0,
		j = 0,
		l = 0,
		m = 0,
		r = 0,
		q = 0;
	this.handleResize = function () {
		r = window.innerWidth / 2;
		q = window.innerHeight / 2
	};
	this.update = function (a) {
		if (this.mouseLook) {
			var b = a * this.lookSpeed;
			this.rotateHorizontally(b * l);
			this.rotateVertically(b * m)
		}
		b = a * this.movementSpeed;
		this.object.translateZ(-b * (0 < i || this.autoForward && !(0 > i) ? 1 : i));
		this.object.translateX(b * k);
		this.object.translateY(b * j);
		g && (this.roll += this.rollSpeed * a * h);
		this.forward.y > this.constrainVertical[1] ? (this.forward.y = this.constrainVertical[1], this.forward.normalize()) : this.forward.y < this.constrainVertical[0] && (this.forward.y = this.constrainVertical[0], this.forward.normalize());
		e.copy(this.forward);
		d.set(0, 1, 0);
		c.cross(d, e).normalize();
		d.cross(e, c).normalize();
		this.object.matrix.elements[0] = c.x;
		this.object.matrix.elements[4] = d.x;
		this.object.matrix.elements[8] = e.x;
		this.object.matrix.elements[1] = c.y;
		this.object.matrix.elements[5] = d.y;
		this.object.matrix.elements[9] = e.y;
		this.object.matrix.elements[2] = c.z;
		this.object.matrix.elements[6] = d.z;
		this.object.matrix.elements[10] = e.z;
		f.identity();
		f.elements[0] = Math.cos(this.roll);
		f.elements[4] = -Math.sin(this.roll);
		f.elements[1] = Math.sin(this.roll);
		f.elements[5] = Math.cos(this.roll);
		this.object.matrix.multiplySelf(f);
		this.object.matrixWorldNeedsUpdate = !0;
		this.object.matrix.elements[12] = this.object.position.x;
		this.object.matrix.elements[13] = this.object.position.y;
		this.object.matrix.elements[14] = this.object.position.z
	};
	this.translateX = function (a) {
		this.object.position.x += this.object.matrix.elements[0] * a;
		this.object.position.y += this.object.matrix.elements[1] * a;
		this.object.position.z += this.object.matrix.elements[2] * a
	};
	this.translateY = function (a) {
		this.object.position.x += this.object.matrix.elements[4] * a;
		this.object.position.y += this.object.matrix.elements[5] * a;
		this.object.position.z += this.object.matrix.elements[6] * a
	};
	this.translateZ = function (a) {
		this.object.position.x -= this.object.matrix.elements[8] * a;
		this.object.position.y -= this.object.matrix.elements[9] * a;
		this.object.position.z -= this.object.matrix.elements[10] * a
	};
	this.rotateHorizontally = function (a) {
		c.set(this.object.matrix.elements[0], this.object.matrix.elements[1], this.object.matrix.elements[2]);
		c.multiplyScalar(a);
		this.forward.sub(c);
		this.forward.normalize()
	};
	this.rotateVertically = function (a) {
		d.set(this.object.matrix.elements[4], this.object.matrix.elements[5], this.object.matrix.elements[6]);
		d.multiplyScalar(a);
		this.forward.add(d);
		this.forward.normalize()
	};
	this.domElement.addEventListener("contextmenu", function (a) {
		a.preventDefault()
	}, !1);
	this.domElement.addEventListener("mousemove", function (a) {
		l = (a.clientX - r) / window.innerWidth;
		m = (a.clientY - q) / window.innerHeight
	}, !1);
	this.domElement.addEventListener("mousedown", function (a) {
		a.preventDefault();
		a.stopPropagation();
		switch (a.button) {
			case 0:
				i = 1;
				break;
			case 2:
				i = -1
		}
	}, !1);
	this.domElement.addEventListener("mouseup", function (a) {
		a.preventDefault();
		a.stopPropagation();
		switch (a.button) {
			case 0:
				i = 0;
				break;
			case 2:
				i = 0
		}
	}, !1);
	this.domElement.addEventListener("keydown", function (a) {
		switch (a.keyCode) {
			case 38:
			case 87:
				i = 1;
				break;
			case 37:
			case 65:
				k = -1;
				break;
			case 40:
			case 83:
				i = -1;
				break;
			case 39:
			case 68:
				k = 1;
				break;
			case 81:
				g = !0;
				h = 1;
				break;
			case 69:
				g = !0;
				h = -1;
				break;
			case 82:
				j = 1;
				break;
			case 70:
				j = -1
		}
	}, !1);
	this.domElement.addEventListener("keyup",

	function (a) {
		switch (a.keyCode) {
			case 38:
			case 87:
				i = 0;
				break;
			case 37:
			case 65:
				k = 0;
				break;
			case 40:
			case 83:
				i = 0;
				break;
			case 39:
			case 68:
				k = 0;
				break;
			case 81:
				g = !1;
				break;
			case 69:
				g = !1;
				break;
			case 82:
				j = 0;
				break;
			case 70:
				j = 0
		}
	}, !1);
	this.handleResize()
};
THREE.TrackballControls = function (a, b) {
	function c(a) {
		h.enabled && (window.removeEventListener("keydown", c), l = j, j === i.NONE && (a.keyCode === h.keys[i.ROTATE] && !h.noRotate ? j = i.ROTATE : a.keyCode === h.keys[i.ZOOM] && !h.noZoom ? j = i.ZOOM : a.keyCode === h.keys[i.PAN] && !h.noPan && (j = i.PAN)))
	}
	function d(a) {
		h.enabled && (j === i.ROTATE && !h.noRotate ? q = h.getMouseProjectionOnBall(a.clientX, a.clientY) : j === i.ZOOM && !h.noZoom ? t = h.getMouseOnScreen(a.clientX, a.clientY) : j === i.PAN && !h.noPan && (x = h.getMouseOnScreen(a.clientX, a.clientY)))
	}

	function e(a) {
		h.enabled && (a.preventDefault(), a.stopPropagation(), j = i.NONE, document.removeEventListener("mousemove", d), document.removeEventListener("mouseup", e))
	}
	function f(a) {
		if (h.enabled) {
			a.preventDefault();
			a.stopPropagation();
			var b = 0;
			a.wheelDelta ? b = a.wheelDelta / 40 : a.detail && (b = -a.detail / 3);
			p.y += 0.05 * (1 / b)
		}
	}
	function g(a) {
		if (h.enabled) switch (a.preventDefault(), a.touches.length) {
			case 1:
				r = q = h.getMouseProjectionOnBall(a.touches[0].pageX, a.touches[0].pageY);
				break;
			case 2:
				p = t = h.getMouseOnScreen(a.touches[0].pageX,
				a.touches[0].pageY);
				break;
			case 3:
				u = x = h.getMouseOnScreen(a.touches[0].pageX, a.touches[0].pageY)
		}
	}
	THREE.EventDispatcher.call(this);
	var h = this,
		i = {
			NONE: -1,
			ROTATE: 0,
			ZOOM: 1,
			PAN: 2
		};
	this.object = a;
	this.domElement = void 0 !== b ? b : document;
	this.enabled = !0;
	this.screen = {
		width: 0,
		height: 0,
		offsetLeft: 0,
		offsetTop: 0
	};
	this.radius = (this.screen.width + this.screen.height) / 4;
	this.rotateSpeed = 1;
	this.zoomSpeed = 1.2;
	this.panSpeed = 0.3;
	this.staticMoving = this.noPan = this.noZoom = this.noRotate = !1;
	this.dynamicDampingFactor = 0.2;
	this.minDistance = 0;
	this.maxDistance = Infinity;
	this.keys = [65, 83, 68];
	this.target = new THREE.Vector3;
	var k = new THREE.Vector3,
		j = i.NONE,
		l = i.NONE,
		m = new THREE.Vector3,
		r = new THREE.Vector3,
		q = new THREE.Vector3,
		p = new THREE.Vector2,
		t = new THREE.Vector2,
		u = new THREE.Vector2,
		x = new THREE.Vector2,
		v = {
			type: "change"
		};
	this.handleResize = function () {
		this.screen.width = window.innerWidth;
		this.screen.height = window.innerHeight;
		this.screen.offsetLeft = 0;
		this.screen.offsetTop = 0;
		this.radius = (this.screen.width + this.screen.height) / 4
	};
	this.handleEvent = function (a) {
		if ("function" == typeof this[a.type]) this[a.type](a)
	};
	this.getMouseOnScreen = function (a, b) {
		return new THREE.Vector2(0.5 * ((a - h.screen.offsetLeft) / h.radius), 0.5 * ((b - h.screen.offsetTop) / h.radius))
	};
	this.getMouseProjectionOnBall = function (a, b) {
		var c = new THREE.Vector3((a - 0.5 * h.screen.width - h.screen.offsetLeft) / h.radius, (0.5 * h.screen.height + h.screen.offsetTop - b) / h.radius, 0),
			d = c.length();
		1 < d ? c.normalize() : c.z = Math.sqrt(1 - d * d);
		m.copy(h.object.position).sub(h.target);
		d = h.object.up.clone().setLength(c.y);
		d.add(h.object.up.clone().crossSelf(m).setLength(c.x));
		d.add(m.setLength(c.z));
		return d
	};
	this.rotateCamera = function () {
		var a = Math.acos(r.dot(q) / r.length() / q.length());
		if (a) {
			var b = (new THREE.Vector3).cross(r, q).normalize(),
				c = new THREE.Quaternion,
				a = a * h.rotateSpeed;
			c.setFromAxisAngle(b, -a);
			c.multiplyVector3(m);
			c.multiplyVector3(h.object.up);
			c.multiplyVector3(q);
			h.staticMoving ? r.copy(q) : (c.setFromAxisAngle(b, a * (h.dynamicDampingFactor - 1)), c.multiplyVector3(r))
		}
	};
	this.zoomCamera = function () {
		var a = 1 + (t.y - p.y) * h.zoomSpeed;
		1 !== a && 0 < a && (m.multiplyScalar(a), h.staticMoving ? p.copy(t) : p.y += (t.y - p.y) * this.dynamicDampingFactor)
	};
	this.panCamera = function () {
		var a = x.clone().sub(u);
		if (a.lengthSq()) {
			a.multiplyScalar(m.length() * h.panSpeed);
			var b = m.clone().crossSelf(h.object.up).setLength(a.x);
			b.add(h.object.up.clone().setLength(a.y));
			h.object.position.add(b);
			h.target.add(b);
			h.staticMoving ? u = x : u.add(a.sub(x, u).multiplyScalar(h.dynamicDampingFactor))
		}
	};
	this.checkDistances = function () {
		if (!h.noZoom || !h.noPan) h.object.position.lengthSq() > h.maxDistance * h.maxDistance && h.object.position.setLength(h.maxDistance), m.lengthSq() < h.minDistance * h.minDistance && h.object.position.add(h.target, m.setLength(h.minDistance))
	};
	this.update = function () {
		m.copy(h.object.position).sub(h.target);
		h.noRotate || h.rotateCamera();
		h.noZoom || h.zoomCamera();
		h.noPan || h.panCamera();
		h.object.position.add(h.target, m);
		h.checkDistances();
		h.object.lookAt(h.target);
		0 < k.distanceToSquared(h.object.position) && (h.dispatchEvent(v), k.copy(h.object.position))
	};
	this.domElement.addEventListener("contextmenu", function (a) {
		a.preventDefault()
	}, !1);
	this.domElement.addEventListener("mousedown", function (a) {
		h.enabled && (a.preventDefault(), a.stopPropagation(), j === i.NONE && (j = a.button), j === i.ROTATE && !h.noRotate ? r = q = h.getMouseProjectionOnBall(a.clientX, a.clientY) : j === i.ZOOM && !h.noZoom ? p = t = h.getMouseOnScreen(a.clientX, a.clientY) : j === i.PAN && !h.noPan && (u = x = h.getMouseOnScreen(a.clientX, a.clientY)), document.addEventListener("mousemove", d, !1), document.addEventListener("mouseup",
		e, !1))
	}, !1);
	this.domElement.addEventListener("mousewheel", f, !1);
	this.domElement.addEventListener("DOMMouseScroll", f, !1);
	this.domElement.addEventListener("touchstart", g, !1);
	this.domElement.addEventListener("touchend", g, !1);
	this.domElement.addEventListener("touchmove", function (a) {
		if (h.enabled) switch (a.preventDefault(), a.touches.length) {
			case 1:
				q = h.getMouseProjectionOnBall(a.touches[0].pageX, a.touches[0].pageY);
				break;
			case 2:
				t = h.getMouseOnScreen(a.touches[0].pageX, a.touches[0].pageY);
				break;
			case 3:
				x = h.getMouseOnScreen(a.touches[0].pageX,
				a.touches[0].pageY)
		}
	}, !1);
	window.addEventListener("keydown", c, !1);
	window.addEventListener("keyup", function () {
		h.enabled && (j = l, window.addEventListener("keydown", c, !1))
	}, !1);
	this.handleResize()
};
THREE.AnaglyphEffect = function (a, b, c) {
	var d = new THREE.Matrix4,
		e = new THREE.Matrix4,
		f, g, h, i, k = new THREE.PerspectiveCamera;
	k.matrixAutoUpdate = !1;
	var j = new THREE.PerspectiveCamera;
	j.matrixAutoUpdate = !1;
	var l = new THREE.OrthographicCamera(-1, 1, 1, -1, 0, 1),
		m = new THREE.Scene,
		r = {
			minFilter: THREE.LinearFilter,
			magFilter: THREE.NearestFilter,
			format: THREE.RGBAFormat
		};
	void 0 === b && (b = 512);
	void 0 === c && (c = 512);
	var q = new THREE.WebGLRenderTarget(b, c, r),
		p = new THREE.WebGLRenderTarget(b, c, r),
		t = new THREE.ShaderMaterial({
			uniforms: {
				mapLeft: {
					type: "t",
					value: q
				},
				mapRight: {
					type: "t",
					value: p
				}
			},
			vertexShader: "varying vec2 vUv;\nvoid main() {\n\tvUv = vec2( uv.x, uv.y );\n\tgl_Position = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );\n}",
			fragmentShader: "uniform sampler2D mapLeft;\nuniform sampler2D mapRight;\nvarying vec2 vUv;\nvoid main() {\n\tvec4 colorL, colorR;\n\tvec2 uv = vUv;\n\tcolorL = texture2D( mapLeft, uv );\n\tcolorR = texture2D( mapRight, uv );\n\tgl_FragColor = vec4( colorL.g * 0.7 + colorL.b * 0.3, colorR.g, colorR.b, colorL.a + colorR.a ) * 1.1;\n}"
		}),
		b = new THREE.Mesh(new THREE.PlaneGeometry(2, 2), t);
	m.add(b);
	this.setSize = function (b, c) {
		q = new THREE.WebGLRenderTarget(b, c, r);
		p = new THREE.WebGLRenderTarget(b, c, r);
		t.uniforms.mapLeft.value = q;
		t.uniforms.mapRight.value = p;
		a.setSize(b, c)
	};
	this.render = function (b, c) {
		b.updateMatrixWorld();
		void 0 === c.parent && c.updateMatrixWorld();
		if (f !== c.aspect || g !== c.near || h !== c.far || i !== c.fov) {
			f = c.aspect;
			g = c.near;
			h = c.far;
			i = c.fov;
			var r = c.projectionMatrix.clone(),
				s = 0.5 * (125 / 30),
				t = s * g / 125,
				z = g * Math.tan(THREE.Math.degToRad(0.5 * i)),
				w;
			d.elements[12] = s;
			e.elements[12] = -s;
			s = -z * f + t;
			w = z * f + t;
			r.elements[0] = 2 * g / (w - s);
			r.elements[8] = (w + s) / (w - s);
			k.projectionMatrix.copy(r);
			s = -z * f - t;
			w = z * f - t;
			r.elements[0] = 2 * g / (w - s);
			r.elements[8] = (w + s) / (w - s);
			j.projectionMatrix.copy(r)
		}
		k.matrixWorld.copy(c.matrixWorld).multiplySelf(e);
		k.position.copy(c.position);
		k.near = c.near;
		k.far = c.far;
		a.render(b, k, q, !0);
		j.matrixWorld.copy(c.matrixWorld).multiplySelf(d);
		j.position.copy(c.position);
		j.near = c.near;
		j.far = c.far;
		a.render(b, j, p, !0);
		a.render(m, l)
	}
};
THREE.AsciiEffect = function (a, b, c) {
	b = void 0 === b ? " .:-=+*#%@" : b;
	c || (c = {});
	var d = !c.resolution ? 0.15 : c.resolution,
		e = !c.scale ? 1 : c.scale,
		f = !c.color ? !1 : c.color,
		g = !c.alpha ? !1 : c.alpha,
		h = !c.block ? !1 : c.block,
		i = !c.invert ? !1 : c.invert,
		k, j, c = document.createElement("div");
	c.style.cursor = "default";
	var l = document.createElement("table");
	c.appendChild(l);
	var m, r, q;
	this.setSize = function (b, c) {
		k = b;
		j = c;
		a.setSize(b, c);
		m = Math.round(k * C);
		r = Math.round(j * C);
		x.width = m;
		x.height = r;
		q = a.domElement;
		q.style.backgroundColor && (l.rows[0].cells[0].style.backgroundColor = q.style.backgroundColor, l.rows[0].cells[0].style.color = q.style.color);
		l.cellSpacing = 0;
		l.cellPadding = 0;
		var d = l.style;
		d.display = "inline";
		d.width = Math.round(m / C * e) + "px";
		d.height = Math.round(r / C * e) + "px";
		d.whiteSpace = "pre";
		d.margin = "0px";
		d.padding = "0px";
		d.letterSpacing = A + "px";
		d.fontFamily = t;
		d.fontSize = z + "px";
		d.lineHeight = w + "px";
		d.textAlign = "left";
		d.textDecoration = "none"
	};
	this.render = function (b, c) {
		a.render(b, c);
		v.clearRect(0, 0, m, r);
		v.drawImage(u, 0, 0, m, r);
		for (var d = v.getImageData(0, 0, m, r).data, e = "", j = 0; j < r; j += 2) {
			for (var k = 0; k < m; k++) {
				var p = 4 * (j * m + k),
					q = d[p],
					t = d[p + 1],
					x = d[p + 2],
					p = d[p + 3],
					w;
				w = (0.3 * q + 0.59 * t + 0.11 * x) / 255;
				0 == p && (w = 1);
				w = Math.floor((1 - w) * (s.length - 1));
				i && (w = s.length - w - 1);
				w = s[w];
				if (void 0 === w || " " == w) w = "&nbsp;";
				e = f ? e + ("<span style='color:rgb(" + q + "," + t + "," + x + ");" + (h ? "background-color:rgb(" + q + "," + t + "," + x + ");" : "") + (g ? "opacity:" + p / 255 + ";" : "") + "'>" + w + "</span>") : e + w
			}
			e += "<br/>"
		}
		l.innerHTML = "<tr><td>" + e + "</td></tr>"
	};
	this.domElement = c;
	var c = " .,:;i1tfLCG08@".split(""),
		p = " CGO08@".split(""),
		t = "courier new, monospace",
		u = a.domElement,
		x = document.createElement("canvas");
	if (x.getContext) {
		var v = x.getContext("2d");
		if (v.getImageData) {
			var s = f ? p : c;
			b && (s = b);
			var C = 0.5;
			switch ("low") {
				case "low":
					C = 0.25;
					break;
				case "medium":
					C = 0.5;
					break;
				case "high":
					C = 1
			}
			d && (C = d);
			var z = 2 / C * e,
				w = 2 / C * e,
				A = 0;
			switch (e) {
				case 1:
					A = -1;
					break;
				case 2:
				case 3:
					A = -2.1;
					break;
				case 4:
					A = -3.1;
					break;
				case 5:
					A = -4.15
			}
		}
	}
};
THREE.CrosseyedEffect = function (a) {
	this.separation = 10;
	var b, c, d = new THREE.PerspectiveCamera;
	d.target = new THREE.Vector3;
	var e = new THREE.PerspectiveCamera;
	e.target = new THREE.Vector3;
	a.autoClear = !1;
	this.setSize = function (d, e) {
		b = d / 2;
		c = e;
		a.setSize(d, e)
	};
	this.render = function (f, g) {
		d.fov = g.fov;
		d.aspect = 0.5 * g.aspect;
		d.near = g.near;
		d.far = g.far;
		d.updateProjectionMatrix();
		d.position.copy(g.position);
		d.target.copy(g.target);
		d.translateX(this.separation);
		d.lookAt(d.target);
		e.near = g.near;
		e.far = g.far;
		e.projectionMatrix = d.projectionMatrix;
		e.position.copy(g.position);
		e.target.copy(g.target);
		e.translateX(-this.separation);
		e.lookAt(e.target);
		a.clear();
		a.setViewport(0, 0, b, c);
		a.render(f, d);
		a.setViewport(b, 0, b, c);
		a.render(f, e, !1)
	}
};
THREE.ParallaxBarrierEffect = function (a) {
	var b = new THREE.Matrix4,
		c = new THREE.Matrix4,
		d, e, f, g, h = new THREE.PerspectiveCamera;
	h.matrixAutoUpdate = !1;
	var i = new THREE.PerspectiveCamera;
	i.matrixAutoUpdate = !1;
	var k = new THREE.Scene,
		j = new THREE.PerspectiveCamera(53, 1, 1, 1E4);
	j.position.z = 2;
	k.add(j);
	var l = {
		minFilter: THREE.LinearFilter,
		magFilter: THREE.NearestFilter,
		format: THREE.RGBAFormat
	}, m = new THREE.WebGLRenderTarget(512, 512, l),
		r = new THREE.WebGLRenderTarget(512, 512, l),
		q = new THREE.ShaderMaterial({
			uniforms: {
				mapLeft: {
					type: "t",
					value: m
				},
				mapRight: {
					type: "t",
					value: r
				}
			},
			vertexShader: "varying vec2 vUv;\nvoid main() {\n\tvUv = vec2( uv.x, uv.y );\n\tgl_Position = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );\n}",
			fragmentShader: "uniform sampler2D mapLeft;\nuniform sampler2D mapRight;\nvarying vec2 vUv;\nvoid main() {\n\tvec2 uv = vUv;\n\tif ( ( mod( gl_FragCoord.x, 2.0 ) ) > 1.00 ) {\n\t\tgl_FragColor = texture2D( mapLeft, uv );\n\t} else {\n\t\tgl_FragColor = texture2D( mapRight, uv );\n\t}\n}"
		}),
		p = new THREE.Mesh(new THREE.PlaneGeometry(2,
		2), q);
	k.add(p);
	this.setSize = function (b, c) {
		m = new THREE.WebGLRenderTarget(b, c, l);
		r = new THREE.WebGLRenderTarget(b, c, l);
		q.uniforms.mapLeft.value = m;
		q.uniforms.mapRight.value = r;
		a.setSize(b, c)
	};
	this.render = function (l, p) {
		l.updateMatrixWorld();
		void 0 === p.parent && p.updateMatrixWorld();
		if (d !== p.aspect || e !== p.near || f !== p.far || g !== p.fov) {
			d = p.aspect;
			e = p.near;
			f = p.far;
			g = p.fov;
			var q = p.projectionMatrix.clone(),
				v = 0.5 * (125 / 30),
				s = v * e / 125,
				C = e * Math.tan(THREE.Math.degToRad(0.5 * g)),
				z;
			b.elements[12] = v;
			c.elements[12] = -v;
			v = -C * d + s;
			z = C * d + s;
			q.elements[0] = 2 * e / (z - v);
			q.elements[8] = (z + v) / (z - v);
			h.projectionMatrix.copy(q);
			v = -C * d - s;
			z = C * d - s;
			q.elements[0] = 2 * e / (z - v);
			q.elements[8] = (z + v) / (z - v);
			i.projectionMatrix.copy(q)
		}
		h.matrixWorld.copy(p.matrixWorld).multiplySelf(c);
		h.position.copy(p.position);
		h.near = p.near;
		h.far = p.far;
		a.render(l, h, m, !0);
		i.matrixWorld.copy(p.matrixWorld).multiplySelf(b);
		i.position.copy(p.position);
		i.near = p.near;
		i.far = p.far;
		a.render(l, i, r, !0);
		k.updateMatrixWorld();
		a.render(k, j)
	}
};
THREE.GeometryExporter = function () {};
THREE.GeometryExporter.prototype = {
	constructor: THREE.GeometryExporter,
	parse: function (a) {
		function b(a, b, c) {
			var d = a.toString() + b.toString() + c.toString();
			if (void 0 !== g[d]) return g[d];
			g[d] = f.length / 3;
			f.push(a, b, c);
			return g[d]
		}
		for (var c = [], d = 0; d < a.vertices.length; d++) {
			var e = a.vertices[d];
			c.push(e.x, e.y, e.z)
		}
		for (var e = [], f = [], g = {}, d = 0; d < a.faces.length; d++) {
			var h = a.faces[d],
				i = h instanceof THREE.Face3,
				k = void 0 !== h.materialIndex,
				j = 0 < h.normal.length(),
				l = void 0 !== h.vertexNormals[0],
				m = 0,
				m = !i ? m | 1 : m & -2,
				m = j ? m | 16 : m & -17,
				m = l ? m | 32 : m & -33;
			e.push(m);
			i ? e.push(h.a, h.b, h.c) : e.push(h.a, h.b, h.c, h.d);
			k && e.push(h.materialIndex);
			j && (k = h.normal, e.push(b(k.x, k.y, k.z)));
			l && (h = h.vertexNormals, i ? e.push(b(h[0].x, h[0].y, h[0].z), b(h[1].x, h[1].y, h[1].z), b(h[2].x, h[2].y, h[2].z)) : e.push(b(h[0].x, h[0].y, h[0].z), b(h[1].x, h[1].y, h[1].z), b(h[2].x, h[2].y, h[2].z), b(h[3].x, h[3].y, h[3].z)))
		}
		return ['{\n\t"metadata": {\n\t\t"formatVersion" : 3.1,\n\t\t"generatedBy"\t: "GeometryExporter"\n\t},', '\t"vertices": ' + JSON.stringify(c) + ",", '\t"normals": ' + JSON.stringify(f) + ",", '\t"uvs": ' + JSON.stringify([
			[]
		]) + ",", '\t"faces": ' + JSON.stringify(e), "}"].join("\n")
	}
};
THREE.ColladaLoader = function () {
	function a(a, d, e) {
		T = a;
		d = d || Fa;
		void 0 !== e && (a = e.split("/"), a.pop(), $a = (1 > a.length ? "." : a.join("/")) + "/");
		if ((a = T.evaluate("//dae:asset", T, F, XPathResult.ORDERED_NODE_ITERATOR_TYPE, null).iterateNext()) && a.childNodes) for (e = 0; e < a.childNodes.length; e++) {
			var i = a.childNodes[e];
			switch (i.nodeName) {
				case "unit":
					(i = i.getAttribute("meter")) && parseFloat(i);
					break;
				case "up_axis":
					Xa = i.textContent.charAt(0)
			}
		}
		if (!Aa.convertUpAxis || Xa === Aa.upAxis) Na = null;
		else switch (Xa) {
			case "X":
				Na = "Y" === Aa.upAxis ? "XtoY" : "XtoZ";
				break;
			case "Y":
				Na = "X" === Aa.upAxis ? "YtoX" : "YtoZ";
				break;
			case "Z":
				Na = "X" === Aa.upAxis ? "ZtoX" : "ZtoY"
		}
		qa = b("//dae:library_images/dae:image", g, "image");
		ra = b("//dae:library_materials/dae:material", H, "material");
		Ua = b("//dae:library_effects/dae:effect", O, "effect");
		Ga = b("//dae:library_geometries/dae:geometry", t, "geometry");
		Va = b(".//dae:library_cameras/dae:camera", N, "camera");
		ta = b("//dae:library_controllers/dae:controller", h, "controller");
		na = b("//dae:library_animations/dae:animation",
		J, "animation");
		Wa = b(".//dae:library_visual_scenes/dae:visual_scene", j, "visual_scene");
		Ba = [];
		Ha = [];
		(a = T.evaluate(".//dae:scene/dae:instance_visual_scene", T, F, XPathResult.ORDERED_NODE_ITERATOR_TYPE, null).iterateNext()) ? (a = a.getAttribute("url").replace(/^#/, ""), U = Wa[0 < a.length ? a : "visual_scene0"]) : U = null;
		fa = new THREE.Object3D;
		for (a = 0; a < U.nodes.length; a++) fa.add(f(U.nodes[a]));
		ib = [];
		c(fa);
		a = {
			scene: fa,
			morphs: Ba,
			skins: Ha,
			animations: ib,
			dae: {
				images: qa,
				materials: ra,
				cameras: Va,
				effects: Ua,
				geometries: Ga,
				controllers: ta,
				animations: na,
				visualScenes: Wa,
				scene: U
			}
		};
		d && d(a);
		return a
	}
	function b(a, b, c) {
		for (var a = T.evaluate(a, T, F, XPathResult.ORDERED_NODE_ITERATOR_TYPE, null), d = {}, e = a.iterateNext(), f = 0; e;) {
			e = (new b).parse(e);
			if (!e.id || 0 == e.id.length) e.id = c + f++;
			d[e.id] = e;
			e = a.iterateNext()
		}
		return d
	}
	function c(a) {
		var b = U.getChildById(a.name, !0),
			d = null;
		if (b && b.keys) {
			d = {
				fps: 60,
				hierarchy: [{
					node: b,
					keys: b.keys,
					sids: b.sids
				}],
				node: a,
				name: "animation_" + a.name,
				length: 0
			};
			ib.push(d);
			for (var e = 0, f = b.keys.length; e < f; e++) d.length = Math.max(d.length,
			b.keys[e].time)
		} else d = {
			hierarchy: [{
				keys: [],
				sids: []
			}]
		};
		e = 0;
		for (f = a.children.length; e < f; e++) for (var b = 0, g = c(a.children[e]).hierarchy.length; b < g; b++) d.hierarchy.push({
			keys: [],
			sids: []
		});
		return d
	}
	function d(a, b, c, e) {
		a.world = a.world || new THREE.Matrix4;
		a.world.copy(a.matrix);
		if (a.channels && a.channels.length) {
			var f = a.channels[0].sampler.output[c];
			f instanceof THREE.Matrix4 && a.world.copy(f)
		}
		e && a.world.multiply(e, a.world);
		b.push(a);
		for (e = 0; e < a.nodes.length; e++) d(a.nodes[e], b, c, a.world)
	}
	function e(a, b, c) {
		var e,
		f = ta[b.url];
		if (!f || !f.skin) console.log("ColladaLoader: Could not find skin controller.");
		else if (!b.skeleton || !b.skeleton.length) console.log("ColladaLoader: Could not find the skeleton for the skin. ");
		else {
			var c = 1E6,
				g = -c,
				h = 0;
			for (e in na) for (var i = na[e], j = 0; j < i.sampler.length; j++) {
				var k = i.sampler[j];
				k.create();
				c = Math.min(c, k.startTime);
				g = Math.max(g, k.endTime);
				h = Math.max(h, k.input.length)
			}
			e = h;
			for (var b = U.getChildById(b.skeleton[0], !0) || U.getChildBySid(b.skeleton[0], !0), n, l, g = new THREE.Vector3, m, j = 0; j < a.vertices.length; j++) f.skin.bindShapeMatrix.multiplyVector3(a.vertices[j]);
			for (c = 0; c < e; c++) {
				h = [];
				i = [];
				for (j = 0; j < a.vertices.length; j++) i.push(new THREE.Vector3);
				d(b, h, c);
				j = h;
				k = f.skin;
				for (l = 0; l < j.length; l++) if (n = j[l], m = -1, "JOINT" == n.type) {
					for (var p = 0; p < k.joints.length; p++) if (n.sid == k.joints[p]) {
						m = p;
						break
					}
					if (0 <= m) {
						p = k.invBindMatrices[m];
						n.invBindMatrix = p;
						n.skinningMatrix = new THREE.Matrix4;
						n.skinningMatrix.multiplyMatrices(n.world, p);
						n.weights = [];
						for (p = 0; p < k.weights.length; p++) for (var r = 0; r < k.weights[p].length; r++) {
							var q = k.weights[p][r];
							q.joint == m && n.weights.push(q)
						}
					} else throw "ColladaLoader: Could not find joint '" + n.sid + "'.";
				}
				for (j = 0; j < h.length; j++) if ("JOINT" == h[j].type) for (k = 0; k < h[j].weights.length; k++) n = h[j].weights[k], l = n.index, n = n.weight, m = a.vertices[l], l = i[l], g.x = m.x, g.y = m.y, g.z = m.z, h[j].skinningMatrix.multiplyVector3(g), l.x += g.x * n, l.y += g.y * n, l.z += g.z * n;
				a.morphTargets.push({
					name: "target_" + c,
					vertices: i
				})
			}
		}
	}
	function f(a) {
		var b = new THREE.Object3D,
			c, d, g, h;
		for (g = 0; g < a.controllers.length; g++) {
			var i = ta[a.controllers[g].url];
			switch (i.type) {
				case "skin":
					if (Ga[i.skin.source]) {
						var j = new p;
						j.url = i.skin.source;
						j.instance_material = a.controllers[g].instance_material;
						a.geometries.push(j);
						c = a.controllers[g]
					} else ta[i.skin.source] && (d = i = ta[i.skin.source], i.morph && Ga[i.morph.source] && (j = new p, j.url = i.morph.source, j.instance_material = a.controllers[g].instance_material, a.geometries.push(j)));
					break;
				case "morph":
					Ga[i.morph.source] && (j = new p, j.url = i.morph.source, j.instance_material = a.controllers[g].instance_material, a.geometries.push(j),
					d = a.controllers[g]), console.log("ColladaLoader: Morph-controller partially supported.")
			}
		}
		j = {};
		for (g = 0; g < a.geometries.length; g++) {
			h = a.geometries[g];
			var i = h.instance_material,
				k = Ga[h.url],
				l = {}, n = [],
				m = 0,
				q;
			if (k && k.mesh && k.mesh.primitives) {
				0 == b.name.length && (b.name = k.id);
				if (i) for (h = 0; h < i.length; h++) {
					q = i[h];
					var s = ra[q.target],
						t = Ua[s.instance_effect.url].shader.material;
					if (k.doubleSided) {
						if (!(t in j)) {
							var u = t.clone();
							u.side = THREE.DoubleSide;
							j[t] = u
						}
						t = j[t]
					}
					t.opacity = !t.opacity ? 1 : t.opacity;
					l[q.symbol] = m;
					n.push(t);
					q = t;
					q.name = null == s.name || "" === s.name ? s.id : s.name;
					m++
				}
				i = q || new THREE.MeshLambertMaterial({
					color: 14540253,
					shading: THREE.FlatShading,
					side: k.doubleSided ? THREE.DoubleSide : THREE.FrontSide
				});
				k = k.mesh.geometry3js;
				if (1 < m) {
					i = new THREE.MeshFaceMaterial(n);
					for (h = 0; h < k.faces.length; h++) n = k.faces[h], n.materialIndex = l[n.daeMaterial]
				}
				if (void 0 !== c) e(k, c), i.morphTargets = !0, i = new THREE.SkinnedMesh(k, i, !1), i.skeleton = c.skeleton, i.skinController = ta[c.url], i.skinInstanceController = c, i.name = "skin_" + Ha.length, Ha.push(i);
				else if (void 0 !== d) {
					h = k;
					l = d instanceof r ? ta[d.url] : d;
					if (!l || !l.morph) console.log("could not find morph controller!");
					else {
						l = l.morph;
						for (n = 0; n < l.targets.length; n++) m = Ga[l.targets[n]], m.mesh && (m.mesh.primitives && m.mesh.primitives.length) && (m = m.mesh.primitives[0].geometry, m.vertices.length === h.vertices.length && h.morphTargets.push({
							name: "target_1",
							vertices: m.vertices
						}));
						h.morphTargets.push({
							name: "target_Z",
							vertices: h.vertices
						})
					}
					i.morphTargets = !0;
					i = new THREE.Mesh(k, i);
					i.name = "morph_" + Ba.length;
					Ba.push(i)
				} else i = new THREE.Mesh(k, i);
				1 < a.geometries.length ? b.add(i) : b = i
			}
		}
		for (g = 0; g < a.cameras.length; g++) b = Va[a.cameras[g].url], b = new THREE.PerspectiveCamera(b.fov, b.aspect_ratio, b.znear, b.zfar);
		b.name = a.id || "";
		b.matrix = a.matrix;
		g = a.matrix.decompose();
		b.position = g[0];
		b.quaternion = g[1];
		b.useQuaternion = !0;
		b.scale = g[2];
		Aa.centerGeometry && b.geometry && (g = THREE.GeometryUtils.center(b.geometry), b.quaternion.multiplyVector3(g.multiplySelf(b.scale)), b.position.sub(g));
		for (g = 0; g < a.nodes.length; g++) b.add(f(a.nodes[g], a));
		return b
	}
	function g() {
		this.init_from = this.id = ""
	}
	function h() {
		this.type = this.name = this.id = "";
		this.morph = this.skin = null
	}
	function i() {
		this.weights = this.targets = this.source = this.method = null
	}
	function k() {
		this.source = "";
		this.bindShapeMatrix = null;
		this.invBindMatrices = [];
		this.joints = [];
		this.weights = []
	}
	function j() {
		this.name = this.id = "";
		this.nodes = [];
		this.scene = new THREE.Object3D
	}
	function l() {
		this.sid = this.name = this.id = "";
		this.nodes = [];
		this.controllers = [];
		this.transforms = [];
		this.geometries = [];
		this.channels = [];
		this.matrix = new THREE.Matrix4
	}
	function m() {
		this.type = this.sid = "";
		this.data = [];
		this.obj = null
	}
	function r() {
		this.url = "";
		this.skeleton = [];
		this.instance_material = []
	}
	function q() {
		this.target = this.symbol = ""
	}
	function p() {
		this.url = "";
		this.instance_material = []
	}
	function t() {
		this.id = "";
		this.mesh = null
	}
	function u(a) {
		this.geometry = a.id;
		this.primitives = [];
		this.geometry3js = this.vertices = null
	}
	function x() {
		this.material = "";
		this.count = 0;
		this.inputs = [];
		this.vcount = null;
		this.p = [];
		this.geometry = new THREE.Geometry
	}
	function v() {
		x.call(this);
		this.vcount = []
	}
	function s() {
		x.call(this);
		this.vcount = 3
	}
	function C() {
		this.source = "";
		this.stride = this.count = 0;
		this.params = []
	}
	function z() {
		this.input = {}
	}
	function w() {
		this.semantic = "";
		this.offset = 0;
		this.source = "";
		this.set = 0
	}
	function A(a) {
		this.id = a;
		this.type = null
	}
	function H() {
		this.name = this.id = "";
		this.instance_effect = null
	}
	function G() {
		this.color = new THREE.Color(0);
		this.color.setRGB(Math.random(), Math.random(), Math.random());
		this.color.a = 1;
		this.texOpts = this.texcoord = this.texture = null
	}
	function I(a, b) {
		this.type = a;
		this.effect = b;
		this.material = null
	}
	function V(a) {
		this.effect = a;
		this.format = this.init_from = null
	}
	function E(a) {
		this.effect = a;
		this.mipfilter = this.magfilter = this.minfilter = this.wrap_t = this.wrap_s = this.source = null
	}
	function O() {
		this.name = this.id = "";
		this.shader = null;
		this.surface = {};
		this.sampler = {}
	}
	function D() {
		this.url = ""
	}
	function J() {
		this.name = this.id = "";
		this.source = {};
		this.sampler = [];
		this.channel = []
	}
	function P(a) {
		this.animation = a;
		this.target = this.source = "";
		this.member = this.arrIndices = this.arrSyntax = this.dotSyntax = this.sid = this.fullSid = null
	}
	function R(a) {
		this.id = "";
		this.animation = a;
		this.inputs = [];
		this.endTime = this.startTime = this.interpolation = this.strideOut = this.output = this.input = null;
		this.duration = 0
	}
	function Q(a) {
		this.targets = [];
		this.time = a
	}
	function N() {
		this.technique = this.name = this.id = ""
	}
	function M() {
		this.url = ""
	}
	function F(a) {
		return "dae" == a ? "http://www.collada.org/2005/11/COLLADASchema" : null
	}
	function W(a) {
		for (var a = ua(a), b = [], c = 0, d = a.length; c < d; c++) b.push(parseFloat(a[c]));
		return b
	}
	function oa(a) {
		for (var a = ua(a), b = [], c = 0, d = a.length; c < d; c++) b.push(parseInt(a[c], 10));
		return b
	}
	function ua(a) {
		return 0 < a.length ? a.replace(/^\s+/, "").replace(/\s+$/, "").split(/\s+/) : []
	}
	function va(a, b, c) {
		return a.hasAttribute(b) ? parseInt(a.getAttribute(b), 10) : c
	}
	function L(a, b) {
		a.doubleSided = !1;
		var c = T.evaluate(".//dae:extra//dae:double_sided", b, F, XPathResult.ORDERED_NODE_ITERATOR_TYPE, null);
		if (c && (c = c.iterateNext()) && 1 === parseInt(c.textContent, 10)) a.doubleSided = !0
	}
	function da(a, b) {
		if (Aa.convertUpAxis && Xa !== Aa.upAxis) switch (Na) {
			case "XtoY":
				var c = a[0];
				a[0] = b * a[1];
				a[1] = c;
				break;
			case "XtoZ":
				c = a[2];
				a[2] = a[1];
				a[1] = a[0];
				a[0] = c;
				break;
			case "YtoX":
				c = a[0];
				a[0] = a[1];
				a[1] = b * c;
				break;
			case "YtoZ":
				c = a[1];
				a[1] = b * a[2];
				a[2] = c;
				break;
			case "ZtoX":
				c = a[0];
				a[0] = a[1];
				a[1] = a[2];
				a[2] = c;
				break;
			case "ZtoY":
				c = a[1], a[1] = a[2], a[2] = b * c
		}
	}
	function ca(a, b) {
		var c = [a[b], a[b + 1], a[b + 2]];
		da(c, -1);
		return new THREE.Vector3(c[0], c[1], c[2])
	}
	function ba(a) {
		if (Aa.convertUpAxis) {
			var b = [a[0], a[4], a[8]];
			da(b, -1);
			a[0] = b[0];
			a[4] = b[1];
			a[8] = b[2];
			b = [a[1], a[5], a[9]];
			da(b, -1);
			a[1] = b[0];
			a[5] = b[1];
			a[9] = b[2];
			b = [a[2], a[6], a[10]];
			da(b, -1);
			a[2] = b[0];
			a[6] = b[1];
			a[10] = b[2];
			b = [a[0], a[1], a[2]];
			da(b, -1);
			a[0] = b[0];
			a[1] = b[1];
			a[2] = b[2];
			b = [a[4], a[5], a[6]];
			da(b, -1);
			a[4] = b[0];
			a[5] = b[1];
			a[6] = b[2];
			b = [a[8], a[9], a[10]];
			da(b, -1);
			a[8] = b[0];
			a[9] = b[1];
			a[10] = b[2];
			b = [a[3], a[7], a[11]];
			da(b, -1);
			a[3] = b[0];
			a[7] = b[1];
			a[11] = b[2]
		}
		return new THREE.Matrix4(a[0], a[1], a[2], a[3], a[4], a[5], a[6], a[7], a[8], a[9], a[10], a[11], a[12], a[13], a[14], a[15])
	}
	function ka(a) {
		if (Aa.convertUpAxis) switch (a) {
			case "X":
				switch (Na) {
					case "XtoY":
					case "XtoZ":
					case "YtoX":
						a =
							"Y";
						break;
					case "ZtoX":
						a = "Z"
				}
				break;
			case "Y":
				switch (Na) {
					case "XtoY":
					case "YtoX":
					case "ZtoX":
						a = "X";
						break;
					case "XtoZ":
					case "YtoZ":
					case "ZtoY":
						a = "Z"
				}
				break;
			case "Z":
				switch (Na) {
					case "XtoZ":
						a = "X";
						break;
					case "YtoZ":
					case "ZtoX":
					case "ZtoY":
						a = "Y"
				}
		}
		return a
	}
	var T = null,
		fa = null,
		U, Fa = null,
		wa = {}, qa = {}, na = {}, ta = {}, Ga = {}, ra = {}, Ua = {}, Va = {}, ib, Wa, $a, Ba, Ha, wb = THREE.SmoothShading,
		Aa = {
			centerGeometry: !1,
			convertUpAxis: !1,
			subdivideFaces: !0,
			upAxis: "Y",
			defaultEnvMap: null
		}, Xa = "Y",
		Na = null;
	g.prototype.parse = function (a) {
		this.id = a.getAttribute("id");
		for (var b = 0; b < a.childNodes.length; b++) {
			var c = a.childNodes[b];
			"init_from" == c.nodeName && (this.init_from = c.textContent)
		}
		return this
	};
	h.prototype.parse = function (a) {
		this.id = a.getAttribute("id");
		this.name = a.getAttribute("name");
		this.type = "none";
		for (var b = 0; b < a.childNodes.length; b++) {
			var c = a.childNodes[b];
			switch (c.nodeName) {
				case "skin":
					this.skin = (new k).parse(c);
					this.type = c.nodeName;
					break;
				case "morph":
					this.morph = (new i).parse(c), this.type = c.nodeName
			}
		}
		return this
	};
	i.prototype.parse = function (a) {
		var b = {}, c = [],
			d;
		this.method = a.getAttribute("method");
		this.source = a.getAttribute("source").replace(/^#/, "");
		for (d = 0; d < a.childNodes.length; d++) {
			var e = a.childNodes[d];
			if (1 == e.nodeType) switch (e.nodeName) {
				case "source":
					e = (new A).parse(e);
					b[e.id] = e;
					break;
				case "targets":
					c = this.parseInputs(e);
					break;
				default:
					console.log(e.nodeName)
			}
		}
		for (d = 0; d < c.length; d++) switch (a = c[d], e = b[a.source], a.semantic) {
			case "MORPH_TARGET":
				this.targets = e.read();
				break;
			case "MORPH_WEIGHT":
				this.weights = e.read()
		}
		return this
	};
	i.prototype.parseInputs = function (a) {
		for (var b = [], c = 0; c < a.childNodes.length; c++) {
			var d = a.childNodes[c];
			if (1 == d.nodeType) switch (d.nodeName) {
				case "input":
					b.push((new w).parse(d))
			}
		}
		return b
	};
	k.prototype.parse = function (a) {
		var b = {}, c, d;
		this.source = a.getAttribute("source").replace(/^#/, "");
		this.invBindMatrices = [];
		this.joints = [];
		this.weights = [];
		for (var e = 0; e < a.childNodes.length; e++) {
			var f = a.childNodes[e];
			if (1 == f.nodeType) switch (f.nodeName) {
				case "bind_shape_matrix":
					f = W(f.textContent);
					this.bindShapeMatrix = ba(f);
					break;
				case "source":
					f = (new A).parse(f);
					b[f.id] = f;
					break;
				case "joints":
					c = f;
					break;
				case "vertex_weights":
					d = f;
					break;
				default:
					console.log(f.nodeName)
			}
		}
		this.parseJoints(c, b);
		this.parseWeights(d, b);
		return this
	};
	k.prototype.parseJoints = function (a, b) {
		for (var c = 0; c < a.childNodes.length; c++) {
			var d = a.childNodes[c];
			if (1 == d.nodeType) switch (d.nodeName) {
				case "input":
					var d = (new w).parse(d),
						e = b[d.source];
					"JOINT" == d.semantic ? this.joints = e.read() : "INV_BIND_MATRIX" == d.semantic && (this.invBindMatrices = e.read())
			}
		}
	};
	k.prototype.parseWeights = function (a,
	b) {
		for (var c, d, e = [], f = 0; f < a.childNodes.length; f++) {
			var g = a.childNodes[f];
			if (1 == g.nodeType) switch (g.nodeName) {
				case "input":
					e.push((new w).parse(g));
					break;
				case "v":
					c = oa(g.textContent);
					break;
				case "vcount":
					d = oa(g.textContent)
			}
		}
		for (f = g = 0; f < d.length; f++) {
			for (var h = d[f], i = [], j = 0; j < h; j++) {
				for (var k = {}, l = 0; l < e.length; l++) {
					var m = e[l],
						p = c[g + m.offset];
					switch (m.semantic) {
						case "JOINT":
							k.joint = p;
							break;
						case "WEIGHT":
							k.weight = b[m.source].data[p]
					}
				}
				i.push(k);
				g += e.length
			}
			for (j = 0; j < i.length; j++) i[j].index = f;
			this.weights.push(i)
		}
	};
	j.prototype.getChildById = function (a, b) {
		for (var c = 0; c < this.nodes.length; c++) {
			var d = this.nodes[c].getChildById(a, b);
			if (d) return d
		}
		return null
	};
	j.prototype.getChildBySid = function (a, b) {
		for (var c = 0; c < this.nodes.length; c++) {
			var d = this.nodes[c].getChildBySid(a, b);
			if (d) return d
		}
		return null
	};
	j.prototype.parse = function (a) {
		this.id = a.getAttribute("id");
		this.name = a.getAttribute("name");
		this.nodes = [];
		for (var b = 0; b < a.childNodes.length; b++) {
			var c = a.childNodes[b];
			if (1 == c.nodeType) switch (c.nodeName) {
				case "node":
					this.nodes.push((new l).parse(c))
			}
		}
		return this
	};
	l.prototype.getChannelForTransform = function (a) {
		for (var b = 0; b < this.channels.length; b++) {
			var c = this.channels[b],
				d = c.target.split("/");
			d.shift();
			var e = d.shift(),
				f = 0 <= e.indexOf("."),
				g = 0 <= e.indexOf("("),
				h;
			if (f) d = e.split("."), e = d.shift(), d.shift();
			else if (g) {
				h = e.split("(");
				e = h.shift();
				for (d = 0; d < h.length; d++) h[d] = parseInt(h[d].replace(/\)/, ""))
			}
			if (e == a) return c.info = {
				sid: e,
				dotSyntax: f,
				arrSyntax: g,
				arrIndices: h
			}, c
		}
		return null
	};
	l.prototype.getChildById = function (a, b) {
		if (this.id == a) return this;
		if (b) for (var c = 0; c < this.nodes.length; c++) {
			var d = this.nodes[c].getChildById(a, b);
			if (d) return d
		}
		return null
	};
	l.prototype.getChildBySid = function (a, b) {
		if (this.sid == a) return this;
		if (b) for (var c = 0; c < this.nodes.length; c++) {
			var d = this.nodes[c].getChildBySid(a, b);
			if (d) return d
		}
		return null
	};
	l.prototype.getTransformBySid = function (a) {
		for (var b = 0; b < this.transforms.length; b++) if (this.transforms[b].sid == a) return this.transforms[b];
		return null
	};
	l.prototype.parse = function (a) {
		var b;
		this.id = a.getAttribute("id");
		this.sid = a.getAttribute("sid");
		this.name = a.getAttribute("name");
		this.type = a.getAttribute("type");
		this.type = "JOINT" == this.type ? this.type : "NODE";
		this.nodes = [];
		this.transforms = [];
		this.geometries = [];
		this.cameras = [];
		this.controllers = [];
		this.matrix = new THREE.Matrix4;
		for (var c = 0; c < a.childNodes.length; c++) if (b = a.childNodes[c], 1 == b.nodeType) switch (b.nodeName) {
			case "node":
				this.nodes.push((new l).parse(b));
				break;
			case "instance_camera":
				this.cameras.push((new M).parse(b));
				break;
			case "instance_controller":
				this.controllers.push((new r).parse(b));
				break;
			case "instance_geometry":
				this.geometries.push((new p).parse(b));
				break;
			case "instance_light":
				break;
			case "instance_node":
				b = b.getAttribute("url").replace(/^#/, "");
				(b = T.evaluate(".//dae:library_nodes//dae:node[@id='" + b + "']", T, F, XPathResult.ORDERED_NODE_ITERATOR_TYPE, null).iterateNext()) && this.nodes.push((new l).parse(b));
				break;
			case "rotate":
			case "translate":
			case "scale":
			case "matrix":
			case "lookat":
			case "skew":
				this.transforms.push((new m).parse(b));
				break;
			case "extra":
				break;
			default:
				console.log(b.nodeName)
		}
		a = [];
		c = 1E6;
		b = -1E6;
		for (var d in na) for (var e = na[d], f = 0; f < e.channel.length; f++) {
			var g = e.channel[f],
				h = e.sampler[f];
			d = g.target.split("/")[0];
			d == this.id && (h.create(), g.sampler = h, c = Math.min(c, h.startTime), b = Math.max(b, h.endTime), a.push(g))
		}
		a.length && (this.startTime = c, this.endTime = b);
		if ((this.channels = a) && this.channels.length) {
			d = [];
			a = [];
			c = 0;
			for (e = this.channels.length; c < e; c++) {
				var i = this.channels[c],
					f = i.fullSid,
					g = i.sampler,
					h = g.input,
					j = this.getTransformBySid(i.sid),
					k;
				if (i.arrIndices) {
					k = [];
					b = 0;
					for (var q = i.arrIndices.length; b < q; b++) {
						var s = k,
							t = b,
							u = i.arrIndices[b]; - 1 < u && 3 > u && (u = ka(["X", "Y", "Z"][u]), u = {
							X: 0,
							Y: 1,
							Z: 2
						}[u]);
						s[t] = u
					}
				} else k = ka(i.member);
				if (j) {
					-1 === a.indexOf(f) && a.push(f);
					b = 0;
					for (q = h.length; b < q; b++) {
						for (var s = h[b], i = g.getData(j.type, b), t = null, u = 0, v = d.length; u < v && null == t; u++) {
							var w = d[u];
							if (w.time === s) t = w;
							else if (w.time > s) break
						}
						if (!t) {
							t = new Q(s);
							u = -1;
							v = 0;
							for (w = d.length; v < w && -1 == u; v++) d[v].time >= s && (u = v);
							s = u;
							d.splice(-1 == s ? d.length : s, 0, t)
						}
						t.addTarget(f, j, k, i)
					}
				} else console.log('Could not find transform "' + i.sid + '" in node ' + this.id)
			}
			for (c = 0; c < a.length; c++) {
				e = a[c];
				for (b = 0; b < d.length; b++) if (t = d[b], !t.hasTarget(e)) {
					h = d;
					f = t;
					k = b;
					g = e;
					j = void 0;
					a: {
						j = k ? k - 1 : 0;
						for (j = 0 <= j ? j : j + h.length; 0 <= j; j--) if (q = h[j], q.hasTarget(g)) {
							j = q;
							break a
						}
						j = null
					}
					q = void 0;
					a: {
						for (k += 1; k < h.length; k++) if (q = h[k], q.hasTarget(g)) break a;
						q = null
					}
					if (j && q) {
						h = (f.time - j.time) / (q.time - j.time);
						j = j.getTarget(g);
						k = q.getTarget(g).data;
						q = j.data;
						i = void 0;
						if ("matrix" === j.type) i = q;
						else if (q.length) {
							i = [];
							for (s = 0; s < q.length; ++s) i[s] = q[s] + (k[s] - q[s]) * h
						} else i = q + (k - q) * h;
						f.addTarget(g,
						j.transform, j.member, i)
					}
				}
			}
			this.keys = d;
			this.sids = a
		}
		this.updateMatrix();
		return this
	};
	l.prototype.updateMatrix = function () {
		this.matrix.identity();
		for (var a = 0; a < this.transforms.length; a++) this.transforms[a].apply(this.matrix)
	};
	m.prototype.parse = function (a) {
		this.sid = a.getAttribute("sid");
		this.type = a.nodeName;
		this.data = W(a.textContent);
		this.convert();
		return this
	};
	m.prototype.convert = function () {
		switch (this.type) {
			case "matrix":
				this.obj = ba(this.data);
				break;
			case "rotate":
				this.angle = THREE.Math.degToRad(this.data[3]);
			case "translate":
				da(this.data, -1);
				this.obj = new THREE.Vector3(this.data[0], this.data[1], this.data[2]);
				break;
			case "scale":
				da(this.data, 1);
				this.obj = new THREE.Vector3(this.data[0], this.data[1], this.data[2]);
				break;
			default:
				console.log("Can not convert Transform of type " + this.type)
		}
	};
	m.prototype.apply = function (a) {
		switch (this.type) {
			case "matrix":
				a.multiplySelf(this.obj);
				break;
			case "translate":
				a.translate(this.obj);
				break;
			case "rotate":
				a.rotateByAxis(this.obj, this.angle);
				break;
			case "scale":
				a.scale(this.obj)
		}
	};
	m.prototype.update = function (a, b) {
		var c = ["X", "Y", "Z", "ANGLE"];
		switch (this.type) {
			case "matrix":
				if (b) if (1 === b.length) switch (b[0]) {
					case 0:
						this.obj.n11 = a[0];
						this.obj.n21 = a[1];
						this.obj.n31 = a[2];
						this.obj.n41 = a[3];
						break;
					case 1:
						this.obj.n12 = a[0];
						this.obj.n22 = a[1];
						this.obj.n32 = a[2];
						this.obj.n42 = a[3];
						break;
					case 2:
						this.obj.n13 = a[0];
						this.obj.n23 = a[1];
						this.obj.n33 = a[2];
						this.obj.n43 = a[3];
						break;
					case 3:
						this.obj.n14 = a[0], this.obj.n24 = a[1], this.obj.n34 = a[2], this.obj.n44 = a[3]
				} else 2 === b.length ? this.obj["n" + (b[0] + 1) + (b[1] + 1)] = a : console.log("Incorrect addressing of matrix in transform.");
				else this.obj.copy(a);
				break;
			case "translate":
			case "scale":
				"[object Array]" === Object.prototype.toString.call(b) && (b = c[b[0]]);
				switch (b) {
					case "X":
						this.obj.x = a;
						break;
					case "Y":
						this.obj.y = a;
						break;
					case "Z":
						this.obj.z = a;
						break;
					default:
						this.obj.x = a[0], this.obj.y = a[1], this.obj.z = a[2]
				}
				break;
			case "rotate":
				switch ("[object Array]" === Object.prototype.toString.call(b) && (b = c[b[0]]), b) {
					case "X":
						this.obj.x = a;
						break;
					case "Y":
						this.obj.y = a;
						break;
					case "Z":
						this.obj.z = a;
						break;
					case "ANGLE":
						this.angle = THREE.Math.degToRad(a);
						break;
					default:
						this.obj.x = a[0], this.obj.y = a[1], this.obj.z = a[2], this.angle = THREE.Math.degToRad(a[3])
				}
		}
	};
	r.prototype.parse = function (a) {
		this.url = a.getAttribute("url").replace(/^#/, "");
		this.skeleton = [];
		this.instance_material = [];
		for (var b = 0; b < a.childNodes.length; b++) {
			var c = a.childNodes[b];
			if (1 === c.nodeType) switch (c.nodeName) {
				case "skeleton":
					this.skeleton.push(c.textContent.replace(/^#/, ""));
					break;
				case "bind_material":
					if (c = T.evaluate(".//dae:instance_material",
					c, F, XPathResult.ORDERED_NODE_ITERATOR_TYPE, null)) for (var d = c.iterateNext(); d;) this.instance_material.push((new q).parse(d)), d = c.iterateNext()
			}
		}
		return this
	};
	q.prototype.parse = function (a) {
		this.symbol = a.getAttribute("symbol");
		this.target = a.getAttribute("target").replace(/^#/, "");
		return this
	};
	p.prototype.parse = function (a) {
		this.url = a.getAttribute("url").replace(/^#/, "");
		this.instance_material = [];
		for (var b = 0; b < a.childNodes.length; b++) {
			var c = a.childNodes[b];
			if (1 == c.nodeType && "bind_material" == c.nodeName) {
				if (a = T.evaluate(".//dae:instance_material", c, F, XPathResult.ORDERED_NODE_ITERATOR_TYPE, null)) for (b = a.iterateNext(); b;) this.instance_material.push((new q).parse(b)), b = a.iterateNext();
				break
			}
		}
		return this
	};
	t.prototype.parse = function (a) {
		this.id = a.getAttribute("id");
		L(this, a);
		for (var b = 0; b < a.childNodes.length; b++) {
			var c = a.childNodes[b];
			switch (c.nodeName) {
				case "mesh":
					this.mesh = (new u(this)).parse(c)
			}
		}
		return this
	};
	u.prototype.parse = function (a) {
		this.primitives = [];
		var b;
		for (b = 0; b < a.childNodes.length; b++) {
			var c = a.childNodes[b];
			switch (c.nodeName) {
				case "source":
					var d = c.getAttribute("id");
					void 0 == wa[d] && (wa[d] = (new A(d)).parse(c));
					break;
				case "vertices":
					this.vertices = (new z).parse(c);
					break;
				case "triangles":
					this.primitives.push((new s).parse(c));
					break;
				case "polygons":
					this.primitives.push((new x).parse(c));
					break;
				case "polylist":
					this.primitives.push((new v).parse(c))
			}
		}
		this.geometry3js = new THREE.Geometry;
		a = wa[this.vertices.input.POSITION.source].data;
		for (b = 0; b < a.length; b += 3) this.geometry3js.vertices.push(ca(a, b).clone());
		for (b = 0; b < this.primitives.length; b++) a = this.primitives[b], a.setVertices(this.vertices), this.handlePrimitive(a, this.geometry3js);
		this.geometry3js.computeCentroids();
		this.geometry3js.computeFaceNormals();
		this.geometry3js.calcNormals && (this.geometry3js.computeVertexNormals(), delete this.geometry3js.calcNormals);
		this.geometry3js.computeBoundingBox();
		return this
	};
	u.prototype.handlePrimitive = function (a, b) {
		var c, d, e = a.p,
			f = a.inputs,
			g, h, i, j, k, l = 0,
			m = 3,
			p = 0,
			q = [];
		for (c = 0; c < f.length; c++) switch (g = f[c], m = g.offset + 1, p = p < m ? m : p, g.semantic) {
			case "TEXCOORD":
				q.push(g.set)
		}
		for (var r = 0; r < e.length; ++r) for (var s = e[r], t = 0; t < s.length;) {
			var u = [],
				v = [],
				w = null,
				x = [],
				m = a.vcount ? a.vcount.length ? a.vcount[l++] : a.vcount : s.length / p;
			for (c = 0; c < m; c++) for (d = 0; d < f.length; d++) switch (g = f[d], j = wa[g.source], h = s[t + c * p + g.offset], k = j.accessor.params.length, i = h * k, g.semantic) {
				case "VERTEX":
					u.push(h);
					break;
				case "NORMAL":
					v.push(ca(j.data, i));
					break;
				case "TEXCOORD":
					w = w || {};
					void 0 === w[g.set] && (w[g.set] = []);
					w[g.set].push(new THREE.Vector2(j.data[i], j.data[i + 1]));
					break;
				case "COLOR":
					x.push((new THREE.Color).setRGB(j.data[i], j.data[i + 1], j.data[i + 2]))
			}
			if (0 == v.length) if (g = this.vertices.input.NORMAL) {
				j = wa[g.source];
				k = j.accessor.params.length;
				c = 0;
				for (h = u.length; c < h; c++) v.push(ca(j.data, u[c] * k))
			} else b.calcNormals = !0;
			if (!w && (w = {}, g = this.vertices.input.TEXCOORD)) {
				q.push(g.set);
				j = wa[g.source];
				k = j.accessor.params.length;
				c = 0;
				for (h = u.length; c < h; c++) i = u[c] * k, void 0 === w[g.set] && (w[g.set] = []), w[g.set].push(new THREE.Vector2(j.data[i], 1 - j.data[i + 1]))
			}
			if (0 == x.length && (g = this.vertices.input.COLOR)) {
				j = wa[g.source];
				k = j.accessor.params.length;
				c = 0;
				for (h = u.length; c < h; c++) i = u[c] * k, x.push((new THREE.Color).setRGB(j.data[i], j.data[i + 1], j.data[i + 2]))
			}
			d = null;
			g = [];
			if (3 === m) g.push(new THREE.Face3(u[0], u[1], u[2], v, x.length ? x : new THREE.Color));
			else if (4 === m) g.push(new THREE.Face4(u[0], u[1], u[2], u[3], v, x.length ? x : new THREE.Color));
			else if (4 < m && Aa.subdivideFaces) {
				x = x.length ? x : new THREE.Color;
				for (d = 1; d < m - 1;) g.push(new THREE.Face3(u[0], u[d], u[d + 1], [v[0], v[d++], v[d]], x))
			}
			if (g.length) {
				c = 0;
				for (h = g.length; c < h; c++) {
					d = g[c];
					d.daeMaterial = a.material;
					b.faces.push(d);
					for (d = 0; d < q.length; d++) u = w[q[d]], u = 4 < m ? [u[0], u[c + 1], u[c + 2]] : 4 === m ? [u[0], u[1], u[2], u[3]] : [u[0], u[1], u[2]], b.faceVertexUvs[d] || (b.faceVertexUvs[d] = []), b.faceVertexUvs[d].push(u)
				}
			} else console.log("dropped face with vcount " + m + " for geometry with id: " + b.id);
			t += p * m
		}
	};
	x.prototype.setVertices = function (a) {
		for (var b = 0; b < this.inputs.length; b++) this.inputs[b].source == a.id && (this.inputs[b].source = a.input.POSITION.source)
	};
	x.prototype.parse = function (a) {
		this.material = a.getAttribute("material");
		this.count = va(a, "count", 0);
		for (var b = 0; b < a.childNodes.length; b++) {
			var c = a.childNodes[b];
			switch (c.nodeName) {
				case "input":
					this.inputs.push((new w).parse(a.childNodes[b]));
					break;
				case "vcount":
					this.vcount = oa(c.textContent);
					break;
				case "p":
					this.p.push(oa(c.textContent));
					break;
				case "ph":
					console.warn("polygon holes not yet supported!")
			}
		}
		return this
	};
	v.prototype = Object.create(x.prototype);
	s.prototype = Object.create(x.prototype);
	C.prototype.parse = function (a) {
		this.params = [];
		this.source = a.getAttribute("source");
		this.count = va(a, "count", 0);
		this.stride = va(a, "stride", 0);
		for (var b = 0; b < a.childNodes.length; b++) {
			var c = a.childNodes[b];
			if ("param" == c.nodeName) {
				var d = {};
				d.name = c.getAttribute("name");
				d.type = c.getAttribute("type");
				this.params.push(d)
			}
		}
		return this
	};
	z.prototype.parse = function (a) {
		this.id = a.getAttribute("id");
		for (var b = 0; b < a.childNodes.length; b++) if ("input" == a.childNodes[b].nodeName) {
			var c = (new w).parse(a.childNodes[b]);
			this.input[c.semantic] = c
		}
		return this
	};
	w.prototype.parse = function (a) {
		this.semantic = a.getAttribute("semantic");
		this.source = a.getAttribute("source").replace(/^#/, "");
		this.set = va(a, "set", -1);
		this.offset = va(a, "offset", 0);
		"TEXCOORD" == this.semantic && 0 > this.set && (this.set = 0);
		return this
	};
	A.prototype.parse = function (a) {
		this.id = a.getAttribute("id");
		for (var b = 0; b < a.childNodes.length; b++) {
			var c = a.childNodes[b];
			switch (c.nodeName) {
				case "bool_array":
					for (var d = ua(c.textContent), e = [], f = 0, g = d.length; f < g; f++) e.push("true" == d[f] || "1" == d[f] ? !0 : !1);
					this.data = e;
					this.type = c.nodeName;
					break;
				case "float_array":
					this.data = W(c.textContent);
					this.type = c.nodeName;
					break;
				case "int_array":
					this.data = oa(c.textContent);
					this.type = c.nodeName;
					break;
				case "IDREF_array":
				case "Name_array":
					this.data = ua(c.textContent);
					this.type = c.nodeName;
					break;
				case "technique_common":
					for (d = 0; d < c.childNodes.length; d++) if ("accessor" == c.childNodes[d].nodeName) {
						this.accessor = (new C).parse(c.childNodes[d]);
						break
					}
			}
		}
		return this
	};
	A.prototype.read = function () {
		var a = [],
			b = this.accessor.params[0];
		switch (b.type) {
			case "IDREF":
			case "Name":
			case "name":
			case "float":
				return this.data;
			case "float4x4":
				for (b = 0; b < this.data.length; b += 16) {
					var c = this.data.slice(b, b + 16),
						c = ba(c);
					a.push(c)
				}
				break;
			default:
				console.log("ColladaLoader: Source: Read dont know how to read " + b.type + ".")
		}
		return a
	};
	H.prototype.parse = function (a) {
		this.id = a.getAttribute("id");
		this.name = a.getAttribute("name");
		for (var b = 0; b < a.childNodes.length; b++) if ("instance_effect" == a.childNodes[b].nodeName) {
			this.instance_effect = (new D).parse(a.childNodes[b]);
			break
		}
		return this
	};
	G.prototype.isColor = function () {
		return null == this.texture
	};
	G.prototype.isTexture = function () {
		return null != this.texture
	};
	G.prototype.parse = function (a) {
		for (var b = 0; b < a.childNodes.length; b++) {
			var c = a.childNodes[b];
			if (1 == c.nodeType) switch (c.nodeName) {
				case "color":
					c = W(c.textContent);
					this.color = new THREE.Color(0);
					this.color.setRGB(c[0], c[1], c[2]);
					this.color.a = c[3];
					break;
				case "texture":
					this.texture = c.getAttribute("texture"), this.texcoord = c.getAttribute("texcoord"), this.texOpts = {
						offsetU: 0,
						offsetV: 0,
						repeatU: 1,
						repeatV: 1,
						wrapU: 1,
						wrapV: 1
					}, this.parseTexture(c)
			}
		}
		return this
	};
	G.prototype.parseTexture = function (a) {
		if (!a.childNodes) return this;
		a.childNodes[1] && "extra" === a.childNodes[1].nodeName && (a = a.childNodes[1], a.childNodes[1] && "technique" === a.childNodes[1].nodeName && (a = a.childNodes[1]));
		for (var b = 0; b < a.childNodes.length; b++) {
			var c = a.childNodes[b];
			switch (c.nodeName) {
				case "offsetU":
				case "offsetV":
				case "repeatU":
				case "repeatV":
					this.texOpts[c.nodeName] = parseFloat(c.textContent);
					break;
				case "wrapU":
				case "wrapV":
					this.texOpts[c.nodeName] = parseInt(c.textContent);
					break;
				default:
					this.texOpts[c.nodeName] = c.textContent
			}
		}
		return this
	};
	I.prototype.parse = function (a) {
		for (var b = 0; b < a.childNodes.length; b++) {
			var c = a.childNodes[b];
			if (1 == c.nodeType) switch (c.nodeName) {
				case "ambient":
				case "emission":
				case "diffuse":
				case "specular":
				case "transparent":
					this[c.nodeName] = (new G).parse(c);
					break;
				case "shininess":
				case "reflectivity":
				case "index_of_refraction":
				case "transparency":
					var d;
					d = T.evaluate(".//dae:float", c, F, XPathResult.ORDERED_NODE_ITERATOR_TYPE, null);
					for (var e = d.iterateNext(), f = []; e;) f.push(e), e = d.iterateNext();
					d = f;
					0 < d.length && (this[c.nodeName] = parseFloat(d[0].textContent))
			}
		}
		this.create();
		return this
	};
	I.prototype.create = function () {
		var a = {}, b = void 0 !== this.transparency && 1 > this.transparency,
			c;
		for (c in this) switch (c) {
			case "ambient":
			case "emission":
			case "diffuse":
			case "specular":
				var d = this[c];
				if (d instanceof G) if (d.isTexture()) {
					var e = this.effect.sampler[d.texture].source;
					if (e && (e = qa[this.effect.surface[e].init_from])) e = THREE.ImageUtils.loadTexture($a + e.init_from), e.wrapS = d.texOpts.wrapU ? THREE.RepeatWrapping : THREE.ClampToEdgeWrapping, e.wrapT = d.texOpts.wrapV ? THREE.RepeatWrapping : THREE.ClampToEdgeWrapping, e.offset.x = d.texOpts.offsetU, e.offset.y = d.texOpts.offsetV, e.repeat.x = d.texOpts.repeatU, e.repeat.y = d.texOpts.repeatV, a.map = e, "emission" === c && (a.emissive = 16777215)
				} else if ("diffuse" === c || !b) "emission" === c ? a.emissive = d.color.getHex() : a[c] = d.color.getHex();
				break;
			case "shininess":
				a[c] = this[c];
				break;
			case "reflectivity":
				a[c] = this[c];
				0 < a[c] && (a.envMap = Aa.defaultEnvMap);
				a.combine = THREE.MixOperation;
				break;
			case "index_of_refraction":
				a.refractionRatio = this[c];
				1 !== this[c] && (a.envMap = Aa.defaultEnvMap);
				break;
			case "transparency":
				b && (a.transparent = !0, a.opacity = this[c], b = !0)
		}
		a.shading = wb;
		a.side = this.effect.doubleSided ? THREE.DoubleSide : THREE.FrontSide;
		switch (this.type) {
			case "constant":
				void 0 != a.emissive && (a.color = a.emissive);
				this.material = new THREE.MeshBasicMaterial(a);
				break;
			case "phong":
			case "blinn":
				void 0 != a.diffuse && (a.color = a.diffuse);
				this.material = new THREE.MeshPhongMaterial(a);
				break;
			default:
				void 0 != a.diffuse && (a.color = a.diffuse), this.material = new THREE.MeshLambertMaterial(a)
		}
		return this.material
	};
	V.prototype.parse = function (a) {
		for (var b = 0; b < a.childNodes.length; b++) {
			var c = a.childNodes[b];
			if (1 == c.nodeType) switch (c.nodeName) {
				case "init_from":
					this.init_from = c.textContent;
					break;
				case "format":
					this.format = c.textContent;
					break;
				default:
					console.log("unhandled Surface prop: " + c.nodeName)
			}
		}
		return this
	};
	E.prototype.parse = function (a) {
		for (var b = 0; b < a.childNodes.length; b++) {
			var c = a.childNodes[b];
			if (1 == c.nodeType) switch (c.nodeName) {
				case "source":
					this.source = c.textContent;
					break;
				case "minfilter":
					this.minfilter = c.textContent;
					break;
				case "magfilter":
					this.magfilter = c.textContent;
					break;
				case "mipfilter":
					this.mipfilter = c.textContent;
					break;
				case "wrap_s":
					this.wrap_s = c.textContent;
					break;
				case "wrap_t":
					this.wrap_t = c.textContent;
					break;
				default:
					console.log("unhandled Sampler2D prop: " + c.nodeName)
			}
		}
		return this
	};
	O.prototype.create = function () {
		if (null == this.shader) return null
	};
	O.prototype.parse = function (a) {
		this.id = a.getAttribute("id");
		this.name = a.getAttribute("name");
		L(this, a);
		this.shader = null;
		for (var b = 0; b < a.childNodes.length; b++) {
			var c = a.childNodes[b];
			if (1 == c.nodeType) switch (c.nodeName) {
				case "profile_COMMON":
					this.parseTechnique(this.parseProfileCOMMON(c))
			}
		}
		return this
	};
	O.prototype.parseNewparam = function (a) {
		for (var b = a.getAttribute("sid"), c = 0; c < a.childNodes.length; c++) {
			var d = a.childNodes[c];
			if (1 == d.nodeType) switch (d.nodeName) {
				case "surface":
					this.surface[b] = (new V(this)).parse(d);
					break;
				case "sampler2D":
					this.sampler[b] = (new E(this)).parse(d);
					break;
				case "extra":
					break;
				default:
					console.log(d.nodeName)
			}
		}
	};
	O.prototype.parseProfileCOMMON = function (a) {
		for (var b, c = 0; c < a.childNodes.length; c++) {
			var d = a.childNodes[c];
			if (1 == d.nodeType) switch (d.nodeName) {
				case "profile_COMMON":
					this.parseProfileCOMMON(d);
					break;
				case "technique":
					b = d;
					break;
				case "newparam":
					this.parseNewparam(d);
					break;
				case "image":
					d = (new g).parse(d);
					qa[d.id] = d;
					break;
				case "extra":
					break;
				default:
					console.log(d.nodeName)
			}
		}
		return b
	};
	O.prototype.parseTechnique = function (a) {
		for (var b = 0; b < a.childNodes.length; b++) {
			var c = a.childNodes[b];
			if (1 == c.nodeType) switch (c.nodeName) {
				case "constant":
				case "lambert":
				case "blinn":
				case "phong":
					this.shader = (new I(c.nodeName, this)).parse(c)
			}
		}
	};
	D.prototype.parse = function (a) {
		this.url = a.getAttribute("url").replace(/^#/, "");
		return this
	};
	J.prototype.parse = function (a) {
		this.id = a.getAttribute("id");
		this.name = a.getAttribute("name");
		this.source = {};
		for (var b = 0; b < a.childNodes.length; b++) {
			var c = a.childNodes[b];
			if (1 == c.nodeType) switch (c.nodeName) {
				case "animation":
					var c = (new J).parse(c),
						d;
					for (d in c.source) this.source[d] = c.source[d];
					for (var e = 0; e < c.channel.length; e++) this.channel.push(c.channel[e]), this.sampler.push(c.sampler[e]);
					break;
				case "source":
					d = (new A).parse(c);
					this.source[d.id] = d;
					break;
				case "sampler":
					this.sampler.push((new R(this)).parse(c));
					break;
				case "channel":
					this.channel.push((new P(this)).parse(c))
			}
		}
		return this
	};
	P.prototype.parse = function (a) {
		this.source = a.getAttribute("source").replace(/^#/, "");
		this.target = a.getAttribute("target");
		var b = this.target.split("/");
		b.shift();
		var a = b.shift(),
			c = 0 <= a.indexOf("."),
			d = 0 <= a.indexOf("(");
		if (c) b = a.split("."), this.sid = b.shift(), this.member = b.shift();
		else if (d) {
			b = a.split("(");
			this.sid = b.shift();
			for (var e = 0; e < b.length; e++) b[e] = parseInt(b[e].replace(/\)/, ""));
			this.arrIndices = b
		} else this.sid = a;
		this.fullSid = a;
		this.dotSyntax = c;
		this.arrSyntax = d;
		return this
	};
	R.prototype.parse = function (a) {
		this.id = a.getAttribute("id");
		this.inputs = [];
		for (var b = 0; b < a.childNodes.length; b++) {
			var c = a.childNodes[b];
			if (1 == c.nodeType) switch (c.nodeName) {
				case "input":
					this.inputs.push((new w).parse(c))
			}
		}
		return this
	};
	R.prototype.create = function () {
		for (var a = 0; a < this.inputs.length; a++) {
			var b = this.inputs[a],
				c = this.animation.source[b.source];
			switch (b.semantic) {
				case "INPUT":
					this.input = c.read();
					break;
				case "OUTPUT":
					this.output = c.read();
					this.strideOut = c.accessor.stride;
					break;
				case "INTERPOLATION":
					this.interpolation = c.read();
					break;
				case "IN_TANGENT":
					break;
				case "OUT_TANGENT":
					break;
				default:
					console.log(b.semantic)
			}
		}
		this.duration = this.endTime = this.startTime = 0;
		if (this.input.length) {
			this.startTime = 1E8;
			this.endTime = -1E8;
			for (a = 0; a < this.input.length; a++) this.startTime = Math.min(this.startTime, this.input[a]), this.endTime = Math.max(this.endTime, this.input[a]);
			this.duration = this.endTime - this.startTime
		}
	};
	R.prototype.getData = function (a, b) {
		var c;
		if ("matrix" === a && 16 === this.strideOut) c = this.output[b];
		else if (1 < this.strideOut) {
			c = [];
			for (var b = b * this.strideOut, d = 0; d < this.strideOut; ++d) c[d] = this.output[b + d];
			if (3 === this.strideOut) switch (a) {
				case "rotate":
				case "translate":
					da(c, -1);
					break;
				case "scale":
					da(c, 1)
			} else 4 === this.strideOut && "matrix" === a && da(c, -1)
		} else c = this.output[b];
		return c
	};
	Q.prototype.addTarget = function (a, b, c, d) {
		this.targets.push({
			sid: a,
			member: c,
			transform: b,
			data: d
		})
	};
	Q.prototype.apply = function (a) {
		for (var b = 0; b < this.targets.length; ++b) {
			var c = this.targets[b];
			(!a || c.sid === a) && c.transform.update(c.data, c.member)
		}
	};
	Q.prototype.getTarget = function (a) {
		for (var b = 0; b < this.targets.length; ++b) if (this.targets[b].sid === a) return this.targets[b];
		return null
	};
	Q.prototype.hasTarget = function (a) {
		for (var b = 0; b < this.targets.length; ++b) if (this.targets[b].sid === a) return !0;
		return !1
	};
	Q.prototype.interpolate = function (a, b) {
		for (var c = 0; c < this.targets.length; ++c) {
			var d = this.targets[c],
				e = a.getTarget(d.sid);
			if ("matrix" !== d.transform.type && e) {
				var f = (b - this.time) / (a.time - this.time),
					g = e.data,
					h = d.data;
				if (0 > f || 1 < f) console.log("Key.interpolate: Warning! Scale out of bounds:" + f), f = 0 > f ? 0 : 1;
				if (h.length) for (var e = [], i = 0; i < h.length; ++i) e[i] = h[i] + (g[i] - h[i]) * f;
				else e = h + (g - h) * f
			} else e = d.data;
			d.transform.update(e, d.member)
		}
	};
	N.prototype.parse = function (a) {
		this.id = a.getAttribute("id");
		this.name = a.getAttribute("name");
		for (var b = 0; b < a.childNodes.length; b++) {
			var c = a.childNodes[b];
			if (1 == c.nodeType) switch (c.nodeName) {
				case "optics":
					this.parseOptics(c)
			}
		}
		return this
	};
	N.prototype.parseOptics = function (a) {
		for (var b = 0; b < a.childNodes.length; b++) if ("technique_common" == a.childNodes[b].nodeName) for (var c = a.childNodes[b], d = 0; d < c.childNodes.length; d++) if (this.technique = c.childNodes[d].nodeName, "perspective" == this.technique) for (var e = c.childNodes[d], f = 0; f < e.childNodes.length; f++) {
			var g = e.childNodes[f];
			switch (g.nodeName) {
				case "yfov":
					this.yfov = g.textContent;
					break;
				case "xfov":
					this.xfov = g.textContent;
					break;
				case "znear":
					this.znear = g.textContent;
					break;
				case "zfar":
					this.zfar = g.textContent;
					break;
				case "aspect_ratio":
					this.aspect_ratio = g.textContent
			}
		} else if ("orthographic" == this.technique) {
			e = c.childNodes[d];
			for (f = 0; f < e.childNodes.length; f++) switch (g = e.childNodes[f], g.nodeName) {
				case "xmag":
					this.xmag = g.textContent;
					break;
				case "ymag":
					this.ymag = g.textContent;
					break;
				case "znear":
					this.znear = g.textContent;
					break;
				case "zfar":
					this.zfar = g.textContent;
					break;
				case "aspect_ratio":
					this.aspect_ratio = g.textContent
			}
		}
		return this
	};
	M.prototype.parse = function (a) {
		this.url = a.getAttribute("url").replace(/^#/, "");
		return this
	};
	return {
		load: function (b, c, d) {
			var e = 0;
			if (document.implementation && document.implementation.createDocument) {
				var f = new XMLHttpRequest;
				f.onreadystatechange = function () {
					if (4 == f.readyState) {
						if (0 == f.status || 200 == f.status) if (f.responseXML) Fa = c, a(f.responseXML, void 0, b);
						else if (f.responseText) {
							Fa = c;
							var g = (new DOMParser).parseFromString(f.responseText, "application/xml");
							a(g, void 0, b)
						} else console.error("ColladaLoader: Empty or non-existing file (" + b + ")")
					} else 3 == f.readyState && d && (0 == e && (e = f.getResponseHeader("Content-Length")), d({
						total: e,
						loaded: f.responseText.length
					}))
				};
				f.open("GET", b, !0);
				f.send(null)
			} else alert("Don't know how to parse XML!")
		},
		parse: a,
		setPreferredShading: function (a) {
			wb = a
		},
		applySkin: e,
		geometries: Ga,
		options: Aa
	}
};
THREE.MTLLoader = function (a, b) {
	THREE.EventDispatcher.call(this);
	this.baseUrl = a;
	this.options = b
};
THREE.MTLLoader.prototype = {
	load: function (a) {
		var b = this,
			c = new XMLHttpRequest;
		c.addEventListener("load", function (c) {
			200 === c.target.status || 0 === c.target.status ? (c = b.parse(c.target.responseText), b.dispatchEvent({
				type: "load",
				content: c
			})) : b.dispatchEvent({
				type: "error",
				message: "Couldn't load URL [" + a + "]",
				response: c.target.responseText
			})
		}, !1);
		c.addEventListener("progress", function (a) {
			b.dispatchEvent({
				type: "progress",
				loaded: a.loaded,
				total: a.total
			})
		}, !1);
		c.addEventListener("error", function () {
			b.dispatchEvent({
				type: "error",
				message: "Couldn't load URL [" + a + "]"
			})
		}, !1);
		c.open("GET", a, !0);
		c.send(null)
	},
	parse: function (a) {
		for (var b = a.split("\n"), c = {}, d = /\s+/, a = {}, e = 0; e < b.length; e++) {
			var f = b[e],
				f = f.trim();
			if (!(0 === f.length || "#" === f.charAt(0))) {
				var g = f.indexOf(" "),
					h = 0 <= g ? f.substring(0, g) : f,
					h = h.toLowerCase(),
					f = 0 <= g ? f.substring(g + 1) : "",
					f = f.trim();
				"newmtl" === h ? (c = {
					name: f
				}, a[f] = c) : c && ("ka" === h || "kd" === h || "ks" === h ? (f = f.split(d, 3), c[h] = [parseFloat(f[0]), parseFloat(f[1]), parseFloat(f[2])]) : c[h] = f)
			}
		}
		b = new THREE.MTLLoader.MaterialCreator(this.baseUrl,
		this.options);
		b.setMaterials(a);
		return b
	}
};
THREE.MTLLoader.MaterialCreator = function (a, b) {
	THREE.EventDispatcher.call(this);
	this.baseUrl = a;
	this.options = b;
	this.materialsInfo = {};
	this.materials = {};
	this.materialsArray = [];
	this.nameLookup = {};
	this.side = this.options && this.options.side ? this.options.side : THREE.FrontSide;
	this.wrap = this.options && this.options.wrap ? this.options.wrap : THREE.RepeatWrapping
};
THREE.MTLLoader.MaterialCreator.prototype = {
	setMaterials: function (a) {
		this.materialsInfo = this.convert(a);
		this.materials = {};
		this.materialsArray = [];
		this.nameLookup = {}
	},
	convert: function (a) {
		if (!this.options) return a;
		var b = {}, c;
		for (c in a) {
			var d = a[c],
				e = {};
			b[c] = e;
			for (var f in d) {
				var g = !0,
					h = d[f],
					i = f.toLowerCase();
				switch (i) {
					case "kd":
					case "ka":
					case "ks":
						this.options && this.options.normalizeRGB && (h = [h[0] / 255, h[1] / 255, h[2] / 255]);
						this.options && this.options.ignoreZeroRGBs && 0 === h[0] && (0 === h[1] && 0 === h[1]) && (g = !1);
						break;
					case "d":
						this.options && this.options.invertTransparency && (h = 1 - h)
				}
				g && (e[i] = h)
			}
		}
		return b
	},
	preload: function () {
		for (var a in this.materialsInfo) this.create(a)
	},
	getIndex: function (a) {
		return this.nameLookup[a]
	},
	getAsArray: function () {
		var a = 0,
			b;
		for (b in this.materialsInfo) this.materialsArray[a] = this.create(b), this.nameLookup[b] = a, a++;
		return this.materialsArray
	},
	create: function (a) {
		void 0 === this.materials[a] && this.createMaterial_(a);
		return this.materials[a]
	},
	createMaterial_: function (a) {
		var b = this.materialsInfo[a],
			c = {
				name: a,
				side: this.side
			}, d;
		for (d in b) {
			var e = b[d];
			switch (d.toLowerCase()) {
				case "kd":
					c.diffuse = (new THREE.Color).setRGB(e[0], e[1], e[2]);
					break;
				case "ka":
					c.ambient = (new THREE.Color).setRGB(e[0], e[1], e[2]);
					break;
				case "ks":
					c.specular = (new THREE.Color).setRGB(e[0], e[1], e[2]);
					break;
				case "map_kd":
					c.map = THREE.MTLLoader.loadTexture(this.baseUrl + e);
					c.map.wrapS = this.wrap;
					c.map.wrapT = this.wrap;
					break;
				case "ns":
					c.shininess = e;
					break;
				case "d":
					1 > e && (c.transparent = !0, c.opacity = e)
			}
		}
		c.diffuse && (c.ambient || (c.ambient = c.diffuse), c.color = c.diffuse);
		this.materials[a] = new THREE.MeshPhongMaterial(c);
		return this.materials[a]
	}
};
THREE.MTLLoader.loadTexture = function (a, b, c, d) {
	if (a.toLowerCase().endsWith(".dds")) var e = THREE.ImageUtils.loadCompressedTexture(a, b, c, d);
	else {
		var f = new Image,
			e = new THREE.Texture(f, b),
			b = new THREE.ImageLoader;
		b.addEventListener("load", function (a) {
			e.image = THREE.MTLLoader.ensurePowerOfTwo_(a.content);
			e.needsUpdate = !0;
			c && c(e)
		});
		b.addEventListener("error", function (a) {
			d && d(a.message)
		});
		b.crossOrigin = this.crossOrigin;
		b.load(a, f)
	}
	return e
};
THREE.MTLLoader.ensurePowerOfTwo_ = function (a) {
	if (!THREE.MTLLoader.isPowerOfTwo_(a.width) || !THREE.MTLLoader.isPowerOfTwo_(a.height)) {
		var b = document.createElement("canvas");
		b.width = THREE.MTLLoader.nextHighestPowerOfTwo_(a.width);
		b.height = THREE.MTLLoader.nextHighestPowerOfTwo_(a.height);
		b.getContext("2d").drawImage(a, 0, 0, a.width, a.height, 0, 0, b.width, b.height);
		return b
	}
	return a
};
THREE.MTLLoader.isPowerOfTwo_ = function (a) {
	return 0 === (a & a - 1)
};
THREE.MTLLoader.nextHighestPowerOfTwo_ = function (a) {
	--a;
	for (var b = 1; 32 > b; b <<= 1) a |= a >> b;
	return a + 1
};
THREE.OBJLoader = function () {
	THREE.EventDispatcher.call(this)
};
THREE.OBJLoader.prototype = {
	constructor: THREE.OBJLoader,
	load: function (a, b) {
		var c = this,
			d = new XMLHttpRequest;
		d.addEventListener("load", function (a) {
			a = c.parse(a.target.responseText);
			c.dispatchEvent({
				type: "load",
				content: a
			});
			b && b(a)
		}, !1);
		d.addEventListener("progress", function (a) {
			c.dispatchEvent({
				type: "progress",
				loaded: a.loaded,
				total: a.total
			})
		}, !1);
		d.addEventListener("error", function () {
			c.dispatchEvent({
				type: "error",
				message: "Couldn't load URL [" + a + "]"
			})
		}, !1);
		d.open("GET", a, !0);
		d.send(null)
	},
	parse: function (a) {
		function b(a,
		b, c) {
			return new THREE.Vector3(a, b, c)
		}
		function c(a, b) {
			return new THREE.Vector2(a, b)
		}
		function d(a, b, c, d) {
			return new THREE.Face3(a, b, c, d)
		}
		function e(a, b, c, d, e) {
			return new THREE.Face4(a, b, c, d, e)
		}
		var f = new THREE.Object3D,
			g = [],
			h = [],
			i = [],
			k, j;
		for (k = /v( +[\d|\.|\+|\-|e]+)( [\d|\.|\+|\-|e]+)( [\d|\.|\+|\-|e]+)/g; null != (j = k.exec(a));) g.push(b(parseFloat(j[1]), parseFloat(j[2]), parseFloat(j[3])));
		for (k = /vn( +[\d|\.|\+|\-|e]+)( [\d|\.|\+|\-|e]+)( [\d|\.|\+|\-|e]+)/g; null != (j = k.exec(a));) h.push(b(parseFloat(j[1]),
		parseFloat(j[2]), parseFloat(j[3])));
		for (k = /vt( +[\d|\.|\+|\-|e]+)( [\d|\.|\+|\-|e]+)/g; null != (j = k.exec(a));) i.push(c(parseFloat(j[1]), parseFloat(j[2])));
		for (var a = a.split("\no "), l = 0, m = a.length; l < m; l++) {
			var r = a[l],
				q = new THREE.Geometry;
			q.vertices = g;
			for (k = /f( +[\d]+)( [\d]+)( [\d]+)( [\d]+)?/g; null != (j = k.exec(r));) void 0 === j[4] ? q.faces.push(d(parseInt(j[1]) - 1, parseInt(j[2]) - 1, parseInt(j[3]) - 1)) : q.faces.push(e(parseInt(j[1]) - 1, parseInt(j[2]) - 1, parseInt(j[3]) - 1, parseInt(j[4]) - 1));
			for (k = /f( +([\d]+)\/([\d]+))( ([\d]+)\/([\d]+))( ([\d]+)\/([\d]+))( ([\d]+)\/([\d]+))?/g; null != (j = k.exec(r));) void 0 === j[10] ? (q.faces.push(d(parseInt(j[2]) - 1, parseInt(j[5]) - 1, parseInt(j[8]) - 1)), q.faceVertexUvs[0].push([i[parseInt(j[3]) - 1], i[parseInt(j[6]) - 1], i[parseInt(j[9]) - 1]])) : (q.faces.push(e(parseInt(j[2]) - 1, parseInt(j[5]) - 1, parseInt(j[8]) - 1, parseInt(j[11]) - 1)), q.faceVertexUvs[0].push([i[parseInt(j[3]) - 1], i[parseInt(j[6]) - 1], i[parseInt(j[9]) - 1], i[parseInt(j[12]) - 1]]));
			for (k = /f( +([\d]+)\/([\d]+)\/([\d]+))( ([\d]+)\/([\d]+)\/([\d]+))( ([\d]+)\/([\d]+)\/([\d]+))( ([\d]+)\/([\d]+)\/([\d]+))?/g; null != (j = k.exec(r));) void 0 === j[13] ? (q.faces.push(d(parseInt(j[2]) - 1, parseInt(j[6]) - 1, parseInt(j[10]) - 1, [h[parseInt(j[4]) - 1], h[parseInt(j[8]) - 1], h[parseInt(j[12]) - 1]])), q.faceVertexUvs[0].push([i[parseInt(j[3]) - 1], i[parseInt(j[7]) - 1], i[parseInt(j[11]) - 1]])) : (q.faces.push(e(parseInt(j[2]) - 1, parseInt(j[6]) - 1, parseInt(j[10]) - 1, parseInt(j[14]) - 1, [h[parseInt(j[4]) - 1], h[parseInt(j[8]) - 1], h[parseInt(j[12]) - 1], h[parseInt(j[16]) - 1]])), q.faceVertexUvs[0].push([i[parseInt(j[3]) - 1], i[parseInt(j[7]) - 1], i[parseInt(j[11]) - 1], i[parseInt(j[15]) - 1]]));
			for (k = /f( +([\d]+)\/\/([\d]+))( ([\d]+)\/\/([\d]+))( ([\d]+)\/\/([\d]+))( ([\d]+)\/\/([\d]+))?/g; null != (j = k.exec(r));) void 0 === j[10] ? q.faces.push(d(parseInt(j[2]) - 1, parseInt(j[5]) - 1, parseInt(j[8]) - 1, [h[parseInt(j[3]) - 1], h[parseInt(j[6]) - 1], h[parseInt(j[9]) - 1]])) : q.faces.push(e(parseInt(j[2]) - 1, parseInt(j[5]) - 1, parseInt(j[8]) - 1, parseInt(j[11]) - 1, [h[parseInt(j[3]) - 1], h[parseInt(j[6]) - 1], h[parseInt(j[9]) - 1], h[parseInt(j[12]) - 1]]));
			q.computeCentroids();
			q.computeFaceNormals();
			q.computeBoundingSphere();
			f.add(new THREE.Mesh(q, new THREE.MeshLambertMaterial))
		}
		return f
	}
};
THREE.OBJMTLLoader = function () {
	THREE.EventDispatcher.call(this)
};
THREE.OBJMTLLoader.prototype = {
	constructor: THREE.OBJMTLLoader,
	load: function (a, b, c) {
		function d(c) {
			"load" === c.type ? c.content instanceof THREE.MTLLoader.MaterialCreator ? (g = !0, i = c.content, i.preload()) : 200 === c.target.status || 0 === c.target.status ? (c = c.target.responseText, h = b ? e.parse(c) : e.parse(c, function (a) {
				g = !1;
				k.load(k.baseUrl + a)
			})) : e.dispatchEvent({
				type: "error",
				message: "Couldn't load URL [" + a + "]",
				response: c.target.responseText
			}) : "error" === c.type && (g = !0);
			g && h && (i && h.traverse(function (a) {
				if (a instanceof
				THREE.Mesh && a.material.name) {
					var b = i.create(a.material.name);
					b && (a.material = b)
				}
			}), e.dispatchEvent({
				type: "load",
				content: h
			}))
		}
		var e = this,
			f = new XMLHttpRequest,
			g, h, i, k = new THREE.MTLLoader(a.substr(0, a.lastIndexOf("/") + 1), c);
		k.addEventListener("load", d);
		k.addEventListener("error", d);
		b ? (k.load(b), g = !1) : g = !0;
		f.addEventListener("load", d, !1);
		f.addEventListener("progress", function (a) {
			e.dispatchEvent({
				type: "progress",
				loaded: a.loaded,
				total: a.total
			})
		}, !1);
		f.addEventListener("error", function () {
			e.dispatchEvent({
				type: "error",
				message: "Couldn't load URL [" + a + "]"
			})
		}, !1);
		f.open("GET", a, !0);
		f.send(null)
	},
	parse: function (a, b) {
		function c(a, b, c) {
			return new THREE.Vector3(a, b, c)
		}
		function d(a, b) {
			return new THREE.Vector2(a, b)
		}
		function e(a, b, c, d) {
			return new THREE.Face3(a, b, c, d)
		}
		function f(a, b, c, d, e) {
			return new THREE.Face4(a, b, c, d, e)
		}
		function g(a, b) {
			b.geometry.computeCentroids();
			b.geometry.computeFaceNormals();
			b.geometry.computeBoundingSphere();
			a.add(new THREE.Mesh(b.geometry, b.material))
		}
		var h = [],
			i = [],
			k = [],
			j = /v( +[\d|\.|\+|\-|e]+)( [\d|\.|\+|\-|e]+)( [\d|\.|\+|\-|e]+)/,
			l = /vn( +[\d|\.|\+|\-|e]+)( [\d|\.|\+|\-|e]+)( [\d|\.|\+|\-|e]+)/,
			m = /vt( +[\d|\.|\+|\-|e]+)( [\d|\.|\+|\-|e]+)/,
			r = /f( +[\d]+)( [\d]+)( [\d]+)( [\d]+)?/,
			q = /f( +([\d]+)\/([\d]+))( ([\d]+)\/([\d]+))( ([\d]+)\/([\d]+))( ([\d]+)\/([\d]+))?/,
			p = /f( +([\d]+)\/([\d]+)\/([\d]+))( ([\d]+)\/([\d]+)\/([\d]+))( ([\d]+)\/([\d]+)\/([\d]+))( ([\d]+)\/([\d]+)\/([\d]+))?/,
			t = /f( +([\d]+)\/\/([\d]+))( ([\d]+)\/\/([\d]+))( ([\d]+)\/\/([\d]+))( ([\d]+)\/\/([\d]+))?/,
			u = new THREE.Object3D,
			x = new THREE.Geometry;
		x.vertices = h;
		for (var v = {
			material: new THREE.MeshLambertMaterial,
			geometry: x
		}, s = a.split("\n"), C = 0; C < s.length; C++) {
			var z = s[C],
				z = z.trim(),
				w;
			0 === z.length || "#" === z.charAt(0) || (null !== (w = j.exec(z)) ? h.push(c(parseFloat(w[1]), parseFloat(w[2]), parseFloat(w[3]))) : null !== (w = l.exec(z)) ? i.push(c(parseFloat(w[1]), parseFloat(w[2]), parseFloat(w[3]))) : null !== (w = m.exec(z)) ? k.push(d(parseFloat(w[1]), parseFloat(w[2]))) : null !== (w = r.exec(z)) ? void 0 === w[4] ? x.faces.push(e(parseInt(w[1]) - 1, parseInt(w[2]) - 1, parseInt(w[3]) - 1)) : x.faces.push(f(parseInt(w[1]) - 1, parseInt(w[2]) - 1, parseInt(w[3]) - 1, parseInt(w[4]) - 1)) : null !== (w = q.exec(z)) ? void 0 === w[10] ? (x.faces.push(e(parseInt(w[2]) - 1, parseInt(w[5]) - 1, parseInt(w[8]) - 1)), x.faceVertexUvs[0].push([k[parseInt(w[3]) - 1], k[parseInt(w[6]) - 1], k[parseInt(w[9]) - 1]])) : (x.faces.push(f(parseInt(w[2]) - 1, parseInt(w[5]) - 1, parseInt(w[8]) - 1, parseInt(w[11]) - 1)), x.faceVertexUvs[0].push([k[parseInt(w[3]) - 1], k[parseInt(w[6]) - 1], k[parseInt(w[9]) - 1], k[parseInt(w[12]) - 1]])) : null !== (w = p.exec(z)) ? void 0 === w[13] ? (x.faces.push(e(parseInt(w[2]) - 1, parseInt(w[6]) - 1, parseInt(w[10]) - 1, [i[parseInt(w[4]) - 1], i[parseInt(w[8]) - 1], i[parseInt(w[12]) - 1]])), x.faceVertexUvs[0].push([k[parseInt(w[3]) - 1], k[parseInt(w[7]) - 1], k[parseInt(w[11]) - 1]])) : (x.faces.push(f(parseInt(w[2]) - 1, parseInt(w[6]) - 1, parseInt(w[10]) - 1, parseInt(w[14]) - 1, [i[parseInt(w[4]) - 1], i[parseInt(w[8]) - 1], i[parseInt(w[12]) - 1], i[parseInt(w[16]) - 1]])), x.faceVertexUvs[0].push([k[parseInt(w[3]) - 1], k[parseInt(w[7]) - 1], k[parseInt(w[11]) - 1], k[parseInt(w[15]) - 1]])) : null !== (w = t.exec(z)) ? void 0 === w[10] ? x.faces.push(e(parseInt(w[2]) - 1, parseInt(w[5]) - 1, parseInt(w[8]) - 1, [i[parseInt(w[3]) - 1], i[parseInt(w[6]) - 1], i[parseInt(w[9]) - 1]])) : x.faces.push(f(parseInt(w[2]) - 1, parseInt(w[5]) - 1, parseInt(w[8]) - 1, parseInt(w[11]) - 1, [i[parseInt(w[3]) - 1], i[parseInt(w[6]) - 1], i[parseInt(w[9]) - 1], i[parseInt(w[12]) - 1]])) : z.startsWith("usemtl ") ? (z = z.substring(7), z = z.trim(), w = new THREE.MeshLambertMaterial, w.name = z, 0 < x.faces.length && (g(u, v), x = new THREE.Geometry, x.vertices = h, v = {
				geometry: x
			}), v.material = w) : z.startsWith("g ") ? (z = z.substring(2), z = z.trim()) : z.startsWith("o ") ? (z = z.substring(2), z = z.trim()) : z.startsWith("s ") || (z.startsWith("mtllib ") ? b && (z = z.substring(7), z = z.trim(), b(z)) : console.error("Unhandled line " + z)))
		}
		g(u, v);
		return u
	}
};
THREE.STLLoader = function () {
	THREE.EventDispatcher.call(this)
};
THREE.STLLoader.prototype = {
	constructor: THREE.STLLoader,
	load: function (a, b) {
		var c = this,
			d = new XMLHttpRequest;
		d.addEventListener("load", function (a) {
			a = c.parse(a.target.responseText);
			c.dispatchEvent({
				type: "load",
				content: a
			});
			b && b(a)
		}, !1);
		d.addEventListener("progress", function (a) {
			c.dispatchEvent({
				type: "progress",
				loaded: a.loaded,
				total: a.total
			})
		}, !1);
		d.addEventListener("error", function () {
			c.dispatchEvent({
				type: "error",
				message: "Couldn't load URL [" + a + "]"
			})
		}, !1);
		d.open("GET", a, !0);
		d.send(null)
	},
	parse: function (a) {
		for (var b = new THREE.Geometry, c = /facet([\s\S]*?)endfacet/g, d; null != (d = c.exec(a));) {
			for (var e = d[0], f = /normal[\s]+([-+]?[0-9]+\.?[0-9]*([eE][-+]?[0-9]+)?)+[\s]+([-+]?[0-9]*\.?[0-9]+([eE][-+]?[0-9]+)?)+[\s]+([-+]?[0-9]*\.?[0-9]+([eE][-+]?[0-9]+)?)+/g; null != (d = f.exec(e));) var g = new THREE.Vector3(d[1], d[3], d[5]);
			for (f = /vertex[\s]+([-+]?[0-9]+\.?[0-9]*([eE][-+]?[0-9]+)?)+[\s]+([-+]?[0-9]*\.?[0-9]+([eE][-+]?[0-9]+)?)+[\s]+([-+]?[0-9]*\.?[0-9]+([eE][-+]?[0-9]+)?)+/g; null != (d = f.exec(e));) b.vertices.push(new THREE.Vector3(d[1],
			d[3], d[5]));
			d = b.vertices.length;
			b.faces.push(new THREE.Face3(d - 3, d - 2, d - 1, g))
		}
		b.computeCentroids();
		b.computeBoundingSphere();
		return b
	}
};
THREE.UTF8Loader = function () {};
THREE.UTF8Loader.prototype.load = function (a, b, c) {
	this.downloadModelJson(a, c, b)
};
THREE.UTF8Loader.BufferGeometryCreator = function () {};
THREE.UTF8Loader.BufferGeometryCreator.prototype.create = function (a, b) {
	var c = b.length / 3,
		d = new THREE.BufferGeometry,
		e = new Float32Array(9 * c),
		f = new Float32Array(9 * c),
		c = new Float32Array(6 * c),
		g, h, i, k, j, l = a.length;
	for (g = h = 0; g < l; g += 8) i = a[g], k = a[g + 1], j = a[g + 2], e[h++] = i, e[h++] = k, e[h++] = j;
	h = 0;
	for (g = 3; g < l; g += 8) i = a[g], k = a[g + 1], c[h++] = i, c[h++] = k;
	h = 0;
	for (g = 5; g < l; g += 8) i = a[g], k = a[g + 1], j = a[g + 2], f[h++] = i, f[h++] = k, f[h++] = j;
	g = d.attributes;
	g.index = {
		itemSize: 1,
		array: b,
		numItems: b.length
	};
	g.position = {
		itemSize: 3,
		array: e,
		numItems: e.length
	};
	g.normal = {
		itemSize: 3,
		array: f,
		numItems: f.length
	};
	g.uv = {
		itemSize: 2,
		array: c,
		numItems: c.length
	};
	d.offsets = [{
		start: 0,
		count: b.length,
		index: 0
	}];
	d.computeBoundingSphere();
	return d
};
THREE.UTF8Loader.GeometryCreator = function () {};
THREE.UTF8Loader.GeometryCreator.prototype = {
	create: function (a, b) {
		var c = new THREE.Geometry;
		this.init_vertices(c, a, 8, 0);
		var d = this.init_uvs(a, 8, 3),
			e = this.init_normals(a, 8, 5);
		this.init_faces(c, e, d, b);
		c.computeCentroids();
		c.computeFaceNormals();
		return c
	},
	init_vertices: function (a, b, c, d) {
		for (var e, f, g, h = b.length; d < h; d += c) e = b[d], f = b[d + 1], g = b[d + 2], this.addVertex(a, e, f, g)
	},
	init_normals: function (a, b, c) {
		for (var d = [], e, f, g, h = a.length; c < h; c += b) e = a[c], f = a[c + 1], g = a[c + 2], d.push(e, f, g);
		return d
	},
	init_uvs: function (a,
	b, c) {
		for (var d = [], e, f, g = a.length; c < g; c += b) e = a[c], f = a[c + 1], d.push(e, f);
		return d
	},
	init_faces: function (a, b, c, d) {
		var e, f, g, h, i, k, j, l = d.length;
		for (e = 0; e < l; e += 3) f = d[e], g = d[e + 1], h = d[e + 2], this.f3n(a, b, f, g, h, 0, f, g, h), i = c[2 * f], f = c[2 * f + 1], k = c[2 * g], g = c[2 * g + 1], j = c[2 * h], h = c[2 * h + 1], this.uv3(a.faceVertexUvs[0], i, f, k, g, j, h)
	},
	addVertex: function (a, b, c, d) {
		a.vertices.push(new THREE.Vector3(b, c, d))
	},
	f3n: function (a, b, c, d, e, f, g, h, i) {
		var k = b[3 * h],
			j = b[3 * h + 1],
			l = b[3 * h + 2],
			h = b[3 * i],
			m = b[3 * i + 1],
			i = b[3 * i + 2],
			b = new THREE.Vector3(b[3 * g], b[3 * g + 1], b[3 * g + 2]),
			k = new THREE.Vector3(k, j, l),
			j = new THREE.Vector3(h, m, i);
		a.faces.push(new THREE.Face3(c, d, e, [b, k, j], null, f))
	},
	uv3: function (a, b, c, d, e, f, g) {
		var h = [];
		h.push(new THREE.Vector2(b, c));
		h.push(new THREE.Vector2(d, e));
		h.push(new THREE.Vector2(f, g));
		a.push(h)
	}
};
var DEFAULT_DECODE_PARAMS = {
	decodeOffsets: [-4095, -4095, -4095, 0, 0, -511, -511, -511],
	decodeScales: [1 / 8191, 1 / 8191, 1 / 8191, 1 / 1023, 1 / 1023, 1 / 1023, 1 / 1023, 1 / 1023]
};
THREE.UTF8Loader.prototype.decompressAttribsInner_ = function (a, b, c, d, e, f, g, h) {
	for (var i = 0; b < c; b++) {
		var k = a.charCodeAt(b),
			i = i + (k >> 1 ^ -(k & 1));
		d[e] = h * (i + g);
		e += f
	}
};
THREE.UTF8Loader.prototype.decompressIndices_ = function (a, b, c, d, e) {
	for (var f = 0, g = 0; g < c; g++) {
		var h = a.charCodeAt(b++);
		d[e++] = f - h;
		0 === h && f++
	}
};
THREE.UTF8Loader.prototype.decompressAABBs_ = function (a, b, c, d, e) {
	for (var f = 6 * c, c = b + f, g = 0, f = new Float32Array(f); b < c; b += 6) {
		var h = a.charCodeAt(b + 0) + d[0],
			i = a.charCodeAt(b + 1) + d[1],
			k = a.charCodeAt(b + 2) + d[2],
			j = a.charCodeAt(b + 3) + 1 >> 1,
			l = a.charCodeAt(b + 4) + 1 >> 1,
			m = a.charCodeAt(b + 5) + 1 >> 1;
		f[g++] = e[0] * (h + j);
		f[g++] = e[1] * (i + l);
		f[g++] = e[2] * (k + m);
		f[g++] = e[0] * j;
		f[g++] = e[1] * l;
		f[g++] = e[2] * m
	}
	return f
};
THREE.UTF8Loader.prototype.decompressMesh = function (a, b, c, d, e, f) {
	for (var g = c.decodeScales.length, h = c.decodeOffsets, c = c.decodeScales, i = b.attribRange[1], k = b.attribRange[0], j = new Float32Array(g * i), l = 0; l < g; l++) {
		var m = k + i,
			r = c[l];
		r && this.decompressAttribsInner_(a, k, m, j, l, g, h[l], r);
		k = m
	}
	i = 3 * b.indexRange[1];
	g = new Uint16Array(i);
	this.decompressIndices_(a, k, i, g, 0);
	k = void 0;
	(i = b.bboxes) && (k = this.decompressAABBs_(a, i, b.names.length, h, c));
	f(d, e, j, g, k, b)
};
THREE.UTF8Loader.prototype.copyAttrib = function (a, b, c, d) {
	for (var e = 0; e < a; e++) c[e] = b[a * d + e]
};
THREE.UTF8Loader.prototype.decodeAttrib2 = function (a, b, c, d, e, f, g, h, i, k) {
	for (var j = 0; 5 > j; j++) {
		var l = a.charCodeAt(e + f * j + k);
		i[j] += l >> 1 ^ -(l & 1);
		h[b * k + j] = i[j];
		g[b * k + j] = d[j] * (i[j] + c[j])
	}
};
THREE.UTF8Loader.prototype.accumulateNormal = function (a, b, c, d, e) {
	var f = d[8 * a],
		g = d[8 * a + 1],
		h = d[8 * a + 2],
		i = d[8 * b],
		k = d[8 * b + 1],
		j = d[8 * b + 2],
		l = d[8 * c],
		m = d[8 * c + 1],
		d = d[8 * c + 2],
		i = i - f,
		k = k - g,
		j = j - h,
		l = l - f,
		m = m - g,
		d = d - h,
		f = k * d - j * m,
		g = j * l - i * d,
		h = i * m - k * l;
	e[3 * a] += f;
	e[3 * a + 1] += g;
	e[3 * a + 2] += h;
	e[3 * b] += f;
	e[3 * b + 1] += g;
	e[3 * b + 2] += h;
	e[3 * c] += f;
	e[3 * c + 1] += g;
	e[3 * c + 2] += h
};
THREE.UTF8Loader.prototype.decompressMesh2 = function (a, b, c, d, e, f) {
	for (var g = c.decodeScales.length, h = c.decodeOffsets, i = c.decodeScales, c = b.attribRange[0], k = b.attribRange[1], j = b.codeRange[0], l = 3 * b.codeRange[2], m = new Uint16Array(l), r = new Int32Array(3 * k), q = new Uint16Array(g), p = new Uint16Array(g * k), t = new Float32Array(g * k), u = 0, x = 0, v = 0; v < l; v += 3) {
		var s = a.charCodeAt(j++),
			C = Math.min(v, 96);
		if (s < C) {
			var z = s % 3,
				s = v - (s - z),
				w, A, H;
			switch (z) {
				case 0:
					w = m[s + 2];
					A = m[s + 1];
					H = m[s + 0];
					break;
				case 1:
					w = m[s + 0];
					A = m[s + 2];
					H = m[s + 1];
					break;
				case 2:
					w = m[s + 1], A = m[s + 0], H = m[s + 2]
			}
			m[x++] = w;
			m[x++] = A;
			s = a.charCodeAt(j++);
			z = u - s;
			m[x++] = z;
			if (0 === s) {
				for (s = 0; 5 > s; s++) C = a.charCodeAt(c + k * s + u), C = (C >> 1 ^ -(C & 1)) + p[g * w + s] + p[g * A + s] - p[g * H + s], q[s] = C, p[g * u + s] = C, t[g * u + s] = i[s] * (C + h[s]);
				u++
			} else this.copyAttrib(g, p, q, z);
			this.accumulateNormal(w, A, z, p, r)
		} else {
			z = u - (s - C);
			m[x++] = z;
			s === C ? this.decodeAttrib2(a, g, h, i, c, k, t, p, q, u++) : this.copyAttrib(g, p, q, z);
			s = a.charCodeAt(j++);
			C = u - s;
			m[x++] = C;
			0 === s ? this.decodeAttrib2(a, g, h, i, c, k, t, p, q, u++) : this.copyAttrib(g, p, q, C);
			var s = a.charCodeAt(j++),
				G = u - s;
			m[x++] = G;
			if (0 === s) {
				for (s = 0; 5 > s; s++) q[s] = (p[g * z + s] + p[g * C + s]) / 2;
				this.decodeAttrib2(a, g, h, i, c, k, t, p, q, u++)
			} else this.copyAttrib(g, p, q, G);
			this.accumulateNormal(z, C, G, p, r)
		}
	}
	for (v = 0; v < k; v++) h = r[3 * v], w = r[3 * v + 1], A = r[3 * v + 2], H = 511 / Math.sqrt(h * h + w * w + A * A), i = a.charCodeAt(c + 5 * k + v), j = a.charCodeAt(c + 6 * k + v), l = a.charCodeAt(c + 7 * k + v), t[g * v + 5] = H * h + (i >> 1 ^ -(i & 1)), t[g * v + 6] = H * w + (j >> 1 ^ -(j & 1)), t[g * v + 7] = H * A + (l >> 1 ^ -(l & 1));
	f(d, e, t, m, void 0, b)
};
THREE.UTF8Loader.prototype.downloadMesh = function (a, b, c, d, e) {
	function f(a) {
		for (; h < c.length;) {
			var f = c[h],
				j = f.indexRange;
			if (j) {
				j = j[0] + 3 * j[1];
				if (a.responseText.length < j) break;
				g.decompressMesh(a.responseText, f, d, b, h, e)
			} else {
				j = f.codeRange;
				j = j[0] + j[1];
				if (a.responseText.length < j) break;
				g.decompressMesh2(a.responseText, f, d, b, h, e)
			}++h
		}
	}
	var g = this,
		h = 0;
	getHttpRequest(a, function (a, b) {
		(200 === a.status || 0 === a.status) && f(a, b)
	}, f)
};
THREE.UTF8Loader.prototype.downloadMeshes = function (a, b, c, d) {
	for (var e in b) this.downloadMesh(a + e, e, b[e], c, d)
};
THREE.UTF8Loader.prototype.createMeshCallback = function (a, b, c) {
	var d = 0,
		e = 0,
		f = {}, g = {}, h = {}, i = b.urls,
		k;
	for (k in i) f[k] = i[k].length, g[k] = 0, e++, h[k] = new THREE.Object3D;
	var j = new THREE.Object3D,
		l = new THREE.MTLLoader.MaterialCreator(a, b.options);
	l.setMaterials(b.materials);
	l.preload();
	var m = new THREE.UTF8Loader.GeometryCreator,
		r = new THREE.UTF8Loader.BufferGeometryCreator;
	return function (a, i, k, u, x, v) {
		i = (void 0 !== b.options.useBuffers ? b.options.useBuffers : 1) ? r.create(k, u) : m.create(k, u);
		v = l.create(v.material);
		v = new THREE.Mesh(i, v);
		h[a].add(v);
		g[a]++;
		g[a] === f[a] && (d++, j.add(h[a]), d === e && c(j))
	}
};
THREE.UTF8Loader.prototype.downloadModel = function (a, b, c, d) {
	b = this.createMeshCallback(b, c, d);
	this.downloadMeshes(a, c.urls, c.decodeParams, b)
};
THREE.UTF8Loader.prototype.downloadModelJson = function (a, b, c) {
	getJsonRequest(a, function (d) {
		d.decodeParams || (d.decodeParams = b && b.decodeParams ? b.decodeParams : DEFAULT_DECODE_PARAMS);
		d.options = b;
		var e = a.substr(0, a.lastIndexOf("/") + 1),
			f = e;
		b && b.geometryBase && (e = b.geometryBase, "/" !== e.charAt(e.length - 1) && (e += "/"));
		b && b.materialBase && (f = b.materialBase, "/" !== f.charAt(f.length - 1) && (f += "/"));
		this.downloadModel(e, f, d, c)
	}.bind(this))
};

function getHttpRequest(a, b, c) {
	var d = new XMLHttpRequest;
	addListeners(d, {
		load: function (a) {
			b(d, a)
		},
		progress: function (a) {
			c(d, a)
		}
	});
	d.open("GET", a, !0);
	d.send(null)
}
function getJsonRequest(a, b) {
	getHttpRequest(a, function (a) {
		b(JSON.parse(a.responseText))
	}, function () {})
}
function addListeners(a, b) {
	for (var c in b) a.addEventListener(c, b[c])
};
THREE.VTKLoader = function () {
	THREE.EventDispatcher.call(this)
};
THREE.VTKLoader.prototype = {
	constructor: THREE.VTKLoader,
	load: function (a, b) {
		var c = this,
			d = new XMLHttpRequest;
		d.addEventListener("load", function (a) {
			a = c.parse(a.target.responseText);
			c.dispatchEvent({
				type: "load",
				content: a
			});
			b && b(a)
		}, !1);
		d.addEventListener("progress", function (a) {
			c.dispatchEvent({
				type: "progress",
				loaded: a.loaded,
				total: a.total
			})
		}, !1);
		d.addEventListener("error", function () {
			c.dispatchEvent({
				type: "error",
				message: "Couldn't load URL [" + a + "]"
			})
		}, !1);
		d.open("GET", a, !0);
		d.send(null)
	},
	parse: function (a) {
		var b = new THREE.Geometry,
			c, d;
		for (c = /([\+|\-]?[\d]+[\.][\d|\-|e]+)[ ]+([\+|\-]?[\d]+[\.][\d|\-|e]+)[ ]+([\+|\-]?[\d]+[\.][\d|\-|e]+)/g; null != (d = c.exec(a));) {
			var e = parseFloat(d[1]),
				f = parseFloat(d[2]);
			d = parseFloat(d[3]);
			b.vertices.push(new THREE.Vector3(e, f, d))
		}
		for (c = /3[ ]+([\d]+)[ ]+([\d]+)[ ]+([\d]+)/g; null != (d = c.exec(a));) e = parseInt(d[1]), f = parseInt(d[2]), d = parseInt(d[3]), b.faces.push(new THREE.Face3(e, f, d));
		for (c = /4[ ]+([\d]+)[ ]+([\d]+)[ ]+([\d]+)[ ]+([\d]+)/g; null != (d = c.exec(a));) {
			var e = parseInt(d[1]),
				f = parseInt(d[2]),
				g = parseInt(d[3]);
			d = parseInt(d[4]);
			b.faces.push(new THREE.Face4(e, f, g, d))
		}
		b.computeCentroids();
		b.computeFaceNormals();
		b.computeVertexNormals();
		b.computeBoundingSphere();
		return b
	}
};
var LZMA = LZMA || {};
LZMA.OutWindow = function () {
	this._windowSize = 0
};
LZMA.OutWindow.prototype.create = function (a) {
	if (!this._buffer || this._windowSize !== a) this._buffer = [];
	this._windowSize = a;
	this._streamPos = this._pos = 0
};
LZMA.OutWindow.prototype.flush = function () {
	var a = this._pos - this._streamPos;
	if (0 !== a) {
		for (; a--;) this._stream.writeByte(this._buffer[this._streamPos++]);
		this._pos >= this._windowSize && (this._pos = 0);
		this._streamPos = this._pos
	}
};
LZMA.OutWindow.prototype.releaseStream = function () {
	this.flush();
	this._stream = null
};
LZMA.OutWindow.prototype.setStream = function (a) {
	this.releaseStream();
	this._stream = a
};
LZMA.OutWindow.prototype.init = function (a) {
	a || (this._pos = this._streamPos = 0)
};
LZMA.OutWindow.prototype.copyBlock = function (a, b) {
	var c = this._pos - a - 1;
	for (0 > c && (c += this._windowSize); b--;) c >= this._windowSize && (c = 0), this._buffer[this._pos++] = this._buffer[c++], this._pos >= this._windowSize && this.flush()
};
LZMA.OutWindow.prototype.putByte = function (a) {
	this._buffer[this._pos++] = a;
	this._pos >= this._windowSize && this.flush()
};
LZMA.OutWindow.prototype.getByte = function (a) {
	a = this._pos - a - 1;
	0 > a && (a += this._windowSize);
	return this._buffer[a]
};
LZMA.RangeDecoder = function () {};
LZMA.RangeDecoder.prototype.setStream = function (a) {
	this._stream = a
};
LZMA.RangeDecoder.prototype.releaseStream = function () {
	this._stream = null
};
LZMA.RangeDecoder.prototype.init = function () {
	var a = 5;
	this._code = 0;
	for (this._range = -1; a--;) this._code = this._code << 8 | this._stream.readByte()
};
LZMA.RangeDecoder.prototype.decodeDirectBits = function (a) {
	for (var b = 0, c; a--;) this._range >>>= 1, c = this._code - this._range >>> 31, this._code -= this._range & c - 1, b = b << 1 | 1 - c, 0 === (this._range & 4278190080) && (this._code = this._code << 8 | this._stream.readByte(), this._range <<= 8);
	return b
};
LZMA.RangeDecoder.prototype.decodeBit = function (a, b) {
	var c = a[b],
		d = (this._range >>> 11) * c;
	if ((this._code ^ 2147483648) < (d ^ 2147483648)) return this._range = d, a[b] += 2048 - c >>> 5, 0 === (this._range & 4278190080) && (this._code = this._code << 8 | this._stream.readByte(), this._range <<= 8), 0;
	this._range -= d;
	this._code -= d;
	a[b] -= c >>> 5;
	0 === (this._range & 4278190080) && (this._code = this._code << 8 | this._stream.readByte(), this._range <<= 8);
	return 1
};
LZMA.initBitModels = function (a, b) {
	for (; b--;) a[b] = 1024
};
LZMA.BitTreeDecoder = function (a) {
	this._models = [];
	this._numBitLevels = a
};
LZMA.BitTreeDecoder.prototype.init = function () {
	LZMA.initBitModels(this._models, 1 << this._numBitLevels)
};
LZMA.BitTreeDecoder.prototype.decode = function (a) {
	for (var b = 1, c = this._numBitLevels; c--;) b = b << 1 | a.decodeBit(this._models, b);
	return b - (1 << this._numBitLevels)
};
LZMA.BitTreeDecoder.prototype.reverseDecode = function (a) {
	for (var b = 1, c = 0, d = 0, e; d < this._numBitLevels; ++d) e = a.decodeBit(this._models, b), b = b << 1 | e, c |= e << d;
	return c
};
LZMA.reverseDecode2 = function (a, b, c, d) {
	for (var e = 1, f = 0, g = 0, h; g < d; ++g) h = c.decodeBit(a, b + e), e = e << 1 | h, f |= h << g;
	return f
};
LZMA.LenDecoder = function () {
	this._choice = [];
	this._lowCoder = [];
	this._midCoder = [];
	this._highCoder = new LZMA.BitTreeDecoder(8);
	this._numPosStates = 0
};
LZMA.LenDecoder.prototype.create = function (a) {
	for (; this._numPosStates < a; ++this._numPosStates) this._lowCoder[this._numPosStates] = new LZMA.BitTreeDecoder(3), this._midCoder[this._numPosStates] = new LZMA.BitTreeDecoder(3)
};
LZMA.LenDecoder.prototype.init = function () {
	var a = this._numPosStates;
	for (LZMA.initBitModels(this._choice, 2); a--;) this._lowCoder[a].init(), this._midCoder[a].init();
	this._highCoder.init()
};
LZMA.LenDecoder.prototype.decode = function (a, b) {
	return 0 === a.decodeBit(this._choice, 0) ? this._lowCoder[b].decode(a) : 0 === a.decodeBit(this._choice, 1) ? 8 + this._midCoder[b].decode(a) : 16 + this._highCoder.decode(a)
};
LZMA.Decoder2 = function () {
	this._decoders = []
};
LZMA.Decoder2.prototype.init = function () {
	LZMA.initBitModels(this._decoders, 768)
};
LZMA.Decoder2.prototype.decodeNormal = function (a) {
	var b = 1;
	do b = b << 1 | a.decodeBit(this._decoders, b);
	while (256 > b);
	return b & 255
};
LZMA.Decoder2.prototype.decodeWithMatchByte = function (a, b) {
	var c = 1,
		d, e;
	do if (d = b >> 7 & 1, b <<= 1, e = a.decodeBit(this._decoders, (1 + d << 8) + c), c = c << 1 | e, d !== e) {
		for (; 256 > c;) c = c << 1 | a.decodeBit(this._decoders, c);
		break
	}
	while (256 > c);
	return c & 255
};
LZMA.LiteralDecoder = function () {};
LZMA.LiteralDecoder.prototype.create = function (a, b) {
	var c;
	if (!this._coders || !(this._numPrevBits === b && this._numPosBits === a)) {
		this._numPosBits = a;
		this._posMask = (1 << a) - 1;
		this._numPrevBits = b;
		this._coders = [];
		for (c = 1 << this._numPrevBits + this._numPosBits; c--;) this._coders[c] = new LZMA.Decoder2
	}
};
LZMA.LiteralDecoder.prototype.init = function () {
	for (var a = 1 << this._numPrevBits + this._numPosBits; a--;) this._coders[a].init()
};
LZMA.LiteralDecoder.prototype.getDecoder = function (a, b) {
	return this._coders[((a & this._posMask) << this._numPrevBits) + ((b & 255) >>> 8 - this._numPrevBits)]
};
LZMA.Decoder = function () {
	this._outWindow = new LZMA.OutWindow;
	this._rangeDecoder = new LZMA.RangeDecoder;
	this._isMatchDecoders = [];
	this._isRepDecoders = [];
	this._isRepG0Decoders = [];
	this._isRepG1Decoders = [];
	this._isRepG2Decoders = [];
	this._isRep0LongDecoders = [];
	this._posSlotDecoder = [];
	this._posDecoders = [];
	this._posAlignDecoder = new LZMA.BitTreeDecoder(4);
	this._lenDecoder = new LZMA.LenDecoder;
	this._repLenDecoder = new LZMA.LenDecoder;
	this._literalDecoder = new LZMA.LiteralDecoder;
	this._dictionarySizeCheck = this._dictionarySize = -1;
	this._posSlotDecoder[0] = new LZMA.BitTreeDecoder(6);
	this._posSlotDecoder[1] = new LZMA.BitTreeDecoder(6);
	this._posSlotDecoder[2] = new LZMA.BitTreeDecoder(6);
	this._posSlotDecoder[3] = new LZMA.BitTreeDecoder(6)
};
LZMA.Decoder.prototype.setDictionarySize = function (a) {
	if (0 > a) return !1;
	this._dictionarySize !== a && (this._dictionarySize = a, this._dictionarySizeCheck = Math.max(this._dictionarySize, 1), this._outWindow.create(Math.max(this._dictionarySizeCheck, 4096)));
	return !0
};
LZMA.Decoder.prototype.setLcLpPb = function (a, b, c) {
	var d = 1 << c;
	if (8 < a || 4 < b || 4 < c) return !1;
	this._literalDecoder.create(b, a);
	this._lenDecoder.create(d);
	this._repLenDecoder.create(d);
	this._posStateMask = d - 1;
	return !0
};
LZMA.Decoder.prototype.init = function () {
	var a = 4;
	this._outWindow.init(!1);
	LZMA.initBitModels(this._isMatchDecoders, 192);
	LZMA.initBitModels(this._isRep0LongDecoders, 192);
	LZMA.initBitModels(this._isRepDecoders, 12);
	LZMA.initBitModels(this._isRepG0Decoders, 12);
	LZMA.initBitModels(this._isRepG1Decoders, 12);
	LZMA.initBitModels(this._isRepG2Decoders, 12);
	LZMA.initBitModels(this._posDecoders, 114);
	for (this._literalDecoder.init(); a--;) this._posSlotDecoder[a].init();
	this._lenDecoder.init();
	this._repLenDecoder.init();
	this._posAlignDecoder.init();
	this._rangeDecoder.init()
};
LZMA.Decoder.prototype.decode = function (a, b, c) {
	var d = 0,
		e = 0,
		f = 0,
		g = 0,
		h = 0,
		i = 0,
		k = 0;
	this._rangeDecoder.setStream(a);
	this._outWindow.setStream(b);
	for (this.init(); 0 > c || i < c;) if (a = i & this._posStateMask, 0 === this._rangeDecoder.decodeBit(this._isMatchDecoders, (d << 4) + a)) k = this._literalDecoder.getDecoder(i++, k), k = 7 <= d ? k.decodeWithMatchByte(this._rangeDecoder, this._outWindow.getByte(e)) : k.decodeNormal(this._rangeDecoder), this._outWindow.putByte(k), d = 4 > d ? 0 : d - (10 > d ? 3 : 6);
	else {
		if (1 === this._rangeDecoder.decodeBit(this._isRepDecoders,
		d)) k = 0, 0 === this._rangeDecoder.decodeBit(this._isRepG0Decoders, d) ? 0 === this._rangeDecoder.decodeBit(this._isRep0LongDecoders, (d << 4) + a) && (d = 7 > d ? 9 : 11, k = 1) : (0 === this._rangeDecoder.decodeBit(this._isRepG1Decoders, d) ? b = f : (0 === this._rangeDecoder.decodeBit(this._isRepG2Decoders, d) ? b = g : (b = h, h = g), g = f), f = e, e = b), 0 === k && (k = 2 + this._repLenDecoder.decode(this._rangeDecoder, a), d = 7 > d ? 8 : 11);
		else if (h = g, g = f, f = e, k = 2 + this._lenDecoder.decode(this._rangeDecoder, a), d = 7 > d ? 7 : 10, a = this._posSlotDecoder[5 >= k ? k - 2 : 3].decode(this._rangeDecoder),
		4 <= a) if (b = (a >> 1) - 1, e = (2 | a & 1) << b, 14 > a) e += LZMA.reverseDecode2(this._posDecoders, e - a - 1, this._rangeDecoder, b);
		else {
			if (e += this._rangeDecoder.decodeDirectBits(b - 4) << 4, e += this._posAlignDecoder.reverseDecode(this._rangeDecoder), 0 > e) {
				if (-1 === e) break;
				return !1
			}
		} else e = a;
		if (e >= i || e >= this._dictionarySizeCheck) return !1;
		this._outWindow.copyBlock(e, k);
		i += k;
		k = this._outWindow.getByte(0)
	}
	this._outWindow.flush();
	this._outWindow.releaseStream();
	this._rangeDecoder.releaseStream();
	return !0
};
LZMA.Decoder.prototype.setDecoderProperties = function (a) {
	var b, c;
	if (5 > a.size) return !1;
	b = a.readByte();
	c = b % 9;
	b = ~~ (b / 9);
	if (!this.setLcLpPb(c, b % 5, ~~ (b / 5))) return !1;
	b = a.readByte();
	b |= a.readByte() << 8;
	b |= a.readByte() << 16;
	b += 16777216 * a.readByte();
	return this.setDictionarySize(b)
};
LZMA.decompress = function (a, b, c, d) {
	var e = new LZMA.Decoder;
	if (!e.setDecoderProperties(a)) throw "Incorrect stream properties";
	if (!e.decode(b, c, d)) throw "Error in data stream";
	return !0
};
var CTM = CTM || {};
CTM.CompressionMethod = {
	RAW: 5718354,
	MG1: 3229517,
	MG2: 3295053
};
CTM.Flags = {
	NORMALS: 1
};
CTM.File = function (a) {
	this.load(a)
};
CTM.File.prototype.load = function (a) {
	this.header = new CTM.FileHeader(a);
	this.body = new CTM.FileBody(this.header);
	this.getReader().read(a, this.body)
};
CTM.File.prototype.getReader = function () {
	var a;
	switch (this.header.compressionMethod) {
		case CTM.CompressionMethod.RAW:
			a = new CTM.ReaderRAW;
			break;
		case CTM.CompressionMethod.MG1:
			a = new CTM.ReaderMG1;
			break;
		case CTM.CompressionMethod.MG2:
			a = new CTM.ReaderMG2
	}
	return a
};
CTM.FileHeader = function (a) {
	a.readInt32();
	this.fileFormat = a.readInt32();
	this.compressionMethod = a.readInt32();
	this.vertexCount = a.readInt32();
	this.triangleCount = a.readInt32();
	this.uvMapCount = a.readInt32();
	this.attrMapCount = a.readInt32();
	this.flags = a.readInt32();
	this.comment = a.readString()
};
CTM.FileHeader.prototype.hasNormals = function () {
	return this.flags & CTM.Flags.NORMALS
};
CTM.FileBody = function (a) {
	var b = 3 * a.triangleCount,
		c = 3 * a.vertexCount,
		d = a.hasNormals() ? 3 * a.vertexCount : 0,
		e = 2 * a.vertexCount,
		f = 4 * a.vertexCount,
		g = 0,
		h = new ArrayBuffer(4 * (b + c + d + e * a.uvMapCount + f * a.attrMapCount));
	this.indices = new Uint32Array(h, 0, b);
	this.vertices = new Float32Array(h, 4 * b, c);
	a.hasNormals() && (this.normals = new Float32Array(h, 4 * (b + c), d));
	if (a.uvMapCount) {
		this.uvMaps = [];
		for (g = 0; g < a.uvMapCount; ++g) this.uvMaps[g] = {
			uv: new Float32Array(h, 4 * (b + c + d + g * e), e)
		}
	}
	if (a.attrMapCount) {
		this.attrMaps = [];
		for (g = 0; g < a.attrMapCount; ++g) this.attrMaps[g] = {
			attr: new Float32Array(h, 4 * (b + c + d + e * a.uvMapCount + g * f), f)
		}
	}
};
CTM.FileMG2Header = function (a) {
	a.readInt32();
	this.vertexPrecision = a.readFloat32();
	this.normalPrecision = a.readFloat32();
	this.lowerBoundx = a.readFloat32();
	this.lowerBoundy = a.readFloat32();
	this.lowerBoundz = a.readFloat32();
	this.higherBoundx = a.readFloat32();
	this.higherBoundy = a.readFloat32();
	this.higherBoundz = a.readFloat32();
	this.divx = a.readInt32();
	this.divy = a.readInt32();
	this.divz = a.readInt32();
	this.sizex = (this.higherBoundx - this.lowerBoundx) / this.divx;
	this.sizey = (this.higherBoundy - this.lowerBoundy) / this.divy;
	this.sizez = (this.higherBoundz - this.lowerBoundz) / this.divz
};
CTM.ReaderRAW = function () {};
CTM.ReaderRAW.prototype.read = function (a, b) {
	this.readIndices(a, b.indices);
	this.readVertices(a, b.vertices);
	b.normals && this.readNormals(a, b.normals);
	b.uvMaps && this.readUVMaps(a, b.uvMaps);
	b.attrMaps && this.readAttrMaps(a, b.attrMaps)
};
CTM.ReaderRAW.prototype.readIndices = function (a, b) {
	a.readInt32();
	a.readArrayInt32(b)
};
CTM.ReaderRAW.prototype.readVertices = function (a, b) {
	a.readInt32();
	a.readArrayFloat32(b)
};
CTM.ReaderRAW.prototype.readNormals = function (a, b) {
	a.readInt32();
	a.readArrayFloat32(b)
};
CTM.ReaderRAW.prototype.readUVMaps = function (a, b) {
	for (var c = 0; c < b.length; ++c) a.readInt32(), b[c].name = a.readString(), b[c].filename = a.readString(), a.readArrayFloat32(b[c].uv)
};
CTM.ReaderRAW.prototype.readAttrMaps = function (a, b) {
	for (var c = 0; c < b.length; ++c) a.readInt32(), b[c].name = a.readString(), a.readArrayFloat32(b[c].attr)
};
CTM.ReaderMG1 = function () {};
CTM.ReaderMG1.prototype.read = function (a, b) {
	this.readIndices(a, b.indices);
	this.readVertices(a, b.vertices);
	b.normals && this.readNormals(a, b.normals);
	b.uvMaps && this.readUVMaps(a, b.uvMaps);
	b.attrMaps && this.readAttrMaps(a, b.attrMaps)
};
CTM.ReaderMG1.prototype.readIndices = function (a, b) {
	a.readInt32();
	a.readInt32();
	var c = new CTM.InterleavedStream(b, 3);
	LZMA.decompress(a, a, c, c.data.length);
	CTM.restoreIndices(b, b.length)
};
CTM.ReaderMG1.prototype.readVertices = function (a, b) {
	a.readInt32();
	a.readInt32();
	var c = new CTM.InterleavedStream(b, 1);
	LZMA.decompress(a, a, c, c.data.length)
};
CTM.ReaderMG1.prototype.readNormals = function (a, b) {
	a.readInt32();
	a.readInt32();
	var c = new CTM.InterleavedStream(b, 3);
	LZMA.decompress(a, a, c, c.data.length)
};
CTM.ReaderMG1.prototype.readUVMaps = function (a, b) {
	for (var c = 0; c < b.length; ++c) {
		a.readInt32();
		b[c].name = a.readString();
		b[c].filename = a.readString();
		a.readInt32();
		var d = new CTM.InterleavedStream(b[c].uv, 2);
		LZMA.decompress(a, a, d, d.data.length)
	}
};
CTM.ReaderMG1.prototype.readAttrMaps = function (a, b) {
	for (var c = 0; c < b.length; ++c) {
		a.readInt32();
		b[c].name = a.readString();
		a.readInt32();
		var d = new CTM.InterleavedStream(b[c].attr, 4);
		LZMA.decompress(a, a, d, d.data.length)
	}
};
CTM.ReaderMG2 = function () {};
CTM.ReaderMG2.prototype.read = function (a, b) {
	this.MG2Header = new CTM.FileMG2Header(a);
	this.readVertices(a, b.vertices);
	this.readIndices(a, b.indices);
	b.normals && this.readNormals(a, b);
	b.uvMaps && this.readUVMaps(a, b.uvMaps);
	b.attrMaps && this.readAttrMaps(a, b.attrMaps)
};
CTM.ReaderMG2.prototype.readVertices = function (a, b) {
	a.readInt32();
	a.readInt32();
	var c = new CTM.InterleavedStream(b, 3);
	LZMA.decompress(a, a, c, c.data.length);
	c = this.readGridIndices(a, b);
	CTM.restoreVertices(b, this.MG2Header, c, this.MG2Header.vertexPrecision)
};
CTM.ReaderMG2.prototype.readGridIndices = function (a, b) {
	a.readInt32();
	a.readInt32();
	var c = new Uint32Array(b.length / 3),
		d = new CTM.InterleavedStream(c, 1);
	LZMA.decompress(a, a, d, d.data.length);
	CTM.restoreGridIndices(c, c.length);
	return c
};
CTM.ReaderMG2.prototype.readIndices = function (a, b) {
	a.readInt32();
	a.readInt32();
	var c = new CTM.InterleavedStream(b, 3);
	LZMA.decompress(a, a, c, c.data.length);
	CTM.restoreIndices(b, b.length)
};
CTM.ReaderMG2.prototype.readNormals = function (a, b) {
	a.readInt32();
	a.readInt32();
	var c = new CTM.InterleavedStream(b.normals, 3);
	LZMA.decompress(a, a, c, c.data.length);
	c = CTM.calcSmoothNormals(b.indices, b.vertices);
	CTM.restoreNormals(b.normals, c, this.MG2Header.normalPrecision)
};
CTM.ReaderMG2.prototype.readUVMaps = function (a, b) {
	for (var c = 0; c < b.length; ++c) {
		a.readInt32();
		b[c].name = a.readString();
		b[c].filename = a.readString();
		var d = a.readFloat32();
		a.readInt32();
		var e = new CTM.InterleavedStream(b[c].uv, 2);
		LZMA.decompress(a, a, e, e.data.length);
		CTM.restoreMap(b[c].uv, 2, d)
	}
};
CTM.ReaderMG2.prototype.readAttrMaps = function (a, b) {
	for (var c = 0; c < b.length; ++c) {
		a.readInt32();
		b[c].name = a.readString();
		var d = a.readFloat32();
		a.readInt32();
		var e = new CTM.InterleavedStream(b[c].attr, 4);
		LZMA.decompress(a, a, e, e.data.length);
		CTM.restoreMap(b[c].attr, 4, d)
	}
};
CTM.restoreIndices = function (a, b) {
	var c = 3;
	for (0 < b && (a[2] += a[0]); c < b; c += 3) a[c] += a[c - 3], a[c + 1] = a[c] === a[c - 3] ? a[c + 1] + a[c - 2] : a[c + 1] + a[c], a[c + 2] += a[c]
};
CTM.restoreGridIndices = function (a, b) {
	for (var c = 1; c < b; ++c) a[c] += a[c - 1]
};
CTM.restoreVertices = function (a, b, c, d) {
	for (var e, f, g, h, i, k = new Uint32Array(a.buffer, a.byteOffset, a.length), j = b.divx, l = j * b.divy, m = 2147483647, r = 0, q = 0, p = 0, t = c.length; q < t; p += 3) g = e = c[q++], i = ~~ (g / l), g -= ~~ (i * l), h = ~~ (g / j), g -= ~~ (h * j), f = k[p], e === m && (f += r), a[p] = b.lowerBoundx + g * b.sizex + d * f, a[p + 1] = b.lowerBoundy + h * b.sizey + d * k[p + 1], a[p + 2] = b.lowerBoundz + i * b.sizez + d * k[p + 2], m = e, r = f
};
CTM.restoreNormals = function (a, b, c) {
	for (var d, e, f, g, h, i, k = new Uint32Array(a.buffer, a.byteOffset, a.length), j = 0, l = a.length; j < l; j += 3) d = k[j] * c, e = k[j + 1], 0 === e ? (a[j] = b[j] * d, a[j + 1] = b[j + 1] * d, a[j + 2] = b[j + 2] * d) : (f = 4 >= e ? 1.5707963267948966 * (k[j + 2] - 2) : 1.5707963267948966 * (4 * k[j + 2] / e - 2), e *= 1.5707963267948966 * c, g = d * Math.sin(e), h = g * Math.cos(f), f = g * Math.sin(f), d *= Math.cos(e), g = b[j + 1], e = b[j] - b[j + 2], i = Math.sqrt(2 * g * g + e * e), 1E-20 < i && (e /= i, g /= i), a[j] = b[j] * d + (b[j + 1] * g - b[j + 2] * e) * f - g * h, a[j + 1] = b[j + 1] * d - (b[j + 2] + b[j]) * g * f + e * h,
	a[j + 2] = b[j + 2] * d + (b[j] * e + b[j + 1] * g) * f + g * h)
};
CTM.restoreMap = function (a, b, c) {
	for (var d, e, f = new Uint32Array(a.buffer, a.byteOffset, a.length), g = 0, h, i = a.length; g < b; ++g) {
		d = 0;
		for (h = g; h < i; h += b) e = f[h], d += e & 1 ? -(e + 1 >> 1) : e >> 1, a[h] = d * c
	}
};
CTM.calcSmoothNormals = function (a, b) {
	var c = new Float32Array(b.length),
		d, e, f, g, h, i, k, j, l, m, r, q;
	r = 0;
	for (q = a.length; r < q;) d = 3 * a[r++], e = 3 * a[r++], f = 3 * a[r++], i = b[e] - b[d], j = b[f] - b[d], k = b[e + 1] - b[d + 1], l = b[f + 1] - b[d + 1], h = b[e + 2] - b[d + 2], m = b[f + 2] - b[d + 2], g = k * m - h * l, h = h * j - i * m, i = i * l - k * j, k = Math.sqrt(g * g + h * h + i * i), 1E-10 < k && (g /= k, h /= k, i /= k), c[d] += g, c[d + 1] += h, c[d + 2] += i, c[e] += g, c[e + 1] += h, c[e + 2] += i, c[f] += g, c[f + 1] += h, c[f + 2] += i;
	r = 0;
	for (q = c.length; r < q; r += 3) k = Math.sqrt(c[r] * c[r] + c[r + 1] * c[r + 1] + c[r + 2] * c[r + 2]), 1E-10 < k && (c[r] /= k, c[r + 1] /= k, c[r + 2] /= k);
	return c
};
CTM.isLittleEndian = function () {
	var a = new ArrayBuffer(2),
		b = new Uint8Array(a),
		a = new Uint16Array(a);
	b[0] = 1;
	return 1 === a[0]
}();
CTM.InterleavedStream = function (a, b) {
	this.data = new Uint8Array(a.buffer, a.byteOffset, a.byteLength);
	this.offset = CTM.isLittleEndian ? 3 : 0;
	this.count = 4 * b;
	this.len = this.data.length
};
CTM.InterleavedStream.prototype.writeByte = function (a) {
	this.data[this.offset] = a;
	this.offset += this.count;
	this.offset >= this.len && (this.offset -= this.len - 4, this.offset >= this.count && (this.offset -= this.count + (CTM.isLittleEndian ? 1 : -1)))
};
CTM.Stream = function (a) {
	this.data = a;
	this.offset = 0
};
CTM.Stream.prototype.TWO_POW_MINUS23 = Math.pow(2, -23);
CTM.Stream.prototype.TWO_POW_MINUS126 = Math.pow(2, -126);
CTM.Stream.prototype.readByte = function () {
	return this.data.charCodeAt(this.offset++) & 255
};
CTM.Stream.prototype.readInt32 = function () {
	var a = this.readByte(),
		a = a | this.readByte() << 8,
		a = a | this.readByte() << 16;
	return a | this.readByte() << 24
};
CTM.Stream.prototype.readFloat32 = function () {
	var a = this.readByte(),
		a = a + (this.readByte() << 8),
		b = this.readByte(),
		c = this.readByte(),
		a = a + ((b & 127) << 16),
		b = (c & 127) << 1 | (b & 128) >>> 7,
		c = c & 128 ? -1 : 1;
	return 255 === b ? 0 !== a ? NaN : Infinity * c : 0 < b ? c * (1 + a * this.TWO_POW_MINUS23) * Math.pow(2, b - 127) : 0 !== a ? c * a * this.TWO_POW_MINUS126 : 0 * c
};
CTM.Stream.prototype.readString = function () {
	var a = this.readInt32();
	this.offset += a;
	return this.data.substr(this.offset - a, a)
};
CTM.Stream.prototype.readArrayInt32 = function (a) {
	for (var b = 0, c = a.length; b < c;) a[b++] = this.readInt32();
	return a
};
CTM.Stream.prototype.readArrayFloat32 = function (a) {
	for (var b = 0, c = a.length; b < c;) a[b++] = this.readFloat32();
	return a
};
THREE.CTMLoader = function (a) {
	THREE.Loader.call(this, a)
};
THREE.CTMLoader.prototype = Object.create(THREE.Loader.prototype);
THREE.CTMLoader.prototype.loadParts = function (a, b, c) {
	var d = this,
		e = new XMLHttpRequest,
		f = c.basePath ? c.basePath : this.extractUrlBase(a);
	e.onreadystatechange = function () {
		if (4 === e.readyState && (200 === e.status || 0 === e.status)) {
			for (var a = JSON.parse(e.responseText), h = [], i = [], k = 0, j = 0; j < a.materials.length; j++) h[j] = THREE.Loader.prototype.createMaterial(a.materials[j], f);
			d.load(f + a.data, function (c) {
				k += 1;
				i.push(c);
				k === a.offsets.length && b(i, h)
			}, {
				useWorker: c.useWorker,
				useBuffers: c.useBuffers,
				offsets: a.offsets
			})
		}
	};
	e.open("GET",
	a, !0);
	e.overrideMimeType && e.overrideMimeType("text/plain; charset=x-user-defined");
	e.setRequestHeader("Content-Type", "text/plain");
	e.send(null)
};
THREE.CTMLoader.prototype.load = function (a, b, c) {
	var d = this,
		e = void 0 !== c.offsets ? c.offsets : [0],
		f = void 0 !== c.useBuffers ? c.useBuffers : !0,
		g = new XMLHttpRequest;
	g.onreadystatechange = function () {
		if (4 === g.readyState) if (200 === g.status || 0 === g.status) {
			var h = g.responseText;
			if (c.useWorker) {
				var i = new Worker("js/loaders/ctm/CTMWorker.js");
				i.onmessage = function (a) {
					for (var a = a.data, c = 0; c < a.length; c++) {
						var e = a[c];
						f ? d.createModelBuffers(e, b) : d.createModelClassic(e, b)
					}
				};
				i.postMessage({
					data: h,
					offsets: e
				})
			} else for (i = 0; i < e.length; i++) {
				var k = new CTM.Stream(h);
				k.offset = e[i];
				k = new CTM.File(k);
				f ? d.createModelBuffers(k, b) : d.createModelClassic(k, b)
			}
		} else console.error("Couldn't load [" + a + "] [" + g.status + "]");
		else 3 !== g.readyState && 2 === g.readyState && g.getResponseHeader("Content-Length")
	};
	g.overrideMimeType("text/plain; charset=x-user-defined");
	g.open("GET", a, !0);
	g.send(null)
};
THREE.CTMLoader.prototype.createModelBuffers = function (a, b) {
	var c = function () {
		this.materials = [];
		THREE.BufferGeometry.call(this);
		var b = a.body.indices,
			c = a.body.vertices,
			f = a.body.normals,
			g, h;
		void 0 !== a.body.uvMaps && 0 < a.body.uvMaps.length && (g = a.body.uvMaps[0].uv);
		void 0 !== a.body.attrMaps && (0 < a.body.attrMaps.length && "Color" === a.body.attrMaps[0].name) && (h = a.body.attrMaps[0].attr);
		var i = new Uint32Array(b.length),
			k = new Float32Array(c.length),
			j, l, m;
		f && (j = new Float32Array(f.length));
		g && (l = new Float32Array(g.length));
		h && (m = new Float32Array(h.length));
		for (var r = {}, q = 0, p = function (a) {
			if (void 0 === r[a]) {
				r[a] = q;
				var b = 3 * a,
					d = 3 * a + 1,
					i = 3 * a + 2,
					p = 3 * q,
					s = 3 * q + 1,
					t = 3 * q + 2;
				k[p] = c[b];
				k[s] = c[d];
				k[t] = c[i];
				f && (j[p] = f[b], j[s] = f[d], j[t] = f[i]);
				g && (l[2 * q] = g[2 * a], l[2 * q + 1] = g[2 * a + 1]);
				h && (m[4 * q] = h[4 * a], m[4 * q + 1] = h[4 * a + 1], m[4 * q + 2] = h[4 * a + 2], m[4 * q + 3] = h[4 * a + 3]);
				q += 1
			}
		}, t, u, x, v = 0; v < b.length; v += 3) t = b[v], u = b[v + 1], x = b[v + 2], p(t), p(u), p(x), i[v] = r[t], i[v + 1] = r[u], i[v + 2] = r[x];
		b = i;
		c = k;
		f && (f = j);
		g && (g = l);
		h && (h = m);
		this.offsets = [];
		i = b;
		p = 0;
		u = c.length;
		x = 0;
		t = u;
		for (v = 0; v < i.length;) {
			for (var s = 0; 3 > s; ++s) {
				var C = i[v++];
				C < u && (u = C);
				C > x && (x = C)
			}
			if (65535 < x - u) {
				v -= 3;
				for (u = p; u < v; ++u) i[u] -= t;
				this.offsets.push({
					start: p,
					count: v - p,
					index: t
				});
				p = v;
				u = c.length;
				x = 0
			}
			t = u
		}
		for (u = p; u < v; ++u) i[u] -= t;
		this.offsets.push({
			start: p,
			count: v - p,
			index: t
		});
		b = new Uint16Array(b);
		v = this.attributes;
		v.index = {
			itemSize: 1,
			array: b,
			numItems: b.length
		};
		v.position = {
			itemSize: 3,
			array: c,
			numItems: c.length
		};
		void 0 !== f && (v.normal = {
			itemSize: 3,
			array: f,
			numItems: f.length
		});
		void 0 !== g && (v.uv = {
			itemSize: 2,
			array: g,
			numItems: g.length
		});
		void 0 !== h && (v.color = {
			itemSize: 4,
			array: h,
			numItems: h.length
		})
	};
	c.prototype = Object.create(THREE.BufferGeometry.prototype);
	c = new c;
	void 0 === c.attributes.normal && c.computeVertexNormals();
	b(c)
};
THREE.CTMLoader.prototype.createModelClassic = function (a, b) {
	var c = function () {
		this.materials = [];
		THREE.Geometry.call(this);
		var b = [],
			c = [],
			f = [],
			g = a.body.vertices,
			h, i, k, j, l = g.length;
		for (j = 0; j < l; j += 3) h = g[j], i = g[j + 1], k = g[j + 2], this.vertices.push(new THREE.Vector3(h, i, k));
		if (void 0 !== a.body.normals) {
			g = a.body.normals;
			l = g.length;
			for (j = 0; j < l; j += 3) h = g[j], i = g[j + 1], k = g[j + 2], b.push(h, i, k)
		}
		if (void 0 !== a.body.uvMaps && 0 < a.body.uvMaps.length) {
			g = a.body.uvMaps[0].uv;
			j = g.length;
			for (k = 0; k < j; k += 2) h = g[k], i = g[k + 1], c.push(h,
			i)
		}
		if (void 0 !== a.body.attrMaps && 0 < a.body.attrMaps.length && "Color" === a.body.attrMaps[0].name) {
			g = a.body.attrMaps[0].attr;
			l = g.length;
			for (j = 0; j < l; j += 4) {
				h = g[j];
				i = g[j + 1];
				k = g[j + 2];
				var m = new THREE.Color;
				m.setRGB(h, i, k);
				f.push(m)
			}
		}
		g = 0 < b.length ? !0 : !1;
		h = 0 < c.length ? !0 : !1;
		i = 0 < f.length ? !0 : !1;
		k = a.body.indices;
		var r, q, p, t, u, x, v, l = k.length;
		for (j = 0; j < l; j += 3) {
			r = k[j];
			q = k[j + 1];
			m = k[j + 2];
			if (g) {
				p = r;
				x = q;
				v = m;
				var s = b[3 * q],
					C = b[3 * q + 1],
					z = b[3 * q + 2];
				u = b[3 * m];
				var w = b[3 * m + 1],
					A = b[3 * m + 2];
				t = new THREE.Vector3(b[3 * r], b[3 * r + 1], b[3 * r + 2]);
				s = new THREE.Vector3(s, C, z);
				u = new THREE.Vector3(u, w, A);
				p = new THREE.Face3(p, x, v, [t, s, u], null, 0)
			} else p = new THREE.Face3(r, q, m, null, null, 0);
			this.faces.push(p);
			i && (p.vertexColors[0] = f[r], p.vertexColors[1] = f[q], p.vertexColors[2] = f[m]);
			h && (p = c[2 * r], r = c[2 * r + 1], t = c[2 * q], u = c[2 * q + 1], x = c[2 * m], v = c[2 * m + 1], m = this.faceVertexUvs[0], q = t, t = u, u = [], u.push(new THREE.Vector2(p, r)), u.push(new THREE.Vector2(q, t)), u.push(new THREE.Vector2(x, v)), m.push(u))
		}
		this.computeCentroids();
		this.computeFaceNormals()
	};
	c.prototype = Object.create(THREE.Geometry.prototype);
	b(new c)
};
THREE.EffectComposer = function (a, b) {
	this.renderer = a;
	void 0 === b && (b = new THREE.WebGLRenderTarget(window.innerWidth || 1, window.innerHeight || 1, {
		minFilter: THREE.LinearFilter,
		magFilter: THREE.LinearFilter,
		format: THREE.RGBFormat,
		stencilBuffer: !1
	}));
	this.renderTarget1 = b;
	this.renderTarget2 = b.clone();
	this.writeBuffer = this.renderTarget1;
	this.readBuffer = this.renderTarget2;
	this.passes = [];
	void 0 === THREE.CopyShader && console.error("THREE.EffectComposer relies on THREE.CopyShader");
	this.copyPass = new THREE.ShaderPass(THREE.CopyShader)
};
THREE.EffectComposer.prototype = {
	swapBuffers: function () {
		var a = this.readBuffer;
		this.readBuffer = this.writeBuffer;
		this.writeBuffer = a
	},
	addPass: function (a) {
		this.passes.push(a)
	},
	insertPass: function (a, b) {
		this.passes.splice(b, 0, a)
	},
	render: function (a) {
		this.writeBuffer = this.renderTarget1;
		this.readBuffer = this.renderTarget2;
		var b = !1,
			c, d, e = this.passes.length;
		for (d = 0; d < e; d++) if (c = this.passes[d], c.enabled) {
			c.render(this.renderer, this.writeBuffer, this.readBuffer, a, b);
			if (c.needsSwap) {
				if (b) {
					var f = this.renderer.context;
					f.stencilFunc(f.NOTEQUAL, 1, 4294967295);
					this.copyPass.render(this.renderer, this.writeBuffer, this.readBuffer, a);
					f.stencilFunc(f.EQUAL, 1, 4294967295)
				}
				this.swapBuffers()
			}
			c instanceof THREE.MaskPass ? b = !0 : c instanceof THREE.ClearMaskPass && (b = !1)
		}
	},
	reset: function (a) {
		void 0 === a && (a = this.renderTarget1.clone(), a.width = window.innerWidth, a.height = window.innerHeight);
		this.renderTarget1 = a;
		this.renderTarget2 = a.clone();
		this.writeBuffer = this.renderTarget1;
		this.readBuffer = this.renderTarget2
	},
	setSize: function (a, b) {
		var c = this.renderTarget1.clone();
		c.width = a;
		c.height = b;
		this.reset(c)
	}
};
THREE.EffectComposer.camera = new THREE.OrthographicCamera(-1, 1, 1, -1, 0, 1);
THREE.EffectComposer.quad = new THREE.Mesh(new THREE.PlaneGeometry(2, 2), null);
THREE.EffectComposer.scene = new THREE.Scene;
THREE.EffectComposer.scene.add(THREE.EffectComposer.quad);
THREE.BloomPass = function (a, b, c, d) {
	var a = void 0 !== a ? a : 1,
		b = void 0 !== b ? b : 25,
		c = void 0 !== c ? c : 4,
		d = void 0 !== d ? d : 256,
		e = {
			minFilter: THREE.LinearFilter,
			magFilter: THREE.LinearFilter,
			format: THREE.RGBFormat
		};
	this.renderTargetX = new THREE.WebGLRenderTarget(d, d, e);
	this.renderTargetY = new THREE.WebGLRenderTarget(d, d, e);
	void 0 === THREE.CopyShader && console.error("THREE.BloomPass relies on THREE.CopyShader");
	d = THREE.CopyShader;
	this.copyUniforms = THREE.UniformsUtils.clone(d.uniforms);
	this.copyUniforms.opacity.value = a;
	this.materialCopy = new THREE.ShaderMaterial({
		uniforms: this.copyUniforms,
		vertexShader: d.vertexShader,
		fragmentShader: d.fragmentShader,
		blending: THREE.AdditiveBlending,
		transparent: !0
	});
	void 0 === THREE.ConvolutionShader && console.error("THREE.BloomPass relies on THREE.ConvolutionShader");
	a = THREE.ConvolutionShader;
	this.convolutionUniforms = THREE.UniformsUtils.clone(a.uniforms);
	this.convolutionUniforms.uImageIncrement.value = THREE.BloomPass.blurx;
	this.convolutionUniforms.cKernel.value = THREE.ConvolutionShader.buildKernel(c);
	this.materialConvolution = new THREE.ShaderMaterial({
		uniforms: this.convolutionUniforms,
		vertexShader: a.vertexShader,
		fragmentShader: a.fragmentShader,
		defines: {
			KERNEL_SIZE_FLOAT: b.toFixed(1),
			KERNEL_SIZE_INT: b.toFixed(0)
		}
	});
	this.enabled = !0;
	this.clear = this.needsSwap = !1
};
THREE.BloomPass.prototype = {
	render: function (a, b, c, d, e) {
		e && a.context.disable(a.context.STENCIL_TEST);
		THREE.EffectComposer.quad.material = this.materialConvolution;
		this.convolutionUniforms.tDiffuse.value = c;
		this.convolutionUniforms.uImageIncrement.value = THREE.BloomPass.blurX;
		a.render(THREE.EffectComposer.scene, THREE.EffectComposer.camera, this.renderTargetX, !0);
		this.convolutionUniforms.tDiffuse.value = this.renderTargetX;
		this.convolutionUniforms.uImageIncrement.value = THREE.BloomPass.blurY;
		a.render(THREE.EffectComposer.scene,
		THREE.EffectComposer.camera, this.renderTargetY, !0);
		THREE.EffectComposer.quad.material = this.materialCopy;
		this.copyUniforms.tDiffuse.value = this.renderTargetY;
		e && a.context.enable(a.context.STENCIL_TEST);
		a.render(THREE.EffectComposer.scene, THREE.EffectComposer.camera, c, this.clear)
	}
};
THREE.BloomPass.blurX = new THREE.Vector2(0.001953125, 0);
THREE.BloomPass.blurY = new THREE.Vector2(0, 0.001953125);
THREE.DotScreenPass = function (a, b, c) {
	void 0 === THREE.DotScreenShader && console.error("THREE.DotScreenPass relies on THREE.DotScreenShader");
	var d = THREE.DotScreenShader;
	this.uniforms = THREE.UniformsUtils.clone(d.uniforms);
	void 0 !== a && this.uniforms.center.value.copy(a);
	void 0 !== b && (this.uniforms.angle.value = b);
	void 0 !== c && (this.uniforms.scale.value = c);
	this.material = new THREE.ShaderMaterial({
		uniforms: this.uniforms,
		vertexShader: d.vertexShader,
		fragmentShader: d.fragmentShader
	});
	this.enabled = !0;
	this.renderToScreen = !1;
	this.needsSwap = !0
};
THREE.DotScreenPass.prototype = {
	render: function (a, b, c) {
		this.uniforms.tDiffuse.value = c;
		this.uniforms.tSize.value.set(c.width, c.height);
		THREE.EffectComposer.quad.material = this.material;
		this.renderToScreen ? a.render(THREE.EffectComposer.scene, THREE.EffectComposer.camera) : a.render(THREE.EffectComposer.scene, THREE.EffectComposer.camera, b, !1)
	}
};
THREE.FilmPass = function (a, b, c, d) {
	void 0 === THREE.FilmShader && console.error("THREE.FilmPass relies on THREE.FilmShader");
	var e = THREE.FilmShader;
	this.uniforms = THREE.UniformsUtils.clone(e.uniforms);
	this.material = new THREE.ShaderMaterial({
		uniforms: this.uniforms,
		vertexShader: e.vertexShader,
		fragmentShader: e.fragmentShader
	});
	void 0 !== d && (this.uniforms.grayscale.value = d);
	void 0 !== a && (this.uniforms.nIntensity.value = a);
	void 0 !== b && (this.uniforms.sIntensity.value = b);
	void 0 !== c && (this.uniforms.sCount.value = c);
	this.enabled = !0;
	this.renderToScreen = !1;
	this.needsSwap = !0
};
THREE.FilmPass.prototype = {
	render: function (a, b, c, d) {
		this.uniforms.tDiffuse.value = c;
		this.uniforms.time.value += d;
		THREE.EffectComposer.quad.material = this.material;
		this.renderToScreen ? a.render(THREE.EffectComposer.scene, THREE.EffectComposer.camera) : a.render(THREE.EffectComposer.scene, THREE.EffectComposer.camera, b, !1)
	}
};
THREE.MaskPass = function (a, b) {
	this.scene = a;
	this.camera = b;
	this.clear = this.enabled = !0;
	this.inverse = this.needsSwap = !1
};
THREE.MaskPass.prototype = {
	render: function (a, b, c) {
		var d = a.context;
		d.colorMask(!1, !1, !1, !1);
		d.depthMask(!1);
		var e, f;
		this.inverse ? (e = 0, f = 1) : (e = 1, f = 0);
		d.enable(d.STENCIL_TEST);
		d.stencilOp(d.REPLACE, d.REPLACE, d.REPLACE);
		d.stencilFunc(d.ALWAYS, e, 4294967295);
		d.clearStencil(f);
		a.render(this.scene, this.camera, c, this.clear);
		a.render(this.scene, this.camera, b, this.clear);
		d.colorMask(!0, !0, !0, !0);
		d.depthMask(!0);
		d.stencilFunc(d.EQUAL, 1, 4294967295);
		d.stencilOp(d.KEEP, d.KEEP, d.KEEP)
	}
};
THREE.ClearMaskPass = function () {
	this.enabled = !0
};
THREE.ClearMaskPass.prototype = {
	render: function (a) {
		a = a.context;
		a.disable(a.STENCIL_TEST)
	}
};
/*
THREE.RenderPass = function (a, b, c, d, e) {
	this.scene = a;
	this.camera = b;
	this.overrideMaterial = c;
	this.clearColor = d;
	this.clearAlpha = void 0 !== e ? e : 1;
	this.oldClearColor = new THREE.Color;
	this.oldClearAlpha = 1;
	this.clear = this.enabled = !0;
	this.needsSwap = !1
};
THREE.RenderPass.prototype = {
	render: function (a, b, c) {
		this.scene.overrideMaterial = this.overrideMaterial;
		this.clearColor && (this.oldClearColor.copy(a.getClearColor()), this.oldClearAlpha = a.getClearAlpha(), a.setClearColor(this.clearColor, this.clearAlpha));
		a.render(this.scene, this.camera, c, this.clear);
		this.clearColor && a.setClearColor(this.oldClearColor, this.oldClearAlpha);
		this.scene.overrideMaterial = null
	}
};*/
/**
 * @author alteredq / http://alteredqualia.com/
 */

THREE.RenderPass = function ( scene, camera, overrideMaterial, clearColor, clearAlpha ) {

	this.scene = scene;
	this.camera = camera;

	this.overrideMaterial = overrideMaterial;

	this.clearColor = clearColor;
	this.clearAlpha = ( clearAlpha !== undefined ) ? clearAlpha : 1;

	this.oldClearColor = new THREE.Color();
	this.oldClearAlpha = 1;

	this.enabled = true;
	this.clear = true;
	this.needsSwap = false;

};

THREE.RenderPass.prototype = {

	render: function ( renderer, writeBuffer, readBuffer, delta ) {

		this.scene.overrideMaterial = this.overrideMaterial;

		if ( this.clearColor ) {

			this.oldClearColor.copy( renderer.getClearColor() );
			this.oldClearAlpha = renderer.getClearAlpha();

			renderer.setClearColor( this.clearColor, this.clearAlpha );

		}

		renderer.render( this.scene, this.camera, readBuffer, this.clear );

		if ( this.clearColor ) {

			renderer.setClearColor( this.oldClearColor, this.oldClearAlpha );

		}

		this.scene.overrideMaterial = null;

	}

};
THREE.SavePass = function (a) {
	void 0 === THREE.CopyShader && console.error("THREE.SavePass relies on THREE.CopyShader");
	var b = THREE.CopyShader;
	this.textureID = "tDiffuse";
	this.uniforms = THREE.UniformsUtils.clone(b.uniforms);
	this.material = new THREE.ShaderMaterial({
		uniforms: this.uniforms,
		vertexShader: b.vertexShader,
		fragmentShader: b.fragmentShader
	});
	this.renderTarget = a;
	void 0 === this.renderTarget && (this.renderTargetParameters = {
		minFilter: THREE.LinearFilter,
		magFilter: THREE.LinearFilter,
		format: THREE.RGBFormat,
		stencilBuffer: !1
	},
	this.renderTarget = new THREE.WebGLRenderTarget(window.innerWidth, window.innerHeight, this.renderTargetParameters));
	this.enabled = !0;
	this.clear = this.needsSwap = !1
};
THREE.SavePass.prototype = {
	render: function (a, b, c) {
		this.uniforms[this.textureID] && (this.uniforms[this.textureID].value = c);
		THREE.EffectComposer.quad.material = this.material;
		a.render(THREE.EffectComposer.scene, THREE.EffectComposer.camera, this.renderTarget, this.clear)
	}
};
THREE.ShaderPass = function (a, b) {
	this.textureID = void 0 !== b ? b : "tDiffuse";
	this.uniforms = THREE.UniformsUtils.clone(a.uniforms);
	this.material = new THREE.ShaderMaterial({
		uniforms: this.uniforms,
		vertexShader: a.vertexShader,
		fragmentShader: a.fragmentShader
	});
	this.renderToScreen = !1;
	this.needsSwap = this.enabled = !0;
	this.clear = !1
};
THREE.ShaderPass.prototype = {
	render: function (a, b, c) {
		this.uniforms[this.textureID] && (this.uniforms[this.textureID].value = c);
		THREE.EffectComposer.quad.material = this.material;
		this.renderToScreen ? a.render(THREE.EffectComposer.scene, THREE.EffectComposer.camera) : a.render(THREE.EffectComposer.scene, THREE.EffectComposer.camera, b, this.clear)
	}
};
THREE.TexturePass = function (a, b) {
	void 0 === THREE.CopyShader && console.error("THREE.TexturePass relies on THREE.CopyShader");
	var c = THREE.CopyShader;
	this.uniforms = THREE.UniformsUtils.clone(c.uniforms);
	this.uniforms.opacity.value = void 0 !== b ? b : 1;
	this.uniforms.tDiffuse.value = a;
	this.material = new THREE.ShaderMaterial({
		uniforms: this.uniforms,
		vertexShader: c.vertexShader,
		fragmentShader: c.fragmentShader
	});
	this.enabled = !0;
	this.needsSwap = !1
};
THREE.TexturePass.prototype = {
	render: function (a, b, c) {
		THREE.EffectComposer.quad.material = this.material;
		a.render(THREE.EffectComposer.scene, THREE.EffectComposer.camera, c)
	}
};
THREE.CSS3DObject = function (a) {
	THREE.Object3D.call(this);
	this.element = a;
	this.element.style.position = "absolute";
	this.element.style.WebkitTransformStyle = "preserve-3d";
	this.element.style.MozTransformStyle = "preserve-3d";
	this.element.style.oTransformStyle = "preserve-3d";
	this.element.style.transformStyle = "preserve-3d"
};
THREE.CSS3DObject.prototype = Object.create(THREE.Object3D.prototype);
THREE.CSS3DSprite = function (a) {
	THREE.CSS3DObject.call(this, a)
};
THREE.CSS3DSprite.prototype = Object.create(THREE.CSS3DObject.prototype);
THREE.CSS3DRenderer = function () {
	console.log("THREE.CSS3DRenderer", THREE.REVISION);
	var a, b, c, d, e = new THREE.Projector,
		f = new THREE.Matrix4;
	this.domElement = document.createElement("div");
	this.domElement.style.overflow = "hidden";
	this.domElement.style.WebkitTransformStyle = "preserve-3d";
	this.domElement.style.WebkitPerspectiveOrigin = "50% 50%";
	this.domElement.style.MozTransformStyle = "preserve-3d";
	this.domElement.style.MozPerspectiveOrigin = "50% 50%";
	this.domElement.style.oTransformStyle = "preserve-3d";
	this.domElement.style.oPerspectiveOrigin =
		"50% 50%";
	this.domElement.style.transformStyle = "preserve-3d";
	this.domElement.style.perspectiveOrigin = "50% 50%";
	this.cameraElement = document.createElement("div");
	this.cameraElement.style.WebkitTransformStyle = "preserve-3d";
	this.cameraElement.style.MozTransformStyle = "preserve-3d";
	this.cameraElement.style.oTransformStyle = "preserve-3d";
	this.cameraElement.style.transformStyle = "preserve-3d";
	this.domElement.appendChild(this.cameraElement);
	this.setSize = function (e, f) {
		a = e;
		b = f;
		c = a / 2;
		d = b / 2;
		this.domElement.style.width = e + "px";
		this.domElement.style.height = f + "px";
		this.cameraElement.style.width = e + "px";
		this.cameraElement.style.height = f + "px"
	};
	var g = function (a) {
		return 1E-6 > Math.abs(a) ? 0 : a
	}, h = function (a) {
		a = a.elements;
		return "translate3d(-50%,-50%,0) matrix3d(" + g(a[0]) + "," + g(a[1]) + "," + g(a[2]) + "," + g(a[3]) + "," + g(-a[4]) + "," + g(-a[5]) + "," + g(-a[6]) + "," + g(-a[7]) + "," + g(a[8]) + "," + g(a[9]) + "," + g(a[10]) + "," + g(a[11]) + "," + g(a[12]) + "," + g(a[13]) + "," + g(a[14]) + "," + g(a[15]) + ")"
	};
	this.render = function (a, k) {
		var j = 0.5 / Math.tan(THREE.Math.degToRad(0.5 * k.fov)) * b;
		this.domElement.style.WebkitPerspective = j + "px";
		this.domElement.style.MozPerspective = j + "px";
		this.domElement.style.oPerspective = j + "px";
		this.domElement.style.perspective = j + "px";
		var l = e.projectScene(a, k, !1).objects,
			j = "translate3d(0,0," + j + "px)",
			m;
		m = k.matrixWorldInverse.elements;
		m = "matrix3d(" + g(m[0]) + "," + g(-m[1]) + "," + g(m[2]) + "," + g(m[3]) + "," + g(m[4]) + "," + g(-m[5]) + "," + g(m[6]) + "," + g(m[7]) + "," + g(m[8]) + "," + g(-m[9]) + "," + g(m[10]) + "," + g(m[11]) + "," + g(m[12]) + "," + g(-m[13]) + "," + g(m[14]) + "," + g(m[15]) + ")";
		var r = j + m + " translate3d(" + c + "px," + d + "px, 0)";
		this.cameraElement.style.WebkitTransform = r;
		this.cameraElement.style.MozTransform = r;
		this.cameraElement.style.oTransform = r;
		this.cameraElement.style.transform = r;
		j = 0;
		for (m = l.length; j < m; j++) if (r = l[j].object, r instanceof THREE.CSS3DObject) {
			var q = r.element;
			r instanceof THREE.CSS3DSprite ? (f.copy(k.matrixWorldInverse), f.transpose(), f.extractPosition(r.matrixWorld), f.scale(r.scale), f.elements[3] = 0, f.elements[7] = 0, f.elements[11] = 0, f.elements[15] = 1, r = h(f)) : r = h(r.matrixWorld);
			q.style.WebkitTransform = r;
			q.style.MozTransform = r;
			q.style.oTransform = r;
			q.style.transform = r;
			q.parentNode !== this.cameraElement && this.cameraElement.appendChild(q)
		}
	}
};
THREE.DOMRenderer = function () {
	console.log("THREE.DOMRenderer", THREE.REVISION);
	var a, b, c, d, e, f, g, h = new THREE.Projector;
	a: {
		for (var i = ["transform", "MozTransform", "WebkitTransform", "msTransform", "OTransform"], k = document.documentElement, j = 0; j < i.length; j++) if ("string" === typeof k.style[i[j]]) {
			g = i[j];
			break a
		}
		g = null
	}
	this.domElement = document.createElement("div");
	this.setSize = function (a, b) {
		c = a;
		d = b;
		e = c / 2;
		f = d / 2
	};
	this.render = function (c, d) {
		var i, j, k, t, u, x;
		a = h.projectScene(c, d);
		b = a.elements;
		i = 0;
		for (j = b.length; i < j; i++) k = b[i], k instanceof THREE.RenderableParticle && k.material instanceof THREE.ParticleDOMMaterial && (t = k.material.element, u = k.x * e + e - (t.offsetWidth >> 1), x = k.y * f + f - (t.offsetHeight >> 1), t.style.left = u + "px", t.style.top = x + "px", t.style.zIndex = Math.abs(Math.floor((1 - k.z) * d.far / d.near)), g && (t.style[g] = "scale(" + k.scale.x * e + "," + k.scale.y * f + ")"))
	}
};
THREE.SVGRenderer = function () {
	function a(a, b, c, d) {
		var e, f, g, h, i, j;
		e = 0;
		for (f = a.length; e < f; e++) g = a[e], h = g.color, g instanceof THREE.DirectionalLight ? (i = g.matrixWorld.getPosition().normalize(), j = c.dot(i), 0 >= j || (j *= g.intensity, d.r += h.r * j, d.g += h.g * j, d.b += h.b * j)) : g instanceof THREE.PointLight && (i = g.matrixWorld.getPosition(), j = c.dot(G.sub(i, b).normalize()), 0 >= j || (j *= 0 == g.distance ? 1 : 1 - Math.min(b.distanceTo(i) / g.distance, 1), 0 != j && (j *= g.intensity, d.r += h.r * j, d.g += h.g * j, d.b += h.b * j)))
	}
	function b(a) {
		null == I[a] && (I[a] = document.createElementNS("http://www.w3.org/2000/svg", "path"), 0 == J && I[a].setAttribute("shape-rendering", "crispEdges"));
		return I[a]
	}
	console.log("THREE.SVGRenderer", THREE.REVISION);
	var c = this,
		d, e, f, g = new THREE.Projector,
		h = document.createElementNS("http://www.w3.org/2000/svg", "svg"),
		i, k, j, l, m, r, q, p, t = new THREE.Box2,
		u = new THREE.Box2,
		x = !1,
		v = new THREE.Color,
		s = new THREE.Color,
		C = new THREE.Color,
		z = new THREE.Color,
		w = new THREE.Color,
		A = new THREE.Color,
		H, G = new THREE.Vector3,
		I = [],
		V = [],
		E, O, D, J = 1;
	this.domElement = h;
	this.sortElements = this.sortObjects = this.autoClear = !0;
	this.info = {
		render: {
			vertices: 0,
			faces: 0
		}
	};
	this.setQuality = function (a) {
		switch (a) {
			case "high":
				J = 1;
				break;
			case "low":
				J = 0
		}
	};
	this.setSize = function (a, b) {
		i = a;
		k = b;
		j = i / 2;
		l = k / 2;
		h.setAttribute("viewBox", -j + " " + -l + " " + i + " " + k);
		h.setAttribute("width", i);
		h.setAttribute("height", k);
		t.min.set(-j, -l);
		t.max.set(j, l)
	};
	this.clear = function () {
		for (; 0 < h.childNodes.length;) h.removeChild(h.childNodes[0])
	};
	this.render = function (i, k) {
		if (!1 === k instanceof THREE.Camera) console.error("THREE.SVGRenderer.render: camera is not an instance of THREE.Camera.");
		else {
			var G, I, M, F;
			this.autoClear && this.clear();
			c.info.render.vertices = 0;
			c.info.render.faces = 0;
			d = g.projectScene(i, k, this.sortObjects, this.sortElements);
			e = d.elements;
			f = d.lights;
			D = O = 0;
			if (x = 0 < f.length) {
				z.setRGB(0, 0, 0);
				w.setRGB(0, 0, 0);
				A.setRGB(0, 0, 0);
				G = 0;
				for (I = f.length; G < I; G++) F = f[G], M = F.color, F instanceof THREE.AmbientLight ? (z.r += M.r, z.g += M.g, z.b += M.b) : F instanceof THREE.DirectionalLight ? (w.r += M.r, w.g += M.g, w.b += M.b) : F instanceof THREE.PointLight && (A.r += M.r, A.g += M.g, A.b += M.b)
			}
			G = 0;
			for (I = e.length; G < I; G++) if (M = e[G], F = M.material, !(void 0 === F || !1 === F.visible)) if (u.makeEmpty(), M instanceof THREE.RenderableParticle) m = M, m.x *= j, m.y *= -l;
			else if (M instanceof THREE.RenderableLine) {
				if (m = M.v1, r = M.v2, m.positionScreen.x *= j, m.positionScreen.y *= -l, r.positionScreen.x *= j, r.positionScreen.y *= -l, u.setFromPoints([m.positionScreen, r.positionScreen]), !0 === t.isIntersectionBox(u)) {
					M = m;
					var W = r,
						oa = D++;
					null == V[oa] && (V[oa] = document.createElementNS("http://www.w3.org/2000/svg", "line"), 0 == J && V[oa].setAttribute("shape-rendering", "crispEdges"));
					E = V[oa];
					E.setAttribute("x1", M.positionScreen.x);
					E.setAttribute("y1", M.positionScreen.y);
					E.setAttribute("x2", W.positionScreen.x);
					E.setAttribute("y2", W.positionScreen.y);
					F instanceof THREE.LineBasicMaterial && (E.setAttribute("style", "fill: none; stroke: " + F.color.getStyle() + "; stroke-width: " + F.linewidth + "; stroke-opacity: " + F.opacity + "; stroke-linecap: " + F.linecap + "; stroke-linejoin: " + F.linejoin), h.appendChild(E))
				}
			} else if (M instanceof THREE.RenderableFace3) {
				if (m = M.v1, r = M.v2, q = M.v3, m.positionScreen.x *= j, m.positionScreen.y *= -l, r.positionScreen.x *= j, r.positionScreen.y *= -l, q.positionScreen.x *= j, q.positionScreen.y *= -l, u.setFromPoints([m.positionScreen, r.positionScreen, q.positionScreen]), !0 === t.isIntersectionBox(u)) {
					var W = m,
						oa = r,
						ua = q;
					c.info.render.vertices += 3;
					c.info.render.faces++;
					E = b(O++);
					E.setAttribute("d", "M " + W.positionScreen.x + " " + W.positionScreen.y + " L " + oa.positionScreen.x + " " + oa.positionScreen.y + " L " + ua.positionScreen.x + "," + ua.positionScreen.y + "z");
					F instanceof THREE.MeshBasicMaterial ? (v.copy(F.color),
					F.vertexColors === THREE.FaceColors && (v.r *= M.color.r, v.g *= M.color.g, v.b *= M.color.b)) : F instanceof THREE.MeshLambertMaterial ? (s.copy(F.color), C.copy(F.emissive), F.vertexColors === THREE.FaceColors && (s.r *= M.color.r, s.g *= M.color.g, s.b *= M.color.b), x ? (v.r = z.r, v.g = z.g, v.b = z.b, a(f, M.centroidModel, M.normalModel, v), v.r = v.r * s.r + C.r, v.g = v.g * s.g + C.g, v.b = v.b * s.b + C.b) : v.copy(s)) : F instanceof THREE.MeshDepthMaterial ? (H = 1 - F.__2near / (F.__farPlusNear - M.z * F.__farMinusNear), v.setRGB(H, H, H)) : F instanceof THREE.MeshNormalMaterial && (v.r = 0.5 * M.normalModelView.x + 0.5, v.g = 0.5 * M.normalModelView.y + 0.5, v.b = 0.5 * M.normalModelView.z + 0.5);
					F.wireframe ? E.setAttribute("style", "fill: none; stroke: " + v.getStyle() + "; stroke-width: " + F.wireframeLinewidth + "; stroke-opacity: " + F.opacity + "; stroke-linecap: " + F.wireframeLinecap + "; stroke-linejoin: " + F.wireframeLinejoin) : E.setAttribute("style", "fill: " + v.getStyle() + "; fill-opacity: " + F.opacity);
					h.appendChild(E)
				}
			} else if (M instanceof THREE.RenderableFace4 && (m = M.v1, r = M.v2, q = M.v3, p = M.v4, m.positionScreen.x *= j, m.positionScreen.y *= -l, r.positionScreen.x *= j, r.positionScreen.y *= -l, q.positionScreen.x *= j, q.positionScreen.y *= -l, p.positionScreen.x *= j, p.positionScreen.y *= -l, u.setFromPoints([m.positionScreen, r.positionScreen, q.positionScreen, p.positionScreen]), !0 === t.isIntersectionBox(u))) {
				var W = m,
					oa = r,
					ua = q,
					va = p;
				c.info.render.vertices += 4;
				c.info.render.faces++;
				E = b(O++);
				E.setAttribute("d", "M " + W.positionScreen.x + " " + W.positionScreen.y + " L " + oa.positionScreen.x + " " + oa.positionScreen.y + " L " + ua.positionScreen.x + "," + ua.positionScreen.y + " L " + va.positionScreen.x + "," + va.positionScreen.y + "z");
				F instanceof THREE.MeshBasicMaterial ? (v.copy(F.color), F.vertexColors === THREE.FaceColors && (v.r *= M.color.r, v.g *= M.color.g, v.b *= M.color.b)) : F instanceof THREE.MeshLambertMaterial ? (s.copy(F.color), C.copy(F.emissive), F.vertexColors === THREE.FaceColors && (s.r *= M.color.r, s.g *= M.color.g, s.b *= M.color.b), x ? (v.r = z.r, v.g = z.g, v.b = z.b, a(f, M.centroidModel, M.normalModel, v), v.r = v.r * s.r + C.r, v.g = v.g * s.g + C.g, v.b = v.b * s.b + C.b) : v.copy(s)) : F instanceof
				THREE.MeshDepthMaterial ? (H = 1 - F.__2near / (F.__farPlusNear - M.z * F.__farMinusNear), v.setRGB(H, H, H)) : F instanceof THREE.MeshNormalMaterial && (v.r = 0.5 * M.normalModelView.x + 0.5, v.g = 0.5 * M.normalModelView.y + 0.5, v.b = 0.5 * M.normalModelView.z + 0.5);
				F.wireframe ? E.setAttribute("style", "fill: none; stroke: " + v.getStyle() + "; stroke-width: " + F.wireframeLinewidth + "; stroke-opacity: " + F.opacity + "; stroke-linecap: " + F.wireframeLinecap + "; stroke-linejoin: " + F.wireframeLinejoin) : E.setAttribute("style", "fill: " + v.getStyle() +
					"; fill-opacity: " + F.opacity);
				h.appendChild(E)
			}
		}
	}
};
THREE.WebGLDeferredRenderer = function (a) {
	function b(a, b) {
		var c = a.material.uniforms;
		c.matProjInverse && (c.matProjInverse.value = b.projectionMatrixInverse);
		c.matView && (c.matView.value = b.matrixWorldInverse);
		c.matViewInverse && (c.matViewInverse.value = b.matrixWorld);
		if (c = a.properties.originalLight) if (a.visible = c.visible, c instanceof THREE.PointLight) {
			var c = a.properties.originalLight,
				d = a.material.uniforms,
				e = c.distance;
			0 < e ? (a.scale.set(1, 1, 1).multiplyScalar(e), d.lightRadius.value = e, m.copy(c.matrixWorld.getPosition()),
			m.applyProjection(b.matrixWorldInverse)/*CHANGEDb.matrixWorldInverse.multiplyVector3(m)*/, d.lightPositionVS.value.copy(m), a.position.copy(c.matrixWorld.getPosition())) : d.lightRadius.value = Infinity;
			d.lightIntensity.value = c.intensity * c.intensity;
			d.lightColor.value.copyGammaToLinear(c.color);
			if (c.castShadow) {
				for (e = 0; 6 > e; e++) {
					// REMOVE ME!!!
					if(c.properties.shadowCamera === undefined)
					{
						//console.log("c.properties.shadowCamera is undefined");
					}
					//**********
					var f = c.properties.shadowCamera[e],
						g = c.properties.shadowMap[e];
					d.matLightView.value[e] = f.matrixWorldInverse;
					d.matLightProj.value[e] = f.projectionMatrix;
					d.samplerShadowMap.value[e] = g
				}
				d.shadowDarkness.value = Math.sqrt(c.shadowDarkness);
				d.shadowBias.value = c.shadowBias;
				d.shadowMapSize.value.set(c.shadowMapWidth, c.shadowMapHeight)
			}
		} else c instanceof THREE.SpotLight ? (c = a.properties.originalLight, d = a.material.uniforms, e = b.matrixWorldInverse, f = c.matrixWorld, m.copy(f.getPosition()), e.multiplyVector3(m), r.copy(f.getPosition()), r.sub(c.target.matrixWorld.getPosition()), r.normalize(), e.rotateAxis(r), d.lightPositionVS.value.copy(m), d.lightDirectionVS.value.copy(r), d.lightAngle.value = c.angle, d.lightDistance.value = c.distance, d.lightIntensity.value = c.intensity * c.intensity, d.lightColor.value.copyGammaToLinear(c.color), c.castShadow && (e = c.properties.shadowCamera, f = c.properties.shadowMap, d.matLightView.value = e.matrixWorldInverse, d.matLightProj.value = e.projectionMatrix, d.samplerShadowMap.value = f, d.shadowDarkness.value = Math.sqrt(c.shadowDarkness), d.shadowBias.value = c.shadowBias, d.shadowMapSize.value.set(c.shadowMapWidth, c.shadowMapHeight))) : c instanceof THREE.DirectionalLight ? (c = a.properties.originalLight, d = a.material.uniforms, r.copy(c.matrixWorld.getPosition()),
		r.sub/*CHANGEDSelf*/(c.target.matrixWorld.getPosition()), r.normalize(), b.matrixWorldInverse.rotateAxis(r), d.lightDirectionVS.value.copy(r), d.lightIntensity.value = c.intensity * c.intensity, d.lightColor.value.copyGammaToLinear(c.color)) : c instanceof THREE.HemisphereLight ? (c = a.properties.originalLight, d = a.material.uniforms, r.copy(c.matrixWorld.getPosition()), r.normalize(), b.matrixWorldInverse.rotateAxis(r), d.lightDirectionVS.value.copy(r), d.lightIntensity.value = c.intensity * c.intensity, d.lightColorSky.value.copyGammaToLinear(c.color),
		d.lightColorGround.value.copyGammaToLinear(c.groundColor)) : c instanceof THREE.AreaLight && (c = a.properties.originalLight, d = a.material.uniforms, e = c.matrixWorld, f = b.matrixWorldInverse, m.copy(e.getPosition()), f.multiplyVector3(m), d.lightPositionVS.value.copy(m), q.copy(c.right), p.copy(c.normal), e.rotateAxis(q), e.rotateAxis(p), f.rotateAxis(q), f.rotateAxis(p), t.cross(q, p), t.normalize(), d.lightRightVS.value.copy(q), d.lightNormalVS.value.copy(p), d.lightUpVS.value.copy(t), d.lightWidth.value = c.width, d.lightHeight.value = c.height, d.constantAttenuation.value = c.constantAttenuation, d.linearAttenuation.value = c.linearAttenuation, d.quadraticAttenuation.value = c.quadraticAttenuation, d.lightIntensity.value = c.intensity * c.intensity, d.lightColor.value.copyGammaToLinear(c.color))
	}
	var c = this,
		d = void 0 !== a.width ? a.width : 800,
		e = void 0 !== a.height ? a.height : 600,
		f = void 0 !== a.scale ? a.scale : 1,
		g = Math.floor(f * d),
		h = Math.floor(f * e),
		i = void 0 !== a.brightness ? a.brightness : 1,
		k = void 0 !== a.tonemapping ? a.tonemapping : THREE.SimpleOperator,
		j = void 0 !== a.antialias ? a.antialias : !1;
	this.renderer = a.renderer;
	void 0 === this.renderer && (this.renderer = new THREE.WebGLRenderer({
		alpha: !1,
		antialias: !1
	}), this.renderer.setSize(d, e), this.renderer.setClearColorHex(0, 0), this.renderer.autoClear = !1);
	this.domElement = this.renderer.domElement;
	this.shadowMapEnabled = !1;
	this.shadowMapType = THREE.PCFSoftShadowMap;
	this.shadowMapSlopeDepthBias = !1;
	this.shadowMapSlopeScale = 2;
	this.shadowMapSlopeBias = 0;
	this.shadowMapSlopeMax = 0.001;
	this.shadowMapCullFace = THREE.CullFaceFront;
	var l = this.renderer.context,
		m = new THREE.Vector3,
		r = new THREE.Vector3,
		q = new THREE.Vector3,
		p = new THREE.Vector3,
		t = new THREE.Vector3,
		u = new THREE.SphereGeometry(1, 16, 8),
		x = new THREE.PlaneGeometry(2, 2),
		v = new THREE.Color(0),
		s = new THREE.Color(16777215),
		C = THREE.ShaderDeferred.color,
		z = THREE.ShaderDeferred.depth,
		w = THREE.ShaderDeferred.normalDepth,
		A = THREE.ShaderDeferred.emissiveLight,
		H = THREE.ShaderDeferred.pointLight,
		G = THREE.ShaderDeferred.spotLight,
		I = THREE.ShaderDeferred.directionalLight,
		V = THREE.ShaderDeferred.hemisphereLight,
		E = THREE.ShaderDeferred.areaLight,
		a = THREE.ShaderDeferred.composite,
		O, D, J, P, R, Q, N, M, F, W, oa = new THREE.Color,
		ua = 0,
		va, L, da, ca = [],
		ba = new THREE.ShaderMaterial;
	ba.visible = !1;
	var ka = new THREE.ShaderMaterial({
		uniforms: THREE.UniformsUtils.clone(w.uniforms),
		vertexShader: w.vertexShader,
		fragmentShader: w.fragmentShader,
		blending: THREE.NoBlending
	}),
		T = new THREE.ShaderMaterial({
			uniforms: THREE.UniformsUtils.clone(z.uniforms),
			vertexShader: z.vertexShader,
			fragmentShader: z.fragmentShader,
			blending: THREE.NoBlending
		}),
		fa = function (a) {
			var b = {}, d = THREE.UniformsUtils.clone(C.uniforms),
				e = new THREE.ShaderMaterial({
					fragmentShader: C.fragmentShader,
					vertexShader: C.vertexShader,
					uniforms: d,
					defines: {
						USE_MAP: !! a.map,
						USE_ENVMAP: !! a.envMap,
						GAMMA_INPUT: !0
					},
					shading: a.shading
				});
			if (a instanceof THREE.MeshBasicMaterial) var f = v,
				i = a.color;
			else f = a.color, i = void 0 !== a.emissive ? a.emissive : v;
			var j = void 0 !== a.specular ? a.specular : v,
				k = void 0 !== a.shininess ? a.shininess : 1,
				l = void 0 !== a.wrapAround ? a.wrapAround ? -1 : 1 : 1,
				m = void 0 !== a.metal ? a.metal ? 1 : -1 : -1;
			d.emissive.value.copyGammaToLinear(i);
			d.diffuse.value.copyGammaToLinear(f);
			d.specular.value.copyGammaToLinear(j);
			d.shininess.value = k;
			d.wrapAround.value = l;
			d.additiveSpecular.value = m;
			d.map.value = a.map;
			a.envMap && (d.envMap.value = a.envMap, d.useRefract.value = a.envMap.mapping instanceof THREE.CubeRefractionMapping, d.refractionRatio.value = a.refractionRatio, d.combine.value = a.combine, d.reflectivity.value = a.reflectivity, d.flipEnvMap.value = a.envMap instanceof THREE.WebGLRenderTargetCube ? 1 : -1, d.samplerNormalDepth.value = D.renderTarget2, d.viewWidth.value = g, d.viewHeight.value = h, ca.push({
				material: e
			}));
			e.vertexColors = a.vertexColors;
			e.morphTargets = a.morphTargets;
			e.morphNormals = a.morphNormals;
			e.skinning = a.skinning;
			e.alphaTest = a.alphaTest;
			e.wireframe = a.wireframe;
			var p;
			a.map ? p = a.map : a.specularMap ? p = a.specularMap : a.normalMap ? p = a.normalMap : a.bumpMap && (p = a.bumpMap);
			void 0 !== p && (f = p.offset, p = p.repeat, d.offsetRepeat.value.set(f.x, f.y, p.x, p.y));
			b.colorMaterial = e;
			a.morphTargets || a.skinning || a.bumpMap ? (d = THREE.UniformsUtils.clone(w.uniforms), e = new THREE.ShaderMaterial({
				uniforms: d,
				vertexShader: w.vertexShader,
				fragmentShader: w.fragmentShader,
				shading: a.shading,
				defines: {
					USE_BUMPMAP: !! a.bumpMap
				},
				blending: THREE.NoBlending
			}), e.morphTargets = a.morphTargets, e.morphNormals = a.morphNormals, e.skinning = a.skinning, a.bumpMap && (d.bumpMap.value = a.bumpMap, d.bumpScale.value = a.bumpScale, f = a.bumpMap.offset, p = a.bumpMap.repeat, d.offsetRepeat.value.set(f.x, f.y, p.x, p.y))) : e = ka.clone();
			e.wireframe = a.wireframe;
			e.vertexColors = a.vertexColors;
			b.normalDepthMaterial = e;
			a.morphTargets || a.skinning ? (d = THREE.UniformsUtils.clone(z.uniforms),
			d = new THREE.ShaderMaterial({
				uniforms: d,
				vertexShader: z.vertexShader,
				fragmentShader: z.fragmentShader,
				shading: a.shading,
				blending: THREE.NoBlending
			}), d.morphTargets = a.morphTargets, d.skinning = a.skinning) : d = T.clone();
			e = {};
			c.shadowMapSlopeDepthBias && (e.SLOPE_DEPTH_BIAS = !0, d.uniforms.slopeScale.value = c.shadowMapSlopeScale, d.uniforms.slopeBias.value = c.shadowMapSlopeBias, d.uniforms.slopeMax.value = c.shadowMapSlopeMax);
			d.defines = e;
			d.wireframe = a.wireframe;
			d.vertexColors = a.vertexColors;
			d.side = c.shadowMapCullFace === THREE.CullFaceFront ? THREE.BackSide : THREE.FrontSide;
			b.depthMaterial = d;
			b.transparent = a.transparent;
			return b
		}, U = function (a) {
			/*TODO: REMOVE*/
			if(a.name == 'player 1 light')
			{
				var asdfasdfasdfsfadfasdfasdfas;
			}
			if (!a.properties.deferredInitialized) {
				if (a.material) if (a.material instanceof THREE.MeshFaceMaterial) {
					for (var b = [], d = [], e = [], f = a.material.materials, i = 0, j = f.length; i < j; i++) {
						var k = fa(f[i]);
						k.transparent ? (b.push(ba), d.push(ba), e.push(ba)) : (b.push(k.colorMaterial), d.push(k.depthMaterial), e.push(k.normalDepthMaterial))
					}
					a.properties.colorMaterial = new THREE.MeshFaceMaterial(b);
					a.properties.depthMaterial = new THREE.MeshFaceMaterial(d);
					a.properties.normalDepthMaterial = new THREE.MeshFaceMaterial(e)
				} else k = fa(a.material), a.properties.colorMaterial = k.colorMaterial, a.properties.depthMaterial = k.depthMaterial, a.properties.normalDepthMaterial = k.normalDepthMaterial, a.properties.transparent = k.transparent;
				if (a instanceof THREE.PointLight) {
					if (c.shadowMapEnabled && a.castShadow) {
						b = {
							USE_SHADOWMAP: !0
						};
						switch (c.shadowMapType) {
							case THREE.BasicShadowMap:
								b.SHADOWMAP_TYPE_BASIC = !0;
								break;
							case THREE.PCFShadowMap:
								b.SHADOWMAP_TYPE_PCF = !0;
								break;
							case THREE.PCFSoftShadowMap:
								b.SHADOWMAP_TYPE_PCF_SOFT = !0
						}
						c.shadowMapSlopeDepthBias && (b.SLOPE_DEPTH_BIAS = !0)
					} else b = {};
					d = new THREE.ShaderMaterial({
						uniforms: THREE.UniformsUtils.clone(H.uniforms),
						vertexShader: H.vertexShader,
						fragmentShader: H.fragmentShader,
						defines: b,
						blending: THREE.AdditiveBlending,
						depthWrite: !1,
						transparent: !0,
						side: THREE.BackSide
					});
					0 < a.distance ? b = u : (b = x, d.depthTest = !1, d.side = THREE.FrontSide);
					d.uniforms.viewWidth.value = g;
					d.uniforms.viewHeight.value = h;
					d.uniforms.samplerColor.value = O.renderTarget2;
					d.uniforms.samplerNormalDepth.value = D.renderTarget2;
					b = new THREE.Mesh(b, d);
					b.properties.originalLight = a;
					ca.push({
						material: d
					});
					if (a.castShadow) {
						a.properties.shadowMap = [];
						a.properties.shadowCamera = [];
						d = c.renderer.supportsLuminanceFloatRenderTarget() ? THREE.LuminanceFormat : THREE.RGBFormat;
						d = {
							minFilter: THREE.NearestFilter,
							magFilter: THREE.NearestFilter,
							stencilBuffer: !1,
							format: d,
							type: THREE.FloatType
						};
						e = [new THREE.Vector3(0, -1, 0), new THREE.Vector3(0, -1, 0), new THREE.Vector3(0, 0, 1), new THREE.Vector3(0,
						0, -1), new THREE.Vector3(0, -1, 0), new THREE.Vector3(0, -1, 0)];
						f = [new THREE.Vector3(1, 0, 0), new THREE.Vector3(-1, 0, 0), new THREE.Vector3(0, 1, 0), new THREE.Vector3(0, -1, 0), new THREE.Vector3(0, 0, 1), new THREE.Vector3(0, 0, -1)];
						for (i = 0; 6 > i; i++) j = new THREE.WebGLRenderTarget(a.shadowMapWidth, a.shadowMapHeight, d), j.generateMipmaps = !1, a.properties.shadowMap[i] = j, j = new THREE.PerspectiveCamera(90, a.shadowMapWidth / a.shadowMapHeight, a.shadowCameraNear, a.shadowCameraFar), j.up.copy(e[i]), j.lookAt(f[i]), a.properties.shadowCamera[i] = j
					}
					0 < a.distance ? L.add(b) : va.add(b);
					a.castShadow && da.properties.shadowCasters.push(a)
				} else if (a instanceof THREE.SpotLight) {
					b = THREE.UniformsUtils.clone(G.uniforms);
					if (c.shadowMapEnabled && a.castShadow) {
						d = {
							USE_SHADOWMAP: !0
						};
						switch (c.shadowMapType) {
							case THREE.BasicShadowMap:
								d.SHADOWMAP_TYPE_BASIC = !0;
								break;
							case THREE.PCFShadowMap:
								d.SHADOWMAP_TYPE_PCF = !0;
								break;
							case THREE.PCFSoftShadowMap:
								d.SHADOWMAP_TYPE_PCF_SOFT = !0
						}
						c.shadowMapSlopeDepthBias && (d.SLOPE_DEPTH_BIAS = !0)
					} else d = {};
					d = new THREE.ShaderMaterial({
						uniforms: b,
						vertexShader: G.vertexShader,
						fragmentShader: G.fragmentShader,
						defines: d,
						blending: THREE.AdditiveBlending,
						depthWrite: !1,
						depthTest: !1,
						transparent: !0
					});
					b.viewWidth.value = g;
					b.viewHeight.value = h;
					b.samplerColor.value = O.renderTarget2;
					b.samplerNormalDepth.value = D.renderTarget2;
					b = new THREE.Mesh(x, d);
					b.properties.originalLight = a;
					ca.push({
						material: d
					});
					a.castShadow && (d = c.renderer.supportsLuminanceFloatRenderTarget() ? THREE.LuminanceFormat : THREE.RGBFormat, d = new THREE.WebGLRenderTarget(a.shadowMapWidth, a.shadowMapHeight, {
						minFilter: THREE.NearestFilter,
						magFilter: THREE.NearestFilter,
						stencilBuffer: !1,
						format: d,
						type: THREE.FloatType
					}), d.wrapS = THREE.MirroredRepeatWrapping, d.wrapT = THREE.MirroredRepeatWrapping, d.generateMipmaps = !1, a.properties.shadowMap = d, d = new THREE.PerspectiveCamera(a.shadowCameraFov, a.shadowMapWidth / a.shadowMapHeight, a.shadowCameraNear, a.shadowCameraFar), a.properties.shadowCamera = d);
					va.add(b);
					a.castShadow && da.properties.shadowCasters.push(a)
				} else a instanceof THREE.DirectionalLight ? (d = THREE.UniformsUtils.clone(I.uniforms),
				b = new THREE.ShaderMaterial({
					uniforms: d,
					vertexShader: I.vertexShader,
					fragmentShader: I.fragmentShader,
					blending: THREE.AdditiveBlending,
					depthWrite: !1,
					depthTest: !1,
					transparent: !0
				}), d.viewWidth.value = g, d.viewHeight.value = h, d.samplerColor.value = O.renderTarget2, d.samplerNormalDepth.value = D.renderTarget2, d = new THREE.Mesh(x, b), d.properties.originalLight = a, ca.push({
					material: b
				}), va.add(d)) : a instanceof THREE.HemisphereLight ? (d = THREE.UniformsUtils.clone(V.uniforms), b = new THREE.ShaderMaterial({
					uniforms: d,
					vertexShader: V.vertexShader,
					fragmentShader: V.fragmentShader,
					blending: THREE.AdditiveBlending,
					depthWrite: !1,
					depthTest: !1,
					transparent: !0
				}), d.viewWidth.value = g, d.viewHeight.value = h, d.samplerColor.value = O.renderTarget2, d.samplerNormalDepth.value = D.renderTarget2, d = new THREE.Mesh(x, b), d.properties.originalLight = a, ca.push({
					material: b
				}), va.add(d)) : a instanceof THREE.AreaLight && (d = THREE.UniformsUtils.clone(E.uniforms), b = new THREE.ShaderMaterial({
					uniforms: d,
					vertexShader: E.vertexShader,
					fragmentShader: E.fragmentShader,
					blending: THREE.AdditiveBlending,
					depthWrite: !1,
					depthTest: !1,
					transparent: !0
				}), d.viewWidth.value = g, d.viewHeight.value = h, d.samplerColor.value = O.renderTarget2, d.samplerNormalDepth.value = D.renderTarget2, d = new THREE.Mesh(x, b), d.properties.originalLight = a, ca.push({
					material: b
				}), va.add(d));
				a.properties.deferredInitialized = !0
			}
		}, Fa = function (a) {
			a.material && (a.material = a.properties.transparent ? ba : a.properties.colorMaterial)
		}, wa = function (a) {
			a.material && (a.material = a.properties.transparent ? ba : a.properties.normalDepthMaterial)
		}, qa = function (a) {
			a.material && (a.properties.transparent || !a.castShadow ? a.material = ba : (a.material = a.properties.depthMaterial, a = a.material, a.uniforms.slopeScale.value = c.shadowMapSlopeScale, a.uniforms.slopeBias.value = c.shadowMapSlopeBias, a.uniforms.slopeMax.value = c.shadowMapSlopeMax, a.side = c.shadowMapCullFace === THREE.CullFaceFront ? THREE.BackSide : THREE.FrontSide))
		};
	this.setAntialias = function (a) {
		(j = a) ? (W.enabled = !0, F.renderToScreen = !1) : (W.enabled = !1, F.renderToScreen = !0)
	};
	this.getAntialias = function () {
		return j
	};
	this.addEffect = function (a,
	b, c) {
		a.material && a.uniforms && (b && (a.uniforms[b].value = D.renderTarget2), c && (a.uniforms[c].value = O.renderTarget2), (b || c) && ca.push({
			material: a.material,
			normalDepth: b,
			color: c
		}));
		P.insertPass(a, -1)
	};
	this.setScale = function (a) {
		f = a;
		g = Math.floor(f * d);
		h = Math.floor(f * e);
		D.setSize(g, h);
		O.setSize(g, h);
		J.setSize(g, h);
		P.setSize(g, h);
		O.renderTarget2.shareDepthFrom = D.renderTarget2;
		J.renderTarget2.shareDepthFrom = D.renderTarget2;
		for (var a = 0, b = ca.length; a < b; a++) {
			var c = ca[a],
				i = c.material.uniforms,
				j = void 0 !== c.color ? c.color :
					"samplerColor",
				c = void 0 !== c.normalDepth ? c.normalDepth : "samplerNormalDepth";
			i[j] && (i[j].value = O.renderTarget2);
			i[c] && (i[c].value = D.renderTarget2);
			i.viewWidth && (i.viewWidth.value = g);
			i.viewHeight && (i.viewHeight.value = h)
		}
		F.uniforms.samplerLight.value = J.renderTarget2;
		W.uniforms.resolution.value.set(1 / d, 1 / e)
	};
	this.setSize = function (a, b) {
		d = a;
		e = b;
		this.renderer.setSize(d, e);
		this.setScale(f)
	};
	var na = function (a, b, d, e) {
		b.near = e.shadowCameraNear;
		b.far = e.shadowCameraFar;
		b.position.copy(e.matrixWorld.getPosition());
		e.target && b.lookAt(e.target.matrixWorld.getPosition());
		b.updateMatrixWorld();
		b.updateProjectionMatrix();
		b.matrixWorldInverse.getInverse(b.matrixWorld);
		c.renderer.render(a, b, d, !0)
	};
	this.render = function (a, c) {
		if (!a.properties.lightSceneProxy) {
			a.properties.lightSceneProxy = new THREE.Scene;
			a.properties.lightSceneFullscreen = new THREE.Scene;
			var d = new THREE.ShaderMaterial({
				uniforms: THREE.UniformsUtils.clone(A.uniforms),
				vertexShader: A.vertexShader,
				fragmentShader: A.fragmentShader,
				depthTest: !1,
				depthWrite: !1,
				blending: THREE.NoBlending
			});
			d.uniforms.viewWidth.value = g;
			d.uniforms.viewHeight.value = h;
			d.uniforms.samplerColor.value = O.renderTarget2;
			var e = new THREE.Mesh(x, d);
			ca.push({
				material: d
			});
			a.properties.lightSceneFullscreen.add(e);
			a.properties.shadowCasters = []
		}
		L = a.properties.lightSceneProxy;
		va = a.properties.lightSceneFullscreen;
		da = a;
		R.camera = c;
		Q.camera = c;
		M.camera = c;
		N.camera = THREE.EffectComposer.camera;
		R.scene = a;
		Q.scene = a;
		N.scene = va;
		M.scene = L;
		a.traverse(U);
		this.renderer.autoUpdateScene = !1;
		a.updateMatrixWorld();
		a.traverse(wa);
		this.renderer.autoClearDepth = !0;
		this.renderer.autoClearStencil = !0;
		l.stencilOp(l.REPLACE, l.REPLACE, l.REPLACE);
		l.stencilFunc(l.ALWAYS, 1, 4294967295);
		l.clearStencil(0);
		D.render();
		l.stencilFunc(l.EQUAL, 1, 4294967295);
		l.stencilOp(l.KEEP, l.KEEP, l.KEEP);
		a.traverse(Fa);
		this.renderer.autoClearDepth = !0;
		this.renderer.autoClearStencil = !1;
		O.render();
		if (this.shadowMapEnabled) {
			this.renderer.autoClearDepth = !0;
			this.renderer.autoClearStencil = !0;
			this.renderer.autoUpdateScene = !1;
			oa.copy(this.renderer.getClearColor());
			ua = this.renderer.getClearAlpha();
			this.renderer.setClearColor(s, 1);
			a.traverse(qa);
			for (var f = a.properties.shadowCasters, d = 0, e = f.length; d < e; d++) {
				var i = f[d];
				if (i instanceof THREE.SpotLight) {
					var j = i.properties.shadowMap,
						k = i.properties.shadowCamera;
					k.fov = i.shadowCameraFov;
					na(a, k, j, i)
				} else if (i instanceof THREE.PointLight) for (var m = 0; 6 > m; m++) j = i.properties.shadowMap[m], k = i.properties.shadowCamera[m], k.fov = 90, na(a, k, j, i)
			}
			this.renderer.setClearColor(oa, ua)
		}
		this.renderer.autoClearDepth = !1;
		this.renderer.autoUpdateScene = !0;
		l.depthFunc(l.GEQUAL);
		c.projectionMatrixInverse.getInverse(c.projectionMatrix);
		d = 0;
		for (e = L.children.length; d < e; d++) f = L.children[d], b(f, c);
		d = 0;
		for (e = va.children.length; d < e; d++) f = va.children[d], b(f, c);
		J.render();
		this.renderer.autoClearDepth = !0;
		this.renderer.autoClearStencil = !0;
		l.depthFunc(l.LEQUAL);
		l.disable(l.STENCIL_TEST);
		P.render(0.1)
	};
	var ta = {
		minFilter: THREE.NearestFilter,
		magFilter: THREE.LinearFilter,
		stencilBuffer: !0,
		format: THREE.RGBAFormat,
		type: THREE.FloatType
	}, Ga = {
		minFilter: THREE.NearestFilter,
		magFilter: THREE.NearestFilter,
		stencilBuffer: !0,
		format: THREE.RGBAFormat,
		type: THREE.FloatType
	}, ra = {
		minFilter: THREE.NearestFilter,
		magFilter: THREE.LinearFilter,
		stencilBuffer: !1,
		format: THREE.RGBFormat,
		type: THREE.UnsignedByteType
	}, Ua = new THREE.WebGLRenderTarget(g, h, Ga),
		Ga = new THREE.WebGLRenderTarget(g, h, Ga),
		ta = new THREE.WebGLRenderTarget(g, h, ta),
		ra = new THREE.WebGLRenderTarget(g, h, ra);
	Ua.generateMipmaps = !1;
	Ga.generateMipmaps = !1;
	ta.generateMipmaps = !1;
	ra.generateMipmaps = !1;
	Q = new THREE.RenderPass;
	Q.clear = !0;
	D = new THREE.EffectComposer(c.renderer, Ga);
	D.addPass(Q);
	R = new THREE.RenderPass;
	R.clear = !0;
	O = new THREE.EffectComposer(c.renderer, Ua);
	O.addPass(R);
	O.renderTarget2.shareDepthFrom = D.renderTarget2;
	N = new THREE.RenderPass;
	N.clear = !0;
	M = new THREE.RenderPass;
	M.clear = !1;
	J = new THREE.EffectComposer(c.renderer, ta);
	J.addPass(N);
	J.addPass(M);
	J.renderTarget2.shareDepthFrom = D.renderTarget2;
	F = new THREE.ShaderPass(a);
	F.uniforms.samplerLight.value = J.renderTarget2;
	F.uniforms.brightness.value = i;
	F.material.blending = THREE.NoBlending;
	F.clear = !0;
	var Va;
	switch (k) {
		case THREE.SimpleOperator:
			Va = {
				TONEMAP_SIMPLE: !0
			};
			break;
		case THREE.LinearOperator:
			Va = {
				TONEMAP_LINEAR: !0
			};
			break;
		case THREE.ReinhardOperator:
			Va = {
				TONEMAP_REINHARD: !0
			};
			break;
		case THREE.FilmicOperator:
			Va = {
				TONEMAP_FILMIC: !0
			};
			break;
		case THREE.UnchartedOperator:
			Va = {
				TONEMAP_UNCHARTED: !0
			}
	}
	F.material.defines = Va;
	W = new THREE.ShaderPass(THREE.FXAAShader);
	W.uniforms.resolution.value.set(1 / d, 1 / e);
	W.renderToScreen = !0;
	P = new THREE.EffectComposer(c.renderer, ra);
	P.addPass(F);
	P.addPass(W);
	j ? (W.enabled = !0, F.renderToScreen = !1) : (W.enabled = !1, F.renderToScreen = !0)
};
THREE.NoOperator = 0;
THREE.SimpleOperator = 1;
THREE.LinearOperator = 2;
THREE.ReinhardOperator = 3;
THREE.FilmicOperator = 4;
THREE.UnchartedOperator = 5;
THREE.BasicShader = {
	uniforms: {},
	vertexShader: "void main() {\ngl_Position = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );\n}",
	fragmentShader: "void main() {\ngl_FragColor = vec4( 1.0, 0.0, 0.0, 0.5 );\n}"
};
THREE.BleachBypassShader = {
	uniforms: {
		tDiffuse: {
			type: "t",
			value: null
		},
		opacity: {
			type: "f",
			value: 1
		}
	},
	vertexShader: "varying vec2 vUv;\nvoid main() {\nvUv = uv;\ngl_Position = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );\n}",
	fragmentShader: "uniform float opacity;\nuniform sampler2D tDiffuse;\nvarying vec2 vUv;\nvoid main() {\nvec4 base = texture2D( tDiffuse, vUv );\nvec3 lumCoeff = vec3( 0.25, 0.65, 0.1 );\nfloat lum = dot( lumCoeff, base.rgb );\nvec3 blend = vec3( lum );\nfloat L = min( 1.0, max( 0.0, 10.0 * ( lum - 0.45 ) ) );\nvec3 result1 = 2.0 * base.rgb * blend;\nvec3 result2 = 1.0 - 2.0 * ( 1.0 - blend ) * ( 1.0 - base.rgb );\nvec3 newColor = mix( result1, result2, L );\nfloat A2 = opacity * base.a;\nvec3 mixRGB = A2 * newColor.rgb;\nmixRGB += ( ( 1.0 - A2 ) * base.rgb );\ngl_FragColor = vec4( mixRGB, base.a );\n}"
};
THREE.BlendShader = {
	uniforms: {
		tDiffuse1: {
			type: "t",
			value: null
		},
		tDiffuse2: {
			type: "t",
			value: null
		},
		mixRatio: {
			type: "f",
			value: 0.5
		},
		opacity: {
			type: "f",
			value: 1
		}
	},
	vertexShader: "varying vec2 vUv;\nvoid main() {\nvUv = uv;\ngl_Position = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );\n}",
	fragmentShader: "uniform float opacity;\nuniform float mixRatio;\nuniform sampler2D tDiffuse1;\nuniform sampler2D tDiffuse2;\nvarying vec2 vUv;\nvoid main() {\nvec4 texel1 = texture2D( tDiffuse1, vUv );\nvec4 texel2 = texture2D( tDiffuse2, vUv );\ngl_FragColor = opacity * mix( texel1, texel2, mixRatio );\n}"
};
THREE.BokehShader = {
	uniforms: {
		tColor: {
			type: "t",
			value: null
		},
		tDepth: {
			type: "t",
			value: null
		},
		focus: {
			type: "f",
			value: 1
		},
		aspect: {
			type: "f",
			value: 1
		},
		aperture: {
			type: "f",
			value: 0.025
		},
		maxblur: {
			type: "f",
			value: 1
		}
	},
	vertexShader: "varying vec2 vUv;\nvoid main() {\nvUv = uv;\ngl_Position = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );\n}",
	fragmentShader: "varying vec2 vUv;\nuniform sampler2D tColor;\nuniform sampler2D tDepth;\nuniform float maxblur;\nuniform float aperture;\nuniform float focus;\nuniform float aspect;\nvoid main() {\nvec2 aspectcorrect = vec2( 1.0, aspect );\nvec4 depth1 = texture2D( tDepth, vUv );\nfloat factor = depth1.x - focus;\nvec2 dofblur = vec2 ( clamp( factor * aperture, -maxblur, maxblur ) );\nvec2 dofblur9 = dofblur * 0.9;\nvec2 dofblur7 = dofblur * 0.7;\nvec2 dofblur4 = dofblur * 0.4;\nvec4 col = vec4( 0.0 );\ncol += texture2D( tColor, vUv.xy );\ncol += texture2D( tColor, vUv.xy + ( vec2(  0.0,   0.4  ) * aspectcorrect ) * dofblur );\ncol += texture2D( tColor, vUv.xy + ( vec2(  0.15,  0.37 ) * aspectcorrect ) * dofblur );\ncol += texture2D( tColor, vUv.xy + ( vec2(  0.29,  0.29 ) * aspectcorrect ) * dofblur );\ncol += texture2D( tColor, vUv.xy + ( vec2( -0.37,  0.15 ) * aspectcorrect ) * dofblur );\ncol += texture2D( tColor, vUv.xy + ( vec2(  0.40,  0.0  ) * aspectcorrect ) * dofblur );\ncol += texture2D( tColor, vUv.xy + ( vec2(  0.37, -0.15 ) * aspectcorrect ) * dofblur );\ncol += texture2D( tColor, vUv.xy + ( vec2(  0.29, -0.29 ) * aspectcorrect ) * dofblur );\ncol += texture2D( tColor, vUv.xy + ( vec2( -0.15, -0.37 ) * aspectcorrect ) * dofblur );\ncol += texture2D( tColor, vUv.xy + ( vec2(  0.0,  -0.4  ) * aspectcorrect ) * dofblur );\ncol += texture2D( tColor, vUv.xy + ( vec2( -0.15,  0.37 ) * aspectcorrect ) * dofblur );\ncol += texture2D( tColor, vUv.xy + ( vec2( -0.29,  0.29 ) * aspectcorrect ) * dofblur );\ncol += texture2D( tColor, vUv.xy + ( vec2(  0.37,  0.15 ) * aspectcorrect ) * dofblur );\ncol += texture2D( tColor, vUv.xy + ( vec2( -0.4,   0.0  ) * aspectcorrect ) * dofblur );\ncol += texture2D( tColor, vUv.xy + ( vec2( -0.37, -0.15 ) * aspectcorrect ) * dofblur );\ncol += texture2D( tColor, vUv.xy + ( vec2( -0.29, -0.29 ) * aspectcorrect ) * dofblur );\ncol += texture2D( tColor, vUv.xy + ( vec2(  0.15, -0.37 ) * aspectcorrect ) * dofblur );\ncol += texture2D( tColor, vUv.xy + ( vec2(  0.15,  0.37 ) * aspectcorrect ) * dofblur9 );\ncol += texture2D( tColor, vUv.xy + ( vec2( -0.37,  0.15 ) * aspectcorrect ) * dofblur9 );\ncol += texture2D( tColor, vUv.xy + ( vec2(  0.37, -0.15 ) * aspectcorrect ) * dofblur9 );\ncol += texture2D( tColor, vUv.xy + ( vec2( -0.15, -0.37 ) * aspectcorrect ) * dofblur9 );\ncol += texture2D( tColor, vUv.xy + ( vec2( -0.15,  0.37 ) * aspectcorrect ) * dofblur9 );\ncol += texture2D( tColor, vUv.xy + ( vec2(  0.37,  0.15 ) * aspectcorrect ) * dofblur9 );\ncol += texture2D( tColor, vUv.xy + ( vec2( -0.37, -0.15 ) * aspectcorrect ) * dofblur9 );\ncol += texture2D( tColor, vUv.xy + ( vec2(  0.15, -0.37 ) * aspectcorrect ) * dofblur9 );\ncol += texture2D( tColor, vUv.xy + ( vec2(  0.29,  0.29 ) * aspectcorrect ) * dofblur7 );\ncol += texture2D( tColor, vUv.xy + ( vec2(  0.40,  0.0  ) * aspectcorrect ) * dofblur7 );\ncol += texture2D( tColor, vUv.xy + ( vec2(  0.29, -0.29 ) * aspectcorrect ) * dofblur7 );\ncol += texture2D( tColor, vUv.xy + ( vec2(  0.0,  -0.4  ) * aspectcorrect ) * dofblur7 );\ncol += texture2D( tColor, vUv.xy + ( vec2( -0.29,  0.29 ) * aspectcorrect ) * dofblur7 );\ncol += texture2D( tColor, vUv.xy + ( vec2( -0.4,   0.0  ) * aspectcorrect ) * dofblur7 );\ncol += texture2D( tColor, vUv.xy + ( vec2( -0.29, -0.29 ) * aspectcorrect ) * dofblur7 );\ncol += texture2D( tColor, vUv.xy + ( vec2(  0.0,   0.4  ) * aspectcorrect ) * dofblur7 );\ncol += texture2D( tColor, vUv.xy + ( vec2(  0.29,  0.29 ) * aspectcorrect ) * dofblur4 );\ncol += texture2D( tColor, vUv.xy + ( vec2(  0.4,   0.0  ) * aspectcorrect ) * dofblur4 );\ncol += texture2D( tColor, vUv.xy + ( vec2(  0.29, -0.29 ) * aspectcorrect ) * dofblur4 );\ncol += texture2D( tColor, vUv.xy + ( vec2(  0.0,  -0.4  ) * aspectcorrect ) * dofblur4 );\ncol += texture2D( tColor, vUv.xy + ( vec2( -0.29,  0.29 ) * aspectcorrect ) * dofblur4 );\ncol += texture2D( tColor, vUv.xy + ( vec2( -0.4,   0.0  ) * aspectcorrect ) * dofblur4 );\ncol += texture2D( tColor, vUv.xy + ( vec2( -0.29, -0.29 ) * aspectcorrect ) * dofblur4 );\ncol += texture2D( tColor, vUv.xy + ( vec2(  0.0,   0.4  ) * aspectcorrect ) * dofblur4 );\ngl_FragColor = col / 41.0;\ngl_FragColor.a = 1.0;\n}"
};
THREE.BrightnessContrastShader = {
	uniforms: {
		tDiffuse: {
			type: "t",
			value: null
		},
		brightness: {
			type: "f",
			value: 0
		},
		contrast: {
			type: "f",
			value: 0
		}
	},
	vertexShader: "varying vec2 vUv;\nvoid main() {\nvUv = uv;\ngl_Position = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );\n}",
	fragmentShader: "uniform sampler2D tDiffuse;\nuniform float brightness;\nuniform float contrast;\nvarying vec2 vUv;\nvoid main() {\ngl_FragColor = texture2D( tDiffuse, vUv );\ngl_FragColor.rgb += brightness;\nif (contrast > 0.0) {\ngl_FragColor.rgb = (gl_FragColor.rgb - 0.5) / (1.0 - contrast) + 0.5;\n} else {\ngl_FragColor.rgb = (gl_FragColor.rgb - 0.5) * (1.0 + contrast) + 0.5;\n}\n}"
};
THREE.ColorCorrectionShader = {
	uniforms: {
		tDiffuse: {
			type: "t",
			value: null
		},
		powRGB: {
			type: "v3",
			value: new THREE.Vector3(2, 2, 2)
		},
		mulRGB: {
			type: "v3",
			value: new THREE.Vector3(1, 1, 1)
		}
	},
	vertexShader: "varying vec2 vUv;\nvoid main() {\nvUv = uv;\ngl_Position = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );\n}",
	fragmentShader: "uniform sampler2D tDiffuse;\nuniform vec3 powRGB;\nuniform vec3 mulRGB;\nvarying vec2 vUv;\nvoid main() {\ngl_FragColor = texture2D( tDiffuse, vUv );\ngl_FragColor.rgb = mulRGB * pow( gl_FragColor.rgb, powRGB );\n}"
};
THREE.ColorifyShader = {
	uniforms: {
		tDiffuse: {
			type: "t",
			value: null
		},
		color: {
			type: "c",
			value: new THREE.Color(16777215)
		}
	},
	vertexShader: "varying vec2 vUv;\nvoid main() {\nvUv = uv;\ngl_Position = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );\n}",
	fragmentShader: "uniform vec3 color;\nuniform sampler2D tDiffuse;\nvarying vec2 vUv;\nvoid main() {\nvec4 texel = texture2D( tDiffuse, vUv );\nvec3 luma = vec3( 0.299, 0.587, 0.114 );\nfloat v = dot( texel.xyz, luma );\ngl_FragColor = vec4( v * color, texel.w );\n}"
};
THREE.ConvolutionShader = {
	defines: {
		KERNEL_SIZE_FLOAT: "25.0",
		KERNEL_SIZE_INT: "25"
	},
	uniforms: {
		tDiffuse: {
			type: "t",
			value: null
		},
		uImageIncrement: {
			type: "v2",
			value: new THREE.Vector2(0.001953125, 0)
		},
		cKernel: {
			type: "fv1",
			value: []
		}
	},
	vertexShader: "uniform vec2 uImageIncrement;\nvarying vec2 vUv;\nvoid main() {\nvUv = uv - ( ( KERNEL_SIZE_FLOAT - 1.0 ) / 2.0 ) * uImageIncrement;\ngl_Position = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );\n}",
	fragmentShader: "uniform float cKernel[ KERNEL_SIZE_INT ];\nuniform sampler2D tDiffuse;\nuniform vec2 uImageIncrement;\nvarying vec2 vUv;\nvoid main() {\nvec2 imageCoord = vUv;\nvec4 sum = vec4( 0.0, 0.0, 0.0, 0.0 );\nfor( int i = 0; i < KERNEL_SIZE_INT; i ++ ) {\nsum += texture2D( tDiffuse, imageCoord ) * cKernel[ i ];\nimageCoord += uImageIncrement;\n}\ngl_FragColor = sum;\n}",
	buildKernel: function (a) {
		var b, c, d, e, f = 2 * Math.ceil(3 * a) + 1;
		25 < f && (f = 25);
		e = 0.5 * (f - 1);
		c = Array(f);
		for (b = d = 0; b < f; ++b) c[b] = Math.exp(-((b - e) * (b - e)) / (2 * a * a)), d += c[b];
		for (b = 0; b < f; ++b) c[b] /= d;
		return c
	}
};
THREE.CopyShader = {
	uniforms: {
		tDiffuse: {
			type: "t",
			value: null
		},
		opacity: {
			type: "f",
			value: 1
		}
	},
	vertexShader: "varying vec2 vUv;\nvoid main() {\nvUv = uv;\ngl_Position = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );\n}",
	fragmentShader: "uniform float opacity;\nuniform sampler2D tDiffuse;\nvarying vec2 vUv;\nvoid main() {\nvec4 texel = texture2D( tDiffuse, vUv );\ngl_FragColor = opacity * texel;\n}"
};
THREE.DOFMipMapShader = {
	uniforms: {
		tColor: {
			type: "t",
			value: null
		},
		tDepth: {
			type: "t",
			value: null
		},
		focus: {
			type: "f",
			value: 1
		},
		maxblur: {
			type: "f",
			value: 1
		}
	},
	vertexShader: "varying vec2 vUv;\nvoid main() {\nvUv = uv;\ngl_Position = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );\n}",
	fragmentShader: "uniform float focus;\nuniform float maxblur;\nuniform sampler2D tColor;\nuniform sampler2D tDepth;\nvarying vec2 vUv;\nvoid main() {\nvec4 depth = texture2D( tDepth, vUv );\nfloat factor = depth.x - focus;\nvec4 col = texture2D( tColor, vUv, 2.0 * maxblur * abs( focus - depth.x ) );\ngl_FragColor = col;\ngl_FragColor.a = 1.0;\n}"
};
THREE.DotScreenShader = {
	uniforms: {
		tDiffuse: {
			type: "t",
			value: null
		},
		tSize: {
			type: "v2",
			value: new THREE.Vector2(256, 256)
		},
		center: {
			type: "v2",
			value: new THREE.Vector2(0.5, 0.5)
		},
		angle: {
			type: "f",
			value: 1.57
		},
		scale: {
			type: "f",
			value: 1
		}
	},
	vertexShader: "varying vec2 vUv;\nvoid main() {\nvUv = uv;\ngl_Position = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );\n}",
	fragmentShader: "uniform vec2 center;\nuniform float angle;\nuniform float scale;\nuniform vec2 tSize;\nuniform sampler2D tDiffuse;\nvarying vec2 vUv;\nfloat pattern() {\nfloat s = sin( angle ), c = cos( angle );\nvec2 tex = vUv * tSize - center;\nvec2 point = vec2( c * tex.x - s * tex.y, s * tex.x + c * tex.y ) * scale;\nreturn ( sin( point.x ) * sin( point.y ) ) * 4.0;\n}\nvoid main() {\nvec4 color = texture2D( tDiffuse, vUv );\nfloat average = ( color.r + color.g + color.b ) / 3.0;\ngl_FragColor = vec4( vec3( average * 10.0 - 5.0 + pattern() ), color.a );\n}"
};
THREE.FilmShader = {
	uniforms: {
		tDiffuse: {
			type: "t",
			value: null
		},
		time: {
			type: "f",
			value: 0
		},
		nIntensity: {
			type: "f",
			value: 0.5
		},
		sIntensity: {
			type: "f",
			value: 0.05
		},
		sCount: {
			type: "f",
			value: 4096
		},
		grayscale: {
			type: "i",
			value: 1
		}
	},
	vertexShader: "varying vec2 vUv;\nvoid main() {\nvUv = uv;\ngl_Position = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );\n}",
	fragmentShader: "uniform float time;\nuniform bool grayscale;\nuniform float nIntensity;\nuniform float sIntensity;\nuniform float sCount;\nuniform sampler2D tDiffuse;\nvarying vec2 vUv;\nvoid main() {\nvec4 cTextureScreen = texture2D( tDiffuse, vUv );\nfloat x = vUv.x * vUv.y * time *  1000.0;\nx = mod( x, 13.0 ) * mod( x, 123.0 );\nfloat dx = mod( x, 0.01 );\nvec3 cResult = cTextureScreen.rgb + cTextureScreen.rgb * clamp( 0.1 + dx * 100.0, 0.0, 1.0 );\nvec2 sc = vec2( sin( vUv.y * sCount ), cos( vUv.y * sCount ) );\ncResult += cTextureScreen.rgb * vec3( sc.x, sc.y, sc.x ) * sIntensity;\ncResult = cTextureScreen.rgb + clamp( nIntensity, 0.0,1.0 ) * ( cResult - cTextureScreen.rgb );\nif( grayscale ) {\ncResult = vec3( cResult.r * 0.3 + cResult.g * 0.59 + cResult.b * 0.11 );\n}\ngl_FragColor =  vec4( cResult, cTextureScreen.a );\n}"
};
THREE.FocusShader = {
	uniforms: {
		tDiffuse: {
			type: "t",
			value: null
		},
		screenWidth: {
			type: "f",
			value: 1024
		},
		screenHeight: {
			type: "f",
			value: 1024
		},
		sampleDistance: {
			type: "f",
			value: 0.94
		},
		waveFactor: {
			type: "f",
			value: 0.00125
		}
	},
	vertexShader: "varying vec2 vUv;\nvoid main() {\nvUv = uv;\ngl_Position = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );\n}",
	fragmentShader: "uniform float screenWidth;\nuniform float screenHeight;\nuniform float sampleDistance;\nuniform float waveFactor;\nuniform sampler2D tDiffuse;\nvarying vec2 vUv;\nvoid main() {\nvec4 color, org, tmp, add;\nfloat sample_dist, f;\nvec2 vin;\nvec2 uv = vUv;\nadd = color = org = texture2D( tDiffuse, uv );\nvin = ( uv - vec2( 0.5 ) ) * vec2( 1.4 );\nsample_dist = dot( vin, vin ) * 2.0;\nf = ( waveFactor * 100.0 + sample_dist ) * sampleDistance * 4.0;\nvec2 sampleSize = vec2(  1.0 / screenWidth, 1.0 / screenHeight ) * vec2( f );\nadd += tmp = texture2D( tDiffuse, uv + vec2( 0.111964, 0.993712 ) * sampleSize );\nif( tmp.b < color.b ) color = tmp;\nadd += tmp = texture2D( tDiffuse, uv + vec2( 0.846724, 0.532032 ) * sampleSize );\nif( tmp.b < color.b ) color = tmp;\nadd += tmp = texture2D( tDiffuse, uv + vec2( 0.943883, -0.330279 ) * sampleSize );\nif( tmp.b < color.b ) color = tmp;\nadd += tmp = texture2D( tDiffuse, uv + vec2( 0.330279, -0.943883 ) * sampleSize );\nif( tmp.b < color.b ) color = tmp;\nadd += tmp = texture2D( tDiffuse, uv + vec2( -0.532032, -0.846724 ) * sampleSize );\nif( tmp.b < color.b ) color = tmp;\nadd += tmp = texture2D( tDiffuse, uv + vec2( -0.993712, -0.111964 ) * sampleSize );\nif( tmp.b < color.b ) color = tmp;\nadd += tmp = texture2D( tDiffuse, uv + vec2( -0.707107, 0.707107 ) * sampleSize );\nif( tmp.b < color.b ) color = tmp;\ncolor = color * vec4( 2.0 ) - ( add / vec4( 8.0 ) );\ncolor = color + ( add / vec4( 8.0 ) - color ) * ( vec4( 1.0 ) - vec4( sample_dist * 0.5 ) );\ngl_FragColor = vec4( color.rgb * color.rgb * vec3( 0.95 ) + color.rgb, 1.0 );\n}"
};
THREE.FXAAShader = {
	uniforms: {
		tDiffuse: {
			type: "t",
			value: null
		},
		resolution: {
			type: "v2",
			value: new THREE.Vector2(1 / 1024, 1 / 512)
		}
	},
	vertexShader: "varying vec2 vUv;\nvoid main() {\nvUv = uv;\ngl_Position = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );\n}",
	fragmentShader: "uniform sampler2D tDiffuse;\nuniform vec2 resolution;\nvarying vec2 vUv;\n#define FXAA_REDUCE_MIN   (1.0/128.0)\n#define FXAA_REDUCE_MUL   (1.0/8.0)\n#define FXAA_SPAN_MAX     8.0\nvoid main() {\nvec3 rgbNW = texture2D( tDiffuse, ( gl_FragCoord.xy + vec2( -1.0, -1.0 ) ) * resolution ).xyz;\nvec3 rgbNE = texture2D( tDiffuse, ( gl_FragCoord.xy + vec2( 1.0, -1.0 ) ) * resolution ).xyz;\nvec3 rgbSW = texture2D( tDiffuse, ( gl_FragCoord.xy + vec2( -1.0, 1.0 ) ) * resolution ).xyz;\nvec3 rgbSE = texture2D( tDiffuse, ( gl_FragCoord.xy + vec2( 1.0, 1.0 ) ) * resolution ).xyz;\nvec4 rgbaM  = texture2D( tDiffuse,  gl_FragCoord.xy  * resolution );\nvec3 rgbM  = rgbaM.xyz;\nfloat opacity  = rgbaM.w;\nvec3 luma = vec3( 0.299, 0.587, 0.114 );\nfloat lumaNW = dot( rgbNW, luma );\nfloat lumaNE = dot( rgbNE, luma );\nfloat lumaSW = dot( rgbSW, luma );\nfloat lumaSE = dot( rgbSE, luma );\nfloat lumaM  = dot( rgbM,  luma );\nfloat lumaMin = min( lumaM, min( min( lumaNW, lumaNE ), min( lumaSW, lumaSE ) ) );\nfloat lumaMax = max( lumaM, max( max( lumaNW, lumaNE) , max( lumaSW, lumaSE ) ) );\nvec2 dir;\ndir.x = -((lumaNW + lumaNE) - (lumaSW + lumaSE));\ndir.y =  ((lumaNW + lumaSW) - (lumaNE + lumaSE));\nfloat dirReduce = max( ( lumaNW + lumaNE + lumaSW + lumaSE ) * ( 0.25 * FXAA_REDUCE_MUL ), FXAA_REDUCE_MIN );\nfloat rcpDirMin = 1.0 / ( min( abs( dir.x ), abs( dir.y ) ) + dirReduce );\ndir = min( vec2( FXAA_SPAN_MAX,  FXAA_SPAN_MAX),\nmax( vec2(-FXAA_SPAN_MAX, -FXAA_SPAN_MAX),\ndir * rcpDirMin)) * resolution;\nvec3 rgbA = 0.5 * (\ntexture2D( tDiffuse, gl_FragCoord.xy  * resolution + dir * ( 1.0 / 3.0 - 0.5 ) ).xyz +\ntexture2D( tDiffuse, gl_FragCoord.xy  * resolution + dir * ( 2.0 / 3.0 - 0.5 ) ).xyz );\nvec3 rgbB = rgbA * 0.5 + 0.25 * (\ntexture2D( tDiffuse, gl_FragCoord.xy  * resolution + dir * -0.5 ).xyz +\ntexture2D( tDiffuse, gl_FragCoord.xy  * resolution + dir * 0.5 ).xyz );\nfloat lumaB = dot( rgbB, luma );\nif ( ( lumaB < lumaMin ) || ( lumaB > lumaMax ) ) {\ngl_FragColor = vec4( rgbA, opacity );\n} else {\ngl_FragColor = vec4( rgbB, opacity );\n}\n}"
};
THREE.HorizontalBlurShader = {
	uniforms: {
		tDiffuse: {
			type: "t",
			value: null
		},
		h: {
			type: "f",
			value: 1 / 512
		}
	},
	vertexShader: "varying vec2 vUv;\nvoid main() {\nvUv = uv;\ngl_Position = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );\n}",
	fragmentShader: "uniform sampler2D tDiffuse;\nuniform float h;\nvarying vec2 vUv;\nvoid main() {\nvec4 sum = vec4( 0.0 );\nsum += texture2D( tDiffuse, vec2( vUv.x - 4.0 * h, vUv.y ) ) * 0.051;\nsum += texture2D( tDiffuse, vec2( vUv.x - 3.0 * h, vUv.y ) ) * 0.0918;\nsum += texture2D( tDiffuse, vec2( vUv.x - 2.0 * h, vUv.y ) ) * 0.12245;\nsum += texture2D( tDiffuse, vec2( vUv.x - 1.0 * h, vUv.y ) ) * 0.1531;\nsum += texture2D( tDiffuse, vec2( vUv.x, vUv.y ) ) * 0.1633;\nsum += texture2D( tDiffuse, vec2( vUv.x + 1.0 * h, vUv.y ) ) * 0.1531;\nsum += texture2D( tDiffuse, vec2( vUv.x + 2.0 * h, vUv.y ) ) * 0.12245;\nsum += texture2D( tDiffuse, vec2( vUv.x + 3.0 * h, vUv.y ) ) * 0.0918;\nsum += texture2D( tDiffuse, vec2( vUv.x + 4.0 * h, vUv.y ) ) * 0.051;\ngl_FragColor = sum;\n}"
};
THREE.HorizontalTiltShiftShader = {
	uniforms: {
		tDiffuse: {
			type: "t",
			value: null
		},
		h: {
			type: "f",
			value: 1 / 512
		},
		r: {
			type: "f",
			value: 0.35
		}
	},
	vertexShader: "varying vec2 vUv;\nvoid main() {\nvUv = uv;\ngl_Position = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );\n}",
	fragmentShader: "uniform sampler2D tDiffuse;\nuniform float h;\nuniform float r;\nvarying vec2 vUv;\nvoid main() {\nvec4 sum = vec4( 0.0 );\nfloat hh = h * abs( r - vUv.y );\nsum += texture2D( tDiffuse, vec2( vUv.x - 4.0 * hh, vUv.y ) ) * 0.051;\nsum += texture2D( tDiffuse, vec2( vUv.x - 3.0 * hh, vUv.y ) ) * 0.0918;\nsum += texture2D( tDiffuse, vec2( vUv.x - 2.0 * hh, vUv.y ) ) * 0.12245;\nsum += texture2D( tDiffuse, vec2( vUv.x - 1.0 * hh, vUv.y ) ) * 0.1531;\nsum += texture2D( tDiffuse, vec2( vUv.x, vUv.y ) ) * 0.1633;\nsum += texture2D( tDiffuse, vec2( vUv.x + 1.0 * hh, vUv.y ) ) * 0.1531;\nsum += texture2D( tDiffuse, vec2( vUv.x + 2.0 * hh, vUv.y ) ) * 0.12245;\nsum += texture2D( tDiffuse, vec2( vUv.x + 3.0 * hh, vUv.y ) ) * 0.0918;\nsum += texture2D( tDiffuse, vec2( vUv.x + 4.0 * hh, vUv.y ) ) * 0.051;\ngl_FragColor = sum;\n}"
};
THREE.HueSaturationShader = {
	uniforms: {
		tDiffuse: {
			type: "t",
			value: null
		},
		hue: {
			type: "f",
			value: 0
		},
		saturation: {
			type: "f",
			value: 0
		}
	},
	vertexShader: "varying vec2 vUv;\nvoid main() {\nvUv = uv;\ngl_Position = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );\n}",
	fragmentShader: "uniform sampler2D tDiffuse;\nuniform float hue;\nuniform float saturation;\nvarying vec2 vUv;\nvoid main() {\ngl_FragColor = texture2D( tDiffuse, vUv );\nfloat angle = hue * 3.14159265;\nfloat s = sin(angle), c = cos(angle);\nvec3 weights = (vec3(2.0 * c, -sqrt(3.0) * s - c, sqrt(3.0) * s - c) + 1.0) / 3.0;\nfloat len = length(gl_FragColor.rgb);\ngl_FragColor.rgb = vec3(\ndot(gl_FragColor.rgb, weights.xyz),\ndot(gl_FragColor.rgb, weights.zxy),\ndot(gl_FragColor.rgb, weights.yzx)\n);\nfloat average = (gl_FragColor.r + gl_FragColor.g + gl_FragColor.b) / 3.0;\nif (saturation > 0.0) {\ngl_FragColor.rgb += (average - gl_FragColor.rgb) * (1.0 - 1.0 / (1.001 - saturation));\n} else {\ngl_FragColor.rgb += (average - gl_FragColor.rgb) * (-saturation);\n}\n}"
};
THREE.LuminosityShader = {
	uniforms: {
		tDiffuse: {
			type: "t",
			value: null
		}
	},
	vertexShader: "varying vec2 vUv;\nvoid main() {\nvUv = uv;\ngl_Position = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );\n}",
	fragmentShader: "uniform sampler2D tDiffuse;\nvarying vec2 vUv;\nvoid main() {\nvec4 texel = texture2D( tDiffuse, vUv );\nvec3 luma = vec3( 0.299, 0.587, 0.114 );\nfloat v = dot( texel.xyz, luma );\ngl_FragColor = vec4( v, v, v, texel.w );\n}"
};
THREE.NormalMapShader = {
	uniforms: {
		heightMap: {
			type: "t",
			value: null
		},
		resolution: {
			type: "v2",
			value: new THREE.Vector2(512, 512)
		},
		scale: {
			type: "v2",
			value: new THREE.Vector2(1, 1)
		},
		height: {
			type: "f",
			value: 0.05
		}
	},
	vertexShader: "varying vec2 vUv;\nvoid main() {\nvUv = uv;\ngl_Position = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );\n}",
	fragmentShader: "uniform float height;\nuniform vec2 resolution;\nuniform sampler2D heightMap;\nvarying vec2 vUv;\nvoid main() {\nfloat val = texture2D( heightMap, vUv ).x;\nfloat valU = texture2D( heightMap, vUv + vec2( 1.0 / resolution.x, 0.0 ) ).x;\nfloat valV = texture2D( heightMap, vUv + vec2( 0.0, 1.0 / resolution.y ) ).x;\ngl_FragColor = vec4( ( 0.5 * normalize( vec3( val - valU, val - valV, height  ) ) + 0.5 ), 1.0 );\n}"
};
THREE.RGBShiftShader = {
	uniforms: {
		tDiffuse: {
			type: "t",
			value: null
		},
		amount: {
			type: "f",
			value: 0.005
		},
		angle: {
			type: "f",
			value: 0
		}
	},
	vertexShader: "varying vec2 vUv;\nvoid main() {\nvUv = uv;\ngl_Position = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );\n}",
	fragmentShader: "uniform sampler2D tDiffuse;\nuniform float amount;\nuniform float angle;\nvarying vec2 vUv;\nvoid main() {\nvec2 offset = amount * vec2( cos(angle), sin(angle));\nvec4 cr = texture2D(tDiffuse, vUv + offset);\nvec4 cga = texture2D(tDiffuse, vUv);\nvec4 cb = texture2D(tDiffuse, vUv - offset);\ngl_FragColor = vec4(cr.r, cga.g, cb.b, cga.a);\n}"
};
THREE.SepiaShader = {
	uniforms: {
		tDiffuse: {
			type: "t",
			value: null
		},
		amount: {
			type: "f",
			value: 1
		}
	},
	vertexShader: "varying vec2 vUv;\nvoid main() {\nvUv = uv;\ngl_Position = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );\n}",
	fragmentShader: "uniform float amount;\nuniform sampler2D tDiffuse;\nvarying vec2 vUv;\nvoid main() {\nvec4 color = texture2D( tDiffuse, vUv );\nvec3 c = color.rgb;\ncolor.r = dot( c, vec3( 1.0 - 0.607 * amount, 0.769 * amount, 0.189 * amount ) );\ncolor.g = dot( c, vec3( 0.349 * amount, 1.0 - 0.314 * amount, 0.168 * amount ) );\ncolor.b = dot( c, vec3( 0.272 * amount, 0.534 * amount, 1.0 - 0.869 * amount ) );\ngl_FragColor = vec4( min( vec3( 1.0 ), color.rgb ), color.a );\n}"
};
/*THREE.SSAOShader={uniforms:{tDiffuse:{type:"t",value:null},tDepth:{type:"t",value:null},size:{type:"v2",value:new THREE.Vector2(512,512)},cameraNear:{type:"f",value:1},cameraFar:{type:"f",value:100},fogNear:{type:"f",value:5},fogFar:{type:"f",value:100},fogEnabled:{type:"i",value:0},onlyAO:{type:"i",value:0},aoClamp:{type:"f",value:0.3},lumInfluence:{type:"f",value:0.9}},vertexShader:"varying vec2 vUv;\nvoid main() {\nvUv = uv;\ngl_Position = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );\n}",
fragmentShader:"uniform float cameraNear;\nuniform float cameraFar;\nuniform float fogNear;\nuniform float fogFar;\nuniform bool fogEnabled;\nuniform bool onlyAO;\nuniform vec2 size;\nuniform float aoClamp;\nuniform float lumInfluence;\nuniform sampler2D tDiffuse;\nuniform sampler2D tDepth;\nvarying vec2 vUv;\n#define DL 2.399963229728653\n#define EULER 2.718281828459045\nfloat width = size.x;\nfloat height = size.y;\nfloat cameraFarPlusNear = cameraFar + cameraNear;\nfloat cameraFarMinusNear = cameraFar - cameraNear;\nfloat cameraCoef = 2.0 * cameraNear;\n#ifndef SAMPLES\n#define SAMPLES 8\n#endif\n#ifndef RADIUS\n#define RADIUS 5.0\n#endif\n#if !defined( FLOAT_DEPTH ) && !defined( RGBA_DEPTH )\n#define RGBA_DEPTH\n#endif\n#ifndef ONLY_AO_COLOR\n#define ONLY_AO_COLOR 1.0, 1.0, 1.0\n#endif\nconst int samples = SAMPLES;\nconst float radius = RADIUS;\nconst bool useNoise = false;\nconst float noiseAmount = 0.0003;\nconst float diffArea = 0.4;\nconst float gDisplace = 0.4;\nconst vec3 onlyAOColor = vec3( ONLY_AO_COLOR );\nfloat unpackDepth( const in vec4 rgba_depth ) {\nfloat depth = 0.0;\n#if defined( RGBA_DEPTH )\nconst vec4 bit_shift = vec4( 1.0 / ( 256.0 * 256.0 * 256.0 ), 1.0 / ( 256.0 * 256.0 ), 1.0 / 256.0, 1.0 );\ndepth = dot( rgba_depth, bit_shift );\n#elif defined( FLOAT_DEPTH )\ndepth = rgba_depth.w;\n#endif\nreturn depth;\n}\nvec2 rand( const vec2 coord ) {\nvec2 noise;\nif ( useNoise ) {\nfloat nx = dot ( coord, vec2( 12.9898, 78.233 ) );\nfloat ny = dot ( coord, vec2( 12.9898, 78.233 ) * 2.0 );\nnoise = clamp( fract ( 43758.5453 * sin( vec2( nx, ny ) ) ), 0.0, 1.0 );\n} else {\nfloat ff = fract( 1.0 - coord.s * ( width / 2.0 ) );\nfloat gg = fract( coord.t * ( height / 2.0 ) );\nnoise = vec2( 0.25, 0.75 ) * vec2( ff ) + vec2( 0.75, 0.25 ) * gg;\n}\nreturn ( noise * 2.0  - 1.0 ) * noiseAmount;\n}\nfloat doFog() {\nfloat zdepth = unpackDepth( texture2D( tDepth, vUv ) );\nfloat depth = -cameraFar * cameraNear / ( zdepth * cameraFarMinusNear - cameraFar );\nreturn smoothstep( fogNear, fogFar, depth );\n}\nfloat readDepth( const in vec2 coord ) {\nreturn cameraCoef / ( cameraFarPlusNear - unpackDepth( texture2D( tDepth, coord ) ) * cameraFarMinusNear );\n}\nfloat compareDepths( const in float depth1, const in float depth2, inout int far ) {\nfloat garea = 2.0;\nfloat diff = ( depth1 - depth2 ) * 100.0;\nif ( diff < gDisplace ) {\ngarea = diffArea;\n} else {\nfar = 1;\n}\nfloat dd = diff - gDisplace;\nfloat gauss = pow( EULER, -2.0 * dd * dd / ( garea * garea ) );\nreturn gauss;\n}\nfloat calcAO( float depth, float dw, float dh ) {\nfloat dd = radius - depth * radius;\nvec2 vv = vec2( dw, dh );\nvec2 coord1 = vUv + dd * vv;\nvec2 coord2 = vUv - dd * vv;\nfloat temp1 = 0.0;\nfloat temp2 = 0.0;\nint far = 0;\ntemp1 = compareDepths( depth, readDepth( coord1 ), far );\nif ( far > 0 ) {\ntemp2 = compareDepths( readDepth( coord2 ), depth, far );\ntemp1 += ( 1.0 - temp1 ) * temp2;\n}\nreturn temp1;\n}\nvoid main() {\nvec2 noise = rand( vUv );\nfloat depth = readDepth( vUv );\nfloat tt = clamp( depth, aoClamp, 1.0 );\nfloat w = ( 1.0 / width )  / tt + ( noise.x * ( 1.0 - noise.x ) );\nfloat h = ( 1.0 / height ) / tt + ( noise.y * ( 1.0 - noise.y ) );\nfloat pw;\nfloat ph;\nfloat ao;\nfloat dz = 1.0 / float( samples );\nfloat z = 1.0 - dz / 2.0;\nfloat l = 0.0;\nfor ( int i = 0; i <= samples; i ++ ) {\nfloat r = sqrt( 1.0 - z );\npw = cos( l ) * r;\nph = sin( l ) * r;\nao += calcAO( depth, pw * w, ph * h );\nz = z - dz;\nl = l + DL;\n}\nao /= float( samples );\nao = 1.0 - ao;\nif ( fogEnabled ) {\nao = mix( ao, 1.0, doFog() );\n}\nvec3 color = texture2D( tDiffuse, vUv ).rgb;\nvec3 lumcoeff = vec3( 0.299, 0.587, 0.114 );\nfloat lum = dot( color.rgb, lumcoeff );\nvec3 luminance = vec3( lum );\nvec3 final = vec3( color * mix( vec3( ao ), vec3( 1.0 ), luminance * lumInfluence ) );\nif ( onlyAO ) {\nfinal = onlyAOColor * vec3( mix( vec3( ao ), vec3( 1.0 ), luminance * lumInfluence ) );\n}\ngl_FragColor = vec4( final, 1.0 );\n}"};THREE.TriangleBlurShader={uniforms:{texture:{type:"t",value:null},delta:{type:"v2",value:new THREE.Vector2(1,1)}},vertexShader:"varying vec2 vUv;\nvoid main() {\nvUv = uv;\ngl_Position = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );\n}",fragmentShader:"#define ITERATIONS 10.0\nuniform sampler2D texture;\nuniform vec2 delta;\nvarying vec2 vUv;\nfloat random( vec3 scale, float seed ) {\nreturn fract( sin( dot( gl_FragCoord.xyz + seed, scale ) ) * 43758.5453 + seed );\n}\nvoid main() {\nvec4 color = vec4( 0.0 );\nfloat total = 0.0;\nfloat offset = random( vec3( 12.9898, 78.233, 151.7182 ), 0.0 );\nfor ( float t = -ITERATIONS; t <= ITERATIONS; t ++ ) {\nfloat percent = ( t + offset - 0.5 ) / ITERATIONS;\nfloat weight = 1.0 - abs( percent );\ncolor += texture2D( texture, vUv + delta * percent ) * weight;\ntotal += weight;\n}\ngl_FragColor = color / total;\n}"};THREE.UnpackDepthRGBAShader={uniforms:{tDiffuse:{type:"t",value:null},opacity:{type:"f",value:1}},vertexShader:"varying vec2 vUv;\nvoid main() {\nvUv = uv;\ngl_Position = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );\n}",fragmentShader:"uniform float opacity;\nuniform sampler2D tDiffuse;\nvarying vec2 vUv;\nfloat unpackDepth( const in vec4 rgba_depth ) {\nconst vec4 bit_shift = vec4( 1.0 / ( 256.0 * 256.0 * 256.0 ), 1.0 / ( 256.0 * 256.0 ), 1.0 / 256.0, 1.0 );\nfloat depth = dot( rgba_depth, bit_shift );\nreturn depth;\n}\nvoid main() {\nfloat depth = 1.0 - unpackDepth( texture2D( tDiffuse, vUv ) );\ngl_FragColor = opacity * vec4( vec3( depth ), 1.0 );\n}"};THREE.VerticalBlurShader={uniforms:{tDiffuse:{type:"t",value:null},v:{type:"f",value:1/512}},vertexShader:"varying vec2 vUv;\nvoid main() {\nvUv = uv;\ngl_Position = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );\n}",fragmentShader:"uniform sampler2D tDiffuse;\nuniform float v;\nvarying vec2 vUv;\nvoid main() {\nvec4 sum = vec4( 0.0 );\nsum += texture2D( tDiffuse, vec2( vUv.x, vUv.y - 4.0 * v ) ) * 0.051;\nsum += texture2D( tDiffuse, vec2( vUv.x, vUv.y - 3.0 * v ) ) * 0.0918;\nsum += texture2D( tDiffuse, vec2( vUv.x, vUv.y - 2.0 * v ) ) * 0.12245;\nsum += texture2D( tDiffuse, vec2( vUv.x, vUv.y - 1.0 * v ) ) * 0.1531;\nsum += texture2D( tDiffuse, vec2( vUv.x, vUv.y ) ) * 0.1633;\nsum += texture2D( tDiffuse, vec2( vUv.x, vUv.y + 1.0 * v ) ) * 0.1531;\nsum += texture2D( tDiffuse, vec2( vUv.x, vUv.y + 2.0 * v ) ) * 0.12245;\nsum += texture2D( tDiffuse, vec2( vUv.x, vUv.y + 3.0 * v ) ) * 0.0918;\nsum += texture2D( tDiffuse, vec2( vUv.x, vUv.y + 4.0 * v ) ) * 0.051;\ngl_FragColor = sum;\n}"};THREE.VerticalTiltShiftShader={uniforms:{tDiffuse:{type:"t",value:null},v:{type:"f",value:1/512},r:{type:"f",value:0.35}},vertexShader:"varying vec2 vUv;\nvoid main() {\nvUv = uv;\ngl_Position = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );\n}",fragmentShader:"uniform sampler2D tDiffuse;\nuniform float v;\nuniform float r;\nvarying vec2 vUv;\nvoid main() {\nvec4 sum = vec4( 0.0 );\nfloat vv = v * abs( r - vUv.y );\nsum += texture2D( tDiffuse, vec2( vUv.x, vUv.y - 4.0 * vv ) ) * 0.051;\nsum += texture2D( tDiffuse, vec2( vUv.x, vUv.y - 3.0 * vv ) ) * 0.0918;\nsum += texture2D( tDiffuse, vec2( vUv.x, vUv.y - 2.0 * vv ) ) * 0.12245;\nsum += texture2D( tDiffuse, vec2( vUv.x, vUv.y - 1.0 * vv ) ) * 0.1531;\nsum += texture2D( tDiffuse, vec2( vUv.x, vUv.y ) ) * 0.1633;\nsum += texture2D( tDiffuse, vec2( vUv.x, vUv.y + 1.0 * vv ) ) * 0.1531;\nsum += texture2D( tDiffuse, vec2( vUv.x, vUv.y + 2.0 * vv ) ) * 0.12245;\nsum += texture2D( tDiffuse, vec2( vUv.x, vUv.y + 3.0 * vv ) ) * 0.0918;\nsum += texture2D( tDiffuse, vec2( vUv.x, vUv.y + 4.0 * vv ) ) * 0.051;\ngl_FragColor = sum;\n}"};THREE.VignetteShader={uniforms:{tDiffuse:{type:"t",value:null},offset:{type:"f",value:1},darkness:{type:"f",value:1}},vertexShader:"varying vec2 vUv;\nvoid main() {\nvUv = uv;\ngl_Position = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );\n}",fragmentShader:"uniform float offset;\nuniform float darkness;\nuniform sampler2D tDiffuse;\nvarying vec2 vUv;\nvoid main() {\nvec4 texel = texture2D( tDiffuse, vUv );\nvec2 uv = ( vUv - vec2( 0.5 ) ) * vec2( offset );\ngl_FragColor = vec4( mix( texel.rgb, vec3( 1.0 - darkness ), dot( uv, uv ) ), texel.a );\n}"};*/

// CUSTOM SSAO SHADER
/**
 * @author alteredq / http://alteredqualia.com/
 *
 * Screen-space ambient occlusion shader
 * - ported from
 *   SSAO GLSL shader v1.2
 *   assembled by Martins Upitis (martinsh) (http://devlog-martinsh.blogspot.com)
 *   original technique is made by ArKano22 (http://www.gamedev.net/topic/550699-ssao-no-halo-artifacts/)
 * - modifications
 * - modified to use RGBA packed depth texture (use clear color 1,1,1,1 for depth pass)
 * - made fog more compatible with three.js linear fog
 * - refactoring and optimizations
 */

THREE.SSAOShader = {

	uniforms: {

		"tDiffuse": {
			type: "t",
			value: null
		},
		"tDepth": {
			type: "t",
			value: null
		},
		"size": {
			type: "v2",
			value: new THREE.Vector2(512, 512)
		},
		"cameraNear": {
			type: "f",
			value: 1
		},
		"cameraFar": {
			type: "f",
			value: 100
		},
		"fogNear": {
			type: "f",
			value: 5
		},
		"fogFar": {
			type: "f",
			value: 100
		},
		"fogEnabled": {
			type: "i",
			value: 0
		},
		"onlyAO": {
			type: "i",
			value: 0
		},
		"aoClamp": {
			type: "f",
			value: 0.3
		},
		"lumInfluence": {
			type: "f",
			value: 0.9
		}

	},

	vertexShader: [

		"varying vec2 vUv;",

		"void main() {",

		"vUv = uv;",

		"gl_Position = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );",

		"}"

	].join("\n"),

	fragmentShader: [

		"uniform float cameraNear;",
		"uniform float cameraFar;",

		"uniform float fogNear;",
		"uniform float fogFar;",

		"uniform bool fogEnabled;", // attenuate AO with linear fog
	"uniform bool onlyAO;", // use only ambient occlusion pass?

	"uniform vec2 size;", // texture width, height
	"uniform float aoClamp;", // depth clamp - reduces haloing at screen edges

	"uniform float lumInfluence;", // how much luminance affects occlusion

	"uniform sampler2D tDiffuse;",
		"uniform sampler2D tDepth;",

		"varying vec2 vUv;",

	// "#define PI 3.14159265",
	"#define DL 2.399963229728653", // PI * ( 3.0 - sqrt( 5.0 ) )
	"#define EULER 2.718281828459045",

	// helpers

	"float width = size.x;", // texture width
	"float height = size.y;", // texture height

	"float cameraFarPlusNear = cameraFar + cameraNear;",
		"float cameraFarMinusNear = cameraFar - cameraNear;",
		"float cameraCoef = 2.0 * cameraNear;",

	// user variables

	"const int samples = 64;", // ao sample count
	"const float radius = 5.0;", // ao radius

	"const bool useNoise = false;", // use noise instead of pattern for sample dithering
	"const float noiseAmount = 0.0003;", // dithering amount

	//"const float diffArea = 0.4;",   // self-shadowing reduction
	//"const float gDisplace = 0.4;",  // gauss bell center

	"const float diffArea = 0.05;", // self-shadowing reduction
	"const float gDisplace = 0.04;", // gauss bell center

	//"const vec3 onlyAOColor = vec3( 1.0, 0.7, 0.5 );",
	"const vec3 onlyAOColor = vec3( 1.0, 1.0, 1.0 );",


	// RGBA depth

	"float unpackDepth( const in vec4 rgba_depth ) {",

		"const vec4 bit_shift = vec4( 1.0 / ( 256.0 * 256.0 * 256.0 ), 1.0 / ( 256.0 * 256.0 ), 1.0 / 256.0, 1.0 );",
		"float depth = dot( rgba_depth, bit_shift );",
		"return depth;",

		"}",

	// generating noise / pattern texture for dithering

	"vec2 rand( const vec2 coord ) {",

		"vec2 noise;",

		"if ( useNoise ) {",

		"float nx = dot ( coord, vec2( 12.9898, 78.233 ) );",
		"float ny = dot ( coord, vec2( 12.9898, 78.233 ) * 2.0 );",

		"noise = clamp( fract ( 43758.5453 * sin( vec2( nx, ny ) ) ), 0.0, 1.0 );",

		"} else {",

		"float ff = fract( 1.0 - coord.s * ( width / 2.0 ) );",
		"float gg = fract( coord.t * ( height / 2.0 ) );",

		"noise = vec2( 0.25, 0.75 ) * vec2( ff ) + vec2( 0.75, 0.25 ) * gg;",

		"}",

		"return ( noise * 2.0  - 1.0 ) * noiseAmount;",

		"}",

		"float doFog() {",

		"float zdepth = unpackDepth( texture2D( tDepth, vUv ) );",
		"float depth = -cameraFar * cameraNear / ( zdepth * cameraFarMinusNear - cameraFar );",

		"return smoothstep( fogNear, fogFar, depth );",

		"}",

		"float readDepth( const in vec2 coord ) {",

	// "return ( 2.0 * cameraNear ) / ( cameraFar + cameraNear - unpackDepth( texture2D( tDepth, coord ) ) * ( cameraFar - cameraNear ) );",
	"return cameraCoef / ( cameraFarPlusNear - unpackDepth( texture2D( tDepth, coord ) ) * cameraFarMinusNear );",


		"}",

		"float compareDepths( const in float depth1, const in float depth2, inout int far ) {",

		"float garea = 2.0;", // gauss bell width
	"float diff = ( depth1 - depth2 ) * 100.0;", // depth difference (0-100)

	// reduce left bell width to avoid self-shadowing

	"if ( diff < gDisplace ) {",

		"garea = diffArea;",

		"} else {",

		"far = 1;",

		"}",

		"float dd = diff - gDisplace;",
		"float gauss = pow( EULER, -2.0 * dd * dd / ( garea * garea ) );",
		"return gauss;",

		"}",

		"float calcAO( float depth, float dw, float dh ) {",

		"float dd = radius - depth * radius;",
		"vec2 vv = vec2( dw, dh );",

		"vec2 coord1 = vUv + dd * vv;",
		"vec2 coord2 = vUv - dd * vv;",

		"float temp1 = 0.0;",
		"float temp2 = 0.0;",

		"int far = 0;",
		"temp1 = compareDepths( depth, readDepth( coord1 ), far );",

	// DEPTH EXTRAPOLATION

	"if ( far > 0 ) {",

		"temp2 = compareDepths( readDepth( coord2 ), depth, far );",
		"temp1 += ( 1.0 - temp1 ) * temp2;",

		"}",

		"return temp1;",

		"}",

		"void main() {",

		"vec2 noise = rand( vUv );",
		"float depth = readDepth( vUv );",

		"float tt = clamp( depth, aoClamp, 1.0 );",

		"float w = ( 1.0 / width )  / tt + ( noise.x * ( 1.0 - noise.x ) );",
		"float h = ( 1.0 / height ) / tt + ( noise.y * ( 1.0 - noise.y ) );",

		"float pw;",
		"float ph;",

		"float ao;",

		"float dz = 1.0 / float( samples );",
		"float z = 1.0 - dz / 2.0;",
		"float l = 0.0;",

		"for ( int i = 0; i <= samples; i ++ ) {",

		"float r = sqrt( 1.0 - z );",

		"pw = cos( l ) * r;",
		"ph = sin( l ) * r;",
		"ao += calcAO( depth, pw * w, ph * h );",
		"z = z - dz;",
		"l = l + DL;",

		"}",

		"ao /= float( samples );",
		"ao = 1.0 - ao;",

		"if ( fogEnabled ) {",

		"ao = mix( ao, 1.0, doFog() );",

		"}",

		"vec3 color = texture2D( tDiffuse, vUv ).rgb;",

		"vec3 lumcoeff = vec3( 0.299, 0.587, 0.114 );",
		"float lum = dot( color.rgb, lumcoeff );",
		"vec3 luminance = vec3( lum );",

		"vec3 final = vec3( color * mix( vec3( ao ), vec3( 1.0 ), luminance * lumInfluence ) );", // mix( color * ao, white, luminance )

	"if ( onlyAO ) {",

		"final = onlyAOColor * vec3( mix( vec3( ao ), vec3( 1.0 ), luminance * lumInfluence ) );", // ambient occlusion only

	"}",

		"gl_FragColor = vec4( final, 1.0 );",

		"}"

	].join("\n")

};


THREE.AudioObject = function (a, b, c, d) {
	THREE.Object3D.call(this);
	void 0 === c && (c = 1);
	void 0 === b && (b = 1);
	void 0 === d && (d = !0);
	if (!this.context) try {
		this.context = new webkitAudioContext
	} catch (e) {
		return console.warn("THREE.AudioObject: webkitAudioContext not found"), this
	}
	this.directionalSource = !1;
	this.listener = this.context.listener;
	this.panner = this.context.createPanner();
	this.source = this.context.createBufferSource();
	this.masterGainNode = this.context.createGainNode();
	this.dryGainNode = this.context.createGainNode();
	this.masterGainNode.gain.value = b;
	this.dryGainNode.gain.value = 3;
	this.source.connect(this.panner);
	this.panner.connect(this.dryGainNode);
	this.dryGainNode.connect(this.masterGainNode);
	this.masterGainNode.connect(this.context.destination);
	this.source.playbackRate.value = c;
	this.source.loop = d;
	var f = new XMLHttpRequest;
	f.open("GET", a, !0);
	f.responseType = "arraybuffer";
	f.onload = function () {
		t.source.buffer = t.context.createBuffer(f.response, !0);
		t.source.noteOn(0)
	};
	f.send();
	var g = new THREE.Vector3,
		h = new THREE.Vector3,
		i = new THREE.Vector3,
		k = new THREE.Vector3,
		j = new THREE.Vector3,
		l = new THREE.Vector3,
		m = new THREE.Vector3,
		r = new THREE.Vector3,
		q = new THREE.Vector3,
		p = new THREE.Vector3,
		t = this;
	this.setVolume = function (a) {
		this.masterGainNode.gain.value = a
	};
	this.update = function (a) {
		i.copy(g);
		k.copy(h);
		g.copy(this.matrixWorld.getPosition());
		h.copy(a.matrixWorld.getPosition());
		j.sub(g, i);
		l.sub(h, k);
		p.copy(a.up);
		r.set(0, 0, -1);
		a.matrixWorld.rotateAxis(r);
		r.normalize();
		this.listener.setPosition(h.x, h.y, h.z);
		this.listener.setVelocity(l.x,
		l.y, l.z);
		this.listener.setOrientation(r.x, r.y, r.z, p.x, p.y, p.z);
		this.panner.setPosition(g.x, g.y, g.z);
		this.panner.setVelocity(j.x, j.y, j.z);
		this.directionalSource && (m.set(0, 0, -1), this.matrixWorld.rotateAxis(m), m.normalize(), q.copy(this.up), this.panner.setOrientation(m.x, m.y, m.z, q.x, q.y, q.z))
	}
};
THREE.AudioObject.prototype = Object.create(THREE.Object3D.prototype);
THREE.AudioObject.prototype.context = null;
THREE.AudioObject.prototype.type = null;
THREE.Car = function () {
	function a() {
		if (b.bodyGeometry && b.wheelGeometry) {
			if (b.autoWheelGeometry) {
				b.wheelGeometry.computeBoundingBox();
				var a = b.wheelGeometry.boundingBox;
				b.wheelOffset.add(a.min, a.max);
				b.wheelOffset.multiplyScalar(0.5);
				b.wheelDiameter = a.max.y - a.min.y;
				THREE.GeometryUtils.center(b.wheelGeometry)
			}
			var a = b.modelScale,
				d = new THREE.Vector3,
				e = new THREE.MeshFaceMaterial(b.bodyMaterials),
				f = new THREE.MeshFaceMaterial(b.wheelMaterials);
			b.bodyMesh = new THREE.Mesh(b.bodyGeometry, e);
			b.bodyMesh.scale.set(a,
			a, a);
			b.root.add(b.bodyMesh);
			d.multiply(b.wheelOffset, new THREE.Vector3(a, a, a));
			b.frontLeftWheelRoot.position.add(d);
			b.frontLeftWheelMesh = new THREE.Mesh(b.wheelGeometry, f);
			b.frontLeftWheelMesh.scale.set(a, a, a);
			b.frontLeftWheelRoot.add(b.frontLeftWheelMesh);
			b.root.add(b.frontLeftWheelRoot);
			d.multiply(b.wheelOffset, new THREE.Vector3(-a, a, a));
			b.frontRightWheelRoot.position.add(d);
			b.frontRightWheelMesh = new THREE.Mesh(b.wheelGeometry, f);
			b.frontRightWheelMesh.scale.set(a, a, a);
			b.frontRightWheelMesh.rotation.z = Math.PI;
			b.frontRightWheelRoot.add(b.frontRightWheelMesh);
			b.root.add(b.frontRightWheelRoot);
			d.multiply(b.wheelOffset, new THREE.Vector3(a, a, -a));
			d.z -= b.backWheelOffset;
			b.backLeftWheelMesh = new THREE.Mesh(b.wheelGeometry, f);
			b.backLeftWheelMesh.position.add(d);
			b.backLeftWheelMesh.scale.set(a, a, a);
			b.root.add(b.backLeftWheelMesh);
			d.multiply(b.wheelOffset, new THREE.Vector3(-a, a, -a));
			d.z -= b.backWheelOffset;
			b.backRightWheelMesh = new THREE.Mesh(b.wheelGeometry, f);
			b.backRightWheelMesh.position.add(d);
			b.backRightWheelMesh.scale.set(a, a, a);
			b.backRightWheelMesh.rotation.z = Math.PI;
			b.root.add(b.backRightWheelMesh);
			b.meshes = [b.bodyMesh, b.frontLeftWheelMesh, b.frontRightWheelMesh, b.backLeftWheelMesh, b.backRightWheelMesh];
			b.loaded = !0;
			b.callback && b.callback(b)
		}
	}
	var b = this;
	this.modelScale = 1;
	this.backWheelOffset = 2;
	this.autoWheelGeometry = !0;
	this.wheelOffset = new THREE.Vector3;
	this.wheelDiameter = 1;
	this.MAX_SPEED = 2200;
	this.MAX_REVERSE_SPEED = -1500;
	this.MAX_WHEEL_ROTATION = 0.6;
	this.FRONT_ACCELERATION = 1250;
	this.BACK_ACCELERATION = 1500;
	this.WHEEL_ANGULAR_ACCELERATION = 1.5;
	this.FRONT_DECCELERATION = 750;
	this.WHEEL_ANGULAR_DECCELERATION = 1;
	this.STEERING_RADIUS_RATIO = 0.0023;
	this.MAX_TILT_SIDES = 0.05;
	this.MAX_TILT_FRONTBACK = 0.015;
	this.carOrientation = this.wheelOrientation = this.acceleration = this.speed = 0;
	this.root = new THREE.Object3D;
	this.frontLeftWheelRoot = new THREE.Object3D;
	this.frontRightWheelRoot = new THREE.Object3D;
	this.wheelMaterials = this.bodyMaterials = this.wheelGeometry = this.bodyGeometry = this.backRightWheelMesh = this.backLeftWheelMesh = this.frontRightWheelMesh = this.frontLeftWheelMesh = this.bodyMesh = null;
	this.loaded = !1;
	this.meshes = [];
	this.enableShadows = function (a) {
		for (var b = 0; b < this.meshes.length; b++) this.meshes[b].castShadow = a, this.meshes[b].receiveShadow = a
	};
	this.setVisible = function (a) {
		for (var b = 0; b < this.meshes.length; b++) this.meshes[b].visible = a, this.meshes[b].visible = a
	};
	this.loadPartsJSON = function (c, d) {
		var e = new THREE.JSONLoader;
		e.load(c, function (c, d) {
			b.bodyGeometry = c;
			b.bodyMaterials = d;
			a()
		});
		e.load(d, function (c, d) {
			b.wheelGeometry = c;
			b.wheelMaterials = d;
			a()
		})
	};
	this.loadPartsBinary = function (c, d) {
		var e = new THREE.BinaryLoader;
		e.load(c, function (c, d) {
			b.bodyGeometry = c;
			b.bodyMaterials = d;
			a()
		});
		e.load(d, function (c, d) {
			b.wheelGeometry = c;
			b.wheelMaterials = d;
			a()
		})
	};
	this.updateCarModel = function (a, b) {
		b.moveForward && (this.speed = THREE.Math.clamp(this.speed + a * this.FRONT_ACCELERATION, this.MAX_REVERSE_SPEED, this.MAX_SPEED), this.acceleration = THREE.Math.clamp(this.acceleration + a, -1, 1));
		b.moveBackward && (this.speed = THREE.Math.clamp(this.speed - a * this.BACK_ACCELERATION,
		this.MAX_REVERSE_SPEED, this.MAX_SPEED), this.acceleration = THREE.Math.clamp(this.acceleration - a, -1, 1));
		b.moveLeft && (this.wheelOrientation = THREE.Math.clamp(this.wheelOrientation + a * this.WHEEL_ANGULAR_ACCELERATION, -this.MAX_WHEEL_ROTATION, this.MAX_WHEEL_ROTATION));
		b.moveRight && (this.wheelOrientation = THREE.Math.clamp(this.wheelOrientation - a * this.WHEEL_ANGULAR_ACCELERATION, -this.MAX_WHEEL_ROTATION, this.MAX_WHEEL_ROTATION));
		if (!b.moveForward && !b.moveBackward) if (0 < this.speed) {
			var e = 1 === this.speed / this.MAX_SPEED ? 1 : -Math.pow(2, -10 * (this.speed / this.MAX_SPEED)) + 1;
			this.speed = THREE.Math.clamp(this.speed - e * a * this.FRONT_DECCELERATION, 0, this.MAX_SPEED);
			this.acceleration = THREE.Math.clamp(this.acceleration - e * a, 0, 1)
		} else e = 1 === this.speed / this.MAX_REVERSE_SPEED ? 1 : -Math.pow(2, -10 * (this.speed / this.MAX_REVERSE_SPEED)) + 1, this.speed = THREE.Math.clamp(this.speed + e * a * this.BACK_ACCELERATION, this.MAX_REVERSE_SPEED, 0), this.acceleration = THREE.Math.clamp(this.acceleration + e * a, -1, 0);
		!b.moveLeft && !b.moveRight && (this.wheelOrientation = 0 < this.wheelOrientation ? THREE.Math.clamp(this.wheelOrientation - a * this.WHEEL_ANGULAR_DECCELERATION, 0, this.MAX_WHEEL_ROTATION) : THREE.Math.clamp(this.wheelOrientation + a * this.WHEEL_ANGULAR_DECCELERATION, -this.MAX_WHEEL_ROTATION, 0));
		e = this.speed * a;
		this.carOrientation += e * this.STEERING_RADIUS_RATIO * this.wheelOrientation;
		this.root.position.x += Math.sin(this.carOrientation) * e;
		this.root.position.z += Math.cos(this.carOrientation) * e;
		this.root.rotation.y = this.carOrientation;
		this.loaded && (this.bodyMesh.rotation.z = this.MAX_TILT_SIDES * this.wheelOrientation * (this.speed / this.MAX_SPEED), this.bodyMesh.rotation.x = -this.MAX_TILT_FRONTBACK * this.acceleration);
		e *= 1 / (this.modelScale * (this.wheelDiameter / 2));
		this.loaded && (this.frontLeftWheelMesh.rotation.x += e, this.frontRightWheelMesh.rotation.x += e, this.backLeftWheelMesh.rotation.x += e, this.backRightWheelMesh.rotation.x += e);
		this.frontLeftWheelRoot.rotation.y = this.wheelOrientation;
		this.frontRightWheelRoot.rotation.y = this.wheelOrientation
	}
};
THREE.Curves = {};
THREE.Curves.GrannyKnot = THREE.Curve.create(function () {}, function (a) {
	var a = 2 * Math.PI * a,
		b = -0.22 * Math.cos(a) - 1.28 * Math.sin(a) - 0.44 * Math.cos(3 * a) - 0.78 * Math.sin(3 * a),
		c = -0.1 * Math.cos(2 * a) - 0.27 * Math.sin(2 * a) + 0.38 * Math.cos(4 * a) + 0.46 * Math.sin(4 * a),
		a = 0.7 * Math.cos(3 * a) - 0.4 * Math.sin(3 * a);
	return (new THREE.Vector3(b, c, a)).multiplyScalar(20)
});
THREE.Curves.HeartCurve = THREE.Curve.create(function (a) {
	this.scale = void 0 === a ? 5 : a
}, function (a) {
	var a = a * 2 * Math.PI,
		b = 16 * Math.pow(Math.sin(a), 3),
		a = 13 * Math.cos(a) - 5 * Math.cos(2 * a) - 2 * Math.cos(3 * a) - Math.cos(4 * a);
	return (new THREE.Vector3(b, a, 0)).multiplyScalar(this.scale)
});
THREE.Curves.VivianiCurve = THREE.Curve.create(function (a) {
	this.radius = a
}, function (a) {
	var a = 4 * a * Math.PI,
		b = this.radius / 2,
		c = b * (1 + Math.cos(a)),
		d = b * Math.sin(a),
		a = 2 * b * Math.sin(a / 2);
	return new THREE.Vector3(c, d, a)
});
THREE.Curves.KnotCurve = THREE.Curve.create(function () {}, function (a) {
	var a = a * 2 * Math.PI,
		b = 50 * Math.sin(a),
		c = Math.cos(a) * (10 + 50 * Math.cos(a)),
		a = Math.sin(a) * (10 + 50 * Math.cos(a));
	return new THREE.Vector3(b, c, a)
});
THREE.Curves.HelixCurve = THREE.Curve.create(function () {}, function (a) {
	var b = 150 * 2 * Math.PI * a / 30,
		c = 30 * Math.cos(b),
		b = 30 * Math.sin(b);
	return new THREE.Vector3(c, b, 150 * a)
});
THREE.Curves.TrefoilKnot = THREE.Curve.create(function (a) {
	this.scale = void 0 === a ? 10 : a
}, function (a) {
	var a = a * 2 * Math.PI,
		b = (2 + Math.cos(3 * a)) * Math.cos(2 * a),
		c = (2 + Math.cos(3 * a)) * Math.sin(2 * a),
		a = Math.sin(3 * a);
	return (new THREE.Vector3(b, c, a)).multiplyScalar(this.scale)
});
THREE.Curves.TorusKnot = THREE.Curve.create(function (a) {
	this.scale = void 0 === a ? 10 : a
}, function (a) {
	var a = a * 2 * Math.PI,
		b = (2 + Math.cos(4 * a)) * Math.cos(3 * a),
		c = (2 + Math.cos(4 * a)) * Math.sin(3 * a),
		a = Math.sin(4 * a);
	return (new THREE.Vector3(b, c, a)).multiplyScalar(this.scale)
});
THREE.Curves.CinquefoilKnot = THREE.Curve.create(function (a) {
	this.scale = void 0 === a ? 10 : a
}, function (a) {
	var a = a * 2 * Math.PI,
		b = (2 + Math.cos(5 * a)) * Math.cos(2 * a),
		c = (2 + Math.cos(5 * a)) * Math.sin(2 * a),
		a = Math.sin(5 * a);
	return (new THREE.Vector3(b, c, a)).multiplyScalar(this.scale)
});
THREE.Curves.TrefoilPolynomialKnot = THREE.Curve.create(function (a) {
	this.scale = void 0 === a ? 10 : a
}, function (a) {
	var a = 4 * a - 2,
		b = Math.pow(a, 3) - 3 * a,
		c = Math.pow(a, 4) - 4 * a * a,
		a = 0.2 * Math.pow(a, 5) - 2 * a;
	return (new THREE.Vector3(b, c, a)).multiplyScalar(this.scale)
});
var scaleTo = function (a, b, c) {
	return c * (b - a) + a
};
THREE.Curves.FigureEightPolynomialKnot = THREE.Curve.create(function (a) {
	this.scale = void 0 === a ? 1 : a
}, function (a) {
	var a = scaleTo(-4, 4, a),
		b = 0.4 * a * (a * a - 7) * (a * a - 10),
		c = Math.pow(a, 4) - 13 * a * a;
	return (new THREE.Vector3(b, c, 0.1 * a * (a * a - 4) * (a * a - 9) * (a * a - 12))).multiplyScalar(this.scale)
});
THREE.Curves.DecoratedTorusKnot4a = THREE.Curve.create(function (a) {
	this.scale = void 0 === a ? 40 : a
}, function (a) {
	var a = a * 2 * Math.PI,
		b = Math.cos(2 * a) * (1 + 0.6 * (Math.cos(5 * a) + 0.75 * Math.cos(10 * a))),
		c = Math.sin(2 * a) * (1 + 0.6 * (Math.cos(5 * a) + 0.75 * Math.cos(10 * a))),
		a = 0.35 * Math.sin(5 * a);
	return (new THREE.Vector3(b, c, a)).multiplyScalar(this.scale)
});
THREE.Curves.DecoratedTorusKnot4b = THREE.Curve.create(function (a) {
	this.scale = void 0 === a ? 40 : a
}, function (a) {
	var b = 2 * a * Math.PI,
		a = Math.cos(2 * b) * (1 + 0.45 * Math.cos(3 * b) + 0.4 * Math.cos(9 * b)),
		c = Math.sin(2 * b) * (1 + 0.45 * Math.cos(3 * b) + 0.4 * Math.cos(9 * b)),
		b = 0.2 * Math.sin(9 * b);
	return (new THREE.Vector3(a, c, b)).multiplyScalar(this.scale)
});
THREE.Curves.DecoratedTorusKnot5a = THREE.Curve.create(function (a) {
	this.scale = void 0 === a ? 40 : a
}, function (a) {
	var b = 2 * a * Math.PI,
		a = Math.cos(3 * b) * (1 + 0.3 * Math.cos(5 * b) + 0.5 * Math.cos(10 * b)),
		c = Math.sin(3 * b) * (1 + 0.3 * Math.cos(5 * b) + 0.5 * Math.cos(10 * b)),
		b = 0.2 * Math.sin(20 * b);
	return (new THREE.Vector3(a, c, b)).multiplyScalar(this.scale)
});
THREE.Curves.DecoratedTorusKnot5c = THREE.Curve.create(function (a) {
	this.scale = void 0 === a ? 40 : a
}, function (a) {
	var b = 2 * a * Math.PI,
		a = Math.cos(4 * b) * (1 + 0.5 * (Math.cos(5 * b) + 0.4 * Math.cos(20 * b))),
		c = Math.sin(4 * b) * (1 + 0.5 * (Math.cos(5 * b) + 0.4 * Math.cos(20 * b))),
		b = 0.35 * Math.sin(15 * b);
	return (new THREE.Vector3(a, c, b)).multiplyScalar(this.scale)
});
THREE.MarchingCubes = function (a, b, c, d) {
	THREE.ImmediateRenderObject.call(this);
	this.material = b;
	this.enableUvs = void 0 !== c ? c : !1;
	this.enableColors = void 0 !== d ? d : !1;
	this.init = function (a) {
		this.resolution = a;
		this.isolation = 80;
		this.size = a;
		this.size2 = this.size * this.size;
		this.size3 = this.size2 * this.size;
		this.halfsize = this.size / 2;
		this.delta = 2 / this.size;
		this.yd = this.size;
		this.zd = this.size2;
		this.field = new Float32Array(this.size3);
		this.normal_cache = new Float32Array(3 * this.size3);
		this.vlist = new Float32Array(36);
		this.nlist = new Float32Array(36);
		this.firstDraw = !0;
		this.maxCount = 4096;
		this.count = 0;
		this.hasUvs = this.hasColors = this.hasNormals = this.hasPositions = !1;
		this.positionArray = new Float32Array(3 * this.maxCount);
		this.normalArray = new Float32Array(3 * this.maxCount);
		this.enableUvs && (this.uvArray = new Float32Array(2 * this.maxCount));
		this.enableColors && (this.colorArray = new Float32Array(3 * this.maxCount))
	};
	this.lerp = function (a, b, c) {
		return a + (b - a) * c
	};
	this.VIntX = function (a, b, c, d, i, k, j, l, m, r) {
		i = (i - m) / (r - m);
		m = this.normal_cache;
		b[d] = k + i * this.delta;
		b[d + 1] = j;
		b[d + 2] = l;
		c[d] = this.lerp(m[a], m[a + 3], i);
		c[d + 1] = this.lerp(m[a + 1], m[a + 4], i);
		c[d + 2] = this.lerp(m[a + 2], m[a + 5], i)
	};
	this.VIntY = function (a, b, c, d, i, k, j, l, m, r) {
		i = (i - m) / (r - m);
		m = this.normal_cache;
		b[d] = k;
		b[d + 1] = j + i * this.delta;
		b[d + 2] = l;
		b = a + 3 * this.yd;
		c[d] = this.lerp(m[a], m[b], i);
		c[d + 1] = this.lerp(m[a + 1], m[b + 1], i);
		c[d + 2] = this.lerp(m[a + 2], m[b + 2], i)
	};
	this.VIntZ = function (a, b, c, d, i, k, j, l, m, r) {
		i = (i - m) / (r - m);
		m = this.normal_cache;
		b[d] = k;
		b[d + 1] = j;
		b[d + 2] = l + i * this.delta;
		b = a + 3 * this.zd;
		c[d] = this.lerp(m[a],
		m[b], i);
		c[d + 1] = this.lerp(m[a + 1], m[b + 1], i);
		c[d + 2] = this.lerp(m[a + 2], m[b + 2], i)
	};
	this.compNorm = function (a) {
		var b = 3 * a;
		0 === this.normal_cache[b] && (this.normal_cache[b] = this.field[a - 1] - this.field[a + 1], this.normal_cache[b + 1] = this.field[a - this.yd] - this.field[a + this.yd], this.normal_cache[b + 2] = this.field[a - this.zd] - this.field[a + this.zd])
	};
	this.polygonize = function (a, b, c, d, i, k) {
		var j = d + 1,
			l = d + this.yd,
			m = d + this.zd,
			r = j + this.yd,
			q = j + this.zd,
			p = d + this.yd + this.zd,
			t = j + this.yd + this.zd,
			u = 0,
			x = this.field[d],
			v = this.field[j],
			s = this.field[l],
			C = this.field[r],
			z = this.field[m],
			w = this.field[q],
			A = this.field[p],
			H = this.field[t];
		x < i && (u |= 1);
		v < i && (u |= 2);
		s < i && (u |= 8);
		C < i && (u |= 4);
		z < i && (u |= 16);
		w < i && (u |= 32);
		A < i && (u |= 128);
		H < i && (u |= 64);
		var G = THREE.edgeTable[u];
		if (0 === G) return 0;
		var I = this.delta,
			V = a + I,
			E = b + I,
			I = c + I;
		G & 1 && (this.compNorm(d), this.compNorm(j), this.VIntX(3 * d, this.vlist, this.nlist, 0, i, a, b, c, x, v));
		G & 2 && (this.compNorm(j), this.compNorm(r), this.VIntY(3 * j, this.vlist, this.nlist, 3, i, V, b, c, v, C));
		G & 4 && (this.compNorm(l), this.compNorm(r),
		this.VIntX(3 * l, this.vlist, this.nlist, 6, i, a, E, c, s, C));
		G & 8 && (this.compNorm(d), this.compNorm(l), this.VIntY(3 * d, this.vlist, this.nlist, 9, i, a, b, c, x, s));
		G & 16 && (this.compNorm(m), this.compNorm(q), this.VIntX(3 * m, this.vlist, this.nlist, 12, i, a, b, I, z, w));
		G & 32 && (this.compNorm(q), this.compNorm(t), this.VIntY(3 * q, this.vlist, this.nlist, 15, i, V, b, I, w, H));
		G & 64 && (this.compNorm(p), this.compNorm(t), this.VIntX(3 * p, this.vlist, this.nlist, 18, i, a, E, I, A, H));
		G & 128 && (this.compNorm(m), this.compNorm(p), this.VIntY(3 * m, this.vlist, this.nlist,
		21, i, a, b, I, z, A));
		G & 256 && (this.compNorm(d), this.compNorm(m), this.VIntZ(3 * d, this.vlist, this.nlist, 24, i, a, b, c, x, z));
		G & 512 && (this.compNorm(j), this.compNorm(q), this.VIntZ(3 * j, this.vlist, this.nlist, 27, i, V, b, c, v, w));
		G & 1024 && (this.compNorm(r), this.compNorm(t), this.VIntZ(3 * r, this.vlist, this.nlist, 30, i, V, E, c, C, H));
		G & 2048 && (this.compNorm(l), this.compNorm(p), this.VIntZ(3 * l, this.vlist, this.nlist, 33, i, a, E, c, s, A));
		u <<= 4;
		for (i = d = 0; - 1 != THREE.triTable[u + i];) a = u + i, b = a + 1, c = a + 2, this.posnormtriv(this.vlist, this.nlist,
		3 * THREE.triTable[a], 3 * THREE.triTable[b], 3 * THREE.triTable[c], k), i += 3, d++;
		return d
	};
	this.posnormtriv = function (a, b, c, d, i, k) {
		var j = 3 * this.count;
		this.positionArray[j] = a[c];
		this.positionArray[j + 1] = a[c + 1];
		this.positionArray[j + 2] = a[c + 2];
		this.positionArray[j + 3] = a[d];
		this.positionArray[j + 4] = a[d + 1];
		this.positionArray[j + 5] = a[d + 2];
		this.positionArray[j + 6] = a[i];
		this.positionArray[j + 7] = a[i + 1];
		this.positionArray[j + 8] = a[i + 2];
		this.normalArray[j] = b[c];
		this.normalArray[j + 1] = b[c + 1];
		this.normalArray[j + 2] = b[c + 2];
		this.normalArray[j + 3] = b[d];
		this.normalArray[j + 4] = b[d + 1];
		this.normalArray[j + 5] = b[d + 2];
		this.normalArray[j + 6] = b[i];
		this.normalArray[j + 7] = b[i + 1];
		this.normalArray[j + 8] = b[i + 2];
		this.enableUvs && (b = 2 * this.count, this.uvArray[b] = a[c], this.uvArray[b + 1] = a[c + 2], this.uvArray[b + 2] = a[d], this.uvArray[b + 3] = a[d + 2], this.uvArray[b + 4] = a[i], this.uvArray[b + 5] = a[i + 2]);
		this.enableColors && (this.colorArray[j] = a[c], this.colorArray[j + 1] = a[c + 1], this.colorArray[j + 2] = a[c + 2], this.colorArray[j + 3] = a[d], this.colorArray[j + 4] = a[d + 1], this.colorArray[j + 5] = a[d + 2], this.colorArray[j + 6] = a[i], this.colorArray[j + 7] = a[i + 1], this.colorArray[j + 8] = a[i + 2]);
		this.count += 3;
		this.count >= this.maxCount - 3 && (this.hasNormals = this.hasPositions = !0, this.enableUvs && (this.hasUvs = !0), this.enableColors && (this.hasColors = !0), k(this))
	};
	this.begin = function () {
		this.count = 0;
		this.hasColors = this.hasUvs = this.hasNormals = this.hasPositions = !1
	};
	this.end = function (a) {
		if (0 !== this.count) {
			for (var b = 3 * this.count; b < this.positionArray.length; b++) this.positionArray[b] = 0;
			this.hasNormals = this.hasPositions = !0;
			this.enableUvs && (this.hasUvs = !0);
			this.enableColors && (this.hasColors = !0);
			a(this)
		}
	};
	this.addBall = function (a, b, c, d, i) {
		var k = this.size * Math.sqrt(d / i),
			j = c * this.size,
			l = b * this.size,
			m = a * this.size,
			r = Math.floor(j - k);
		1 > r && (r = 1);
		j = Math.floor(j + k);
		j > this.size - 1 && (j = this.size - 1);
		var q = Math.floor(l - k);
		1 > q && (q = 1);
		l = Math.floor(l + k);
		l > this.size - 1 && (l = this.size - 1);
		var p = Math.floor(m - k);
		1 > p && (p = 1);
		k = Math.floor(m + k);
		k > this.size - 1 && (k = this.size - 1);
		for (var t, u, x, v, s, C; r < j; r++) {
			m = this.size2 * r;
			u = r / this.size - c;
			s = u * u;
			for (u = q; u < l; u++) {
				x = m + this.size * u;
				t = u / this.size - b;
				C = t * t;
				for (t = p; t < k; t++) v = t / this.size - a, v = d / (1E-6 + v * v + C + s) - i, 0 < v && (this.field[x + t] += v)
			}
		}
	};
	this.addPlaneX = function (a, b) {
		var c, d, i, k, j, l = this.size,
			m = this.yd,
			r = this.zd,
			q = this.field,
			p = l * Math.sqrt(a / b);
		p > l && (p = l);
		for (c = 0; c < p; c++) if (d = c / l, d *= d, k = a / (1E-4 + d) - b, 0 < k) for (d = 0; d < l; d++) {
			j = c + d * m;
			for (i = 0; i < l; i++) q[r * i + j] += k
		}
	};
	this.addPlaneY = function (a, b) {
		var c, d, i, k, j, l, m = this.size,
			r = this.yd,
			q = this.zd,
			p = this.field,
			t = m * Math.sqrt(a / b);
		t > m && (t = m);
		for (d = 0; d < t; d++) if (c = d / m, c *= c, k = a / (1E-4 + c) - b, 0 < k) {
			j = d * r;
			for (c = 0; c < m; c++) {
				l = j + c;
				for (i = 0; i < m; i++) p[q * i + l] += k
			}
		}
	};
	this.addPlaneZ = function (a, b) {
		var c, d, i, k, j, l, m = this.size,
			r = this.yd,
			q = this.zd,
			p = this.field,
			t = m * Math.sqrt(a / b);
		t > m && (t = m);
		for (i = 0; i < t; i++) if (c = i / m, c *= c, k = a / (1E-4 + c) - b, 0 < k) {
			j = q * i;
			for (d = 0; d < m; d++) {
				l = j + d * r;
				for (c = 0; c < m; c++) p[l + c] += k
			}
		}
	};
	this.reset = function () {
		var a;
		for (a = 0; a < this.size3; a++) this.normal_cache[3 * a] = 0, this.field[a] = 0
	};
	this.render = function (a) {
		this.begin();
		var b, c, d, i, k, j, l, m, r, q = this.size - 2;
		for (i = 1; i < q; i++) {
			r = this.size2 * i;
			l = (i - this.halfsize) / this.halfsize;
			for (d = 1; d < q; d++) {
				m = r + this.size * d;
				j = (d - this.halfsize) / this.halfsize;
				for (c = 1; c < q; c++) k = (c - this.halfsize) / this.halfsize, b = m + c, this.polygonize(k, j, l, b, this.isolation, a)
			}
		}
		this.end(a)
	};
	this.generateGeometry = function () {
		var a = 0,
			b = new THREE.Geometry,
			c = [];
		this.render(function (d) {
			var i, k, j, l, m, r, q, p;
			for (i = 0; i < d.count; i++) r = 3 * i, q = r + 1, p = r + 2, k = d.positionArray[r], j = d.positionArray[q], l = d.positionArray[p], m = new THREE.Vector3(k, j, l), k = d.normalArray[r], j = d.normalArray[q], l = d.normalArray[p],
			r = new THREE.Vector3(k, j, l), r.normalize(), b.vertices.push(m), c.push(r);
			m = d.count / 3;
			for (i = 0; i < m; i++) r = 3 * (a + i), q = r + 1, p = r + 2, k = c[r], j = c[q], l = c[p], r = new THREE.Face3(r, q, p, [k, j, l]), b.faces.push(r);
			a += m;
			d.count = 0
		});
		return b
	};
	this.init(a)
};
THREE.MarchingCubes.prototype = Object.create(THREE.ImmediateRenderObject.prototype);
THREE.edgeTable = new Int32Array([0, 265, 515, 778, 1030, 1295, 1541, 1804, 2060, 2309, 2575, 2822, 3082, 3331, 3593, 3840, 400, 153, 915, 666, 1430, 1183, 1941, 1692, 2460, 2197, 2975, 2710, 3482, 3219, 3993, 3728, 560, 825, 51, 314, 1590, 1855, 1077, 1340, 2620, 2869, 2111, 2358, 3642, 3891, 3129, 3376, 928, 681, 419, 170, 1958, 1711, 1445, 1196, 2988, 2725, 2479, 2214, 4010, 3747, 3497, 3232, 1120, 1385, 1635, 1898, 102, 367, 613, 876, 3180, 3429, 3695, 3942, 2154, 2403, 2665, 2912, 1520, 1273, 2035, 1786, 502, 255, 1013, 764, 3580, 3317, 4095, 3830, 2554, 2291, 3065, 2800, 1616, 1881, 1107,
1370, 598, 863, 85, 348, 3676, 3925, 3167, 3414, 2650, 2899, 2137, 2384, 1984, 1737, 1475, 1226, 966, 719, 453, 204, 4044, 3781, 3535, 3270, 3018, 2755, 2505, 2240, 2240, 2505, 2755, 3018, 3270, 3535, 3781, 4044, 204, 453, 719, 966, 1226, 1475, 1737, 1984, 2384, 2137, 2899, 2650, 3414, 3167, 3925, 3676, 348, 85, 863, 598, 1370, 1107, 1881, 1616, 2800, 3065, 2291, 2554, 3830, 4095, 3317, 3580, 764, 1013, 255, 502, 1786, 2035, 1273, 1520, 2912, 2665, 2403, 2154, 3942, 3695, 3429, 3180, 876, 613, 367, 102, 1898, 1635, 1385, 1120, 3232, 3497, 3747, 4010, 2214, 2479, 2725, 2988, 1196, 1445, 1711, 1958, 170,
419, 681, 928, 3376, 3129, 3891, 3642, 2358, 2111, 2869, 2620, 1340, 1077, 1855, 1590, 314, 51, 825, 560, 3728, 3993, 3219, 3482, 2710, 2975, 2197, 2460, 1692, 1941, 1183, 1430, 666, 915, 153, 400, 3840, 3593, 3331, 3082, 2822, 2575, 2309, 2060, 1804, 1541, 1295, 1030, 778, 515, 265, 0]);
THREE.triTable = new Int32Array([-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 0, 8, 3, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 0, 1, 9, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 1, 8, 3, 9, 8, 1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 1, 2, 10, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 0, 8, 3, 1, 2, 10, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 9, 2, 10, 0, 2, 9, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 2, 8, 3, 2, 10, 8, 10, 9, 8, -1, -1, -1, -1, -1, -1, -1, 3, 11, 2, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 0, 11, 2, 8, 11, 0, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 1, 9, 0, 2, 3, 11, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 1, 11, 2, 1, 9, 11, 9, 8, 11, -1, -1, -1, -1, -1, -1, -1, 3, 10, 1, 11, 10, 3, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 0, 10, 1, 0, 8, 10, 8, 11, 10, -1, -1, -1, -1, -1, -1, -1, 3, 9, 0, 3, 11, 9, 11, 10, 9, -1, -1, -1, -1, -1, -1, -1, 9, 8, 10, 10, 8, 11, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 4, 7, 8, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 4, 3, 0, 7, 3, 4, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 0, 1, 9, 8, 4, 7, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 4, 1, 9, 4, 7, 1, 7, 3, 1, -1, -1, -1, -1, -1, -1, -1, 1, 2, 10, 8, 4, 7, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 3, 4, 7, 3, 0, 4, 1, 2, 10, -1, -1, -1, -1, -1, -1, -1, 9, 2, 10, 9, 0, 2, 8, 4, 7, -1, -1, -1, -1, -1, -1, -1, 2, 10, 9, 2, 9, 7, 2, 7, 3, 7, 9, 4, -1, -1, -1, -1, 8, 4, 7, 3, 11, 2, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 11, 4, 7, 11, 2, 4, 2, 0, 4, -1, -1, -1, -1, -1, -1, -1, 9, 0, 1, 8, 4, 7, 2, 3, 11, -1, -1, -1, -1, -1, -1, -1, 4, 7, 11, 9, 4, 11, 9, 11, 2, 9, 2, 1, -1, -1, -1, -1, 3, 10, 1, 3, 11, 10, 7, 8, 4, -1, -1, -1, -1, -1, -1, -1, 1, 11, 10, 1, 4, 11, 1, 0, 4, 7, 11, 4, -1, -1, -1, -1, 4, 7, 8, 9, 0, 11, 9, 11, 10, 11, 0, 3, -1, -1, -1, -1, 4, 7, 11, 4, 11, 9, 9, 11, 10, -1, -1, -1, -1, -1, -1, -1, 9, 5, 4, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 9, 5, 4, 0, 8, 3, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 0, 5, 4, 1, 5, 0, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 8, 5, 4, 8, 3, 5, 3, 1, 5, -1, -1, -1, -1, -1, -1, -1, 1, 2, 10, 9, 5, 4, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 3, 0, 8, 1, 2, 10, 4, 9, 5, -1, -1, -1, -1, -1, -1, -1, 5, 2, 10, 5, 4, 2, 4, 0, 2, -1, -1, -1, -1, -1, -1, -1, 2, 10, 5, 3, 2, 5, 3, 5, 4, 3, 4, 8, -1, -1, -1, -1, 9, 5, 4, 2, 3, 11, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 0, 11, 2, 0, 8, 11, 4, 9, 5, -1, -1, -1, -1, -1, -1, -1, 0, 5, 4, 0, 1, 5, 2, 3, 11, -1, -1, -1, -1, -1, -1, -1, 2, 1, 5, 2, 5, 8, 2, 8, 11, 4, 8, 5, -1, -1, -1, -1, 10, 3, 11, 10, 1, 3, 9, 5, 4, -1, -1, -1, -1, -1, -1, -1, 4, 9, 5, 0, 8, 1, 8, 10, 1, 8, 11, 10, -1, -1, -1, -1, 5, 4, 0, 5, 0, 11, 5, 11, 10, 11, 0, 3, -1, -1, -1, -1, 5, 4, 8, 5,
8, 10, 10, 8, 11, -1, -1, -1, -1, -1, -1, -1, 9, 7, 8, 5, 7, 9, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 9, 3, 0, 9, 5, 3, 5, 7, 3, -1, -1, -1, -1, -1, -1, -1, 0, 7, 8, 0, 1, 7, 1, 5, 7, -1, -1, -1, -1, -1, -1, -1, 1, 5, 3, 3, 5, 7, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 9, 7, 8, 9, 5, 7, 10, 1, 2, -1, -1, -1, -1, -1, -1, -1, 10, 1, 2, 9, 5, 0, 5, 3, 0, 5, 7, 3, -1, -1, -1, -1, 8, 0, 2, 8, 2, 5, 8, 5, 7, 10, 5, 2, -1, -1, -1, -1, 2, 10, 5, 2, 5, 3, 3, 5, 7, -1, -1, -1, -1, -1, -1, -1, 7, 9, 5, 7, 8, 9, 3, 11, 2, -1, -1, -1, -1, -1, -1, -1, 9, 5, 7, 9, 7, 2, 9, 2, 0, 2, 7, 11, -1, -1, -1, -1, 2, 3, 11, 0, 1, 8, 1, 7, 8, 1, 5, 7, -1, -1, -1, -1, 11, 2, 1, 11, 1, 7, 7, 1, 5, -1, -1, -1, -1, -1, -1, -1, 9, 5, 8, 8, 5, 7, 10, 1, 3, 10, 3, 11, -1, -1, -1, -1, 5, 7, 0, 5, 0, 9, 7, 11, 0, 1, 0, 10, 11, 10, 0, -1, 11, 10, 0, 11, 0, 3, 10, 5, 0, 8, 0, 7, 5, 7, 0, -1, 11, 10, 5, 7, 11, 5, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 10, 6, 5, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 0, 8, 3, 5, 10, 6, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 9, 0, 1, 5, 10, 6, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 1, 8, 3, 1, 9, 8, 5, 10, 6, -1, -1, -1, -1, -1, -1, -1, 1, 6, 5, 2, 6, 1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 1, 6, 5, 1, 2, 6, 3, 0, 8, -1, -1, -1, -1, -1, -1, -1, 9, 6, 5, 9, 0, 6, 0, 2, 6, -1, -1, -1, -1, -1, -1, -1, 5, 9, 8, 5, 8, 2, 5, 2, 6, 3, 2, 8, -1, -1, -1, -1, 2, 3, 11, 10, 6,
5, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 11, 0, 8, 11, 2, 0, 10, 6, 5, -1, -1, -1, -1, -1, -1, -1, 0, 1, 9, 2, 3, 11, 5, 10, 6, -1, -1, -1, -1, -1, -1, -1, 5, 10, 6, 1, 9, 2, 9, 11, 2, 9, 8, 11, -1, -1, -1, -1, 6, 3, 11, 6, 5, 3, 5, 1, 3, -1, -1, -1, -1, -1, -1, -1, 0, 8, 11, 0, 11, 5, 0, 5, 1, 5, 11, 6, -1, -1, -1, -1, 3, 11, 6, 0, 3, 6, 0, 6, 5, 0, 5, 9, -1, -1, -1, -1, 6, 5, 9, 6, 9, 11, 11, 9, 8, -1, -1, -1, -1, -1, -1, -1, 5, 10, 6, 4, 7, 8, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 4, 3, 0, 4, 7, 3, 6, 5, 10, -1, -1, -1, -1, -1, -1, -1, 1, 9, 0, 5, 10, 6, 8, 4, 7, -1, -1, -1, -1, -1, -1, -1, 10, 6, 5, 1, 9, 7, 1, 7, 3, 7, 9, 4, -1, -1, -1, -1, 6, 1, 2, 6, 5, 1, 4, 7, 8, -1, -1, -1, -1, -1, -1, -1, 1, 2, 5, 5, 2, 6, 3, 0, 4, 3, 4, 7, -1, -1, -1, -1, 8, 4, 7, 9, 0, 5, 0, 6, 5, 0, 2, 6, -1, -1, -1, -1, 7, 3, 9, 7, 9, 4, 3, 2, 9, 5, 9, 6, 2, 6, 9, -1, 3, 11, 2, 7, 8, 4, 10, 6, 5, -1, -1, -1, -1, -1, -1, -1, 5, 10, 6, 4, 7, 2, 4, 2, 0, 2, 7, 11, -1, -1, -1, -1, 0, 1, 9, 4, 7, 8, 2, 3, 11, 5, 10, 6, -1, -1, -1, -1, 9, 2, 1, 9, 11, 2, 9, 4, 11, 7, 11, 4, 5, 10, 6, -1, 8, 4, 7, 3, 11, 5, 3, 5, 1, 5, 11, 6, -1, -1, -1, -1, 5, 1, 11, 5, 11, 6, 1, 0, 11, 7, 11, 4, 0, 4, 11, -1, 0, 5, 9, 0, 6, 5, 0, 3, 6, 11, 6, 3, 8, 4, 7, -1, 6, 5, 9, 6, 9, 11, 4, 7, 9, 7, 11, 9, -1, -1, -1, -1, 10, 4, 9, 6, 4, 10, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 4, 10, 6, 4, 9, 10, 0, 8, 3, -1, -1, -1, -1, -1, -1, -1,
10, 0, 1, 10, 6, 0, 6, 4, 0, -1, -1, -1, -1, -1, -1, -1, 8, 3, 1, 8, 1, 6, 8, 6, 4, 6, 1, 10, -1, -1, -1, -1, 1, 4, 9, 1, 2, 4, 2, 6, 4, -1, -1, -1, -1, -1, -1, -1, 3, 0, 8, 1, 2, 9, 2, 4, 9, 2, 6, 4, -1, -1, -1, -1, 0, 2, 4, 4, 2, 6, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 8, 3, 2, 8, 2, 4, 4, 2, 6, -1, -1, -1, -1, -1, -1, -1, 10, 4, 9, 10, 6, 4, 11, 2, 3, -1, -1, -1, -1, -1, -1, -1, 0, 8, 2, 2, 8, 11, 4, 9, 10, 4, 10, 6, -1, -1, -1, -1, 3, 11, 2, 0, 1, 6, 0, 6, 4, 6, 1, 10, -1, -1, -1, -1, 6, 4, 1, 6, 1, 10, 4, 8, 1, 2, 1, 11, 8, 11, 1, -1, 9, 6, 4, 9, 3, 6, 9, 1, 3, 11, 6, 3, -1, -1, -1, -1, 8, 11, 1, 8, 1, 0, 11, 6, 1, 9, 1, 4, 6, 4, 1, -1, 3, 11, 6, 3, 6, 0, 0, 6, 4, -1, -1, -1, -1, -1, -1, -1,
6, 4, 8, 11, 6, 8, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 7, 10, 6, 7, 8, 10, 8, 9, 10, -1, -1, -1, -1, -1, -1, -1, 0, 7, 3, 0, 10, 7, 0, 9, 10, 6, 7, 10, -1, -1, -1, -1, 10, 6, 7, 1, 10, 7, 1, 7, 8, 1, 8, 0, -1, -1, -1, -1, 10, 6, 7, 10, 7, 1, 1, 7, 3, -1, -1, -1, -1, -1, -1, -1, 1, 2, 6, 1, 6, 8, 1, 8, 9, 8, 6, 7, -1, -1, -1, -1, 2, 6, 9, 2, 9, 1, 6, 7, 9, 0, 9, 3, 7, 3, 9, -1, 7, 8, 0, 7, 0, 6, 6, 0, 2, -1, -1, -1, -1, -1, -1, -1, 7, 3, 2, 6, 7, 2, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 2, 3, 11, 10, 6, 8, 10, 8, 9, 8, 6, 7, -1, -1, -1, -1, 2, 0, 7, 2, 7, 11, 0, 9, 7, 6, 7, 10, 9, 10, 7, -1, 1, 8, 0, 1, 7, 8, 1, 10, 7, 6, 7, 10, 2, 3, 11, -1, 11, 2, 1, 11, 1, 7, 10, 6, 1, 6, 7, 1, -1, -1, -1, -1,
8, 9, 6, 8, 6, 7, 9, 1, 6, 11, 6, 3, 1, 3, 6, -1, 0, 9, 1, 11, 6, 7, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 7, 8, 0, 7, 0, 6, 3, 11, 0, 11, 6, 0, -1, -1, -1, -1, 7, 11, 6, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 7, 6, 11, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 3, 0, 8, 11, 7, 6, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 0, 1, 9, 11, 7, 6, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 8, 1, 9, 8, 3, 1, 11, 7, 6, -1, -1, -1, -1, -1, -1, -1, 10, 1, 2, 6, 11, 7, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 1, 2, 10, 3, 0, 8, 6, 11, 7, -1, -1, -1, -1, -1, -1, -1, 2, 9, 0, 2, 10, 9, 6, 11, 7, -1, -1, -1, -1, -1, -1, -1, 6, 11, 7, 2, 10, 3, 10, 8, 3, 10, 9, 8, -1, -1, -1, -1, 7,
2, 3, 6, 2, 7, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 7, 0, 8, 7, 6, 0, 6, 2, 0, -1, -1, -1, -1, -1, -1, -1, 2, 7, 6, 2, 3, 7, 0, 1, 9, -1, -1, -1, -1, -1, -1, -1, 1, 6, 2, 1, 8, 6, 1, 9, 8, 8, 7, 6, -1, -1, -1, -1, 10, 7, 6, 10, 1, 7, 1, 3, 7, -1, -1, -1, -1, -1, -1, -1, 10, 7, 6, 1, 7, 10, 1, 8, 7, 1, 0, 8, -1, -1, -1, -1, 0, 3, 7, 0, 7, 10, 0, 10, 9, 6, 10, 7, -1, -1, -1, -1, 7, 6, 10, 7, 10, 8, 8, 10, 9, -1, -1, -1, -1, -1, -1, -1, 6, 8, 4, 11, 8, 6, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 3, 6, 11, 3, 0, 6, 0, 4, 6, -1, -1, -1, -1, -1, -1, -1, 8, 6, 11, 8, 4, 6, 9, 0, 1, -1, -1, -1, -1, -1, -1, -1, 9, 4, 6, 9, 6, 3, 9, 3, 1, 11, 3, 6, -1, -1, -1, -1, 6, 8, 4, 6, 11, 8, 2, 10, 1, -1, -1, -1, -1, -1, -1, -1, 1, 2, 10, 3, 0, 11, 0, 6, 11, 0, 4, 6, -1, -1, -1, -1, 4, 11, 8, 4, 6, 11, 0, 2, 9, 2, 10, 9, -1, -1, -1, -1, 10, 9, 3, 10, 3, 2, 9, 4, 3, 11, 3, 6, 4, 6, 3, -1, 8, 2, 3, 8, 4, 2, 4, 6, 2, -1, -1, -1, -1, -1, -1, -1, 0, 4, 2, 4, 6, 2, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 1, 9, 0, 2, 3, 4, 2, 4, 6, 4, 3, 8, -1, -1, -1, -1, 1, 9, 4, 1, 4, 2, 2, 4, 6, -1, -1, -1, -1, -1, -1, -1, 8, 1, 3, 8, 6, 1, 8, 4, 6, 6, 10, 1, -1, -1, -1, -1, 10, 1, 0, 10, 0, 6, 6, 0, 4, -1, -1, -1, -1, -1, -1, -1, 4, 6, 3, 4, 3, 8, 6, 10, 3, 0, 3, 9, 10, 9, 3, -1, 10, 9, 4, 6, 10, 4, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 4, 9, 5, 7, 6, 11, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 0, 8, 3, 4, 9, 5, 11, 7, 6, -1, -1, -1, -1, -1, -1, -1, 5, 0, 1, 5, 4, 0, 7, 6, 11, -1, -1, -1, -1, -1, -1, -1, 11, 7, 6, 8, 3, 4, 3, 5, 4, 3, 1, 5, -1, -1, -1, -1, 9, 5, 4, 10, 1, 2, 7, 6, 11, -1, -1, -1, -1, -1, -1, -1, 6, 11, 7, 1, 2, 10, 0, 8, 3, 4, 9, 5, -1, -1, -1, -1, 7, 6, 11, 5, 4, 10, 4, 2, 10, 4, 0, 2, -1, -1, -1, -1, 3, 4, 8, 3, 5, 4, 3, 2, 5, 10, 5, 2, 11, 7, 6, -1, 7, 2, 3, 7, 6, 2, 5, 4, 9, -1, -1, -1, -1, -1, -1, -1, 9, 5, 4, 0, 8, 6, 0, 6, 2, 6, 8, 7, -1, -1, -1, -1, 3, 6, 2, 3, 7, 6, 1, 5, 0, 5, 4, 0, -1, -1, -1, -1, 6, 2, 8, 6, 8, 7, 2, 1, 8, 4, 8, 5, 1, 5, 8, -1, 9, 5, 4, 10, 1, 6, 1, 7, 6, 1, 3, 7, -1, -1, -1, -1, 1, 6, 10, 1, 7, 6, 1, 0, 7, 8, 7, 0, 9, 5, 4, -1, 4, 0, 10, 4, 10, 5, 0, 3, 10, 6, 10, 7, 3, 7, 10, -1, 7, 6, 10, 7, 10, 8, 5, 4, 10, 4, 8, 10, -1, -1, -1, -1, 6, 9, 5, 6, 11, 9, 11, 8, 9, -1, -1, -1, -1, -1, -1, -1, 3, 6, 11, 0, 6, 3, 0, 5, 6, 0, 9, 5, -1, -1, -1, -1, 0, 11, 8, 0, 5, 11, 0, 1, 5, 5, 6, 11, -1, -1, -1, -1, 6, 11, 3, 6, 3, 5, 5, 3, 1, -1, -1, -1, -1, -1, -1, -1, 1, 2, 10, 9, 5, 11, 9, 11, 8, 11, 5, 6, -1, -1, -1, -1, 0, 11, 3, 0, 6, 11, 0, 9, 6, 5, 6, 9, 1, 2, 10, -1, 11, 8, 5, 11, 5, 6, 8, 0, 5, 10, 5, 2, 0, 2, 5, -1, 6, 11, 3, 6, 3, 5, 2, 10, 3, 10, 5, 3, -1, -1, -1, -1, 5, 8, 9, 5, 2, 8, 5, 6, 2, 3, 8, 2, -1, -1, -1, -1, 9, 5, 6, 9, 6, 0, 0, 6, 2, -1, -1, -1, -1, -1, -1, -1, 1, 5, 8, 1, 8, 0, 5, 6, 8, 3, 8, 2, 6, 2, 8, -1, 1, 5, 6, 2, 1, 6, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
1, 3, 6, 1, 6, 10, 3, 8, 6, 5, 6, 9, 8, 9, 6, -1, 10, 1, 0, 10, 0, 6, 9, 5, 0, 5, 6, 0, -1, -1, -1, -1, 0, 3, 8, 5, 6, 10, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 10, 5, 6, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 11, 5, 10, 7, 5, 11, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 11, 5, 10, 11, 7, 5, 8, 3, 0, -1, -1, -1, -1, -1, -1, -1, 5, 11, 7, 5, 10, 11, 1, 9, 0, -1, -1, -1, -1, -1, -1, -1, 10, 7, 5, 10, 11, 7, 9, 8, 1, 8, 3, 1, -1, -1, -1, -1, 11, 1, 2, 11, 7, 1, 7, 5, 1, -1, -1, -1, -1, -1, -1, -1, 0, 8, 3, 1, 2, 7, 1, 7, 5, 7, 2, 11, -1, -1, -1, -1, 9, 7, 5, 9, 2, 7, 9, 0, 2, 2, 11, 7, -1, -1, -1, -1, 7, 5, 2, 7, 2, 11, 5, 9, 2, 3, 2, 8, 9, 8, 2, -1, 2, 5, 10, 2, 3, 5, 3, 7, 5, -1, -1, -1, -1, -1, -1, -1, 8, 2, 0, 8, 5, 2, 8, 7, 5, 10, 2, 5, -1, -1, -1, -1, 9, 0, 1, 5, 10, 3, 5, 3, 7, 3, 10, 2, -1, -1, -1, -1, 9, 8, 2, 9, 2, 1, 8, 7, 2, 10, 2, 5, 7, 5, 2, -1, 1, 3, 5, 3, 7, 5, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 0, 8, 7, 0, 7, 1, 1, 7, 5, -1, -1, -1, -1, -1, -1, -1, 9, 0, 3, 9, 3, 5, 5, 3, 7, -1, -1, -1, -1, -1, -1, -1, 9, 8, 7, 5, 9, 7, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 5, 8, 4, 5, 10, 8, 10, 11, 8, -1, -1, -1, -1, -1, -1, -1, 5, 0, 4, 5, 11, 0, 5, 10, 11, 11, 3, 0, -1, -1, -1, -1, 0, 1, 9, 8, 4, 10, 8, 10, 11, 10, 4, 5, -1, -1, -1, -1, 10, 11, 4, 10, 4, 5, 11, 3, 4, 9, 4, 1, 3, 1, 4, -1, 2, 5, 1, 2, 8, 5, 2, 11, 8, 4, 5, 8, -1, -1, -1, -1, 0, 4, 11, 0, 11, 3, 4, 5, 11,
2, 11, 1, 5, 1, 11, -1, 0, 2, 5, 0, 5, 9, 2, 11, 5, 4, 5, 8, 11, 8, 5, -1, 9, 4, 5, 2, 11, 3, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 2, 5, 10, 3, 5, 2, 3, 4, 5, 3, 8, 4, -1, -1, -1, -1, 5, 10, 2, 5, 2, 4, 4, 2, 0, -1, -1, -1, -1, -1, -1, -1, 3, 10, 2, 3, 5, 10, 3, 8, 5, 4, 5, 8, 0, 1, 9, -1, 5, 10, 2, 5, 2, 4, 1, 9, 2, 9, 4, 2, -1, -1, -1, -1, 8, 4, 5, 8, 5, 3, 3, 5, 1, -1, -1, -1, -1, -1, -1, -1, 0, 4, 5, 1, 0, 5, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 8, 4, 5, 8, 5, 3, 9, 0, 5, 0, 3, 5, -1, -1, -1, -1, 9, 4, 5, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 4, 11, 7, 4, 9, 11, 9, 10, 11, -1, -1, -1, -1, -1, -1, -1, 0, 8, 3, 4, 9, 7, 9, 11, 7, 9, 10, 11, -1, -1, -1, -1, 1, 10, 11, 1, 11,
4, 1, 4, 0, 7, 4, 11, -1, -1, -1, -1, 3, 1, 4, 3, 4, 8, 1, 10, 4, 7, 4, 11, 10, 11, 4, -1, 4, 11, 7, 9, 11, 4, 9, 2, 11, 9, 1, 2, -1, -1, -1, -1, 9, 7, 4, 9, 11, 7, 9, 1, 11, 2, 11, 1, 0, 8, 3, -1, 11, 7, 4, 11, 4, 2, 2, 4, 0, -1, -1, -1, -1, -1, -1, -1, 11, 7, 4, 11, 4, 2, 8, 3, 4, 3, 2, 4, -1, -1, -1, -1, 2, 9, 10, 2, 7, 9, 2, 3, 7, 7, 4, 9, -1, -1, -1, -1, 9, 10, 7, 9, 7, 4, 10, 2, 7, 8, 7, 0, 2, 0, 7, -1, 3, 7, 10, 3, 10, 2, 7, 4, 10, 1, 10, 0, 4, 0, 10, -1, 1, 10, 2, 8, 7, 4, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 4, 9, 1, 4, 1, 7, 7, 1, 3, -1, -1, -1, -1, -1, -1, -1, 4, 9, 1, 4, 1, 7, 0, 8, 1, 8, 7, 1, -1, -1, -1, -1, 4, 0, 3, 7, 4, 3, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 4, 8, 7, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 9, 10, 8, 10, 11, 8, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 3, 0, 9, 3, 9, 11, 11, 9, 10, -1, -1, -1, -1, -1, -1, -1, 0, 1, 10, 0, 10, 8, 8, 10, 11, -1, -1, -1, -1, -1, -1, -1, 3, 1, 10, 11, 3, 10, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 1, 2, 11, 1, 11, 9, 9, 11, 8, -1, -1, -1, -1, -1, -1, -1, 3, 0, 9, 3, 9, 11, 1, 2, 9, 2, 11, 9, -1, -1, -1, -1, 0, 2, 11, 8, 0, 11, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 3, 2, 11, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 2, 3, 8, 2, 8, 10, 10, 8, 9, -1, -1, -1, -1, -1, -1, -1, 9, 10, 2, 0, 9, 2, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 2, 3, 8, 2, 8, 10, 0, 1, 8, 1, 10, 8, -1, -1, -1, -1, 1, 10,
2, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 1, 3, 8, 9, 1, 8, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 0, 9, 1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 0, 3, 8, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1]);
THREE.MD2Character = function () {
	function a(a, b) {
		for (var d = new THREE.UVMapping, h = [], i = 0; i < b.length; i++) h[i] = THREE.ImageUtils.loadTexture(a + b[i], d, c), h[i].name = b[i];
		return h
	}
	function b(a, b) {
		a.computeMorphNormals();
		var c = THREE.ImageUtils.generateDataTexture(1, 1, new THREE.Color(16777215)),
			c = new THREE.MeshPhongMaterial({
				color: 16755200,
				specular: 1118481,
				shininess: 50,
				wireframe: !0,
				shading: THREE.SmoothShading,
				map: c,
				morphTargets: !0,
				morphNormals: !0,
				metal: !1
			}),
			h = new THREE.MeshPhongMaterial({
				color: 16777215,
				specular: 1118481,
				shininess: 50,
				wireframe: !1,
				shading: THREE.SmoothShading,
				map: b,
				morphTargets: !0,
				morphNormals: !0,
				metal: !1
			});
		h.wrapAround = !0;
		var i = new THREE.MorphAnimMesh(a, h);
		i.rotation.y = -Math.PI / 2;
		i.castShadow = !0;
		i.receiveShadow = !0;
		i.materialTexture = h;
		i.materialWireframe = c;
		i.parseAnimations();
		i.playAnimation(a.firstAnimation, d.animationFPS);
		i.baseDuration = i.duration;
		return i
	}
	function c() {
		d.loadCounter -= 1;
		if (0 === d.loadCounter) d.onLoadComplete()
	}
	var d = this;
	this.scale = 1;
	this.animationFPS = 6;
	this.root = new THREE.Object3D;
	this.meshWeapon = this.meshBody = null;
	this.skinsBody = [];
	this.skinsWeapon = [];
	this.weapons = [];
	this.activeAnimation = null;
	this.onLoadComplete = function () {};
	this.loadCounter = 0;
	this.loadParts = function (e) {
		this.loadCounter = 2 * e.weapons.length + e.skins.length + 1;
		for (var f = [], g = 0; g < e.weapons.length; g++) f[g] = e.weapons[g][1];
		this.skinsBody = a(e.baseUrl + "skins/", e.skins);
		this.skinsWeapon = a(e.baseUrl + "skins/", f);
		f = new THREE.JSONLoader;
		f.load(e.baseUrl + e.body, function (a) {
			a.computeBoundingBox();
			d.root.position.y = -d.scale * a.boundingBox.min.y;
			var e = b(a, d.skinsBody[0]);
			e.scale.set(d.scale, d.scale, d.scale);
			d.root.add(e);
			d.meshBody = e;
			d.activeAnimation = a.firstAnimation;
			c()
		});
		for (var h = function (a, e) {
			return function (f) {
				f = b(f, d.skinsWeapon[a]);
				f.scale.set(d.scale, d.scale, d.scale);
				f.visible = !1;
				f.name = e;
				d.root.add(f);
				d.weapons[a] = f;
				d.meshWeapon = f;
				c()
			}
		}, g = 0; g < e.weapons.length; g++) f.load(e.baseUrl + e.weapons[g][0], h(g, e.weapons[g][0]))
	};
	this.setPlaybackRate = function (a) {
		this.meshBody && (this.meshBody.duration = this.meshBody.baseDuration / a);
		this.meshWeapon && (this.meshWeapon.duration = this.meshWeapon.baseDuration / a)
	};
	this.setWireframe = function (a) {
		a ? (this.meshBody && (this.meshBody.material = this.meshBody.materialWireframe), this.meshWeapon && (this.meshWeapon.material = this.meshWeapon.materialWireframe)) : (this.meshBody && (this.meshBody.material = this.meshBody.materialTexture), this.meshWeapon && (this.meshWeapon.material = this.meshWeapon.materialTexture))
	};
	this.setSkin = function (a) {
		this.meshBody && !1 === this.meshBody.material.wireframe && (this.meshBody.material.map = this.skinsBody[a])
	};
	this.setWeapon = function (a) {
		for (var b = 0; b < this.weapons.length; b++) this.weapons[b].visible = !1;
		if (a = this.weapons[a]) a.visible = !0, this.meshWeapon = a, a.playAnimation(this.activeAnimation, this.animationFPS), this.meshWeapon.baseDuration = this.meshWeapon.duration, this.meshWeapon.time = this.meshBody.time, this.meshWeapon.duration = this.meshBody.duration
	};
	this.setAnimation = function (a) {
		this.meshBody && (this.meshBody.playAnimation(a, this.animationFPS), this.meshBody.baseDuration = this.meshBody.duration);
		this.meshWeapon && (this.meshWeapon.playAnimation(a, this.animationFPS), this.meshWeapon.baseDuration = this.meshWeapon.duration, this.meshWeapon.time = this.meshBody.time);
		this.activeAnimation = a
	};
	this.update = function (a) {
		this.meshBody && this.meshBody.updateAnimation(1E3 * a);
		this.meshWeapon && this.meshWeapon.updateAnimation(1E3 * a)
	}
};
THREE.MD2CharacterComplex = function () {
	function a(a, b) {
		for (var d = new THREE.UVMapping, h = [], i = 0; i < b.length; i++) h[i] = THREE.ImageUtils.loadTexture(a + b[i], d, c), h[i].name = b[i];
		return h
	}
	function b(a, b) {
		a.computeMorphNormals();
		var c = THREE.ImageUtils.generateDataTexture(1, 1, new THREE.Color(16777215)),
			c = new THREE.MeshPhongMaterial({
				color: 16755200,
				specular: 1118481,
				shininess: 50,
				wireframe: !0,
				shading: THREE.SmoothShading,
				map: c,
				morphTargets: !0,
				morphNormals: !0,
				metal: !0
			}),
			h = new THREE.MeshPhongMaterial({
				color: 16777215,
				specular: 1118481,
				shininess: 50,
				wireframe: !1,
				shading: THREE.SmoothShading,
				map: b,
				morphTargets: !0,
				morphNormals: !0,
				metal: !0
			});
		h.wrapAround = !0;
		var i = new THREE.MorphBlendMesh(a, h);
		i.rotation.y = -Math.PI / 2;
		i.materialTexture = h;
		i.materialWireframe = c;
		i.autoCreateAnimations(d.animationFPS);
		return i
	}
	function c() {
		d.loadCounter -= 1;
		if (0 === d.loadCounter) d.onLoadComplete()
	}
	var d = this;
	this.scale = 1;
	this.animationFPS = 6;
	this.transitionFrames = 15;
	this.maxSpeed = 275;
	this.maxReverseSpeed = -275;
	this.frontDecceleration = this.backAcceleration = this.frontAcceleration = 600;
	this.angularSpeed = 2.5;
	this.root = new THREE.Object3D;
	this.controls = this.meshWeapon = this.meshBody = null;
	this.skinsBody = [];
	this.skinsWeapon = [];
	this.weapons = [];
	this.currentSkin = void 0;
	this.onLoadComplete = function () {};
	this.meshes = [];
	this.animations = {};
	this.bodyOrientation = this.speed = this.loadCounter = 0;
	this.walkSpeed = this.maxSpeed;
	this.crouchSpeed = 0.5 * this.maxSpeed;
	this.oldAnimation = this.activeAnimation = null;
	this.enableShadows = function (a) {
		for (var b = 0; b < this.meshes.length; b++) this.meshes[b].castShadow = a, this.meshes[b].receiveShadow = a
	};
	this.setVisible = function (a) {
		for (var b = 0; b < this.meshes.length; b++) this.meshes[b].visible = a, this.meshes[b].visible = a
	};
	this.shareParts = function (a) {
		this.animations = a.animations;
		this.walkSpeed = a.walkSpeed;
		this.crouchSpeed = a.crouchSpeed;
		this.skinsBody = a.skinsBody;
		this.skinsWeapon = a.skinsWeapon;
		var c = b(a.meshBody.geometry, this.skinsBody[0]);
		c.scale.set(this.scale, this.scale, this.scale);
		this.root.position.y = a.root.position.y;
		this.root.add(c);
		this.meshBody = c;
		this.meshes.push(c);
		for (c = 0; c < a.weapons.length; c++) {
			var d = b(a.weapons[c].geometry, this.skinsWeapon[c]);
			d.scale.set(this.scale, this.scale, this.scale);
			d.visible = !1;
			d.name = a.weapons[c].name;
			this.root.add(d);
			this.meshWeapon = this.weapons[c] = d;
			this.meshes.push(d)
		}
	};
	this.loadParts = function (e) {
		this.animations = e.animations;
		this.walkSpeed = e.walkSpeed;
		this.crouchSpeed = e.crouchSpeed;
		this.loadCounter = 2 * e.weapons.length + e.skins.length + 1;
		for (var f = [], g = 0; g < e.weapons.length; g++) f[g] = e.weapons[g][1];
		this.skinsBody = a(e.baseUrl + "skins/",
		e.skins);
		this.skinsWeapon = a(e.baseUrl + "skins/", f);
		f = new THREE.JSONLoader;
		f.load(e.baseUrl + e.body, function (a) {
			a.computeBoundingBox();
			d.root.position.y = -d.scale * a.boundingBox.min.y;
			a = b(a, d.skinsBody[0]);
			a.scale.set(d.scale, d.scale, d.scale);
			d.root.add(a);
			d.meshBody = a;
			d.meshes.push(a);
			c()
		});
		for (var h = function (a, e) {
			return function (f) {
				f = b(f, d.skinsWeapon[a]);
				f.scale.set(d.scale, d.scale, d.scale);
				f.visible = !1;
				f.name = e;
				d.root.add(f);
				d.weapons[a] = f;
				d.meshWeapon = f;
				d.meshes.push(f);
				c()
			}
		}, g = 0; g < e.weapons.length; g++) f.load(e.baseUrl + e.weapons[g][0], h(g, e.weapons[g][0]))
	};
	this.setPlaybackRate = function (a) {
		this.meshBody && (this.meshBody.duration = this.meshBody.baseDuration / a);
		this.meshWeapon && (this.meshWeapon.duration = this.meshWeapon.baseDuration / a)
	};
	this.setWireframe = function (a) {
		a ? (this.meshBody && (this.meshBody.material = this.meshBody.materialWireframe), this.meshWeapon && (this.meshWeapon.material = this.meshWeapon.materialWireframe)) : (this.meshBody && (this.meshBody.material = this.meshBody.materialTexture), this.meshWeapon && (this.meshWeapon.material = this.meshWeapon.materialTexture))
	};
	this.setSkin = function (a) {
		this.meshBody && !1 === this.meshBody.material.wireframe && (this.meshBody.material.map = this.skinsBody[a], this.currentSkin = a)
	};
	this.setWeapon = function (a) {
		for (var b = 0; b < this.weapons.length; b++) this.weapons[b].visible = !1;
		if (a = this.weapons[a]) a.visible = !0, this.meshWeapon = a, this.activeAnimation && (a.playAnimation(this.activeAnimation), this.meshWeapon.setAnimationTime(this.activeAnimation, this.meshBody.getAnimationTime(this.activeAnimation)))
	};
	this.setAnimation = function (a) {
		a !== this.activeAnimation && a && (this.meshBody && (this.meshBody.setAnimationWeight(a, 0), this.meshBody.playAnimation(a), this.oldAnimation = this.activeAnimation, this.activeAnimation = a, this.blendCounter = this.transitionFrames), this.meshWeapon && (this.meshWeapon.setAnimationWeight(a, 0), this.meshWeapon.playAnimation(a)))
	};
	this.update = function (a) {
		this.controls && this.updateMovementModel(a);
		this.animations && (this.updateBehaviors(a), this.updateAnimations(a))
	};
	this.updateAnimations = function (a) {
		var b = 1;
		0 < this.blendCounter && (b = (this.transitionFrames - this.blendCounter) / this.transitionFrames, this.blendCounter -= 1);
		this.meshBody && (this.meshBody.update(a), this.meshBody.setAnimationWeight(this.activeAnimation, b), this.meshBody.setAnimationWeight(this.oldAnimation, 1 - b));
		this.meshWeapon && (this.meshWeapon.update(a), this.meshWeapon.setAnimationWeight(this.activeAnimation, b), this.meshWeapon.setAnimationWeight(this.oldAnimation, 1 - b))
	};
	this.updateBehaviors = function () {
		var a = this.controls,
			b = this.animations,
			c, d;
		a.crouch ? (c = b.crouchMove, d = b.crouchIdle) : (c = b.move, d = b.idle);
		a.jump && (d = c = b.jump);
		a.attack && (d = a.crouch ? c = b.crouchAttack : c = b.attack);
		(a.moveForward || a.moveBackward || a.moveLeft || a.moveRight) && this.activeAnimation !== c && this.setAnimation(c);
		Math.abs(this.speed) < 0.2 * this.maxSpeed && !a.moveLeft && !a.moveRight && !a.moveForward && !a.moveBackward && this.activeAnimation !== d && this.setAnimation(d);
		a.moveForward && (this.meshBody && (this.meshBody.setAnimationDirectionForward(this.activeAnimation), this.meshBody.setAnimationDirectionForward(this.oldAnimation)),
		this.meshWeapon && (this.meshWeapon.setAnimationDirectionForward(this.activeAnimation), this.meshWeapon.setAnimationDirectionForward(this.oldAnimation)));
		a.moveBackward && (this.meshBody && (this.meshBody.setAnimationDirectionBackward(this.activeAnimation), this.meshBody.setAnimationDirectionBackward(this.oldAnimation)), this.meshWeapon && (this.meshWeapon.setAnimationDirectionBackward(this.activeAnimation), this.meshWeapon.setAnimationDirectionBackward(this.oldAnimation)))
	};
	this.updateMovementModel = function (a) {
		var b = this.controls;
		this.maxSpeed = b.crouch ? this.crouchSpeed : this.walkSpeed;
		this.maxReverseSpeed = -this.maxSpeed;
		b.moveForward && (this.speed = THREE.Math.clamp(this.speed + a * this.frontAcceleration, this.maxReverseSpeed, this.maxSpeed));
		b.moveBackward && (this.speed = THREE.Math.clamp(this.speed - a * this.backAcceleration, this.maxReverseSpeed, this.maxSpeed));
		b.moveLeft && (this.bodyOrientation += a * this.angularSpeed, this.speed = THREE.Math.clamp(this.speed + 1 * a * this.frontAcceleration, this.maxReverseSpeed, this.maxSpeed));
		b.moveRight && (this.bodyOrientation -= a * this.angularSpeed, this.speed = THREE.Math.clamp(this.speed + 1 * a * this.frontAcceleration, this.maxReverseSpeed, this.maxSpeed));
		!b.moveForward && !b.moveBackward && (0 < this.speed ? (b = 1 === this.speed / this.maxSpeed ? 1 : -Math.pow(2, -10 * (this.speed / this.maxSpeed)) + 1, this.speed = THREE.Math.clamp(this.speed - b * a * this.frontDecceleration, 0, this.maxSpeed)) : (b = 1 === this.speed / this.maxReverseSpeed ? 1 : -Math.pow(2, -10 * (this.speed / this.maxReverseSpeed)) + 1, this.speed = THREE.Math.clamp(this.speed + b * a * this.backAcceleration,
		this.maxReverseSpeed, 0)));
		a *= this.speed;
		this.root.position.x += Math.sin(this.bodyOrientation) * a;
		this.root.position.z += Math.cos(this.bodyOrientation) * a;
		this.root.rotation.y = this.bodyOrientation
	}
};
THREE.ParametricGeometries = {
	klein: function (a, b) {
		var b = b * Math.PI,
			a = a * 2 * Math.PI,
			b = 2 * b,
			c, d, e;
		b < Math.PI ? (c = 3 * Math.cos(b) * (1 + Math.sin(b)) + 2 * (1 - Math.cos(b) / 2) * Math.cos(b) * Math.cos(a), e = -8 * Math.sin(b) - 2 * (1 - Math.cos(b) / 2) * Math.sin(b) * Math.cos(a)) : (c = 3 * Math.cos(b) * (1 + Math.sin(b)) + 2 * (1 - Math.cos(b) / 2) * Math.cos(a + Math.PI), e = -8 * Math.sin(b));
		d = -2 * (1 - Math.cos(b) / 2) * Math.sin(a);
		return new THREE.Vector3(c, d, e)
	},
	plane: function (a, b) {
		return function (c, d) {
			return new THREE.Vector3(c * a, 0, d * b)
		}
	},
	mobius: function (a, b) {
		var a = a - 0.5,
			c = 2 * Math.PI * b,
			d, e;
		d = Math.cos(c) * (2 + a * Math.cos(c / 2));
		e = Math.sin(c) * (2 + a * Math.cos(c / 2));
		c = a * Math.sin(c / 2);
		return new THREE.Vector3(d, e, c)
	},
	mobius3d: function (a, b) {
		var a = a * Math.PI,
			b = b * 2 * Math.PI,
			a = 2 * a,
			c = a / 2,
			d, e;
		d = 0.125 * Math.cos(b) * Math.cos(c) - 0.65 * Math.sin(b) * Math.sin(c);
		e = 0.125 * Math.cos(b) * Math.sin(c) + 0.65 * Math.sin(b) * Math.cos(c);
		c = (2.25 + d) * Math.sin(a);
		d = (2.25 + d) * Math.cos(a);
		return new THREE.Vector3(d, c, e)
	}
};
THREE.ParametricGeometries.TubeGeometry = function (a, b, c, d, e, f) {
	this.path = a;
	this.segments = b || 64;
	this.radius = c || 1;
	this.segmentsRadius = d || 8;
	this.closed = e || !1;
	f && (this.debug = new THREE.Object3D);
	var g = this,
		h, i, k, j = this.segments + 1,
		l, m, r, q = new THREE.Vector3,
		p, e = new THREE.TubeGeometry.FrenetFrames(a, b, e),
		t = e.tangents,
		u = e.normals,
		x = e.binormals;
	this.tangents = t;
	this.normals = u;
	this.binormals = x;
	THREE.ParametricGeometry.call(this, function (b, d) {
		d *= 2 * Math.PI;
		p = b * (j - 1);
		p = Math.floor(p);
		r = a.getPointAt(b);
		h = t[p];
		i = u[p];
		k = x[p];
		g.debug && (g.debug.add(new THREE.ArrowHelper(h, r, c, 255)), g.debug.add(new THREE.ArrowHelper(i, r, c, 16711680)), g.debug.add(new THREE.ArrowHelper(k, r, c, 65280)));
		l = -g.radius * Math.cos(d);
		m = g.radius * Math.sin(d);
		q.copy(r);
		q.x += l * i.x + m * k.x;
		q.y += l * i.y + m * k.y;
		q.z += l * i.z + m * k.z;
		return q.clone()
	}, b, d)
};
THREE.ParametricGeometries.TubeGeometry.prototype = Object.create(THREE.Geometry.prototype);
THREE.ParametricGeometries.TorusKnotGeometry = function (a, b, c, d, e, f, g) {
	this.radius = a || 200;
	this.tube = b || 40;
	this.segmentsR = c || 64;
	this.segmentsT = d || 8;
	this.p = e || 2;
	this.q = f || 3;
	this.heightScale = g || 1;
	var h = new(THREE.Curve.create(function () {}, function (b) {
		var b = b * 2 * Math.PI,
			c = (1 + 0.5 * Math.cos(f * b)) * Math.cos(e * b),
			d = (1 + 0.5 * Math.cos(f * b)) * Math.sin(e * b),
			b = 0.5 * Math.sin(f * b);
		return (new THREE.Vector3(c, d * g, b)).multiplyScalar(a)
	}));
	THREE.ParametricGeometries.TubeGeometry.call(this, h, c, b, d, !0, !1)
};
THREE.ParametricGeometries.TorusKnotGeometry.prototype = Object.create(THREE.Geometry.prototype);
THREE.ParametricGeometries.SphereGeometry = function (a, b, c) {
	THREE.ParametricGeometry.call(this, function (b, c) {
		var b = b * Math.PI,
			c = c * 2 * Math.PI,
			f = a * Math.sin(b) * Math.cos(c),
			g = a * Math.sin(b) * Math.sin(c),
			h = a * Math.cos(b);
		return new THREE.Vector3(f, g, h)
	}, b, c, !1)
};
THREE.ParametricGeometries.SphereGeometry.prototype = Object.create(THREE.Geometry.prototype);
THREE.ParametricGeometries.PlaneGeometry = function (a, b, c, d) {
	THREE.ParametricGeometry.call(this, function (c, d) {
		return new THREE.Vector3(c * a, 0, d * b)
	}, c, d)
};
THREE.ParametricGeometries.PlaneGeometry.prototype = Object.create(THREE.Geometry.prototype);
THREE.ShaderGodRays = {
	godrays_generate: {
		uniforms: {
			tInput: {
				type: "t",
				value: null
			},
			fStepSize: {
				type: "f",
				value: 1
			},
			vSunPositionScreenSpace: {
				type: "v2",
				value: new THREE.Vector2(0.5, 0.5)
			}
		},
		vertexShader: "varying vec2 vUv;\nvoid main() {\nvUv = uv;\ngl_Position = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );\n}",
		fragmentShader: "#define TAPS_PER_PASS 6.0\nvarying vec2 vUv;\nuniform sampler2D tInput;\nuniform vec2 vSunPositionScreenSpace;\nuniform float fStepSize;\nvoid main() {\nvec2 delta = vSunPositionScreenSpace - vUv;\nfloat dist = length( delta );\nvec2 stepv = fStepSize * delta / dist;\nfloat iters = dist/fStepSize;\nvec2 uv = vUv.xy;\nfloat col = 0.0;\nif ( 0.0 <= iters && uv.y < 1.0 ) col += texture2D( tInput, uv ).r;\nuv += stepv;\nif ( 1.0 <= iters && uv.y < 1.0 ) col += texture2D( tInput, uv ).r;\nuv += stepv;\nif ( 2.0 <= iters && uv.y < 1.0 ) col += texture2D( tInput, uv ).r;\nuv += stepv;\nif ( 3.0 <= iters && uv.y < 1.0 ) col += texture2D( tInput, uv ).r;\nuv += stepv;\nif ( 4.0 <= iters && uv.y < 1.0 ) col += texture2D( tInput, uv ).r;\nuv += stepv;\nif ( 5.0 <= iters && uv.y < 1.0 ) col += texture2D( tInput, uv ).r;\nuv += stepv;\ngl_FragColor = vec4( col/TAPS_PER_PASS );\ngl_FragColor.a = 1.0;\n}"
	},
	godrays_combine: {
		uniforms: {
			tColors: {
				type: "t",
				value: null
			},
			tGodRays: {
				type: "t",
				value: null
			},
			fGodRayIntensity: {
				type: "f",
				value: 0.69
			},
			vSunPositionScreenSpace: {
				type: "v2",
				value: new THREE.Vector2(0.5, 0.5)
			}
		},
		vertexShader: "varying vec2 vUv;\nvoid main() {\nvUv = uv;\ngl_Position = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );\n}",
		fragmentShader: "varying vec2 vUv;\nuniform sampler2D tColors;\nuniform sampler2D tGodRays;\nuniform vec2 vSunPositionScreenSpace;\nuniform float fGodRayIntensity;\nvoid main() {\ngl_FragColor = texture2D( tColors, vUv ) + fGodRayIntensity * vec4( 1.0 - texture2D( tGodRays, vUv ).r );\ngl_FragColor.a = 1.0;\n}"
	},
	godrays_fake_sun: {
		uniforms: {
			vSunPositionScreenSpace: {
				type: "v2",
				value: new THREE.Vector2(0.5, 0.5)
			},
			fAspect: {
				type: "f",
				value: 1
			},
			sunColor: {
				type: "c",
				value: new THREE.Color(16772608)
			},
			bgColor: {
				type: "c",
				value: new THREE.Color(0)
			}
		},
		vertexShader: "varying vec2 vUv;\nvoid main() {\nvUv = uv;\ngl_Position = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );\n}",
		fragmentShader: "varying vec2 vUv;\nuniform vec2 vSunPositionScreenSpace;\nuniform float fAspect;\nuniform vec3 sunColor;\nuniform vec3 bgColor;\nvoid main() {\nvec2 diff = vUv - vSunPositionScreenSpace;\ndiff.x *= fAspect;\nfloat prop = clamp( length( diff ) / 0.5, 0.0, 1.0 );\nprop = 0.35 * pow( 1.0 - prop, 3.0 );\ngl_FragColor.xyz = mix( sunColor, bgColor, 1.0 - prop );\ngl_FragColor.w = 1.0;\n}"
	}
};
THREE.ShaderSkin = {
	skinSimple: {
		uniforms: THREE.UniformsUtils.merge([THREE.UniformsLib.fog, THREE.UniformsLib.lights, THREE.UniformsLib.shadowmap, {
			enableBump: {
				type: "i",
				value: 0
			},
			enableSpecular: {
				type: "i",
				value: 0
			},
			tDiffuse: {
				type: "t",
				value: null
			},
			tBeckmann: {
				type: "t",
				value: null
			},
			uDiffuseColor: {
				type: "c",
				value: new THREE.Color(15658734)
			},
			uSpecularColor: {
				type: "c",
				value: new THREE.Color(1118481)
			},
			uAmbientColor: {
				type: "c",
				value: new THREE.Color(328965)
			},
			uOpacity: {
				type: "f",
				value: 1
			},
			uRoughness: {
				type: "f",
				value: 0.15
			},
			uSpecularBrightness: {
				type: "f",
				value: 0.75
			},
			bumpMap: {
				type: "t",
				value: null
			},
			bumpScale: {
				type: "f",
				value: 1
			},
			specularMap: {
				type: "t",
				value: null
			},
			offsetRepeat: {
				type: "v4",
				value: new THREE.Vector4(0, 0, 1, 1)
			},
			uWrapRGB: {
				type: "v3",
				value: new THREE.Vector3(0.75, 0.375, 0.1875)
			}
		}]),
		fragmentShader: ["#define USE_BUMPMAP\n#extension GL_OES_standard_derivatives : enable\nuniform bool enableBump;\nuniform bool enableSpecular;\nuniform vec3 uAmbientColor;\nuniform vec3 uDiffuseColor;\nuniform vec3 uSpecularColor;\nuniform float uOpacity;\nuniform float uRoughness;\nuniform float uSpecularBrightness;\nuniform vec3 uWrapRGB;\nuniform sampler2D tDiffuse;\nuniform sampler2D tBeckmann;\nuniform sampler2D specularMap;\nvarying vec3 vNormal;\nvarying vec2 vUv;\nuniform vec3 ambientLightColor;\n#if MAX_DIR_LIGHTS > 0\nuniform vec3 directionalLightColor[ MAX_DIR_LIGHTS ];\nuniform vec3 directionalLightDirection[ MAX_DIR_LIGHTS ];\n#endif\n#if MAX_HEMI_LIGHTS > 0\nuniform vec3 hemisphereLightSkyColor[ MAX_HEMI_LIGHTS ];\nuniform vec3 hemisphereLightGroundColor[ MAX_HEMI_LIGHTS ];\nuniform vec3 hemisphereLightDirection[ MAX_HEMI_LIGHTS ];\n#endif\n#if MAX_POINT_LIGHTS > 0\nuniform vec3 pointLightColor[ MAX_POINT_LIGHTS ];\nuniform vec3 pointLightPosition[ MAX_POINT_LIGHTS ];\nuniform float pointLightDistance[ MAX_POINT_LIGHTS ];\n#endif\nvarying vec3 vViewPosition;",
		THREE.ShaderChunk.shadowmap_pars_fragment, THREE.ShaderChunk.fog_pars_fragment, THREE.ShaderChunk.bumpmap_pars_fragment, "float fresnelReflectance( vec3 H, vec3 V, float F0 ) {\nfloat base = 1.0 - dot( V, H );\nfloat exponential = pow( base, 5.0 );\nreturn exponential + F0 * ( 1.0 - exponential );\n}\nfloat KS_Skin_Specular( vec3 N,\nvec3 L,\nvec3 V,\nfloat m,\nfloat rho_s\n) {\nfloat result = 0.0;\nfloat ndotl = dot( N, L );\nif( ndotl > 0.0 ) {\nvec3 h = L + V;\nvec3 H = normalize( h );\nfloat ndoth = dot( N, H );\nfloat PH = pow( 2.0 * texture2D( tBeckmann, vec2( ndoth, m ) ).x, 10.0 );\nfloat F = fresnelReflectance( H, V, 0.028 );\nfloat frSpec = max( PH * F / dot( h, h ), 0.0 );\nresult = ndotl * rho_s * frSpec;\n}\nreturn result;\n}\nvoid main() {\ngl_FragColor = vec4( vec3( 1.0 ), uOpacity );\nvec4 colDiffuse = texture2D( tDiffuse, vUv );\ncolDiffuse.rgb *= colDiffuse.rgb;\ngl_FragColor = gl_FragColor * colDiffuse;\nvec3 normal = normalize( vNormal );\nvec3 viewPosition = normalize( vViewPosition );\nfloat specularStrength;\nif ( enableSpecular ) {\nvec4 texelSpecular = texture2D( specularMap, vUv );\nspecularStrength = texelSpecular.r;\n} else {\nspecularStrength = 1.0;\n}\n#ifdef USE_BUMPMAP\nif ( enableBump ) normal = perturbNormalArb( -vViewPosition, normal, dHdxy_fwd() );\n#endif\nvec3 specularTotal = vec3( 0.0 );\n#if MAX_POINT_LIGHTS > 0\nvec3 pointTotal = vec3( 0.0 );\nfor ( int i = 0; i < MAX_POINT_LIGHTS; i ++ ) {\nvec4 lPosition = viewMatrix * vec4( pointLightPosition[ i ], 1.0 );\nvec3 lVector = lPosition.xyz + vViewPosition.xyz;\nfloat lDistance = 1.0;\nif ( pointLightDistance[ i ] > 0.0 )\nlDistance = 1.0 - min( ( length( lVector ) / pointLightDistance[ i ] ), 1.0 );\nlVector = normalize( lVector );\nfloat pointDiffuseWeightFull = max( dot( normal, lVector ), 0.0 );\nfloat pointDiffuseWeightHalf = max( 0.5 * dot( normal, lVector ) + 0.5, 0.0 );\nvec3 pointDiffuseWeight = mix( vec3 ( pointDiffuseWeightFull ), vec3( pointDiffuseWeightHalf ), uWrapRGB );\nfloat pointSpecularWeight = KS_Skin_Specular( normal, lVector, viewPosition, uRoughness, uSpecularBrightness );\npointTotal    += lDistance * uDiffuseColor * pointLightColor[ i ] * pointDiffuseWeight;\nspecularTotal += lDistance * uSpecularColor * pointLightColor[ i ] * pointSpecularWeight * specularStrength;\n}\n#endif\n#if MAX_DIR_LIGHTS > 0\nvec3 dirTotal = vec3( 0.0 );\nfor( int i = 0; i < MAX_DIR_LIGHTS; i++ ) {\nvec4 lDirection = viewMatrix * vec4( directionalLightDirection[ i ], 0.0 );\nvec3 dirVector = normalize( lDirection.xyz );\nfloat dirDiffuseWeightFull = max( dot( normal, dirVector ), 0.0 );\nfloat dirDiffuseWeightHalf = max( 0.5 * dot( normal, dirVector ) + 0.5, 0.0 );\nvec3 dirDiffuseWeight = mix( vec3 ( dirDiffuseWeightFull ), vec3( dirDiffuseWeightHalf ), uWrapRGB );\nfloat dirSpecularWeight =  KS_Skin_Specular( normal, dirVector, viewPosition, uRoughness, uSpecularBrightness );\ndirTotal \t   += uDiffuseColor * directionalLightColor[ i ] * dirDiffuseWeight;\nspecularTotal += uSpecularColor * directionalLightColor[ i ] * dirSpecularWeight * specularStrength;\n}\n#endif\n#if MAX_HEMI_LIGHTS > 0\nvec3 hemiTotal = vec3( 0.0 );\nfor ( int i = 0; i < MAX_HEMI_LIGHTS; i ++ ) {\nvec4 lDirection = viewMatrix * vec4( hemisphereLightDirection[ i ], 0.0 );\nvec3 lVector = normalize( lDirection.xyz );\nfloat dotProduct = dot( normal, lVector );\nfloat hemiDiffuseWeight = 0.5 * dotProduct + 0.5;\nhemiTotal += uDiffuseColor * mix( hemisphereLightGroundColor[ i ], hemisphereLightSkyColor[ i ], hemiDiffuseWeight );\nfloat hemiSpecularWeight = 0.0;\nhemiSpecularWeight += KS_Skin_Specular( normal, lVector, viewPosition, uRoughness, uSpecularBrightness );\nvec3 lVectorGround = -lVector;\nhemiSpecularWeight += KS_Skin_Specular( normal, lVectorGround, viewPosition, uRoughness, uSpecularBrightness );\nspecularTotal += uSpecularColor * mix( hemisphereLightGroundColor[ i ], hemisphereLightSkyColor[ i ], hemiDiffuseWeight ) * hemiSpecularWeight * specularStrength;\n}\n#endif\nvec3 totalLight = vec3( 0.0 );\n#if MAX_DIR_LIGHTS > 0\ntotalLight += dirTotal;\n#endif\n#if MAX_POINT_LIGHTS > 0\ntotalLight += pointTotal;\n#endif\n#if MAX_HEMI_LIGHTS > 0\ntotalLight += hemiTotal;\n#endif\ngl_FragColor.xyz = gl_FragColor.xyz * ( totalLight + ambientLightColor * uAmbientColor ) + specularTotal;",
		THREE.ShaderChunk.shadowmap_fragment, THREE.ShaderChunk.linear_to_gamma_fragment, THREE.ShaderChunk.fog_fragment, "}"].join("\n"),
		vertexShader: ["uniform vec4 offsetRepeat;\nvarying vec3 vNormal;\nvarying vec2 vUv;\nvarying vec3 vViewPosition;", THREE.ShaderChunk.shadowmap_pars_vertex, "void main() {\nvec4 mvPosition = modelViewMatrix * vec4( position, 1.0 );\nvec4 worldPosition = modelMatrix * vec4( position, 1.0 );\nvViewPosition = -mvPosition.xyz;\nvNormal = normalize( normalMatrix * normal );\nvUv = uv * offsetRepeat.zw + offsetRepeat.xy;\ngl_Position = projectionMatrix * mvPosition;",
		THREE.ShaderChunk.shadowmap_vertex, "}"].join("\n")
	},
	skin: {
		uniforms: THREE.UniformsUtils.merge([THREE.UniformsLib.fog, THREE.UniformsLib.lights, {
			passID: {
				type: "i",
				value: 0
			},
			tDiffuse: {
				type: "t",
				value: null
			},
			tNormal: {
				type: "t",
				value: null
			},
			tBlur1: {
				type: "t",
				value: null
			},
			tBlur2: {
				type: "t",
				value: null
			},
			tBlur3: {
				type: "t",
				value: null
			},
			tBlur4: {
				type: "t",
				value: null
			},
			tBeckmann: {
				type: "t",
				value: null
			},
			uNormalScale: {
				type: "f",
				value: 1
			},
			uDiffuseColor: {
				type: "c",
				value: new THREE.Color(15658734)
			},
			uSpecularColor: {
				type: "c",
				value: new THREE.Color(1118481)
			},
			uAmbientColor: {
				type: "c",
				value: new THREE.Color(328965)
			},
			uOpacity: {
				type: "f",
				value: 1
			},
			uRoughness: {
				type: "f",
				value: 0.15
			},
			uSpecularBrightness: {
				type: "f",
				value: 0.75
			}
		}]),
		fragmentShader: ["uniform vec3 uAmbientColor;\nuniform vec3 uDiffuseColor;\nuniform vec3 uSpecularColor;\nuniform float uOpacity;\nuniform float uRoughness;\nuniform float uSpecularBrightness;\nuniform int passID;\nuniform sampler2D tDiffuse;\nuniform sampler2D tNormal;\nuniform sampler2D tBlur1;\nuniform sampler2D tBlur2;\nuniform sampler2D tBlur3;\nuniform sampler2D tBlur4;\nuniform sampler2D tBeckmann;\nuniform float uNormalScale;\nvarying vec3 vTangent;\nvarying vec3 vBinormal;\nvarying vec3 vNormal;\nvarying vec2 vUv;\nuniform vec3 ambientLightColor;\n#if MAX_DIR_LIGHTS > 0\nuniform vec3 directionalLightColor[ MAX_DIR_LIGHTS ];\nuniform vec3 directionalLightDirection[ MAX_DIR_LIGHTS ];\n#endif\n#if MAX_POINT_LIGHTS > 0\nuniform vec3 pointLightColor[ MAX_POINT_LIGHTS ];\nvarying vec4 vPointLight[ MAX_POINT_LIGHTS ];\n#endif\nvarying vec3 vViewPosition;",
		THREE.ShaderChunk.fog_pars_fragment, "float fresnelReflectance( vec3 H, vec3 V, float F0 ) {\nfloat base = 1.0 - dot( V, H );\nfloat exponential = pow( base, 5.0 );\nreturn exponential + F0 * ( 1.0 - exponential );\n}\nfloat KS_Skin_Specular( vec3 N,\nvec3 L,\nvec3 V,\nfloat m,\nfloat rho_s\n) {\nfloat result = 0.0;\nfloat ndotl = dot( N, L );\nif( ndotl > 0.0 ) {\nvec3 h = L + V;\nvec3 H = normalize( h );\nfloat ndoth = dot( N, H );\nfloat PH = pow( 2.0 * texture2D( tBeckmann, vec2( ndoth, m ) ).x, 10.0 );\nfloat F = fresnelReflectance( H, V, 0.028 );\nfloat frSpec = max( PH * F / dot( h, h ), 0.0 );\nresult = ndotl * rho_s * frSpec;\n}\nreturn result;\n}\nvoid main() {\ngl_FragColor = vec4( 1.0 );\nvec4 mColor = vec4( uDiffuseColor, uOpacity );\nvec4 mSpecular = vec4( uSpecularColor, uOpacity );\nvec3 normalTex = texture2D( tNormal, vUv ).xyz * 2.0 - 1.0;\nnormalTex.xy *= uNormalScale;\nnormalTex = normalize( normalTex );\nvec4 colDiffuse = texture2D( tDiffuse, vUv );\ncolDiffuse *= colDiffuse;\ngl_FragColor = gl_FragColor * colDiffuse;\nmat3 tsb = mat3( vTangent, vBinormal, vNormal );\nvec3 finalNormal = tsb * normalTex;\nvec3 normal = normalize( finalNormal );\nvec3 viewPosition = normalize( vViewPosition );\nvec3 specularTotal = vec3( 0.0 );\n#if MAX_POINT_LIGHTS > 0\nvec4 pointTotal = vec4( vec3( 0.0 ), 1.0 );\nfor ( int i = 0; i < MAX_POINT_LIGHTS; i ++ ) {\nvec3 pointVector = normalize( vPointLight[ i ].xyz );\nfloat pointDistance = vPointLight[ i ].w;\nfloat pointDiffuseWeight = max( dot( normal, pointVector ), 0.0 );\npointTotal  += pointDistance * vec4( pointLightColor[ i ], 1.0 ) * ( mColor * pointDiffuseWeight );\nif ( passID == 1 )\nspecularTotal += pointDistance * mSpecular.xyz * pointLightColor[ i ] * KS_Skin_Specular( normal, pointVector, viewPosition, uRoughness, uSpecularBrightness );\n}\n#endif\n#if MAX_DIR_LIGHTS > 0\nvec4 dirTotal = vec4( vec3( 0.0 ), 1.0 );\nfor( int i = 0; i < MAX_DIR_LIGHTS; i++ ) {\nvec4 lDirection = viewMatrix * vec4( directionalLightDirection[ i ], 0.0 );\nvec3 dirVector = normalize( lDirection.xyz );\nfloat dirDiffuseWeight = max( dot( normal, dirVector ), 0.0 );\ndirTotal  += vec4( directionalLightColor[ i ], 1.0 ) * ( mColor * dirDiffuseWeight );\nif ( passID == 1 )\nspecularTotal += mSpecular.xyz * directionalLightColor[ i ] * KS_Skin_Specular( normal, dirVector, viewPosition, uRoughness, uSpecularBrightness );\n}\n#endif\nvec4 totalLight = vec4( vec3( 0.0 ), uOpacity );\n#if MAX_DIR_LIGHTS > 0\ntotalLight += dirTotal;\n#endif\n#if MAX_POINT_LIGHTS > 0\ntotalLight += pointTotal;\n#endif\ngl_FragColor = gl_FragColor * totalLight;\nif ( passID == 0 ) {\ngl_FragColor = vec4( sqrt( gl_FragColor.xyz ), gl_FragColor.w );\n} else if ( passID == 1 ) {\n#ifdef VERSION1\nvec3 nonblurColor = sqrt( gl_FragColor.xyz );\n#else\nvec3 nonblurColor = gl_FragColor.xyz;\n#endif\nvec3 blur1Color = texture2D( tBlur1, vUv ).xyz;\nvec3 blur2Color = texture2D( tBlur2, vUv ).xyz;\nvec3 blur3Color = texture2D( tBlur3, vUv ).xyz;\nvec3 blur4Color = texture2D( tBlur4, vUv ).xyz;\ngl_FragColor = vec4( vec3( 0.22,  0.437, 0.635 ) * nonblurColor + \nvec3( 0.101, 0.355, 0.365 ) * blur1Color + \nvec3( 0.119, 0.208, 0.0 )   * blur2Color + \nvec3( 0.114, 0.0,   0.0 )   * blur3Color + \nvec3( 0.444, 0.0,   0.0 )   * blur4Color\n, gl_FragColor.w );\ngl_FragColor.xyz *= pow( colDiffuse.xyz, vec3( 0.5 ) );\ngl_FragColor.xyz += ambientLightColor * uAmbientColor * colDiffuse.xyz + specularTotal;\n#ifndef VERSION1\ngl_FragColor.xyz = sqrt( gl_FragColor.xyz );\n#endif\n}",
		THREE.ShaderChunk.fog_fragment, "}"].join("\n"),
		vertexShader: "attribute vec4 tangent;\n#ifdef VERTEX_TEXTURES\nuniform sampler2D tDisplacement;\nuniform float uDisplacementScale;\nuniform float uDisplacementBias;\n#endif\nvarying vec3 vTangent;\nvarying vec3 vBinormal;\nvarying vec3 vNormal;\nvarying vec2 vUv;\n#if MAX_POINT_LIGHTS > 0\nuniform vec3 pointLightPosition[ MAX_POINT_LIGHTS ];\nuniform float pointLightDistance[ MAX_POINT_LIGHTS ];\nvarying vec4 vPointLight[ MAX_POINT_LIGHTS ];\n#endif\nvarying vec3 vViewPosition;\nvoid main() {\nvec4 worldPosition = modelMatrix * vec4( position, 1.0 );\nvec4 mvPosition = modelViewMatrix * vec4( position, 1.0 );\nvViewPosition = -mvPosition.xyz;\nvNormal = normalize( normalMatrix * normal );\nvTangent = normalize( normalMatrix * tangent.xyz );\nvBinormal = cross( vNormal, vTangent ) * tangent.w;\nvBinormal = normalize( vBinormal );\nvUv = uv;\n#if MAX_POINT_LIGHTS > 0\nfor( int i = 0; i < MAX_POINT_LIGHTS; i++ ) {\nvec4 lPosition = viewMatrix * vec4( pointLightPosition[ i ], 1.0 );\nvec3 lVector = lPosition.xyz - mvPosition.xyz;\nfloat lDistance = 1.0;\nif ( pointLightDistance[ i ] > 0.0 )\nlDistance = 1.0 - min( ( length( lVector ) / pointLightDistance[ i ] ), 1.0 );\nlVector = normalize( lVector );\nvPointLight[ i ] = vec4( lVector, lDistance );\n}\n#endif\n#ifdef VERTEX_TEXTURES\nvec3 dv = texture2D( tDisplacement, uv ).xyz;\nfloat df = uDisplacementScale * dv.x + uDisplacementBias;\nvec4 displacedPosition = vec4( vNormal.xyz * df, 0.0 ) + mvPosition;\ngl_Position = projectionMatrix * displacedPosition;\n#else\ngl_Position = projectionMatrix * mvPosition;\n#endif\n}",
		vertexShaderUV: "attribute vec4 tangent;\n#ifdef VERTEX_TEXTURES\nuniform sampler2D tDisplacement;\nuniform float uDisplacementScale;\nuniform float uDisplacementBias;\n#endif\nvarying vec3 vTangent;\nvarying vec3 vBinormal;\nvarying vec3 vNormal;\nvarying vec2 vUv;\n#if MAX_POINT_LIGHTS > 0\nuniform vec3 pointLightPosition[ MAX_POINT_LIGHTS ];\nuniform float pointLightDistance[ MAX_POINT_LIGHTS ];\nvarying vec4 vPointLight[ MAX_POINT_LIGHTS ];\n#endif\nvarying vec3 vViewPosition;\nvoid main() {\nvec4 worldPosition = modelMatrix * vec4( position, 1.0 );\nvec4 mvPosition = modelViewMatrix * vec4( position, 1.0 );\nvViewPosition = -mvPosition.xyz;\nvNormal = normalize( normalMatrix * normal );\nvTangent = normalize( normalMatrix * tangent.xyz );\nvBinormal = cross( vNormal, vTangent ) * tangent.w;\nvBinormal = normalize( vBinormal );\nvUv = uv;\n#if MAX_POINT_LIGHTS > 0\nfor( int i = 0; i < MAX_POINT_LIGHTS; i++ ) {\nvec4 lPosition = viewMatrix * vec4( pointLightPosition[ i ], 1.0 );\nvec3 lVector = lPosition.xyz - mvPosition.xyz;\nfloat lDistance = 1.0;\nif ( pointLightDistance[ i ] > 0.0 )\nlDistance = 1.0 - min( ( length( lVector ) / pointLightDistance[ i ] ), 1.0 );\nlVector = normalize( lVector );\nvPointLight[ i ] = vec4( lVector, lDistance );\n}\n#endif\ngl_Position = vec4( uv.x * 2.0 - 1.0, uv.y * 2.0 - 1.0, 0.0, 1.0 );\n}"
	},
	beckmann: {
		uniforms: {},
		vertexShader: "varying vec2 vUv;\nvoid main() {\nvUv = uv;\ngl_Position = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );\n}",
		fragmentShader: "varying vec2 vUv;\nfloat PHBeckmann( float ndoth, float m ) {\nfloat alpha = acos( ndoth );\nfloat ta = tan( alpha );\nfloat val = 1.0 / ( m * m * pow( ndoth, 4.0 ) ) * exp( -( ta * ta ) / ( m * m ) );\nreturn val;\n}\nfloat KSTextureCompute( vec2 tex ) {\nreturn 0.5 * pow( PHBeckmann( tex.x, tex.y ), 0.1 );\n}\nvoid main() {\nfloat x = KSTextureCompute( vUv );\ngl_FragColor = vec4( x, x, x, 1.0 );\n}"
	}
};
THREE.ShaderTerrain = {
	terrain: {
		uniforms: THREE.UniformsUtils.merge([THREE.UniformsLib.fog, THREE.UniformsLib.lights, THREE.UniformsLib.shadowmap, {
			enableDiffuse1: {
				type: "i",
				value: 0
			},
			enableDiffuse2: {
				type: "i",
				value: 0
			},
			enableSpecular: {
				type: "i",
				value: 0
			},
			enableReflection: {
				type: "i",
				value: 0
			},
			tDiffuse1: {
				type: "t",
				value: null
			},
			tDiffuse2: {
				type: "t",
				value: null
			},
			tDetail: {
				type: "t",
				value: null
			},
			tNormal: {
				type: "t",
				value: null
			},
			tSpecular: {
				type: "t",
				value: null
			},
			tDisplacement: {
				type: "t",
				value: null
			},
			uNormalScale: {
				type: "f",
				value: 1
			},
			uDisplacementBias: {
				type: "f",
				value: 0
			},
			uDisplacementScale: {
				type: "f",
				value: 1
			},
			uDiffuseColor: {
				type: "c",
				value: new THREE.Color(15658734)
			},
			uSpecularColor: {
				type: "c",
				value: new THREE.Color(1118481)
			},
			uAmbientColor: {
				type: "c",
				value: new THREE.Color(328965)
			},
			uShininess: {
				type: "f",
				value: 30
			},
			uOpacity: {
				type: "f",
				value: 1
			},
			uRepeatBase: {
				type: "v2",
				value: new THREE.Vector2(1, 1)
			},
			uRepeatOverlay: {
				type: "v2",
				value: new THREE.Vector2(1, 1)
			},
			uOffset: {
				type: "v2",
				value: new THREE.Vector2(0, 0)
			}
		}]),
		fragmentShader: ["uniform vec3 uAmbientColor;\nuniform vec3 uDiffuseColor;\nuniform vec3 uSpecularColor;\nuniform float uShininess;\nuniform float uOpacity;\nuniform bool enableDiffuse1;\nuniform bool enableDiffuse2;\nuniform bool enableSpecular;\nuniform sampler2D tDiffuse1;\nuniform sampler2D tDiffuse2;\nuniform sampler2D tDetail;\nuniform sampler2D tNormal;\nuniform sampler2D tSpecular;\nuniform sampler2D tDisplacement;\nuniform float uNormalScale;\nuniform vec2 uRepeatOverlay;\nuniform vec2 uRepeatBase;\nuniform vec2 uOffset;\nvarying vec3 vTangent;\nvarying vec3 vBinormal;\nvarying vec3 vNormal;\nvarying vec2 vUv;\nuniform vec3 ambientLightColor;\n#if MAX_DIR_LIGHTS > 0\nuniform vec3 directionalLightColor[ MAX_DIR_LIGHTS ];\nuniform vec3 directionalLightDirection[ MAX_DIR_LIGHTS ];\n#endif\n#if MAX_HEMI_LIGHTS > 0\nuniform vec3 hemisphereLightSkyColor[ MAX_HEMI_LIGHTS ];\nuniform vec3 hemisphereLightGroundColor[ MAX_HEMI_LIGHTS ];\nuniform vec3 hemisphereLightDirection[ MAX_HEMI_LIGHTS ];\n#endif\n#if MAX_POINT_LIGHTS > 0\nuniform vec3 pointLightColor[ MAX_POINT_LIGHTS ];\nuniform vec3 pointLightPosition[ MAX_POINT_LIGHTS ];\nuniform float pointLightDistance[ MAX_POINT_LIGHTS ];\n#endif\nvarying vec3 vViewPosition;",
		THREE.ShaderChunk.shadowmap_pars_fragment, THREE.ShaderChunk.fog_pars_fragment, "void main() {\ngl_FragColor = vec4( vec3( 1.0 ), uOpacity );\nvec3 specularTex = vec3( 1.0 );\nvec2 uvOverlay = uRepeatOverlay * vUv + uOffset;\nvec2 uvBase = uRepeatBase * vUv;\nvec3 normalTex = texture2D( tDetail, uvOverlay ).xyz * 2.0 - 1.0;\nnormalTex.xy *= uNormalScale;\nnormalTex = normalize( normalTex );\nif( enableDiffuse1 && enableDiffuse2 ) {\nvec4 colDiffuse1 = texture2D( tDiffuse1, uvOverlay );\nvec4 colDiffuse2 = texture2D( tDiffuse2, uvOverlay );\n#ifdef GAMMA_INPUT\ncolDiffuse1.xyz *= colDiffuse1.xyz;\ncolDiffuse2.xyz *= colDiffuse2.xyz;\n#endif\ngl_FragColor = gl_FragColor * mix ( colDiffuse1, colDiffuse2, 1.0 - texture2D( tDisplacement, uvBase ) );\n } else if( enableDiffuse1 ) {\ngl_FragColor = gl_FragColor * texture2D( tDiffuse1, uvOverlay );\n} else if( enableDiffuse2 ) {\ngl_FragColor = gl_FragColor * texture2D( tDiffuse2, uvOverlay );\n}\nif( enableSpecular )\nspecularTex = texture2D( tSpecular, uvOverlay ).xyz;\nmat3 tsb = mat3( vTangent, vBinormal, vNormal );\nvec3 finalNormal = tsb * normalTex;\nvec3 normal = normalize( finalNormal );\nvec3 viewPosition = normalize( vViewPosition );\n#if MAX_POINT_LIGHTS > 0\nvec3 pointDiffuse = vec3( 0.0 );\nvec3 pointSpecular = vec3( 0.0 );\nfor ( int i = 0; i < MAX_POINT_LIGHTS; i ++ ) {\nvec4 lPosition = viewMatrix * vec4( pointLightPosition[ i ], 1.0 );\nvec3 lVector = lPosition.xyz + vViewPosition.xyz;\nfloat lDistance = 1.0;\nif ( pointLightDistance[ i ] > 0.0 )\nlDistance = 1.0 - min( ( length( lVector ) / pointLightDistance[ i ] ), 1.0 );\nlVector = normalize( lVector );\nvec3 pointHalfVector = normalize( lVector + viewPosition );\nfloat pointDistance = lDistance;\nfloat pointDotNormalHalf = max( dot( normal, pointHalfVector ), 0.0 );\nfloat pointDiffuseWeight = max( dot( normal, lVector ), 0.0 );\nfloat pointSpecularWeight = specularTex.r * max( pow( pointDotNormalHalf, uShininess ), 0.0 );\npointDiffuse += pointDistance * pointLightColor[ i ] * uDiffuseColor * pointDiffuseWeight;\npointSpecular += pointDistance * pointLightColor[ i ] * uSpecularColor * pointSpecularWeight * pointDiffuseWeight;\n}\n#endif\n#if MAX_DIR_LIGHTS > 0\nvec3 dirDiffuse = vec3( 0.0 );\nvec3 dirSpecular = vec3( 0.0 );\nfor( int i = 0; i < MAX_DIR_LIGHTS; i++ ) {\nvec4 lDirection = viewMatrix * vec4( directionalLightDirection[ i ], 0.0 );\nvec3 dirVector = normalize( lDirection.xyz );\nvec3 dirHalfVector = normalize( dirVector + viewPosition );\nfloat dirDotNormalHalf = max( dot( normal, dirHalfVector ), 0.0 );\nfloat dirDiffuseWeight = max( dot( normal, dirVector ), 0.0 );\nfloat dirSpecularWeight = specularTex.r * max( pow( dirDotNormalHalf, uShininess ), 0.0 );\ndirDiffuse += directionalLightColor[ i ] * uDiffuseColor * dirDiffuseWeight;\ndirSpecular += directionalLightColor[ i ] * uSpecularColor * dirSpecularWeight * dirDiffuseWeight;\n}\n#endif\n#if MAX_HEMI_LIGHTS > 0\nvec3 hemiDiffuse  = vec3( 0.0 );\nvec3 hemiSpecular = vec3( 0.0 );\nfor( int i = 0; i < MAX_HEMI_LIGHTS; i ++ ) {\nvec4 lDirection = viewMatrix * vec4( hemisphereLightDirection[ i ], 0.0 );\nvec3 lVector = normalize( lDirection.xyz );\nfloat dotProduct = dot( normal, lVector );\nfloat hemiDiffuseWeight = 0.5 * dotProduct + 0.5;\nhemiDiffuse += uDiffuseColor * mix( hemisphereLightGroundColor[ i ], hemisphereLightSkyColor[ i ], hemiDiffuseWeight );\nfloat hemiSpecularWeight = 0.0;\nvec3 hemiHalfVectorSky = normalize( lVector + viewPosition );\nfloat hemiDotNormalHalfSky = 0.5 * dot( normal, hemiHalfVectorSky ) + 0.5;\nhemiSpecularWeight += specularTex.r * max( pow( hemiDotNormalHalfSky, uShininess ), 0.0 );\nvec3 lVectorGround = -lVector;\nvec3 hemiHalfVectorGround = normalize( lVectorGround + viewPosition );\nfloat hemiDotNormalHalfGround = 0.5 * dot( normal, hemiHalfVectorGround ) + 0.5;\nhemiSpecularWeight += specularTex.r * max( pow( hemiDotNormalHalfGround, uShininess ), 0.0 );\nhemiSpecular += uSpecularColor * mix( hemisphereLightGroundColor[ i ], hemisphereLightSkyColor[ i ], hemiDiffuseWeight ) * hemiSpecularWeight * hemiDiffuseWeight;\n}\n#endif\nvec3 totalDiffuse = vec3( 0.0 );\nvec3 totalSpecular = vec3( 0.0 );\n#if MAX_DIR_LIGHTS > 0\ntotalDiffuse += dirDiffuse;\ntotalSpecular += dirSpecular;\n#endif\n#if MAX_HEMI_LIGHTS > 0\ntotalDiffuse += hemiDiffuse;\ntotalSpecular += hemiSpecular;\n#endif\n#if MAX_POINT_LIGHTS > 0\ntotalDiffuse += pointDiffuse;\ntotalSpecular += pointSpecular;\n#endif\ngl_FragColor.xyz = gl_FragColor.xyz * ( totalDiffuse + ambientLightColor * uAmbientColor + totalSpecular );",
		THREE.ShaderChunk.shadowmap_fragment, THREE.ShaderChunk.linear_to_gamma_fragment, THREE.ShaderChunk.fog_fragment, "}"].join("\n"),
		vertexShader: ["attribute vec4 tangent;\nuniform vec2 uRepeatBase;\nuniform sampler2D tNormal;\n#ifdef VERTEX_TEXTURES\nuniform sampler2D tDisplacement;\nuniform float uDisplacementScale;\nuniform float uDisplacementBias;\n#endif\nvarying vec3 vTangent;\nvarying vec3 vBinormal;\nvarying vec3 vNormal;\nvarying vec2 vUv;\nvarying vec3 vViewPosition;", THREE.ShaderChunk.shadowmap_pars_vertex,
			"void main() {\nvNormal = normalize( normalMatrix * normal );\nvTangent = normalize( normalMatrix * tangent.xyz );\nvBinormal = cross( vNormal, vTangent ) * tangent.w;\nvBinormal = normalize( vBinormal );\nvUv = uv;\nvec2 uvBase = uv * uRepeatBase;\n#ifdef VERTEX_TEXTURES\nvec3 dv = texture2D( tDisplacement, uvBase ).xyz;\nfloat df = uDisplacementScale * dv.x + uDisplacementBias;\nvec3 displacedPosition = normal * df + position;\nvec4 worldPosition = modelMatrix * vec4( displacedPosition, 1.0 );\nvec4 mvPosition = modelViewMatrix * vec4( displacedPosition, 1.0 );\n#else\nvec4 worldPosition = modelMatrix * vec4( position, 1.0 );\nvec4 mvPosition = modelViewMatrix * vec4( position, 1.0 );\n#endif\ngl_Position = projectionMatrix * mvPosition;\nvViewPosition = -mvPosition.xyz;\nvec3 normalTex = texture2D( tNormal, uvBase ).xyz * 2.0 - 1.0;\nvNormal = normalMatrix * normalTex;",
		THREE.ShaderChunk.shadowmap_vertex, "}"].join("\n")
	}
};
THREE.ShaderToon = {
	toon1: {
		uniforms: {
			uDirLightPos: {
				type: "v3",
				value: new THREE.Vector3
			},
			uDirLightColor: {
				type: "c",
				value: new THREE.Color(15658734)
			},
			uAmbientLightColor: {
				type: "c",
				value: new THREE.Color(328965)
			},
			uBaseColor: {
				type: "c",
				value: new THREE.Color(16777215)
			}
		},
		vertexShader: "varying vec3 vNormal;\nvarying vec3 vRefract;\nvoid main() {\nvec4 worldPosition = modelMatrix * vec4( position, 1.0 );\nvec4 mvPosition = modelViewMatrix * vec4( position, 1.0 );\nvec3 worldNormal = normalize ( mat3( modelMatrix[0].xyz, modelMatrix[1].xyz, modelMatrix[2].xyz ) * normal );\nvNormal = normalize( normalMatrix * normal );\nvec3 I = worldPosition.xyz - cameraPosition;\nvRefract = refract( normalize( I ), worldNormal, 1.02 );\ngl_Position = projectionMatrix * mvPosition;\n}",
		fragmentShader: "uniform vec3 uBaseColor;\nuniform vec3 uDirLightPos;\nuniform vec3 uDirLightColor;\nuniform vec3 uAmbientLightColor;\nvarying vec3 vNormal;\nvarying vec3 vRefract;\nvoid main() {\nfloat directionalLightWeighting = max( dot( normalize( vNormal ), uDirLightPos ), 0.0);\nvec3 lightWeighting = uAmbientLightColor + uDirLightColor * directionalLightWeighting;\nfloat intensity = smoothstep( - 0.5, 1.0, pow( length(lightWeighting), 20.0 ) );\nintensity += length(lightWeighting) * 0.2;\nfloat cameraWeighting = dot( normalize( vNormal ), vRefract );\nintensity += pow( 1.0 - length( cameraWeighting ), 6.0 );\nintensity = intensity * 0.2 + 0.3;\nif ( intensity < 0.50 ) {\ngl_FragColor = vec4( 2.0 * intensity * uBaseColor, 1.0 );\n} else {\ngl_FragColor = vec4( 1.0 - 2.0 * ( 1.0 - intensity ) * ( 1.0 - uBaseColor ), 1.0 );\n}\n}"
	},
	toon2: {
		uniforms: {
			uDirLightPos: {
				type: "v3",
				value: new THREE.Vector3
			},
			uDirLightColor: {
				type: "c",
				value: new THREE.Color(15658734)
			},
			uAmbientLightColor: {
				type: "c",
				value: new THREE.Color(328965)
			},
			uBaseColor: {
				type: "c",
				value: new THREE.Color(15658734)
			},
			uLineColor1: {
				type: "c",
				value: new THREE.Color(8421504)
			},
			uLineColor2: {
				type: "c",
				value: new THREE.Color(0)
			},
			uLineColor3: {
				type: "c",
				value: new THREE.Color(0)
			},
			uLineColor4: {
				type: "c",
				value: new THREE.Color(0)
			}
		},
		vertexShader: "varying vec3 vNormal;\nvoid main() {\ngl_Position = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );\nvNormal = normalize( normalMatrix * normal );\n}",
		fragmentShader: "uniform vec3 uBaseColor;\nuniform vec3 uLineColor1;\nuniform vec3 uLineColor2;\nuniform vec3 uLineColor3;\nuniform vec3 uLineColor4;\nuniform vec3 uDirLightPos;\nuniform vec3 uDirLightColor;\nuniform vec3 uAmbientLightColor;\nvarying vec3 vNormal;\nvoid main() {\nfloat camera = max( dot( normalize( vNormal ), vec3( 0.0, 0.0, 1.0 ) ), 0.4);\nfloat light = max( dot( normalize( vNormal ), uDirLightPos ), 0.0);\ngl_FragColor = vec4( uBaseColor, 1.0 );\nif ( length(uAmbientLightColor + uDirLightColor * light) < 1.00 ) {\ngl_FragColor *= vec4( uLineColor1, 1.0 );\n}\nif ( length(uAmbientLightColor + uDirLightColor * camera) < 0.50 ) {\ngl_FragColor *= vec4( uLineColor2, 1.0 );\n}\n}"
	},
	hatching: {
		uniforms: {
			uDirLightPos: {
				type: "v3",
				value: new THREE.Vector3
			},
			uDirLightColor: {
				type: "c",
				value: new THREE.Color(15658734)
			},
			uAmbientLightColor: {
				type: "c",
				value: new THREE.Color(328965)
			},
			uBaseColor: {
				type: "c",
				value: new THREE.Color(16777215)
			},
			uLineColor1: {
				type: "c",
				value: new THREE.Color(0)
			},
			uLineColor2: {
				type: "c",
				value: new THREE.Color(0)
			},
			uLineColor3: {
				type: "c",
				value: new THREE.Color(0)
			},
			uLineColor4: {
				type: "c",
				value: new THREE.Color(0)
			}
		},
		vertexShader: "varying vec3 vNormal;\nvoid main() {\ngl_Position = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );\nvNormal = normalize( normalMatrix * normal );\n}",
		fragmentShader: "uniform vec3 uBaseColor;\nuniform vec3 uLineColor1;\nuniform vec3 uLineColor2;\nuniform vec3 uLineColor3;\nuniform vec3 uLineColor4;\nuniform vec3 uDirLightPos;\nuniform vec3 uDirLightColor;\nuniform vec3 uAmbientLightColor;\nvarying vec3 vNormal;\nvoid main() {\nfloat directionalLightWeighting = max( dot( normalize(vNormal), uDirLightPos ), 0.0);\nvec3 lightWeighting = uAmbientLightColor + uDirLightColor * directionalLightWeighting;\ngl_FragColor = vec4( uBaseColor, 1.0 );\nif ( length(lightWeighting) < 1.00 ) {\nif ( mod(gl_FragCoord.x + gl_FragCoord.y, 10.0) == 0.0) {\ngl_FragColor = vec4( uLineColor1, 1.0 );\n}\n}\nif ( length(lightWeighting) < 0.75 ) {\nif (mod(gl_FragCoord.x - gl_FragCoord.y, 10.0) == 0.0) {\ngl_FragColor = vec4( uLineColor2, 1.0 );\n}\n}\nif ( length(lightWeighting) < 0.50 ) {\nif (mod(gl_FragCoord.x + gl_FragCoord.y - 5.0, 10.0) == 0.0) {\ngl_FragColor = vec4( uLineColor3, 1.0 );\n}\n}\nif ( length(lightWeighting) < 0.3465 ) {\nif (mod(gl_FragCoord.x - gl_FragCoord.y - 5.0, 10.0) == 0.0) {\ngl_FragColor = vec4( uLineColor4, 1.0 );\n}\n}\n}"
	},
	dotted: {
		uniforms: {
			uDirLightPos: {
				type: "v3",
				value: new THREE.Vector3
			},
			uDirLightColor: {
				type: "c",
				value: new THREE.Color(15658734)
			},
			uAmbientLightColor: {
				type: "c",
				value: new THREE.Color(328965)
			},
			uBaseColor: {
				type: "c",
				value: new THREE.Color(16777215)
			},
			uLineColor1: {
				type: "c",
				value: new THREE.Color(0)
			}
		},
		vertexShader: "varying vec3 vNormal;\nvoid main() {\ngl_Position = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );\nvNormal = normalize( normalMatrix * normal );\n}",
		fragmentShader: "uniform vec3 uBaseColor;\nuniform vec3 uLineColor1;\nuniform vec3 uLineColor2;\nuniform vec3 uLineColor3;\nuniform vec3 uLineColor4;\nuniform vec3 uDirLightPos;\nuniform vec3 uDirLightColor;\nuniform vec3 uAmbientLightColor;\nvarying vec3 vNormal;\nvoid main() {\nfloat directionalLightWeighting = max( dot( normalize(vNormal), uDirLightPos ), 0.0);\nvec3 lightWeighting = uAmbientLightColor + uDirLightColor * directionalLightWeighting;\ngl_FragColor = vec4( uBaseColor, 1.0 );\nif ( length(lightWeighting) < 1.00 ) {\nif ( ( mod(gl_FragCoord.x, 4.001) + mod(gl_FragCoord.y, 4.0) ) > 6.00 ) {\ngl_FragColor = vec4( uLineColor1, 1.0 );\n}\n}\nif ( length(lightWeighting) < 0.50 ) {\nif ( ( mod(gl_FragCoord.x + 2.0, 4.001) + mod(gl_FragCoord.y + 2.0, 4.0) ) > 6.00 ) {\ngl_FragColor = vec4( uLineColor1, 1.0 );\n}\n}\n}"
	}
};
THREE.DeferredShaderChunk = {
	unpackFloat: "vec3 float_to_vec3( float data ) {\nvec3 uncompressed;\nuncompressed.x = fract( data );\nfloat zInt = floor( data / 255.0 );\nuncompressed.z = fract( zInt / 255.0 );\nuncompressed.y = fract( floor( data - ( zInt * 255.0 ) ) / 255.0 );\nreturn uncompressed;\n}",
	computeVertexPositionVS: "vec2 texCoord = gl_FragCoord.xy / vec2( viewWidth, viewHeight );\nvec4 normalDepth = texture2D( samplerNormalDepth, texCoord );\nfloat z = normalDepth.w;\nif ( z == 0.0 ) discard;\nvec2 xy = texCoord * 2.0 - 1.0;\nvec4 vertexPositionProjected = vec4( xy, z, 1.0 );\nvec4 vertexPositionVS = matProjInverse * vertexPositionProjected;\nvertexPositionVS.xyz /= vertexPositionVS.w;\nvertexPositionVS.w = 1.0;",
	computeNormal: "vec3 normal = normalDepth.xyz * 2.0 - 1.0;",
	unpackColorMap: "vec4 colorMap = texture2D( samplerColor, texCoord );\nvec3 albedo = float_to_vec3( abs( colorMap.x ) );\nvec3 specularColor = float_to_vec3( abs( colorMap.y ) );\nfloat shininess = abs( colorMap.z );\nfloat wrapAround = sign( colorMap.z );\nfloat additiveSpecular = sign( colorMap.y );",
	computeDiffuse: "float dotProduct = dot( normal, lightVector );\nfloat diffuseFull = max( dotProduct, 0.0 );\nvec3 diffuse;\nif ( wrapAround < 0.0 ) {\nfloat diffuseHalf = max( 0.5 * dotProduct + 0.5, 0.0 );\nconst vec3 wrapRGB = vec3( 1.0, 1.0, 1.0 );\ndiffuse = mix( vec3( diffuseFull ), vec3( diffuseHalf ), wrapRGB );\n} else {\ndiffuse = vec3( diffuseFull );\n}",
	computeSpecular: "vec3 halfVector = normalize( lightVector - normalize( vertexPositionVS.xyz ) );\nfloat dotNormalHalf = max( dot( normal, halfVector ), 0.0 );\nfloat specularNormalization = ( shininess + 2.0001 ) / 8.0;\nvec3 schlick = specularColor + vec3( 1.0 - specularColor ) * pow( 1.0 - dot( lightVector, halfVector ), 5.0 );\nvec3 specular = schlick * max( pow( dotNormalHalf, shininess ), 0.0 ) * diffuse * specularNormalization;",
	combine: "vec3 light = lightIntensity * lightColor;\ngl_FragColor = vec4( light * ( albedo * diffuse + specular ), attenuation );"
};
THREE.ShaderDeferred = {
	color: {
		uniforms: THREE.UniformsUtils.merge([THREE.UniformsLib.common, THREE.UniformsLib.fog, THREE.UniformsLib.shadowmap, {
			emissive: {
				type: "c",
				value: new THREE.Color(0)
			},
			specular: {
				type: "c",
				value: new THREE.Color(1118481)
			},
			shininess: {
				type: "f",
				value: 30
			},
			wrapAround: {
				type: "f",
				value: 1
			},
			additiveSpecular: {
				type: "f",
				value: 1
			},
			samplerNormalDepth: {
				type: "t",
				value: null
			},
			viewWidth: {
				type: "f",
				value: 800
			},
			viewHeight: {
				type: "f",
				value: 600
			}
		}]),
		fragmentShader: ["uniform vec3 diffuse;\nuniform vec3 specular;\nuniform vec3 emissive;\nuniform float shininess;\nuniform float wrapAround;\nuniform float additiveSpecular;",
		THREE.ShaderChunk.color_pars_fragment, THREE.ShaderChunk.map_pars_fragment, THREE.ShaderChunk.lightmap_pars_fragment, "#ifdef USE_ENVMAP\nvarying vec3 vWorldPosition;\nuniform float reflectivity;\nuniform samplerCube envMap;\nuniform float flipEnvMap;\nuniform int combine;\nuniform bool useRefract;\nuniform float refractionRatio;\nuniform sampler2D samplerNormalDepth;\nuniform float viewHeight;\nuniform float viewWidth;\n#endif", THREE.ShaderChunk.fog_pars_fragment, THREE.ShaderChunk.shadowmap_pars_fragment,
		THREE.ShaderChunk.specularmap_pars_fragment, "const float unit = 255.0/256.0;\nfloat vec3_to_float( vec3 data ) {\nhighp float compressed = fract( data.x * unit ) + floor( data.y * unit * 255.0 ) + floor( data.z * unit * 255.0 ) * 255.0;\nreturn compressed;\n}\nvoid main() {\nconst float opacity = 1.0;\ngl_FragColor = vec4( diffuse, opacity );", THREE.ShaderChunk.map_fragment, THREE.ShaderChunk.alphatest_fragment, THREE.ShaderChunk.specularmap_fragment, THREE.ShaderChunk.lightmap_fragment, THREE.ShaderChunk.color_fragment,
			"#ifdef USE_ENVMAP\nvec2 texCoord = gl_FragCoord.xy / vec2( viewWidth, viewHeight );\nvec4 normalDepth = texture2D( samplerNormalDepth, texCoord );\nvec3 normal = normalDepth.xyz * 2.0 - 1.0;\nvec3 reflectVec;\nvec3 cameraToVertex = normalize( vWorldPosition - cameraPosition );\nif ( useRefract ) {\nreflectVec = refract( cameraToVertex, normal, refractionRatio );\n} else { \nreflectVec = reflect( cameraToVertex, normal );\n}\n#ifdef DOUBLE_SIDED\nfloat flipNormal = ( -1.0 + 2.0 * float( gl_FrontFacing ) );\nvec4 cubeColor = textureCube( envMap, flipNormal * vec3( flipEnvMap * reflectVec.x, reflectVec.yz ) );\n#else\nvec4 cubeColor = textureCube( envMap, vec3( flipEnvMap * reflectVec.x, reflectVec.yz ) );\n#endif\n#ifdef GAMMA_INPUT\ncubeColor.xyz *= cubeColor.xyz;\n#endif\nif ( combine == 1 ) {\ngl_FragColor.xyz = mix( gl_FragColor.xyz, cubeColor.xyz, specularStrength * reflectivity );\n} else if ( combine == 2 ) {\ngl_FragColor.xyz += cubeColor.xyz * specularStrength * reflectivity;\n} else {\ngl_FragColor.xyz = mix( gl_FragColor.xyz, gl_FragColor.xyz * cubeColor.xyz, specularStrength * reflectivity );\n}\n#endif",
		THREE.ShaderChunk.shadowmap_fragment, THREE.ShaderChunk.fog_fragment, "const float compressionScale = 0.999;\nvec3 diffuseMapColor;\n#ifdef USE_MAP\ndiffuseMapColor = texelColor.xyz;\n#else\ndiffuseMapColor = vec3( 1.0 );\n#endif\ngl_FragColor.x = vec3_to_float( compressionScale * gl_FragColor.xyz );\nif ( additiveSpecular < 0.0 ) {\ngl_FragColor.y = vec3_to_float( compressionScale * specular );\n} else {\ngl_FragColor.y = vec3_to_float( compressionScale * specular * diffuseMapColor );\n}\ngl_FragColor.y *= additiveSpecular;\ngl_FragColor.z = wrapAround * shininess;\n#ifdef USE_COLOR\ngl_FragColor.w = vec3_to_float( compressionScale * emissive * diffuseMapColor * vColor );\n#else\ngl_FragColor.w = vec3_to_float( compressionScale * emissive * diffuseMapColor );\n#endif\n}"].join("\n"),
		vertexShader: [THREE.ShaderChunk.map_pars_vertex, THREE.ShaderChunk.lightmap_pars_vertex, THREE.ShaderChunk.color_pars_vertex, THREE.ShaderChunk.morphtarget_pars_vertex, THREE.ShaderChunk.skinning_pars_vertex, THREE.ShaderChunk.shadowmap_pars_vertex, "#ifdef USE_ENVMAP\nvarying vec3 vWorldPosition;\n#endif\nvoid main() {", THREE.ShaderChunk.map_vertex, THREE.ShaderChunk.lightmap_vertex, THREE.ShaderChunk.color_vertex, THREE.ShaderChunk.skinbase_vertex, THREE.ShaderChunk.morphtarget_vertex, THREE.ShaderChunk.skinning_vertex,
		THREE.ShaderChunk.default_vertex, THREE.ShaderChunk.worldpos_vertex, THREE.ShaderChunk.shadowmap_vertex, "#ifdef USE_ENVMAP\nvWorldPosition = worldPosition.xyz;\n#endif\n}"].join("\n")
	},
	normalDepth: {
		uniforms: {
			bumpMap: {
				type: "t",
				value: null
			},
			bumpScale: {
				type: "f",
				value: 1
			},
			offsetRepeat: {
				type: "v4",
				value: new THREE.Vector4(0, 0, 1, 1)
			}
		},
		fragmentShader: ["#ifdef USE_BUMPMAP\n#extension GL_OES_standard_derivatives : enable\n\nvarying vec2 vUv;\nvarying vec3 vViewPosition;", THREE.ShaderChunk.bumpmap_pars_fragment, "#endif\nvarying vec3 normalView;\nvarying vec4 clipPos;\nvoid main() {\nvec3 normal = normalize( normalView );\n#ifdef USE_BUMPMAP\nnormal = perturbNormalArb( -vViewPosition, normal, dHdxy_fwd() );\n#endif\ngl_FragColor.xyz = normal * 0.5 + 0.5;\ngl_FragColor.w = clipPos.z / clipPos.w;\n}"].join("\n"),
		vertexShader: ["varying vec3 normalView;\nvarying vec4 clipPos;\n#ifdef USE_BUMPMAP\nvarying vec2 vUv;\nvarying vec3 vViewPosition;\nuniform vec4 offsetRepeat;\n#endif", THREE.ShaderChunk.morphtarget_pars_vertex, THREE.ShaderChunk.skinning_pars_vertex, "void main() {", THREE.ShaderChunk.morphnormal_vertex, THREE.ShaderChunk.skinbase_vertex, THREE.ShaderChunk.skinnormal_vertex, THREE.ShaderChunk.defaultnormal_vertex, THREE.ShaderChunk.morphtarget_vertex, THREE.ShaderChunk.skinning_vertex, THREE.ShaderChunk.default_vertex,
			"normalView = normalize( normalMatrix * objectNormal );\n#ifdef USE_BUMPMAP\nvUv = uv * offsetRepeat.zw + offsetRepeat.xy;\nvViewPosition = -mvPosition.xyz;\n#endif\nclipPos = gl_Position;\n}"].join("\n")
	},
	depth: {
		uniforms: {
			slopeScale: {
				type: "f",
				value: 2
			},
			slopeBias: {
				type: "f",
				value: 0
			},
			slopeMax: {
				type: "f",
				value: 0.001
			}
		},
		fragmentShader: "#ifdef SLOPE_DEPTH_BIAS\n#extension GL_OES_standard_derivatives : enable\n\nuniform float slopeScale;\nuniform float slopeBias;\nuniform float slopeMax;\n#endif\nvarying vec4 clipPos;\nvoid main() {\nfloat depth = clipPos.z / clipPos.w;\n#ifdef SLOPE_DEPTH_BIAS\nfloat dx = dFdx( depth );\nfloat dy = dFdy( depth );\nfloat m = max( abs(dx), abs(dy) );\nm = min( m, slopeMax );\ngl_FragColor.x = depth + m * slopeScale + slopeBias;\n#else\ngl_FragColor.x = depth;\n#endif\n}",
		vertexShader: ["varying vec4 clipPos;", THREE.ShaderChunk.morphtarget_pars_vertex, THREE.ShaderChunk.skinning_pars_vertex, "void main() {", THREE.ShaderChunk.skinbase_vertex, THREE.ShaderChunk.morphtarget_vertex, THREE.ShaderChunk.skinning_vertex, THREE.ShaderChunk.default_vertex, "clipPos = gl_Position;\n}"].join("\n")
	},
	pointLight: {
		uniforms: {
			samplerNormalDepth: {
				type: "t",
				value: null
			},
			samplerColor: {
				type: "t",
				value: null
			},
			matProjInverse: {
				type: "m4",
				value: new THREE.Matrix4
			},
			viewWidth: {
				type: "f",
				value: 800
			},
			viewHeight: {
				type: "f",
				value: 600
			},
			lightPositionVS: {
				type: "v3",
				value: new THREE.Vector3(0, 0, 0)
			},
			lightColor: {
				type: "c",
				value: new THREE.Color(0)
			},
			lightIntensity: {
				type: "f",
				value: 1
			},
			lightRadius: {
				type: "f",
				value: 1
			},
			matViewInverse: {
				type: "m4",
				value: new THREE.Matrix4
			},
			matLightView: {
				type: "m4v",
				value: []
			},
			matLightProj: {
				type: "m4v",
				value: []
			},
			samplerShadowMap: {
				type: "tv",
				value: []
			},
			shadowMapSize: {
				type: "v2",
				value: new THREE.Vector2(512, 512)
			},
			shadowDarkness: {
				type: "f",
				value: 0.5
			},
			shadowBias: {
				type: "f",
				value: 0
			}
		},
		fragmentShader: ["uniform sampler2D samplerColor;\nuniform sampler2D samplerNormalDepth;\nuniform float lightRadius;\nuniform float lightIntensity;\nuniform float viewHeight;\nuniform float viewWidth;\nuniform vec3 lightColor;\nuniform vec3 lightPositionVS;\nuniform mat4 matProjInverse;\n#ifdef USE_SHADOWMAP\nuniform mat4 matViewInverse;\nuniform mat4 matLightView[ 6 ];\nuniform mat4 matLightProj[ 6 ];\nuniform sampler2D samplerShadowMap[ 6 ];\nuniform float shadowBias;\nuniform float shadowDarkness;\nuniform vec2 shadowMapSize;\n#endif",
		THREE.DeferredShaderChunk.unpackFloat, "void main() {", THREE.DeferredShaderChunk.computeVertexPositionVS, "vec3 lightVector = lightPositionVS - vertexPositionVS.xyz;\nfloat distance = length( lightVector );\nif ( distance > lightRadius ) discard;", THREE.DeferredShaderChunk.computeNormal, THREE.DeferredShaderChunk.unpackColorMap, "lightVector = normalize( lightVector );", THREE.DeferredShaderChunk.computeDiffuse, THREE.DeferredShaderChunk.computeSpecular, "float cutoff = 0.3;\nfloat denom = distance / lightRadius + 1.0;\nfloat attenuation = 1.0 / ( denom * denom );\nattenuation = ( attenuation - cutoff ) / ( 1.0 - cutoff );\nattenuation = max( attenuation, 0.0 );\nattenuation *= attenuation;\nfloat totalOcclusion = 1.0;\n#ifdef USE_SHADOWMAP\nvec4 posWS = matViewInverse * vertexPositionVS;\nfor ( int i = 0; i < 6; i ++ ) {\nfloat occlusion = 1.0;\nvec4 posLightCS = matLightProj[ i ] * matLightView[ i ] * posWS;\nvec2 shadowCoord = ( posLightCS.xy / posLightCS.w ) * 0.5 + 0.5;\nbvec4 inFrustumVec = bvec4 ( shadowCoord.x >= 0.0, shadowCoord.x <= 1.0, shadowCoord.y >= 0.0, shadowCoord.y <= 1.0 );\nbool inFrustum = all( inFrustumVec );\nif ( inFrustum ) {\n#ifdef SLOPE_DEPTH_BIAS\nfloat vertexDepth = posLightCS.z / posLightCS.w;\n#else\nfloat vertexDepth = posLightCS.z / posLightCS.w - shadowBias;\n#endif\nfloat shadowDepth;\n#if defined( SHADOWMAP_TYPE_PCF )\nfloat shadowValue = 0.0;\nconst float shadowDelta = 1.0 / 9.0;\nfloat xPixelOffset = 1.0 / shadowMapSize.x;\nfloat yPixelOffset = 1.0 / shadowMapSize.y;\nfloat dx0 = -1.25 * xPixelOffset;\nfloat dy0 = -1.25 * yPixelOffset;\nfloat dx1 = 1.25 * xPixelOffset;\nfloat dy1 = 1.25 * yPixelOffset;\nshadowDepth = texture2D( samplerShadowMap[ i ], shadowCoord + vec2( dx0, dy0 ) ).x;\nif ( vertexDepth > shadowDepth ) shadowValue += shadowDelta;\nshadowDepth = texture2D( samplerShadowMap[ i ], shadowCoord + vec2( 0.0, dy0 ) ).x;\nif ( vertexDepth > shadowDepth ) shadowValue += shadowDelta;\nshadowDepth = texture2D( samplerShadowMap[ i ], shadowCoord + vec2( dx1, dy0 ) ).x;\nif ( vertexDepth > shadowDepth ) shadowValue += shadowDelta;\nshadowDepth = texture2D( samplerShadowMap[ i ], shadowCoord + vec2( dx0, 0.0 ) ).x;\nif ( vertexDepth > shadowDepth ) shadowValue += shadowDelta;\nshadowDepth = texture2D( samplerShadowMap[ i ], shadowCoord ).x;\nif ( vertexDepth > shadowDepth ) shadowValue += shadowDelta;\nshadowDepth = texture2D( samplerShadowMap[ i ], shadowCoord + vec2( dx1, 0.0 ) ).x;\nif ( vertexDepth > shadowDepth ) shadowValue += shadowDelta;\nshadowDepth = texture2D( samplerShadowMap[ i ], shadowCoord + vec2( dx0, dy1 ) ).x;\nif ( vertexDepth > shadowDepth) shadowValue += shadowDelta;\nshadowDepth = texture2D( samplerShadowMap[ i ], shadowCoord + vec2( 0.0, dy1 ) ).x;\nif ( vertexDepth > shadowDepth ) shadowValue += shadowDelta;\nshadowDepth = texture2D( samplerShadowMap[ i ], shadowCoord + vec2( dx1, dy1 ) ).x;\nif ( vertexDepth > shadowDepth ) shadowValue += shadowDelta;\nocclusion = 1.0 - shadowDarkness * shadowValue;\n#elif defined( SHADOWMAP_TYPE_PCF_SOFT )\nfloat shadow = 0.0;\nfloat xPixelOffset = 1.0 / shadowMapSize.x;\nfloat yPixelOffset = 1.0 / shadowMapSize.y;\nfloat dx0 = -1.0 * xPixelOffset;\nfloat dy0 = -1.0 * yPixelOffset;\nfloat dx1 = 1.0 * xPixelOffset;\nfloat dy1 = 1.0 * yPixelOffset;\nmat3 shadowKernel;\nshadowDepth = texture2D( samplerShadowMap[ i ], shadowCoord + vec2( dx0, dy0 ) ).x;\nif ( vertexDepth > shadowDepth ) shadowKernel[0][0] = 0.25;\nelse shadowKernel[0][0] = 0.0;\nshadowDepth = texture2D( samplerShadowMap[ i ], shadowCoord + vec2( dx0, 0.0 ) ).x;\nif ( vertexDepth > shadowDepth ) shadowKernel[0][1] = 0.25;\nelse shadowKernel[0][1] = 0.0;\nshadowDepth = texture2D( samplerShadowMap[ i ], shadowCoord + vec2( dx0, dy1 ) ).x;\nif ( vertexDepth > shadowDepth ) shadowKernel[0][2] = 0.25;\nelse shadowKernel[0][2] = 0.0;\nshadowDepth = texture2D( samplerShadowMap[ i ], shadowCoord + vec2( 0.0, dy0 ) ).x;\nif ( vertexDepth > shadowDepth ) shadowKernel[1][0] = 0.25;\nelse shadowKernel[1][0] = 0.0;\nshadowDepth = texture2D( samplerShadowMap[ i ], shadowCoord ).x;\nif ( vertexDepth > shadowDepth ) shadowKernel[1][1] = 0.25;\nelse shadowKernel[1][1] = 0.0;\nshadowDepth = texture2D( samplerShadowMap[ i ], shadowCoord + vec2( 0.0, dy1 ) ).x;\nif ( vertexDepth > shadowDepth ) shadowKernel[1][2] = 0.25;\nelse shadowKernel[1][2] = 0.0;\nshadowDepth = texture2D( samplerShadowMap[ i ], shadowCoord + vec2( dx1, dy0 ) ).x;\nif ( vertexDepth > shadowDepth ) shadowKernel[2][0] = 0.25;\nelse shadowKernel[2][0] = 0.0;\nshadowDepth = texture2D( samplerShadowMap[ i ], shadowCoord + vec2( dx1, 0.0 ) ).x;\nif ( vertexDepth > shadowDepth ) shadowKernel[2][1] = 0.25;\nelse shadowKernel[2][1] = 0.0;\nshadowDepth = texture2D( samplerShadowMap[ i ], shadowCoord + vec2( dx1, dy1 ) ).x;\nif ( vertexDepth > shadowDepth ) shadowKernel[2][2] = 0.25;\nelse shadowKernel[2][2] = 0.0;\nvec2 fractionalCoord = 1.0 - fract( shadowCoord * shadowMapSize );\nshadowKernel[0] = mix( shadowKernel[1], shadowKernel[0], fractionalCoord.x );\nshadowKernel[1] = mix( shadowKernel[2], shadowKernel[1], fractionalCoord.x );\nvec4 shadowValues;\nshadowValues.x = mix( shadowKernel[0][1], shadowKernel[0][0], fractionalCoord.y );\nshadowValues.y = mix( shadowKernel[0][2], shadowKernel[0][1], fractionalCoord.y );\nshadowValues.z = mix( shadowKernel[1][1], shadowKernel[1][0], fractionalCoord.y );\nshadowValues.w = mix( shadowKernel[1][2], shadowKernel[1][1], fractionalCoord.y );\nfloat shadowValue = dot( shadowValues, vec4( 1.0 ) );\nocclusion = 1.0 - shadowDarkness * shadowValue;\n#else\nshadowDepth = texture2D( samplerShadowMap[ i ], shadowCoord ).x;\nif ( vertexDepth > shadowDepth ) occlusion = 1.0 - shadowDarkness;\n#endif\ntotalOcclusion *= occlusion;\n}\n}\n#endif\nattenuation *= totalOcclusion;",
		THREE.DeferredShaderChunk.combine, "}"].join("\n"),
		vertexShader: "void main() { \nvec4 mvPosition = modelViewMatrix * vec4( position, 1.0 );\ngl_Position = projectionMatrix * mvPosition;\n}"
	},
	spotLight: {
		uniforms: {
			samplerNormalDepth: {
				type: "t",
				value: null
			},
			samplerColor: {
				type: "t",
				value: null
			},
			matProjInverse: {
				type: "m4",
				value: new THREE.Matrix4
			},
			viewWidth: {
				type: "f",
				value: 800
			},
			viewHeight: {
				type: "f",
				value: 600
			},
			lightPositionVS: {
				type: "v3",
				value: new THREE.Vector3(0, 1, 0)
			},
			lightDirectionVS: {
				type: "v3",
				value: new THREE.Vector3(0,
				1, 0)
			},
			lightColor: {
				type: "c",
				value: new THREE.Color(0)
			},
			lightIntensity: {
				type: "f",
				value: 1
			},
			lightDistance: {
				type: "f",
				value: 1
			},
			lightAngle: {
				type: "f",
				value: 1
			},
			matViewInverse: {
				type: "m4",
				value: new THREE.Matrix4
			},
			matLightView: {
				type: "m4",
				value: new THREE.Matrix4
			},
			matLightProj: {
				type: "m4",
				value: new THREE.Matrix4
			},
			samplerShadowMap: {
				type: "t",
				value: null
			},
			shadowMapSize: {
				type: "v2",
				value: new THREE.Vector2(512, 512)
			},
			shadowDarkness: {
				type: "f",
				value: 0.5
			},
			shadowBias: {
				type: "f",
				value: 0
			}
		},
		fragmentShader: ["uniform vec3 lightPositionVS;\nuniform vec3 lightDirectionVS;\nuniform sampler2D samplerColor;\nuniform sampler2D samplerNormalDepth;\nuniform float viewHeight;\nuniform float viewWidth;\nuniform float lightAngle;\nuniform float lightIntensity;\nuniform vec3 lightColor;\nuniform mat4 matProjInverse;\n#ifdef USE_SHADOWMAP\nuniform mat4 matViewInverse;\nuniform mat4 matLightView;\nuniform mat4 matLightProj;\nuniform sampler2D samplerShadowMap;\nuniform float shadowBias;\nuniform float shadowDarkness;\nuniform vec2 shadowMapSize;\n#endif",
		THREE.DeferredShaderChunk.unpackFloat, "void main() {", THREE.DeferredShaderChunk.computeVertexPositionVS, THREE.DeferredShaderChunk.computeNormal, THREE.DeferredShaderChunk.unpackColorMap, "vec3 lightVector = normalize( lightPositionVS.xyz - vertexPositionVS.xyz );\nfloat rho = dot( lightDirectionVS, lightVector );\nfloat rhoMax = cos( lightAngle * 0.5 );\nif ( rho <= rhoMax ) discard;\nfloat theta = rhoMax + 0.0001;\nfloat phi = rhoMax + 0.05;\nfloat falloff = 4.0;\nfloat spot = 0.0;\nif ( rho >= phi ) {\nspot = 1.0;\n} else if ( rho <= theta ) {\nspot = 0.0;\n} else { \nspot = pow( ( rho - theta ) / ( phi - theta ), falloff );\n}",
		THREE.DeferredShaderChunk.computeDiffuse, "diffuse *= spot;", THREE.DeferredShaderChunk.computeSpecular, "float occlusion = 1.0;\n#ifdef USE_SHADOWMAP\nvec4 posWS = matViewInverse * vertexPositionVS;\nvec4 posLightCS = matLightProj * matLightView * posWS;\nvec2 shadowCoord = ( posLightCS.xy / posLightCS.w ) * 0.5 + 0.5;\n#ifdef SLOPE_DEPTH_BIAS\nfloat vertexDepth = posLightCS.z / posLightCS.w;\n#else\nfloat vertexDepth = posLightCS.z / posLightCS.w - shadowBias;\n#endif\nfloat shadowDepth;\n#if defined( SHADOWMAP_TYPE_PCF )\nfloat shadowValue = 0.0;\nconst float shadowDelta = 1.0 / 9.0;\nfloat xPixelOffset = 1.0 / shadowMapSize.x;\nfloat yPixelOffset = 1.0 / shadowMapSize.y;\nfloat dx0 = -1.25 * xPixelOffset;\nfloat dy0 = -1.25 * yPixelOffset;\nfloat dx1 = 1.25 * xPixelOffset;\nfloat dy1 = 1.25 * yPixelOffset;\nshadowDepth = texture2D( samplerShadowMap, shadowCoord + vec2( dx0, dy0 ) ).x;\nif ( vertexDepth > shadowDepth ) shadowValue += shadowDelta;\nshadowDepth = texture2D( samplerShadowMap, shadowCoord + vec2( 0.0, dy0 ) ).x;\nif ( vertexDepth > shadowDepth ) shadowValue += shadowDelta;\nshadowDepth = texture2D( samplerShadowMap, shadowCoord + vec2( dx1, dy0 ) ).x;\nif ( vertexDepth > shadowDepth ) shadowValue += shadowDelta;\nshadowDepth = texture2D( samplerShadowMap, shadowCoord + vec2( dx0, 0.0 ) ).x;\nif ( vertexDepth > shadowDepth ) shadowValue += shadowDelta;\nshadowDepth = texture2D( samplerShadowMap, shadowCoord ).x;\nif ( vertexDepth > shadowDepth ) shadowValue += shadowDelta;\nshadowDepth = texture2D( samplerShadowMap, shadowCoord + vec2( dx1, 0.0 ) ).x;\nif ( vertexDepth > shadowDepth ) shadowValue += shadowDelta;\nshadowDepth = texture2D( samplerShadowMap, shadowCoord + vec2( dx0, dy1 ) ).x;\nif ( vertexDepth > shadowDepth) shadowValue += shadowDelta;\nshadowDepth = texture2D( samplerShadowMap, shadowCoord + vec2( 0.0, dy1 ) ).x;\nif ( vertexDepth > shadowDepth ) shadowValue += shadowDelta;\nshadowDepth = texture2D( samplerShadowMap, shadowCoord + vec2( dx1, dy1 ) ).x;\nif ( vertexDepth > shadowDepth ) shadowValue += shadowDelta;\nocclusion = 1.0 - shadowDarkness * shadowValue;\n#elif defined( SHADOWMAP_TYPE_PCF_SOFT )\nfloat shadow = 0.0;\nfloat xPixelOffset = 1.0 / shadowMapSize.x;\nfloat yPixelOffset = 1.0 / shadowMapSize.y;\nfloat dx0 = -1.0 * xPixelOffset;\nfloat dy0 = -1.0 * yPixelOffset;\nfloat dx1 = 1.0 * xPixelOffset;\nfloat dy1 = 1.0 * yPixelOffset;\nmat3 shadowKernel;\nshadowDepth = texture2D( samplerShadowMap, shadowCoord + vec2( dx0, dy0 ) ).x;\nif ( vertexDepth > shadowDepth ) shadowKernel[0][0] = 0.25;\nelse shadowKernel[0][0] = 0.0;\nshadowDepth = texture2D( samplerShadowMap, shadowCoord + vec2( dx0, 0.0 ) ).x;\nif ( vertexDepth > shadowDepth ) shadowKernel[0][1] = 0.25;\nelse shadowKernel[0][1] = 0.0;\nshadowDepth = texture2D( samplerShadowMap, shadowCoord + vec2( dx0, dy1 ) ).x;\nif ( vertexDepth > shadowDepth ) shadowKernel[0][2] = 0.25;\nelse shadowKernel[0][2] = 0.0;\nshadowDepth = texture2D( samplerShadowMap, shadowCoord + vec2( 0.0, dy0 ) ).x;\nif ( vertexDepth > shadowDepth ) shadowKernel[1][0] = 0.25;\nelse shadowKernel[1][0] = 0.0;\nshadowDepth = texture2D( samplerShadowMap, shadowCoord ).x;\nif ( vertexDepth > shadowDepth ) shadowKernel[1][1] = 0.25;\nelse shadowKernel[1][1] = 0.0;\nshadowDepth = texture2D( samplerShadowMap, shadowCoord + vec2( 0.0, dy1 ) ).x;\nif ( vertexDepth > shadowDepth ) shadowKernel[1][2] = 0.25;\nelse shadowKernel[1][2] = 0.0;\nshadowDepth = texture2D( samplerShadowMap, shadowCoord + vec2( dx1, dy0 ) ).x;\nif ( vertexDepth > shadowDepth ) shadowKernel[2][0] = 0.25;\nelse shadowKernel[2][0] = 0.0;\nshadowDepth = texture2D( samplerShadowMap, shadowCoord + vec2( dx1, 0.0 ) ).x;\nif ( vertexDepth > shadowDepth ) shadowKernel[2][1] = 0.25;\nelse shadowKernel[2][1] = 0.0;\nshadowDepth = texture2D( samplerShadowMap, shadowCoord + vec2( dx1, dy1 ) ).x;\nif ( vertexDepth > shadowDepth ) shadowKernel[2][2] = 0.25;\nelse shadowKernel[2][2] = 0.0;\nvec2 fractionalCoord = 1.0 - fract( shadowCoord * shadowMapSize );\nshadowKernel[0] = mix( shadowKernel[1], shadowKernel[0], fractionalCoord.x );\nshadowKernel[1] = mix( shadowKernel[2], shadowKernel[1], fractionalCoord.x );\nvec4 shadowValues;\nshadowValues.x = mix( shadowKernel[0][1], shadowKernel[0][0], fractionalCoord.y );\nshadowValues.y = mix( shadowKernel[0][2], shadowKernel[0][1], fractionalCoord.y );\nshadowValues.z = mix( shadowKernel[1][1], shadowKernel[1][0], fractionalCoord.y );\nshadowValues.w = mix( shadowKernel[1][2], shadowKernel[1][1], fractionalCoord.y );\nfloat shadowValue = dot( shadowValues, vec4( 1.0 ) );\nocclusion = 1.0 - shadowDarkness * shadowValue;\n#else\nshadowDepth = texture2D( samplerShadowMap, shadowCoord ).x;\nif ( vertexDepth > shadowDepth ) occlusion = 1.0 - shadowDarkness;\n#endif\n#endif\nfloat attenuation = occlusion;",
		THREE.DeferredShaderChunk.combine, "}"].join("\n"),
		vertexShader: "void main() { \ngl_Position = vec4( sign( position.xy ), 0.0, 1.0 );\n}"
	},
	directionalLight: {
		uniforms: {
			samplerNormalDepth: {
				type: "t",
				value: null
			},
			samplerColor: {
				type: "t",
				value: null
			},
			matProjInverse: {
				type: "m4",
				value: new THREE.Matrix4
			},
			viewWidth: {
				type: "f",
				value: 800
			},
			viewHeight: {
				type: "f",
				value: 600
			},
			lightDirectionVS: {
				type: "v3",
				value: new THREE.Vector3(0, 1, 0)
			},
			lightColor: {
				type: "c",
				value: new THREE.Color(0)
			},
			lightIntensity: {
				type: "f",
				value: 1
			}
		},
		fragmentShader: ["uniform sampler2D samplerColor;\nuniform sampler2D samplerNormalDepth;\nuniform float lightRadius;\nuniform float lightIntensity;\nuniform float viewHeight;\nuniform float viewWidth;\nuniform vec3 lightColor;\nuniform vec3 lightDirectionVS;\nuniform mat4 matProjInverse;",
		THREE.DeferredShaderChunk.unpackFloat, "void main() {", THREE.DeferredShaderChunk.computeVertexPositionVS, THREE.DeferredShaderChunk.computeNormal, THREE.DeferredShaderChunk.unpackColorMap, "vec3 lightVector = lightDirectionVS;", THREE.DeferredShaderChunk.computeDiffuse, THREE.DeferredShaderChunk.computeSpecular, "const float attenuation = 1.0;", THREE.DeferredShaderChunk.combine, "}"].join("\n"),
		vertexShader: "void main() { \ngl_Position = vec4( sign( position.xy ), 0.0, 1.0 );\n}"
	},
	hemisphereLight: {
		uniforms: {
			samplerNormalDepth: {
				type: "t",
				value: null
			},
			samplerColor: {
				type: "t",
				value: null
			},
			matProjInverse: {
				type: "m4",
				value: new THREE.Matrix4
			},
			viewWidth: {
				type: "f",
				value: 800
			},
			viewHeight: {
				type: "f",
				value: 600
			},
			lightDirectionVS: {
				type: "v3",
				value: new THREE.Vector3(0, 1, 0)
			},
			lightColorSky: {
				type: "c",
				value: new THREE.Color(0)
			},
			lightColorGround: {
				type: "c",
				value: new THREE.Color(0)
			},
			lightIntensity: {
				type: "f",
				value: 1
			}
		},
		fragmentShader: ["uniform sampler2D samplerColor;\nuniform sampler2D samplerNormalDepth;\nuniform float lightRadius;\nuniform float lightIntensity;\nuniform float viewHeight;\nuniform float viewWidth;\nuniform vec3 lightColorSky;\nuniform vec3 lightColorGround;\nuniform vec3 lightDirectionVS;\nuniform mat4 matProjInverse;",
		THREE.DeferredShaderChunk.unpackFloat, "void main() {", THREE.DeferredShaderChunk.computeVertexPositionVS, THREE.DeferredShaderChunk.computeNormal, THREE.DeferredShaderChunk.unpackColorMap, "vec3 lightVector = lightDirectionVS;\nfloat dotProduct = dot( normal, lightVector );\nfloat hemiDiffuseWeight = 0.5 * dotProduct + 0.5;\nvec3 hemiColor = mix( lightColorGround, lightColorSky, hemiDiffuseWeight );\nvec3 diffuse = hemiColor;\nvec3 hemiHalfVectorSky = normalize( lightVector - vertexPositionVS.xyz );\nfloat hemiDotNormalHalfSky = 0.5 * dot( normal, hemiHalfVectorSky ) + 0.5;\nfloat hemiSpecularWeightSky = max( pow( hemiDotNormalHalfSky, shininess ), 0.0 );\nvec3 lVectorGround = -lightVector;\nvec3 hemiHalfVectorGround = normalize( lVectorGround - vertexPositionVS.xyz );\nfloat hemiDotNormalHalfGround = 0.5 * dot( normal, hemiHalfVectorGround ) + 0.5;\nfloat hemiSpecularWeightGround = max( pow( hemiDotNormalHalfGround, shininess ), 0.0 );\nfloat dotProductGround = dot( normal, lVectorGround );\nfloat specularNormalization = ( shininess + 2.0001 ) / 8.0;\nvec3 schlickSky = specularColor + vec3( 1.0 - specularColor ) * pow( 1.0 - dot( lightVector, hemiHalfVectorSky ), 5.0 );\nvec3 schlickGround = specularColor + vec3( 1.0 - specularColor ) * pow( 1.0 - dot( lVectorGround, hemiHalfVectorGround ), 5.0 );\nvec3 specular = hemiColor * specularNormalization * ( schlickSky * hemiSpecularWeightSky * max( dotProduct, 0.0 ) + schlickGround * hemiSpecularWeightGround * max( dotProductGround, 0.0 ) );\ngl_FragColor = vec4( lightIntensity * ( albedo * diffuse + specular ), 1.0 );\n}"].join("\n"),
		vertexShader: "void main() { \ngl_Position = vec4( sign( position.xy ), 0.0, 1.0 );\n}"
	},
	areaLight: {
		uniforms: {
			samplerNormalDepth: {
				type: "t",
				value: null
			},
			samplerColor: {
				type: "t",
				value: null
			},
			matProjInverse: {
				type: "m4",
				value: new THREE.Matrix4
			},
			viewWidth: {
				type: "f",
				value: 800
			},
			viewHeight: {
				type: "f",
				value: 600
			},
			lightPositionVS: {
				type: "v3",
				value: new THREE.Vector3(0, 1, 0)
			},
			lightNormalVS: {
				type: "v3",
				value: new THREE.Vector3(0, -1, 0)
			},
			lightRightVS: {
				type: "v3",
				value: new THREE.Vector3(1, 0, 0)
			},
			lightUpVS: {
				type: "v3",
				value: new THREE.Vector3(1,
				0, 0)
			},
			lightColor: {
				type: "c",
				value: new THREE.Color(0)
			},
			lightIntensity: {
				type: "f",
				value: 1
			},
			lightWidth: {
				type: "f",
				value: 1
			},
			lightHeight: {
				type: "f",
				value: 1
			},
			constantAttenuation: {
				type: "f",
				value: 1.5
			},
			linearAttenuation: {
				type: "f",
				value: 0.5
			},
			quadraticAttenuation: {
				type: "f",
				value: 0.1
			}
		},
		fragmentShader: ["uniform vec3 lightPositionVS;\nuniform vec3 lightNormalVS;\nuniform vec3 lightRightVS;\nuniform vec3 lightUpVS;\nuniform sampler2D samplerColor;\nuniform sampler2D samplerNormalDepth;\nuniform float lightWidth;\nuniform float lightHeight;\nuniform float constantAttenuation;\nuniform float linearAttenuation;\nuniform float quadraticAttenuation;\nuniform float lightIntensity;\nuniform vec3 lightColor;\nuniform float viewHeight;\nuniform float viewWidth;\nuniform mat4 matProjInverse;",
		THREE.DeferredShaderChunk.unpackFloat, "vec3 projectOnPlane( vec3 point, vec3 planeCenter, vec3 planeNorm ) {\nreturn point - dot( point - planeCenter, planeNorm ) * planeNorm;\n}\nbool sideOfPlane( vec3 point, vec3 planeCenter, vec3 planeNorm ) {\nreturn ( dot( point - planeCenter, planeNorm ) >= 0.0 );\n}\nvec3 linePlaneIntersect( vec3 lp, vec3 lv, vec3 pc, vec3 pn ) {\nreturn lp + lv * ( dot( pn, pc - lp ) / dot( pn, lv ) );\n}\nfloat calculateAttenuation( float dist ) {\nreturn ( 1.0 / ( constantAttenuation + linearAttenuation * dist + quadraticAttenuation * dist * dist ) );\n}\nvoid main() {",
		THREE.DeferredShaderChunk.computeVertexPositionVS, THREE.DeferredShaderChunk.computeNormal, THREE.DeferredShaderChunk.unpackColorMap, "float w = lightWidth;\nfloat h = lightHeight;\nvec3 proj = projectOnPlane( vertexPositionVS.xyz, lightPositionVS, lightNormalVS );\nvec3 dir = proj - lightPositionVS;\nvec2 diagonal = vec2( dot( dir, lightRightVS ), dot( dir, lightUpVS ) );\nvec2 nearest2D = vec2( clamp( diagonal.x, -w, w ), clamp( diagonal.y, -h, h ) );\nvec3 nearestPointInside = vec3( lightPositionVS ) + ( lightRightVS * nearest2D.x + lightUpVS * nearest2D.y );\nvec3 lightDir = normalize( nearestPointInside - vertexPositionVS.xyz );\nfloat NdotL = max( dot( lightNormalVS, -lightDir ), 0.0 );\nfloat NdotL2 = max( dot( normal, lightDir ), 0.0 );\nif ( NdotL2 * NdotL > 0.0 ) {\nvec3 diffuse = vec3( sqrt( NdotL * NdotL2 ) );\nvec3 specular = vec3( 0.0 );\nvec3 R = reflect( normalize( -vertexPositionVS.xyz ), normal );\nvec3 E = linePlaneIntersect( vertexPositionVS.xyz, R, vec3( lightPositionVS ), lightNormalVS );\nfloat specAngle = dot( R, lightNormalVS );\nif ( specAngle > 0.0 ) {\nvec3 dirSpec = E - vec3( lightPositionVS );\nvec2 dirSpec2D = vec2( dot( dirSpec, lightRightVS ), dot( dirSpec, lightUpVS ) );\nvec2 nearestSpec2D = vec2( clamp( dirSpec2D.x, -w, w ), clamp( dirSpec2D.y, -h, h ) );\nfloat specFactor = 1.0 - clamp( length( nearestSpec2D - dirSpec2D ) * 0.05 * shininess, 0.0, 1.0 );\nspecular = specularColor * specFactor * specAngle * diffuse;\n}\nfloat dist = distance( vertexPositionVS.xyz, nearestPointInside );\nfloat attenuation = calculateAttenuation( dist );",
		THREE.DeferredShaderChunk.combine, "} else {\ndiscard;\n}\n}"].join("\n"),
		vertexShader: "void main() {\ngl_Position = vec4( sign( position.xy ), 0.0, 1.0 );\n}"
	},
	emissiveLight: {
		uniforms: {
			samplerColor: {
				type: "t",
				value: null
			},
			viewWidth: {
				type: "f",
				value: 800
			},
			viewHeight: {
				type: "f",
				value: 600
			}
		},
		fragmentShader: ["uniform sampler2D samplerColor;\nuniform float viewHeight;\nuniform float viewWidth;", THREE.DeferredShaderChunk.unpackFloat, "void main() {\nvec2 texCoord = gl_FragCoord.xy / vec2( viewWidth, viewHeight );\nvec4 colorMap = texture2D( samplerColor, texCoord );\nvec3 emissiveColor = float_to_vec3( abs( colorMap.w ) );\ngl_FragColor = vec4( emissiveColor, 1.0 );\n}"].join("\n"),
		vertexShader: "void main() { \ngl_Position = vec4( sign( position.xy ), 0.0, 1.0 );\n}"
	},
	composite: {
		uniforms: {
			samplerLight: {
				type: "t",
				value: null
			},
			brightness: {
				type: "f",
				value: 1
			}
		},
		fragmentShader: "varying vec2 texCoord;\nuniform sampler2D samplerLight;\nuniform float brightness;\n#ifdef TONEMAP_UNCHARTED\nconst float A = 0.15;\nconst float B = 0.50;\nconst float C = 0.10;\nconst float D = 0.20;\nconst float E = 0.02;\nconst float F = 0.30;\nconst float W = 11.2;\nvec3 Uncharted2Tonemap( vec3 x ) {\nreturn ( ( x * ( A * x + C * B ) + D * E ) / ( x * ( A * x + B ) + D * F ) ) - E / F;\n}\n#endif\nvoid main() {\nvec3 inColor = texture2D( samplerLight, texCoord ).xyz;\ninColor *= brightness;\nvec3 outColor;\n#if defined( TONEMAP_SIMPLE )\noutColor = sqrt( inColor );\n#elif defined( TONEMAP_LINEAR )\noutColor = pow( inColor, vec3( 1.0 / 2.2 ) );\n#elif defined( TONEMAP_REINHARD )\ninColor = inColor / ( 1.0 + inColor );\noutColor = pow( inColor, vec3( 1.0 / 2.2 ) );\n#elif defined( TONEMAP_FILMIC )\nvec3 x = max( vec3( 0.0 ), inColor - 0.004 );\noutColor = ( x * ( 6.2 * x + 0.5 ) ) / ( x * ( 6.2 * x + 1.7 ) + 0.06 );\n#elif defined( TONEMAP_UNCHARTED )\nfloat ExposureBias = 2.0;\nvec3 curr = Uncharted2Tonemap( ExposureBias * inColor );\nvec3 whiteScale = vec3( 1.0 ) / Uncharted2Tonemap( vec3( W ) );\nvec3 color = curr * whiteScale;\noutColor = pow( color, vec3( 1.0 / 2.2 ) );\n#else\noutColor = inColor;\n#endif\ngl_FragColor = vec4( outColor, 1.0 );\n}",
		vertexShader: "varying vec2 texCoord;\nvoid main() {\nvec4 pos = vec4( sign( position.xy ), 0.0, 1.0 );\ntexCoord = pos.xy * vec2( 0.5 ) + 0.5;\ngl_Position = pos;\n}"
	}
};
var SPARKS = {
	Emitter: function (a) {
		this._counter = a ? a : new SPARKS.SteadyCounter(10);
		this._particles = [];
		this._initializers = [];
		this._actions = [];
		this._activities = [];
		this._handlers = [];
		this.callbacks = {}
	}
};
SPARKS.Emitter.prototype = {
	_TIMESTEP: 15,
	_timer: null,
	_lastTime: null,
	_timerStep: 10,
	_velocityVerlet: !0,
	start: function () {
		this._lastTime = Date.now();
		this._timer = setTimeout(this.step, this._timerStep, this);
		this._isRunning = !0
	},
	stop: function () {
		this._isRunning = !1;
		clearTimeout(this._timer)
	},
	isRunning: function () {
		return this._isRunning & 1
	},
	step: function (a) {
		var b = Date.now(),
			c = b - a._lastTime;
		if (this._velocityVerlet) a.update(c / 1E3), a._lastTime = b;
		else {
			var d = 20 * a._TIMESTEP;
			for (c >= d && (c = d); c >= a._TIMESTEP;) a.update(a._TIMESTEP / 1E3), c -= a._TIMESTEP;
			a._lastTime = b - c
		}
		a._isRunning && setTimeout(a.step, a._timerStep, a)
	},
	update: function (a) {
		var b, c, d = this._counter.updateEmitter(this, a);
		for (b = 0; b < d; b++) this.createParticle();
		d = this._activities.length;
		for (b = 0; b < d; b++) this._activities[b].update(this, a);
		var d = this._actions.length,
			e, f, g = this._particles.length;
		for (c = 0; c < d; c++) {
			f = this._actions[c];
			for (b = 0; b < g; ++b) e = this._particles[b], f.update(this, e, a)
		}
		for (b = g; b--;) e = this._particles[b], e.isDead ? (this._particles.splice(b, 1), this.dispatchEvent("dead",
		e), SPARKS.VectorPool.release(e.position), SPARKS.VectorPool.release(e.velocity)) : this.dispatchEvent("updated", e);
		this.dispatchEvent("loopUpdated")
	},
	createParticle: function () {
		var a = new SPARKS.Particle,
			b = this._initializers.length,
			c;
		for (c = 0; c < b; c++) this._initializers[c].initialize(this, a);
		this._particles.push(a);
		this.dispatchEvent("created", a);
		return a
	},
	addInitializer: function (a) {
		this._initializers.push(a)
	},
	addAction: function (a) {
		this._actions.push(a)
	},
	removeInitializer: function (a) {
		a = this._initializers.indexOf(a); - 1 < a && this._initializers.splice(a, 1)
	},
	removeAction: function (a) {
		a = this._actions.indexOf(a); - 1 < a && this._actions.splice(a, 1)
	},
	addCallback: function (a, b) {
		this.callbacks[a] = b
	},
	dispatchEvent: function (a, b) {
		var c = this.callbacks[a];
		c && c(b)
	}
};
SPARKS.EVENT_PARTICLE_CREATED = "created";
SPARKS.EVENT_PARTICLE_UPDATED = "updated";
SPARKS.EVENT_PARTICLE_DEAD = "dead";
SPARKS.EVENT_LOOP_UPDATED = "loopUpdated";
SPARKS.SteadyCounter = function (a) {
	this.rate = a;
	this.leftover = 0
};
SPARKS.SteadyCounter.prototype.updateEmitter = function (a, b) {
	var c = b * this.rate + this.leftover,
		d = Math.floor(c);
	this.leftover = c - d;
	return d
};
SPARKS.ShotCounter = function (a) {
	this.particles = a;
	this.used = !1
};
SPARKS.ShotCounter.prototype.updateEmitter = function () {
	if (this.used) return 0;
	this.used = !0;
	return this.particles
};
SPARKS.Particle = function () {
	this.age = this.lifetime = 0;
	this.energy = 1;
	this.isDead = !1;
	this.target = null;
	this.position = SPARKS.VectorPool.get().set(0, 0, 0);
	this.velocity = SPARKS.VectorPool.get().set(0, 0, 0);
	this._oldvelocity = SPARKS.VectorPool.get().set(0, 0, 0)
};
SPARKS.Action = function () {
	this._priority = 0
};
SPARKS.Age = function (a) {
	this._easing = null == a ? TWEEN.Easing.Linear.None : a
};
SPARKS.Age.prototype.update = function (a, b, c) {
	b.age += c;
	b.age >= b.lifetime ? (b.energy = 0, b.isDead = !0) : (a = this._easing(b.age / b.lifetime), b.energy = -1 * a + 1)
};
SPARKS.Move = function () {};
SPARKS.Move.prototype.update = function (a, b, c) {
	var a = b.position,
		d = b.velocity,
		b = b._oldvelocity;
	this._velocityVerlet ? (a.x += 0.5 * (d.x + b.x) * c, a.y += 0.5 * (d.y + b.y) * c, a.z += 0.5 * (d.z + b.z) * c) : (a.x += d.x * c, a.y += d.y * c, a.z += d.z * c)
};
SPARKS.DeathZone = function (a) {
	this.zone = a
};
SPARKS.DeathZone.prototype.update = function (a, b) {
	this.zone.contains(b.position) && (b.isDead = !0)
};
SPARKS.ActionZone = function (a, b) {
	this.action = a;
	this.zone = b
};
SPARKS.ActionZone.prototype.update = function (a, b, c) {
	this.zone.contains(b.position) && this.action.update(a, b, c)
};
SPARKS.Accelerate = function (a, b, c) {
	this.acceleration = a instanceof THREE.Vector3 ? a : new THREE.Vector3(a, b, c)
};
SPARKS.Accelerate.prototype.update = function (a, b, c) {
	var a = this.acceleration,
		d = b.velocity;
	b._oldvelocity.set(d.x, d.y, d.z);
	d.x += a.x * c;
	d.y += a.y * c;
	d.z += a.z * c
};
SPARKS.AccelerateFactor = function (a) {
	this.factor = a
};
SPARKS.AccelerateFactor.prototype.update = function (a, b, c) {
	var a = this.factor,
		b = b.velocity,
		d = b.length();
	0 < d && (c = a * c / d + 1, b.multiplyScalar(c))
};
SPARKS.AccelerateVelocity = function (a) {
	this.factor = a
};
SPARKS.AccelerateVelocity.prototype.update = function (a, b) {
	var c = this.factor,
		d = b.velocity;
	d.z += -d.x * c;
	d.y += d.z * c;
	d.x += d.y * c
};
SPARKS.RandomDrift = function (a, b, c) {
	this.drift = a instanceof THREE.Vector3 ? a : new THREE.Vector3(a, b, c)
};
SPARKS.RandomDrift.prototype.update = function (a, b, c) {
	a = this.drift;
	b = b.velocity;
	b.x += (Math.random() - 0.5) * a.x * c;
	b.y += (Math.random() - 0.5) * a.y * c;
	b.z += (Math.random() - 0.5) * a.z * c
};
SPARKS.Zone = function () {};
SPARKS.PointZone = function (a) {
	this.pos = a
};
SPARKS.PointZone.prototype.getLocation = function () {
	return this.pos
};
SPARKS.PointZone = function (a) {
	this.pos = a
};
SPARKS.PointZone.prototype.getLocation = function () {
	return this.pos
};
SPARKS.LineZone = function (a, b) {
	this.start = a;
	this.end = b;
	this._length = b.clone().sub(a)
};
SPARKS.LineZone.prototype.getLocation = function () {
	var a = this._length.clone();
	a.multiplyScalar(Math.random());
	return a.add(this.start)
};
SPARKS.ParallelogramZone = function (a, b, c) {
	this.corner = a;
	this.side1 = b;
	this.side2 = c
};
SPARKS.ParallelogramZone.prototype.getLocation = function () {
	var a = this.side1.clone().multiplyScalar(Math.random()),
		b = this.side2.clone().multiplyScalar(Math.random());
	a.add(b);
	return a.add(this.corner)
};
SPARKS.CubeZone = function (a, b, c, d) {
	this.position = a;
	this.x = b;
	this.y = c;
	this.z = d
};
SPARKS.CubeZone.prototype.getLocation = function () {
	var a = this.position.clone();
	a.x += Math.random() * this.x;
	a.y += Math.random() * this.y;
	a.z += Math.random() * this.z;
	return a
};
SPARKS.CubeZone.prototype.contains = function (a) {
	var b = this.position.x,
		c = this.position.y,
		d = this.position.z,
		e = this.x,
		f = this.y,
		g = this.z;
	0 > e && (b += e, e = Math.abs(e));
	0 > f && (c += f, f = Math.abs(f));
	0 > g && (d += g, g = Math.abs(g));
	b = a.x - b;
	c = a.y - c;
	a = a.z - d;
	return 0 < b && b < e && 0 < c && c < f && 0 < a && a < g ? !0 : !1
};
SPARKS.SphereCapZone = function (a, b, c, d, e, f) {
	this.x = a;
	this.y = b;
	this.z = c;
	this.minr = d;
	this.maxr = e;
	this.angle = f
};
SPARKS.SphereCapZone.prototype.getLocation = function () {
	var a = 2 * Math.PI * SPARKS.Utils.random(),
		b = SPARKS.Utils.random(),
		a = SPARKS.VectorPool.get().set(b * Math.cos(a), -1 / Math.tan(this.angle * SPARKS.Utils.DEGREE_TO_RADIAN), b * Math.sin(a)),
		b = this.minr - (this.minr - this.maxr) * Math.random();
	a.multiplyScalar(b);
	a.__markedForReleased = !0;
	return a
};
SPARKS.Lifetime = function (a, b) {
	this._min = a;
	this._max = b ? b : a
};
SPARKS.Lifetime.prototype.initialize = function (a, b) {
	b.lifetime = this._min + SPARKS.Utils.random() * (this._max - this._min)
};
SPARKS.Position = function (a) {
	this.zone = a
};
SPARKS.Position.prototype.initialize = function (a, b) {
	var c = this.zone.getLocation();
	b.position.set(c.x, c.y, c.z)
};
SPARKS.Velocity = function (a) {
	this.zone = a
};
SPARKS.Velocity.prototype.initialize = function (a, b) {
	var c = this.zone.getLocation();
	b.velocity.set(c.x, c.y, c.z);
	c.__markedForReleased && (SPARKS.VectorPool.release(c), c.__markedForReleased = !1)
};
SPARKS.Target = function (a, b) {
	this.target = a;
	this.callback = b
};
SPARKS.Target.prototype.initialize = function (a, b) {
	b.target = this.callback ? this.callback() : this.target
};
SPARKS.VectorPool = {
	__pools: [],
	get: function () {
		return 0 < this.__pools.length ? this.__pools.pop() : this._addToPool()
	},
	release: function (a) {
		this.__pools.push(a)
	},
	_addToPool: function () {
		for (var a = 0; 100 > a; a++) this.__pools.push(new THREE.Vector3);
		return new THREE.Vector3
	}
};
SPARKS.Utils = {
	random: function () {
		return Math.random()
	},
	DEGREE_TO_RADIAN: Math.PI / 180,
	TWOPI: 2 * Math.PI,
	getPerpendiculars: function (a) {
		var b = this.getPerpendicular(a),
			a = a.cross(b);
		a.normalize();
		return [b, a]
	},
	getPerpendicular: function (a) {
		return 0 == a.x ? new THREE.Vector3D(1, 0, 0) : (new THREE.Vector3(a.y, -a.x, 0)).normalize()
	}
};
THREE.UVsUtils = {};
THREE.UVsUtils.CylinderUVGenerator = function () {
	this.uRepeat = 1;
	this.lengthCache = this.targetGeometry = null
};
THREE.UVsUtils.CylinderUVGenerator.prototype = {
	generateTopUV: THREE.ExtrudeGeometry.WorldUVGenerator.generateTopUV,
	generateBottomUV: THREE.ExtrudeGeometry.WorldUVGenerator.generateBottomUV,
	generateSideWallUV: function (a, b, c, d, e, f, g, h, i, k, j, l) {
		this.targetGeometry !== a && this.prepare(a, c);
		b = this.lengthCache;
		a = i / k;
		i = (i + 1) / k;
		j = b[j];
		l = b[l];
		j < l && (j += 1);
		j *= this.uRepeat;
		l *= this.uRepeat;
		return [new THREE.Vector2(j, a), new THREE.Vector2(l, a), new THREE.Vector2(l, i), new THREE.Vector2(j, i)]
	},
	prepare: function (a, b) {
		for (var c,
		d, e = [], f = 0, g = b.length, h = 0; h < g; h++) {
			c = b[h];
			d = b[(h + 1) % g];
			var i = c.x - d.x;
			c = c.y - d.y;
			i = Math.sqrt(i * i + c * c);
			e.push(f);
			f += i
		}
		this.normalizeArray(e, f);
		this.targetGeometry = a;
		this.lengthCache = e
	},
	normalizeArray: function (a, b) {
		for (var c = a.length, d = 0; d < c; d++) a[d] /= b;
		return a
	}
};
THREE.UVsDebug = function (a) {
	var b = a.faces,
		c = a.faceVertexUvs[0];
	console.log("debugging geometry", a);
	a = document.createElement("canvas");
	a.width = 1024;
	a.height = 1024;
	var d = a.getContext("2d");
	d.lineWidth = 1;
	d.strokeStyle = "rgba(0,0,0,0.8)";
	d.fillStyle = "rgba(255,255,255, 1.0)";
	d.fillRect(0, 0, 1024, 1024);
	var e, f, g, h, i, k, j = new THREE.Vector2,
		l = new THREE.Vector2;
	g = 0;
	for (h = c.length; g < h; g++) {
		e = c[g];
		d.beginPath();
		j.set(0, 0);
		i = 0;
		for (k = e.length; i < k; i++) f = e[i], j.x += f.x, j.y += f.y, 0 == i ? d.moveTo(1024 * f.x, 1024 * f.y) : d.lineTo(1024 * f.x, 1024 * f.y);
		d.closePath();
		d.stroke();
		j.divideScalar(k);
		d.font = "12pt Arial bold";
		d.fillStyle = "rgba(0,0,0,0.8)";
		d.fillText(g, 1024 * j.x, 1024 * j.y);
		d.font = "8pt Arial bold";
		d.fillStyle = "rgba(30,30,0,0.8)";
		i = 0;
		for (k = e.length; i < k; i++) f = e[i], l.set(f.x, f.y).sub(j).divideScalar(4), l.x = f.x - l.x, l.y = f.y - l.y, d.fillText("abcd" [i] + ":" + b[g]["abcd" [i]], 1024 * l.x, 1024 * l.y)
	}
	return a
};
var ImprovedNoise = function () {
	function a(a) {
		return a * a * a * (a * (6 * a - 15) + 10)
	}
	function b(a, b, c) {
		return b + a * (c - b)
	}
	function c(a, b, c, d) {
		var a = a & 15,
			e = 8 > a ? b : c,
			b = 4 > a ? c : 12 == a || 14 == a ? b : d;
		return (0 == (a & 1) ? e : -e) + (0 == (a & 2) ? b : -b)
	}
	for (var d = [151, 160, 137, 91, 90, 15, 131, 13, 201, 95, 96, 53, 194, 233, 7, 225, 140, 36, 103, 30, 69, 142, 8, 99, 37, 240, 21, 10, 23, 190, 6, 148, 247, 120, 234, 75, 0, 26, 197, 62, 94, 252, 219, 203, 117, 35, 11, 32, 57, 177, 33, 88, 237, 149, 56, 87, 174, 20, 125, 136, 171, 168, 68, 175, 74, 165, 71, 134, 139, 48, 27, 166, 77, 146, 158, 231, 83, 111, 229, 122, 60,
	211, 133, 230, 220, 105, 92, 41, 55, 46, 245, 40, 244, 102, 143, 54, 65, 25, 63, 161, 1, 216, 80, 73, 209, 76, 132, 187, 208, 89, 18, 169, 200, 196, 135, 130, 116, 188, 159, 86, 164, 100, 109, 198, 173, 186, 3, 64, 52, 217, 226, 250, 124, 123, 5, 202, 38, 147, 118, 126, 255, 82, 85, 212, 207, 206, 59, 227, 47, 16, 58, 17, 182, 189, 28, 42, 223, 183, 170, 213, 119, 248, 152, 2, 44, 154, 163, 70, 221, 153, 101, 155, 167, 43, 172, 9, 129, 22, 39, 253, 19, 98, 108, 110, 79, 113, 224, 232, 178, 185, 112, 104, 218, 246, 97, 228, 251, 34, 242, 193, 238, 210, 144, 12, 191, 179, 162, 241, 81, 51, 145, 235, 249, 14, 239, 107, 49, 192, 214, 31,
	181, 199, 106, 157, 184, 84, 204, 176, 115, 121, 50, 45, 127, 4, 150, 254, 138, 236, 205, 93, 222, 114, 67, 29, 24, 72, 243, 141, 128, 195, 78, 66, 215, 61, 156, 180], e = 0; 256 > e; e++) d[256 + e] = d[e];
	return {
		noise: function (e, g, h) {
			var i = ~~e,
				k = ~~g,
				j = ~~h,
				l = i & 255,
				m = k & 255,
				r = j & 255,
				e = e - i,
				g = g - k,
				h = h - j,
				i = e - 1,
				k = g - 1,
				j = h - 1,
				q = a(e),
				p = a(g),
				t = a(h),
				u = d[l] + m,
				x = d[u] + r,
				u = d[u + 1] + r,
				m = d[l + 1] + m,
				l = d[m] + r,
				r = d[m + 1] + r;
			return b(t, b(p, b(q, c(d[x], e, g, h), c(d[l], i, g, h)), b(q, c(d[u], e, k, h), c(d[r], i, k, h))), b(p, b(q, c(d[x + 1], e, g, j), c(d[l + 1], i, g, h - 1)), b(q, c(d[u + 1], e, k, j), c(d[r + 1], i, k, j))))
		}
	}
};
var SimplexNoise = function (a) {
	void 0 == a && (a = Math);
	this.grad3 = [
		[1, 1, 0],
		[-1, 1, 0],
		[1, -1, 0],
		[-1, -1, 0],
		[1, 0, 1],
		[-1, 0, 1],
		[1, 0, -1],
		[-1, 0, -1],
		[0, 1, 1],
		[0, -1, 1],
		[0, 1, -1],
		[0, -1, -1]
	];
	this.grad4 = [
		[0, 1, 1, 1],
		[0, 1, 1, -1],
		[0, 1, -1, 1],
		[0, 1, -1, -1],
		[0, -1, 1, 1],
		[0, -1, 1, -1],
		[0, -1, -1, 1],
		[0, -1, -1, -1],
		[1, 0, 1, 1],
		[1, 0, 1, -1],
		[1, 0, -1, 1],
		[1, 0, -1, -1],
		[-1, 0, 1, 1],
		[-1, 0, 1, -1],
		[-1, 0, -1, 1],
		[-1, 0, -1, -1],
		[1, 1, 0, 1],
		[1, 1, 0, -1],
		[1, -1, 0, 1],
		[1, -1, 0, -1],
		[-1, 1, 0, 1],
		[-1, 1, 0, -1],
		[-1, -1, 0, 1],
		[-1, -1, 0, -1],
		[1, 1, 1, 0],
		[1, 1, -1, 0],
		[1, -1, 1, 0],
		[1, -1, -1, 0],
		[-1, 1, 1, 0],
		[-1, 1, -1, 0],
		[-1, -1, 1, 0],
		[-1, -1, -1, 0]
	];
	this.p = [];
	for (var b = 0; 256 > b; b++) this.p[b] = Math.floor(256 * a.random());
	this.perm = [];
	for (b = 0; 512 > b; b++) this.perm[b] = this.p[b & 255];
	this.simplex = [
		[0, 1, 2, 3],
		[0, 1, 3, 2],
		[0, 0, 0, 0],
		[0, 2, 3, 1],
		[0, 0, 0, 0],
		[0, 0, 0, 0],
		[0, 0, 0, 0],
		[1, 2, 3, 0],
		[0, 2, 1, 3],
		[0, 0, 0, 0],
		[0, 3, 1, 2],
		[0, 3, 2, 1],
		[0, 0, 0, 0],
		[0, 0, 0, 0],
		[0, 0, 0, 0],
		[1, 3, 2, 0],
		[0, 0, 0, 0],
		[0, 0, 0, 0],
		[0, 0, 0, 0],
		[0, 0, 0, 0],
		[0, 0, 0, 0],
		[0, 0, 0, 0],
		[0, 0, 0, 0],
		[0, 0, 0, 0],
		[1, 2, 0, 3],
		[0, 0, 0, 0],
		[1, 3, 0, 2],
		[0, 0, 0, 0],
		[0, 0, 0, 0],
		[0, 0, 0, 0],
		[2, 3, 0, 1],
		[2,
		3, 1, 0],
		[1, 0, 2, 3],
		[1, 0, 3, 2],
		[0, 0, 0, 0],
		[0, 0, 0, 0],
		[0, 0, 0, 0],
		[2, 0, 3, 1],
		[0, 0, 0, 0],
		[2, 1, 3, 0],
		[0, 0, 0, 0],
		[0, 0, 0, 0],
		[0, 0, 0, 0],
		[0, 0, 0, 0],
		[0, 0, 0, 0],
		[0, 0, 0, 0],
		[0, 0, 0, 0],
		[0, 0, 0, 0],
		[2, 0, 1, 3],
		[0, 0, 0, 0],
		[0, 0, 0, 0],
		[0, 0, 0, 0],
		[3, 0, 1, 2],
		[3, 0, 2, 1],
		[0, 0, 0, 0],
		[3, 1, 2, 0],
		[2, 1, 0, 3],
		[0, 0, 0, 0],
		[0, 0, 0, 0],
		[0, 0, 0, 0],
		[3, 1, 0, 2],
		[0, 0, 0, 0],
		[3, 2, 0, 1],
		[3, 2, 1, 0]
	]
};
SimplexNoise.prototype.dot = function (a, b, c) {
	return a[0] * b + a[1] * c
};
SimplexNoise.prototype.dot3 = function (a, b, c, d) {
	return a[0] * b + a[1] * c + a[2] * d
};
SimplexNoise.prototype.dot4 = function (a, b, c, d, e) {
	return a[0] * b + a[1] * c + a[2] * d + a[3] * e
};
SimplexNoise.prototype.noise = function (a, b) {
	var c, d, e;
	e = 0.5 * (Math.sqrt(3) - 1);
	e *= a + b;
	var f = Math.floor(a + e),
		g = Math.floor(b + e),
		h = (3 - Math.sqrt(3)) / 6;
	e = (f + g) * h;
	c = a - (f - e);
	var i = b - (g - e),
		k, j;
	c > i ? (k = 1, j = 0) : (k = 0, j = 1);
	d = c - k + h;
	var l = i - j + h;
	e = c - 1 + 2 * h;
	var h = i - 1 + 2 * h,
		m = f & 255,
		g = g & 255,
		f = this.perm[m + this.perm[g]] % 12;
	k = this.perm[m + k + this.perm[g + j]] % 12;
	j = this.perm[m + 1 + this.perm[g + 1]] % 12;
	g = 0.5 - c * c - i * i;
	0 > g ? c = 0 : (g *= g, c = g * g * this.dot(this.grad3[f], c, i));
	i = 0.5 - d * d - l * l;
	0 > i ? d = 0 : (i *= i, d = i * i * this.dot(this.grad3[k], d, l));
	l = 0.5 - e * e - h * h;
	0 > l ? e = 0 : (l *= l, e = l * l * this.dot(this.grad3[j], e, h));
	return 70 * (c + d + e)
};
SimplexNoise.prototype.noise3d = function (a, b, c) {
	var d, e, f, g = (a + b + c) * (1 / 3),
		h = Math.floor(a + g),
		i = Math.floor(b + g),
		k = Math.floor(c + g),
		g = 1 / 6;
	f = (h + i + k) * g;
	d = a - (h - f);
	e = b - (i - f);
	var j = c - (k - f),
		l, m, r, q, p, t;
	d >= e ? e >= j ? (l = 1, r = m = 0, p = q = 1, t = 0) : (d >= j ? (l = 1, r = m = 0) : (m = l = 0, r = 1), q = 1, p = 0, t = 1) : e < j ? (m = l = 0, r = 1, q = 0, t = p = 1) : d < j ? (l = 0, m = 1, q = r = 0, t = p = 1) : (l = 0, m = 1, r = 0, p = q = 1, t = 0);
	var u = d - l + g,
		x = e - m + g,
		v = j - r + g;
	f = d - q + 2 * g;
	var a = e - p + 2 * g,
		s = j - t + 2 * g,
		c = d - 1 + 3 * g,
		b = e - 1 + 3 * g,
		g = j - 1 + 3 * g,
		h = h & 255,
		C = i & 255,
		z = k & 255,
		i = this.perm[h + this.perm[C + this.perm[z]]] % 12,
		k = this.perm[h + l + this.perm[C + m + this.perm[z + r]]] % 12;
	q = this.perm[h + q + this.perm[C + p + this.perm[z + t]]] % 12;
	h = this.perm[h + 1 + this.perm[C + 1 + this.perm[z + 1]]] % 12;
	p = 0.6 - d * d - e * e - j * j;
	0 > p ? d = 0 : (p *= p, d = p * p * this.dot3(this.grad3[i], d, e, j));
	e = 0.6 - u * u - x * x - v * v;
	0 > e ? e = 0 : (e *= e, e = e * e * this.dot3(this.grad3[k], u, x, v));
	u = 0.6 - f * f - a * a - s * s;
	0 > u ? f = 0 : (u *= u, f = u * u * this.dot3(this.grad3[q], f, a, s));
	a = 0.6 - c * c - b * b - g * g;
	0 > a ? c = 0 : (a *= a, c = a * a * this.dot3(this.grad3[h], c, b, g));
	return 32 * (d + e + f + c)
};
SimplexNoise.prototype.noise4d = function (a, b, c, d) {
	var e = this.grad4,
		f = this.simplex,
		g = this.perm,
		h = (Math.sqrt(5) - 1) / 4,
		i = (5 - Math.sqrt(5)) / 20,
		k, j, h = (a + b + c + d) * h,
		l = Math.floor(a + h),
		m = Math.floor(b + h),
		r = Math.floor(c + h),
		q = Math.floor(d + h),
		h = (l + m + r + q) * i,
		a = a - (l - h);
	k = b - (m - h);
	j = c - (r - h);
	var p = d - (q - h),
		d = (a > k ? 32 : 0) + (a > j ? 16 : 0) + (k > j ? 8 : 0) + (a > p ? 4 : 0) + (k > p ? 2 : 0) + (j > p ? 1 : 0),
		t, u, x, v, s, C, z, w, A, H, G, I;
	t = 3 <= f[d][0] ? 1 : 0;
	u = 3 <= f[d][1] ? 1 : 0;
	x = 3 <= f[d][2] ? 1 : 0;
	v = 3 <= f[d][3] ? 1 : 0;
	s = 2 <= f[d][0] ? 1 : 0;
	C = 2 <= f[d][1] ? 1 : 0;
	z = 2 <= f[d][2] ? 1 : 0;
	w = 2 <= f[d][3] ? 1 : 0;
	A = 1 <= f[d][0] ? 1 : 0;
	H = 1 <= f[d][1] ? 1 : 0;
	G = 1 <= f[d][2] ? 1 : 0;
	I = 1 <= f[d][3] ? 1 : 0;
	var V = a - t + i,
		E = k - u + i,
		O = j - x + i,
		D = p - v + i,
		J = a - s + 2 * i,
		P = k - C + 2 * i,
		R = j - z + 2 * i,
		Q = p - w + 2 * i,
		b = a - A + 3 * i,
		h = k - H + 3 * i,
		N = j - G + 3 * i,
		M = p - I + 3 * i,
		f = a - 1 + 4 * i,
		d = k - 1 + 4 * i,
		c = j - 1 + 4 * i,
		i = p - 1 + 4 * i,
		l = l & 255,
		m = m & 255,
		F = r & 255,
		q = q & 255,
		r = g[l + g[m + g[F + g[q]]]] % 32;
	t = g[l + t + g[m + u + g[F + x + g[q + v]]]] % 32;
	s = g[l + s + g[m + C + g[F + z + g[q + w]]]] % 32;
	A = g[l + A + g[m + H + g[F + G + g[q + I]]]] % 32;
	g = g[l + 1 + g[m + 1 + g[F + 1 + g[q + 1]]]] % 32;
	q = 0.6 - a * a - k * k - j * j - p * p;
	0 > q ? a = 0 : (q *= q, a = q * q * this.dot4(e[r], a, k, j, p));
	k = 0.6 - V * V - E * E - O * O - D * D;
	0 > k ? k = 0 : (k *= k, k = k * k * this.dot4(e[t], V, E, O, D));
	j = 0.6 - J * J - P * P - R * R - Q * Q;
	0 > j ? j = 0 : (j *= j, j = j * j * this.dot4(e[s], J, P, R, Q));
	J = 0.6 - b * b - h * h - N * N - M * M;
	0 > J ? b = 0 : (J *= J, b = J * J * this.dot4(e[A], b, h, N, M));
	h = 0.6 - f * f - d * d - c * c - i * i;
	0 > h ? e = 0 : (h *= h, e = h * h * this.dot4(e[g], f, d, c, i));
	return 27 * (a + k + j + b + e)
};
var Detector = {
	canvas: !! window.CanvasRenderingContext2D,
	webgl: function () {
		try {
			return !!window.WebGLRenderingContext && !! document.createElement("canvas").getContext("experimental-webgl")
		} catch (a) {
			return !1
		}
	}(),
	workers: !! window.Worker,
	fileapi: window.File && window.FileReader && window.FileList && window.Blob,
	getWebGLErrorMessage: function () {
		var a = document.createElement("div");
		a.id = "webgl-error-message";
		a.style.fontFamily = "monospace";
		a.style.fontSize = "13px";
		a.style.fontWeight = "normal";
		a.style.textAlign = "center";
		a.style.background = "#fff";
		a.style.color = "#000";
		a.style.padding = "1.5em";
		a.style.width = "400px";
		a.style.margin = "5em auto 0";
		this.webgl || (a.innerHTML = window.WebGLRenderingContext ? 'Your graphics card does not seem to support <a href="http://khronos.org/webgl/wiki/Getting_a_WebGL_Implementation" style="color:#000">WebGL</a>.<br />\nFind out how to get it <a href="http://get.webgl.org/" style="color:#000">here</a>.' : 'Your browser does not seem to support <a href="http://khronos.org/webgl/wiki/Getting_a_WebGL_Implementation" style="color:#000">WebGL</a>.<br/>\nFind out how to get it <a href="http://get.webgl.org/" style="color:#000">here</a>.');
		return a
	},
	addGetWebGLMessage: function (a) {
		var b, c, a = a || {};
		b = void 0 !== a.parent ? a.parent : document.body;
		a = void 0 !== a.id ? a.id : "oldie";
		c = Detector.getWebGLErrorMessage();
		c.id = a;
		b.appendChild(c)
	}
};